"use strict";
(() => {
  // securepub.js
  window.sp_init_to_ok = (s, fnc) => {
    return s.replaceAll("\u2576", "\u2501").replaceAll("\u256D", "\u250F").replaceAll("\u256E", "\u2513").replaceAll("\u2575", "\u2503").replaceAll("\u2570", "\u2517").replaceAll("\u256F", "\u251B").replaceAll("\u252C", "\u2533").replaceAll("\u25A1", "\u25A0");
  };
  window.sp_init_to_error = (s, fnc) => {
    return s.replaceAll("\u2576", "\u2501").replaceAll("\u256D", "\u250F").replaceAll("\u256E", "\u2513").replaceAll("\u2575", "\u2502").replaceAll("\u25A1", "X");
  };
  window.sp_init_to_skip = (s) => s.replace("\u2502", "\u2503");
  window.sp_fetch_workflow_files = (workflowpaths) => {
    var requests = workflowpaths.map((wfp) => {
      var url = `/_v1.2401_/workflow/${wfp}.json`;
      if (localStorage?.debug !== void 0)
        console.log("sp_fetch_workflow_files ", url);
      return fetch(url).then((response) => {
        if (!response.ok)
          throw new Error(`HTTP error: ${response.status}`);
        return response.json();
      });
    });
    return Promise.all(requests).catch((err) => console.error(`Fetch problem: ${err.message}`));
  };
  window.sp_fill_in_workflow_defaults = (flags) => {
    if (flags.workflows) {
      for (const w of flags.workflows) {
        for (const idx in w.progress) {
          let p = w.progress[idx];
          let num = Number(idx) + 1;
          p.messages.error = p.messages.error ?? p.messages.ok;
          p.display.ok = p.display.ok ?? sp_init_to_ok(p.display.init, "p.display.init");
          p.display.ok2 = p.display.ok2 ?? sp_init_to_ok(p.display.ok, "p.display.ok");
          p.display.error = p.display.error ?? sp_init_to_error(p.display.init, "p.display.init");
          p.display.error2 = p.display.error2 ?? sp_init_to_error(p.display.error, "p.display.error");
          p.display.skip = p.display.skip ?? sp_init_to_skip(p.display.init, "p.display.init");
          p.display.skip2 = p.display.skip2 ?? p.display.skip;
          p.display.ok = p.display.ok.replaceAll(/%%/g, String(num).padStart(2));
          p.display.ok2 = p.display.ok2.replaceAll(/%%/g, String(num).padStart(2));
          p.display.error = p.display.error.replaceAll(/%%/g, String(num).padStart(2));
          p.display.error2 = p.display.error2.replaceAll(/%%/g, String(num).padStart(2));
          p.display.skip = p.display.skip.replaceAll(/%%/g, String(num).padStart(2));
          p.display.skip2 = p.display.skip2.replaceAll(/%%/g, String(num).padStart(2));
          p.display.init = p.display.init.replaceAll(/%%/g, String(num).padStart(2));
        }
      }
      for (const idx in flags.workflows) {
        let num = Number(idx) + 1;
        let w = flags.workflows[idx];
        w.label = `${num}. ${w.label}`;
      }
    }
  };
})();
