(function(scope){
'use strict';

function F(arity, fun, wrapper) {
  wrapper.a = arity;
  wrapper.f = fun;
  return wrapper;
}

function F2(fun) {
  return F(2, fun, function(a) { return function(b) { return fun(a,b); }; })
}
function F3(fun) {
  return F(3, fun, function(a) {
    return function(b) { return function(c) { return fun(a, b, c); }; };
  });
}
function F4(fun) {
  return F(4, fun, function(a) { return function(b) { return function(c) {
    return function(d) { return fun(a, b, c, d); }; }; };
  });
}
function F5(fun) {
  return F(5, fun, function(a) { return function(b) { return function(c) {
    return function(d) { return function(e) { return fun(a, b, c, d, e); }; }; }; };
  });
}
function F6(fun) {
  return F(6, fun, function(a) { return function(b) { return function(c) {
    return function(d) { return function(e) { return function(f) {
    return fun(a, b, c, d, e, f); }; }; }; }; };
  });
}
function F7(fun) {
  return F(7, fun, function(a) { return function(b) { return function(c) {
    return function(d) { return function(e) { return function(f) {
    return function(g) { return fun(a, b, c, d, e, f, g); }; }; }; }; }; };
  });
}
function F8(fun) {
  return F(8, fun, function(a) { return function(b) { return function(c) {
    return function(d) { return function(e) { return function(f) {
    return function(g) { return function(h) {
    return fun(a, b, c, d, e, f, g, h); }; }; }; }; }; }; };
  });
}
function F9(fun) {
  return F(9, fun, function(a) { return function(b) { return function(c) {
    return function(d) { return function(e) { return function(f) {
    return function(g) { return function(h) { return function(i) {
    return fun(a, b, c, d, e, f, g, h, i); }; }; }; }; }; }; }; };
  });
}

function A2(fun, a, b) {
  return fun.a === 2 ? fun.f(a, b) : fun(a)(b);
}
function A3(fun, a, b, c) {
  return fun.a === 3 ? fun.f(a, b, c) : fun(a)(b)(c);
}
function A4(fun, a, b, c, d) {
  return fun.a === 4 ? fun.f(a, b, c, d) : fun(a)(b)(c)(d);
}
function A5(fun, a, b, c, d, e) {
  return fun.a === 5 ? fun.f(a, b, c, d, e) : fun(a)(b)(c)(d)(e);
}
function A6(fun, a, b, c, d, e, f) {
  return fun.a === 6 ? fun.f(a, b, c, d, e, f) : fun(a)(b)(c)(d)(e)(f);
}
function A7(fun, a, b, c, d, e, f, g) {
  return fun.a === 7 ? fun.f(a, b, c, d, e, f, g) : fun(a)(b)(c)(d)(e)(f)(g);
}
function A8(fun, a, b, c, d, e, f, g, h) {
  return fun.a === 8 ? fun.f(a, b, c, d, e, f, g, h) : fun(a)(b)(c)(d)(e)(f)(g)(h);
}
function A9(fun, a, b, c, d, e, f, g, h, i) {
  return fun.a === 9 ? fun.f(a, b, c, d, e, f, g, h, i) : fun(a)(b)(c)(d)(e)(f)(g)(h)(i);
}



// EQUALITY

function _Utils_eq(x, y)
{
	for (
		var pair, stack = [], isEqual = _Utils_eqHelp(x, y, 0, stack);
		isEqual && (pair = stack.pop());
		isEqual = _Utils_eqHelp(pair.a, pair.b, 0, stack)
		)
	{}

	return isEqual;
}

function _Utils_eqHelp(x, y, depth, stack)
{
	if (x === y)
	{
		return true;
	}

	if (typeof x !== 'object' || x === null || y === null)
	{
		typeof x === 'function' && _Debug_crash(5);
		return false;
	}

	if (depth > 100)
	{
		stack.push(_Utils_Tuple2(x,y));
		return true;
	}

	/**/
	if (x.$ === 'Set_elm_builtin')
	{
		x = $elm$core$Set$toList(x);
		y = $elm$core$Set$toList(y);
	}
	if (x.$ === 'RBNode_elm_builtin' || x.$ === 'RBEmpty_elm_builtin')
	{
		x = $elm$core$Dict$toList(x);
		y = $elm$core$Dict$toList(y);
	}
	//*/

	/**_UNUSED/
	if (x.$ < 0)
	{
		x = $elm$core$Dict$toList(x);
		y = $elm$core$Dict$toList(y);
	}
	//*/

	for (var key in x)
	{
		if (!_Utils_eqHelp(x[key], y[key], depth + 1, stack))
		{
			return false;
		}
	}
	return true;
}

var _Utils_equal = F2(_Utils_eq);
var _Utils_notEqual = F2(function(a, b) { return !_Utils_eq(a,b); });



// COMPARISONS

// Code in Generate/JavaScript.hs, Basics.js, and List.js depends on
// the particular integer values assigned to LT, EQ, and GT.

function _Utils_cmp(x, y, ord)
{
	if (typeof x !== 'object')
	{
		return x === y ? /*EQ*/ 0 : x < y ? /*LT*/ -1 : /*GT*/ 1;
	}

	/**/
	if (x instanceof String)
	{
		var a = x.valueOf();
		var b = y.valueOf();
		return a === b ? 0 : a < b ? -1 : 1;
	}
	//*/

	/**_UNUSED/
	if (typeof x.$ === 'undefined')
	//*/
	/**/
	if (x.$[0] === '#')
	//*/
	{
		return (ord = _Utils_cmp(x.a, y.a))
			? ord
			: (ord = _Utils_cmp(x.b, y.b))
				? ord
				: _Utils_cmp(x.c, y.c);
	}

	// traverse conses until end of a list or a mismatch
	for (; x.b && y.b && !(ord = _Utils_cmp(x.a, y.a)); x = x.b, y = y.b) {} // WHILE_CONSES
	return ord || (x.b ? /*GT*/ 1 : y.b ? /*LT*/ -1 : /*EQ*/ 0);
}

var _Utils_lt = F2(function(a, b) { return _Utils_cmp(a, b) < 0; });
var _Utils_le = F2(function(a, b) { return _Utils_cmp(a, b) < 1; });
var _Utils_gt = F2(function(a, b) { return _Utils_cmp(a, b) > 0; });
var _Utils_ge = F2(function(a, b) { return _Utils_cmp(a, b) >= 0; });

var _Utils_compare = F2(function(x, y)
{
	var n = _Utils_cmp(x, y);
	return n < 0 ? $elm$core$Basics$LT : n ? $elm$core$Basics$GT : $elm$core$Basics$EQ;
});


// COMMON VALUES

var _Utils_Tuple0_UNUSED = 0;
var _Utils_Tuple0 = { $: '#0' };

function _Utils_Tuple2_UNUSED(a, b) { return { a: a, b: b }; }
function _Utils_Tuple2(a, b) { return { $: '#2', a: a, b: b }; }

function _Utils_Tuple3_UNUSED(a, b, c) { return { a: a, b: b, c: c }; }
function _Utils_Tuple3(a, b, c) { return { $: '#3', a: a, b: b, c: c }; }

function _Utils_chr_UNUSED(c) { return c; }
function _Utils_chr(c) { return new String(c); }


// RECORDS

function _Utils_update(oldRecord, updatedFields)
{
	var newRecord = {};

	for (var key in oldRecord)
	{
		newRecord[key] = oldRecord[key];
	}

	for (var key in updatedFields)
	{
		newRecord[key] = updatedFields[key];
	}

	return newRecord;
}


// APPEND

var _Utils_append = F2(_Utils_ap);

function _Utils_ap(xs, ys)
{
	// append Strings
	if (typeof xs === 'string')
	{
		return xs + ys;
	}

	// append Lists
	if (!xs.b)
	{
		return ys;
	}
	var root = _List_Cons(xs.a, ys);
	xs = xs.b
	for (var curr = root; xs.b; xs = xs.b) // WHILE_CONS
	{
		curr = curr.b = _List_Cons(xs.a, ys);
	}
	return root;
}



var _List_Nil_UNUSED = { $: 0 };
var _List_Nil = { $: '[]' };

function _List_Cons_UNUSED(hd, tl) { return { $: 1, a: hd, b: tl }; }
function _List_Cons(hd, tl) { return { $: '::', a: hd, b: tl }; }


var _List_cons = F2(_List_Cons);

function _List_fromArray(arr)
{
	var out = _List_Nil;
	for (var i = arr.length; i--; )
	{
		out = _List_Cons(arr[i], out);
	}
	return out;
}

function _List_toArray(xs)
{
	for (var out = []; xs.b; xs = xs.b) // WHILE_CONS
	{
		out.push(xs.a);
	}
	return out;
}

var _List_map2 = F3(function(f, xs, ys)
{
	for (var arr = []; xs.b && ys.b; xs = xs.b, ys = ys.b) // WHILE_CONSES
	{
		arr.push(A2(f, xs.a, ys.a));
	}
	return _List_fromArray(arr);
});

var _List_map3 = F4(function(f, xs, ys, zs)
{
	for (var arr = []; xs.b && ys.b && zs.b; xs = xs.b, ys = ys.b, zs = zs.b) // WHILE_CONSES
	{
		arr.push(A3(f, xs.a, ys.a, zs.a));
	}
	return _List_fromArray(arr);
});

var _List_map4 = F5(function(f, ws, xs, ys, zs)
{
	for (var arr = []; ws.b && xs.b && ys.b && zs.b; ws = ws.b, xs = xs.b, ys = ys.b, zs = zs.b) // WHILE_CONSES
	{
		arr.push(A4(f, ws.a, xs.a, ys.a, zs.a));
	}
	return _List_fromArray(arr);
});

var _List_map5 = F6(function(f, vs, ws, xs, ys, zs)
{
	for (var arr = []; vs.b && ws.b && xs.b && ys.b && zs.b; vs = vs.b, ws = ws.b, xs = xs.b, ys = ys.b, zs = zs.b) // WHILE_CONSES
	{
		arr.push(A5(f, vs.a, ws.a, xs.a, ys.a, zs.a));
	}
	return _List_fromArray(arr);
});

var _List_sortBy = F2(function(f, xs)
{
	return _List_fromArray(_List_toArray(xs).sort(function(a, b) {
		return _Utils_cmp(f(a), f(b));
	}));
});

var _List_sortWith = F2(function(f, xs)
{
	return _List_fromArray(_List_toArray(xs).sort(function(a, b) {
		var ord = A2(f, a, b);
		return ord === $elm$core$Basics$EQ ? 0 : ord === $elm$core$Basics$LT ? -1 : 1;
	}));
});



var _JsArray_empty = [];

function _JsArray_singleton(value)
{
    return [value];
}

function _JsArray_length(array)
{
    return array.length;
}

var _JsArray_initialize = F3(function(size, offset, func)
{
    var result = new Array(size);

    for (var i = 0; i < size; i++)
    {
        result[i] = func(offset + i);
    }

    return result;
});

var _JsArray_initializeFromList = F2(function (max, ls)
{
    var result = new Array(max);

    for (var i = 0; i < max && ls.b; i++)
    {
        result[i] = ls.a;
        ls = ls.b;
    }

    result.length = i;
    return _Utils_Tuple2(result, ls);
});

var _JsArray_unsafeGet = F2(function(index, array)
{
    return array[index];
});

var _JsArray_unsafeSet = F3(function(index, value, array)
{
    var length = array.length;
    var result = new Array(length);

    for (var i = 0; i < length; i++)
    {
        result[i] = array[i];
    }

    result[index] = value;
    return result;
});

var _JsArray_push = F2(function(value, array)
{
    var length = array.length;
    var result = new Array(length + 1);

    for (var i = 0; i < length; i++)
    {
        result[i] = array[i];
    }

    result[length] = value;
    return result;
});

var _JsArray_foldl = F3(function(func, acc, array)
{
    var length = array.length;

    for (var i = 0; i < length; i++)
    {
        acc = A2(func, array[i], acc);
    }

    return acc;
});

var _JsArray_foldr = F3(function(func, acc, array)
{
    for (var i = array.length - 1; i >= 0; i--)
    {
        acc = A2(func, array[i], acc);
    }

    return acc;
});

var _JsArray_map = F2(function(func, array)
{
    var length = array.length;
    var result = new Array(length);

    for (var i = 0; i < length; i++)
    {
        result[i] = func(array[i]);
    }

    return result;
});

var _JsArray_indexedMap = F3(function(func, offset, array)
{
    var length = array.length;
    var result = new Array(length);

    for (var i = 0; i < length; i++)
    {
        result[i] = A2(func, offset + i, array[i]);
    }

    return result;
});

var _JsArray_slice = F3(function(from, to, array)
{
    return array.slice(from, to);
});

var _JsArray_appendN = F3(function(n, dest, source)
{
    var destLen = dest.length;
    var itemsToCopy = n - destLen;

    if (itemsToCopy > source.length)
    {
        itemsToCopy = source.length;
    }

    var size = destLen + itemsToCopy;
    var result = new Array(size);

    for (var i = 0; i < destLen; i++)
    {
        result[i] = dest[i];
    }

    for (var i = 0; i < itemsToCopy; i++)
    {
        result[i + destLen] = source[i];
    }

    return result;
});



// LOG

var _Debug_log_UNUSED = F2(function(tag, value)
{
	return value;
});

var _Debug_log = F2(function(tag, value)
{
	console.log(tag + ': ' + _Debug_toString(value));
	return value;
});


// TODOS

function _Debug_todo(moduleName, region)
{
	return function(message) {
		_Debug_crash(8, moduleName, region, message);
	};
}

function _Debug_todoCase(moduleName, region, value)
{
	return function(message) {
		_Debug_crash(9, moduleName, region, value, message);
	};
}


// TO STRING

function _Debug_toString_UNUSED(value)
{
	return '<internals>';
}

function _Debug_toString(value)
{
	return _Debug_toAnsiString(false, value);
}

function _Debug_toAnsiString(ansi, value)
{
	if (typeof value === 'function')
	{
		return _Debug_internalColor(ansi, '<function>');
	}

	if (typeof value === 'boolean')
	{
		return _Debug_ctorColor(ansi, value ? 'True' : 'False');
	}

	if (typeof value === 'number')
	{
		return _Debug_numberColor(ansi, value + '');
	}

	if (value instanceof String)
	{
		return _Debug_charColor(ansi, "'" + _Debug_addSlashes(value, true) + "'");
	}

	if (typeof value === 'string')
	{
		return _Debug_stringColor(ansi, '"' + _Debug_addSlashes(value, false) + '"');
	}

	if (typeof value === 'object' && '$' in value)
	{
		var tag = value.$;

		if (typeof tag === 'number')
		{
			return _Debug_internalColor(ansi, '<internals>');
		}

		if (tag[0] === '#')
		{
			var output = [];
			for (var k in value)
			{
				if (k === '$') continue;
				output.push(_Debug_toAnsiString(ansi, value[k]));
			}
			return '(' + output.join(',') + ')';
		}

		if (tag === 'Set_elm_builtin')
		{
			return _Debug_ctorColor(ansi, 'Set')
				+ _Debug_fadeColor(ansi, '.fromList') + ' '
				+ _Debug_toAnsiString(ansi, $elm$core$Set$toList(value));
		}

		if (tag === 'RBNode_elm_builtin' || tag === 'RBEmpty_elm_builtin')
		{
			return _Debug_ctorColor(ansi, 'Dict')
				+ _Debug_fadeColor(ansi, '.fromList') + ' '
				+ _Debug_toAnsiString(ansi, $elm$core$Dict$toList(value));
		}

		if (tag === 'Array_elm_builtin')
		{
			return _Debug_ctorColor(ansi, 'Array')
				+ _Debug_fadeColor(ansi, '.fromList') + ' '
				+ _Debug_toAnsiString(ansi, $elm$core$Array$toList(value));
		}

		if (tag === '::' || tag === '[]')
		{
			var output = '[';

			value.b && (output += _Debug_toAnsiString(ansi, value.a), value = value.b)

			for (; value.b; value = value.b) // WHILE_CONS
			{
				output += ',' + _Debug_toAnsiString(ansi, value.a);
			}
			return output + ']';
		}

		var output = '';
		for (var i in value)
		{
			if (i === '$') continue;
			var str = _Debug_toAnsiString(ansi, value[i]);
			var c0 = str[0];
			var parenless = c0 === '{' || c0 === '(' || c0 === '[' || c0 === '<' || c0 === '"' || str.indexOf(' ') < 0;
			output += ' ' + (parenless ? str : '(' + str + ')');
		}
		return _Debug_ctorColor(ansi, tag) + output;
	}

	if (typeof DataView === 'function' && value instanceof DataView)
	{
		return _Debug_stringColor(ansi, '<' + value.byteLength + ' bytes>');
	}

	if (typeof File !== 'undefined' && value instanceof File)
	{
		return _Debug_internalColor(ansi, '<' + value.name + '>');
	}

	if (typeof value === 'object')
	{
		var output = [];
		for (var key in value)
		{
			var field = key[0] === '_' ? key.slice(1) : key;
			output.push(_Debug_fadeColor(ansi, field) + ' = ' + _Debug_toAnsiString(ansi, value[key]));
		}
		if (output.length === 0)
		{
			return '{}';
		}
		return '{ ' + output.join(', ') + ' }';
	}

	return _Debug_internalColor(ansi, '<internals>');
}

function _Debug_addSlashes(str, isChar)
{
	var s = str
		.replace(/\\/g, '\\\\')
		.replace(/\n/g, '\\n')
		.replace(/\t/g, '\\t')
		.replace(/\r/g, '\\r')
		.replace(/\v/g, '\\v')
		.replace(/\0/g, '\\0');

	if (isChar)
	{
		return s.replace(/\'/g, '\\\'');
	}
	else
	{
		return s.replace(/\"/g, '\\"');
	}
}

function _Debug_ctorColor(ansi, string)
{
	return ansi ? '\x1b[96m' + string + '\x1b[0m' : string;
}

function _Debug_numberColor(ansi, string)
{
	return ansi ? '\x1b[95m' + string + '\x1b[0m' : string;
}

function _Debug_stringColor(ansi, string)
{
	return ansi ? '\x1b[93m' + string + '\x1b[0m' : string;
}

function _Debug_charColor(ansi, string)
{
	return ansi ? '\x1b[92m' + string + '\x1b[0m' : string;
}

function _Debug_fadeColor(ansi, string)
{
	return ansi ? '\x1b[37m' + string + '\x1b[0m' : string;
}

function _Debug_internalColor(ansi, string)
{
	return ansi ? '\x1b[36m' + string + '\x1b[0m' : string;
}

function _Debug_toHexDigit(n)
{
	return String.fromCharCode(n < 10 ? 48 + n : 55 + n);
}


// CRASH


function _Debug_crash_UNUSED(identifier)
{
	throw new Error('https://github.com/elm/core/blob/1.0.0/hints/' + identifier + '.md');
}


function _Debug_crash(identifier, fact1, fact2, fact3, fact4)
{
	switch(identifier)
	{
		case 0:
			throw new Error('What node should I take over? In JavaScript I need something like:\n\n    Elm.Main.init({\n        node: document.getElementById("elm-node")\n    })\n\nYou need to do this with any Browser.sandbox or Browser.element program.');

		case 1:
			throw new Error('Browser.application programs cannot handle URLs like this:\n\n    ' + document.location.href + '\n\nWhat is the root? The root of your file system? Try looking at this program with `elm reactor` or some other server.');

		case 2:
			var jsonErrorString = fact1;
			throw new Error('Problem with the flags given to your Elm program on initialization.\n\n' + jsonErrorString);

		case 3:
			var portName = fact1;
			throw new Error('There can only be one port named `' + portName + '`, but your program has multiple.');

		case 4:
			var portName = fact1;
			var problem = fact2;
			throw new Error('Trying to send an unexpected type of value through port `' + portName + '`:\n' + problem);

		case 5:
			throw new Error('Trying to use `(==)` on functions.\nThere is no way to know if functions are "the same" in the Elm sense.\nRead more about this at https://package.elm-lang.org/packages/elm/core/latest/Basics#== which describes why it is this way and what the better version will look like.');

		case 6:
			var moduleName = fact1;
			throw new Error('Your page is loading multiple Elm scripts with a module named ' + moduleName + '. Maybe a duplicate script is getting loaded accidentally? If not, rename one of them so I know which is which!');

		case 8:
			var moduleName = fact1;
			var region = fact2;
			var message = fact3;
			throw new Error('TODO in module `' + moduleName + '` ' + _Debug_regionToString(region) + '\n\n' + message);

		case 9:
			var moduleName = fact1;
			var region = fact2;
			var value = fact3;
			var message = fact4;
			throw new Error(
				'TODO in module `' + moduleName + '` from the `case` expression '
				+ _Debug_regionToString(region) + '\n\nIt received the following value:\n\n    '
				+ _Debug_toString(value).replace('\n', '\n    ')
				+ '\n\nBut the branch that handles it says:\n\n    ' + message.replace('\n', '\n    ')
			);

		case 10:
			throw new Error('Bug in https://github.com/elm/virtual-dom/issues');

		case 11:
			throw new Error('Cannot perform mod 0. Division by zero error.');
	}
}

function _Debug_regionToString(region)
{
	if (region.start.line === region.end.line)
	{
		return 'on line ' + region.start.line;
	}
	return 'on lines ' + region.start.line + ' through ' + region.end.line;
}



// MATH

var _Basics_add = F2(function(a, b) { return a + b; });
var _Basics_sub = F2(function(a, b) { return a - b; });
var _Basics_mul = F2(function(a, b) { return a * b; });
var _Basics_fdiv = F2(function(a, b) { return a / b; });
var _Basics_idiv = F2(function(a, b) { return (a / b) | 0; });
var _Basics_pow = F2(Math.pow);

var _Basics_remainderBy = F2(function(b, a) { return a % b; });

// https://www.microsoft.com/en-us/research/wp-content/uploads/2016/02/divmodnote-letter.pdf
var _Basics_modBy = F2(function(modulus, x)
{
	var answer = x % modulus;
	return modulus === 0
		? _Debug_crash(11)
		:
	((answer > 0 && modulus < 0) || (answer < 0 && modulus > 0))
		? answer + modulus
		: answer;
});


// TRIGONOMETRY

var _Basics_pi = Math.PI;
var _Basics_e = Math.E;
var _Basics_cos = Math.cos;
var _Basics_sin = Math.sin;
var _Basics_tan = Math.tan;
var _Basics_acos = Math.acos;
var _Basics_asin = Math.asin;
var _Basics_atan = Math.atan;
var _Basics_atan2 = F2(Math.atan2);


// MORE MATH

function _Basics_toFloat(x) { return x; }
function _Basics_truncate(n) { return n | 0; }
function _Basics_isInfinite(n) { return n === Infinity || n === -Infinity; }

var _Basics_ceiling = Math.ceil;
var _Basics_floor = Math.floor;
var _Basics_round = Math.round;
var _Basics_sqrt = Math.sqrt;
var _Basics_log = Math.log;
var _Basics_isNaN = isNaN;


// BOOLEANS

function _Basics_not(bool) { return !bool; }
var _Basics_and = F2(function(a, b) { return a && b; });
var _Basics_or  = F2(function(a, b) { return a || b; });
var _Basics_xor = F2(function(a, b) { return a !== b; });



var _String_cons = F2(function(chr, str)
{
	return chr + str;
});

function _String_uncons(string)
{
	var word = string.charCodeAt(0);
	return !isNaN(word)
		? $elm$core$Maybe$Just(
			0xD800 <= word && word <= 0xDBFF
				? _Utils_Tuple2(_Utils_chr(string[0] + string[1]), string.slice(2))
				: _Utils_Tuple2(_Utils_chr(string[0]), string.slice(1))
		)
		: $elm$core$Maybe$Nothing;
}

var _String_append = F2(function(a, b)
{
	return a + b;
});

function _String_length(str)
{
	return str.length;
}

var _String_map = F2(function(func, string)
{
	var len = string.length;
	var array = new Array(len);
	var i = 0;
	while (i < len)
	{
		var word = string.charCodeAt(i);
		if (0xD800 <= word && word <= 0xDBFF)
		{
			array[i] = func(_Utils_chr(string[i] + string[i+1]));
			i += 2;
			continue;
		}
		array[i] = func(_Utils_chr(string[i]));
		i++;
	}
	return array.join('');
});

var _String_filter = F2(function(isGood, str)
{
	var arr = [];
	var len = str.length;
	var i = 0;
	while (i < len)
	{
		var char = str[i];
		var word = str.charCodeAt(i);
		i++;
		if (0xD800 <= word && word <= 0xDBFF)
		{
			char += str[i];
			i++;
		}

		if (isGood(_Utils_chr(char)))
		{
			arr.push(char);
		}
	}
	return arr.join('');
});

function _String_reverse(str)
{
	var len = str.length;
	var arr = new Array(len);
	var i = 0;
	while (i < len)
	{
		var word = str.charCodeAt(i);
		if (0xD800 <= word && word <= 0xDBFF)
		{
			arr[len - i] = str[i + 1];
			i++;
			arr[len - i] = str[i - 1];
			i++;
		}
		else
		{
			arr[len - i] = str[i];
			i++;
		}
	}
	return arr.join('');
}

var _String_foldl = F3(function(func, state, string)
{
	var len = string.length;
	var i = 0;
	while (i < len)
	{
		var char = string[i];
		var word = string.charCodeAt(i);
		i++;
		if (0xD800 <= word && word <= 0xDBFF)
		{
			char += string[i];
			i++;
		}
		state = A2(func, _Utils_chr(char), state);
	}
	return state;
});

var _String_foldr = F3(function(func, state, string)
{
	var i = string.length;
	while (i--)
	{
		var char = string[i];
		var word = string.charCodeAt(i);
		if (0xDC00 <= word && word <= 0xDFFF)
		{
			i--;
			char = string[i] + char;
		}
		state = A2(func, _Utils_chr(char), state);
	}
	return state;
});

var _String_split = F2(function(sep, str)
{
	return str.split(sep);
});

var _String_join = F2(function(sep, strs)
{
	return strs.join(sep);
});

var _String_slice = F3(function(start, end, str) {
	return str.slice(start, end);
});

function _String_trim(str)
{
	return str.trim();
}

function _String_trimLeft(str)
{
	return str.replace(/^\s+/, '');
}

function _String_trimRight(str)
{
	return str.replace(/\s+$/, '');
}

function _String_words(str)
{
	return _List_fromArray(str.trim().split(/\s+/g));
}

function _String_lines(str)
{
	return _List_fromArray(str.split(/\r\n|\r|\n/g));
}

function _String_toUpper(str)
{
	return str.toUpperCase();
}

function _String_toLower(str)
{
	return str.toLowerCase();
}

var _String_any = F2(function(isGood, string)
{
	var i = string.length;
	while (i--)
	{
		var char = string[i];
		var word = string.charCodeAt(i);
		if (0xDC00 <= word && word <= 0xDFFF)
		{
			i--;
			char = string[i] + char;
		}
		if (isGood(_Utils_chr(char)))
		{
			return true;
		}
	}
	return false;
});

var _String_all = F2(function(isGood, string)
{
	var i = string.length;
	while (i--)
	{
		var char = string[i];
		var word = string.charCodeAt(i);
		if (0xDC00 <= word && word <= 0xDFFF)
		{
			i--;
			char = string[i] + char;
		}
		if (!isGood(_Utils_chr(char)))
		{
			return false;
		}
	}
	return true;
});

var _String_contains = F2(function(sub, str)
{
	return str.indexOf(sub) > -1;
});

var _String_startsWith = F2(function(sub, str)
{
	return str.indexOf(sub) === 0;
});

var _String_endsWith = F2(function(sub, str)
{
	return str.length >= sub.length &&
		str.lastIndexOf(sub) === str.length - sub.length;
});

var _String_indexes = F2(function(sub, str)
{
	var subLen = sub.length;

	if (subLen < 1)
	{
		return _List_Nil;
	}

	var i = 0;
	var is = [];

	while ((i = str.indexOf(sub, i)) > -1)
	{
		is.push(i);
		i = i + subLen;
	}

	return _List_fromArray(is);
});


// TO STRING

function _String_fromNumber(number)
{
	return number + '';
}


// INT CONVERSIONS

function _String_toInt(str)
{
	var total = 0;
	var code0 = str.charCodeAt(0);
	var start = code0 == 0x2B /* + */ || code0 == 0x2D /* - */ ? 1 : 0;

	for (var i = start; i < str.length; ++i)
	{
		var code = str.charCodeAt(i);
		if (code < 0x30 || 0x39 < code)
		{
			return $elm$core$Maybe$Nothing;
		}
		total = 10 * total + code - 0x30;
	}

	return i == start
		? $elm$core$Maybe$Nothing
		: $elm$core$Maybe$Just(code0 == 0x2D ? -total : total);
}


// FLOAT CONVERSIONS

function _String_toFloat(s)
{
	// check if it is a hex, octal, or binary number
	if (s.length === 0 || /[\sxbo]/.test(s))
	{
		return $elm$core$Maybe$Nothing;
	}
	var n = +s;
	// faster isNaN check
	return n === n ? $elm$core$Maybe$Just(n) : $elm$core$Maybe$Nothing;
}

function _String_fromList(chars)
{
	return _List_toArray(chars).join('');
}




function _Char_toCode(char)
{
	var code = char.charCodeAt(0);
	if (0xD800 <= code && code <= 0xDBFF)
	{
		return (code - 0xD800) * 0x400 + char.charCodeAt(1) - 0xDC00 + 0x10000
	}
	return code;
}

function _Char_fromCode(code)
{
	return _Utils_chr(
		(code < 0 || 0x10FFFF < code)
			? '\uFFFD'
			:
		(code <= 0xFFFF)
			? String.fromCharCode(code)
			:
		(code -= 0x10000,
			String.fromCharCode(Math.floor(code / 0x400) + 0xD800, code % 0x400 + 0xDC00)
		)
	);
}

function _Char_toUpper(char)
{
	return _Utils_chr(char.toUpperCase());
}

function _Char_toLower(char)
{
	return _Utils_chr(char.toLowerCase());
}

function _Char_toLocaleUpper(char)
{
	return _Utils_chr(char.toLocaleUpperCase());
}

function _Char_toLocaleLower(char)
{
	return _Utils_chr(char.toLocaleLowerCase());
}



/**/
function _Json_errorToString(error)
{
	return $elm$json$Json$Decode$errorToString(error);
}
//*/


// CORE DECODERS

function _Json_succeed(msg)
{
	return {
		$: 0,
		a: msg
	};
}

function _Json_fail(msg)
{
	return {
		$: 1,
		a: msg
	};
}

function _Json_decodePrim(decoder)
{
	return { $: 2, b: decoder };
}

var _Json_decodeInt = _Json_decodePrim(function(value) {
	return (typeof value !== 'number')
		? _Json_expecting('an INT', value)
		:
	(-2147483647 < value && value < 2147483647 && (value | 0) === value)
		? $elm$core$Result$Ok(value)
		:
	(isFinite(value) && !(value % 1))
		? $elm$core$Result$Ok(value)
		: _Json_expecting('an INT', value);
});

var _Json_decodeBool = _Json_decodePrim(function(value) {
	return (typeof value === 'boolean')
		? $elm$core$Result$Ok(value)
		: _Json_expecting('a BOOL', value);
});

var _Json_decodeFloat = _Json_decodePrim(function(value) {
	return (typeof value === 'number')
		? $elm$core$Result$Ok(value)
		: _Json_expecting('a FLOAT', value);
});

var _Json_decodeValue = _Json_decodePrim(function(value) {
	return $elm$core$Result$Ok(_Json_wrap(value));
});

var _Json_decodeString = _Json_decodePrim(function(value) {
	return (typeof value === 'string')
		? $elm$core$Result$Ok(value)
		: (value instanceof String)
			? $elm$core$Result$Ok(value + '')
			: _Json_expecting('a STRING', value);
});

function _Json_decodeList(decoder) { return { $: 3, b: decoder }; }
function _Json_decodeArray(decoder) { return { $: 4, b: decoder }; }

function _Json_decodeNull(value) { return { $: 5, c: value }; }

var _Json_decodeField = F2(function(field, decoder)
{
	return {
		$: 6,
		d: field,
		b: decoder
	};
});

var _Json_decodeIndex = F2(function(index, decoder)
{
	return {
		$: 7,
		e: index,
		b: decoder
	};
});

function _Json_decodeKeyValuePairs(decoder)
{
	return {
		$: 8,
		b: decoder
	};
}

function _Json_mapMany(f, decoders)
{
	return {
		$: 9,
		f: f,
		g: decoders
	};
}

var _Json_andThen = F2(function(callback, decoder)
{
	return {
		$: 10,
		b: decoder,
		h: callback
	};
});

function _Json_oneOf(decoders)
{
	return {
		$: 11,
		g: decoders
	};
}


// DECODING OBJECTS

var _Json_map1 = F2(function(f, d1)
{
	return _Json_mapMany(f, [d1]);
});

var _Json_map2 = F3(function(f, d1, d2)
{
	return _Json_mapMany(f, [d1, d2]);
});

var _Json_map3 = F4(function(f, d1, d2, d3)
{
	return _Json_mapMany(f, [d1, d2, d3]);
});

var _Json_map4 = F5(function(f, d1, d2, d3, d4)
{
	return _Json_mapMany(f, [d1, d2, d3, d4]);
});

var _Json_map5 = F6(function(f, d1, d2, d3, d4, d5)
{
	return _Json_mapMany(f, [d1, d2, d3, d4, d5]);
});

var _Json_map6 = F7(function(f, d1, d2, d3, d4, d5, d6)
{
	return _Json_mapMany(f, [d1, d2, d3, d4, d5, d6]);
});

var _Json_map7 = F8(function(f, d1, d2, d3, d4, d5, d6, d7)
{
	return _Json_mapMany(f, [d1, d2, d3, d4, d5, d6, d7]);
});

var _Json_map8 = F9(function(f, d1, d2, d3, d4, d5, d6, d7, d8)
{
	return _Json_mapMany(f, [d1, d2, d3, d4, d5, d6, d7, d8]);
});


// DECODE

var _Json_runOnString = F2(function(decoder, string)
{
	try
	{
		var value = JSON.parse(string);
		return _Json_runHelp(decoder, value);
	}
	catch (e)
	{
		return $elm$core$Result$Err(A2($elm$json$Json$Decode$Failure, 'This is not valid JSON! ' + e.message, _Json_wrap(string)));
	}
});

var _Json_run = F2(function(decoder, value)
{
	return _Json_runHelp(decoder, _Json_unwrap(value));
});

function _Json_runHelp(decoder, value)
{
	switch (decoder.$)
	{
		case 2:
			return decoder.b(value);

		case 5:
			return (value === null)
				? $elm$core$Result$Ok(decoder.c)
				: _Json_expecting('null', value);

		case 3:
			if (!_Json_isArray(value))
			{
				return _Json_expecting('a LIST', value);
			}
			return _Json_runArrayDecoder(decoder.b, value, _List_fromArray);

		case 4:
			if (!_Json_isArray(value))
			{
				return _Json_expecting('an ARRAY', value);
			}
			return _Json_runArrayDecoder(decoder.b, value, _Json_toElmArray);

		case 6:
			var field = decoder.d;
			if (typeof value !== 'object' || value === null || !(field in value))
			{
				return _Json_expecting('an OBJECT with a field named `' + field + '`', value);
			}
			var result = _Json_runHelp(decoder.b, value[field]);
			return ($elm$core$Result$isOk(result)) ? result : $elm$core$Result$Err(A2($elm$json$Json$Decode$Field, field, result.a));

		case 7:
			var index = decoder.e;
			if (!_Json_isArray(value))
			{
				return _Json_expecting('an ARRAY', value);
			}
			if (index >= value.length)
			{
				return _Json_expecting('a LONGER array. Need index ' + index + ' but only see ' + value.length + ' entries', value);
			}
			var result = _Json_runHelp(decoder.b, value[index]);
			return ($elm$core$Result$isOk(result)) ? result : $elm$core$Result$Err(A2($elm$json$Json$Decode$Index, index, result.a));

		case 8:
			if (typeof value !== 'object' || value === null || _Json_isArray(value))
			{
				return _Json_expecting('an OBJECT', value);
			}

			var keyValuePairs = _List_Nil;
			// TODO test perf of Object.keys and switch when support is good enough
			for (var key in value)
			{
				if (value.hasOwnProperty(key))
				{
					var result = _Json_runHelp(decoder.b, value[key]);
					if (!$elm$core$Result$isOk(result))
					{
						return $elm$core$Result$Err(A2($elm$json$Json$Decode$Field, key, result.a));
					}
					keyValuePairs = _List_Cons(_Utils_Tuple2(key, result.a), keyValuePairs);
				}
			}
			return $elm$core$Result$Ok($elm$core$List$reverse(keyValuePairs));

		case 9:
			var answer = decoder.f;
			var decoders = decoder.g;
			for (var i = 0; i < decoders.length; i++)
			{
				var result = _Json_runHelp(decoders[i], value);
				if (!$elm$core$Result$isOk(result))
				{
					return result;
				}
				answer = answer(result.a);
			}
			return $elm$core$Result$Ok(answer);

		case 10:
			var result = _Json_runHelp(decoder.b, value);
			return (!$elm$core$Result$isOk(result))
				? result
				: _Json_runHelp(decoder.h(result.a), value);

		case 11:
			var errors = _List_Nil;
			for (var temp = decoder.g; temp.b; temp = temp.b) // WHILE_CONS
			{
				var result = _Json_runHelp(temp.a, value);
				if ($elm$core$Result$isOk(result))
				{
					return result;
				}
				errors = _List_Cons(result.a, errors);
			}
			return $elm$core$Result$Err($elm$json$Json$Decode$OneOf($elm$core$List$reverse(errors)));

		case 1:
			return $elm$core$Result$Err(A2($elm$json$Json$Decode$Failure, decoder.a, _Json_wrap(value)));

		case 0:
			return $elm$core$Result$Ok(decoder.a);
	}
}

function _Json_runArrayDecoder(decoder, value, toElmValue)
{
	var len = value.length;
	var array = new Array(len);
	for (var i = 0; i < len; i++)
	{
		var result = _Json_runHelp(decoder, value[i]);
		if (!$elm$core$Result$isOk(result))
		{
			return $elm$core$Result$Err(A2($elm$json$Json$Decode$Index, i, result.a));
		}
		array[i] = result.a;
	}
	return $elm$core$Result$Ok(toElmValue(array));
}

function _Json_isArray(value)
{
	return Array.isArray(value) || (typeof FileList !== 'undefined' && value instanceof FileList);
}

function _Json_toElmArray(array)
{
	return A2($elm$core$Array$initialize, array.length, function(i) { return array[i]; });
}

function _Json_expecting(type, value)
{
	return $elm$core$Result$Err(A2($elm$json$Json$Decode$Failure, 'Expecting ' + type, _Json_wrap(value)));
}


// EQUALITY

function _Json_equality(x, y)
{
	if (x === y)
	{
		return true;
	}

	if (x.$ !== y.$)
	{
		return false;
	}

	switch (x.$)
	{
		case 0:
		case 1:
			return x.a === y.a;

		case 2:
			return x.b === y.b;

		case 5:
			return x.c === y.c;

		case 3:
		case 4:
		case 8:
			return _Json_equality(x.b, y.b);

		case 6:
			return x.d === y.d && _Json_equality(x.b, y.b);

		case 7:
			return x.e === y.e && _Json_equality(x.b, y.b);

		case 9:
			return x.f === y.f && _Json_listEquality(x.g, y.g);

		case 10:
			return x.h === y.h && _Json_equality(x.b, y.b);

		case 11:
			return _Json_listEquality(x.g, y.g);
	}
}

function _Json_listEquality(aDecoders, bDecoders)
{
	var len = aDecoders.length;
	if (len !== bDecoders.length)
	{
		return false;
	}
	for (var i = 0; i < len; i++)
	{
		if (!_Json_equality(aDecoders[i], bDecoders[i]))
		{
			return false;
		}
	}
	return true;
}


// ENCODE

var _Json_encode = F2(function(indentLevel, value)
{
	return JSON.stringify(_Json_unwrap(value), null, indentLevel) + '';
});

function _Json_wrap(value) { return { $: 0, a: value }; }
function _Json_unwrap(value) { return value.a; }

function _Json_wrap_UNUSED(value) { return value; }
function _Json_unwrap_UNUSED(value) { return value; }

function _Json_emptyArray() { return []; }
function _Json_emptyObject() { return {}; }

var _Json_addField = F3(function(key, value, object)
{
	object[key] = _Json_unwrap(value);
	return object;
});

function _Json_addEntry(func)
{
	return F2(function(entry, array)
	{
		array.push(_Json_unwrap(func(entry)));
		return array;
	});
}

var _Json_encodeNull = _Json_wrap(null);



// TASKS

function _Scheduler_succeed(value)
{
	return {
		$: 0,
		a: value
	};
}

function _Scheduler_fail(error)
{
	return {
		$: 1,
		a: error
	};
}

function _Scheduler_binding(callback)
{
	return {
		$: 2,
		b: callback,
		c: null
	};
}

var _Scheduler_andThen = F2(function(callback, task)
{
	return {
		$: 3,
		b: callback,
		d: task
	};
});

var _Scheduler_onError = F2(function(callback, task)
{
	return {
		$: 4,
		b: callback,
		d: task
	};
});

function _Scheduler_receive(callback)
{
	return {
		$: 5,
		b: callback
	};
}


// PROCESSES

var _Scheduler_guid = 0;

function _Scheduler_rawSpawn(task)
{
	var proc = {
		$: 0,
		e: _Scheduler_guid++,
		f: task,
		g: null,
		h: []
	};

	_Scheduler_enqueue(proc);

	return proc;
}

function _Scheduler_spawn(task)
{
	return _Scheduler_binding(function(callback) {
		callback(_Scheduler_succeed(_Scheduler_rawSpawn(task)));
	});
}

function _Scheduler_rawSend(proc, msg)
{
	proc.h.push(msg);
	_Scheduler_enqueue(proc);
}

var _Scheduler_send = F2(function(proc, msg)
{
	return _Scheduler_binding(function(callback) {
		_Scheduler_rawSend(proc, msg);
		callback(_Scheduler_succeed(_Utils_Tuple0));
	});
});

function _Scheduler_kill(proc)
{
	return _Scheduler_binding(function(callback) {
		var task = proc.f;
		if (task.$ === 2 && task.c)
		{
			task.c();
		}

		proc.f = null;

		callback(_Scheduler_succeed(_Utils_Tuple0));
	});
}


/* STEP PROCESSES

type alias Process =
  { $ : tag
  , id : unique_id
  , root : Task
  , stack : null | { $: SUCCEED | FAIL, a: callback, b: stack }
  , mailbox : [msg]
  }

*/


var _Scheduler_working = false;
var _Scheduler_queue = [];


function _Scheduler_enqueue(proc)
{
	_Scheduler_queue.push(proc);
	if (_Scheduler_working)
	{
		return;
	}
	_Scheduler_working = true;
	while (proc = _Scheduler_queue.shift())
	{
		_Scheduler_step(proc);
	}
	_Scheduler_working = false;
}


function _Scheduler_step(proc)
{
	while (proc.f)
	{
		var rootTag = proc.f.$;
		if (rootTag === 0 || rootTag === 1)
		{
			while (proc.g && proc.g.$ !== rootTag)
			{
				proc.g = proc.g.i;
			}
			if (!proc.g)
			{
				return;
			}
			proc.f = proc.g.b(proc.f.a);
			proc.g = proc.g.i;
		}
		else if (rootTag === 2)
		{
			proc.f.c = proc.f.b(function(newRoot) {
				proc.f = newRoot;
				_Scheduler_enqueue(proc);
			});
			return;
		}
		else if (rootTag === 5)
		{
			if (proc.h.length === 0)
			{
				return;
			}
			proc.f = proc.f.b(proc.h.shift());
		}
		else // if (rootTag === 3 || rootTag === 4)
		{
			proc.g = {
				$: rootTag === 3 ? 0 : 1,
				b: proc.f.b,
				i: proc.g
			};
			proc.f = proc.f.d;
		}
	}
}



function _Process_sleep(time)
{
	return _Scheduler_binding(function(callback) {
		var id = setTimeout(function() {
			callback(_Scheduler_succeed(_Utils_Tuple0));
		}, time);

		return function() { clearTimeout(id); };
	});
}




// PROGRAMS


var _Platform_worker = F4(function(impl, flagDecoder, debugMetadata, args)
{
	return _Platform_initialize(
		flagDecoder,
		args,
		impl.init,
		impl.update,
		impl.subscriptions,
		function() { return function() {} }
	);
});



// INITIALIZE A PROGRAM


function _Platform_initialize(flagDecoder, args, init, update, subscriptions, stepperBuilder)
{
	var result = A2(_Json_run, flagDecoder, _Json_wrap(args ? args['flags'] : undefined));
	$elm$core$Result$isOk(result) || _Debug_crash(2 /**/, _Json_errorToString(result.a) /**/);
	var managers = {};
	var initPair = init(result.a);
	var model = initPair.a;
	var stepper = stepperBuilder(sendToApp, model);
	var ports = _Platform_setupEffects(managers, sendToApp);

	function sendToApp(msg, viewMetadata)
	{
		var pair = A2(update, msg, model);
		stepper(model = pair.a, viewMetadata);
		_Platform_enqueueEffects(managers, pair.b, subscriptions(model));
	}

	_Platform_enqueueEffects(managers, initPair.b, subscriptions(model));

	return ports ? { ports: ports } : {};
}



// TRACK PRELOADS
//
// This is used by code in elm/browser and elm/http
// to register any HTTP requests that are triggered by init.
//


var _Platform_preload;


function _Platform_registerPreload(url)
{
	_Platform_preload.add(url);
}



// EFFECT MANAGERS


var _Platform_effectManagers = {};


function _Platform_setupEffects(managers, sendToApp)
{
	var ports;

	// setup all necessary effect managers
	for (var key in _Platform_effectManagers)
	{
		var manager = _Platform_effectManagers[key];

		if (manager.a)
		{
			ports = ports || {};
			ports[key] = manager.a(key, sendToApp);
		}

		managers[key] = _Platform_instantiateManager(manager, sendToApp);
	}

	return ports;
}


function _Platform_createManager(init, onEffects, onSelfMsg, cmdMap, subMap)
{
	return {
		b: init,
		c: onEffects,
		d: onSelfMsg,
		e: cmdMap,
		f: subMap
	};
}


function _Platform_instantiateManager(info, sendToApp)
{
	var router = {
		g: sendToApp,
		h: undefined
	};

	var onEffects = info.c;
	var onSelfMsg = info.d;
	var cmdMap = info.e;
	var subMap = info.f;

	function loop(state)
	{
		return A2(_Scheduler_andThen, loop, _Scheduler_receive(function(msg)
		{
			var value = msg.a;

			if (msg.$ === 0)
			{
				return A3(onSelfMsg, router, value, state);
			}

			return cmdMap && subMap
				? A4(onEffects, router, value.i, value.j, state)
				: A3(onEffects, router, cmdMap ? value.i : value.j, state);
		}));
	}

	return router.h = _Scheduler_rawSpawn(A2(_Scheduler_andThen, loop, info.b));
}



// ROUTING


var _Platform_sendToApp = F2(function(router, msg)
{
	return _Scheduler_binding(function(callback)
	{
		router.g(msg);
		callback(_Scheduler_succeed(_Utils_Tuple0));
	});
});


var _Platform_sendToSelf = F2(function(router, msg)
{
	return A2(_Scheduler_send, router.h, {
		$: 0,
		a: msg
	});
});



// BAGS


function _Platform_leaf(home)
{
	return function(value)
	{
		return {
			$: 1,
			k: home,
			l: value
		};
	};
}


function _Platform_batch(list)
{
	return {
		$: 2,
		m: list
	};
}


var _Platform_map = F2(function(tagger, bag)
{
	return {
		$: 3,
		n: tagger,
		o: bag
	}
});



// PIPE BAGS INTO EFFECT MANAGERS
//
// Effects must be queued!
//
// Say your init contains a synchronous command, like Time.now or Time.here
//
//   - This will produce a batch of effects (FX_1)
//   - The synchronous task triggers the subsequent `update` call
//   - This will produce a batch of effects (FX_2)
//
// If we just start dispatching FX_2, subscriptions from FX_2 can be processed
// before subscriptions from FX_1. No good! Earlier versions of this code had
// this problem, leading to these reports:
//
//   https://github.com/elm/core/issues/980
//   https://github.com/elm/core/pull/981
//   https://github.com/elm/compiler/issues/1776
//
// The queue is necessary to avoid ordering issues for synchronous commands.


// Why use true/false here? Why not just check the length of the queue?
// The goal is to detect "are we currently dispatching effects?" If we
// are, we need to bail and let the ongoing while loop handle things.
//
// Now say the queue has 1 element. When we dequeue the final element,
// the queue will be empty, but we are still actively dispatching effects.
// So you could get queue jumping in a really tricky category of cases.
//
var _Platform_effectsQueue = [];
var _Platform_effectsActive = false;


function _Platform_enqueueEffects(managers, cmdBag, subBag)
{
	_Platform_effectsQueue.push({ p: managers, q: cmdBag, r: subBag });

	if (_Platform_effectsActive) return;

	_Platform_effectsActive = true;
	for (var fx; fx = _Platform_effectsQueue.shift(); )
	{
		_Platform_dispatchEffects(fx.p, fx.q, fx.r);
	}
	_Platform_effectsActive = false;
}


function _Platform_dispatchEffects(managers, cmdBag, subBag)
{
	var effectsDict = {};
	_Platform_gatherEffects(true, cmdBag, effectsDict, null);
	_Platform_gatherEffects(false, subBag, effectsDict, null);

	for (var home in managers)
	{
		_Scheduler_rawSend(managers[home], {
			$: 'fx',
			a: effectsDict[home] || { i: _List_Nil, j: _List_Nil }
		});
	}
}


function _Platform_gatherEffects(isCmd, bag, effectsDict, taggers)
{
	switch (bag.$)
	{
		case 1:
			var home = bag.k;
			var effect = _Platform_toEffect(isCmd, home, taggers, bag.l);
			effectsDict[home] = _Platform_insert(isCmd, effect, effectsDict[home]);
			return;

		case 2:
			for (var list = bag.m; list.b; list = list.b) // WHILE_CONS
			{
				_Platform_gatherEffects(isCmd, list.a, effectsDict, taggers);
			}
			return;

		case 3:
			_Platform_gatherEffects(isCmd, bag.o, effectsDict, {
				s: bag.n,
				t: taggers
			});
			return;
	}
}


function _Platform_toEffect(isCmd, home, taggers, value)
{
	function applyTaggers(x)
	{
		for (var temp = taggers; temp; temp = temp.t)
		{
			x = temp.s(x);
		}
		return x;
	}

	var map = isCmd
		? _Platform_effectManagers[home].e
		: _Platform_effectManagers[home].f;

	return A2(map, applyTaggers, value)
}


function _Platform_insert(isCmd, newEffect, effects)
{
	effects = effects || { i: _List_Nil, j: _List_Nil };

	isCmd
		? (effects.i = _List_Cons(newEffect, effects.i))
		: (effects.j = _List_Cons(newEffect, effects.j));

	return effects;
}



// PORTS


function _Platform_checkPortName(name)
{
	if (_Platform_effectManagers[name])
	{
		_Debug_crash(3, name)
	}
}



// OUTGOING PORTS


function _Platform_outgoingPort(name, converter)
{
	_Platform_checkPortName(name);
	_Platform_effectManagers[name] = {
		e: _Platform_outgoingPortMap,
		u: converter,
		a: _Platform_setupOutgoingPort
	};
	return _Platform_leaf(name);
}


var _Platform_outgoingPortMap = F2(function(tagger, value) { return value; });


function _Platform_setupOutgoingPort(name)
{
	var subs = [];
	var converter = _Platform_effectManagers[name].u;

	// CREATE MANAGER

	var init = _Process_sleep(0);

	_Platform_effectManagers[name].b = init;
	_Platform_effectManagers[name].c = F3(function(router, cmdList, state)
	{
		for ( ; cmdList.b; cmdList = cmdList.b) // WHILE_CONS
		{
			// grab a separate reference to subs in case unsubscribe is called
			var currentSubs = subs;
			var value = _Json_unwrap(converter(cmdList.a));
			for (var i = 0; i < currentSubs.length; i++)
			{
				currentSubs[i](value);
			}
		}
		return init;
	});

	// PUBLIC API

	function subscribe(callback)
	{
		subs.push(callback);
	}

	function unsubscribe(callback)
	{
		// copy subs into a new array in case unsubscribe is called within a
		// subscribed callback
		subs = subs.slice();
		var index = subs.indexOf(callback);
		if (index >= 0)
		{
			subs.splice(index, 1);
		}
	}

	return {
		subscribe: subscribe,
		unsubscribe: unsubscribe
	};
}



// INCOMING PORTS


function _Platform_incomingPort(name, converter)
{
	_Platform_checkPortName(name);
	_Platform_effectManagers[name] = {
		f: _Platform_incomingPortMap,
		u: converter,
		a: _Platform_setupIncomingPort
	};
	return _Platform_leaf(name);
}


var _Platform_incomingPortMap = F2(function(tagger, finalTagger)
{
	return function(value)
	{
		return tagger(finalTagger(value));
	};
});


function _Platform_setupIncomingPort(name, sendToApp)
{
	var subs = _List_Nil;
	var converter = _Platform_effectManagers[name].u;

	// CREATE MANAGER

	var init = _Scheduler_succeed(null);

	_Platform_effectManagers[name].b = init;
	_Platform_effectManagers[name].c = F3(function(router, subList, state)
	{
		subs = subList;
		return init;
	});

	// PUBLIC API

	function send(incomingValue)
	{
		var result = A2(_Json_run, converter, _Json_wrap(incomingValue));

		$elm$core$Result$isOk(result) || _Debug_crash(4, name, result.a);

		var value = result.a;
		for (var temp = subs; temp.b; temp = temp.b) // WHILE_CONS
		{
			sendToApp(temp.a(value));
		}
	}

	return { send: send };
}



// EXPORT ELM MODULES
//
// Have DEBUG and PROD versions so that we can (1) give nicer errors in
// debug mode and (2) not pay for the bits needed for that in prod mode.
//


function _Platform_export_UNUSED(exports)
{
	scope['Elm']
		? _Platform_mergeExportsProd(scope['Elm'], exports)
		: scope['Elm'] = exports;
}


function _Platform_mergeExportsProd(obj, exports)
{
	for (var name in exports)
	{
		(name in obj)
			? (name == 'init')
				? _Debug_crash(6)
				: _Platform_mergeExportsProd(obj[name], exports[name])
			: (obj[name] = exports[name]);
	}
}


function _Platform_export(exports)
{
	scope['Elm']
		? _Platform_mergeExportsDebug('Elm', scope['Elm'], exports)
		: scope['Elm'] = exports;
}


function _Platform_mergeExportsDebug(moduleName, obj, exports)
{
	for (var name in exports)
	{
		(name in obj)
			? (name == 'init')
				? _Debug_crash(6, moduleName)
				: _Platform_mergeExportsDebug(moduleName + '.' + name, obj[name], exports[name])
			: (obj[name] = exports[name]);
	}
}




// HELPERS


var _VirtualDom_divertHrefToApp;

var _VirtualDom_doc = typeof document !== 'undefined' ? document : {};


function _VirtualDom_appendChild(parent, child)
{
	parent.appendChild(child);
}

var _VirtualDom_init = F4(function(virtualNode, flagDecoder, debugMetadata, args)
{
	// NOTE: this function needs _Platform_export available to work

	/**_UNUSED/
	var node = args['node'];
	//*/
	/**/
	var node = args && args['node'] ? args['node'] : _Debug_crash(0);
	//*/

	node.parentNode.replaceChild(
		_VirtualDom_render(virtualNode, function() {}),
		node
	);

	return {};
});



// TEXT


function _VirtualDom_text(string)
{
	return {
		$: 0,
		a: string
	};
}



// NODE


var _VirtualDom_nodeNS = F2(function(namespace, tag)
{
	return F2(function(factList, kidList)
	{
		for (var kids = [], descendantsCount = 0; kidList.b; kidList = kidList.b) // WHILE_CONS
		{
			var kid = kidList.a;
			descendantsCount += (kid.b || 0);
			kids.push(kid);
		}
		descendantsCount += kids.length;

		return {
			$: 1,
			c: tag,
			d: _VirtualDom_organizeFacts(factList),
			e: kids,
			f: namespace,
			b: descendantsCount
		};
	});
});


var _VirtualDom_node = _VirtualDom_nodeNS(undefined);



// KEYED NODE


var _VirtualDom_keyedNodeNS = F2(function(namespace, tag)
{
	return F2(function(factList, kidList)
	{
		for (var kids = [], descendantsCount = 0; kidList.b; kidList = kidList.b) // WHILE_CONS
		{
			var kid = kidList.a;
			descendantsCount += (kid.b.b || 0);
			kids.push(kid);
		}
		descendantsCount += kids.length;

		return {
			$: 2,
			c: tag,
			d: _VirtualDom_organizeFacts(factList),
			e: kids,
			f: namespace,
			b: descendantsCount
		};
	});
});


var _VirtualDom_keyedNode = _VirtualDom_keyedNodeNS(undefined);



// CUSTOM


function _VirtualDom_custom(factList, model, render, diff)
{
	return {
		$: 3,
		d: _VirtualDom_organizeFacts(factList),
		g: model,
		h: render,
		i: diff
	};
}



// MAP


var _VirtualDom_map = F2(function(tagger, node)
{
	return {
		$: 4,
		j: tagger,
		k: node,
		b: 1 + (node.b || 0)
	};
});



// LAZY


function _VirtualDom_thunk(refs, thunk)
{
	return {
		$: 5,
		l: refs,
		m: thunk,
		k: undefined
	};
}

var _VirtualDom_lazy = F2(function(func, a)
{
	return _VirtualDom_thunk([func, a], function() {
		return func(a);
	});
});

var _VirtualDom_lazy2 = F3(function(func, a, b)
{
	return _VirtualDom_thunk([func, a, b], function() {
		return A2(func, a, b);
	});
});

var _VirtualDom_lazy3 = F4(function(func, a, b, c)
{
	return _VirtualDom_thunk([func, a, b, c], function() {
		return A3(func, a, b, c);
	});
});

var _VirtualDom_lazy4 = F5(function(func, a, b, c, d)
{
	return _VirtualDom_thunk([func, a, b, c, d], function() {
		return A4(func, a, b, c, d);
	});
});

var _VirtualDom_lazy5 = F6(function(func, a, b, c, d, e)
{
	return _VirtualDom_thunk([func, a, b, c, d, e], function() {
		return A5(func, a, b, c, d, e);
	});
});

var _VirtualDom_lazy6 = F7(function(func, a, b, c, d, e, f)
{
	return _VirtualDom_thunk([func, a, b, c, d, e, f], function() {
		return A6(func, a, b, c, d, e, f);
	});
});

var _VirtualDom_lazy7 = F8(function(func, a, b, c, d, e, f, g)
{
	return _VirtualDom_thunk([func, a, b, c, d, e, f, g], function() {
		return A7(func, a, b, c, d, e, f, g);
	});
});

var _VirtualDom_lazy8 = F9(function(func, a, b, c, d, e, f, g, h)
{
	return _VirtualDom_thunk([func, a, b, c, d, e, f, g, h], function() {
		return A8(func, a, b, c, d, e, f, g, h);
	});
});



// FACTS


var _VirtualDom_on = F2(function(key, handler)
{
	return {
		$: 'a0',
		n: key,
		o: handler
	};
});
var _VirtualDom_style = F2(function(key, value)
{
	return {
		$: 'a1',
		n: key,
		o: value
	};
});
var _VirtualDom_property = F2(function(key, value)
{
	return {
		$: 'a2',
		n: key,
		o: value
	};
});
var _VirtualDom_attribute = F2(function(key, value)
{
	return {
		$: 'a3',
		n: key,
		o: value
	};
});
var _VirtualDom_attributeNS = F3(function(namespace, key, value)
{
	return {
		$: 'a4',
		n: key,
		o: { f: namespace, o: value }
	};
});



// XSS ATTACK VECTOR CHECKS


function _VirtualDom_noScript(tag)
{
	return tag == 'script' ? 'p' : tag;
}

function _VirtualDom_noOnOrFormAction(key)
{
	return /^(on|formAction$)/i.test(key) ? 'data-' + key : key;
}

function _VirtualDom_noInnerHtmlOrFormAction(key)
{
	return key == 'innerHTML' || key == 'formAction' ? 'data-' + key : key;
}

function _VirtualDom_noJavaScriptUri_UNUSED(value)
{
	return /^javascript:/i.test(value.replace(/\s/g,'')) ? '' : value;
}

function _VirtualDom_noJavaScriptUri(value)
{
	return /^javascript:/i.test(value.replace(/\s/g,''))
		? 'javascript:alert("This is an XSS vector. Please use ports or web components instead.")'
		: value;
}

function _VirtualDom_noJavaScriptOrHtmlUri_UNUSED(value)
{
	return /^\s*(javascript:|data:text\/html)/i.test(value) ? '' : value;
}

function _VirtualDom_noJavaScriptOrHtmlUri(value)
{
	return /^\s*(javascript:|data:text\/html)/i.test(value)
		? 'javascript:alert("This is an XSS vector. Please use ports or web components instead.")'
		: value;
}



// MAP FACTS


var _VirtualDom_mapAttribute = F2(function(func, attr)
{
	return (attr.$ === 'a0')
		? A2(_VirtualDom_on, attr.n, _VirtualDom_mapHandler(func, attr.o))
		: attr;
});

function _VirtualDom_mapHandler(func, handler)
{
	var tag = $elm$virtual_dom$VirtualDom$toHandlerInt(handler);

	// 0 = Normal
	// 1 = MayStopPropagation
	// 2 = MayPreventDefault
	// 3 = Custom

	return {
		$: handler.$,
		a:
			!tag
				? A2($elm$json$Json$Decode$map, func, handler.a)
				:
			A3($elm$json$Json$Decode$map2,
				tag < 3
					? _VirtualDom_mapEventTuple
					: _VirtualDom_mapEventRecord,
				$elm$json$Json$Decode$succeed(func),
				handler.a
			)
	};
}

var _VirtualDom_mapEventTuple = F2(function(func, tuple)
{
	return _Utils_Tuple2(func(tuple.a), tuple.b);
});

var _VirtualDom_mapEventRecord = F2(function(func, record)
{
	return {
		message: func(record.message),
		stopPropagation: record.stopPropagation,
		preventDefault: record.preventDefault
	}
});



// ORGANIZE FACTS


function _VirtualDom_organizeFacts(factList)
{
	for (var facts = {}; factList.b; factList = factList.b) // WHILE_CONS
	{
		var entry = factList.a;

		var tag = entry.$;
		var key = entry.n;
		var value = entry.o;

		if (tag === 'a2')
		{
			(key === 'className')
				? _VirtualDom_addClass(facts, key, _Json_unwrap(value))
				: facts[key] = _Json_unwrap(value);

			continue;
		}

		var subFacts = facts[tag] || (facts[tag] = {});
		(tag === 'a3' && key === 'class')
			? _VirtualDom_addClass(subFacts, key, value)
			: subFacts[key] = value;
	}

	return facts;
}

function _VirtualDom_addClass(object, key, newClass)
{
	var classes = object[key];
	object[key] = classes ? classes + ' ' + newClass : newClass;
}



// RENDER


function _VirtualDom_render(vNode, eventNode)
{
	var tag = vNode.$;

	if (tag === 5)
	{
		return _VirtualDom_render(vNode.k || (vNode.k = vNode.m()), eventNode);
	}

	if (tag === 0)
	{
		return _VirtualDom_doc.createTextNode(vNode.a);
	}

	if (tag === 4)
	{
		var subNode = vNode.k;
		var tagger = vNode.j;

		while (subNode.$ === 4)
		{
			typeof tagger !== 'object'
				? tagger = [tagger, subNode.j]
				: tagger.push(subNode.j);

			subNode = subNode.k;
		}

		var subEventRoot = { j: tagger, p: eventNode };
		var domNode = _VirtualDom_render(subNode, subEventRoot);
		domNode.elm_event_node_ref = subEventRoot;
		return domNode;
	}

	if (tag === 3)
	{
		var domNode = vNode.h(vNode.g);
		_VirtualDom_applyFacts(domNode, eventNode, vNode.d);
		return domNode;
	}

	// at this point `tag` must be 1 or 2

	var domNode = vNode.f
		? _VirtualDom_doc.createElementNS(vNode.f, vNode.c)
		: _VirtualDom_doc.createElement(vNode.c);

	if (_VirtualDom_divertHrefToApp && vNode.c == 'a')
	{
		domNode.addEventListener('click', _VirtualDom_divertHrefToApp(domNode));
	}

	_VirtualDom_applyFacts(domNode, eventNode, vNode.d);

	for (var kids = vNode.e, i = 0; i < kids.length; i++)
	{
		_VirtualDom_appendChild(domNode, _VirtualDom_render(tag === 1 ? kids[i] : kids[i].b, eventNode));
	}

	return domNode;
}



// APPLY FACTS


function _VirtualDom_applyFacts(domNode, eventNode, facts)
{
	for (var key in facts)
	{
		var value = facts[key];

		key === 'a1'
			? _VirtualDom_applyStyles(domNode, value)
			:
		key === 'a0'
			? _VirtualDom_applyEvents(domNode, eventNode, value)
			:
		key === 'a3'
			? _VirtualDom_applyAttrs(domNode, value)
			:
		key === 'a4'
			? _VirtualDom_applyAttrsNS(domNode, value)
			:
		((key !== 'value' && key !== 'checked') || domNode[key] !== value) && (domNode[key] = value);
	}
}



// APPLY STYLES


function _VirtualDom_applyStyles(domNode, styles)
{
	var domNodeStyle = domNode.style;

	for (var key in styles)
	{
		domNodeStyle[key] = styles[key];
	}
}



// APPLY ATTRS


function _VirtualDom_applyAttrs(domNode, attrs)
{
	for (var key in attrs)
	{
		var value = attrs[key];
		typeof value !== 'undefined'
			? domNode.setAttribute(key, value)
			: domNode.removeAttribute(key);
	}
}



// APPLY NAMESPACED ATTRS


function _VirtualDom_applyAttrsNS(domNode, nsAttrs)
{
	for (var key in nsAttrs)
	{
		var pair = nsAttrs[key];
		var namespace = pair.f;
		var value = pair.o;

		typeof value !== 'undefined'
			? domNode.setAttributeNS(namespace, key, value)
			: domNode.removeAttributeNS(namespace, key);
	}
}



// APPLY EVENTS


function _VirtualDom_applyEvents(domNode, eventNode, events)
{
	var allCallbacks = domNode.elmFs || (domNode.elmFs = {});

	for (var key in events)
	{
		var newHandler = events[key];
		var oldCallback = allCallbacks[key];

		if (!newHandler)
		{
			domNode.removeEventListener(key, oldCallback);
			allCallbacks[key] = undefined;
			continue;
		}

		if (oldCallback)
		{
			var oldHandler = oldCallback.q;
			if (oldHandler.$ === newHandler.$)
			{
				oldCallback.q = newHandler;
				continue;
			}
			domNode.removeEventListener(key, oldCallback);
		}

		oldCallback = _VirtualDom_makeCallback(eventNode, newHandler);
		domNode.addEventListener(key, oldCallback,
			_VirtualDom_passiveSupported
			&& { passive: $elm$virtual_dom$VirtualDom$toHandlerInt(newHandler) < 2 }
		);
		allCallbacks[key] = oldCallback;
	}
}



// PASSIVE EVENTS


var _VirtualDom_passiveSupported;

try
{
	window.addEventListener('t', null, Object.defineProperty({}, 'passive', {
		get: function() { _VirtualDom_passiveSupported = true; }
	}));
}
catch(e) {}



// EVENT HANDLERS


function _VirtualDom_makeCallback(eventNode, initialHandler)
{
	function callback(event)
	{
		var handler = callback.q;
		var result = _Json_runHelp(handler.a, event);

		if (!$elm$core$Result$isOk(result))
		{
			return;
		}

		var tag = $elm$virtual_dom$VirtualDom$toHandlerInt(handler);

		// 0 = Normal
		// 1 = MayStopPropagation
		// 2 = MayPreventDefault
		// 3 = Custom

		var value = result.a;
		var message = !tag ? value : tag < 3 ? value.a : value.message;
		var stopPropagation = tag == 1 ? value.b : tag == 3 && value.stopPropagation;
		var currentEventNode = (
			stopPropagation && event.stopPropagation(),
			(tag == 2 ? value.b : tag == 3 && value.preventDefault) && event.preventDefault(),
			eventNode
		);
		var tagger;
		var i;
		while (tagger = currentEventNode.j)
		{
			if (typeof tagger == 'function')
			{
				message = tagger(message);
			}
			else
			{
				for (var i = tagger.length; i--; )
				{
					message = tagger[i](message);
				}
			}
			currentEventNode = currentEventNode.p;
		}
		currentEventNode(message, stopPropagation); // stopPropagation implies isSync
	}

	callback.q = initialHandler;

	return callback;
}

function _VirtualDom_equalEvents(x, y)
{
	return x.$ == y.$ && _Json_equality(x.a, y.a);
}



// DIFF


// TODO: Should we do patches like in iOS?
//
// type Patch
//   = At Int Patch
//   | Batch (List Patch)
//   | Change ...
//
// How could it not be better?
//
function _VirtualDom_diff(x, y)
{
	var patches = [];
	_VirtualDom_diffHelp(x, y, patches, 0);
	return patches;
}


function _VirtualDom_pushPatch(patches, type, index, data)
{
	var patch = {
		$: type,
		r: index,
		s: data,
		t: undefined,
		u: undefined
	};
	patches.push(patch);
	return patch;
}


function _VirtualDom_diffHelp(x, y, patches, index)
{
	if (x === y)
	{
		return;
	}

	var xType = x.$;
	var yType = y.$;

	// Bail if you run into different types of nodes. Implies that the
	// structure has changed significantly and it's not worth a diff.
	if (xType !== yType)
	{
		if (xType === 1 && yType === 2)
		{
			y = _VirtualDom_dekey(y);
			yType = 1;
		}
		else
		{
			_VirtualDom_pushPatch(patches, 0, index, y);
			return;
		}
	}

	// Now we know that both nodes are the same $.
	switch (yType)
	{
		case 5:
			var xRefs = x.l;
			var yRefs = y.l;
			var i = xRefs.length;
			var same = i === yRefs.length;
			while (same && i--)
			{
				same = xRefs[i] === yRefs[i];
			}
			if (same)
			{
				y.k = x.k;
				return;
			}
			y.k = y.m();
			var subPatches = [];
			_VirtualDom_diffHelp(x.k, y.k, subPatches, 0);
			subPatches.length > 0 && _VirtualDom_pushPatch(patches, 1, index, subPatches);
			return;

		case 4:
			// gather nested taggers
			var xTaggers = x.j;
			var yTaggers = y.j;
			var nesting = false;

			var xSubNode = x.k;
			while (xSubNode.$ === 4)
			{
				nesting = true;

				typeof xTaggers !== 'object'
					? xTaggers = [xTaggers, xSubNode.j]
					: xTaggers.push(xSubNode.j);

				xSubNode = xSubNode.k;
			}

			var ySubNode = y.k;
			while (ySubNode.$ === 4)
			{
				nesting = true;

				typeof yTaggers !== 'object'
					? yTaggers = [yTaggers, ySubNode.j]
					: yTaggers.push(ySubNode.j);

				ySubNode = ySubNode.k;
			}

			// Just bail if different numbers of taggers. This implies the
			// structure of the virtual DOM has changed.
			if (nesting && xTaggers.length !== yTaggers.length)
			{
				_VirtualDom_pushPatch(patches, 0, index, y);
				return;
			}

			// check if taggers are "the same"
			if (nesting ? !_VirtualDom_pairwiseRefEqual(xTaggers, yTaggers) : xTaggers !== yTaggers)
			{
				_VirtualDom_pushPatch(patches, 2, index, yTaggers);
			}

			// diff everything below the taggers
			_VirtualDom_diffHelp(xSubNode, ySubNode, patches, index + 1);
			return;

		case 0:
			if (x.a !== y.a)
			{
				_VirtualDom_pushPatch(patches, 3, index, y.a);
			}
			return;

		case 1:
			_VirtualDom_diffNodes(x, y, patches, index, _VirtualDom_diffKids);
			return;

		case 2:
			_VirtualDom_diffNodes(x, y, patches, index, _VirtualDom_diffKeyedKids);
			return;

		case 3:
			if (x.h !== y.h)
			{
				_VirtualDom_pushPatch(patches, 0, index, y);
				return;
			}

			var factsDiff = _VirtualDom_diffFacts(x.d, y.d);
			factsDiff && _VirtualDom_pushPatch(patches, 4, index, factsDiff);

			var patch = y.i(x.g, y.g);
			patch && _VirtualDom_pushPatch(patches, 5, index, patch);

			return;
	}
}

// assumes the incoming arrays are the same length
function _VirtualDom_pairwiseRefEqual(as, bs)
{
	for (var i = 0; i < as.length; i++)
	{
		if (as[i] !== bs[i])
		{
			return false;
		}
	}

	return true;
}

function _VirtualDom_diffNodes(x, y, patches, index, diffKids)
{
	// Bail if obvious indicators have changed. Implies more serious
	// structural changes such that it's not worth it to diff.
	if (x.c !== y.c || x.f !== y.f)
	{
		_VirtualDom_pushPatch(patches, 0, index, y);
		return;
	}

	var factsDiff = _VirtualDom_diffFacts(x.d, y.d);
	factsDiff && _VirtualDom_pushPatch(patches, 4, index, factsDiff);

	diffKids(x, y, patches, index);
}



// DIFF FACTS


// TODO Instead of creating a new diff object, it's possible to just test if
// there *is* a diff. During the actual patch, do the diff again and make the
// modifications directly. This way, there's no new allocations. Worth it?
function _VirtualDom_diffFacts(x, y, category)
{
	var diff;

	// look for changes and removals
	for (var xKey in x)
	{
		if (xKey === 'a1' || xKey === 'a0' || xKey === 'a3' || xKey === 'a4')
		{
			var subDiff = _VirtualDom_diffFacts(x[xKey], y[xKey] || {}, xKey);
			if (subDiff)
			{
				diff = diff || {};
				diff[xKey] = subDiff;
			}
			continue;
		}

		// remove if not in the new facts
		if (!(xKey in y))
		{
			diff = diff || {};
			diff[xKey] =
				!category
					? (typeof x[xKey] === 'string' ? '' : null)
					:
				(category === 'a1')
					? ''
					:
				(category === 'a0' || category === 'a3')
					? undefined
					:
				{ f: x[xKey].f, o: undefined };

			continue;
		}

		var xValue = x[xKey];
		var yValue = y[xKey];

		// reference equal, so don't worry about it
		if (xValue === yValue && xKey !== 'value' && xKey !== 'checked'
			|| category === 'a0' && _VirtualDom_equalEvents(xValue, yValue))
		{
			continue;
		}

		diff = diff || {};
		diff[xKey] = yValue;
	}

	// add new stuff
	for (var yKey in y)
	{
		if (!(yKey in x))
		{
			diff = diff || {};
			diff[yKey] = y[yKey];
		}
	}

	return diff;
}



// DIFF KIDS


function _VirtualDom_diffKids(xParent, yParent, patches, index)
{
	var xKids = xParent.e;
	var yKids = yParent.e;

	var xLen = xKids.length;
	var yLen = yKids.length;

	// FIGURE OUT IF THERE ARE INSERTS OR REMOVALS

	if (xLen > yLen)
	{
		_VirtualDom_pushPatch(patches, 6, index, {
			v: yLen,
			i: xLen - yLen
		});
	}
	else if (xLen < yLen)
	{
		_VirtualDom_pushPatch(patches, 7, index, {
			v: xLen,
			e: yKids
		});
	}

	// PAIRWISE DIFF EVERYTHING ELSE

	for (var minLen = xLen < yLen ? xLen : yLen, i = 0; i < minLen; i++)
	{
		var xKid = xKids[i];
		_VirtualDom_diffHelp(xKid, yKids[i], patches, ++index);
		index += xKid.b || 0;
	}
}



// KEYED DIFF


function _VirtualDom_diffKeyedKids(xParent, yParent, patches, rootIndex)
{
	var localPatches = [];

	var changes = {}; // Dict String Entry
	var inserts = []; // Array { index : Int, entry : Entry }
	// type Entry = { tag : String, vnode : VNode, index : Int, data : _ }

	var xKids = xParent.e;
	var yKids = yParent.e;
	var xLen = xKids.length;
	var yLen = yKids.length;
	var xIndex = 0;
	var yIndex = 0;

	var index = rootIndex;

	while (xIndex < xLen && yIndex < yLen)
	{
		var x = xKids[xIndex];
		var y = yKids[yIndex];

		var xKey = x.a;
		var yKey = y.a;
		var xNode = x.b;
		var yNode = y.b;

		var newMatch = undefined;
		var oldMatch = undefined;

		// check if keys match

		if (xKey === yKey)
		{
			index++;
			_VirtualDom_diffHelp(xNode, yNode, localPatches, index);
			index += xNode.b || 0;

			xIndex++;
			yIndex++;
			continue;
		}

		// look ahead 1 to detect insertions and removals.

		var xNext = xKids[xIndex + 1];
		var yNext = yKids[yIndex + 1];

		if (xNext)
		{
			var xNextKey = xNext.a;
			var xNextNode = xNext.b;
			oldMatch = yKey === xNextKey;
		}

		if (yNext)
		{
			var yNextKey = yNext.a;
			var yNextNode = yNext.b;
			newMatch = xKey === yNextKey;
		}


		// swap x and y
		if (newMatch && oldMatch)
		{
			index++;
			_VirtualDom_diffHelp(xNode, yNextNode, localPatches, index);
			_VirtualDom_insertNode(changes, localPatches, xKey, yNode, yIndex, inserts);
			index += xNode.b || 0;

			index++;
			_VirtualDom_removeNode(changes, localPatches, xKey, xNextNode, index);
			index += xNextNode.b || 0;

			xIndex += 2;
			yIndex += 2;
			continue;
		}

		// insert y
		if (newMatch)
		{
			index++;
			_VirtualDom_insertNode(changes, localPatches, yKey, yNode, yIndex, inserts);
			_VirtualDom_diffHelp(xNode, yNextNode, localPatches, index);
			index += xNode.b || 0;

			xIndex += 1;
			yIndex += 2;
			continue;
		}

		// remove x
		if (oldMatch)
		{
			index++;
			_VirtualDom_removeNode(changes, localPatches, xKey, xNode, index);
			index += xNode.b || 0;

			index++;
			_VirtualDom_diffHelp(xNextNode, yNode, localPatches, index);
			index += xNextNode.b || 0;

			xIndex += 2;
			yIndex += 1;
			continue;
		}

		// remove x, insert y
		if (xNext && xNextKey === yNextKey)
		{
			index++;
			_VirtualDom_removeNode(changes, localPatches, xKey, xNode, index);
			_VirtualDom_insertNode(changes, localPatches, yKey, yNode, yIndex, inserts);
			index += xNode.b || 0;

			index++;
			_VirtualDom_diffHelp(xNextNode, yNextNode, localPatches, index);
			index += xNextNode.b || 0;

			xIndex += 2;
			yIndex += 2;
			continue;
		}

		break;
	}

	// eat up any remaining nodes with removeNode and insertNode

	while (xIndex < xLen)
	{
		index++;
		var x = xKids[xIndex];
		var xNode = x.b;
		_VirtualDom_removeNode(changes, localPatches, x.a, xNode, index);
		index += xNode.b || 0;
		xIndex++;
	}

	while (yIndex < yLen)
	{
		var endInserts = endInserts || [];
		var y = yKids[yIndex];
		_VirtualDom_insertNode(changes, localPatches, y.a, y.b, undefined, endInserts);
		yIndex++;
	}

	if (localPatches.length > 0 || inserts.length > 0 || endInserts)
	{
		_VirtualDom_pushPatch(patches, 8, rootIndex, {
			w: localPatches,
			x: inserts,
			y: endInserts
		});
	}
}



// CHANGES FROM KEYED DIFF


var _VirtualDom_POSTFIX = '_elmW6BL';


function _VirtualDom_insertNode(changes, localPatches, key, vnode, yIndex, inserts)
{
	var entry = changes[key];

	// never seen this key before
	if (!entry)
	{
		entry = {
			c: 0,
			z: vnode,
			r: yIndex,
			s: undefined
		};

		inserts.push({ r: yIndex, A: entry });
		changes[key] = entry;

		return;
	}

	// this key was removed earlier, a match!
	if (entry.c === 1)
	{
		inserts.push({ r: yIndex, A: entry });

		entry.c = 2;
		var subPatches = [];
		_VirtualDom_diffHelp(entry.z, vnode, subPatches, entry.r);
		entry.r = yIndex;
		entry.s.s = {
			w: subPatches,
			A: entry
		};

		return;
	}

	// this key has already been inserted or moved, a duplicate!
	_VirtualDom_insertNode(changes, localPatches, key + _VirtualDom_POSTFIX, vnode, yIndex, inserts);
}


function _VirtualDom_removeNode(changes, localPatches, key, vnode, index)
{
	var entry = changes[key];

	// never seen this key before
	if (!entry)
	{
		var patch = _VirtualDom_pushPatch(localPatches, 9, index, undefined);

		changes[key] = {
			c: 1,
			z: vnode,
			r: index,
			s: patch
		};

		return;
	}

	// this key was inserted earlier, a match!
	if (entry.c === 0)
	{
		entry.c = 2;
		var subPatches = [];
		_VirtualDom_diffHelp(vnode, entry.z, subPatches, index);

		_VirtualDom_pushPatch(localPatches, 9, index, {
			w: subPatches,
			A: entry
		});

		return;
	}

	// this key has already been removed or moved, a duplicate!
	_VirtualDom_removeNode(changes, localPatches, key + _VirtualDom_POSTFIX, vnode, index);
}



// ADD DOM NODES
//
// Each DOM node has an "index" assigned in order of traversal. It is important
// to minimize our crawl over the actual DOM, so these indexes (along with the
// descendantsCount of virtual nodes) let us skip touching entire subtrees of
// the DOM if we know there are no patches there.


function _VirtualDom_addDomNodes(domNode, vNode, patches, eventNode)
{
	_VirtualDom_addDomNodesHelp(domNode, vNode, patches, 0, 0, vNode.b, eventNode);
}


// assumes `patches` is non-empty and indexes increase monotonically.
function _VirtualDom_addDomNodesHelp(domNode, vNode, patches, i, low, high, eventNode)
{
	var patch = patches[i];
	var index = patch.r;

	while (index === low)
	{
		var patchType = patch.$;

		if (patchType === 1)
		{
			_VirtualDom_addDomNodes(domNode, vNode.k, patch.s, eventNode);
		}
		else if (patchType === 8)
		{
			patch.t = domNode;
			patch.u = eventNode;

			var subPatches = patch.s.w;
			if (subPatches.length > 0)
			{
				_VirtualDom_addDomNodesHelp(domNode, vNode, subPatches, 0, low, high, eventNode);
			}
		}
		else if (patchType === 9)
		{
			patch.t = domNode;
			patch.u = eventNode;

			var data = patch.s;
			if (data)
			{
				data.A.s = domNode;
				var subPatches = data.w;
				if (subPatches.length > 0)
				{
					_VirtualDom_addDomNodesHelp(domNode, vNode, subPatches, 0, low, high, eventNode);
				}
			}
		}
		else
		{
			patch.t = domNode;
			patch.u = eventNode;
		}

		i++;

		if (!(patch = patches[i]) || (index = patch.r) > high)
		{
			return i;
		}
	}

	var tag = vNode.$;

	if (tag === 4)
	{
		var subNode = vNode.k;

		while (subNode.$ === 4)
		{
			subNode = subNode.k;
		}

		return _VirtualDom_addDomNodesHelp(domNode, subNode, patches, i, low + 1, high, domNode.elm_event_node_ref);
	}

	// tag must be 1 or 2 at this point

	var vKids = vNode.e;
	var childNodes = domNode.childNodes;
	for (var j = 0; j < vKids.length; j++)
	{
		low++;
		var vKid = tag === 1 ? vKids[j] : vKids[j].b;
		var nextLow = low + (vKid.b || 0);
		if (low <= index && index <= nextLow)
		{
			i = _VirtualDom_addDomNodesHelp(childNodes[j], vKid, patches, i, low, nextLow, eventNode);
			if (!(patch = patches[i]) || (index = patch.r) > high)
			{
				return i;
			}
		}
		low = nextLow;
	}
	return i;
}



// APPLY PATCHES


function _VirtualDom_applyPatches(rootDomNode, oldVirtualNode, patches, eventNode)
{
	if (patches.length === 0)
	{
		return rootDomNode;
	}

	_VirtualDom_addDomNodes(rootDomNode, oldVirtualNode, patches, eventNode);
	return _VirtualDom_applyPatchesHelp(rootDomNode, patches);
}

function _VirtualDom_applyPatchesHelp(rootDomNode, patches)
{
	for (var i = 0; i < patches.length; i++)
	{
		var patch = patches[i];
		var localDomNode = patch.t
		var newNode = _VirtualDom_applyPatch(localDomNode, patch);
		if (localDomNode === rootDomNode)
		{
			rootDomNode = newNode;
		}
	}
	return rootDomNode;
}

function _VirtualDom_applyPatch(domNode, patch)
{
	switch (patch.$)
	{
		case 0:
			return _VirtualDom_applyPatchRedraw(domNode, patch.s, patch.u);

		case 4:
			_VirtualDom_applyFacts(domNode, patch.u, patch.s);
			return domNode;

		case 3:
			domNode.replaceData(0, domNode.length, patch.s);
			return domNode;

		case 1:
			return _VirtualDom_applyPatchesHelp(domNode, patch.s);

		case 2:
			if (domNode.elm_event_node_ref)
			{
				domNode.elm_event_node_ref.j = patch.s;
			}
			else
			{
				domNode.elm_event_node_ref = { j: patch.s, p: patch.u };
			}
			return domNode;

		case 6:
			var data = patch.s;
			for (var i = 0; i < data.i; i++)
			{
				domNode.removeChild(domNode.childNodes[data.v]);
			}
			return domNode;

		case 7:
			var data = patch.s;
			var kids = data.e;
			var i = data.v;
			var theEnd = domNode.childNodes[i];
			for (; i < kids.length; i++)
			{
				domNode.insertBefore(_VirtualDom_render(kids[i], patch.u), theEnd);
			}
			return domNode;

		case 9:
			var data = patch.s;
			if (!data)
			{
				domNode.parentNode.removeChild(domNode);
				return domNode;
			}
			var entry = data.A;
			if (typeof entry.r !== 'undefined')
			{
				domNode.parentNode.removeChild(domNode);
			}
			entry.s = _VirtualDom_applyPatchesHelp(domNode, data.w);
			return domNode;

		case 8:
			return _VirtualDom_applyPatchReorder(domNode, patch);

		case 5:
			return patch.s(domNode);

		default:
			_Debug_crash(10); // 'Ran into an unknown patch!'
	}
}


function _VirtualDom_applyPatchRedraw(domNode, vNode, eventNode)
{
	var parentNode = domNode.parentNode;
	var newNode = _VirtualDom_render(vNode, eventNode);

	if (!newNode.elm_event_node_ref)
	{
		newNode.elm_event_node_ref = domNode.elm_event_node_ref;
	}

	if (parentNode && newNode !== domNode)
	{
		parentNode.replaceChild(newNode, domNode);
	}
	return newNode;
}


function _VirtualDom_applyPatchReorder(domNode, patch)
{
	var data = patch.s;

	// remove end inserts
	var frag = _VirtualDom_applyPatchReorderEndInsertsHelp(data.y, patch);

	// removals
	domNode = _VirtualDom_applyPatchesHelp(domNode, data.w);

	// inserts
	var inserts = data.x;
	for (var i = 0; i < inserts.length; i++)
	{
		var insert = inserts[i];
		var entry = insert.A;
		var node = entry.c === 2
			? entry.s
			: _VirtualDom_render(entry.z, patch.u);
		domNode.insertBefore(node, domNode.childNodes[insert.r]);
	}

	// add end inserts
	if (frag)
	{
		_VirtualDom_appendChild(domNode, frag);
	}

	return domNode;
}


function _VirtualDom_applyPatchReorderEndInsertsHelp(endInserts, patch)
{
	if (!endInserts)
	{
		return;
	}

	var frag = _VirtualDom_doc.createDocumentFragment();
	for (var i = 0; i < endInserts.length; i++)
	{
		var insert = endInserts[i];
		var entry = insert.A;
		_VirtualDom_appendChild(frag, entry.c === 2
			? entry.s
			: _VirtualDom_render(entry.z, patch.u)
		);
	}
	return frag;
}


function _VirtualDom_virtualize(node)
{
	// TEXT NODES

	if (node.nodeType === 3)
	{
		return _VirtualDom_text(node.textContent);
	}


	// WEIRD NODES

	if (node.nodeType !== 1)
	{
		return _VirtualDom_text('');
	}


	// ELEMENT NODES

	var attrList = _List_Nil;
	var attrs = node.attributes;
	for (var i = attrs.length; i--; )
	{
		var attr = attrs[i];
		var name = attr.name;
		var value = attr.value;
		attrList = _List_Cons( A2(_VirtualDom_attribute, name, value), attrList );
	}

	var tag = node.tagName.toLowerCase();
	var kidList = _List_Nil;
	var kids = node.childNodes;

	for (var i = kids.length; i--; )
	{
		kidList = _List_Cons(_VirtualDom_virtualize(kids[i]), kidList);
	}
	return A3(_VirtualDom_node, tag, attrList, kidList);
}

function _VirtualDom_dekey(keyedNode)
{
	var keyedKids = keyedNode.e;
	var len = keyedKids.length;
	var kids = new Array(len);
	for (var i = 0; i < len; i++)
	{
		kids[i] = keyedKids[i].b;
	}

	return {
		$: 1,
		c: keyedNode.c,
		d: keyedNode.d,
		e: kids,
		f: keyedNode.f,
		b: keyedNode.b
	};
}




// ELEMENT


var _Debugger_element;

var _Browser_element = _Debugger_element || F4(function(impl, flagDecoder, debugMetadata, args)
{
        if (args && args['nodes']) {

                //
                // when caller passes 'nodes' assume using multi-views
                //

                return _Platform_initialize(
                        flagDecoder,
                        args,
                        impl.init,
                        impl.update,
                        impl.subscriptions,
        
                        function(sendToApp, initialModel) {
                                var view = impl.view;
        
                                var domNodes = args && args['nodes'] ? args['nodes'] : _Debug_crash(0);
                                var curNodes = domNodes.map(n => _VirtualDom_virtualize(n));
                                var len      = curNodes.length;
        
                                return _Browser_makeAnimator(initialModel, function(model)
                                {
                                  for (var i = 0; i < len; i++) { //console.log('@@@', i);
                                    var domNode  = domNodes[i];
                                    var currNode = curNodes[i];

                                    //
                                    // we don't know what module is running so
                                    // set 'currentView' in all of them
                                    //

                                    $author$project$TopicList$currentView = i;
                                    $author$project$Topic$currentView = i;
                                    $author$project$Test$currentView = i;
                                    $author$project$SignIn$currentView = i;
                                    $author$project$Profile$currentView = i;
                                    $author$project$MemberList$currentView = i;
                                    $author$project$Member$currentView = i;
                                    $author$project$Join$currentView = i;
                                    $author$project$Create$currentView = i;
                                    $author$project$BundleList$currentView = i;
                                    $author$project$Bundle$currentView = i;
        
                                    var nextNode = view(model);
                                    var patches = _VirtualDom_diff(currNode, nextNode);
        
                                    domNodes[i] = _VirtualDom_applyPatches(domNode, currNode, patches, sendToApp);
                                    curNodes[i] = nextNode;
                                  }
                                });
                        }
                );
        }
	return _Platform_initialize(
		flagDecoder,
		args,
		impl.init,
		impl.update,
		impl.subscriptions,
		function(sendToApp, initialModel) {
			var view = impl.view;
			/**_UNUSED/
			var domNode = args['node'];
			//*/
			/**/
			var domNode = args && args['node'] ? args['node'] : _Debug_crash(0);
			//*/
			var currNode = _VirtualDom_virtualize(domNode);

			return _Browser_makeAnimator(initialModel, function(model)
			{
				var nextNode = view(model);
				var patches = _VirtualDom_diff(currNode, nextNode);
				domNode = _VirtualDom_applyPatches(domNode, currNode, patches, sendToApp);
				currNode = nextNode;
			});
		}
	);
});



// DOCUMENT


var _Debugger_document;

var _Browser_document = _Debugger_document || F4(function(impl, flagDecoder, debugMetadata, args)
{
	return _Platform_initialize(
		flagDecoder,
		args,
		impl.init,
		impl.update,
		impl.subscriptions,
		function(sendToApp, initialModel) {
			var divertHrefToApp = impl.setup && impl.setup(sendToApp)
			var view = impl.view;
			var title = _VirtualDom_doc.title;
			var bodyNode = _VirtualDom_doc.body;
			var currNode = _VirtualDom_virtualize(bodyNode);
			return _Browser_makeAnimator(initialModel, function(model)
			{
				_VirtualDom_divertHrefToApp = divertHrefToApp;
				var doc = view(model);
				var nextNode = _VirtualDom_node('body')(_List_Nil)(doc.body);
				var patches = _VirtualDom_diff(currNode, nextNode);
				bodyNode = _VirtualDom_applyPatches(bodyNode, currNode, patches, sendToApp);
				currNode = nextNode;
				_VirtualDom_divertHrefToApp = 0;
				(title !== doc.title) && (_VirtualDom_doc.title = title = doc.title);
			});
		}
	);
});



// ANIMATION


var _Browser_cancelAnimationFrame =
	typeof cancelAnimationFrame !== 'undefined'
		? cancelAnimationFrame
		: function(id) { clearTimeout(id); };

var _Browser_requestAnimationFrame =
	typeof requestAnimationFrame !== 'undefined'
		? requestAnimationFrame
		: function(callback) { return setTimeout(callback, 1000 / 60); };


function _Browser_makeAnimator(model, draw)
{
	draw(model);

	var state = 0;

	function updateIfNeeded()
	{
		state = state === 1
			? 0
			: ( _Browser_requestAnimationFrame(updateIfNeeded), draw(model), 1 );
	}

	return function(nextModel, isSync)
	{
		model = nextModel;

		isSync
			? ( draw(model),
				state === 2 && (state = 1)
				)
			: ( state === 0 && _Browser_requestAnimationFrame(updateIfNeeded),
				state = 2
				);
	};
}



// APPLICATION


function _Browser_application(impl)
{
	var onUrlChange = impl.onUrlChange;
	var onUrlRequest = impl.onUrlRequest;
	var key = function() { key.a(onUrlChange(_Browser_getUrl())); };

	return _Browser_document({
		setup: function(sendToApp)
		{
			key.a = sendToApp;
			_Browser_window.addEventListener('popstate', key);
			_Browser_window.navigator.userAgent.indexOf('Trident') < 0 || _Browser_window.addEventListener('hashchange', key);

			return F2(function(domNode, event)
			{
				if (!event.ctrlKey && !event.metaKey && !event.shiftKey && event.button < 1 && !domNode.target && !domNode.hasAttribute('download'))
				{
					event.preventDefault();
					var href = domNode.href;
					var curr = _Browser_getUrl();
					var next = $elm$url$Url$fromString(href).a;
					sendToApp(onUrlRequest(
						(next
							&& curr.protocol === next.protocol
							&& curr.host === next.host
							&& curr.port_.a === next.port_.a
						)
							? $elm$browser$Browser$Internal(next)
							: $elm$browser$Browser$External(href)
					));
				}
			});
		},
		init: function(flags)
		{
			return A3(impl.init, flags, _Browser_getUrl(), key);
		},
		view: impl.view,
		update: impl.update,
		subscriptions: impl.subscriptions
	});
}

function _Browser_getUrl()
{
	return $elm$url$Url$fromString(_VirtualDom_doc.location.href).a || _Debug_crash(1);
}

var _Browser_go = F2(function(key, n)
{
	return A2($elm$core$Task$perform, $elm$core$Basics$never, _Scheduler_binding(function() {
		n && history.go(n);
		key();
	}));
});

var _Browser_pushUrl = F2(function(key, url)
{
	return A2($elm$core$Task$perform, $elm$core$Basics$never, _Scheduler_binding(function() {
		history.pushState({}, '', url);
		key();
	}));
});

var _Browser_replaceUrl = F2(function(key, url)
{
	return A2($elm$core$Task$perform, $elm$core$Basics$never, _Scheduler_binding(function() {
		history.replaceState({}, '', url);
		key();
	}));
});



// GLOBAL EVENTS


var _Browser_fakeNode = { addEventListener: function() {}, removeEventListener: function() {} };
var _Browser_doc = typeof document !== 'undefined' ? document : _Browser_fakeNode;
var _Browser_window = typeof window !== 'undefined' ? window : _Browser_fakeNode;

var _Browser_on = F3(function(node, eventName, sendToSelf)
{
	return _Scheduler_spawn(_Scheduler_binding(function(callback)
	{
		function handler(event)	{ _Scheduler_rawSpawn(sendToSelf(event)); }
		node.addEventListener(eventName, handler, _VirtualDom_passiveSupported && { passive: true });
		return function() { node.removeEventListener(eventName, handler); };
	}));
});

var _Browser_decodeEvent = F2(function(decoder, event)
{
	var result = _Json_runHelp(decoder, event);
	return $elm$core$Result$isOk(result) ? $elm$core$Maybe$Just(result.a) : $elm$core$Maybe$Nothing;
});



// PAGE VISIBILITY


function _Browser_visibilityInfo()
{
	return (typeof _VirtualDom_doc.hidden !== 'undefined')
		? { hidden: 'hidden', change: 'visibilitychange' }
		:
	(typeof _VirtualDom_doc.mozHidden !== 'undefined')
		? { hidden: 'mozHidden', change: 'mozvisibilitychange' }
		:
	(typeof _VirtualDom_doc.msHidden !== 'undefined')
		? { hidden: 'msHidden', change: 'msvisibilitychange' }
		:
	(typeof _VirtualDom_doc.webkitHidden !== 'undefined')
		? { hidden: 'webkitHidden', change: 'webkitvisibilitychange' }
		: { hidden: 'hidden', change: 'visibilitychange' };
}



// ANIMATION FRAMES


function _Browser_rAF()
{
	return _Scheduler_binding(function(callback)
	{
		var id = _Browser_requestAnimationFrame(function() {
			callback(_Scheduler_succeed(Date.now()));
		});

		return function() {
			_Browser_cancelAnimationFrame(id);
		};
	});
}


function _Browser_now()
{
	return _Scheduler_binding(function(callback)
	{
		callback(_Scheduler_succeed(Date.now()));
	});
}



// DOM STUFF


function _Browser_withNode(id, doStuff)
{
	return _Scheduler_binding(function(callback)
	{
		_Browser_requestAnimationFrame(function() {
			var node = document.getElementById(id);
			callback(node
				? _Scheduler_succeed(doStuff(node))
				: _Scheduler_fail($elm$browser$Browser$Dom$NotFound(id))
			);
		});
	});
}


function _Browser_withWindow(doStuff)
{
	return _Scheduler_binding(function(callback)
	{
		_Browser_requestAnimationFrame(function() {
			callback(_Scheduler_succeed(doStuff()));
		});
	});
}


// FOCUS and BLUR


var _Browser_call = F2(function(functionName, id)
{
	return _Browser_withNode(id, function(node) {
		node[functionName]();
		return _Utils_Tuple0;
	});
});



// WINDOW VIEWPORT


function _Browser_getViewport()
{
	return {
		scene: _Browser_getScene(),
		viewport: {
			x: _Browser_window.pageXOffset,
			y: _Browser_window.pageYOffset,
			width: _Browser_doc.documentElement.clientWidth,
			height: _Browser_doc.documentElement.clientHeight
		}
	};
}

function _Browser_getScene()
{
	var body = _Browser_doc.body;
	var elem = _Browser_doc.documentElement;
	return {
		width: Math.max(body.scrollWidth, body.offsetWidth, elem.scrollWidth, elem.offsetWidth, elem.clientWidth),
		height: Math.max(body.scrollHeight, body.offsetHeight, elem.scrollHeight, elem.offsetHeight, elem.clientHeight)
	};
}

var _Browser_setViewport = F2(function(x, y)
{
	return _Browser_withWindow(function()
	{
		_Browser_window.scroll(x, y);
		return _Utils_Tuple0;
	});
});



// ELEMENT VIEWPORT


function _Browser_getViewportOf(id)
{
	return _Browser_withNode(id, function(node)
	{
		return {
			scene: {
				width: node.scrollWidth,
				height: node.scrollHeight
			},
			viewport: {
				x: node.scrollLeft,
				y: node.scrollTop,
				width: node.clientWidth,
				height: node.clientHeight
			}
		};
	});
}


var _Browser_setViewportOf = F3(function(id, x, y)
{
	return _Browser_withNode(id, function(node)
	{
		node.scrollLeft = x;
		node.scrollTop = y;
		return _Utils_Tuple0;
	});
});



// ELEMENT


function _Browser_getElement(id)
{
	return _Browser_withNode(id, function(node)
	{
		var rect = node.getBoundingClientRect();
		var x = _Browser_window.pageXOffset;
		var y = _Browser_window.pageYOffset;
		return {
			scene: _Browser_getScene(),
			viewport: {
				x: x,
				y: y,
				width: _Browser_doc.documentElement.clientWidth,
				height: _Browser_doc.documentElement.clientHeight
			},
			element: {
				x: x + rect.left,
				y: y + rect.top,
				width: rect.width,
				height: rect.height
			}
		};
	});
}



// LOAD and RELOAD


function _Browser_reload(skipCache)
{
	return A2($elm$core$Task$perform, $elm$core$Basics$never, _Scheduler_binding(function(callback)
	{
		_VirtualDom_doc.location.reload(skipCache);
	}));
}

function _Browser_load(url)
{
	return A2($elm$core$Task$perform, $elm$core$Basics$never, _Scheduler_binding(function(callback)
	{
		try
		{
			_Browser_window.location = url;
		}
		catch(err)
		{
			// Only Firefox can throw a NS_ERROR_MALFORMED_URI exception here.
			// Other browsers reload the page, so let's be consistent about that.
			_VirtualDom_doc.location.reload(false);
		}
	}));
}


// CREATE

var _Regex_never = /.^/;

var _Regex_fromStringWith = F2(function(options, string)
{
	var flags = 'g';
	if (options.multiline) { flags += 'm'; }
	if (options.caseInsensitive) { flags += 'i'; }

	try
	{
		return $elm$core$Maybe$Just(new RegExp(string, flags));
	}
	catch(error)
	{
		return $elm$core$Maybe$Nothing;
	}
});


// USE

var _Regex_contains = F2(function(re, string)
{
	return string.match(re) !== null;
});


var _Regex_findAtMost = F3(function(n, re, str)
{
	var out = [];
	var number = 0;
	var string = str;
	var lastIndex = re.lastIndex;
	var prevLastIndex = -1;
	var result;
	while (number++ < n && (result = re.exec(string)))
	{
		if (prevLastIndex == re.lastIndex) break;
		var i = result.length - 1;
		var subs = new Array(i);
		while (i > 0)
		{
			var submatch = result[i];
			subs[--i] = submatch
				? $elm$core$Maybe$Just(submatch)
				: $elm$core$Maybe$Nothing;
		}
		out.push(A4($elm$regex$Regex$Match, result[0], result.index, number, _List_fromArray(subs)));
		prevLastIndex = re.lastIndex;
	}
	re.lastIndex = lastIndex;
	return _List_fromArray(out);
});


var _Regex_replaceAtMost = F4(function(n, re, replacer, string)
{
	var count = 0;
	function jsReplacer(match)
	{
		if (count++ >= n)
		{
			return match;
		}
		var i = arguments.length - 3;
		var submatches = new Array(i);
		while (i > 0)
		{
			var submatch = arguments[i];
			submatches[--i] = submatch
				? $elm$core$Maybe$Just(submatch)
				: $elm$core$Maybe$Nothing;
		}
		return replacer(A4($elm$regex$Regex$Match, match, arguments[arguments.length - 2], count, _List_fromArray(submatches)));
	}
	return string.replace(re, jsReplacer);
});

var _Regex_splitAtMost = F3(function(n, re, str)
{
	var string = str;
	var out = [];
	var start = re.lastIndex;
	var restoreLastIndex = re.lastIndex;
	while (n--)
	{
		var result = re.exec(string);
		if (!result) break;
		out.push(string.slice(start, result.index));
		start = re.lastIndex;
	}
	out.push(string.slice(start));
	re.lastIndex = restoreLastIndex;
	return _List_fromArray(out);
});

var _Regex_infinity = Infinity;



var _Bitwise_and = F2(function(a, b)
{
	return a & b;
});

var _Bitwise_or = F2(function(a, b)
{
	return a | b;
});

var _Bitwise_xor = F2(function(a, b)
{
	return a ^ b;
});

function _Bitwise_complement(a)
{
	return ~a;
};

var _Bitwise_shiftLeftBy = F2(function(offset, a)
{
	return a << offset;
});

var _Bitwise_shiftRightBy = F2(function(offset, a)
{
	return a >> offset;
});

var _Bitwise_shiftRightZfBy = F2(function(offset, a)
{
	return a >>> offset;
});



function _Time_now(millisToPosix)
{
	return _Scheduler_binding(function(callback)
	{
		callback(_Scheduler_succeed(millisToPosix(Date.now())));
	});
}

var _Time_setInterval = F2(function(interval, task)
{
	return _Scheduler_binding(function(callback)
	{
		var id = setInterval(function() { _Scheduler_rawSpawn(task); }, interval);
		return function() { clearInterval(id); };
	});
});

function _Time_here()
{
	return _Scheduler_binding(function(callback)
	{
		callback(_Scheduler_succeed(
			A2($elm$time$Time$customZone, -(new Date().getTimezoneOffset()), _List_Nil)
		));
	});
}


function _Time_getZoneName()
{
	return _Scheduler_binding(function(callback)
	{
		try
		{
			var name = $elm$time$Time$Name(Intl.DateTimeFormat().resolvedOptions().timeZone);
		}
		catch (e)
		{
			var name = $elm$time$Time$Offset(new Date().getTimezoneOffset());
		}
		callback(_Scheduler_succeed(name));
	});
}



// DECODER

var _File_decoder = _Json_decodePrim(function(value) {
	// NOTE: checks if `File` exists in case this is run on node
	return (typeof File !== 'undefined' && value instanceof File)
		? $elm$core$Result$Ok(value)
		: _Json_expecting('a FILE', value);
});


// METADATA

function _File_name(file) { return file.name; }
function _File_mime(file) { return file.type; }
function _File_size(file) { return file.size; }

function _File_lastModified(file)
{
	return $elm$time$Time$millisToPosix(file.lastModified);
}


// DOWNLOAD

var _File_downloadNode;

function _File_getDownloadNode()
{
	return _File_downloadNode || (_File_downloadNode = document.createElement('a'));
}

var _File_download = F3(function(name, mime, content)
{
	return _Scheduler_binding(function(callback)
	{
		var blob = new Blob([content], {type: mime});

		// for IE10+
		if (navigator.msSaveOrOpenBlob)
		{
			navigator.msSaveOrOpenBlob(blob, name);
			return;
		}

		// for HTML5
		var node = _File_getDownloadNode();
		var objectUrl = URL.createObjectURL(blob);
		node.href = objectUrl;
		node.download = name;
		_File_click(node);
		URL.revokeObjectURL(objectUrl);
	});
});

function _File_downloadUrl(href)
{
	return _Scheduler_binding(function(callback)
	{
		var node = _File_getDownloadNode();
		node.href = href;
		node.download = '';
		node.origin === location.origin || (node.target = '_blank');
		_File_click(node);
	});
}


// IE COMPATIBILITY

function _File_makeBytesSafeForInternetExplorer(bytes)
{
	// only needed by IE10 and IE11 to fix https://github.com/elm/file/issues/10
	// all other browsers can just run `new Blob([bytes])` directly with no problem
	//
	return new Uint8Array(bytes.buffer, bytes.byteOffset, bytes.byteLength);
}

function _File_click(node)
{
	// only needed by IE10 and IE11 to fix https://github.com/elm/file/issues/11
	// all other browsers have MouseEvent and do not need this conditional stuff
	//
	if (typeof MouseEvent === 'function')
	{
		node.dispatchEvent(new MouseEvent('click'));
	}
	else
	{
		var event = document.createEvent('MouseEvents');
		event.initMouseEvent('click', true, true, window, 0, 0, 0, 0, 0, false, false, false, false, 0, null);
		document.body.appendChild(node);
		node.dispatchEvent(event);
		document.body.removeChild(node);
	}
}


// UPLOAD

var _File_node;

function _File_uploadOne(mimes)
{
	return _Scheduler_binding(function(callback)
	{
		_File_node = document.createElement('input');
		_File_node.type = 'file';
		_File_node.accept = A2($elm$core$String$join, ',', mimes);
		_File_node.addEventListener('change', function(event)
		{
			callback(_Scheduler_succeed(event.target.files[0]));
		});
		_File_click(_File_node);
	});
}

function _File_uploadOneOrMore(mimes)
{
	return _Scheduler_binding(function(callback)
	{
		_File_node = document.createElement('input');
		_File_node.type = 'file';
		_File_node.multiple = true;
		_File_node.accept = A2($elm$core$String$join, ',', mimes);
		_File_node.addEventListener('change', function(event)
		{
			var elmFiles = _List_fromArray(event.target.files);
			callback(_Scheduler_succeed(_Utils_Tuple2(elmFiles.a, elmFiles.b)));
		});
		_File_click(_File_node);
	});
}


// CONTENT

function _File_toString(blob)
{
	return _Scheduler_binding(function(callback)
	{
		var reader = new FileReader();
		reader.addEventListener('loadend', function() {
			callback(_Scheduler_succeed(reader.result));
		});
		reader.readAsText(blob);
		return function() { reader.abort(); };
	});
}

function _File_toBytes(blob)
{
	return _Scheduler_binding(function(callback)
	{
		var reader = new FileReader();
		reader.addEventListener('loadend', function() {
			callback(_Scheduler_succeed(new DataView(reader.result)));
		});
		reader.readAsArrayBuffer(blob);
		return function() { reader.abort(); };
	});
}

function _File_toUrl(blob)
{
	return _Scheduler_binding(function(callback)
	{
		var reader = new FileReader();
		reader.addEventListener('loadend', function() {
			callback(_Scheduler_succeed(reader.result));
		});
		reader.readAsDataURL(blob);
		return function() { reader.abort(); };
	});
}

var $elm$core$Basics$EQ = {$: 'EQ'};
var $elm$core$Basics$GT = {$: 'GT'};
var $elm$core$Basics$LT = {$: 'LT'};
var $elm$core$List$cons = _List_cons;
var $elm$core$Dict$foldr = F3(
	function (func, acc, t) {
		foldr:
		while (true) {
			if (t.$ === 'RBEmpty_elm_builtin') {
				return acc;
			} else {
				var key = t.b;
				var value = t.c;
				var left = t.d;
				var right = t.e;
				var $temp$func = func,
					$temp$acc = A3(
					func,
					key,
					value,
					A3($elm$core$Dict$foldr, func, acc, right)),
					$temp$t = left;
				func = $temp$func;
				acc = $temp$acc;
				t = $temp$t;
				continue foldr;
			}
		}
	});
var $elm$core$Dict$toList = function (dict) {
	return A3(
		$elm$core$Dict$foldr,
		F3(
			function (key, value, list) {
				return A2(
					$elm$core$List$cons,
					_Utils_Tuple2(key, value),
					list);
			}),
		_List_Nil,
		dict);
};
var $elm$core$Dict$keys = function (dict) {
	return A3(
		$elm$core$Dict$foldr,
		F3(
			function (key, value, keyList) {
				return A2($elm$core$List$cons, key, keyList);
			}),
		_List_Nil,
		dict);
};
var $elm$core$Set$toList = function (_v0) {
	var dict = _v0.a;
	return $elm$core$Dict$keys(dict);
};
var $elm$core$Elm$JsArray$foldr = _JsArray_foldr;
var $elm$core$Array$foldr = F3(
	function (func, baseCase, _v0) {
		var tree = _v0.c;
		var tail = _v0.d;
		var helper = F2(
			function (node, acc) {
				if (node.$ === 'SubTree') {
					var subTree = node.a;
					return A3($elm$core$Elm$JsArray$foldr, helper, acc, subTree);
				} else {
					var values = node.a;
					return A3($elm$core$Elm$JsArray$foldr, func, acc, values);
				}
			});
		return A3(
			$elm$core$Elm$JsArray$foldr,
			helper,
			A3($elm$core$Elm$JsArray$foldr, func, baseCase, tail),
			tree);
	});
var $elm$core$Array$toList = function (array) {
	return A3($elm$core$Array$foldr, $elm$core$List$cons, _List_Nil, array);
};
var $elm$core$Result$Err = function (a) {
	return {$: 'Err', a: a};
};
var $elm$json$Json$Decode$Failure = F2(
	function (a, b) {
		return {$: 'Failure', a: a, b: b};
	});
var $elm$json$Json$Decode$Field = F2(
	function (a, b) {
		return {$: 'Field', a: a, b: b};
	});
var $elm$json$Json$Decode$Index = F2(
	function (a, b) {
		return {$: 'Index', a: a, b: b};
	});
var $elm$core$Result$Ok = function (a) {
	return {$: 'Ok', a: a};
};
var $elm$json$Json$Decode$OneOf = function (a) {
	return {$: 'OneOf', a: a};
};
var $elm$core$Basics$False = {$: 'False'};
var $elm$core$Basics$add = _Basics_add;
var $elm$core$Maybe$Just = function (a) {
	return {$: 'Just', a: a};
};
var $elm$core$Maybe$Nothing = {$: 'Nothing'};
var $elm$core$String$all = _String_all;
var $elm$core$Basics$and = _Basics_and;
var $elm$core$Basics$append = _Utils_append;
var $elm$json$Json$Encode$encode = _Json_encode;
var $elm$core$String$fromInt = _String_fromNumber;
var $elm$core$String$join = F2(
	function (sep, chunks) {
		return A2(
			_String_join,
			sep,
			_List_toArray(chunks));
	});
var $elm$core$String$split = F2(
	function (sep, string) {
		return _List_fromArray(
			A2(_String_split, sep, string));
	});
var $elm$json$Json$Decode$indent = function (str) {
	return A2(
		$elm$core$String$join,
		'\n    ',
		A2($elm$core$String$split, '\n', str));
};
var $elm$core$List$foldl = F3(
	function (func, acc, list) {
		foldl:
		while (true) {
			if (!list.b) {
				return acc;
			} else {
				var x = list.a;
				var xs = list.b;
				var $temp$func = func,
					$temp$acc = A2(func, x, acc),
					$temp$list = xs;
				func = $temp$func;
				acc = $temp$acc;
				list = $temp$list;
				continue foldl;
			}
		}
	});
var $elm$core$List$length = function (xs) {
	return A3(
		$elm$core$List$foldl,
		F2(
			function (_v0, i) {
				return i + 1;
			}),
		0,
		xs);
};
var $elm$core$List$map2 = _List_map2;
var $elm$core$Basics$le = _Utils_le;
var $elm$core$Basics$sub = _Basics_sub;
var $elm$core$List$rangeHelp = F3(
	function (lo, hi, list) {
		rangeHelp:
		while (true) {
			if (_Utils_cmp(lo, hi) < 1) {
				var $temp$lo = lo,
					$temp$hi = hi - 1,
					$temp$list = A2($elm$core$List$cons, hi, list);
				lo = $temp$lo;
				hi = $temp$hi;
				list = $temp$list;
				continue rangeHelp;
			} else {
				return list;
			}
		}
	});
var $elm$core$List$range = F2(
	function (lo, hi) {
		return A3($elm$core$List$rangeHelp, lo, hi, _List_Nil);
	});
var $elm$core$List$indexedMap = F2(
	function (f, xs) {
		return A3(
			$elm$core$List$map2,
			f,
			A2(
				$elm$core$List$range,
				0,
				$elm$core$List$length(xs) - 1),
			xs);
	});
var $elm$core$Char$toCode = _Char_toCode;
var $elm$core$Char$isLower = function (_char) {
	var code = $elm$core$Char$toCode(_char);
	return (97 <= code) && (code <= 122);
};
var $elm$core$Char$isUpper = function (_char) {
	var code = $elm$core$Char$toCode(_char);
	return (code <= 90) && (65 <= code);
};
var $elm$core$Basics$or = _Basics_or;
var $elm$core$Char$isAlpha = function (_char) {
	return $elm$core$Char$isLower(_char) || $elm$core$Char$isUpper(_char);
};
var $elm$core$Char$isDigit = function (_char) {
	var code = $elm$core$Char$toCode(_char);
	return (code <= 57) && (48 <= code);
};
var $elm$core$Char$isAlphaNum = function (_char) {
	return $elm$core$Char$isLower(_char) || ($elm$core$Char$isUpper(_char) || $elm$core$Char$isDigit(_char));
};
var $elm$core$List$reverse = function (list) {
	return A3($elm$core$List$foldl, $elm$core$List$cons, _List_Nil, list);
};
var $elm$core$String$uncons = _String_uncons;
var $elm$json$Json$Decode$errorOneOf = F2(
	function (i, error) {
		return '\n\n(' + ($elm$core$String$fromInt(i + 1) + (') ' + $elm$json$Json$Decode$indent(
			$elm$json$Json$Decode$errorToString(error))));
	});
var $elm$json$Json$Decode$errorToString = function (error) {
	return A2($elm$json$Json$Decode$errorToStringHelp, error, _List_Nil);
};
var $elm$json$Json$Decode$errorToStringHelp = F2(
	function (error, context) {
		errorToStringHelp:
		while (true) {
			switch (error.$) {
				case 'Field':
					var f = error.a;
					var err = error.b;
					var isSimple = function () {
						var _v1 = $elm$core$String$uncons(f);
						if (_v1.$ === 'Nothing') {
							return false;
						} else {
							var _v2 = _v1.a;
							var _char = _v2.a;
							var rest = _v2.b;
							return $elm$core$Char$isAlpha(_char) && A2($elm$core$String$all, $elm$core$Char$isAlphaNum, rest);
						}
					}();
					var fieldName = isSimple ? ('.' + f) : ('[\'' + (f + '\']'));
					var $temp$error = err,
						$temp$context = A2($elm$core$List$cons, fieldName, context);
					error = $temp$error;
					context = $temp$context;
					continue errorToStringHelp;
				case 'Index':
					var i = error.a;
					var err = error.b;
					var indexName = '[' + ($elm$core$String$fromInt(i) + ']');
					var $temp$error = err,
						$temp$context = A2($elm$core$List$cons, indexName, context);
					error = $temp$error;
					context = $temp$context;
					continue errorToStringHelp;
				case 'OneOf':
					var errors = error.a;
					if (!errors.b) {
						return 'Ran into a Json.Decode.oneOf with no possibilities' + function () {
							if (!context.b) {
								return '!';
							} else {
								return ' at json' + A2(
									$elm$core$String$join,
									'',
									$elm$core$List$reverse(context));
							}
						}();
					} else {
						if (!errors.b.b) {
							var err = errors.a;
							var $temp$error = err,
								$temp$context = context;
							error = $temp$error;
							context = $temp$context;
							continue errorToStringHelp;
						} else {
							var starter = function () {
								if (!context.b) {
									return 'Json.Decode.oneOf';
								} else {
									return 'The Json.Decode.oneOf at json' + A2(
										$elm$core$String$join,
										'',
										$elm$core$List$reverse(context));
								}
							}();
							var introduction = starter + (' failed in the following ' + ($elm$core$String$fromInt(
								$elm$core$List$length(errors)) + ' ways:'));
							return A2(
								$elm$core$String$join,
								'\n\n',
								A2(
									$elm$core$List$cons,
									introduction,
									A2($elm$core$List$indexedMap, $elm$json$Json$Decode$errorOneOf, errors)));
						}
					}
				default:
					var msg = error.a;
					var json = error.b;
					var introduction = function () {
						if (!context.b) {
							return 'Problem with the given value:\n\n';
						} else {
							return 'Problem with the value at json' + (A2(
								$elm$core$String$join,
								'',
								$elm$core$List$reverse(context)) + ':\n\n    ');
						}
					}();
					return introduction + ($elm$json$Json$Decode$indent(
						A2($elm$json$Json$Encode$encode, 4, json)) + ('\n\n' + msg));
			}
		}
	});
var $elm$core$Array$branchFactor = 32;
var $elm$core$Array$Array_elm_builtin = F4(
	function (a, b, c, d) {
		return {$: 'Array_elm_builtin', a: a, b: b, c: c, d: d};
	});
var $elm$core$Elm$JsArray$empty = _JsArray_empty;
var $elm$core$Basics$ceiling = _Basics_ceiling;
var $elm$core$Basics$fdiv = _Basics_fdiv;
var $elm$core$Basics$logBase = F2(
	function (base, number) {
		return _Basics_log(number) / _Basics_log(base);
	});
var $elm$core$Basics$toFloat = _Basics_toFloat;
var $elm$core$Array$shiftStep = $elm$core$Basics$ceiling(
	A2($elm$core$Basics$logBase, 2, $elm$core$Array$branchFactor));
var $elm$core$Array$empty = A4($elm$core$Array$Array_elm_builtin, 0, $elm$core$Array$shiftStep, $elm$core$Elm$JsArray$empty, $elm$core$Elm$JsArray$empty);
var $elm$core$Elm$JsArray$initialize = _JsArray_initialize;
var $elm$core$Array$Leaf = function (a) {
	return {$: 'Leaf', a: a};
};
var $elm$core$Basics$apL = F2(
	function (f, x) {
		return f(x);
	});
var $elm$core$Basics$apR = F2(
	function (x, f) {
		return f(x);
	});
var $elm$core$Basics$eq = _Utils_equal;
var $elm$core$Basics$floor = _Basics_floor;
var $elm$core$Elm$JsArray$length = _JsArray_length;
var $elm$core$Basics$gt = _Utils_gt;
var $elm$core$Basics$max = F2(
	function (x, y) {
		return (_Utils_cmp(x, y) > 0) ? x : y;
	});
var $elm$core$Basics$mul = _Basics_mul;
var $elm$core$Array$SubTree = function (a) {
	return {$: 'SubTree', a: a};
};
var $elm$core$Elm$JsArray$initializeFromList = _JsArray_initializeFromList;
var $elm$core$Array$compressNodes = F2(
	function (nodes, acc) {
		compressNodes:
		while (true) {
			var _v0 = A2($elm$core$Elm$JsArray$initializeFromList, $elm$core$Array$branchFactor, nodes);
			var node = _v0.a;
			var remainingNodes = _v0.b;
			var newAcc = A2(
				$elm$core$List$cons,
				$elm$core$Array$SubTree(node),
				acc);
			if (!remainingNodes.b) {
				return $elm$core$List$reverse(newAcc);
			} else {
				var $temp$nodes = remainingNodes,
					$temp$acc = newAcc;
				nodes = $temp$nodes;
				acc = $temp$acc;
				continue compressNodes;
			}
		}
	});
var $elm$core$Tuple$first = function (_v0) {
	var x = _v0.a;
	return x;
};
var $elm$core$Array$treeFromBuilder = F2(
	function (nodeList, nodeListSize) {
		treeFromBuilder:
		while (true) {
			var newNodeSize = $elm$core$Basics$ceiling(nodeListSize / $elm$core$Array$branchFactor);
			if (newNodeSize === 1) {
				return A2($elm$core$Elm$JsArray$initializeFromList, $elm$core$Array$branchFactor, nodeList).a;
			} else {
				var $temp$nodeList = A2($elm$core$Array$compressNodes, nodeList, _List_Nil),
					$temp$nodeListSize = newNodeSize;
				nodeList = $temp$nodeList;
				nodeListSize = $temp$nodeListSize;
				continue treeFromBuilder;
			}
		}
	});
var $elm$core$Array$builderToArray = F2(
	function (reverseNodeList, builder) {
		if (!builder.nodeListSize) {
			return A4(
				$elm$core$Array$Array_elm_builtin,
				$elm$core$Elm$JsArray$length(builder.tail),
				$elm$core$Array$shiftStep,
				$elm$core$Elm$JsArray$empty,
				builder.tail);
		} else {
			var treeLen = builder.nodeListSize * $elm$core$Array$branchFactor;
			var depth = $elm$core$Basics$floor(
				A2($elm$core$Basics$logBase, $elm$core$Array$branchFactor, treeLen - 1));
			var correctNodeList = reverseNodeList ? $elm$core$List$reverse(builder.nodeList) : builder.nodeList;
			var tree = A2($elm$core$Array$treeFromBuilder, correctNodeList, builder.nodeListSize);
			return A4(
				$elm$core$Array$Array_elm_builtin,
				$elm$core$Elm$JsArray$length(builder.tail) + treeLen,
				A2($elm$core$Basics$max, 5, depth * $elm$core$Array$shiftStep),
				tree,
				builder.tail);
		}
	});
var $elm$core$Basics$idiv = _Basics_idiv;
var $elm$core$Basics$lt = _Utils_lt;
var $elm$core$Array$initializeHelp = F5(
	function (fn, fromIndex, len, nodeList, tail) {
		initializeHelp:
		while (true) {
			if (fromIndex < 0) {
				return A2(
					$elm$core$Array$builderToArray,
					false,
					{nodeList: nodeList, nodeListSize: (len / $elm$core$Array$branchFactor) | 0, tail: tail});
			} else {
				var leaf = $elm$core$Array$Leaf(
					A3($elm$core$Elm$JsArray$initialize, $elm$core$Array$branchFactor, fromIndex, fn));
				var $temp$fn = fn,
					$temp$fromIndex = fromIndex - $elm$core$Array$branchFactor,
					$temp$len = len,
					$temp$nodeList = A2($elm$core$List$cons, leaf, nodeList),
					$temp$tail = tail;
				fn = $temp$fn;
				fromIndex = $temp$fromIndex;
				len = $temp$len;
				nodeList = $temp$nodeList;
				tail = $temp$tail;
				continue initializeHelp;
			}
		}
	});
var $elm$core$Basics$remainderBy = _Basics_remainderBy;
var $elm$core$Array$initialize = F2(
	function (len, fn) {
		if (len <= 0) {
			return $elm$core$Array$empty;
		} else {
			var tailLen = len % $elm$core$Array$branchFactor;
			var tail = A3($elm$core$Elm$JsArray$initialize, tailLen, len - tailLen, fn);
			var initialFromIndex = (len - tailLen) - $elm$core$Array$branchFactor;
			return A5($elm$core$Array$initializeHelp, fn, initialFromIndex, len, _List_Nil, tail);
		}
	});
var $elm$core$Basics$True = {$: 'True'};
var $elm$core$Result$isOk = function (result) {
	if (result.$ === 'Ok') {
		return true;
	} else {
		return false;
	}
};
var $elm$json$Json$Decode$map = _Json_map1;
var $elm$json$Json$Decode$map2 = _Json_map2;
var $elm$json$Json$Decode$succeed = _Json_succeed;
var $elm$virtual_dom$VirtualDom$toHandlerInt = function (handler) {
	switch (handler.$) {
		case 'Normal':
			return 0;
		case 'MayStopPropagation':
			return 1;
		case 'MayPreventDefault':
			return 2;
		default:
			return 3;
	}
};
var $elm$browser$Browser$External = function (a) {
	return {$: 'External', a: a};
};
var $elm$browser$Browser$Internal = function (a) {
	return {$: 'Internal', a: a};
};
var $elm$core$Basics$identity = function (x) {
	return x;
};
var $elm$browser$Browser$Dom$NotFound = function (a) {
	return {$: 'NotFound', a: a};
};
var $elm$url$Url$Http = {$: 'Http'};
var $elm$url$Url$Https = {$: 'Https'};
var $elm$url$Url$Url = F6(
	function (protocol, host, port_, path, query, fragment) {
		return {fragment: fragment, host: host, path: path, port_: port_, protocol: protocol, query: query};
	});
var $elm$core$String$contains = _String_contains;
var $elm$core$String$length = _String_length;
var $elm$core$String$slice = _String_slice;
var $elm$core$String$dropLeft = F2(
	function (n, string) {
		return (n < 1) ? string : A3(
			$elm$core$String$slice,
			n,
			$elm$core$String$length(string),
			string);
	});
var $elm$core$String$indexes = _String_indexes;
var $elm$core$String$isEmpty = function (string) {
	return string === '';
};
var $elm$core$String$left = F2(
	function (n, string) {
		return (n < 1) ? '' : A3($elm$core$String$slice, 0, n, string);
	});
var $elm$core$String$toInt = _String_toInt;
var $elm$url$Url$chompBeforePath = F5(
	function (protocol, path, params, frag, str) {
		if ($elm$core$String$isEmpty(str) || A2($elm$core$String$contains, '@', str)) {
			return $elm$core$Maybe$Nothing;
		} else {
			var _v0 = A2($elm$core$String$indexes, ':', str);
			if (!_v0.b) {
				return $elm$core$Maybe$Just(
					A6($elm$url$Url$Url, protocol, str, $elm$core$Maybe$Nothing, path, params, frag));
			} else {
				if (!_v0.b.b) {
					var i = _v0.a;
					var _v1 = $elm$core$String$toInt(
						A2($elm$core$String$dropLeft, i + 1, str));
					if (_v1.$ === 'Nothing') {
						return $elm$core$Maybe$Nothing;
					} else {
						var port_ = _v1;
						return $elm$core$Maybe$Just(
							A6(
								$elm$url$Url$Url,
								protocol,
								A2($elm$core$String$left, i, str),
								port_,
								path,
								params,
								frag));
					}
				} else {
					return $elm$core$Maybe$Nothing;
				}
			}
		}
	});
var $elm$url$Url$chompBeforeQuery = F4(
	function (protocol, params, frag, str) {
		if ($elm$core$String$isEmpty(str)) {
			return $elm$core$Maybe$Nothing;
		} else {
			var _v0 = A2($elm$core$String$indexes, '/', str);
			if (!_v0.b) {
				return A5($elm$url$Url$chompBeforePath, protocol, '/', params, frag, str);
			} else {
				var i = _v0.a;
				return A5(
					$elm$url$Url$chompBeforePath,
					protocol,
					A2($elm$core$String$dropLeft, i, str),
					params,
					frag,
					A2($elm$core$String$left, i, str));
			}
		}
	});
var $elm$url$Url$chompBeforeFragment = F3(
	function (protocol, frag, str) {
		if ($elm$core$String$isEmpty(str)) {
			return $elm$core$Maybe$Nothing;
		} else {
			var _v0 = A2($elm$core$String$indexes, '?', str);
			if (!_v0.b) {
				return A4($elm$url$Url$chompBeforeQuery, protocol, $elm$core$Maybe$Nothing, frag, str);
			} else {
				var i = _v0.a;
				return A4(
					$elm$url$Url$chompBeforeQuery,
					protocol,
					$elm$core$Maybe$Just(
						A2($elm$core$String$dropLeft, i + 1, str)),
					frag,
					A2($elm$core$String$left, i, str));
			}
		}
	});
var $elm$url$Url$chompAfterProtocol = F2(
	function (protocol, str) {
		if ($elm$core$String$isEmpty(str)) {
			return $elm$core$Maybe$Nothing;
		} else {
			var _v0 = A2($elm$core$String$indexes, '#', str);
			if (!_v0.b) {
				return A3($elm$url$Url$chompBeforeFragment, protocol, $elm$core$Maybe$Nothing, str);
			} else {
				var i = _v0.a;
				return A3(
					$elm$url$Url$chompBeforeFragment,
					protocol,
					$elm$core$Maybe$Just(
						A2($elm$core$String$dropLeft, i + 1, str)),
					A2($elm$core$String$left, i, str));
			}
		}
	});
var $elm$core$String$startsWith = _String_startsWith;
var $elm$url$Url$fromString = function (str) {
	return A2($elm$core$String$startsWith, 'http://', str) ? A2(
		$elm$url$Url$chompAfterProtocol,
		$elm$url$Url$Http,
		A2($elm$core$String$dropLeft, 7, str)) : (A2($elm$core$String$startsWith, 'https://', str) ? A2(
		$elm$url$Url$chompAfterProtocol,
		$elm$url$Url$Https,
		A2($elm$core$String$dropLeft, 8, str)) : $elm$core$Maybe$Nothing);
};
var $elm$core$Basics$never = function (_v0) {
	never:
	while (true) {
		var nvr = _v0.a;
		var $temp$_v0 = nvr;
		_v0 = $temp$_v0;
		continue never;
	}
};
var $elm$core$Task$Perform = function (a) {
	return {$: 'Perform', a: a};
};
var $elm$core$Task$succeed = _Scheduler_succeed;
var $elm$core$Task$init = $elm$core$Task$succeed(_Utils_Tuple0);
var $elm$core$List$foldrHelper = F4(
	function (fn, acc, ctr, ls) {
		if (!ls.b) {
			return acc;
		} else {
			var a = ls.a;
			var r1 = ls.b;
			if (!r1.b) {
				return A2(fn, a, acc);
			} else {
				var b = r1.a;
				var r2 = r1.b;
				if (!r2.b) {
					return A2(
						fn,
						a,
						A2(fn, b, acc));
				} else {
					var c = r2.a;
					var r3 = r2.b;
					if (!r3.b) {
						return A2(
							fn,
							a,
							A2(
								fn,
								b,
								A2(fn, c, acc)));
					} else {
						var d = r3.a;
						var r4 = r3.b;
						var res = (ctr > 500) ? A3(
							$elm$core$List$foldl,
							fn,
							acc,
							$elm$core$List$reverse(r4)) : A4($elm$core$List$foldrHelper, fn, acc, ctr + 1, r4);
						return A2(
							fn,
							a,
							A2(
								fn,
								b,
								A2(
									fn,
									c,
									A2(fn, d, res))));
					}
				}
			}
		}
	});
var $elm$core$List$foldr = F3(
	function (fn, acc, ls) {
		return A4($elm$core$List$foldrHelper, fn, acc, 0, ls);
	});
var $elm$core$List$map = F2(
	function (f, xs) {
		return A3(
			$elm$core$List$foldr,
			F2(
				function (x, acc) {
					return A2(
						$elm$core$List$cons,
						f(x),
						acc);
				}),
			_List_Nil,
			xs);
	});
var $elm$core$Task$andThen = _Scheduler_andThen;
var $elm$core$Task$map = F2(
	function (func, taskA) {
		return A2(
			$elm$core$Task$andThen,
			function (a) {
				return $elm$core$Task$succeed(
					func(a));
			},
			taskA);
	});
var $elm$core$Task$map2 = F3(
	function (func, taskA, taskB) {
		return A2(
			$elm$core$Task$andThen,
			function (a) {
				return A2(
					$elm$core$Task$andThen,
					function (b) {
						return $elm$core$Task$succeed(
							A2(func, a, b));
					},
					taskB);
			},
			taskA);
	});
var $elm$core$Task$sequence = function (tasks) {
	return A3(
		$elm$core$List$foldr,
		$elm$core$Task$map2($elm$core$List$cons),
		$elm$core$Task$succeed(_List_Nil),
		tasks);
};
var $elm$core$Platform$sendToApp = _Platform_sendToApp;
var $elm$core$Task$spawnCmd = F2(
	function (router, _v0) {
		var task = _v0.a;
		return _Scheduler_spawn(
			A2(
				$elm$core$Task$andThen,
				$elm$core$Platform$sendToApp(router),
				task));
	});
var $elm$core$Task$onEffects = F3(
	function (router, commands, state) {
		return A2(
			$elm$core$Task$map,
			function (_v0) {
				return _Utils_Tuple0;
			},
			$elm$core$Task$sequence(
				A2(
					$elm$core$List$map,
					$elm$core$Task$spawnCmd(router),
					commands)));
	});
var $elm$core$Task$onSelfMsg = F3(
	function (_v0, _v1, _v2) {
		return $elm$core$Task$succeed(_Utils_Tuple0);
	});
var $elm$core$Task$cmdMap = F2(
	function (tagger, _v0) {
		var task = _v0.a;
		return $elm$core$Task$Perform(
			A2($elm$core$Task$map, tagger, task));
	});
_Platform_effectManagers['Task'] = _Platform_createManager($elm$core$Task$init, $elm$core$Task$onEffects, $elm$core$Task$onSelfMsg, $elm$core$Task$cmdMap);
var $elm$core$Task$command = _Platform_leaf('Task');
var $elm$core$Task$perform = F2(
	function (toMessage, task) {
		return $elm$core$Task$command(
			$elm$core$Task$Perform(
				A2($elm$core$Task$map, toMessage, task)));
	});
var $elm$browser$Browser$element = _Browser_element;
var $author$project$TopicList$Model$Failed = function (a) {
	return {$: 'Failed', a: a};
};
var $author$project$TopicList$Model$Loaded = F2(
	function (a, b) {
		return {$: 'Loaded', a: a, b: b};
	});
var $krisajenkins$remotedata$RemoteData$NotAsked = {$: 'NotAsked'};
var $elm$core$Dict$RBEmpty_elm_builtin = {$: 'RBEmpty_elm_builtin'};
var $elm$core$Dict$empty = $elm$core$Dict$RBEmpty_elm_builtin;
var $elm$core$Array$repeat = F2(
	function (n, e) {
		return A2(
			$elm$core$Array$initialize,
			n,
			function (_v0) {
				return e;
			});
	});
var $author$project$Progress$Steps$initialFlows = function (flags) {
	var makeFlow = function (w) {
		return {
			messages: _List_Nil,
			steps: A2(
				$elm$core$Array$repeat,
				$elm$core$List$length(w.progress),
				'init'),
			success: $elm$core$Maybe$Nothing,
			workflow: w
		};
	};
	return A2($elm$core$List$map, makeFlow, flags.workflows);
};
var $elm$core$Platform$Cmd$batch = _Platform_batch;
var $elm$core$Platform$Cmd$none = $elm$core$Platform$Cmd$batch(_List_Nil);
var $author$project$Progress$Model$init = function (flags) {
	var state = {
		active: 0,
		decodeErrors: _List_Nil,
		expanded: false,
		flows: $author$project$Progress$Steps$initialFlows(flags)
	};
	return _Utils_Tuple2(state, $elm$core$Platform$Cmd$none);
};
var $elm$json$Json$Decode$decodeValue = _Json_run;
var $author$project$TopicList$Flags$Flags = F3(
	function (config, extra, workflows) {
		return {config: config, extra: extra, workflows: workflows};
	});
var $author$project$TopicList$Flags$Extra = F6(
	function (mode, module_, progressView, topiclistView, viewNodes, workflowpaths) {
		return {mode: mode, module_: module_, progressView: progressView, topiclistView: topiclistView, viewNodes: viewNodes, workflowpaths: workflowpaths};
	});
var $author$project$TopicList$Flags$ExtraProgressView = function (labels) {
	return {labels: labels};
};
var $author$project$TopicList$Flags$ExtraProgressViewLabels = F4(
	function (decodeErrors, diagnosticLogs, status, workflow) {
		return {decodeErrors: decodeErrors, diagnosticLogs: diagnosticLogs, status: status, workflow: workflow};
	});
var $author$project$TopicList$Flags$ExtraProgressViewLabelsDecodeErrors = function (label) {
	return {label: label};
};
var $elm$json$Json$Decode$field = _Json_decodeField;
var $elm$json$Json$Decode$string = _Json_decodeString;
var $author$project$TopicList$Flags$extraProgressViewLabelsDecodeErrorsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$TopicList$Flags$ExtraProgressViewLabelsDecodeErrors,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$TopicList$Flags$ExtraProgressViewLabelsDiagnosticLogs = function (label) {
	return {label: label};
};
var $author$project$TopicList$Flags$extraProgressViewLabelsDiagnosticLogsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$TopicList$Flags$ExtraProgressViewLabelsDiagnosticLogs,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$TopicList$Flags$ExtraProgressViewLabelsStatus = F2(
	function (failure, success) {
		return {failure: failure, success: success};
	});
var $author$project$TopicList$Flags$extraProgressViewLabelsStatusDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$TopicList$Flags$ExtraProgressViewLabelsStatus,
	A2($elm$json$Json$Decode$field, 'failure', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'success', $elm$json$Json$Decode$string));
var $author$project$TopicList$Flags$ExtraProgressViewLabelsWorkflow = function (label) {
	return {label: label};
};
var $author$project$TopicList$Flags$extraProgressViewLabelsWorkflowDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$TopicList$Flags$ExtraProgressViewLabelsWorkflow,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $elm$json$Json$Decode$map4 = _Json_map4;
var $author$project$TopicList$Flags$extraProgressViewLabelsDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$TopicList$Flags$ExtraProgressViewLabels,
	A2($elm$json$Json$Decode$field, 'decode_errors', $author$project$TopicList$Flags$extraProgressViewLabelsDecodeErrorsDecoder),
	A2($elm$json$Json$Decode$field, 'diagnostic_logs', $author$project$TopicList$Flags$extraProgressViewLabelsDiagnosticLogsDecoder),
	A2($elm$json$Json$Decode$field, 'status', $author$project$TopicList$Flags$extraProgressViewLabelsStatusDecoder),
	A2($elm$json$Json$Decode$field, 'workflow', $author$project$TopicList$Flags$extraProgressViewLabelsWorkflowDecoder));
var $author$project$TopicList$Flags$extraProgressViewDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$TopicList$Flags$ExtraProgressView,
	A2($elm$json$Json$Decode$field, 'labels', $author$project$TopicList$Flags$extraProgressViewLabelsDecoder));
var $author$project$TopicList$Flags$ExtraTopiclistView = F4(
	function (labels, plurals, requests, transitions) {
		return {labels: labels, plurals: plurals, requests: requests, transitions: transitions};
	});
var $author$project$TopicList$Flags$ExtraTopiclistViewLabels = function (accept) {
	return function (addTopic) {
		return function (description) {
			return function (details) {
				return function (invitation) {
					return function (lastVisit) {
						return function (pctVisited) {
							return function (restricted) {
								return function (searchTopics) {
									return function (shared) {
										return function (showExample) {
											return function (unrestricted) {
												return {accept: accept, addTopic: addTopic, description: description, details: details, invitation: invitation, lastVisit: lastVisit, pctVisited: pctVisited, restricted: restricted, searchTopics: searchTopics, shared: shared, showExample: showExample, unrestricted: unrestricted};
											};
										};
									};
								};
							};
						};
					};
				};
			};
		};
	};
};
var $author$project$TopicList$Flags$ExtraTopiclistViewLabelsAccept = function (label) {
	return {label: label};
};
var $author$project$TopicList$Flags$extraTopiclistViewLabelsAcceptDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$TopicList$Flags$ExtraTopiclistViewLabelsAccept,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$TopicList$Flags$ExtraTopiclistViewLabelsAddTopic = function (label) {
	return {label: label};
};
var $author$project$TopicList$Flags$extraTopiclistViewLabelsAddTopicDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$TopicList$Flags$ExtraTopiclistViewLabelsAddTopic,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$TopicList$Flags$ExtraTopiclistViewLabelsDescription = function (label) {
	return {label: label};
};
var $author$project$TopicList$Flags$extraTopiclistViewLabelsDescriptionDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$TopicList$Flags$ExtraTopiclistViewLabelsDescription,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$TopicList$Flags$ExtraTopiclistViewLabelsDetails = function (label) {
	return {label: label};
};
var $author$project$TopicList$Flags$extraTopiclistViewLabelsDetailsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$TopicList$Flags$ExtraTopiclistViewLabelsDetails,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$TopicList$Flags$ExtraTopiclistViewLabelsInvitation = function (description) {
	return {description: description};
};
var $author$project$TopicList$Flags$extraTopiclistViewLabelsInvitationDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$TopicList$Flags$ExtraTopiclistViewLabelsInvitation,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string));
var $author$project$TopicList$Flags$ExtraTopiclistViewLabelsLastVisit = function (label) {
	return {label: label};
};
var $author$project$TopicList$Flags$extraTopiclistViewLabelsLastVisitDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$TopicList$Flags$ExtraTopiclistViewLabelsLastVisit,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$TopicList$Flags$ExtraTopiclistViewLabelsPctVisited = function (label) {
	return {label: label};
};
var $author$project$TopicList$Flags$extraTopiclistViewLabelsPctVisitedDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$TopicList$Flags$ExtraTopiclistViewLabelsPctVisited,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$TopicList$Flags$ExtraTopiclistViewLabelsRestricted = function (label) {
	return {label: label};
};
var $author$project$TopicList$Flags$extraTopiclistViewLabelsRestrictedDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$TopicList$Flags$ExtraTopiclistViewLabelsRestricted,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$TopicList$Flags$ExtraTopiclistViewLabelsSearchTopics = function (placeholder) {
	return {placeholder: placeholder};
};
var $author$project$TopicList$Flags$extraTopiclistViewLabelsSearchTopicsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$TopicList$Flags$ExtraTopiclistViewLabelsSearchTopics,
	A2($elm$json$Json$Decode$field, 'placeholder', $elm$json$Json$Decode$string));
var $author$project$TopicList$Flags$ExtraTopiclistViewLabelsShared = F2(
	function (label, width) {
		return {label: label, width: width};
	});
var $author$project$TopicList$Flags$extraTopiclistViewLabelsSharedDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$TopicList$Flags$ExtraTopiclistViewLabelsShared,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$TopicList$Flags$ExtraTopiclistViewLabelsShowExample = function (label) {
	return {label: label};
};
var $author$project$TopicList$Flags$extraTopiclistViewLabelsShowExampleDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$TopicList$Flags$ExtraTopiclistViewLabelsShowExample,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$TopicList$Flags$ExtraTopiclistViewLabelsUnrestricted = function (label) {
	return {label: label};
};
var $author$project$TopicList$Flags$extraTopiclistViewLabelsUnrestrictedDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$TopicList$Flags$ExtraTopiclistViewLabelsUnrestricted,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $elm$json$Json$Decode$map5 = _Json_map5;
var $elm$json$Json$Decode$map8 = _Json_map8;
var $author$project$TopicList$Flags$extraTopiclistViewLabelsDecoder = function () {
	var fieldSet0 = A9(
		$elm$json$Json$Decode$map8,
		$author$project$TopicList$Flags$ExtraTopiclistViewLabels,
		A2($elm$json$Json$Decode$field, 'accept', $author$project$TopicList$Flags$extraTopiclistViewLabelsAcceptDecoder),
		A2($elm$json$Json$Decode$field, 'add_topic', $author$project$TopicList$Flags$extraTopiclistViewLabelsAddTopicDecoder),
		A2($elm$json$Json$Decode$field, 'description', $author$project$TopicList$Flags$extraTopiclistViewLabelsDescriptionDecoder),
		A2($elm$json$Json$Decode$field, 'details', $author$project$TopicList$Flags$extraTopiclistViewLabelsDetailsDecoder),
		A2($elm$json$Json$Decode$field, 'invitation', $author$project$TopicList$Flags$extraTopiclistViewLabelsInvitationDecoder),
		A2($elm$json$Json$Decode$field, 'last_visit', $author$project$TopicList$Flags$extraTopiclistViewLabelsLastVisitDecoder),
		A2($elm$json$Json$Decode$field, 'pct_visited', $author$project$TopicList$Flags$extraTopiclistViewLabelsPctVisitedDecoder),
		A2($elm$json$Json$Decode$field, 'restricted', $author$project$TopicList$Flags$extraTopiclistViewLabelsRestrictedDecoder));
	return A6(
		$elm$json$Json$Decode$map5,
		$elm$core$Basics$apL,
		fieldSet0,
		A2($elm$json$Json$Decode$field, 'search_topics', $author$project$TopicList$Flags$extraTopiclistViewLabelsSearchTopicsDecoder),
		A2($elm$json$Json$Decode$field, 'shared', $author$project$TopicList$Flags$extraTopiclistViewLabelsSharedDecoder),
		A2($elm$json$Json$Decode$field, 'show_example', $author$project$TopicList$Flags$extraTopiclistViewLabelsShowExampleDecoder),
		A2($elm$json$Json$Decode$field, 'unrestricted', $author$project$TopicList$Flags$extraTopiclistViewLabelsUnrestrictedDecoder));
}();
var $author$project$TopicList$Flags$ExtraTopiclistViewPlurals = function (comments) {
	return function (files) {
		return function (folders) {
			return function (noComments) {
				return function (noFiles) {
					return function (noFolders) {
						return function (noUnread) {
							return function (oneComment) {
								return function (oneFile) {
									return function (oneFolder) {
										return function (oneUnread) {
											return function (unread) {
												return {comments: comments, files: files, folders: folders, noComments: noComments, noFiles: noFiles, noFolders: noFolders, noUnread: noUnread, oneComment: oneComment, oneFile: oneFile, oneFolder: oneFolder, oneUnread: oneUnread, unread: unread};
											};
										};
									};
								};
							};
						};
					};
				};
			};
		};
	};
};
var $author$project$TopicList$Flags$extraTopiclistViewPluralsDecoder = function () {
	var fieldSet0 = A9(
		$elm$json$Json$Decode$map8,
		$author$project$TopicList$Flags$ExtraTopiclistViewPlurals,
		A2($elm$json$Json$Decode$field, 'comments', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'files', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'folders', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'no_comments', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'no_files', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'no_folders', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'no_unread', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'one_comment', $elm$json$Json$Decode$string));
	return A6(
		$elm$json$Json$Decode$map5,
		$elm$core$Basics$apL,
		fieldSet0,
		A2($elm$json$Json$Decode$field, 'one_file', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'one_folder', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'one_unread', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'unread', $elm$json$Json$Decode$string));
}();
var $author$project$TopicList$Flags$ExtraTopiclistViewRequests = function (submit) {
	return {submit: submit};
};
var $author$project$TopicList$Flags$extraTopiclistViewRequestsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$TopicList$Flags$ExtraTopiclistViewRequests,
	A2($elm$json$Json$Decode$field, 'submit', $elm$json$Json$Decode$string));
var $author$project$TopicList$Flags$ExtraTopiclistViewTransitions = F3(
	function (accept, add, details) {
		return {accept: accept, add: add, details: details};
	});
var $elm$json$Json$Decode$map3 = _Json_map3;
var $author$project$TopicList$Flags$extraTopiclistViewTransitionsDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$TopicList$Flags$ExtraTopiclistViewTransitions,
	A2($elm$json$Json$Decode$field, 'accept', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'add', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'details', $elm$json$Json$Decode$string));
var $author$project$TopicList$Flags$extraTopiclistViewDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$TopicList$Flags$ExtraTopiclistView,
	A2($elm$json$Json$Decode$field, 'labels', $author$project$TopicList$Flags$extraTopiclistViewLabelsDecoder),
	A2($elm$json$Json$Decode$field, 'plurals', $author$project$TopicList$Flags$extraTopiclistViewPluralsDecoder),
	A2($elm$json$Json$Decode$field, 'requests', $author$project$TopicList$Flags$extraTopiclistViewRequestsDecoder),
	A2($elm$json$Json$Decode$field, 'transitions', $author$project$TopicList$Flags$extraTopiclistViewTransitionsDecoder));
var $elm$json$Json$Decode$list = _Json_decodeList;
var $elm$json$Json$Decode$map6 = _Json_map6;
var $author$project$TopicList$Flags$extraDecoder = A7(
	$elm$json$Json$Decode$map6,
	$author$project$TopicList$Flags$Extra,
	A2($elm$json$Json$Decode$field, 'mode', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'module', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'progress_view', $author$project$TopicList$Flags$extraProgressViewDecoder),
	A2($elm$json$Json$Decode$field, 'topiclist_view', $author$project$TopicList$Flags$extraTopiclistViewDecoder),
	A2(
		$elm$json$Json$Decode$field,
		'view_nodes',
		$elm$json$Json$Decode$list($elm$json$Json$Decode$string)),
	A2(
		$elm$json$Json$Decode$field,
		'workflowpaths',
		$elm$json$Json$Decode$list($elm$json$Json$Decode$string)));
var $author$project$TopicList$Flags$FlagsConfig = F3(
	function (baseUrl, defaultLanguage, extra) {
		return {baseUrl: baseUrl, defaultLanguage: defaultLanguage, extra: extra};
	});
var $author$project$TopicList$Flags$FlagsConfigExtra = F4(
	function (dev, originCollab, originReview, title) {
		return {dev: dev, originCollab: originCollab, originReview: originReview, title: title};
	});
var $elm$json$Json$Decode$bool = _Json_decodeBool;
var $author$project$TopicList$Flags$flagsConfigExtraDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$TopicList$Flags$FlagsConfigExtra,
	A2($elm$json$Json$Decode$field, 'dev', $elm$json$Json$Decode$bool),
	A2($elm$json$Json$Decode$field, 'origin_collab', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'origin_review', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'title', $elm$json$Json$Decode$string));
var $author$project$TopicList$Flags$flagsConfigDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$TopicList$Flags$FlagsConfig,
	A2($elm$json$Json$Decode$field, 'base_url', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'default_language', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'extra', $author$project$TopicList$Flags$flagsConfigExtraDecoder));
var $author$project$TopicList$Flags$FlagsWorkflowsObject = F3(
	function (name, label, progress) {
		return {label: label, name: name, progress: progress};
	});
var $author$project$TopicList$Flags$FlagsWorkflowsObjectProgressObject = F2(
	function (display, messages) {
		return {display: display, messages: messages};
	});
var $author$project$TopicList$Flags$FlagsWorkflowsObjectProgressObjectDisplay = F7(
	function (error, error2, init, ok, ok2, skip, skip2) {
		return {error: error, error2: error2, init: init, ok: ok, ok2: ok2, skip: skip, skip2: skip2};
	});
var $elm$json$Json$Decode$map7 = _Json_map7;
var $author$project$TopicList$Flags$flagsWorkflowsObjectProgressObjectDisplayDecoder = A8(
	$elm$json$Json$Decode$map7,
	$author$project$TopicList$Flags$FlagsWorkflowsObjectProgressObjectDisplay,
	A2($elm$json$Json$Decode$field, 'error', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'error2', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'init', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'ok', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'ok2', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'skip', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'skip2', $elm$json$Json$Decode$string));
var $author$project$TopicList$Flags$FlagsWorkflowsObjectProgressObjectMessages = F2(
	function (error, ok) {
		return {error: error, ok: ok};
	});
var $author$project$TopicList$Flags$flagsWorkflowsObjectProgressObjectMessagesDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$TopicList$Flags$FlagsWorkflowsObjectProgressObjectMessages,
	A2($elm$json$Json$Decode$field, 'error', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'ok', $elm$json$Json$Decode$string));
var $author$project$TopicList$Flags$flagsWorkflowsObjectProgressObjectDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$TopicList$Flags$FlagsWorkflowsObjectProgressObject,
	A2($elm$json$Json$Decode$field, 'display', $author$project$TopicList$Flags$flagsWorkflowsObjectProgressObjectDisplayDecoder),
	A2($elm$json$Json$Decode$field, 'messages', $author$project$TopicList$Flags$flagsWorkflowsObjectProgressObjectMessagesDecoder));
var $author$project$TopicList$Flags$flagsWorkflowsObjectDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$TopicList$Flags$FlagsWorkflowsObject,
	A2($elm$json$Json$Decode$field, 'name', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2(
		$elm$json$Json$Decode$field,
		'progress',
		$elm$json$Json$Decode$list($author$project$TopicList$Flags$flagsWorkflowsObjectProgressObjectDecoder)));
var $author$project$TopicList$Flags$flagsDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$TopicList$Flags$Flags,
	A2($elm$json$Json$Decode$field, 'config', $author$project$TopicList$Flags$flagsConfigDecoder),
	A2($elm$json$Json$Decode$field, 'extra', $author$project$TopicList$Flags$extraDecoder),
	A2(
		$elm$json$Json$Decode$field,
		'workflows',
		$elm$json$Json$Decode$list($author$project$TopicList$Flags$flagsWorkflowsObjectDecoder)));
var $elm$core$Result$mapError = F2(
	function (f, result) {
		if (result.$ === 'Ok') {
			var v = result.a;
			return $elm$core$Result$Ok(v);
		} else {
			var e = result.a;
			return $elm$core$Result$Err(
				f(e));
		}
	});
var $author$project$TopicList$Flags$jsonToResultFlags = function (json) {
	return A2(
		$elm$core$Result$mapError,
		$elm$json$Json$Decode$errorToString,
		A2($elm$json$Json$Decode$decodeValue, $author$project$TopicList$Flags$flagsDecoder, json));
};
var $author$project$TopicList$Model$ProgressMsg = function (a) {
	return {$: 'ProgressMsg', a: a};
};
var $elm$core$Platform$Cmd$map = _Platform_map;
var $author$project$TopicList$progressCmds = function (pcmds) {
	return A2($elm$core$Platform$Cmd$map, $author$project$TopicList$Model$ProgressMsg, pcmds);
};
var $author$project$TopicList$progressFlags = function (flags) {
	return {labels: flags.extra.progressView.labels, workflows: flags.workflows};
};
var $author$project$TopicList$init = function (value) {
	var _v0 = $author$project$TopicList$Flags$jsonToResultFlags(value);
	if (_v0.$ === 'Err') {
		var err = _v0.a;
		return _Utils_Tuple2(
			$author$project$TopicList$Model$Failed(err),
			$elm$core$Platform$Cmd$none);
	} else {
		var flags = _v0.a;
		var _v1 = $author$project$Progress$Model$init(
			$author$project$TopicList$progressFlags(flags));
		var pstate = _v1.a;
		var pcmds = _v1.b;
		return _Utils_Tuple2(
			A2(
				$author$project$TopicList$Model$Loaded,
				flags,
				{auth: $krisajenkins$remotedata$RemoteData$NotAsked, bundles: $elm$core$Dict$empty, filter: '', profiles: $elm$core$Dict$empty, progress: pstate, response: $krisajenkins$remotedata$RemoteData$NotAsked, show_example: false, topics: $elm$core$Dict$empty}),
			$author$project$TopicList$progressCmds(pcmds));
	}
};
var $author$project$TopicList$Model$Incoming = function (a) {
	return {$: 'Incoming', a: a};
};
var $elm$json$Json$Decode$value = _Json_decodeValue;
var $author$project$Shared$Ports$toElm = _Platform_incomingPort('toElm', $elm$json$Json$Decode$value);
var $author$project$TopicList$subscriptions = function (model) {
	return $author$project$Shared$Ports$toElm($author$project$TopicList$Model$Incoming);
};
var $author$project$Progress$Model$DecodeErr = function (a) {
	return {$: 'DecodeErr', a: a};
};
var $krisajenkins$remotedata$RemoteData$Failure = function (a) {
	return {$: 'Failure', a: a};
};
var $author$project$Progress$Model$Incoming = function (a) {
	return {$: 'Incoming', a: a};
};
var $krisajenkins$remotedata$RemoteData$Success = function (a) {
	return {$: 'Success', a: a};
};
var $elm$core$Debug$log = _Debug_log;
var $author$project$Shared$Dbg$log = F2(
	function (x, y) {
		return A2($elm$core$Debug$log, x, y);
	});
var $author$project$Shared$Cmd$cmdLog = F2(
	function (s, any) {
		var _v0 = A2($author$project$Shared$Dbg$log, 'cmdLog', s);
		return _Utils_Tuple2(any, $elm$core$Platform$Cmd$none);
	});
var $elm$browser$Browser$Navigation$load = _Browser_load;
var $author$project$Shared$Cmd$cmdTransition = F2(
	function (path, any) {
		return _Utils_Tuple2(
			any,
			$elm$browser$Browser$Navigation$load(path));
	});
var $author$project$Shared$Cmd$cmdTransitionString = F3(
	function (path, key, any) {
		return _Utils_Tuple2(
			any,
			$elm$browser$Browser$Navigation$load(
				_Utils_ap(path, key)));
	});
var $elm$regex$Regex$Match = F4(
	function (match, index, number, submatches) {
		return {index: index, match: match, number: number, submatches: submatches};
	});
var $elm$regex$Regex$contains = _Regex_contains;
var $elm$regex$Regex$fromStringWith = _Regex_fromStringWith;
var $elm$regex$Regex$fromString = function (string) {
	return A2(
		$elm$regex$Regex$fromStringWith,
		{caseInsensitive: false, multiline: false},
		string);
};
var $elm$regex$Regex$never = _Regex_never;
var $elm$core$Maybe$withDefault = F2(
	function (_default, maybe) {
		if (maybe.$ === 'Just') {
			var value = maybe.a;
			return value;
		} else {
			return _default;
		}
	});
var $author$project$Shared$Reg$decodeErrRegex = A2(
	$elm$core$Maybe$withDefault,
	$elm$regex$Regex$never,
	$elm$regex$Regex$fromString('Problem with the given value:'));
var $author$project$Shared$Reg$decodeErr = function (err) {
	return A2($elm$regex$Regex$contains, $author$project$Shared$Reg$decodeErrRegex, err);
};
var $elm$core$Basics$not = _Basics_not;
var $author$project$TopicList$Model$emptyBundle = {bundle_stats: $elm$core$Maybe$Nothing, data: $elm$core$Maybe$Nothing};
var $elm$core$Basics$compare = _Utils_compare;
var $elm$core$Dict$get = F2(
	function (targetKey, dict) {
		get:
		while (true) {
			if (dict.$ === 'RBEmpty_elm_builtin') {
				return $elm$core$Maybe$Nothing;
			} else {
				var key = dict.b;
				var value = dict.c;
				var left = dict.d;
				var right = dict.e;
				var _v1 = A2($elm$core$Basics$compare, targetKey, key);
				switch (_v1.$) {
					case 'LT':
						var $temp$targetKey = targetKey,
							$temp$dict = left;
						targetKey = $temp$targetKey;
						dict = $temp$dict;
						continue get;
					case 'EQ':
						return $elm$core$Maybe$Just(value);
					default:
						var $temp$targetKey = targetKey,
							$temp$dict = right;
						targetKey = $temp$targetKey;
						dict = $temp$dict;
						continue get;
				}
			}
		}
	});
var $elm$core$Dict$Black = {$: 'Black'};
var $elm$core$Dict$RBNode_elm_builtin = F5(
	function (a, b, c, d, e) {
		return {$: 'RBNode_elm_builtin', a: a, b: b, c: c, d: d, e: e};
	});
var $elm$core$Dict$Red = {$: 'Red'};
var $elm$core$Dict$balance = F5(
	function (color, key, value, left, right) {
		if ((right.$ === 'RBNode_elm_builtin') && (right.a.$ === 'Red')) {
			var _v1 = right.a;
			var rK = right.b;
			var rV = right.c;
			var rLeft = right.d;
			var rRight = right.e;
			if ((left.$ === 'RBNode_elm_builtin') && (left.a.$ === 'Red')) {
				var _v3 = left.a;
				var lK = left.b;
				var lV = left.c;
				var lLeft = left.d;
				var lRight = left.e;
				return A5(
					$elm$core$Dict$RBNode_elm_builtin,
					$elm$core$Dict$Red,
					key,
					value,
					A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Black, lK, lV, lLeft, lRight),
					A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Black, rK, rV, rLeft, rRight));
			} else {
				return A5(
					$elm$core$Dict$RBNode_elm_builtin,
					color,
					rK,
					rV,
					A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Red, key, value, left, rLeft),
					rRight);
			}
		} else {
			if ((((left.$ === 'RBNode_elm_builtin') && (left.a.$ === 'Red')) && (left.d.$ === 'RBNode_elm_builtin')) && (left.d.a.$ === 'Red')) {
				var _v5 = left.a;
				var lK = left.b;
				var lV = left.c;
				var _v6 = left.d;
				var _v7 = _v6.a;
				var llK = _v6.b;
				var llV = _v6.c;
				var llLeft = _v6.d;
				var llRight = _v6.e;
				var lRight = left.e;
				return A5(
					$elm$core$Dict$RBNode_elm_builtin,
					$elm$core$Dict$Red,
					lK,
					lV,
					A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Black, llK, llV, llLeft, llRight),
					A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Black, key, value, lRight, right));
			} else {
				return A5($elm$core$Dict$RBNode_elm_builtin, color, key, value, left, right);
			}
		}
	});
var $elm$core$Dict$insertHelp = F3(
	function (key, value, dict) {
		if (dict.$ === 'RBEmpty_elm_builtin') {
			return A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Red, key, value, $elm$core$Dict$RBEmpty_elm_builtin, $elm$core$Dict$RBEmpty_elm_builtin);
		} else {
			var nColor = dict.a;
			var nKey = dict.b;
			var nValue = dict.c;
			var nLeft = dict.d;
			var nRight = dict.e;
			var _v1 = A2($elm$core$Basics$compare, key, nKey);
			switch (_v1.$) {
				case 'LT':
					return A5(
						$elm$core$Dict$balance,
						nColor,
						nKey,
						nValue,
						A3($elm$core$Dict$insertHelp, key, value, nLeft),
						nRight);
				case 'EQ':
					return A5($elm$core$Dict$RBNode_elm_builtin, nColor, nKey, value, nLeft, nRight);
				default:
					return A5(
						$elm$core$Dict$balance,
						nColor,
						nKey,
						nValue,
						nLeft,
						A3($elm$core$Dict$insertHelp, key, value, nRight));
			}
		}
	});
var $elm$core$Dict$insert = F3(
	function (key, value, dict) {
		var _v0 = A3($elm$core$Dict$insertHelp, key, value, dict);
		if ((_v0.$ === 'RBNode_elm_builtin') && (_v0.a.$ === 'Red')) {
			var _v1 = _v0.a;
			var k = _v0.b;
			var v = _v0.c;
			var l = _v0.d;
			var r = _v0.e;
			return A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Black, k, v, l, r);
		} else {
			var x = _v0;
			return x;
		}
	});
var $author$project$TopicList$Model$updateBundle = F3(
	function (key, fn, state) {
		var bundle = function () {
			var _v0 = A2($elm$core$Dict$get, key, state.bundles);
			if (_v0.$ === 'Just') {
				var m = _v0.a;
				return m;
			} else {
				return $author$project$TopicList$Model$emptyBundle;
			}
		}();
		var newbundle = fn(bundle);
		return _Utils_update(
			state,
			{
				bundles: A3($elm$core$Dict$insert, key, newbundle, state.bundles)
			});
	});
var $author$project$ProfileData$Model$TopicList = {$: 'TopicList'};
var $elm$time$Time$Posix = function (a) {
	return {$: 'Posix', a: a};
};
var $elm$time$Time$millisToPosix = $elm$time$Time$Posix;
var $author$project$ProfileData$Model$emptyProfileData = {
	accepted_on: $elm$time$Time$millisToPosix(0),
	home: {bnum: $elm$core$Maybe$Nothing, page: $author$project$ProfileData$Model$TopicList, tkey: $elm$core$Maybe$Nothing},
	initials: '',
	moniker: '',
	paragraph: $elm$core$Maybe$Nothing,
	subtitle: $elm$core$Maybe$Nothing,
	thumbnail: $elm$core$Maybe$Nothing,
	title: ''
};
var $author$project$TopicList$Model$updateProfile = F3(
	function (key, fn, state) {
		var profile = function () {
			var _v0 = A2($elm$core$Dict$get, key, state.profiles);
			if (_v0.$ === 'Just') {
				var m = _v0.a;
				return m;
			} else {
				return $author$project$ProfileData$Model$emptyProfileData;
			}
		}();
		var newprofile = fn(profile);
		return _Utils_update(
			state,
			{
				profiles: A3($elm$core$Dict$insert, key, newprofile, state.profiles)
			});
	});
var $author$project$Progress$Decode$DecodeError = function (a) {
	return {$: 'DecodeError', a: a};
};
var $elm$core$Array$length = function (_v0) {
	var len = _v0.a;
	return len;
};
var $elm$core$List$partition = F2(
	function (pred, list) {
		var step = F2(
			function (x, _v0) {
				var trues = _v0.a;
				var falses = _v0.b;
				return pred(x) ? _Utils_Tuple2(
					A2($elm$core$List$cons, x, trues),
					falses) : _Utils_Tuple2(
					trues,
					A2($elm$core$List$cons, x, falses));
			});
		return A3(
			$elm$core$List$foldr,
			step,
			_Utils_Tuple2(_List_Nil, _List_Nil),
			list);
	});
var $author$project$Progress$Steps$resetFlow = F2(
	function (flows, flowname) {
		var _v0 = A2(
			$elm$core$List$partition,
			function (f) {
				return _Utils_eq(f.workflow.name, flowname);
			},
			flows);
		var found = _v0.a;
		var others = _v0.b;
		if (found.b) {
			if (!found.b.b) {
				var flow = found.a;
				var newFlow = {
					messages: _List_Nil,
					steps: A2(
						$elm$core$Array$repeat,
						$elm$core$Array$length(flow.steps),
						'init'),
					success: $elm$core$Maybe$Nothing,
					workflow: flow.workflow
				};
				return $elm$core$Result$Ok(
					A2($elm$core$List$cons, newFlow, others));
			} else {
				return $elm$core$Result$Err('Workflow name appears multiple times in flags.workflows: ' + flowname);
			}
		} else {
			return $elm$core$Result$Err('Workflow name not found in flags.workflows: ' + flowname);
		}
	});
var $elm$core$List$append = F2(
	function (xs, ys) {
		if (!ys.b) {
			return xs;
		} else {
			return A3($elm$core$List$foldr, $elm$core$List$cons, ys, xs);
		}
	});
var $author$project$Progress$Model$updateDecodeErrors = F2(
	function (incoming, state) {
		if (incoming.$ === 'DecodeError') {
			var err = incoming.a;
			return _Utils_update(
				state,
				{
					decodeErrors: A2(
						$elm$core$List$append,
						state.decodeErrors,
						_List_fromArray(
							[err]))
				});
		} else {
			return state;
		}
	});
var $elm$core$String$replace = F3(
	function (before, after, string) {
		return A2(
			$elm$core$String$join,
			after,
			A2($elm$core$String$split, before, string));
	});
var $author$project$Shared$Text$indented = function (s) {
	return '    ' + A3($elm$core$String$replace, '\n', '\n    ', s);
};
var $elm$core$String$cons = _String_cons;
var $elm$core$String$fromChar = function (_char) {
	return A2($elm$core$String$cons, _char, '');
};
var $elm$core$Bitwise$and = _Bitwise_and;
var $elm$core$Bitwise$shiftRightBy = _Bitwise_shiftRightBy;
var $elm$core$String$repeatHelp = F3(
	function (n, chunk, result) {
		return (n <= 0) ? result : A3(
			$elm$core$String$repeatHelp,
			n >> 1,
			_Utils_ap(chunk, chunk),
			(!(n & 1)) ? result : _Utils_ap(result, chunk));
	});
var $elm$core$String$repeat = F2(
	function (n, chunk) {
		return A3($elm$core$String$repeatHelp, n, chunk, '');
	});
var $elm$core$String$padLeft = F3(
	function (n, _char, string) {
		return _Utils_ap(
			A2(
				$elm$core$String$repeat,
				n - $elm$core$String$length(string),
				$elm$core$String$fromChar(_char)),
			string);
	});
var $elm$core$List$drop = F2(
	function (n, list) {
		drop:
		while (true) {
			if (n <= 0) {
				return list;
			} else {
				if (!list.b) {
					return list;
				} else {
					var x = list.a;
					var xs = list.b;
					var $temp$n = n - 1,
						$temp$list = xs;
					n = $temp$n;
					list = $temp$list;
					continue drop;
				}
			}
		}
	});
var $elm$core$List$head = function (list) {
	if (list.b) {
		var x = list.a;
		var xs = list.b;
		return $elm$core$Maybe$Just(x);
	} else {
		return $elm$core$Maybe$Nothing;
	}
};
var $author$project$Progress$Steps$stepMessage = F3(
	function (flow, idx, stepstatus) {
		var _v0 = $elm$core$List$head(
			A2($elm$core$List$drop, idx, flow.workflow.progress));
		if (_v0.$ === 'Nothing') {
			return '<< unknown step >>';
		} else {
			var progobj = _v0.a;
			switch (stepstatus) {
				case 'ok':
					return progobj.messages.ok;
				case 'error':
					return progobj.messages.error;
				default:
					return '';
			}
		}
	});
var $author$project$Progress$Steps$stepLog = F3(
	function (flow, step, stepstatus) {
		var padstep = A3(
			$elm$core$String$padLeft,
			2,
			_Utils_chr(' '),
			$elm$core$String$fromInt(step));
		var message = A3($author$project$Progress$Steps$stepMessage, flow, step - 1, stepstatus);
		var line = padstep + ('. ' + message);
		switch (stepstatus) {
			case 'ok':
				return _List_fromArray(
					[line]);
			case 'error':
				return _List_fromArray(
					[line]);
			default:
				return _List_Nil;
		}
	});
var $elm_community$maybe_extra$Maybe$Extra$cons = F2(
	function (item, list) {
		if (item.$ === 'Just') {
			var v = item.a;
			return A2($elm$core$List$cons, v, list);
		} else {
			return list;
		}
	});
var $elm_community$maybe_extra$Maybe$Extra$values = A2($elm$core$List$foldr, $elm_community$maybe_extra$Maybe$Extra$cons, _List_Nil);
var $author$project$Progress$Model$updateDetail = F2(
	function (incoming, state) {
		var _v0 = state.flows;
		if (!_v0.b) {
			return state;
		} else {
			var flow = _v0.a;
			var tail = _v0.b;
			var up = function (strs) {
				var newFlow = _Utils_update(
					flow,
					{
						messages: A2($elm$core$List$append, flow.messages, strs)
					});
				return _Utils_update(
					state,
					{
						flows: A2($elm$core$List$cons, newFlow, tail)
					});
			};
			switch (incoming.$) {
				case 'InternalError':
					var mstep = incoming.a;
					var detail = incoming.b;
					return up(
						_List_fromArray(
							[detail]));
				case 'BadRequest':
					var step = incoming.a;
					var detail = incoming.b;
					return up(
						_List_fromArray(
							[detail]));
				case 'StepProgress':
					var step = incoming.a;
					var stepstatus = incoming.b;
					var mdetail = incoming.c;
					var logmsg = A3($author$project$Progress$Steps$stepLog, flow, step, stepstatus);
					var details = A2(
						$elm$core$List$map,
						$author$project$Shared$Text$indented,
						$elm_community$maybe_extra$Maybe$Extra$values(
							_List_fromArray(
								[mdetail])));
					return up(
						_Utils_ap(logmsg, details));
				case 'Notice':
					var notice = incoming.a;
					return up(
						_List_fromArray(
							[
								$author$project$Shared$Text$indented(notice)
							]));
				case 'Error':
					var error = incoming.a;
					return up(
						_List_fromArray(
							[
								$author$project$Shared$Text$indented(error)
							]));
				default:
					return state;
			}
		}
	});
var $elm$core$Bitwise$shiftRightZfBy = _Bitwise_shiftRightZfBy;
var $elm$core$Array$bitMask = 4294967295 >>> (32 - $elm$core$Array$shiftStep);
var $elm$core$Basics$ge = _Utils_ge;
var $elm$core$Elm$JsArray$unsafeGet = _JsArray_unsafeGet;
var $elm$core$Elm$JsArray$unsafeSet = _JsArray_unsafeSet;
var $elm$core$Array$setHelp = F4(
	function (shift, index, value, tree) {
		var pos = $elm$core$Array$bitMask & (index >>> shift);
		var _v0 = A2($elm$core$Elm$JsArray$unsafeGet, pos, tree);
		if (_v0.$ === 'SubTree') {
			var subTree = _v0.a;
			var newSub = A4($elm$core$Array$setHelp, shift - $elm$core$Array$shiftStep, index, value, subTree);
			return A3(
				$elm$core$Elm$JsArray$unsafeSet,
				pos,
				$elm$core$Array$SubTree(newSub),
				tree);
		} else {
			var values = _v0.a;
			var newLeaf = A3($elm$core$Elm$JsArray$unsafeSet, $elm$core$Array$bitMask & index, value, values);
			return A3(
				$elm$core$Elm$JsArray$unsafeSet,
				pos,
				$elm$core$Array$Leaf(newLeaf),
				tree);
		}
	});
var $elm$core$Bitwise$shiftLeftBy = _Bitwise_shiftLeftBy;
var $elm$core$Array$tailIndex = function (len) {
	return (len >>> 5) << 5;
};
var $elm$core$Array$set = F3(
	function (index, value, array) {
		var len = array.a;
		var startShift = array.b;
		var tree = array.c;
		var tail = array.d;
		return ((index < 0) || (_Utils_cmp(index, len) > -1)) ? array : ((_Utils_cmp(
			index,
			$elm$core$Array$tailIndex(len)) > -1) ? A4(
			$elm$core$Array$Array_elm_builtin,
			len,
			startShift,
			tree,
			A3($elm$core$Elm$JsArray$unsafeSet, $elm$core$Array$bitMask & index, value, tail)) : A4(
			$elm$core$Array$Array_elm_builtin,
			len,
			startShift,
			A4($elm$core$Array$setHelp, startShift, index, value, tree),
			tail));
	});
var $author$project$Progress$Steps$updateFlowSteps = F4(
	function (flows, step, stepstatus, forcefail) {
		if (!flows.b) {
			return flows;
		} else {
			var head = flows.a;
			var tail = flows.b;
			var newhead = _Utils_update(
				head,
				{
					steps: A3($elm$core$Array$set, step - 1, stepstatus, head.steps),
					success: forcefail ? $elm$core$Maybe$Just(false) : head.success
				});
			return A2($elm$core$List$cons, newhead, tail);
		}
	});
var $author$project$Progress$Steps$updateFlowSuccess = F2(
	function (flows, success) {
		if (!flows.b) {
			return flows;
		} else {
			var head = flows.a;
			var tail = flows.b;
			var newhead = _Utils_update(
				head,
				{success: success});
			return A2($elm$core$List$cons, newhead, tail);
		}
	});
var $author$project$Progress$Model$updateProgress = F2(
	function (incoming, state) {
		var up = F4(
			function (mstep, stepstatus, expand, forcefail) {
				if (mstep.$ === 'Just') {
					var step = mstep.a;
					return _Utils_update(
						state,
						{
							expanded: expand,
							flows: A4($author$project$Progress$Steps$updateFlowSteps, state.flows, step, stepstatus, forcefail)
						});
				} else {
					return state;
				}
			});
		switch (incoming.$) {
			case 'InternalError':
				var mstep = incoming.a;
				var detail = incoming.b;
				return A4(up, mstep, 'error', true, true);
			case 'BadRequest':
				var step = incoming.a;
				var detail = incoming.b;
				return A4(
					up,
					$elm$core$Maybe$Just(step),
					'error',
					true,
					true);
			case 'StepProgress':
				var step = incoming.a;
				var stepstatus = incoming.b;
				var mdetail = incoming.c;
				var expand = function () {
					if (stepstatus === 'error') {
						return true;
					} else {
						return state.expanded;
					}
				}();
				return A4(
					up,
					$elm$core$Maybe$Just(step),
					stepstatus,
					expand,
					false);
			case 'Finished':
				var mdetail = incoming.a;
				if (mdetail.$ === 'Nothing') {
					return _Utils_update(
						state,
						{
							flows: A2(
								$author$project$Progress$Steps$updateFlowSuccess,
								state.flows,
								$elm$core$Maybe$Just(true))
						});
				} else {
					return _Utils_update(
						state,
						{
							expanded: true,
							flows: A2(
								$author$project$Progress$Steps$updateFlowSuccess,
								state.flows,
								$elm$core$Maybe$Just(false))
						});
				}
			default:
				return state;
		}
	});
var $elm$json$Json$Decode$andThen = _Json_andThen;
var $author$project$Progress$Decode$BadRequest = F2(
	function (a, b) {
		return {$: 'BadRequest', a: a, b: b};
	});
var $author$project$Progress$Decode$Cancelled = {$: 'Cancelled'};
var $author$project$Progress$Decode$Error = function (a) {
	return {$: 'Error', a: a};
};
var $author$project$Progress$Decode$Finished = function (a) {
	return {$: 'Finished', a: a};
};
var $author$project$Progress$Decode$InternalError = F2(
	function (a, b) {
		return {$: 'InternalError', a: a, b: b};
	});
var $author$project$Progress$Decode$NotRunning = {$: 'NotRunning'};
var $author$project$Progress$Decode$Notice = function (a) {
	return {$: 'Notice', a: a};
};
var $author$project$Progress$Decode$Reset = function (a) {
	return {$: 'Reset', a: a};
};
var $author$project$Progress$Decode$Running = {$: 'Running'};
var $author$project$Progress$Decode$StepProgress = F3(
	function (a, b, c) {
		return {$: 'StepProgress', a: a, b: b, c: c};
	});
var $elm$json$Json$Decode$fail = _Json_fail;
var $elm$json$Json$Decode$int = _Json_decodeInt;
var $elm$json$Json$Decode$oneOf = _Json_oneOf;
var $elm$json$Json$Decode$maybe = function (decoder) {
	return $elm$json$Json$Decode$oneOf(
		_List_fromArray(
			[
				A2($elm$json$Json$Decode$map, $elm$core$Maybe$Just, decoder),
				$elm$json$Json$Decode$succeed($elm$core$Maybe$Nothing)
			]));
};
var $author$project$Progress$Decode$progressMsgDecoderByMsg = function (msg) {
	switch (msg) {
		case 'reset':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Progress$Decode$Reset,
				A2($elm$json$Json$Decode$field, 'flowname', $elm$json$Json$Decode$string));
		case 'internal server error':
			return A3(
				$elm$json$Json$Decode$map2,
				$author$project$Progress$Decode$InternalError,
				$elm$json$Json$Decode$maybe(
					A2($elm$json$Json$Decode$field, 'step', $elm$json$Json$Decode$int)),
				A2($elm$json$Json$Decode$field, 'details', $elm$json$Json$Decode$string));
		case 'bad request':
			return A3(
				$elm$json$Json$Decode$map2,
				$author$project$Progress$Decode$BadRequest,
				A2($elm$json$Json$Decode$field, 'step', $elm$json$Json$Decode$int),
				A2($elm$json$Json$Decode$field, 'details', $elm$json$Json$Decode$string));
		case 'running':
			return $elm$json$Json$Decode$succeed($author$project$Progress$Decode$Running);
		case 'not running':
			return $elm$json$Json$Decode$succeed($author$project$Progress$Decode$NotRunning);
		case 'cancelled':
			return $elm$json$Json$Decode$succeed($author$project$Progress$Decode$Cancelled);
		case 'progress':
			return A4(
				$elm$json$Json$Decode$map3,
				$author$project$Progress$Decode$StepProgress,
				A2($elm$json$Json$Decode$field, 'step', $elm$json$Json$Decode$int),
				A2($elm$json$Json$Decode$field, 'status', $elm$json$Json$Decode$string),
				$elm$json$Json$Decode$maybe(
					A2($elm$json$Json$Decode$field, 'details', $elm$json$Json$Decode$string)));
		case 'notice':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Progress$Decode$Notice,
				A2($elm$json$Json$Decode$field, 'notice', $elm$json$Json$Decode$string));
		case 'error':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Progress$Decode$Error,
				A2($elm$json$Json$Decode$field, 'error', $elm$json$Json$Decode$string));
		case 'decode error':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Progress$Decode$DecodeError,
				A2($elm$json$Json$Decode$field, 'error', $elm$json$Json$Decode$string));
		case 'finished':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Progress$Decode$Finished,
				$elm$json$Json$Decode$maybe(
					A2($elm$json$Json$Decode$field, 'error', $elm$json$Json$Decode$string)));
		default:
			var other = msg;
			return $elm$json$Json$Decode$fail(other);
	}
};
var $author$project$Progress$Decode$progressMsgDecoder = A2(
	$elm$json$Json$Decode$andThen,
	$author$project$Progress$Decode$progressMsgDecoderByMsg,
	A2($elm$json$Json$Decode$field, 'msg', $elm$json$Json$Decode$string));
var $author$project$Progress$Decode$valueToProgressMsg = function (value) {
	return A2(
		$elm$core$Result$mapError,
		$elm$json$Json$Decode$errorToString,
		A2($elm$json$Json$Decode$decodeValue, $author$project$Progress$Decode$progressMsgDecoder, value));
};
var $author$project$Progress$Model$update = F3(
	function (flags, state, msg) {
		switch (msg.$) {
			case 'ToggleProgressExpanded':
				var newstate = _Utils_update(
					state,
					{expanded: !state.expanded});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			case 'SelectTab':
				var active = msg.a;
				var newstate = _Utils_update(
					state,
					{active: active});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			case 'DecodeErr':
				var err = msg.a;
				var newstate = A2(
					$author$project$Progress$Model$updateDecodeErrors,
					$author$project$Progress$Decode$DecodeError(err),
					state);
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			default:
				var value = msg.a;
				var _v1 = $author$project$Progress$Decode$valueToProgressMsg(value);
				if (_v1.$ === 'Err') {
					var err = _v1.a;
					return A2($author$project$Shared$Cmd$cmdLog, err, state);
				} else {
					if (_v1.a.$ === 'Reset') {
						var flowname = _v1.a.a;
						var _v2 = A2($author$project$Progress$Steps$resetFlow, state.flows, flowname);
						if (_v2.$ === 'Err') {
							var err = _v2.a;
							return A2($author$project$Shared$Cmd$cmdLog, err, state);
						} else {
							var newFlows = _v2.a;
							var newstate = _Utils_update(
								state,
								{active: 0, flows: newFlows});
							return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
						}
					} else {
						var incoming = _v1.a;
						var newstate = A2(
							$author$project$Progress$Model$updateDecodeErrors,
							incoming,
							A2(
								$author$project$Progress$Model$updateDetail,
								incoming,
								A2($author$project$Progress$Model$updateProgress, incoming, state)));
						return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
					}
				}
		}
	});
var $author$project$TopicList$updateStateCmds = F3(
	function (flags, state, cmds) {
		return _Utils_Tuple2(
			A2($author$project$TopicList$Model$Loaded, flags, state),
			cmds);
	});
var $author$project$TopicList$updateProgress = F3(
	function (flags, state, pmsg) {
		var _v0 = A3(
			$author$project$Progress$Model$update,
			$author$project$TopicList$progressFlags(flags),
			state.progress,
			pmsg);
		var pstate = _v0.a;
		var pcmds = _v0.b;
		return A3(
			$author$project$TopicList$updateStateCmds,
			flags,
			_Utils_update(
				state,
				{progress: pstate}),
			$author$project$TopicList$progressCmds(pcmds));
	});
var $author$project$TopicList$updateState = F2(
	function (flags, state) {
		return A3($author$project$TopicList$updateStateCmds, flags, state, $elm$core$Platform$Cmd$none);
	});
var $author$project$TopicList$Model$emptyTopic = {data: $elm$core$Maybe$Nothing, expanded: false};
var $author$project$TopicList$Model$updateTopic = F3(
	function (tkey, fn, state) {
		var topic = function () {
			var _v0 = A2($elm$core$Dict$get, tkey, state.topics);
			if (_v0.$ === 'Just') {
				var m = _v0.a;
				return m;
			} else {
				return $author$project$TopicList$Model$emptyTopic;
			}
		}();
		var newtopic = fn(topic);
		return _Utils_update(
			state,
			{
				topics: A3($elm$core$Dict$insert, tkey, newtopic, state.topics)
			});
	});
var $author$project$TopicList$Decode$IncomingTopicData = F2(
	function (a, b) {
		return {$: 'IncomingTopicData', a: a, b: b};
	});
var $author$project$TopicList$Decode$IncomingAuth = function (a) {
	return {$: 'IncomingAuth', a: a};
};
var $author$project$TopicList$Decode$IncomingBundleData = F3(
	function (a, b, c) {
		return {$: 'IncomingBundleData', a: a, b: b, c: c};
	});
var $author$project$TopicList$Decode$IncomingError = function (a) {
	return {$: 'IncomingError', a: a};
};
var $author$project$TopicList$Decode$IncomingProfileData = F2(
	function (a, b) {
		return {$: 'IncomingProfileData', a: a, b: b};
	});
var $author$project$TopicList$Decode$Progress = function (a) {
	return {$: 'Progress', a: a};
};
var $author$project$Auth$Model$Auth = F4(
	function (mnum, username, unchanged, role) {
		return {mnum: mnum, role: role, unchanged: unchanged, username: username};
	});
var $author$project$MemberData$Model$Guest = {$: 'Guest'};
var $author$project$MemberData$Model$Host = {$: 'Host'};
var $author$project$MemberData$Model$Removed = {$: 'Removed'};
var $author$project$MemberData$Decode$roleDecoder = A2(
	$elm$json$Json$Decode$andThen,
	function (role) {
		switch (role) {
			case 'host':
				return $elm$json$Json$Decode$succeed($author$project$MemberData$Model$Host);
			case 'guest':
				return $elm$json$Json$Decode$succeed($author$project$MemberData$Model$Guest);
			case 'removed':
				return $elm$json$Json$Decode$succeed($author$project$MemberData$Model$Removed);
			default:
				var other = role;
				return $elm$json$Json$Decode$fail(other);
		}
	},
	$elm$json$Json$Decode$string);
var $author$project$Auth$Decode$authDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$Auth$Model$Auth,
	A2($elm$json$Json$Decode$field, 'mnum', $elm$json$Json$Decode$int),
	A2($elm$json$Json$Decode$field, 'username', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'unchanged', $elm$json$Json$Decode$bool),
	A2($elm$json$Json$Decode$field, 'role', $author$project$MemberData$Decode$roleDecoder));
var $author$project$BundleData$Model$BundleData = F4(
	function (name, description, restricted, shared_with) {
		return {description: description, name: name, restricted: restricted, shared_with: shared_with};
	});
var $author$project$BundleData$Decode$bundleDataDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$BundleData$Model$BundleData,
	A2($elm$json$Json$Decode$field, 'name', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'restricted', $elm$json$Json$Decode$bool),
	A2(
		$elm$json$Json$Decode$field,
		'shared_with',
		$elm$json$Json$Decode$list($elm$json$Json$Decode$int)));
var $author$project$BundleStats$Model$BundleStats = F4(
	function (mount, folders, files, size) {
		return {files: files, folders: folders, mount: mount, size: size};
	});
var $elm$json$Json$Decode$float = _Json_decodeFloat;
var $author$project$BundleStats$Decode$bundleStatsDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$BundleStats$Model$BundleStats,
	A2($elm$json$Json$Decode$field, 'mount', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'folders', $elm$json$Json$Decode$int),
	A2($elm$json$Json$Decode$field, 'files', $elm$json$Json$Decode$int),
	A2($elm$json$Json$Decode$field, 'size', $elm$json$Json$Decode$float));
var $author$project$ProfileData$Model$ProfileData = F8(
	function (thumbnail, initials, title, subtitle, paragraph, moniker, accepted_on, home) {
		return {accepted_on: accepted_on, home: home, initials: initials, moniker: moniker, paragraph: paragraph, subtitle: subtitle, thumbnail: thumbnail, title: title};
	});
var $author$project$ProfileData$Model$Bundle = {$: 'Bundle'};
var $author$project$ProfileData$Decode$decodeHomePageBundleByKind = function (kind) {
	if (kind === 'home bundle') {
		return A2(
			$elm$json$Json$Decode$map,
			function (bnum) {
				return {
					bnum: $elm$core$Maybe$Just(bnum),
					page: $author$project$ProfileData$Model$Bundle,
					tkey: $elm$core$Maybe$Nothing
				};
			},
			A2($elm$json$Json$Decode$field, 'bnum', $elm$json$Json$Decode$int));
	} else {
		var other = kind;
		return $elm$json$Json$Decode$fail(other);
	}
};
var $author$project$ProfileData$Decode$decodeHomePageBundle = A2(
	$elm$json$Json$Decode$andThen,
	$author$project$ProfileData$Decode$decodeHomePageBundleByKind,
	A2($elm$json$Json$Decode$field, 'kind', $elm$json$Json$Decode$string));
var $author$project$ProfileData$Model$Topic = {$: 'Topic'};
var $author$project$ProfileData$Decode$decodeHomePageTopicByKind = function (kind) {
	if (kind === 'home topic') {
		return A2(
			$elm$json$Json$Decode$map,
			function (tkey) {
				return {
					bnum: $elm$core$Maybe$Nothing,
					page: $author$project$ProfileData$Model$Topic,
					tkey: $elm$core$Maybe$Just(tkey)
				};
			},
			A2($elm$json$Json$Decode$field, 'tkey', $elm$json$Json$Decode$string));
	} else {
		var other = kind;
		return $elm$json$Json$Decode$fail(other);
	}
};
var $author$project$ProfileData$Decode$decodeHomePageTopic = A2(
	$elm$json$Json$Decode$andThen,
	$author$project$ProfileData$Decode$decodeHomePageTopicByKind,
	A2($elm$json$Json$Decode$field, 'kind', $elm$json$Json$Decode$string));
var $author$project$ProfileData$Decode$decodeHomePageTopicList = $elm$json$Json$Decode$succeed(
	{bnum: $elm$core$Maybe$Nothing, page: $author$project$ProfileData$Model$TopicList, tkey: $elm$core$Maybe$Nothing});
var $author$project$Shared$Time$decodeTime = A2(
	$elm$json$Json$Decode$andThen,
	function (ms) {
		return $elm$json$Json$Decode$succeed(
			$elm$time$Time$millisToPosix(ms));
	},
	$elm$json$Json$Decode$int);
var $author$project$ProfileData$Decode$profileDataDecoder = A9(
	$elm$json$Json$Decode$map8,
	$author$project$ProfileData$Model$ProfileData,
	$elm$json$Json$Decode$maybe(
		A2($elm$json$Json$Decode$field, 'thumbnail', $elm$json$Json$Decode$string)),
	A2($elm$json$Json$Decode$field, 'initials', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'title', $elm$json$Json$Decode$string),
	$elm$json$Json$Decode$maybe(
		A2($elm$json$Json$Decode$field, 'subtitle', $elm$json$Json$Decode$string)),
	$elm$json$Json$Decode$maybe(
		A2($elm$json$Json$Decode$field, 'paragraph', $elm$json$Json$Decode$string)),
	A2($elm$json$Json$Decode$field, 'moniker', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'accepted_on', $author$project$Shared$Time$decodeTime),
	$elm$json$Json$Decode$oneOf(
		_List_fromArray(
			[
				A2($elm$json$Json$Decode$field, 'home', $author$project$ProfileData$Decode$decodeHomePageTopic),
				A2($elm$json$Json$Decode$field, 'home', $author$project$ProfileData$Decode$decodeHomePageBundle),
				$author$project$ProfileData$Decode$decodeHomePageTopicList
			])));
var $author$project$TopicData$Model$TopicData = F3(
	function (creator, details, bundles) {
		return {bundles: bundles, creator: creator, details: details};
	});
var $author$project$TopicData$Model$TopicBundle = F2(
	function (bnum, include) {
		return {bnum: bnum, include: include};
	});
var $author$project$TopicData$Decode$topicBundleDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$TopicData$Model$TopicBundle,
	A2($elm$json$Json$Decode$field, 'bnum', $elm$json$Json$Decode$int),
	A2($elm$json$Json$Decode$field, 'include', $elm$json$Json$Decode$bool));
var $author$project$TopicData$Model$TopicDetails = F3(
	function (title, description, path) {
		return {description: description, path: path, title: title};
	});
var $author$project$TopicData$Decode$topicDetailsDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$TopicData$Model$TopicDetails,
	A2($elm$json$Json$Decode$field, 'title', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'path', $elm$json$Json$Decode$string));
var $author$project$TopicData$Decode$topicDataDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$TopicData$Model$TopicData,
	$elm$json$Json$Decode$succeed($elm$core$Maybe$Nothing),
	A2($elm$json$Json$Decode$field, 'details', $author$project$TopicData$Decode$topicDetailsDecoder),
	A2(
		$elm$json$Json$Decode$field,
		'bundles',
		$elm$json$Json$Decode$list($author$project$TopicData$Decode$topicBundleDecoder)));
var $author$project$TopicList$Decode$incomingMsgDecoderByMsg = function (msg) {
	switch (msg) {
		case 'error':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$TopicList$Decode$IncomingError,
				A2($elm$json$Json$Decode$field, 'details', $elm$json$Json$Decode$string));
		case 'auth':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$TopicList$Decode$IncomingAuth,
				A2($elm$json$Json$Decode$field, 'auth', $author$project$Auth$Decode$authDecoder));
		case 'topic info':
			return A3(
				$elm$json$Json$Decode$map2,
				$author$project$TopicList$Decode$IncomingTopicData,
				A2($elm$json$Json$Decode$field, 'tkey', $elm$json$Json$Decode$string),
				A2($elm$json$Json$Decode$field, 'topic', $author$project$TopicData$Decode$topicDataDecoder));
		case 'bundle info':
			return A4(
				$elm$json$Json$Decode$map3,
				$author$project$TopicList$Decode$IncomingBundleData,
				A2($elm$json$Json$Decode$field, 'bnum', $elm$json$Json$Decode$int),
				A2($elm$json$Json$Decode$field, 'bundle', $author$project$BundleData$Decode$bundleDataDecoder),
				A2($elm$json$Json$Decode$field, 'stats', $author$project$BundleStats$Decode$bundleStatsDecoder));
		case 'profile info':
			return A3(
				$elm$json$Json$Decode$map2,
				$author$project$TopicList$Decode$IncomingProfileData,
				A2($elm$json$Json$Decode$field, 'mnum', $elm$json$Json$Decode$int),
				A2($elm$json$Json$Decode$field, 'profile', $author$project$ProfileData$Decode$profileDataDecoder));
		case 'progress':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$TopicList$Decode$Progress,
				A2($elm$json$Json$Decode$field, 'progress', $elm$json$Json$Decode$value));
		default:
			var other = msg;
			return $elm$json$Json$Decode$fail(other);
	}
};
var $author$project$TopicList$Decode$incomingMsgDecoder = A2(
	$elm$json$Json$Decode$andThen,
	$author$project$TopicList$Decode$incomingMsgDecoderByMsg,
	A2($elm$json$Json$Decode$field, 'msg', $elm$json$Json$Decode$string));
var $elm$regex$Regex$find = _Regex_findAtMost(_Regex_infinity);
var $author$project$TopicData$Model$topicCreatorRegex = A2(
	$elm$core$Maybe$withDefault,
	$elm$regex$Regex$never,
	$elm$regex$Regex$fromString('^([0-9]+)'));
var $author$project$TopicData$Model$topicCreator = function (tkey) {
	var _v0 = A2($elm$regex$Regex$find, $author$project$TopicData$Model$topicCreatorRegex, tkey);
	if (_v0.b && (!_v0.b.b)) {
		var match = _v0.a;
		return $elm$core$String$toInt(match.match);
	} else {
		return $elm$core$Maybe$Nothing;
	}
};
var $author$project$TopicData$Model$setCreator = F2(
	function (tkey, topic) {
		return _Utils_update(
			topic,
			{
				creator: $author$project$TopicData$Model$topicCreator(tkey)
			});
	});
var $author$project$TopicList$Decode$valueToIncomingMsg = function (value) {
	var _v0 = A2(
		$elm$core$Result$mapError,
		$elm$json$Json$Decode$errorToString,
		A2($elm$json$Json$Decode$decodeValue, $author$project$TopicList$Decode$incomingMsgDecoder, value));
	if ((_v0.$ === 'Ok') && (_v0.a.$ === 'IncomingTopicData')) {
		var _v1 = _v0.a;
		var tkey = _v1.a;
		var data = _v1.b;
		return $elm$core$Result$Ok(
			A2(
				$author$project$TopicList$Decode$IncomingTopicData,
				tkey,
				A2($author$project$TopicData$Model$setCreator, tkey, data)));
	} else {
		var other = _v0;
		return other;
	}
};
var $author$project$TopicList$update = F2(
	function (msg, model) {
		var _v0 = _Utils_Tuple2(model, msg);
		if (_v0.a.$ === 'Failed') {
			return _Utils_Tuple2(model, $elm$core$Platform$Cmd$none);
		} else {
			switch (_v0.b.$) {
				case 'UpdateFilter':
					var _v1 = _v0.a;
					var flags = _v1.a;
					var state = _v1.b;
					var value = _v0.b.a;
					return A2(
						$author$project$TopicList$updateState,
						flags,
						_Utils_update(
							state,
							{filter: value, response: $krisajenkins$remotedata$RemoteData$NotAsked}));
				case 'UpdateShowExample':
					var _v2 = _v0.a;
					var flags = _v2.a;
					var state = _v2.b;
					var value = _v0.b.a;
					return A2(
						$author$project$TopicList$updateState,
						flags,
						_Utils_update(
							state,
							{response: $krisajenkins$remotedata$RemoteData$NotAsked, show_example: value}));
				case 'PressAddTopic':
					var _v3 = _v0.a;
					var flags = _v3.a;
					var state = _v3.b;
					var _v4 = _v0.b;
					return A2($author$project$Shared$Cmd$cmdTransition, flags.extra.topiclistView.transitions.add, model);
				case 'PressAccept':
					var _v5 = _v0.a;
					var flags = _v5.a;
					var state = _v5.b;
					var _v6 = _v0.b;
					return A2($author$project$Shared$Cmd$cmdTransition, flags.extra.topiclistView.transitions.accept, model);
				case 'ProgressMsg':
					var _v7 = _v0.a;
					var flags = _v7.a;
					var state = _v7.b;
					var pmsg = _v0.b.a;
					return A3($author$project$TopicList$updateProgress, flags, state, pmsg);
				case 'ToggleExpanded':
					var _v8 = _v0.a;
					var flags = _v8.a;
					var state = _v8.b;
					var key = _v0.b.a;
					var newstate = A3(
						$author$project$TopicList$Model$updateTopic,
						key,
						function (m) {
							return _Utils_update(
								m,
								{expanded: !m.expanded});
						},
						state);
					return A2(
						$author$project$TopicList$updateState,
						flags,
						_Utils_update(
							newstate,
							{response: $krisajenkins$remotedata$RemoteData$NotAsked}));
				case 'PressDetails':
					var _v9 = _v0.a;
					var flags = _v9.a;
					var state = _v9.b;
					var key = _v0.b.a;
					return A3($author$project$Shared$Cmd$cmdTransitionString, flags.extra.topiclistView.transitions.details, key, model);
				default:
					var _v10 = _v0.a;
					var flags = _v10.a;
					var state = _v10.b;
					var v = _v0.b.a;
					var _v11 = $author$project$TopicList$Decode$valueToIncomingMsg(v);
					if (_v11.$ === 'Err') {
						var err = _v11.a;
						return $author$project$Shared$Reg$decodeErr(err) ? A3(
							$author$project$TopicList$updateProgress,
							flags,
							state,
							$author$project$Progress$Model$DecodeErr(err)) : A2($author$project$Shared$Cmd$cmdLog, 'Err ' + err, model);
					} else {
						switch (_v11.a.$) {
							case 'IncomingError':
								var err = _v11.a.a;
								return A2(
									$author$project$TopicList$updateState,
									flags,
									_Utils_update(
										state,
										{
											response: $krisajenkins$remotedata$RemoteData$Failure(err)
										}));
							case 'IncomingAuth':
								var auth = _v11.a.a;
								return A2(
									$author$project$TopicList$updateState,
									flags,
									_Utils_update(
										state,
										{
											auth: $krisajenkins$remotedata$RemoteData$Success(auth)
										}));
							case 'IncomingTopicData':
								var _v12 = _v11.a;
								var tkey = _v12.a;
								var data = _v12.b;
								var newstate = A3(
									$author$project$TopicList$Model$updateTopic,
									tkey,
									function (t) {
										return _Utils_update(
											t,
											{
												data: $elm$core$Maybe$Just(data)
											});
									},
									state);
								return A2($author$project$TopicList$updateState, flags, newstate);
							case 'IncomingBundleData':
								var _v13 = _v11.a;
								var key = _v13.a;
								var data = _v13.b;
								var stats = _v13.c;
								var newstate = A3(
									$author$project$TopicList$Model$updateBundle,
									key,
									function (b) {
										return _Utils_update(
											b,
											{
												bundle_stats: $elm$core$Maybe$Just(stats),
												data: $elm$core$Maybe$Just(data)
											});
									},
									state);
								return A2($author$project$TopicList$updateState, flags, newstate);
							case 'IncomingProfileData':
								var _v14 = _v11.a;
								var key = _v14.a;
								var data = _v14.b;
								var newstate = A3(
									$author$project$TopicList$Model$updateProfile,
									key,
									function (_v15) {
										return data;
									},
									state);
								return A2($author$project$TopicList$updateState, flags, newstate);
							default:
								var value = _v11.a.a;
								return A3(
									$author$project$TopicList$updateProgress,
									flags,
									state,
									$author$project$Progress$Model$Incoming(value));
						}
					}
			}
		}
	});
var $elm$json$Json$Encode$string = _Json_wrap;
var $elm$html$Html$Attributes$stringProperty = F2(
	function (key, string) {
		return A2(
			_VirtualDom_property,
			key,
			$elm$json$Json$Encode$string(string));
	});
var $elm$html$Html$Attributes$class = $elm$html$Html$Attributes$stringProperty('className');
var $author$project$TopicList$currentView = 0;
var $elm$html$Html$div = _VirtualDom_node('div');
var $elm$virtual_dom$VirtualDom$map = _VirtualDom_map;
var $elm$html$Html$map = $elm$virtual_dom$VirtualDom$map;
var $elm$html$Html$p = _VirtualDom_node('p');
var $elm$virtual_dom$VirtualDom$text = _VirtualDom_text;
var $elm$html$Html$text = $elm$virtual_dom$VirtualDom$text;
var $author$project$Progress$Model$ToggleProgressExpanded = {$: 'ToggleProgressExpanded'};
var $elm$html$Html$br = _VirtualDom_node('br');
var $elm_community$list_extra$List$Extra$dropWhile = F2(
	function (predicate, list) {
		dropWhile:
		while (true) {
			if (!list.b) {
				return _List_Nil;
			} else {
				var x = list.a;
				var xs = list.b;
				if (predicate(x)) {
					var $temp$predicate = predicate,
						$temp$list = xs;
					predicate = $temp$predicate;
					list = $temp$list;
					continue dropWhile;
				} else {
					return list;
				}
			}
		}
	});
var $elm$html$Html$h3 = _VirtualDom_node('h3');
var $elm$core$Elm$JsArray$foldl = _JsArray_foldl;
var $elm$core$Elm$JsArray$indexedMap = _JsArray_indexedMap;
var $elm$core$Array$indexedMap = F2(
	function (func, _v0) {
		var len = _v0.a;
		var tree = _v0.c;
		var tail = _v0.d;
		var initialBuilder = {
			nodeList: _List_Nil,
			nodeListSize: 0,
			tail: A3(
				$elm$core$Elm$JsArray$indexedMap,
				func,
				$elm$core$Array$tailIndex(len),
				tail)
		};
		var helper = F2(
			function (node, builder) {
				if (node.$ === 'SubTree') {
					var subTree = node.a;
					return A3($elm$core$Elm$JsArray$foldl, helper, builder, subTree);
				} else {
					var leaf = node.a;
					var offset = builder.nodeListSize * $elm$core$Array$branchFactor;
					var mappedLeaf = $elm$core$Array$Leaf(
						A3($elm$core$Elm$JsArray$indexedMap, func, offset, leaf));
					return {
						nodeList: A2($elm$core$List$cons, mappedLeaf, builder.nodeList),
						nodeListSize: builder.nodeListSize + 1,
						tail: builder.tail
					};
				}
			});
		return A2(
			$elm$core$Array$builderToArray,
			true,
			A3($elm$core$Elm$JsArray$foldl, helper, initialBuilder, tree));
	});
var $elm$virtual_dom$VirtualDom$Normal = function (a) {
	return {$: 'Normal', a: a};
};
var $elm$virtual_dom$VirtualDom$on = _VirtualDom_on;
var $elm$html$Html$Events$on = F2(
	function (event, decoder) {
		return A2(
			$elm$virtual_dom$VirtualDom$on,
			event,
			$elm$virtual_dom$VirtualDom$Normal(decoder));
	});
var $elm$html$Html$Events$onClick = function (msg) {
	return A2(
		$elm$html$Html$Events$on,
		'click',
		$elm$json$Json$Decode$succeed(msg));
};
var $elm$html$Html$pre = _VirtualDom_node('pre');
var $elm$virtual_dom$VirtualDom$style = _VirtualDom_style;
var $elm$html$Html$Attributes$style = $elm$virtual_dom$VirtualDom$style;
var $elm$svg$Svg$Attributes$class = _VirtualDom_attribute('class');
var $elm$svg$Svg$Attributes$d = _VirtualDom_attribute('d');
var $elm$virtual_dom$VirtualDom$node = function (tag) {
	return _VirtualDom_node(
		_VirtualDom_noScript(tag));
};
var $elm$html$Html$node = $elm$virtual_dom$VirtualDom$node;
var $elm$svg$Svg$trustedNode = _VirtualDom_nodeNS('http://www.w3.org/2000/svg');
var $elm$svg$Svg$path = $elm$svg$Svg$trustedNode('path');
var $elm$svg$Svg$svg = $elm$svg$Svg$trustedNode('svg');
var $elm$svg$Svg$Attributes$viewBox = _VirtualDom_attribute('viewBox');
var $author$project$Shared$Expand$svgExpandCollapse = function (open) {
	var stylenode = A3(
		$elm$html$Html$node,
		'style',
		_List_Nil,
		_List_fromArray(
			[
				$elm$html$Html$text('\npath {\n  fill: black;\n}\n@media (prefers-color-scheme: dark) {\n  path { fill: white; }\n}\n                             ')
			]));
	return open ? A2(
		$elm$svg$Svg$svg,
		_List_fromArray(
			[
				$elm$svg$Svg$Attributes$class('ionicon'),
				$elm$svg$Svg$Attributes$viewBox('0 0 512 512')
			]),
		_List_fromArray(
			[
				stylenode,
				A2(
				$elm$svg$Svg$path,
				_List_fromArray(
					[
						$elm$svg$Svg$Attributes$d('M98 190.06l139.78 163.12a24 24 0 0036.44 0L414 190.06c13.34-15.57 2.28-39.62-18.22-39.62h-279.6c-20.5 0-31.56 24.05-18.18 39.62z')
					]),
				_List_Nil)
			])) : A2(
		$elm$svg$Svg$svg,
		_List_fromArray(
			[
				$elm$svg$Svg$Attributes$class('ionicon'),
				$elm$svg$Svg$Attributes$viewBox('0 0 512 512')
			]),
		_List_fromArray(
			[
				stylenode,
				A2(
				$elm$svg$Svg$path,
				_List_fromArray(
					[
						$elm$svg$Svg$Attributes$d('M190.06 414l163.12-139.78a24 24 0 000-36.44L190.06 98c-15.57-13.34-39.62-2.28-39.62 18.22v279.6c0 20.5 24.05 31.56 39.62 18.18z')
					]),
				_List_Nil)
			]));
};
var $author$project$Progress$Model$SelectTab = function (a) {
	return {$: 'SelectTab', a: a};
};
var $elm$html$Html$a = _VirtualDom_node('a');
var $elm$html$Html$li = _VirtualDom_node('li');
var $elm$html$Html$ul = _VirtualDom_node('ul');
var $author$project$Progress$View$viewFlowTabs = F2(
	function (flags, state) {
		var flowStyleClass = F2(
			function (idx, flow) {
				var _v0 = flow.success;
				if (_v0.$ === 'Just') {
					if (_v0.a) {
						return _List_fromArray(
							[
								$elm$html$Html$Attributes$class('sp-diag-success')
							]);
					} else {
						return _List_fromArray(
							[
								$elm$html$Html$Attributes$class('sp-diag-failure')
							]);
					}
				} else {
					return _List_fromArray(
						[
							$elm$html$Html$Attributes$class('sp-diag-nothing')
						]);
				}
			});
		var flowClass = F2(
			function (idx, flow) {
				return _Utils_eq(idx, state.active) ? _Utils_ap(
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('is-active')
						]),
					A2(flowStyleClass, idx, flow)) : A2(flowStyleClass, idx, flow);
			});
		var flowTab = F2(
			function (idx, flow) {
				return A2(
					$elm$html$Html$li,
					A2(flowClass, idx, flow),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$a,
							_List_fromArray(
								[
									A2($elm$html$Html$Attributes$style, 'margin-bottom', '0px'),
									$elm$html$Html$Events$onClick(
									$author$project$Progress$Model$SelectTab(idx))
								]),
							_List_fromArray(
								[
									$elm$html$Html$text(flow.workflow.label)
								]))
						]));
			});
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('tabs is-small')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$ul,
					_List_fromArray(
						[
							A2($elm$html$Html$Attributes$style, 'border-bottom-width', '0px')
						]),
					A2($elm$core$List$indexedMap, flowTab, state.flows))
				]));
	});
var $elm$core$List$filter = F2(
	function (isGood, list) {
		return A3(
			$elm$core$List$foldr,
			F2(
				function (x, xs) {
					return isGood(x) ? A2($elm$core$List$cons, x, xs) : xs;
				}),
			_List_Nil,
			list);
	});
var $author$project$Progress$Steps$progressStyle = function (stepstatus) {
	switch (stepstatus) {
		case 'ok':
			return _List_fromArray(
				[
					$elm$html$Html$Attributes$class('sp-diag-ok')
				]);
		case 'ok2':
			return _List_fromArray(
				[
					$elm$html$Html$Attributes$class('sp-diag-ok2')
				]);
		case 'error':
			return _List_fromArray(
				[
					$elm$html$Html$Attributes$class('sp-diag-error')
				]);
		case 'error2':
			return _List_fromArray(
				[
					$elm$html$Html$Attributes$class('sp-diag-error2')
				]);
		case 'init':
			return _List_fromArray(
				[
					$elm$html$Html$Attributes$class('sp-diag-init')
				]);
		default:
			return _List_fromArray(
				[
					$elm$html$Html$Attributes$class('sp-diag-other')
				]);
	}
};
var $author$project$Progress$Steps$stepDisplay = F3(
	function (flow, idx, stepstatus) {
		var _v0 = $elm$core$List$head(
			A2($elm$core$List$drop, idx, flow.workflow.progress));
		if (_v0.$ === 'Nothing') {
			return '<< unknown step >>';
		} else {
			var progobj = _v0.a;
			switch (stepstatus) {
				case 'ok':
					return progobj.display.ok;
				case 'ok2':
					return progobj.display.ok2;
				case 'error':
					return progobj.display.error;
				case 'error2':
					return progobj.display.error2;
				case 'init':
					return progobj.display.init;
				case 'skip':
					return progobj.display.skip;
				case 'skip2':
					return progobj.display.skip2;
				default:
					return '<< unknown stepstatus ' + (stepstatus + ' >>');
			}
		}
	});
var $author$project$Progress$View$viewProgressStep = F3(
	function (flow, idx, stepstatus) {
		var display = A3($author$project$Progress$Steps$stepDisplay, flow, idx, stepstatus);
		var lines = A2(
			$elm$core$List$filter,
			function (s) {
				return $elm$core$String$length(s) > 0;
			},
			A2($elm$core$String$split, '>', display));
		return A2(
			$elm$html$Html$pre,
			_Utils_ap(
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('mono diag'),
						A2($elm$html$Html$Attributes$style, 'line-height', '1.0'),
						A2($elm$html$Html$Attributes$style, 'overflow-x', 'visible'),
						A2($elm$html$Html$Attributes$style, 'overflow-y', 'visible'),
						A2($elm$html$Html$Attributes$style, 'margin-bottom', '0'),
						A2($elm$html$Html$Attributes$style, 'padding-top', '0'),
						A2($elm$html$Html$Attributes$style, 'padding-bottom', '0')
					]),
				$author$project$Progress$Steps$progressStyle(stepstatus)),
			A2(
				$elm$core$List$map,
				function (x) {
					return $elm$html$Html$text(x);
				},
				lines));
	});
var $author$project$Progress$View$viewFlowProgress = F3(
	function (flags, state, flow) {
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('media'),
					A2($elm$html$Html$Attributes$style, 'transform', 'translate(-26px, 0px)')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('media-left mr-0'),
							A2($elm$html$Html$Attributes$style, 'width', '24px'),
							A2($elm$html$Html$Attributes$style, 'min-width', '24px'),
							A2($elm$html$Html$Attributes$style, 'height', '24px'),
							$elm$html$Html$Events$onClick($author$project$Progress$Model$ToggleProgressExpanded)
						]),
					_List_fromArray(
						[
							$author$project$Shared$Expand$svgExpandCollapse(state.expanded)
						])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('media-content'),
							A2($elm$html$Html$Attributes$style, 'overflow-x', 'visible')
						]),
					function () {
						if (state.expanded) {
							var workflowTitle = $elm$html$Html$text(flags.labels.workflow.label);
							var workflowTabs = A2($author$project$Progress$View$viewFlowTabs, flags, state);
							var workflowSteps = $elm$core$Array$toList(
								A2(
									$elm$core$Array$indexedMap,
									$author$project$Progress$View$viewProgressStep(flow),
									flow.steps));
							var workflowStatus = function () {
								var _v1 = flow.success;
								if (_v1.$ === 'Just') {
									if (_v1.a) {
										return A2(
											$elm$html$Html$h3,
											_List_Nil,
											_List_fromArray(
												[
													$elm$html$Html$text(flags.labels.status.success)
												]));
									} else {
										return A2(
											$elm$html$Html$h3,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('has-text-danger')
												]),
											_List_fromArray(
												[
													$elm$html$Html$text(flags.labels.status.failure)
												]));
									}
								} else {
									return A2($elm$html$Html$div, _List_Nil, _List_Nil);
								}
							}();
							var decodeErrors = function () {
								var _v0 = state.decodeErrors;
								if (!_v0.b) {
									return A2($elm$html$Html$div, _List_Nil, _List_Nil);
								} else {
									var errors = _v0;
									return A2(
										$elm$html$Html$div,
										_List_fromArray(
											[
												$elm$html$Html$Attributes$class('m-0')
											]),
										_List_fromArray(
											[
												A2(
												$elm$html$Html$div,
												_List_fromArray(
													[
														$elm$html$Html$Attributes$class('field is-horizontal')
													]),
												_List_fromArray(
													[
														A2(
														$elm$html$Html$div,
														_List_fromArray(
															[
																$elm$html$Html$Attributes$class('field-label is-normal')
															]),
														_List_fromArray(
															[
																A2(
																$elm$html$Html$h3,
																_List_fromArray(
																	[
																		$elm$html$Html$Attributes$class('has-text-danger')
																	]),
																_List_fromArray(
																	[
																		$elm$html$Html$text(flags.labels.decodeErrors.label)
																	]))
															])),
														A2(
														$elm$html$Html$div,
														_List_fromArray(
															[
																$elm$html$Html$Attributes$class('field is-danger readonly'),
																A2($elm$html$Html$Attributes$style, 'font-family', 'jetbrains, monospace'),
																A2($elm$html$Html$Attributes$style, 'line-height', '1.0'),
																A2($elm$html$Html$Attributes$style, 'margin-bottom', '0'),
																A2($elm$html$Html$Attributes$style, 'padding-top', '0'),
																A2($elm$html$Html$Attributes$style, 'padding-bottom', '0')
															]),
														A2(
															$elm$core$List$map,
															function (s) {
																return $elm$html$Html$text(s + '\n');
															},
															A2(
																$elm_community$list_extra$List$Extra$dropWhile,
																function (s) {
																	return s === '';
																},
																errors)))
													])),
												A2($elm$html$Html$br, _List_Nil, _List_Nil)
											]));
								}
							}();
							return _List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('content')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$h3,
											_List_Nil,
											_List_fromArray(
												[workflowTitle])),
											decodeErrors,
											workflowTabs
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('content')
										]),
									A2($elm$core$List$cons, workflowStatus, workflowSteps)),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('content')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$h3,
											_List_Nil,
											_List_fromArray(
												[
													$elm$html$Html$text(flags.labels.diagnosticLogs.label)
												])),
											A2(
											$elm$html$Html$pre,
											_List_fromArray(
												[
													A2($elm$html$Html$Attributes$style, 'max-width', '100%'),
													A2($elm$html$Html$Attributes$style, 'line-height', '1.0'),
													A2($elm$html$Html$Attributes$style, 'overflow-x', 'visible'),
													A2($elm$html$Html$Attributes$style, 'overflow-y', 'visible')
												]),
											A2(
												$elm$core$List$map,
												function (s) {
													return $elm$html$Html$text(s + '\n');
												},
												A2(
													$elm_community$list_extra$List$Extra$dropWhile,
													function (s) {
														return s === '';
													},
													flow.messages))),
											A2($elm$html$Html$br, _List_Nil, _List_Nil)
										]))
								]);
						} else {
							return _List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('content')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$h3,
											_List_Nil,
											_List_fromArray(
												[
													$elm$html$Html$text(flags.labels.workflow.label)
												]))
										]))
								]);
						}
					}())
				]));
	});
var $author$project$Progress$View$view = F2(
	function (flags, state) {
		var _v0 = A2($elm$core$List$drop, state.active, state.flows);
		if (!_v0.b) {
			return A2(
				$elm$html$Html$p,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('notification is-danger')
					]),
				_List_fromArray(
					[
						$elm$html$Html$text('no flows')
					]));
		} else {
			var flow = _v0.a;
			var others = _v0.b;
			return A2(
				$elm$html$Html$div,
				_List_Nil,
				_List_fromArray(
					[
						A3($author$project$Progress$View$viewFlowProgress, flags, state, flow)
					]));
		}
	});
var $author$project$TopicList$Model$PressAccept = {$: 'PressAccept'};
var $author$project$TopicList$Model$PressAddTopic = {$: 'PressAddTopic'};
var $elm$html$Html$button = _VirtualDom_node('button');
var $elm$json$Json$Encode$bool = _Json_wrap;
var $elm$html$Html$Attributes$boolProperty = F2(
	function (key, bool) {
		return A2(
			_VirtualDom_property,
			key,
			$elm$json$Json$Encode$bool(bool));
	});
var $elm$html$Html$Attributes$disabled = $elm$html$Html$Attributes$boolProperty('disabled');
var $author$project$Shared$Text$nbsp = $elm$core$String$fromChar(
	_Utils_chr('\u00A0'));
var $elm$core$Basics$neq = _Utils_notEqual;
var $author$project$TopicList$View$viewAddSearch = F2(
	function (flags, state) {
		var add_enabled = function () {
			var _v0 = state.auth;
			if (_v0.$ === 'Success') {
				var auth = _v0.a;
				var _v1 = _Utils_Tuple2(
					auth.role,
					A2($elm$core$Dict$get, auth.mnum, state.profiles));
				if (_v1.a.$ === 'Host') {
					var _v2 = _v1.a;
					return true;
				} else {
					if (_v1.b.$ === 'Just') {
						var profile = _v1.b.a;
						return (!_Utils_eq(
							profile.accepted_on,
							$elm$time$Time$millisToPosix(0))) ? true : false;
					} else {
						return false;
					}
				}
			} else {
				return false;
			}
		}();
		var message = _List_fromArray(
			[
				A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('media')
					]),
				add_enabled ? _List_fromArray(
					[
						$elm$html$Html$text($author$project$Shared$Text$nbsp)
					]) : _List_fromArray(
					[
						A2(
						$elm$html$Html$div,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('is-hidden-mobile mr-5')
							]),
						_List_fromArray(
							[
								$elm$html$Html$text($author$project$Shared$Text$nbsp)
							])),
						A2(
						$elm$html$Html$div,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('media-content')
							]),
						_List_fromArray(
							[
								A2(
								$elm$html$Html$p,
								_List_fromArray(
									[
										$elm$html$Html$Attributes$class('has-text-danger')
									]),
								_List_fromArray(
									[
										$elm$html$Html$text(flags.extra.topiclistView.labels.invitation.description)
									]))
							])),
						A2(
						$elm$html$Html$div,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('media-right')
							]),
						_List_fromArray(
							[
								A2(
								$elm$html$Html$button,
								_List_fromArray(
									[
										$elm$html$Html$Attributes$class('button has-background-primary-dark has-text-white is-pulled-right'),
										$elm$html$Html$Events$onClick($author$project$TopicList$Model$PressAccept)
									]),
								_List_fromArray(
									[
										$elm$html$Html$text(flags.extra.topiclistView.labels.accept.label)
									]))
							]))
					]))
			]);
		return _Utils_ap(
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('columns mb-0')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('is-hidden-mobile mr-5')
								]),
							_List_fromArray(
								[
									$elm$html$Html$text($author$project$Shared$Text$nbsp)
								])),
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('column is-one-fifth')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$button,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('button has-background-primary-dark has-text-white'),
											$elm$html$Html$Attributes$disabled(!add_enabled),
											$elm$html$Html$Events$onClick($author$project$TopicList$Model$PressAddTopic)
										]),
									_List_fromArray(
										[
											$elm$html$Html$text(flags.extra.topiclistView.labels.addTopic.label)
										]))
								])),
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('column is-hidden-mobile')
								]),
							_List_Nil)
						]))
				]),
			message);
	});
var $elm$core$List$takeReverse = F3(
	function (n, list, kept) {
		takeReverse:
		while (true) {
			if (n <= 0) {
				return kept;
			} else {
				if (!list.b) {
					return kept;
				} else {
					var x = list.a;
					var xs = list.b;
					var $temp$n = n - 1,
						$temp$list = xs,
						$temp$kept = A2($elm$core$List$cons, x, kept);
					n = $temp$n;
					list = $temp$list;
					kept = $temp$kept;
					continue takeReverse;
				}
			}
		}
	});
var $elm$core$List$takeTailRec = F2(
	function (n, list) {
		return $elm$core$List$reverse(
			A3($elm$core$List$takeReverse, n, list, _List_Nil));
	});
var $elm$core$List$takeFast = F3(
	function (ctr, n, list) {
		if (n <= 0) {
			return _List_Nil;
		} else {
			var _v0 = _Utils_Tuple2(n, list);
			_v0$1:
			while (true) {
				_v0$5:
				while (true) {
					if (!_v0.b.b) {
						return list;
					} else {
						if (_v0.b.b.b) {
							switch (_v0.a) {
								case 1:
									break _v0$1;
								case 2:
									var _v2 = _v0.b;
									var x = _v2.a;
									var _v3 = _v2.b;
									var y = _v3.a;
									return _List_fromArray(
										[x, y]);
								case 3:
									if (_v0.b.b.b.b) {
										var _v4 = _v0.b;
										var x = _v4.a;
										var _v5 = _v4.b;
										var y = _v5.a;
										var _v6 = _v5.b;
										var z = _v6.a;
										return _List_fromArray(
											[x, y, z]);
									} else {
										break _v0$5;
									}
								default:
									if (_v0.b.b.b.b && _v0.b.b.b.b.b) {
										var _v7 = _v0.b;
										var x = _v7.a;
										var _v8 = _v7.b;
										var y = _v8.a;
										var _v9 = _v8.b;
										var z = _v9.a;
										var _v10 = _v9.b;
										var w = _v10.a;
										var tl = _v10.b;
										return (ctr > 1000) ? A2(
											$elm$core$List$cons,
											x,
											A2(
												$elm$core$List$cons,
												y,
												A2(
													$elm$core$List$cons,
													z,
													A2(
														$elm$core$List$cons,
														w,
														A2($elm$core$List$takeTailRec, n - 4, tl))))) : A2(
											$elm$core$List$cons,
											x,
											A2(
												$elm$core$List$cons,
												y,
												A2(
													$elm$core$List$cons,
													z,
													A2(
														$elm$core$List$cons,
														w,
														A3($elm$core$List$takeFast, ctr + 1, n - 4, tl)))));
									} else {
										break _v0$5;
									}
							}
						} else {
							if (_v0.a === 1) {
								break _v0$1;
							} else {
								break _v0$5;
							}
						}
					}
				}
				return list;
			}
			var _v1 = _v0.b;
			var x = _v1.a;
			return _List_fromArray(
				[x]);
		}
	});
var $elm$core$List$take = F2(
	function (n, list) {
		return A3($elm$core$List$takeFast, 0, n, list);
	});
var $author$project$TopicList$Model$PressDetails = function (a) {
	return {$: 'PressDetails', a: a};
};
var $author$project$TopicList$Model$ToggleExpanded = function (a) {
	return {$: 'ToggleExpanded', a: a};
};
var $elm$core$Maybe$andThen = F2(
	function (callback, maybeValue) {
		if (maybeValue.$ === 'Just') {
			var value = maybeValue.a;
			return callback(value);
		} else {
			return $elm$core$Maybe$Nothing;
		}
	});
var $elm$html$Html$Attributes$value = $elm$html$Html$Attributes$stringProperty('value');
var $author$project$Shared$Icon$squareIcon = F2(
	function (size, name) {
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					A2(
					$elm$html$Html$Attributes$style,
					'width',
					$elm$core$String$fromInt(size) + 'px'),
					A2(
					$elm$html$Html$Attributes$style,
					'height',
					$elm$core$String$fromInt(size) + 'px')
				]),
			_List_fromArray(
				[
					A3(
					$elm$html$Html$node,
					'square-initials',
					_List_fromArray(
						[
							$elm$html$Html$Attributes$value(name)
						]),
					_List_Nil)
				]));
	});
var $elm$html$Html$span = _VirtualDom_node('span');
var $author$project$TopicList$View$viewExpanded = F4(
	function (flags, state, tkey, topic) {
		var description_text = function () {
			var _v0 = topic.data;
			if (_v0.$ === 'Nothing') {
				return _List_Nil;
			} else {
				var data = _v0.a;
				return _List_fromArray(
					[
						A2($elm$html$Html$br, _List_Nil, _List_Nil),
						A2(
						$elm$html$Html$span,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('tag mr-1')
							]),
						_List_fromArray(
							[
								$elm$html$Html$text(flags.extra.topiclistView.labels.description.label)
							])),
						A2(
						$elm$html$Html$span,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('mt-5')
							]),
						_List_fromArray(
							[
								$elm$html$Html$text(data.details.description)
							]))
					]);
			}
		}();
		return topic.expanded ? description_text : description_text;
	});
var $author$project$TopicList$View$viewTopic = F3(
	function (flags, state, _v0) {
		var tkey = _v0.a;
		var topic = _v0.b;
		var title_txt = function () {
			var _v3 = topic.data;
			if (_v3.$ === 'Nothing') {
				return _List_Nil;
			} else {
				var data = _v3.a;
				return _List_fromArray(
					[
						A2(
						$elm$html$Html$p,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('title is-4 mt-0 mb-0')
							]),
						_List_fromArray(
							[
								$elm$html$Html$text(data.details.title)
							]))
					]);
			}
		}();
		var stats_txt = _List_Nil;
		var mthumbnail = A2(
			$elm$core$Maybe$andThen,
			function (profile) {
				return profile.thumbnail;
			},
			A2(
				$elm$core$Maybe$andThen,
				function (creator) {
					return A2($elm$core$Dict$get, creator, state.profiles);
				},
				A2(
					$elm$core$Maybe$andThen,
					function (data) {
						return data.creator;
					},
					topic.data)));
		var picture = function () {
			if (mthumbnail.$ === 'Nothing') {
				var _v2 = topic.data;
				if (_v2.$ === 'Nothing') {
					return A2($author$project$Shared$Icon$squareIcon, 48, '');
				} else {
					var data = _v2.a;
					return A2($author$project$Shared$Icon$squareIcon, 48, data.details.title);
				}
			} else {
				var url = mthumbnail.a;
				return A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							A2($elm$html$Html$Attributes$style, 'width', '48px'),
							A2($elm$html$Html$Attributes$style, 'height', '48px'),
							A2($elm$html$Html$Attributes$style, 'background-image', 'url(\'' + (url + '\')')),
							A2($elm$html$Html$Attributes$style, 'background-position', 'center'),
							A2($elm$html$Html$Attributes$style, 'background-repeat', 'no-repeat'),
							A2($elm$html$Html$Attributes$style, 'background-size', 'contain')
						]),
					_List_Nil);
			}
		}();
		var image_div = _List_fromArray(
			[
				A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('image is-48x48')
					]),
				_List_fromArray(
					[picture]))
			]);
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('media')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('mr-1'),
							A2($elm$html$Html$Attributes$style, 'width', '24px'),
							A2($elm$html$Html$Attributes$style, 'min-width', '24px'),
							A2($elm$html$Html$Attributes$style, 'height', '24px'),
							$elm$html$Html$Events$onClick(
							$author$project$TopicList$Model$ToggleExpanded(tkey))
						]),
					_List_fromArray(
						[
							$author$project$Shared$Expand$svgExpandCollapse(topic.expanded)
						])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('media-left')
						]),
					image_div),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('media-content'),
							A2($elm$html$Html$Attributes$style, 'overflow-x', 'visible'),
							A2($elm$html$Html$Attributes$style, 'overflow-y', 'visible')
						]),
					_Utils_ap(
						_List_fromArray(
							[
								A2(
								$elm$html$Html$div,
								_List_fromArray(
									[
										$elm$html$Html$Attributes$class('columns mb-0')
									]),
								_List_fromArray(
									[
										A2(
										$elm$html$Html$div,
										_List_fromArray(
											[
												$elm$html$Html$Attributes$class('column is-5 pb-0')
											]),
										_Utils_ap(title_txt, stats_txt))
									]))
							]),
						A4($author$project$TopicList$View$viewExpanded, flags, state, tkey, topic))),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('media-right')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$button,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('button has-background-primary-dark has-text-white'),
									$elm$html$Html$Events$onClick(
									$author$project$TopicList$Model$PressDetails(tkey))
								]),
							_List_fromArray(
								[
									$elm$html$Html$text(flags.extra.topiclistView.labels.details.label)
								]))
						]))
				]));
	});
var $author$project$TopicList$View$viewTopics = F2(
	function (flags, state) {
		var _v0 = state.filter;
		if (_v0 === '') {
			return A2(
				$elm$core$List$map,
				A2($author$project$TopicList$View$viewTopic, flags, state),
				$elm$core$Dict$toList(state.topics));
		} else {
			var filter = _v0;
			return A2(
				$elm$core$List$map,
				A2($author$project$TopicList$View$viewTopic, flags, state),
				A2(
					$elm$core$List$take,
					1,
					$elm$core$Dict$toList(state.topics)));
		}
	});
var $author$project$TopicList$View$view = F2(
	function (flags, state) {
		return A2(
			$elm$html$Html$div,
			_List_Nil,
			_Utils_ap(
				A2($author$project$TopicList$View$viewAddSearch, flags, state),
				A2($author$project$TopicList$View$viewTopics, flags, state)));
	});
var $author$project$TopicList$view = function (model) {
	var _v0 = _Utils_Tuple2($author$project$TopicList$currentView, model);
	_v0$3:
	while (true) {
		if (_v0.b.$ === 'Failed') {
			if (!_v0.a) {
				var err = _v0.b.a;
				return A2(
					$elm$html$Html$p,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('notification is-danger')
						]),
					_List_fromArray(
						[
							$elm$html$Html$text(err)
						]));
			} else {
				break _v0$3;
			}
		} else {
			switch (_v0.a) {
				case 0:
					var _v1 = _v0.b;
					var flags = _v1.a;
					var state = _v1.b;
					return A2($author$project$TopicList$View$view, flags, state);
				case 1:
					var _v2 = _v0.b;
					var flags = _v2.a;
					var state = _v2.b;
					return A2(
						$elm$html$Html$map,
						$author$project$TopicList$Model$ProgressMsg,
						A2(
							$author$project$Progress$View$view,
							$author$project$TopicList$progressFlags(flags),
							state.progress));
				default:
					break _v0$3;
			}
		}
	}
	return A2($elm$html$Html$div, _List_Nil, _List_Nil);
};
var $author$project$TopicList$main = $elm$browser$Browser$element(
	{init: $author$project$TopicList$init, subscriptions: $author$project$TopicList$subscriptions, update: $author$project$TopicList$update, view: $author$project$TopicList$view});
var $author$project$Topic$Model$Failed = function (a) {
	return {$: 'Failed', a: a};
};
var $author$project$Topic$Model$Loaded = F2(
	function (a, b) {
		return {$: 'Loaded', a: a, b: b};
	});
var $author$project$Topic$Model$BundlesMsg = function (a) {
	return {$: 'BundlesMsg', a: a};
};
var $author$project$Topic$bundlesCmds = function (bcmds) {
	return A2($elm$core$Platform$Cmd$map, $author$project$Topic$Model$BundlesMsg, bcmds);
};
var $author$project$Topic$bundlesFlags = function (flags) {
	return {errors: flags.extra.topicBundles.errors, labels: flags.extra.topicBundles.labels, transitions: flags.extra.topicBundles.transitions};
};
var $author$project$Topic$Model$CommentsMsg = function (a) {
	return {$: 'CommentsMsg', a: a};
};
var $author$project$Topic$commentsCmds = function (ccmds) {
	return A2($elm$core$Platform$Cmd$map, $author$project$Topic$Model$CommentsMsg, ccmds);
};
var $author$project$Topic$commentsFlags = function (flags) {
	return {labels: flags.extra.topicComments.labels, transitions: flags.extra.topicComments.transitions};
};
var $author$project$Topic$Model$DetailsMsg = function (a) {
	return {$: 'DetailsMsg', a: a};
};
var $author$project$Topic$detailsCmds = function (dcmds) {
	return A2($elm$core$Platform$Cmd$map, $author$project$Topic$Model$DetailsMsg, dcmds);
};
var $author$project$Topic$detailsFlags = function (flags) {
	return {errors: flags.extra.topicDetails.errors, labels: flags.extra.topicDetails.labels, readonly: flags.extra.topicDetails.readonly};
};
var $author$project$TopicBundles$Model$Problems = function (selectedErr) {
	return {selectedErr: selectedErr};
};
var $elm$core$List$maybeCons = F3(
	function (f, mx, xs) {
		var _v0 = f(mx);
		if (_v0.$ === 'Just') {
			var x = _v0.a;
			return A2($elm$core$List$cons, x, xs);
		} else {
			return xs;
		}
	});
var $elm$core$List$filterMap = F2(
	function (f, xs) {
		return A3(
			$elm$core$List$foldr,
			$elm$core$List$maybeCons(f),
			_List_Nil,
			xs);
	});
var $author$project$TopicBundles$Model$bundleList = function (state) {
	var getItem = function (item) {
		var _v0 = A2($elm$core$Dict$get, item.bnum, state.bundles);
		if (_v0.$ === 'Just') {
			var b = _v0.a;
			return $elm$core$Maybe$Just(
				_Utils_Tuple2(item, b));
		} else {
			return $elm$core$Maybe$Nothing;
		}
	};
	return A2($elm$core$List$filterMap, getItem, state.current);
};
var $author$project$TopicBundles$Model$bundlesIncluded = F2(
	function (state, accepted) {
		var included = function (_v0) {
			var item = _v0.a;
			var b = _v0.b;
			return item.include ? (b.data.restricted ? (accepted ? $elm$core$Maybe$Just(item.bnum) : $elm$core$Maybe$Nothing) : $elm$core$Maybe$Just(item.bnum)) : $elm$core$Maybe$Nothing;
		};
		return A2(
			$elm$core$List$filterMap,
			included,
			$author$project$TopicBundles$Model$bundleList(state));
	});
var $author$project$TopicBundles$Model$validate = F3(
	function (flags, state, accepted) {
		return {
			selectedErr: function () {
				var _v0 = $elm$core$List$length(
					A2($author$project$TopicBundles$Model$bundlesIncluded, state, accepted));
				if (!_v0) {
					return $elm$core$Maybe$Just(flags.errors.selected.none);
				} else {
					return $elm$core$Maybe$Nothing;
				}
			}()
		};
	});
var $author$project$TopicBundles$Model$validateState = F3(
	function (flags, state, accepted) {
		return _Utils_update(
			state,
			{
				problems: A3($author$project$TopicBundles$Model$validate, flags, state, accepted)
			});
	});
var $author$project$TopicBundles$Model$init = function (flags) {
	return _Utils_Tuple2(
		A3(
			$author$project$TopicBundles$Model$validateState,
			flags,
			{
				bundles: $elm$core$Dict$empty,
				current: _List_Nil,
				initial: _List_Nil,
				problems: $author$project$TopicBundles$Model$Problems($elm$core$Maybe$Nothing)
			},
			false),
		$elm$core$Platform$Cmd$none);
};
var $author$project$TopicComments$Model$ClockMsg = function (a) {
	return {$: 'ClockMsg', a: a};
};
var $author$project$CommentData$Model$CommentData = F4(
	function (mnum, path, when, what) {
		return {mnum: mnum, path: path, what: what, when: when};
	});
var $author$project$CommentData$Comment$Node = function (a) {
	return {$: 'Node', a: a};
};
var $author$project$Shared$Clock$epoch = $elm$time$Time$millisToPosix(0);
var $author$project$Shared$Clock$AdjustTimeZone = function (a) {
	return {$: 'AdjustTimeZone', a: a};
};
var $author$project$Shared$Clock$Model = F3(
	function (zone, start, time) {
		return {start: start, time: time, zone: zone};
	});
var $author$project$Shared$Clock$Tick = function (a) {
	return {$: 'Tick', a: a};
};
var $elm$time$Time$Name = function (a) {
	return {$: 'Name', a: a};
};
var $elm$time$Time$Offset = function (a) {
	return {$: 'Offset', a: a};
};
var $elm$time$Time$Zone = F2(
	function (a, b) {
		return {$: 'Zone', a: a, b: b};
	});
var $elm$time$Time$customZone = $elm$time$Time$Zone;
var $elm$time$Time$here = _Time_here(_Utils_Tuple0);
var $elm$time$Time$now = _Time_now($elm$time$Time$millisToPosix);
var $elm$time$Time$utc = A2($elm$time$Time$Zone, 0, _List_Nil);
var $author$project$Shared$Clock$init = _Utils_Tuple2(
	A3($author$project$Shared$Clock$Model, $elm$time$Time$utc, $author$project$Shared$Clock$epoch, $author$project$Shared$Clock$epoch),
	$elm$core$Platform$Cmd$batch(
		_List_fromArray(
			[
				A2($elm$core$Task$perform, $author$project$Shared$Clock$AdjustTimeZone, $elm$time$Time$here),
				A2($elm$core$Task$perform, $author$project$Shared$Clock$Tick, $elm$time$Time$now)
			])));
var $author$project$TopicComments$Model$init = function (flags) {
	var _v0 = $author$project$Shared$Clock$init;
	var clock = _v0.a;
	var clockcmds = _v0.b;
	return _Utils_Tuple2(
		{
			clock: clock,
			comments: $author$project$CommentData$Comment$Node(
				{
					cancel: $elm$core$Maybe$Nothing,
					_delete: false,
					detail: A4($author$project$CommentData$Model$CommentData, 0, '', $author$project$Shared$Clock$epoch, ''),
					edit: false,
					expanded: true,
					replies: _List_Nil,
					stored: false
				}),
			mnum: $elm$core$Maybe$Nothing,
			next_comment: 1
		},
		A2($elm$core$Platform$Cmd$map, $author$project$TopicComments$Model$ClockMsg, clockcmds));
};
var $author$project$TopicDetails$Model$Problems = F2(
	function (currentErr, titleErr) {
		return {currentErr: currentErr, titleErr: titleErr};
	});
var $author$project$TopicData$Model$emptyTopicData = {
	bundles: _List_Nil,
	creator: $elm$core$Maybe$Nothing,
	details: {description: '', path: '/index.html', title: ''}
};
var $author$project$TopicDetails$Model$dataErrors = function (flags) {
	return {
		path: {reserved: '', syntax: ''},
		title: {syntax: flags.errors.title.syntax}
	};
};
var $elm_community$maybe_extra$Maybe$Extra$orList = function (maybes) {
	orList:
	while (true) {
		if (!maybes.b) {
			return $elm$core$Maybe$Nothing;
		} else {
			if (maybes.a.$ === 'Nothing') {
				var _v1 = maybes.a;
				var rest = maybes.b;
				var $temp$maybes = rest;
				maybes = $temp$maybes;
				continue orList;
			} else {
				var answer = maybes.a.a;
				return $elm$core$Maybe$Just(answer);
			}
		}
	}
};
var $author$project$TopicData$Valid$titleregex = '^.{4,100}$';
var $author$project$TopicData$Valid$validTitleRegex = A2(
	$elm$core$Maybe$withDefault,
	$elm$regex$Regex$never,
	$elm$regex$Regex$fromString($author$project$TopicData$Valid$titleregex));
var $author$project$TopicData$Valid$titleSyntaxErr = F2(
	function (errors, title) {
		var _v0 = A2($elm$regex$Regex$contains, $author$project$TopicData$Valid$validTitleRegex, title);
		if (_v0) {
			return $elm$core$Maybe$Nothing;
		} else {
			return $elm$core$Maybe$Just(errors.title.syntax);
		}
	});
var $author$project$TopicData$Valid$titleErr = F2(
	function (errors, title) {
		return $elm_community$maybe_extra$Maybe$Extra$orList(
			_List_fromArray(
				[
					A2($author$project$TopicData$Valid$titleSyntaxErr, errors, title)
				]));
	});
var $author$project$TopicDetails$Model$validate = F3(
	function (flags, current, readonly) {
		return {
			currentErr: $elm$core$Maybe$Nothing,
			titleErr: readonly ? $elm$core$Maybe$Nothing : A2(
				$author$project$TopicData$Valid$titleErr,
				$author$project$TopicDetails$Model$dataErrors(flags),
				current.details.title)
		};
	});
var $author$project$TopicDetails$Model$validateState = F2(
	function (flags, state) {
		return _Utils_update(
			state,
			{
				problems: A3($author$project$TopicDetails$Model$validate, flags, state.current, state.readonly)
			});
	});
var $author$project$TopicDetails$Model$init = function (flags) {
	return _Utils_Tuple2(
		A2(
			$author$project$TopicDetails$Model$validateState,
			flags,
			{
				current: $author$project$TopicData$Model$emptyTopicData,
				initial: $elm$core$Maybe$Nothing,
				mnum: $elm$core$Maybe$Nothing,
				problems: A2($author$project$TopicDetails$Model$Problems, $elm$core$Maybe$Nothing, $elm$core$Maybe$Nothing),
				readonly: flags.readonly
			}),
		$elm$core$Platform$Cmd$none);
};
var $elm$core$Set$Set_elm_builtin = function (a) {
	return {$: 'Set_elm_builtin', a: a};
};
var $elm$core$Set$empty = $elm$core$Set$Set_elm_builtin($elm$core$Dict$empty);
var $author$project$TopicMembers$Model$init = F2(
	function (flags, mode) {
		return _Utils_Tuple2(
			{added: $elm$core$Set$empty, expanded: mode === 'add', initial: $elm$core$Set$empty, notes: $elm$core$Dict$empty, profiles: $elm$core$Dict$empty, removed: $elm$core$Set$empty},
			$elm$core$Platform$Cmd$none);
	});
var $author$project$TopicReview$Model$Problems = F2(
	function (currentErr, pathErr) {
		return {currentErr: currentErr, pathErr: pathErr};
	});
var $author$project$TopicReview$Model$dataErrors = function (flags) {
	return {
		path: {reserved: flags.errors.path.reserved, syntax: flags.errors.path.syntax},
		title: {syntax: ''}
	};
};
var $author$project$TopicData$Valid$reservedregex = '^/_v1[.]2401_';
var $author$project$TopicData$Valid$reservedPathRegex = A2(
	$elm$core$Maybe$withDefault,
	$elm$regex$Regex$never,
	$elm$regex$Regex$fromString($author$project$TopicData$Valid$reservedregex));
var $author$project$TopicData$Valid$pathReservedErr = F2(
	function (errors, path) {
		var _v0 = A2($elm$regex$Regex$contains, $author$project$TopicData$Valid$reservedPathRegex, path);
		if (_v0) {
			return $elm$core$Maybe$Just(errors.path.reserved);
		} else {
			return $elm$core$Maybe$Nothing;
		}
	});
var $author$project$TopicData$Valid$pathregex = '^.{1,2000}$';
var $author$project$TopicData$Valid$validPathRegex = A2(
	$elm$core$Maybe$withDefault,
	$elm$regex$Regex$never,
	$elm$regex$Regex$fromString($author$project$TopicData$Valid$pathregex));
var $author$project$TopicData$Valid$pathSyntaxErr = F2(
	function (errors, path) {
		var _v0 = A2($elm$regex$Regex$contains, $author$project$TopicData$Valid$validPathRegex, path);
		if (!_v0) {
			return $elm$core$Maybe$Just(errors.path.syntax);
		} else {
			return $elm$core$Maybe$Nothing;
		}
	});
var $author$project$TopicData$Valid$pathErr = F2(
	function (errors, path) {
		return $elm_community$maybe_extra$Maybe$Extra$orList(
			_List_fromArray(
				[
					A2($author$project$TopicData$Valid$pathSyntaxErr, errors, path),
					A2($author$project$TopicData$Valid$pathReservedErr, errors, path)
				]));
	});
var $author$project$TopicReview$Model$validate = F2(
	function (flags, current) {
		return {
			currentErr: $elm$core$Maybe$Nothing,
			pathErr: A2(
				$author$project$TopicData$Valid$pathErr,
				$author$project$TopicReview$Model$dataErrors(flags),
				current.details.path)
		};
	});
var $author$project$TopicReview$Model$validateState = F3(
	function (flags, state, details) {
		return _Utils_update(
			state,
			{
				problems: A2($author$project$TopicReview$Model$validate, flags, details.current)
			});
	});
var $author$project$TopicReview$Model$init = F2(
	function (flags, details) {
		return _Utils_Tuple2(
			A3(
				$author$project$TopicReview$Model$validateState,
				flags,
				{
					expanded: false,
					frametarget: $elm$core$Maybe$Nothing,
					loaded: $elm$core$Maybe$Nothing,
					pause: false,
					paused: false,
					problems: A2($author$project$TopicReview$Model$Problems, $elm$core$Maybe$Nothing, $elm$core$Maybe$Nothing),
					windowtarget: $elm$core$Maybe$Nothing
				},
				details),
			$elm$core$Platform$Cmd$none);
	});
var $author$project$Topic$Flags$Flags = F3(
	function (config, extra, workflows) {
		return {config: config, extra: extra, workflows: workflows};
	});
var $author$project$Topic$Flags$Extra = function (mode) {
	return function (module_) {
		return function (plurals) {
			return function (progressView) {
				return function (remoteData) {
					return function (topicBundles) {
						return function (topicComments) {
							return function (topicDetails) {
								return function (topicMembers) {
									return function (topicReview) {
										return function (topicSubmit) {
											return function (viewNodes) {
												return {mode: mode, module_: module_, plurals: plurals, progressView: progressView, remoteData: remoteData, topicBundles: topicBundles, topicComments: topicComments, topicDetails: topicDetails, topicMembers: topicMembers, topicReview: topicReview, topicSubmit: topicSubmit, viewNodes: viewNodes};
											};
										};
									};
								};
							};
						};
					};
				};
			};
		};
	};
};
var $author$project$Topic$Flags$ExtraPlurals = function (comments) {
	return function (files) {
		return function (folders) {
			return function (noComments) {
				return function (noFiles) {
					return function (noFolders) {
						return function (noUnread) {
							return function (oneComment) {
								return function (oneFile) {
									return function (oneFolder) {
										return function (oneUnread) {
											return function (unread) {
												return {comments: comments, files: files, folders: folders, noComments: noComments, noFiles: noFiles, noFolders: noFolders, noUnread: noUnread, oneComment: oneComment, oneFile: oneFile, oneFolder: oneFolder, oneUnread: oneUnread, unread: unread};
											};
										};
									};
								};
							};
						};
					};
				};
			};
		};
	};
};
var $author$project$Topic$Flags$extraPluralsDecoder = function () {
	var fieldSet0 = A9(
		$elm$json$Json$Decode$map8,
		$author$project$Topic$Flags$ExtraPlurals,
		A2($elm$json$Json$Decode$field, 'comments', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'files', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'folders', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'no_comments', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'no_files', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'no_folders', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'no_unread', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'one_comment', $elm$json$Json$Decode$string));
	return A6(
		$elm$json$Json$Decode$map5,
		$elm$core$Basics$apL,
		fieldSet0,
		A2($elm$json$Json$Decode$field, 'one_file', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'one_folder', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'one_unread', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'unread', $elm$json$Json$Decode$string));
}();
var $author$project$Topic$Flags$ExtraProgressView = function (labels) {
	return {labels: labels};
};
var $author$project$Topic$Flags$ExtraProgressViewLabels = F4(
	function (decodeErrors, diagnosticLogs, status, workflow) {
		return {decodeErrors: decodeErrors, diagnosticLogs: diagnosticLogs, status: status, workflow: workflow};
	});
var $author$project$Topic$Flags$ExtraProgressViewLabelsDecodeErrors = function (label) {
	return {label: label};
};
var $author$project$Topic$Flags$extraProgressViewLabelsDecodeErrorsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Topic$Flags$ExtraProgressViewLabelsDecodeErrors,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraProgressViewLabelsDiagnosticLogs = function (label) {
	return {label: label};
};
var $author$project$Topic$Flags$extraProgressViewLabelsDiagnosticLogsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Topic$Flags$ExtraProgressViewLabelsDiagnosticLogs,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraProgressViewLabelsStatus = F2(
	function (failure, success) {
		return {failure: failure, success: success};
	});
var $author$project$Topic$Flags$extraProgressViewLabelsStatusDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Topic$Flags$ExtraProgressViewLabelsStatus,
	A2($elm$json$Json$Decode$field, 'failure', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'success', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraProgressViewLabelsWorkflow = function (label) {
	return {label: label};
};
var $author$project$Topic$Flags$extraProgressViewLabelsWorkflowDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Topic$Flags$ExtraProgressViewLabelsWorkflow,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$extraProgressViewLabelsDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$Topic$Flags$ExtraProgressViewLabels,
	A2($elm$json$Json$Decode$field, 'decode_errors', $author$project$Topic$Flags$extraProgressViewLabelsDecodeErrorsDecoder),
	A2($elm$json$Json$Decode$field, 'diagnostic_logs', $author$project$Topic$Flags$extraProgressViewLabelsDiagnosticLogsDecoder),
	A2($elm$json$Json$Decode$field, 'status', $author$project$Topic$Flags$extraProgressViewLabelsStatusDecoder),
	A2($elm$json$Json$Decode$field, 'workflow', $author$project$Topic$Flags$extraProgressViewLabelsWorkflowDecoder));
var $author$project$Topic$Flags$extraProgressViewDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Topic$Flags$ExtraProgressView,
	A2($elm$json$Json$Decode$field, 'labels', $author$project$Topic$Flags$extraProgressViewLabelsDecoder));
var $author$project$Topic$Flags$ExtraRemoteData = F2(
	function (loading, notasked) {
		return {loading: loading, notasked: notasked};
	});
var $author$project$Topic$Flags$extraRemoteDataDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Topic$Flags$ExtraRemoteData,
	A2($elm$json$Json$Decode$field, 'loading', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'notasked', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicBundles = F3(
	function (errors, labels, transitions) {
		return {errors: errors, labels: labels, transitions: transitions};
	});
var $author$project$Topic$Flags$ExtraTopicBundlesErrors = function (selected) {
	return {selected: selected};
};
var $author$project$Topic$Flags$ExtraTopicBundlesErrorsSelected = function (none) {
	return {none: none};
};
var $author$project$Topic$Flags$extraTopicBundlesErrorsSelectedDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Topic$Flags$ExtraTopicBundlesErrorsSelected,
	A2($elm$json$Json$Decode$field, 'none', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$extraTopicBundlesErrorsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Topic$Flags$ExtraTopicBundlesErrors,
	A2($elm$json$Json$Decode$field, 'selected', $author$project$Topic$Flags$extraTopicBundlesErrorsSelectedDecoder));
var $author$project$Topic$Flags$ExtraTopicBundlesLabels = F8(
	function (checkbox, details, folders, mount, name, reset, restricted, size) {
		return {checkbox: checkbox, details: details, folders: folders, mount: mount, name: name, reset: reset, restricted: restricted, size: size};
	});
var $author$project$Topic$Flags$ExtraTopicBundlesLabelsCheckbox = function (width) {
	return {width: width};
};
var $author$project$Topic$Flags$extraTopicBundlesLabelsCheckboxDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Topic$Flags$ExtraTopicBundlesLabelsCheckbox,
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicBundlesLabelsDetails = F2(
	function (label, width) {
		return {label: label, width: width};
	});
var $author$project$Topic$Flags$extraTopicBundlesLabelsDetailsDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Topic$Flags$ExtraTopicBundlesLabelsDetails,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicBundlesLabelsFolders = F2(
	function (label, width) {
		return {label: label, width: width};
	});
var $author$project$Topic$Flags$extraTopicBundlesLabelsFoldersDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Topic$Flags$ExtraTopicBundlesLabelsFolders,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicBundlesLabelsMount = F2(
	function (label, width) {
		return {label: label, width: width};
	});
var $author$project$Topic$Flags$extraTopicBundlesLabelsMountDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Topic$Flags$ExtraTopicBundlesLabelsMount,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicBundlesLabelsName = F2(
	function (label, width) {
		return {label: label, width: width};
	});
var $author$project$Topic$Flags$extraTopicBundlesLabelsNameDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Topic$Flags$ExtraTopicBundlesLabelsName,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicBundlesLabelsReset = F2(
	function (label, width) {
		return {label: label, width: width};
	});
var $author$project$Topic$Flags$extraTopicBundlesLabelsResetDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Topic$Flags$ExtraTopicBundlesLabelsReset,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicBundlesLabelsRestricted = F5(
	function (accept, datalabel, description, value, width) {
		return {accept: accept, datalabel: datalabel, description: description, value: value, width: width};
	});
var $author$project$Topic$Flags$extraTopicBundlesLabelsRestrictedDecoder = A6(
	$elm$json$Json$Decode$map5,
	$author$project$Topic$Flags$ExtraTopicBundlesLabelsRestricted,
	A2($elm$json$Json$Decode$field, 'accept', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'datalabel', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'value', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicBundlesLabelsSize = F2(
	function (label, width) {
		return {label: label, width: width};
	});
var $author$project$Topic$Flags$extraTopicBundlesLabelsSizeDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Topic$Flags$ExtraTopicBundlesLabelsSize,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$extraTopicBundlesLabelsDecoder = A9(
	$elm$json$Json$Decode$map8,
	$author$project$Topic$Flags$ExtraTopicBundlesLabels,
	A2($elm$json$Json$Decode$field, 'checkbox', $author$project$Topic$Flags$extraTopicBundlesLabelsCheckboxDecoder),
	A2($elm$json$Json$Decode$field, 'details', $author$project$Topic$Flags$extraTopicBundlesLabelsDetailsDecoder),
	A2($elm$json$Json$Decode$field, 'folders', $author$project$Topic$Flags$extraTopicBundlesLabelsFoldersDecoder),
	A2($elm$json$Json$Decode$field, 'mount', $author$project$Topic$Flags$extraTopicBundlesLabelsMountDecoder),
	A2($elm$json$Json$Decode$field, 'name', $author$project$Topic$Flags$extraTopicBundlesLabelsNameDecoder),
	A2($elm$json$Json$Decode$field, 'reset', $author$project$Topic$Flags$extraTopicBundlesLabelsResetDecoder),
	A2($elm$json$Json$Decode$field, 'restricted', $author$project$Topic$Flags$extraTopicBundlesLabelsRestrictedDecoder),
	A2($elm$json$Json$Decode$field, 'size', $author$project$Topic$Flags$extraTopicBundlesLabelsSizeDecoder));
var $author$project$Topic$Flags$ExtraTopicBundlesTransitions = function (details) {
	return {details: details};
};
var $author$project$Topic$Flags$extraTopicBundlesTransitionsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Topic$Flags$ExtraTopicBundlesTransitions,
	A2($elm$json$Json$Decode$field, 'details', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$extraTopicBundlesDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Topic$Flags$ExtraTopicBundles,
	A2($elm$json$Json$Decode$field, 'errors', $author$project$Topic$Flags$extraTopicBundlesErrorsDecoder),
	A2($elm$json$Json$Decode$field, 'labels', $author$project$Topic$Flags$extraTopicBundlesLabelsDecoder),
	A2($elm$json$Json$Decode$field, 'transitions', $author$project$Topic$Flags$extraTopicBundlesTransitionsDecoder));
var $author$project$Topic$Flags$ExtraTopicComments = F2(
	function (labels, transitions) {
		return {labels: labels, transitions: transitions};
	});
var $author$project$Topic$Flags$ExtraTopicCommentsLabels = function (accept) {
	return function (addComment) {
		return function (addWarning) {
			return function (ago) {
				return function (cancel) {
					return function (description) {
						return function (edit) {
							return function (edit2) {
								return function (invitation) {
									return function (member) {
										return function (more) {
											return function (reply) {
												return function (save) {
													return function (title) {
														return function (you) {
															return {accept: accept, addComment: addComment, addWarning: addWarning, ago: ago, cancel: cancel, description: description, edit: edit, edit2: edit2, invitation: invitation, member: member, more: more, reply: reply, save: save, title: title, you: you};
														};
													};
												};
											};
										};
									};
								};
							};
						};
					};
				};
			};
		};
	};
};
var $author$project$Topic$Flags$ExtraTopicCommentsLabelsAccept = function (label) {
	return {label: label};
};
var $author$project$Topic$Flags$extraTopicCommentsLabelsAcceptDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Topic$Flags$ExtraTopicCommentsLabelsAccept,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicCommentsLabelsAddComment = F2(
	function (label, width) {
		return {label: label, width: width};
	});
var $author$project$Topic$Flags$extraTopicCommentsLabelsAddCommentDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Topic$Flags$ExtraTopicCommentsLabelsAddComment,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicCommentsLabelsAddWarning = function (description) {
	return {description: description};
};
var $author$project$Topic$Flags$extraTopicCommentsLabelsAddWarningDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Topic$Flags$ExtraTopicCommentsLabelsAddWarning,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicCommentsLabelsAgo = F9(
	function (day, days, hour, hours, label, minute, minutes, week, weeks) {
		return {day: day, days: days, hour: hour, hours: hours, label: label, minute: minute, minutes: minutes, week: week, weeks: weeks};
	});
var $author$project$Topic$Flags$extraTopicCommentsLabelsAgoDecoder = function () {
	var fieldSet0 = A9(
		$elm$json$Json$Decode$map8,
		$author$project$Topic$Flags$ExtraTopicCommentsLabelsAgo,
		A2($elm$json$Json$Decode$field, 'day', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'days', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'hour', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'hours', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'minute', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'minutes', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'week', $elm$json$Json$Decode$string));
	return A3(
		$elm$json$Json$Decode$map2,
		$elm$core$Basics$apL,
		fieldSet0,
		A2($elm$json$Json$Decode$field, 'weeks', $elm$json$Json$Decode$string));
}();
var $author$project$Topic$Flags$ExtraTopicCommentsLabelsCancel = function (label) {
	return {label: label};
};
var $author$project$Topic$Flags$extraTopicCommentsLabelsCancelDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Topic$Flags$ExtraTopicCommentsLabelsCancel,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicCommentsLabelsDescription = function (label) {
	return {label: label};
};
var $author$project$Topic$Flags$extraTopicCommentsLabelsDescriptionDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Topic$Flags$ExtraTopicCommentsLabelsDescription,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicCommentsLabelsEdit2 = function (label) {
	return {label: label};
};
var $author$project$Topic$Flags$extraTopicCommentsLabelsEdit2Decoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Topic$Flags$ExtraTopicCommentsLabelsEdit2,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicCommentsLabelsEdit = function (label) {
	return {label: label};
};
var $author$project$Topic$Flags$extraTopicCommentsLabelsEditDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Topic$Flags$ExtraTopicCommentsLabelsEdit,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicCommentsLabelsInvitation = function (description) {
	return {description: description};
};
var $author$project$Topic$Flags$extraTopicCommentsLabelsInvitationDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Topic$Flags$ExtraTopicCommentsLabelsInvitation,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicCommentsLabelsMember = function (label) {
	return {label: label};
};
var $author$project$Topic$Flags$extraTopicCommentsLabelsMemberDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Topic$Flags$ExtraTopicCommentsLabelsMember,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicCommentsLabelsMore = function (label) {
	return {label: label};
};
var $author$project$Topic$Flags$extraTopicCommentsLabelsMoreDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Topic$Flags$ExtraTopicCommentsLabelsMore,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicCommentsLabelsReply = function (label) {
	return {label: label};
};
var $author$project$Topic$Flags$extraTopicCommentsLabelsReplyDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Topic$Flags$ExtraTopicCommentsLabelsReply,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicCommentsLabelsSave = function (label) {
	return {label: label};
};
var $author$project$Topic$Flags$extraTopicCommentsLabelsSaveDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Topic$Flags$ExtraTopicCommentsLabelsSave,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicCommentsLabelsTitle = function (label) {
	return {label: label};
};
var $author$project$Topic$Flags$extraTopicCommentsLabelsTitleDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Topic$Flags$ExtraTopicCommentsLabelsTitle,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicCommentsLabelsYou = function (label) {
	return {label: label};
};
var $author$project$Topic$Flags$extraTopicCommentsLabelsYouDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Topic$Flags$ExtraTopicCommentsLabelsYou,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$extraTopicCommentsLabelsDecoder = function () {
	var fieldSet0 = A9(
		$elm$json$Json$Decode$map8,
		$author$project$Topic$Flags$ExtraTopicCommentsLabels,
		A2($elm$json$Json$Decode$field, 'accept', $author$project$Topic$Flags$extraTopicCommentsLabelsAcceptDecoder),
		A2($elm$json$Json$Decode$field, 'add_comment', $author$project$Topic$Flags$extraTopicCommentsLabelsAddCommentDecoder),
		A2($elm$json$Json$Decode$field, 'add_warning', $author$project$Topic$Flags$extraTopicCommentsLabelsAddWarningDecoder),
		A2($elm$json$Json$Decode$field, 'ago', $author$project$Topic$Flags$extraTopicCommentsLabelsAgoDecoder),
		A2($elm$json$Json$Decode$field, 'cancel', $author$project$Topic$Flags$extraTopicCommentsLabelsCancelDecoder),
		A2($elm$json$Json$Decode$field, 'description', $author$project$Topic$Flags$extraTopicCommentsLabelsDescriptionDecoder),
		A2($elm$json$Json$Decode$field, 'edit', $author$project$Topic$Flags$extraTopicCommentsLabelsEditDecoder),
		A2($elm$json$Json$Decode$field, 'edit2', $author$project$Topic$Flags$extraTopicCommentsLabelsEdit2Decoder));
	return A9(
		$elm$json$Json$Decode$map8,
		$elm$core$Basics$apL,
		fieldSet0,
		A2($elm$json$Json$Decode$field, 'invitation', $author$project$Topic$Flags$extraTopicCommentsLabelsInvitationDecoder),
		A2($elm$json$Json$Decode$field, 'member', $author$project$Topic$Flags$extraTopicCommentsLabelsMemberDecoder),
		A2($elm$json$Json$Decode$field, 'more', $author$project$Topic$Flags$extraTopicCommentsLabelsMoreDecoder),
		A2($elm$json$Json$Decode$field, 'reply', $author$project$Topic$Flags$extraTopicCommentsLabelsReplyDecoder),
		A2($elm$json$Json$Decode$field, 'save', $author$project$Topic$Flags$extraTopicCommentsLabelsSaveDecoder),
		A2($elm$json$Json$Decode$field, 'title', $author$project$Topic$Flags$extraTopicCommentsLabelsTitleDecoder),
		A2($elm$json$Json$Decode$field, 'you', $author$project$Topic$Flags$extraTopicCommentsLabelsYouDecoder));
}();
var $author$project$Topic$Flags$ExtraTopicCommentsTransitions = function (accept) {
	return {accept: accept};
};
var $author$project$Topic$Flags$extraTopicCommentsTransitionsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Topic$Flags$ExtraTopicCommentsTransitions,
	A2($elm$json$Json$Decode$field, 'accept', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$extraTopicCommentsDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Topic$Flags$ExtraTopicComments,
	A2($elm$json$Json$Decode$field, 'labels', $author$project$Topic$Flags$extraTopicCommentsLabelsDecoder),
	A2($elm$json$Json$Decode$field, 'transitions', $author$project$Topic$Flags$extraTopicCommentsTransitionsDecoder));
var $author$project$Topic$Flags$ExtraTopicDetails = F3(
	function (errors, labels, readonly) {
		return {errors: errors, labels: labels, readonly: readonly};
	});
var $author$project$Topic$Flags$ExtraTopicDetailsErrors = function (title) {
	return {title: title};
};
var $author$project$Topic$Flags$ExtraTopicDetailsErrorsTitle = function (syntax) {
	return {syntax: syntax};
};
var $author$project$Topic$Flags$extraTopicDetailsErrorsTitleDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Topic$Flags$ExtraTopicDetailsErrorsTitle,
	A2($elm$json$Json$Decode$field, 'syntax', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$extraTopicDetailsErrorsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Topic$Flags$ExtraTopicDetailsErrors,
	A2($elm$json$Json$Decode$field, 'title', $author$project$Topic$Flags$extraTopicDetailsErrorsTitleDecoder));
var $author$project$Topic$Flags$ExtraTopicDetailsLabels = F2(
	function (description, title) {
		return {description: description, title: title};
	});
var $author$project$Topic$Flags$ExtraTopicDetailsLabelsDescription = F3(
	function (description, label, placeholder) {
		return {description: description, label: label, placeholder: placeholder};
	});
var $author$project$Topic$Flags$extraTopicDetailsLabelsDescriptionDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Topic$Flags$ExtraTopicDetailsLabelsDescription,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'placeholder', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicDetailsLabelsTitle = F3(
	function (description, label, placeholder) {
		return {description: description, label: label, placeholder: placeholder};
	});
var $author$project$Topic$Flags$extraTopicDetailsLabelsTitleDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Topic$Flags$ExtraTopicDetailsLabelsTitle,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'placeholder', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$extraTopicDetailsLabelsDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Topic$Flags$ExtraTopicDetailsLabels,
	A2($elm$json$Json$Decode$field, 'description', $author$project$Topic$Flags$extraTopicDetailsLabelsDescriptionDecoder),
	A2($elm$json$Json$Decode$field, 'title', $author$project$Topic$Flags$extraTopicDetailsLabelsTitleDecoder));
var $author$project$Topic$Flags$extraTopicDetailsDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Topic$Flags$ExtraTopicDetails,
	A2($elm$json$Json$Decode$field, 'errors', $author$project$Topic$Flags$extraTopicDetailsErrorsDecoder),
	A2($elm$json$Json$Decode$field, 'labels', $author$project$Topic$Flags$extraTopicDetailsLabelsDecoder),
	A2($elm$json$Json$Decode$field, 'readonly', $elm$json$Json$Decode$bool));
var $author$project$Topic$Flags$ExtraTopicMembers = function (labels) {
	return {labels: labels};
};
var $author$project$Topic$Flags$ExtraTopicMembersLabels = F9(
	function (accepted, checkbox, description, description2, note, participants, shareWith, title, who) {
		return {accepted: accepted, checkbox: checkbox, description: description, description2: description2, note: note, participants: participants, shareWith: shareWith, title: title, who: who};
	});
var $author$project$Topic$Flags$ExtraTopicMembersLabelsAccepted = F4(
	function (datalabel, description, value, width) {
		return {datalabel: datalabel, description: description, value: value, width: width};
	});
var $author$project$Topic$Flags$extraTopicMembersLabelsAcceptedDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$Topic$Flags$ExtraTopicMembersLabelsAccepted,
	A2($elm$json$Json$Decode$field, 'datalabel', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'value', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicMembersLabelsCheckbox = function (width) {
	return {width: width};
};
var $author$project$Topic$Flags$extraTopicMembersLabelsCheckboxDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Topic$Flags$ExtraTopicMembersLabelsCheckbox,
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicMembersLabelsDescription2 = function (label) {
	return {label: label};
};
var $author$project$Topic$Flags$extraTopicMembersLabelsDescription2Decoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Topic$Flags$ExtraTopicMembersLabelsDescription2,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicMembersLabelsDescription = function (label) {
	return {label: label};
};
var $author$project$Topic$Flags$extraTopicMembersLabelsDescriptionDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Topic$Flags$ExtraTopicMembersLabelsDescription,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicMembersLabelsNote = F2(
	function (label, width) {
		return {label: label, width: width};
	});
var $author$project$Topic$Flags$extraTopicMembersLabelsNoteDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Topic$Flags$ExtraTopicMembersLabelsNote,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicMembersLabelsParticipants = function (label) {
	return {label: label};
};
var $author$project$Topic$Flags$extraTopicMembersLabelsParticipantsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Topic$Flags$ExtraTopicMembersLabelsParticipants,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicMembersLabelsShareWith = F2(
	function (label, none) {
		return {label: label, none: none};
	});
var $author$project$Topic$Flags$extraTopicMembersLabelsShareWithDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Topic$Flags$ExtraTopicMembersLabelsShareWith,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'none', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicMembersLabelsTitle = F2(
	function (label, width) {
		return {label: label, width: width};
	});
var $author$project$Topic$Flags$extraTopicMembersLabelsTitleDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Topic$Flags$ExtraTopicMembersLabelsTitle,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicMembersLabelsWho = F2(
	function (label, width) {
		return {label: label, width: width};
	});
var $author$project$Topic$Flags$extraTopicMembersLabelsWhoDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Topic$Flags$ExtraTopicMembersLabelsWho,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$extraTopicMembersLabelsDecoder = function () {
	var fieldSet0 = A9(
		$elm$json$Json$Decode$map8,
		$author$project$Topic$Flags$ExtraTopicMembersLabels,
		A2($elm$json$Json$Decode$field, 'accepted', $author$project$Topic$Flags$extraTopicMembersLabelsAcceptedDecoder),
		A2($elm$json$Json$Decode$field, 'checkbox', $author$project$Topic$Flags$extraTopicMembersLabelsCheckboxDecoder),
		A2($elm$json$Json$Decode$field, 'description', $author$project$Topic$Flags$extraTopicMembersLabelsDescriptionDecoder),
		A2($elm$json$Json$Decode$field, 'description2', $author$project$Topic$Flags$extraTopicMembersLabelsDescription2Decoder),
		A2($elm$json$Json$Decode$field, 'note', $author$project$Topic$Flags$extraTopicMembersLabelsNoteDecoder),
		A2($elm$json$Json$Decode$field, 'participants', $author$project$Topic$Flags$extraTopicMembersLabelsParticipantsDecoder),
		A2($elm$json$Json$Decode$field, 'share_with', $author$project$Topic$Flags$extraTopicMembersLabelsShareWithDecoder),
		A2($elm$json$Json$Decode$field, 'title', $author$project$Topic$Flags$extraTopicMembersLabelsTitleDecoder));
	return A3(
		$elm$json$Json$Decode$map2,
		$elm$core$Basics$apL,
		fieldSet0,
		A2($elm$json$Json$Decode$field, 'who', $author$project$Topic$Flags$extraTopicMembersLabelsWhoDecoder));
}();
var $author$project$Topic$Flags$extraTopicMembersDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Topic$Flags$ExtraTopicMembers,
	A2($elm$json$Json$Decode$field, 'labels', $author$project$Topic$Flags$extraTopicMembersLabelsDecoder));
var $author$project$Topic$Flags$ExtraTopicReview = F3(
	function (errors, labels, transitions) {
		return {errors: errors, labels: labels, transitions: transitions};
	});
var $author$project$Topic$Flags$ExtraTopicReviewErrors = function (path) {
	return {path: path};
};
var $author$project$Topic$Flags$ExtraTopicReviewErrorsPath = F2(
	function (reserved, syntax) {
		return {reserved: reserved, syntax: syntax};
	});
var $author$project$Topic$Flags$extraTopicReviewErrorsPathDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Topic$Flags$ExtraTopicReviewErrorsPath,
	A2($elm$json$Json$Decode$field, 'reserved', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'syntax', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$extraTopicReviewErrorsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Topic$Flags$ExtraTopicReviewErrors,
	A2($elm$json$Json$Decode$field, 'path', $author$project$Topic$Flags$extraTopicReviewErrorsPathDecoder));
var $author$project$Topic$Flags$ExtraTopicReviewLabels = F7(
	function (close, open, openreview, options, path, pause, preview) {
		return {close: close, open: open, openreview: openreview, options: options, path: path, pause: pause, preview: preview};
	});
var $author$project$Topic$Flags$ExtraTopicReviewLabelsClose = F2(
	function (label, width) {
		return {label: label, width: width};
	});
var $author$project$Topic$Flags$extraTopicReviewLabelsCloseDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Topic$Flags$ExtraTopicReviewLabelsClose,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicReviewLabelsOpen = function (label) {
	return {label: label};
};
var $author$project$Topic$Flags$extraTopicReviewLabelsOpenDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Topic$Flags$ExtraTopicReviewLabelsOpen,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicReviewLabelsOpenreview = function (label) {
	return {label: label};
};
var $author$project$Topic$Flags$extraTopicReviewLabelsOpenreviewDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Topic$Flags$ExtraTopicReviewLabelsOpenreview,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicReviewLabelsOptions = function (label) {
	return {label: label};
};
var $author$project$Topic$Flags$extraTopicReviewLabelsOptionsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Topic$Flags$ExtraTopicReviewLabelsOptions,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicReviewLabelsPath = F3(
	function (description, label, placeholder) {
		return {description: description, label: label, placeholder: placeholder};
	});
var $author$project$Topic$Flags$extraTopicReviewLabelsPathDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Topic$Flags$ExtraTopicReviewLabelsPath,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'placeholder', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicReviewLabelsPause = F2(
	function (description, label) {
		return {description: description, label: label};
	});
var $author$project$Topic$Flags$extraTopicReviewLabelsPauseDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Topic$Flags$ExtraTopicReviewLabelsPause,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicReviewLabelsPreview = F3(
	function (label, proceed, width) {
		return {label: label, proceed: proceed, width: width};
	});
var $author$project$Topic$Flags$extraTopicReviewLabelsPreviewDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Topic$Flags$ExtraTopicReviewLabelsPreview,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'proceed', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$extraTopicReviewLabelsDecoder = A8(
	$elm$json$Json$Decode$map7,
	$author$project$Topic$Flags$ExtraTopicReviewLabels,
	A2($elm$json$Json$Decode$field, 'close', $author$project$Topic$Flags$extraTopicReviewLabelsCloseDecoder),
	A2($elm$json$Json$Decode$field, 'open', $author$project$Topic$Flags$extraTopicReviewLabelsOpenDecoder),
	A2($elm$json$Json$Decode$field, 'openreview', $author$project$Topic$Flags$extraTopicReviewLabelsOpenreviewDecoder),
	A2($elm$json$Json$Decode$field, 'options', $author$project$Topic$Flags$extraTopicReviewLabelsOptionsDecoder),
	A2($elm$json$Json$Decode$field, 'path', $author$project$Topic$Flags$extraTopicReviewLabelsPathDecoder),
	A2($elm$json$Json$Decode$field, 'pause', $author$project$Topic$Flags$extraTopicReviewLabelsPauseDecoder),
	A2($elm$json$Json$Decode$field, 'preview', $author$project$Topic$Flags$extraTopicReviewLabelsPreviewDecoder));
var $author$project$Topic$Flags$ExtraTopicReviewTransitions = F2(
	function (frame, review) {
		return {frame: frame, review: review};
	});
var $author$project$Topic$Flags$extraTopicReviewTransitionsDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Topic$Flags$ExtraTopicReviewTransitions,
	A2($elm$json$Json$Decode$field, 'frame', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'review', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$extraTopicReviewDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Topic$Flags$ExtraTopicReview,
	A2($elm$json$Json$Decode$field, 'errors', $author$project$Topic$Flags$extraTopicReviewErrorsDecoder),
	A2($elm$json$Json$Decode$field, 'labels', $author$project$Topic$Flags$extraTopicReviewLabelsDecoder),
	A2($elm$json$Json$Decode$field, 'transitions', $author$project$Topic$Flags$extraTopicReviewTransitionsDecoder));
var $author$project$Topic$Flags$ExtraTopicSubmit = F3(
	function (labels, requests, transitions) {
		return {labels: labels, requests: requests, transitions: transitions};
	});
var $author$project$Topic$Flags$ExtraTopicSubmitLabels = F5(
	function (description, pause, submit, title, transition) {
		return {description: description, pause: pause, submit: submit, title: title, transition: transition};
	});
var $author$project$Topic$Flags$ExtraTopicSubmitLabelsDescription = function (label) {
	return {label: label};
};
var $author$project$Topic$Flags$extraTopicSubmitLabelsDescriptionDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Topic$Flags$ExtraTopicSubmitLabelsDescription,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicSubmitLabelsPause = F2(
	function (description, label) {
		return {description: description, label: label};
	});
var $author$project$Topic$Flags$extraTopicSubmitLabelsPauseDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Topic$Flags$ExtraTopicSubmitLabelsPause,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicSubmitLabelsSubmit = F6(
	function (changed, failed, label, unchanged, updated, width) {
		return {changed: changed, failed: failed, label: label, unchanged: unchanged, updated: updated, width: width};
	});
var $author$project$Topic$Flags$extraTopicSubmitLabelsSubmitDecoder = A7(
	$elm$json$Json$Decode$map6,
	$author$project$Topic$Flags$ExtraTopicSubmitLabelsSubmit,
	A2($elm$json$Json$Decode$field, 'changed', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'failed', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'unchanged', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'updated', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicSubmitLabelsTitle = function (label) {
	return {label: label};
};
var $author$project$Topic$Flags$extraTopicSubmitLabelsTitleDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Topic$Flags$ExtraTopicSubmitLabelsTitle,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicSubmitLabelsTransition = function (label) {
	return {label: label};
};
var $author$project$Topic$Flags$extraTopicSubmitLabelsTransitionDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Topic$Flags$ExtraTopicSubmitLabelsTransition,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$extraTopicSubmitLabelsDecoder = A6(
	$elm$json$Json$Decode$map5,
	$author$project$Topic$Flags$ExtraTopicSubmitLabels,
	A2($elm$json$Json$Decode$field, 'description', $author$project$Topic$Flags$extraTopicSubmitLabelsDescriptionDecoder),
	A2($elm$json$Json$Decode$field, 'pause', $author$project$Topic$Flags$extraTopicSubmitLabelsPauseDecoder),
	A2($elm$json$Json$Decode$field, 'submit', $author$project$Topic$Flags$extraTopicSubmitLabelsSubmitDecoder),
	A2($elm$json$Json$Decode$field, 'title', $author$project$Topic$Flags$extraTopicSubmitLabelsTitleDecoder),
	A2($elm$json$Json$Decode$field, 'transition', $author$project$Topic$Flags$extraTopicSubmitLabelsTransitionDecoder));
var $author$project$Topic$Flags$ExtraTopicSubmitRequests = function (submit) {
	return {submit: submit};
};
var $author$project$Topic$Flags$extraTopicSubmitRequestsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Topic$Flags$ExtraTopicSubmitRequests,
	A2($elm$json$Json$Decode$field, 'submit', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$ExtraTopicSubmitTransitions = function (view) {
	return {view: view};
};
var $author$project$Topic$Flags$extraTopicSubmitTransitionsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Topic$Flags$ExtraTopicSubmitTransitions,
	A2($elm$json$Json$Decode$field, 'view', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$extraTopicSubmitDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Topic$Flags$ExtraTopicSubmit,
	A2($elm$json$Json$Decode$field, 'labels', $author$project$Topic$Flags$extraTopicSubmitLabelsDecoder),
	A2($elm$json$Json$Decode$field, 'requests', $author$project$Topic$Flags$extraTopicSubmitRequestsDecoder),
	A2($elm$json$Json$Decode$field, 'transitions', $author$project$Topic$Flags$extraTopicSubmitTransitionsDecoder));
var $author$project$Topic$Flags$extraDecoder = function () {
	var fieldSet0 = A9(
		$elm$json$Json$Decode$map8,
		$author$project$Topic$Flags$Extra,
		A2($elm$json$Json$Decode$field, 'mode', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'module', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'plurals', $author$project$Topic$Flags$extraPluralsDecoder),
		A2($elm$json$Json$Decode$field, 'progress_view', $author$project$Topic$Flags$extraProgressViewDecoder),
		A2($elm$json$Json$Decode$field, 'remote_data', $author$project$Topic$Flags$extraRemoteDataDecoder),
		A2($elm$json$Json$Decode$field, 'topic_bundles', $author$project$Topic$Flags$extraTopicBundlesDecoder),
		A2($elm$json$Json$Decode$field, 'topic_comments', $author$project$Topic$Flags$extraTopicCommentsDecoder),
		A2($elm$json$Json$Decode$field, 'topic_details', $author$project$Topic$Flags$extraTopicDetailsDecoder));
	return A6(
		$elm$json$Json$Decode$map5,
		$elm$core$Basics$apL,
		fieldSet0,
		A2($elm$json$Json$Decode$field, 'topic_members', $author$project$Topic$Flags$extraTopicMembersDecoder),
		A2($elm$json$Json$Decode$field, 'topic_review', $author$project$Topic$Flags$extraTopicReviewDecoder),
		A2($elm$json$Json$Decode$field, 'topic_submit', $author$project$Topic$Flags$extraTopicSubmitDecoder),
		A2(
			$elm$json$Json$Decode$field,
			'view_nodes',
			$elm$json$Json$Decode$list($elm$json$Json$Decode$string)));
}();
var $author$project$Topic$Flags$FlagsConfig = F3(
	function (baseUrl, defaultLanguage, extra) {
		return {baseUrl: baseUrl, defaultLanguage: defaultLanguage, extra: extra};
	});
var $author$project$Topic$Flags$FlagsConfigExtra = F4(
	function (dev, originCollab, originReview, title) {
		return {dev: dev, originCollab: originCollab, originReview: originReview, title: title};
	});
var $author$project$Topic$Flags$flagsConfigExtraDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$Topic$Flags$FlagsConfigExtra,
	A2($elm$json$Json$Decode$field, 'dev', $elm$json$Json$Decode$bool),
	A2($elm$json$Json$Decode$field, 'origin_collab', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'origin_review', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'title', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$flagsConfigDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Topic$Flags$FlagsConfig,
	A2($elm$json$Json$Decode$field, 'base_url', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'default_language', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'extra', $author$project$Topic$Flags$flagsConfigExtraDecoder));
var $author$project$Topic$Flags$FlagsWorkflowsObject = F3(
	function (name, label, progress) {
		return {label: label, name: name, progress: progress};
	});
var $author$project$Topic$Flags$FlagsWorkflowsObjectProgressObject = F2(
	function (display, messages) {
		return {display: display, messages: messages};
	});
var $author$project$Topic$Flags$FlagsWorkflowsObjectProgressObjectDisplay = F7(
	function (error, error2, init, ok, ok2, skip, skip2) {
		return {error: error, error2: error2, init: init, ok: ok, ok2: ok2, skip: skip, skip2: skip2};
	});
var $author$project$Topic$Flags$flagsWorkflowsObjectProgressObjectDisplayDecoder = A8(
	$elm$json$Json$Decode$map7,
	$author$project$Topic$Flags$FlagsWorkflowsObjectProgressObjectDisplay,
	A2($elm$json$Json$Decode$field, 'error', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'error2', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'init', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'ok', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'ok2', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'skip', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'skip2', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$FlagsWorkflowsObjectProgressObjectMessages = F2(
	function (error, ok) {
		return {error: error, ok: ok};
	});
var $author$project$Topic$Flags$flagsWorkflowsObjectProgressObjectMessagesDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Topic$Flags$FlagsWorkflowsObjectProgressObjectMessages,
	A2($elm$json$Json$Decode$field, 'error', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'ok', $elm$json$Json$Decode$string));
var $author$project$Topic$Flags$flagsWorkflowsObjectProgressObjectDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Topic$Flags$FlagsWorkflowsObjectProgressObject,
	A2($elm$json$Json$Decode$field, 'display', $author$project$Topic$Flags$flagsWorkflowsObjectProgressObjectDisplayDecoder),
	A2($elm$json$Json$Decode$field, 'messages', $author$project$Topic$Flags$flagsWorkflowsObjectProgressObjectMessagesDecoder));
var $author$project$Topic$Flags$flagsWorkflowsObjectDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Topic$Flags$FlagsWorkflowsObject,
	A2($elm$json$Json$Decode$field, 'name', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2(
		$elm$json$Json$Decode$field,
		'progress',
		$elm$json$Json$Decode$list($author$project$Topic$Flags$flagsWorkflowsObjectProgressObjectDecoder)));
var $author$project$Topic$Flags$flagsDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Topic$Flags$Flags,
	A2($elm$json$Json$Decode$field, 'config', $author$project$Topic$Flags$flagsConfigDecoder),
	A2($elm$json$Json$Decode$field, 'extra', $author$project$Topic$Flags$extraDecoder),
	A2(
		$elm$json$Json$Decode$field,
		'workflows',
		$elm$json$Json$Decode$list($author$project$Topic$Flags$flagsWorkflowsObjectDecoder)));
var $author$project$Topic$Flags$jsonToResultFlags = function (json) {
	return A2(
		$elm$core$Result$mapError,
		$elm$json$Json$Decode$errorToString,
		A2($elm$json$Json$Decode$decodeValue, $author$project$Topic$Flags$flagsDecoder, json));
};
var $author$project$Topic$Model$MembersMsg = function (a) {
	return {$: 'MembersMsg', a: a};
};
var $author$project$Topic$membersCmds = function (mcmds) {
	return A2($elm$core$Platform$Cmd$map, $author$project$Topic$Model$MembersMsg, mcmds);
};
var $author$project$Topic$membersFlags = function (flags) {
	return {labels: flags.extra.topicMembers.labels};
};
var $author$project$Topic$Model$ProgressMsg = function (a) {
	return {$: 'ProgressMsg', a: a};
};
var $author$project$Topic$progressCmds = function (pcmds) {
	return A2($elm$core$Platform$Cmd$map, $author$project$Topic$Model$ProgressMsg, pcmds);
};
var $author$project$Topic$progressFlags = function (flags) {
	return {labels: flags.extra.progressView.labels, workflows: flags.workflows};
};
var $author$project$Topic$Model$ReviewMsg = function (a) {
	return {$: 'ReviewMsg', a: a};
};
var $author$project$Topic$reviewCmds = function (rcmds) {
	return A2($elm$core$Platform$Cmd$map, $author$project$Topic$Model$ReviewMsg, rcmds);
};
var $author$project$Topic$reviewFlags = function (flags) {
	return {config: flags.config, errors: flags.extra.topicReview.errors, labels: flags.extra.topicReview.labels, transitions: flags.extra.topicReview.transitions};
};
var $author$project$Topic$init = function (value) {
	var _v0 = $author$project$Topic$Flags$jsonToResultFlags(value);
	if (_v0.$ === 'Err') {
		var err = _v0.a;
		return _Utils_Tuple2(
			$author$project$Topic$Model$Failed(err),
			$elm$core$Platform$Cmd$none);
	} else {
		var flags = _v0.a;
		var _v1 = $author$project$Progress$Model$init(
			$author$project$Topic$progressFlags(flags));
		var pstate = _v1.a;
		var pcmds = _v1.b;
		var _v2 = A2(
			$author$project$TopicMembers$Model$init,
			$author$project$Topic$membersFlags(flags),
			flags.extra.mode);
		var mstate = _v2.a;
		var mcmds = _v2.b;
		var _v3 = $author$project$TopicDetails$Model$init(
			$author$project$Topic$detailsFlags(flags));
		var dstate = _v3.a;
		var dcmds = _v3.b;
		var _v4 = A2(
			$author$project$TopicReview$Model$init,
			$author$project$Topic$reviewFlags(flags),
			dstate);
		var rstate = _v4.a;
		var rcmds = _v4.b;
		var _v5 = $author$project$TopicComments$Model$init(
			$author$project$Topic$commentsFlags(flags));
		var cstate = _v5.a;
		var ccmds = _v5.b;
		var _v6 = $author$project$TopicBundles$Model$init(
			$author$project$Topic$bundlesFlags(flags));
		var bstate = _v6.a;
		var bcmds = _v6.b;
		return _Utils_Tuple2(
			A2(
				$author$project$Topic$Model$Loaded,
				flags,
				{auth: $krisajenkins$remotedata$RemoteData$NotAsked, bundles: bstate, comments: cstate, creator_expanded: true, details: dstate, members: mstate, options_expanded: false, pause: false, progress: pstate, result: $krisajenkins$remotedata$RemoteData$NotAsked, review: rstate, tkey: $elm$core$Maybe$Nothing}),
			$elm$core$Platform$Cmd$batch(
				_List_fromArray(
					[
						$author$project$Topic$detailsCmds(dcmds),
						$author$project$Topic$bundlesCmds(bcmds),
						$author$project$Topic$reviewCmds(rcmds),
						$author$project$Topic$membersCmds(mcmds),
						$author$project$Topic$commentsCmds(ccmds),
						$author$project$Topic$progressCmds(pcmds)
					])));
	}
};
var $author$project$Topic$Model$Incoming = function (a) {
	return {$: 'Incoming', a: a};
};
var $elm$core$Platform$Sub$batch = _Platform_batch;
var $elm$core$Platform$Sub$map = _Platform_map;
var $elm$core$Platform$Sub$none = $elm$core$Platform$Sub$batch(_List_Nil);
var $elm$time$Time$Every = F2(
	function (a, b) {
		return {$: 'Every', a: a, b: b};
	});
var $elm$time$Time$State = F2(
	function (taggers, processes) {
		return {processes: processes, taggers: taggers};
	});
var $elm$time$Time$init = $elm$core$Task$succeed(
	A2($elm$time$Time$State, $elm$core$Dict$empty, $elm$core$Dict$empty));
var $elm$time$Time$addMySub = F2(
	function (_v0, state) {
		var interval = _v0.a;
		var tagger = _v0.b;
		var _v1 = A2($elm$core$Dict$get, interval, state);
		if (_v1.$ === 'Nothing') {
			return A3(
				$elm$core$Dict$insert,
				interval,
				_List_fromArray(
					[tagger]),
				state);
		} else {
			var taggers = _v1.a;
			return A3(
				$elm$core$Dict$insert,
				interval,
				A2($elm$core$List$cons, tagger, taggers),
				state);
		}
	});
var $elm$core$Process$kill = _Scheduler_kill;
var $elm$core$Dict$foldl = F3(
	function (func, acc, dict) {
		foldl:
		while (true) {
			if (dict.$ === 'RBEmpty_elm_builtin') {
				return acc;
			} else {
				var key = dict.b;
				var value = dict.c;
				var left = dict.d;
				var right = dict.e;
				var $temp$func = func,
					$temp$acc = A3(
					func,
					key,
					value,
					A3($elm$core$Dict$foldl, func, acc, left)),
					$temp$dict = right;
				func = $temp$func;
				acc = $temp$acc;
				dict = $temp$dict;
				continue foldl;
			}
		}
	});
var $elm$core$Dict$merge = F6(
	function (leftStep, bothStep, rightStep, leftDict, rightDict, initialResult) {
		var stepState = F3(
			function (rKey, rValue, _v0) {
				stepState:
				while (true) {
					var list = _v0.a;
					var result = _v0.b;
					if (!list.b) {
						return _Utils_Tuple2(
							list,
							A3(rightStep, rKey, rValue, result));
					} else {
						var _v2 = list.a;
						var lKey = _v2.a;
						var lValue = _v2.b;
						var rest = list.b;
						if (_Utils_cmp(lKey, rKey) < 0) {
							var $temp$rKey = rKey,
								$temp$rValue = rValue,
								$temp$_v0 = _Utils_Tuple2(
								rest,
								A3(leftStep, lKey, lValue, result));
							rKey = $temp$rKey;
							rValue = $temp$rValue;
							_v0 = $temp$_v0;
							continue stepState;
						} else {
							if (_Utils_cmp(lKey, rKey) > 0) {
								return _Utils_Tuple2(
									list,
									A3(rightStep, rKey, rValue, result));
							} else {
								return _Utils_Tuple2(
									rest,
									A4(bothStep, lKey, lValue, rValue, result));
							}
						}
					}
				}
			});
		var _v3 = A3(
			$elm$core$Dict$foldl,
			stepState,
			_Utils_Tuple2(
				$elm$core$Dict$toList(leftDict),
				initialResult),
			rightDict);
		var leftovers = _v3.a;
		var intermediateResult = _v3.b;
		return A3(
			$elm$core$List$foldl,
			F2(
				function (_v4, result) {
					var k = _v4.a;
					var v = _v4.b;
					return A3(leftStep, k, v, result);
				}),
			intermediateResult,
			leftovers);
	});
var $elm$core$Platform$sendToSelf = _Platform_sendToSelf;
var $elm$time$Time$setInterval = _Time_setInterval;
var $elm$core$Process$spawn = _Scheduler_spawn;
var $elm$time$Time$spawnHelp = F3(
	function (router, intervals, processes) {
		if (!intervals.b) {
			return $elm$core$Task$succeed(processes);
		} else {
			var interval = intervals.a;
			var rest = intervals.b;
			var spawnTimer = $elm$core$Process$spawn(
				A2(
					$elm$time$Time$setInterval,
					interval,
					A2($elm$core$Platform$sendToSelf, router, interval)));
			var spawnRest = function (id) {
				return A3(
					$elm$time$Time$spawnHelp,
					router,
					rest,
					A3($elm$core$Dict$insert, interval, id, processes));
			};
			return A2($elm$core$Task$andThen, spawnRest, spawnTimer);
		}
	});
var $elm$time$Time$onEffects = F3(
	function (router, subs, _v0) {
		var processes = _v0.processes;
		var rightStep = F3(
			function (_v6, id, _v7) {
				var spawns = _v7.a;
				var existing = _v7.b;
				var kills = _v7.c;
				return _Utils_Tuple3(
					spawns,
					existing,
					A2(
						$elm$core$Task$andThen,
						function (_v5) {
							return kills;
						},
						$elm$core$Process$kill(id)));
			});
		var newTaggers = A3($elm$core$List$foldl, $elm$time$Time$addMySub, $elm$core$Dict$empty, subs);
		var leftStep = F3(
			function (interval, taggers, _v4) {
				var spawns = _v4.a;
				var existing = _v4.b;
				var kills = _v4.c;
				return _Utils_Tuple3(
					A2($elm$core$List$cons, interval, spawns),
					existing,
					kills);
			});
		var bothStep = F4(
			function (interval, taggers, id, _v3) {
				var spawns = _v3.a;
				var existing = _v3.b;
				var kills = _v3.c;
				return _Utils_Tuple3(
					spawns,
					A3($elm$core$Dict$insert, interval, id, existing),
					kills);
			});
		var _v1 = A6(
			$elm$core$Dict$merge,
			leftStep,
			bothStep,
			rightStep,
			newTaggers,
			processes,
			_Utils_Tuple3(
				_List_Nil,
				$elm$core$Dict$empty,
				$elm$core$Task$succeed(_Utils_Tuple0)));
		var spawnList = _v1.a;
		var existingDict = _v1.b;
		var killTask = _v1.c;
		return A2(
			$elm$core$Task$andThen,
			function (newProcesses) {
				return $elm$core$Task$succeed(
					A2($elm$time$Time$State, newTaggers, newProcesses));
			},
			A2(
				$elm$core$Task$andThen,
				function (_v2) {
					return A3($elm$time$Time$spawnHelp, router, spawnList, existingDict);
				},
				killTask));
	});
var $elm$time$Time$onSelfMsg = F3(
	function (router, interval, state) {
		var _v0 = A2($elm$core$Dict$get, interval, state.taggers);
		if (_v0.$ === 'Nothing') {
			return $elm$core$Task$succeed(state);
		} else {
			var taggers = _v0.a;
			var tellTaggers = function (time) {
				return $elm$core$Task$sequence(
					A2(
						$elm$core$List$map,
						function (tagger) {
							return A2(
								$elm$core$Platform$sendToApp,
								router,
								tagger(time));
						},
						taggers));
			};
			return A2(
				$elm$core$Task$andThen,
				function (_v1) {
					return $elm$core$Task$succeed(state);
				},
				A2($elm$core$Task$andThen, tellTaggers, $elm$time$Time$now));
		}
	});
var $elm$core$Basics$composeL = F3(
	function (g, f, x) {
		return g(
			f(x));
	});
var $elm$time$Time$subMap = F2(
	function (f, _v0) {
		var interval = _v0.a;
		var tagger = _v0.b;
		return A2(
			$elm$time$Time$Every,
			interval,
			A2($elm$core$Basics$composeL, f, tagger));
	});
_Platform_effectManagers['Time'] = _Platform_createManager($elm$time$Time$init, $elm$time$Time$onEffects, $elm$time$Time$onSelfMsg, 0, $elm$time$Time$subMap);
var $elm$time$Time$subscription = _Platform_leaf('Time');
var $elm$time$Time$every = F2(
	function (interval, tagger) {
		return $elm$time$Time$subscription(
			A2($elm$time$Time$Every, interval, tagger));
	});
var $author$project$Shared$Clock$subscriptions = function (model) {
	return A2($elm$time$Time$every, 30 * 1000, $author$project$Shared$Clock$Tick);
};
var $author$project$TopicComments$Model$subscriptions = function (state) {
	return A2(
		$elm$core$Platform$Sub$map,
		$author$project$TopicComments$Model$ClockMsg,
		$author$project$Shared$Clock$subscriptions(state.clock));
};
var $author$project$Topic$subscriptions = function (model) {
	if (model.$ === 'Failed') {
		var err = model.a;
		return $elm$core$Platform$Sub$none;
	} else {
		var flags = model.a;
		var state = model.b;
		return $elm$core$Platform$Sub$batch(
			_List_fromArray(
				[
					$author$project$Shared$Ports$toElm($author$project$Topic$Model$Incoming),
					A2(
					$elm$core$Platform$Sub$map,
					$author$project$Topic$Model$CommentsMsg,
					$author$project$TopicComments$Model$subscriptions(state.comments))
				]));
	}
};
var $author$project$TopicBundles$Model$IncomingBundleData = F3(
	function (a, b, c) {
		return {$: 'IncomingBundleData', a: a, b: b, c: c};
	});
var $author$project$TopicComments$Model$IncomingCommentData = F2(
	function (a, b) {
		return {$: 'IncomingCommentData', a: a, b: b};
	});
var $author$project$TopicMembers$Model$IncomingNote = F2(
	function (a, b) {
		return {$: 'IncomingNote', a: a, b: b};
	});
var $author$project$TopicMembers$Model$IncomingProfileData = F2(
	function (a, b) {
		return {$: 'IncomingProfileData', a: a, b: b};
	});
var $author$project$TopicBundles$Model$IncomingTopicData = function (a) {
	return {$: 'IncomingTopicData', a: a};
};
var $author$project$TopicDetails$Model$IncomingTopicData = function (a) {
	return {$: 'IncomingTopicData', a: a};
};
var $author$project$TopicMembers$Model$IncomingTopicMembers = function (a) {
	return {$: 'IncomingTopicMembers', a: a};
};
var $author$project$TopicMembers$Model$UpdateTopicOk = {$: 'UpdateTopicOk'};
var $author$project$Topic$Model$isCreator = function (state) {
	var _v0 = _Utils_Tuple2(state.auth, state.tkey);
	if ((_v0.a.$ === 'Success') && (_v0.b.$ === 'Just')) {
		var auth = _v0.a.a;
		var tkey = _v0.b.a;
		return _Utils_eq(
			$elm$core$Maybe$Just(auth.mnum),
			$author$project$TopicData$Model$topicCreator(tkey)) ? true : false;
	} else {
		return false;
	}
};
var $author$project$Topic$Model$allowUpdate = F2(
	function (flags, state) {
		var _v0 = _Utils_Tuple3(
			flags.extra.mode,
			state.auth,
			$author$project$Topic$Model$isCreator(state));
		_v0$2:
		while (true) {
			switch (_v0.a) {
				case 'view':
					if (_v0.c) {
						return true;
					} else {
						break _v0$2;
					}
				case 'add':
					if (_v0.b.$ === 'Success') {
						var auth = _v0.b.a;
						return true;
					} else {
						break _v0$2;
					}
				default:
					break _v0$2;
			}
		}
		return false;
	});
var $elm$json$Json$Encode$object = function (pairs) {
	return _Json_wrap(
		A3(
			$elm$core$List$foldl,
			F2(
				function (_v0, obj) {
					var k = _v0.a;
					var v = _v0.b;
					return A3(_Json_addField, k, v, obj);
				}),
			_Json_emptyObject(_Utils_Tuple0),
			pairs));
};
var $author$project$Shared$Ports$toMain = _Platform_outgoingPort('toMain', $elm$core$Basics$identity);
var $elm$json$Json$Encode$int = _Json_wrap;
var $elm$time$Time$posixToMillis = function (_v0) {
	var millis = _v0.a;
	return millis;
};
var $author$project$CommentData$Encode$topicCommentToValue = F2(
	function (tkey, args) {
		var encodeWhen = _List_fromArray(
			[
				_Utils_Tuple2(
				'when',
				$elm$json$Json$Encode$int(
					$elm$time$Time$posixToMillis(args.when)))
			]);
		var encodeWhat = _List_fromArray(
			[
				_Utils_Tuple2(
				'what',
				$elm$json$Json$Encode$string(args.what))
			]);
		var encodeTkey = _List_fromArray(
			[
				_Utils_Tuple2(
				'tkey',
				$elm$json$Json$Encode$string(tkey))
			]);
		var encodePath = _List_fromArray(
			[
				_Utils_Tuple2(
				'path',
				$elm$json$Json$Encode$string(args.path))
			]);
		var encodeMnum = _List_fromArray(
			[
				_Utils_Tuple2(
				'mnum',
				$elm$json$Json$Encode$int(args.mnum))
			]);
		var encodeKind = _List_fromArray(
			[
				_Utils_Tuple2(
				'kind',
				$elm$json$Json$Encode$string('comment'))
			]);
		var encoders = _Utils_ap(
			_List_Nil,
			_Utils_ap(
				encodeKind,
				_Utils_ap(
					encodeTkey,
					_Utils_ap(
						encodeMnum,
						_Utils_ap(
							encodePath,
							_Utils_ap(encodeWhen, encodeWhat))))));
		return $elm$json$Json$Encode$object(encoders);
	});
var $author$project$Topic$Cmd$cmdSaveComment = F3(
	function (flags, state, _v0) {
		var node = _v0.a;
		var _v1 = state.tkey;
		if (_v1.$ === 'Just') {
			var tkey = _v1.a;
			var encodeTkey = _List_fromArray(
				[
					_Utils_Tuple2(
					'tkey',
					$elm$json$Json$Encode$string(tkey))
				]);
			var encodeKind = node.stored ? _List_fromArray(
				[
					_Utils_Tuple2(
					'kind',
					$elm$json$Json$Encode$string('update comment'))
				]) : _List_fromArray(
				[
					_Utils_Tuple2(
					'kind',
					$elm$json$Json$Encode$string('add comment'))
				]);
			var encodeComment = _List_fromArray(
				[
					_Utils_Tuple2(
					'comment',
					A2($author$project$CommentData$Encode$topicCommentToValue, tkey, node.detail))
				]);
			var encoders = _Utils_ap(
				_List_Nil,
				_Utils_ap(
					encodeKind,
					_Utils_ap(encodeTkey, encodeComment)));
			var request = $elm$json$Json$Encode$object(encoders);
			return _Utils_Tuple2(
				A2($author$project$Topic$Model$Loaded, flags, state),
				$author$project$Shared$Ports$toMain(request));
		} else {
			return _Utils_Tuple2(
				A2($author$project$Topic$Model$Loaded, flags, state),
				$elm$core$Platform$Cmd$none);
		}
	});
var $krisajenkins$remotedata$RemoteData$Loading = {$: 'Loading'};
var $elm$core$List$concat = function (lists) {
	return A3($elm$core$List$foldr, $elm$core$List$append, _List_Nil, lists);
};
var $elm$core$List$tail = function (list) {
	if (list.b) {
		var x = list.a;
		var xs = list.b;
		return $elm$core$Maybe$Just(xs);
	} else {
		return $elm$core$Maybe$Nothing;
	}
};
var $author$project$CommentData$Comment$getAllComments = function (root) {
	var flatComments = F2(
		function (path, n) {
			var comment = n.a;
			var helper = function (nr) {
				var reply = nr.a;
				return A2(
					flatComments,
					A2($elm$core$List$cons, reply.detail.path, path),
					nr);
			};
			var replies = $elm$core$List$concat(
				A2($elm$core$List$map, helper, comment.replies));
			return A2($elm$core$List$cons, comment.detail, replies);
		});
	var maybeComments = $elm$core$List$tail(
		A2(flatComments, _List_Nil, root));
	return A2($elm$core$Maybe$withDefault, _List_Nil, maybeComments);
};
var $elm$json$Json$Encode$list = F2(
	function (func, entries) {
		return _Json_wrap(
			A3(
				$elm$core$List$foldl,
				_Json_addEntry(func),
				_Json_emptyArray(_Utils_Tuple0),
				entries));
	});
var $author$project$TopicData$Encode$topicBundleToValue = function (args) {
	var encodeInclude = _List_fromArray(
		[
			_Utils_Tuple2(
			'include',
			$elm$json$Json$Encode$bool(args.include))
		]);
	var encodeBnum = _List_fromArray(
		[
			_Utils_Tuple2(
			'bnum',
			$elm$json$Json$Encode$int(args.bnum))
		]);
	var encoders = _Utils_ap(
		_List_Nil,
		_Utils_ap(encodeBnum, encodeInclude));
	return $elm$json$Json$Encode$object(encoders);
};
var $author$project$TopicData$Encode$topicDetailsToValue = function (args) {
	var encodeTitle = _List_fromArray(
		[
			_Utils_Tuple2(
			'title',
			$elm$json$Json$Encode$string(args.title))
		]);
	var encodePath = _List_fromArray(
		[
			_Utils_Tuple2(
			'path',
			$elm$json$Json$Encode$string(args.path))
		]);
	var encodeDescription = _List_fromArray(
		[
			_Utils_Tuple2(
			'description',
			$elm$json$Json$Encode$string(args.description))
		]);
	var encoders = _Utils_ap(
		_List_Nil,
		_Utils_ap(
			encodeTitle,
			_Utils_ap(encodeDescription, encodePath)));
	return $elm$json$Json$Encode$object(encoders);
};
var $author$project$Topic$Cmd$cmdSubmitRequest = F2(
	function (flags, state) {
		var newstate = _Utils_update(
			state,
			{result: $krisajenkins$remotedata$RemoteData$Loading});
		var ms = flags.extra.topicSubmit;
		var encodeTkey = function () {
			var _v2 = state.tkey;
			if (_v2.$ === 'Just') {
				var tkey = _v2.a;
				return _List_fromArray(
					[
						_Utils_Tuple2(
						'tkey',
						$elm$json$Json$Encode$string(tkey))
					]);
			} else {
				return _List_Nil;
			}
		}();
		var encodeRemoved = function () {
			var _v1 = ms.requests.submit;
			if (_v1 === 'update topic') {
				return _List_fromArray(
					[
						_Utils_Tuple2(
						'removed',
						A2(
							$elm$json$Json$Encode$list,
							$elm$json$Json$Encode$int,
							$elm$core$Set$toList(state.members.removed)))
					]);
			} else {
				return _List_Nil;
			}
		}();
		var encodeKind = _List_fromArray(
			[
				_Utils_Tuple2(
				'kind',
				$elm$json$Json$Encode$string(ms.requests.submit))
			]);
		var encodeDetails = _List_fromArray(
			[
				_Utils_Tuple2(
				'details',
				$author$project$TopicData$Encode$topicDetailsToValue(state.details.current.details))
			]);
		var encodeComments = function () {
			var tkey = function () {
				var _v0 = state.tkey;
				if (_v0.$ === 'Just') {
					var value = _v0.a;
					return value;
				} else {
					return 'not known yet';
				}
			}();
			var comments = $author$project$CommentData$Comment$getAllComments(state.comments.comments);
			return _List_fromArray(
				[
					_Utils_Tuple2(
					'comments',
					A2(
						$elm$json$Json$Encode$list,
						$author$project$CommentData$Encode$topicCommentToValue(tkey),
						comments))
				]);
		}();
		var encodeBundles = _List_fromArray(
			[
				_Utils_Tuple2(
				'bundles',
				A2($elm$json$Json$Encode$list, $author$project$TopicData$Encode$topicBundleToValue, state.bundles.current))
			]);
		var encodeAdded = _List_fromArray(
			[
				_Utils_Tuple2(
				'added',
				A2(
					$elm$json$Json$Encode$list,
					$elm$json$Json$Encode$int,
					$elm$core$Set$toList(state.members.added)))
			]);
		var encoders = _Utils_ap(
			_List_Nil,
			_Utils_ap(
				encodeKind,
				_Utils_ap(
					encodeTkey,
					_Utils_ap(
						encodeDetails,
						_Utils_ap(
							encodeBundles,
							_Utils_ap(
								encodeAdded,
								_Utils_ap(encodeRemoved, encodeComments)))))));
		var request = $elm$json$Json$Encode$object(encoders);
		return _Utils_Tuple2(
			A2($author$project$Topic$Model$Loaded, flags, newstate),
			$author$project$Shared$Ports$toMain(request));
	});
var $elm$core$Set$insert = F2(
	function (key, _v0) {
		var dict = _v0.a;
		return $elm$core$Set$Set_elm_builtin(
			A3($elm$core$Dict$insert, key, _Utils_Tuple0, dict));
	});
var $elm$core$Set$fromList = function (list) {
	return A3($elm$core$List$foldl, $elm$core$Set$insert, $elm$core$Set$empty, list);
};
var $author$project$CommentData$Comment$getComment = F2(
	function (path, _v0) {
		getComment:
		while (true) {
			var node = _v0.a;
			if (!path.b) {
				return $elm$core$Maybe$Just(
					$author$project$CommentData$Comment$Node(node));
			} else {
				var target = path.a;
				var rest = path.b;
				var notTarget = function (_v3) {
					var n = _v3.a;
					return !_Utils_eq(n.detail.path, target);
				};
				var _v2 = $elm$core$List$head(
					A2($elm_community$list_extra$List$Extra$dropWhile, notTarget, node.replies));
				if (_v2.$ === 'Nothing') {
					return $elm$core$Maybe$Nothing;
				} else {
					var reply = _v2.a;
					var $temp$path = rest,
						$temp$_v0 = reply;
					path = $temp$path;
					_v0 = $temp$_v0;
					continue getComment;
				}
			}
		}
	});
var $author$project$Topic$Model$isAccepted = F2(
	function (profiles, rauth) {
		if (rauth.$ === 'Success') {
			var auth = rauth.a;
			var _v1 = _Utils_Tuple2(
				auth.role,
				A2($elm$core$Dict$get, auth.mnum, profiles));
			if (_v1.a.$ === 'Host') {
				var _v2 = _v1.a;
				return true;
			} else {
				if (_v1.b.$ === 'Just') {
					var profile = _v1.b.a;
					return (!_Utils_eq(
						profile.accepted_on,
						$elm$time$Time$millisToPosix(0))) ? true : false;
				} else {
					return false;
				}
			}
		} else {
			return false;
		}
	});
var $author$project$TopicBundles$Model$topicBundlesChanged = F2(
	function (initial, current) {
		return !_Utils_eq(initial, current);
	});
var $author$project$TopicData$Model$topicDataChanged = F2(
	function (initial, current) {
		if (initial.$ === 'Nothing') {
			return true;
		} else {
			var topicData = initial.a;
			return false || ((!_Utils_eq(topicData.details, current.details)) || (!_Utils_eq(topicData.bundles, current.bundles)));
		}
	});
var $elm$core$Dict$isEmpty = function (dict) {
	if (dict.$ === 'RBEmpty_elm_builtin') {
		return true;
	} else {
		return false;
	}
};
var $elm$core$Set$isEmpty = function (_v0) {
	var dict = _v0.a;
	return $elm$core$Dict$isEmpty(dict);
};
var $author$project$TopicMembers$Model$topicMembersChanged = F2(
	function (added, removed) {
		return ($elm$core$Set$isEmpty(added) && $elm$core$Set$isEmpty(removed)) ? false : true;
	});
var $author$project$Topic$View$somethingChanged = F2(
	function (flags, state) {
		return A2($author$project$TopicData$Model$topicDataChanged, state.details.initial, state.details.current) ? true : (A2($author$project$TopicBundles$Model$topicBundlesChanged, state.bundles.initial, state.bundles.current) ? true : (A2($author$project$TopicMembers$Model$topicMembersChanged, state.members.added, state.members.removed) ? true : false));
	});
var $author$project$TopicBundles$Model$bundlesErr = function (problems) {
	return $elm_community$maybe_extra$Maybe$Extra$orList(
		_List_fromArray(
			[problems.selectedErr]));
};
var $author$project$TopicDetails$Model$detailsErr = function (problems) {
	return $elm_community$maybe_extra$Maybe$Extra$orList(
		_List_fromArray(
			[problems.currentErr, problems.titleErr]));
};
var $author$project$Topic$Model$topicErr = function (state) {
	return $elm_community$maybe_extra$Maybe$Extra$orList(
		_List_fromArray(
			[
				$author$project$TopicDetails$Model$detailsErr(state.details.problems),
				$author$project$TopicBundles$Model$bundlesErr(state.bundles.problems)
			]));
};
var $author$project$Topic$View$currentError = F2(
	function (flags, state) {
		var updated = A2($author$project$Topic$View$somethingChanged, flags, state);
		var ts = flags.extra.topicSubmit;
		var emsg = $elm_community$maybe_extra$Maybe$Extra$orList(
			_List_fromArray(
				[
					$author$project$Topic$Model$topicErr(state)
				]));
		var _v0 = _Utils_Tuple3(emsg, updated, state.result);
		if (_v0.a.$ === 'Just') {
			var x = _v0.a.a;
			return $elm$core$Result$Err(x);
		} else {
			if (_v0.b) {
				var _v1 = _v0.a;
				return $elm$core$Result$Ok(ts.labels.submit.changed);
			} else {
				if (_v0.c.$ === 'Success') {
					var _v2 = _v0.a;
					return $elm$core$Result$Ok(ts.labels.submit.updated);
				} else {
					var _v3 = _v0.a;
					return $elm$core$Result$Ok(ts.labels.submit.unchanged);
				}
			}
		}
	});
var $elm_community$result_extra$Result$Extra$isOk = function (x) {
	if (x.$ === 'Ok') {
		return true;
	} else {
		return false;
	}
};
var $author$project$Topic$View$okToSubmit = F2(
	function (flags, state) {
		return true && (A2($author$project$Topic$View$somethingChanged, flags, state) && ($elm_community$result_extra$Result$Extra$isOk(
			A2($author$project$Topic$View$currentError, flags, state)) && (!_Utils_eq(state.result, $krisajenkins$remotedata$RemoteData$Loading))));
	});
var $author$project$Shared$Tkey$commentPathRegex = A2(
	$elm$core$Maybe$withDefault,
	$elm$regex$Regex$never,
	$elm$regex$Regex$fromString('^([1-9][0-9]*)([ZABCDEFGHJ]+)(.*)$'));
var $author$project$Shared$Tkey$nextCommentPath = function (path) {
	var _v0 = A2($elm$regex$Regex$find, $author$project$Shared$Tkey$commentPathRegex, path);
	if (_v0.b && (!_v0.b.b)) {
		var match = _v0.a;
		var _v1 = match.submatches;
		_v1$2:
		while (true) {
			if ((((_v1.b && (_v1.a.$ === 'Just')) && _v1.b.b) && (_v1.b.a.$ === 'Just')) && _v1.b.b.b) {
				if (_v1.b.b.a.$ === 'Just') {
					if (!_v1.b.b.b.b) {
						var mnum = _v1.a.a;
						var _v2 = _v1.b;
						var tkstr = _v2.a.a;
						var _v3 = _v2.b;
						var rest = _v3.a.a;
						return $elm$core$Maybe$Just(
							_Utils_Tuple2(
								_Utils_ap(mnum, tkstr),
								rest));
					} else {
						break _v1$2;
					}
				} else {
					if (!_v1.b.b.b.b) {
						var mnum = _v1.a.a;
						var _v4 = _v1.b;
						var tkstr = _v4.a.a;
						var _v5 = _v4.b;
						var _v6 = _v5.a;
						return $elm$core$Maybe$Just(
							_Utils_Tuple2(
								_Utils_ap(mnum, tkstr),
								''));
					} else {
						break _v1$2;
					}
				}
			} else {
				break _v1$2;
			}
		}
		return $elm$core$Maybe$Nothing;
	} else {
		return $elm$core$Maybe$Nothing;
	}
};
var $author$project$Shared$Tkey$pathToList = function (path) {
	var _v0 = $author$project$Shared$Tkey$nextCommentPath(path);
	if (_v0.$ === 'Just') {
		var _v1 = _v0.a;
		var first = _v1.a;
		var rest = _v1.b;
		return A2(
			$elm$core$List$cons,
			first,
			A2(
				$elm$core$List$map,
				function (e) {
					return _Utils_ap(first, e);
				},
				$author$project$Shared$Tkey$pathToList(rest)));
	} else {
		return _List_Nil;
	}
};
var $author$project$Shared$Cmd$cmdTransitionNumber = F3(
	function (path, n, any) {
		return _Utils_Tuple2(
			any,
			$elm$browser$Browser$Navigation$load(
				_Utils_ap(
					path,
					$elm$core$String$fromInt(n))));
	});
var $elm_community$list_extra$List$Extra$findIndexHelp = F3(
	function (index, predicate, list) {
		findIndexHelp:
		while (true) {
			if (!list.b) {
				return $elm$core$Maybe$Nothing;
			} else {
				var x = list.a;
				var xs = list.b;
				if (predicate(x)) {
					return $elm$core$Maybe$Just(index);
				} else {
					var $temp$index = index + 1,
						$temp$predicate = predicate,
						$temp$list = xs;
					index = $temp$index;
					predicate = $temp$predicate;
					list = $temp$list;
					continue findIndexHelp;
				}
			}
		}
	});
var $elm_community$list_extra$List$Extra$findIndex = $elm_community$list_extra$List$Extra$findIndexHelp(0);
var $elm_community$list_extra$List$Extra$splitAt = F2(
	function (n, xs) {
		return _Utils_Tuple2(
			A2($elm$core$List$take, n, xs),
			A2($elm$core$List$drop, n, xs));
	});
var $elm_community$list_extra$List$Extra$uncons = function (list) {
	if (!list.b) {
		return $elm$core$Maybe$Nothing;
	} else {
		var first = list.a;
		var rest = list.b;
		return $elm$core$Maybe$Just(
			_Utils_Tuple2(first, rest));
	}
};
var $elm_community$list_extra$List$Extra$swapAt = F3(
	function (index1, index2, l) {
		swapAt:
		while (true) {
			if (_Utils_eq(index1, index2) || (index1 < 0)) {
				return l;
			} else {
				if (_Utils_cmp(index1, index2) > 0) {
					var $temp$index1 = index2,
						$temp$index2 = index1,
						$temp$l = l;
					index1 = $temp$index1;
					index2 = $temp$index2;
					l = $temp$l;
					continue swapAt;
				} else {
					var _v0 = A2($elm_community$list_extra$List$Extra$splitAt, index1, l);
					var part1 = _v0.a;
					var tail1 = _v0.b;
					var _v1 = A2($elm_community$list_extra$List$Extra$splitAt, index2 - index1, tail1);
					var head2 = _v1.a;
					var tail2 = _v1.b;
					var _v2 = _Utils_Tuple2(
						$elm_community$list_extra$List$Extra$uncons(head2),
						$elm_community$list_extra$List$Extra$uncons(tail2));
					if ((_v2.a.$ === 'Just') && (_v2.b.$ === 'Just')) {
						var _v3 = _v2.a.a;
						var value1 = _v3.a;
						var part2 = _v3.b;
						var _v4 = _v2.b.a;
						var value2 = _v4.a;
						var part3 = _v4.b;
						return $elm$core$List$concat(
							_List_fromArray(
								[
									part1,
									A2($elm$core$List$cons, value2, part2),
									A2($elm$core$List$cons, value1, part3)
								]));
					} else {
						return l;
					}
				}
			}
		}
	});
var $author$project$TopicBundles$Model$moveDown = F2(
	function (bnum, state) {
		var _v0 = A2(
			$elm_community$list_extra$List$Extra$findIndex,
			function (item) {
				return _Utils_eq(item.bnum, bnum);
			},
			state.current);
		if (_v0.$ === 'Nothing') {
			return state;
		} else {
			var idx = _v0.a;
			var updated = A3($elm_community$list_extra$List$Extra$swapAt, idx, idx + 1, state.current);
			return _Utils_update(
				state,
				{current: updated});
		}
	});
var $author$project$TopicBundles$Model$moveUp = F2(
	function (bnum, state) {
		var _v0 = A2(
			$elm_community$list_extra$List$Extra$findIndex,
			function (item) {
				return _Utils_eq(item.bnum, bnum);
			},
			state.current);
		if (_v0.$ === 'Nothing') {
			return state;
		} else {
			if (!_v0.a) {
				return state;
			} else {
				var idx = _v0.a;
				var updated = A3($elm_community$list_extra$List$Extra$swapAt, idx - 1, idx, state.current);
				return _Utils_update(
					state,
					{current: updated});
			}
		}
	});
var $elm$core$List$any = F2(
	function (isOkay, list) {
		any:
		while (true) {
			if (!list.b) {
				return false;
			} else {
				var x = list.a;
				var xs = list.b;
				if (isOkay(x)) {
					return true;
				} else {
					var $temp$isOkay = isOkay,
						$temp$list = xs;
					isOkay = $temp$isOkay;
					list = $temp$list;
					continue any;
				}
			}
		}
	});
var $elm$core$List$member = F2(
	function (x, xs) {
		return A2(
			$elm$core$List$any,
			function (a) {
				return _Utils_eq(a, x);
			},
			xs);
	});
var $author$project$TopicBundles$Model$recalc = F2(
	function (state, items) {
		var itemnums = A2(
			$elm$core$List$map,
			function (item) {
				return item.bnum;
			},
			items);
		var bundlelist = $elm$core$Dict$toList(state.bundles);
		var bundlenums = A2(
			$elm$core$List$map,
			function (_v0) {
				var i = _v0.a;
				return i;
			},
			bundlelist);
		var missing = A2(
			$elm$core$List$filter,
			function (n) {
				return !A2($elm$core$List$member, n, itemnums);
			},
			bundlenums);
		return _Utils_ap(
			items,
			A2(
				$elm$core$List$map,
				function (n) {
					return {bnum: n, include: false};
				},
				missing));
	});
var $author$project$TopicBundles$Model$updateBundle = F4(
	function (key, data, stats, state) {
		var newbundle = {data: data, stats: stats};
		return _Utils_update(
			state,
			{
				bundles: A3($elm$core$Dict$insert, key, newbundle, state.bundles)
			});
	});
var $author$project$TopicBundles$Model$updateInclude = F4(
	function (flags, bnum, included, state) {
		var updateItem = function (item) {
			return _Utils_eq(item.bnum, bnum) ? _Utils_update(
				item,
				{include: included}) : item;
		};
		var updated = A2($elm$core$List$map, updateItem, state.current);
		return _Utils_update(
			state,
			{current: updated});
	});
var $author$project$TopicBundles$Model$update = F5(
	function (flags, state1, accepted, allowupdate, msg) {
		var _v0 = A2($author$project$Shared$Dbg$log, 'TopicBundles update', msg);
		switch (_v0.$) {
			case 'UpdateInclude':
				var bnum = _v0.a;
				var value = _v0.b;
				var state = A4($author$project$TopicBundles$Model$updateInclude, flags, bnum, value, state1);
				return _Utils_Tuple2(
					A3($author$project$TopicBundles$Model$validateState, flags, state, accepted),
					$elm$core$Platform$Cmd$none);
			case 'PressMoveUp':
				var bnum = _v0.a;
				var state = A2($author$project$TopicBundles$Model$moveUp, bnum, state1);
				return _Utils_Tuple2(state, $elm$core$Platform$Cmd$none);
			case 'PressMoveDown':
				var bnum = _v0.a;
				var state = A2($author$project$TopicBundles$Model$moveDown, bnum, state1);
				return _Utils_Tuple2(state, $elm$core$Platform$Cmd$none);
			case 'PressDetails':
				var bnum = _v0.a;
				return A3($author$project$Shared$Cmd$cmdTransitionNumber, flags.transitions.details, bnum, state1);
			case 'PressReset':
				var state = _Utils_update(
					state1,
					{current: state1.initial});
				return _Utils_Tuple2(
					A3($author$project$TopicBundles$Model$validateState, flags, state, accepted),
					$elm$core$Platform$Cmd$none);
			case 'IncomingBundleData':
				var bnum = _v0.a;
				var data = _v0.b;
				var stats = _v0.c;
				var state2 = A4($author$project$TopicBundles$Model$updateBundle, bnum, data, stats, state1);
				var initial2 = allowupdate ? A2($author$project$TopicBundles$Model$recalc, state2, state2.initial) : state2.initial;
				var current2 = allowupdate ? A2($author$project$TopicBundles$Model$recalc, state2, state2.current) : state2.current;
				var state = _Utils_update(
					state2,
					{current: current2, initial: initial2});
				return _Utils_Tuple2(
					A3($author$project$TopicBundles$Model$validateState, flags, state, accepted),
					$elm$core$Platform$Cmd$none);
			default:
				var topic = _v0.a;
				var initial = allowupdate ? A2($author$project$TopicBundles$Model$recalc, state1, topic.bundles) : A2(
					$elm$core$List$filter,
					function (b) {
						return b.include;
					},
					topic.bundles);
				var state = _Utils_update(
					state1,
					{current: initial, initial: initial});
				return _Utils_Tuple2(
					A3($author$project$TopicBundles$Model$validateState, flags, state, accepted),
					$elm$core$Platform$Cmd$none);
		}
	});
var $author$project$TopicDetails$Model$update = F3(
	function (flags, state, msg) {
		var problems = state.problems;
		var current = state.current;
		var details = current.details;
		switch (msg.$) {
			case 'UpdateTitle':
				var value = msg.a;
				var newstate = _Utils_update(
					state,
					{
						current: _Utils_update(
							current,
							{
								details: _Utils_update(
									details,
									{title: value})
							}),
						problems: _Utils_update(
							problems,
							{
								titleErr: A2(
									$author$project$TopicData$Valid$titleErr,
									$author$project$TopicDetails$Model$dataErrors(flags),
									value)
							})
					});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			case 'UpdateDescription':
				var value = msg.a;
				var newstate = _Utils_update(
					state,
					{
						current: _Utils_update(
							current,
							{
								details: _Utils_update(
									details,
									{description: value})
							})
					});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			case 'IncomingAuth':
				var mnum = msg.a;
				var newstate = _Utils_update(
					state,
					{
						mnum: $elm$core$Maybe$Just(mnum)
					});
				return _Utils_Tuple2(
					A2($author$project$TopicDetails$Model$validateState, flags, newstate),
					$elm$core$Platform$Cmd$none);
			case 'IncomingTopicData':
				var topic = msg.a;
				var newstate = _Utils_update(
					state,
					{
						current: topic,
						initial: $elm$core$Maybe$Just(topic)
					});
				return _Utils_Tuple2(
					A2($author$project$TopicDetails$Model$validateState, flags, newstate),
					$elm$core$Platform$Cmd$none);
			default:
				var newstate = _Utils_update(
					state,
					{
						initial: $elm$core$Maybe$Just(current)
					});
				return _Utils_Tuple2(
					A2($author$project$TopicDetails$Model$validateState, flags, newstate),
					$elm$core$Platform$Cmd$none);
		}
	});
var $elm$core$Dict$getMin = function (dict) {
	getMin:
	while (true) {
		if ((dict.$ === 'RBNode_elm_builtin') && (dict.d.$ === 'RBNode_elm_builtin')) {
			var left = dict.d;
			var $temp$dict = left;
			dict = $temp$dict;
			continue getMin;
		} else {
			return dict;
		}
	}
};
var $elm$core$Dict$moveRedLeft = function (dict) {
	if (((dict.$ === 'RBNode_elm_builtin') && (dict.d.$ === 'RBNode_elm_builtin')) && (dict.e.$ === 'RBNode_elm_builtin')) {
		if ((dict.e.d.$ === 'RBNode_elm_builtin') && (dict.e.d.a.$ === 'Red')) {
			var clr = dict.a;
			var k = dict.b;
			var v = dict.c;
			var _v1 = dict.d;
			var lClr = _v1.a;
			var lK = _v1.b;
			var lV = _v1.c;
			var lLeft = _v1.d;
			var lRight = _v1.e;
			var _v2 = dict.e;
			var rClr = _v2.a;
			var rK = _v2.b;
			var rV = _v2.c;
			var rLeft = _v2.d;
			var _v3 = rLeft.a;
			var rlK = rLeft.b;
			var rlV = rLeft.c;
			var rlL = rLeft.d;
			var rlR = rLeft.e;
			var rRight = _v2.e;
			return A5(
				$elm$core$Dict$RBNode_elm_builtin,
				$elm$core$Dict$Red,
				rlK,
				rlV,
				A5(
					$elm$core$Dict$RBNode_elm_builtin,
					$elm$core$Dict$Black,
					k,
					v,
					A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Red, lK, lV, lLeft, lRight),
					rlL),
				A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Black, rK, rV, rlR, rRight));
		} else {
			var clr = dict.a;
			var k = dict.b;
			var v = dict.c;
			var _v4 = dict.d;
			var lClr = _v4.a;
			var lK = _v4.b;
			var lV = _v4.c;
			var lLeft = _v4.d;
			var lRight = _v4.e;
			var _v5 = dict.e;
			var rClr = _v5.a;
			var rK = _v5.b;
			var rV = _v5.c;
			var rLeft = _v5.d;
			var rRight = _v5.e;
			if (clr.$ === 'Black') {
				return A5(
					$elm$core$Dict$RBNode_elm_builtin,
					$elm$core$Dict$Black,
					k,
					v,
					A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Red, lK, lV, lLeft, lRight),
					A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Red, rK, rV, rLeft, rRight));
			} else {
				return A5(
					$elm$core$Dict$RBNode_elm_builtin,
					$elm$core$Dict$Black,
					k,
					v,
					A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Red, lK, lV, lLeft, lRight),
					A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Red, rK, rV, rLeft, rRight));
			}
		}
	} else {
		return dict;
	}
};
var $elm$core$Dict$moveRedRight = function (dict) {
	if (((dict.$ === 'RBNode_elm_builtin') && (dict.d.$ === 'RBNode_elm_builtin')) && (dict.e.$ === 'RBNode_elm_builtin')) {
		if ((dict.d.d.$ === 'RBNode_elm_builtin') && (dict.d.d.a.$ === 'Red')) {
			var clr = dict.a;
			var k = dict.b;
			var v = dict.c;
			var _v1 = dict.d;
			var lClr = _v1.a;
			var lK = _v1.b;
			var lV = _v1.c;
			var _v2 = _v1.d;
			var _v3 = _v2.a;
			var llK = _v2.b;
			var llV = _v2.c;
			var llLeft = _v2.d;
			var llRight = _v2.e;
			var lRight = _v1.e;
			var _v4 = dict.e;
			var rClr = _v4.a;
			var rK = _v4.b;
			var rV = _v4.c;
			var rLeft = _v4.d;
			var rRight = _v4.e;
			return A5(
				$elm$core$Dict$RBNode_elm_builtin,
				$elm$core$Dict$Red,
				lK,
				lV,
				A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Black, llK, llV, llLeft, llRight),
				A5(
					$elm$core$Dict$RBNode_elm_builtin,
					$elm$core$Dict$Black,
					k,
					v,
					lRight,
					A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Red, rK, rV, rLeft, rRight)));
		} else {
			var clr = dict.a;
			var k = dict.b;
			var v = dict.c;
			var _v5 = dict.d;
			var lClr = _v5.a;
			var lK = _v5.b;
			var lV = _v5.c;
			var lLeft = _v5.d;
			var lRight = _v5.e;
			var _v6 = dict.e;
			var rClr = _v6.a;
			var rK = _v6.b;
			var rV = _v6.c;
			var rLeft = _v6.d;
			var rRight = _v6.e;
			if (clr.$ === 'Black') {
				return A5(
					$elm$core$Dict$RBNode_elm_builtin,
					$elm$core$Dict$Black,
					k,
					v,
					A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Red, lK, lV, lLeft, lRight),
					A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Red, rK, rV, rLeft, rRight));
			} else {
				return A5(
					$elm$core$Dict$RBNode_elm_builtin,
					$elm$core$Dict$Black,
					k,
					v,
					A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Red, lK, lV, lLeft, lRight),
					A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Red, rK, rV, rLeft, rRight));
			}
		}
	} else {
		return dict;
	}
};
var $elm$core$Dict$removeHelpPrepEQGT = F7(
	function (targetKey, dict, color, key, value, left, right) {
		if ((left.$ === 'RBNode_elm_builtin') && (left.a.$ === 'Red')) {
			var _v1 = left.a;
			var lK = left.b;
			var lV = left.c;
			var lLeft = left.d;
			var lRight = left.e;
			return A5(
				$elm$core$Dict$RBNode_elm_builtin,
				color,
				lK,
				lV,
				lLeft,
				A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Red, key, value, lRight, right));
		} else {
			_v2$2:
			while (true) {
				if ((right.$ === 'RBNode_elm_builtin') && (right.a.$ === 'Black')) {
					if (right.d.$ === 'RBNode_elm_builtin') {
						if (right.d.a.$ === 'Black') {
							var _v3 = right.a;
							var _v4 = right.d;
							var _v5 = _v4.a;
							return $elm$core$Dict$moveRedRight(dict);
						} else {
							break _v2$2;
						}
					} else {
						var _v6 = right.a;
						var _v7 = right.d;
						return $elm$core$Dict$moveRedRight(dict);
					}
				} else {
					break _v2$2;
				}
			}
			return dict;
		}
	});
var $elm$core$Dict$removeMin = function (dict) {
	if ((dict.$ === 'RBNode_elm_builtin') && (dict.d.$ === 'RBNode_elm_builtin')) {
		var color = dict.a;
		var key = dict.b;
		var value = dict.c;
		var left = dict.d;
		var lColor = left.a;
		var lLeft = left.d;
		var right = dict.e;
		if (lColor.$ === 'Black') {
			if ((lLeft.$ === 'RBNode_elm_builtin') && (lLeft.a.$ === 'Red')) {
				var _v3 = lLeft.a;
				return A5(
					$elm$core$Dict$RBNode_elm_builtin,
					color,
					key,
					value,
					$elm$core$Dict$removeMin(left),
					right);
			} else {
				var _v4 = $elm$core$Dict$moveRedLeft(dict);
				if (_v4.$ === 'RBNode_elm_builtin') {
					var nColor = _v4.a;
					var nKey = _v4.b;
					var nValue = _v4.c;
					var nLeft = _v4.d;
					var nRight = _v4.e;
					return A5(
						$elm$core$Dict$balance,
						nColor,
						nKey,
						nValue,
						$elm$core$Dict$removeMin(nLeft),
						nRight);
				} else {
					return $elm$core$Dict$RBEmpty_elm_builtin;
				}
			}
		} else {
			return A5(
				$elm$core$Dict$RBNode_elm_builtin,
				color,
				key,
				value,
				$elm$core$Dict$removeMin(left),
				right);
		}
	} else {
		return $elm$core$Dict$RBEmpty_elm_builtin;
	}
};
var $elm$core$Dict$removeHelp = F2(
	function (targetKey, dict) {
		if (dict.$ === 'RBEmpty_elm_builtin') {
			return $elm$core$Dict$RBEmpty_elm_builtin;
		} else {
			var color = dict.a;
			var key = dict.b;
			var value = dict.c;
			var left = dict.d;
			var right = dict.e;
			if (_Utils_cmp(targetKey, key) < 0) {
				if ((left.$ === 'RBNode_elm_builtin') && (left.a.$ === 'Black')) {
					var _v4 = left.a;
					var lLeft = left.d;
					if ((lLeft.$ === 'RBNode_elm_builtin') && (lLeft.a.$ === 'Red')) {
						var _v6 = lLeft.a;
						return A5(
							$elm$core$Dict$RBNode_elm_builtin,
							color,
							key,
							value,
							A2($elm$core$Dict$removeHelp, targetKey, left),
							right);
					} else {
						var _v7 = $elm$core$Dict$moveRedLeft(dict);
						if (_v7.$ === 'RBNode_elm_builtin') {
							var nColor = _v7.a;
							var nKey = _v7.b;
							var nValue = _v7.c;
							var nLeft = _v7.d;
							var nRight = _v7.e;
							return A5(
								$elm$core$Dict$balance,
								nColor,
								nKey,
								nValue,
								A2($elm$core$Dict$removeHelp, targetKey, nLeft),
								nRight);
						} else {
							return $elm$core$Dict$RBEmpty_elm_builtin;
						}
					}
				} else {
					return A5(
						$elm$core$Dict$RBNode_elm_builtin,
						color,
						key,
						value,
						A2($elm$core$Dict$removeHelp, targetKey, left),
						right);
				}
			} else {
				return A2(
					$elm$core$Dict$removeHelpEQGT,
					targetKey,
					A7($elm$core$Dict$removeHelpPrepEQGT, targetKey, dict, color, key, value, left, right));
			}
		}
	});
var $elm$core$Dict$removeHelpEQGT = F2(
	function (targetKey, dict) {
		if (dict.$ === 'RBNode_elm_builtin') {
			var color = dict.a;
			var key = dict.b;
			var value = dict.c;
			var left = dict.d;
			var right = dict.e;
			if (_Utils_eq(targetKey, key)) {
				var _v1 = $elm$core$Dict$getMin(right);
				if (_v1.$ === 'RBNode_elm_builtin') {
					var minKey = _v1.b;
					var minValue = _v1.c;
					return A5(
						$elm$core$Dict$balance,
						color,
						minKey,
						minValue,
						left,
						$elm$core$Dict$removeMin(right));
				} else {
					return $elm$core$Dict$RBEmpty_elm_builtin;
				}
			} else {
				return A5(
					$elm$core$Dict$balance,
					color,
					key,
					value,
					left,
					A2($elm$core$Dict$removeHelp, targetKey, right));
			}
		} else {
			return $elm$core$Dict$RBEmpty_elm_builtin;
		}
	});
var $elm$core$Dict$remove = F2(
	function (key, dict) {
		var _v0 = A2($elm$core$Dict$removeHelp, key, dict);
		if ((_v0.$ === 'RBNode_elm_builtin') && (_v0.a.$ === 'Red')) {
			var _v1 = _v0.a;
			var k = _v0.b;
			var v = _v0.c;
			var l = _v0.d;
			var r = _v0.e;
			return A5($elm$core$Dict$RBNode_elm_builtin, $elm$core$Dict$Black, k, v, l, r);
		} else {
			var x = _v0;
			return x;
		}
	});
var $elm$core$Dict$diff = F2(
	function (t1, t2) {
		return A3(
			$elm$core$Dict$foldl,
			F3(
				function (k, v, t) {
					return A2($elm$core$Dict$remove, k, t);
				}),
			t1,
			t2);
	});
var $elm$core$Set$diff = F2(
	function (_v0, _v1) {
		var dict1 = _v0.a;
		var dict2 = _v1.a;
		return $elm$core$Set$Set_elm_builtin(
			A2($elm$core$Dict$diff, dict1, dict2));
	});
var $elm$core$Dict$member = F2(
	function (key, dict) {
		var _v0 = A2($elm$core$Dict$get, key, dict);
		if (_v0.$ === 'Just') {
			return true;
		} else {
			return false;
		}
	});
var $elm$core$Set$member = F2(
	function (key, _v0) {
		var dict = _v0.a;
		return A2($elm$core$Dict$member, key, dict);
	});
var $elm$core$Set$remove = F2(
	function (key, _v0) {
		var dict = _v0.a;
		return $elm$core$Set$Set_elm_builtin(
			A2($elm$core$Dict$remove, key, dict));
	});
var $elm$core$Dict$union = F2(
	function (t1, t2) {
		return A3($elm$core$Dict$foldl, $elm$core$Dict$insert, t2, t1);
	});
var $elm$core$Set$union = F2(
	function (_v0, _v1) {
		var dict1 = _v0.a;
		var dict2 = _v1.a;
		return $elm$core$Set$Set_elm_builtin(
			A2($elm$core$Dict$union, dict1, dict2));
	});
var $author$project$TopicMembers$Model$update = F3(
	function (flags, state, msg) {
		switch (msg.$) {
			case 'ToggleMembersExpanded':
				var newstate = _Utils_update(
					state,
					{expanded: !state.expanded});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			case 'UpdateShared':
				var mnum = msg.a;
				var shared = msg.b;
				var newstate = shared ? _Utils_update(
					state,
					{
						added: A2($elm$core$Set$member, mnum, state.initial) ? state.added : A2($elm$core$Set$insert, mnum, state.added),
						removed: A2($elm$core$Set$remove, mnum, state.removed)
					}) : _Utils_update(
					state,
					{
						added: A2($elm$core$Set$remove, mnum, state.added),
						removed: A2($elm$core$Set$member, mnum, state.initial) ? A2($elm$core$Set$insert, mnum, state.removed) : state.removed
					});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			case 'IncomingProfileData':
				var mnum = msg.a;
				var value = msg.b;
				var newstate = _Utils_update(
					state,
					{
						profiles: A3($elm$core$Dict$insert, mnum, value, state.profiles)
					});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			case 'IncomingTopicMembers':
				var members = msg.a;
				var newstate = _Utils_update(
					state,
					{
						initial: $elm$core$Set$fromList(members)
					});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			case 'IncomingNote':
				var mnum = msg.a;
				var value = msg.b;
				var newstate = _Utils_update(
					state,
					{
						notes: A3($elm$core$Dict$insert, mnum, value, state.notes)
					});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			default:
				var initial = A2(
					$elm$core$Set$diff,
					A2($elm$core$Set$union, state.initial, state.added),
					state.removed);
				var newstate = _Utils_update(
					state,
					{added: $elm$core$Set$empty, initial: initial, removed: $elm$core$Set$empty});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
		}
	});
var $author$project$Topic$updateStateCmds = F3(
	function (flags, cmds, state) {
		return _Utils_Tuple2(
			A2($author$project$Topic$Model$Loaded, flags, state),
			cmds);
	});
var $author$project$Topic$updateBundles = F3(
	function (flags, bmsg, state) {
		var allowupdate = A2($author$project$Topic$Model$allowUpdate, flags, state);
		var accepted = A2($author$project$Topic$Model$isAccepted, state.members.profiles, state.auth);
		var _v0 = A5(
			$author$project$TopicBundles$Model$update,
			$author$project$Topic$bundlesFlags(flags),
			state.bundles,
			accepted,
			allowupdate,
			bmsg);
		var bstate = _v0.a;
		var bcmds = _v0.b;
		return A3(
			$author$project$Topic$updateStateCmds,
			flags,
			$author$project$Topic$bundlesCmds(bcmds),
			_Utils_update(
				state,
				{bundles: bstate}));
	});
var $author$project$TopicComments$Model$SaveComment = F2(
	function (a, b) {
		return {$: 'SaveComment', a: a, b: b};
	});
var $author$project$CommentData$Comment$applyUpdate = F3(
	function (updateFn, path, oldroot) {
		var node = oldroot.a;
		if (!path.b) {
			return updateFn(oldroot);
		} else {
			var target = path.a;
			var rest = path.b;
			var transform = function (cn) {
				var curNode = cn.a;
				return _Utils_eq(curNode.detail.path, target) ? A3($author$project$CommentData$Comment$applyUpdate, updateFn, rest, cn) : cn;
			};
			var newReplies = A2(
				$elm$core$List$filter,
				function (_v1) {
					var n = _v1.a;
					return !n._delete;
				},
				A2($elm$core$List$map, transform, node.replies));
			return $author$project$CommentData$Comment$Node(
				_Utils_update(
					node,
					{replies: newReplies}));
		}
	});
var $author$project$CommentData$Comment$newNode = F5(
	function (mnum, path, what, edit, stored) {
		return $author$project$CommentData$Comment$Node(
			{
				cancel: $elm$core$Maybe$Nothing,
				_delete: false,
				detail: A4($author$project$CommentData$Model$CommentData, mnum, path, $author$project$Shared$Clock$epoch, what),
				edit: edit,
				expanded: true,
				replies: _List_Nil,
				stored: stored
			});
	});
var $author$project$CommentData$Comment$addComment = F4(
	function (path, cid, mnum, oldroot) {
		var parent = function () {
			var _v1 = $elm$core$List$head(
				$elm$core$List$reverse(path));
			if (_v1.$ === 'Nothing') {
				return '';
			} else {
				var last = _v1.a;
				return last;
			}
		}();
		var newpath = _Utils_ap(parent, cid);
		var newnode = A5($author$project$CommentData$Comment$newNode, mnum, newpath, '', true, false);
		var addReply = function (_v0) {
			var node = _v0.a;
			return $author$project$CommentData$Comment$Node(
				_Utils_update(
					node,
					{
						replies: A2($elm$core$List$cons, newnode, node.replies)
					}));
		};
		return A3($author$project$CommentData$Comment$applyUpdate, addReply, path, oldroot);
	});
var $author$project$CommentData$Comment$cancelComment = F2(
	function (path, oldroot) {
		var cancelReply = function (_v1) {
			var node = _v1.a;
			var _v0 = node.cancel;
			if (_v0.$ === 'Nothing') {
				return $author$project$CommentData$Comment$Node(
					_Utils_update(
						node,
						{_delete: true}));
			} else {
				var detail = _v0.a;
				return $author$project$CommentData$Comment$Node(
					_Utils_update(
						node,
						{detail: detail, edit: false}));
			}
		};
		return A3($author$project$CommentData$Comment$applyUpdate, cancelReply, path, oldroot);
	});
var $author$project$CommentData$Comment$editComment = F2(
	function (path, oldroot) {
		var editReply = function (_v0) {
			var node = _v0.a;
			return $author$project$CommentData$Comment$Node(
				_Utils_update(
					node,
					{
						cancel: $elm$core$Maybe$Just(node.detail),
						edit: true
					}));
		};
		return A3($author$project$CommentData$Comment$applyUpdate, editReply, path, oldroot);
	});
var $author$project$CommentData$Comment$incomingComment = F3(
	function (parent, detail, oldroot) {
		var incoming = function (_v3) {
			var parentattrs = _v3.a;
			var newattrs = {cancel: $elm$core$Maybe$Nothing, _delete: false, detail: detail, edit: false, expanded: true, replies: _List_Nil, stored: true};
			var isTarget = function (_v2) {
				var n = _v2.a;
				return _Utils_eq(n.detail.path, detail.path);
			};
			var _v0 = A2($elm$core$List$partition, isTarget, parentattrs.replies);
			var us = _v0.a;
			var siblings = _v0.b;
			var newnode = function () {
				if (us.b && (!us.b.b)) {
					var oldattrs = us.a.a;
					return $author$project$CommentData$Comment$Node(
						_Utils_update(
							newattrs,
							{replies: oldattrs.replies}));
				} else {
					return $author$project$CommentData$Comment$Node(newattrs);
				}
			}();
			return $author$project$CommentData$Comment$Node(
				_Utils_update(
					parentattrs,
					{
						replies: A2($elm$core$List$cons, newnode, siblings)
					}));
		};
		return A3($author$project$CommentData$Comment$applyUpdate, incoming, parent, oldroot);
	});
var $elm$core$String$foldr = _String_foldr;
var $elm$core$String$toList = function (string) {
	return A3($elm$core$String$foldr, $elm$core$List$cons, _List_Nil, string);
};
var $author$project$Shared$Tkey$makeTkey = F2(
	function (mnum, tnum) {
		var mstr = $elm$core$String$fromInt(mnum);
		var cint = $elm$core$String$fromInt(tnum);
		var cdigits = A2(
			$elm$core$List$filterMap,
			$elm$core$String$toInt,
			A2(
				$elm$core$List$map,
				$elm$core$String$fromChar,
				$elm$core$String$toList(cint)));
		var cstr = A2(
			$elm$core$String$join,
			'',
			A2(
				$elm$core$List$map,
				function (x) {
					return A3($elm$core$String$slice, x, x + 1, 'ZABCDEFGHJ');
				},
				cdigits));
		return _Utils_ap(mstr, cstr);
	});
var $author$project$CommentData$Comment$saveComment = F3(
	function (path, when, oldroot) {
		var saveDetail = function (detail) {
			return _Utils_update(
				detail,
				{when: when});
		};
		var saveReply = function (_v0) {
			var node = _v0.a;
			return $author$project$CommentData$Comment$Node(
				_Utils_update(
					node,
					{
						cancel: $elm$core$Maybe$Nothing,
						detail: saveDetail(node.detail),
						edit: false
					}));
		};
		return A3($author$project$CommentData$Comment$applyUpdate, saveReply, path, oldroot);
	});
var $author$project$Shared$Clock$setTime = F2(
	function (newTime, model) {
		return _Utils_update(
			model,
			{time: newTime});
	});
var $elm$core$Maybe$map = F2(
	function (f, maybe) {
		if (maybe.$ === 'Just') {
			var value = maybe.a;
			return $elm$core$Maybe$Just(
				f(value));
		} else {
			return $elm$core$Maybe$Nothing;
		}
	});
var $elm_community$list_extra$List$Extra$init = function (items) {
	if (!items.b) {
		return $elm$core$Maybe$Nothing;
	} else {
		var nonEmptyList = items;
		return A2(
			$elm$core$Maybe$map,
			$elm$core$List$reverse,
			$elm$core$List$tail(
				$elm$core$List$reverse(nonEmptyList)));
	}
};
var $elm_community$list_extra$List$Extra$last = function (items) {
	last:
	while (true) {
		if (!items.b) {
			return $elm$core$Maybe$Nothing;
		} else {
			if (!items.b.b) {
				var x = items.a;
				return $elm$core$Maybe$Just(x);
			} else {
				var rest = items.b;
				var $temp$items = rest;
				items = $temp$items;
				continue last;
			}
		}
	}
};
var $elm$core$String$reverse = _String_reverse;
var $author$project$Shared$Tkey$reversedCommentPathRegex = A2(
	$elm$core$Maybe$withDefault,
	$elm$regex$Regex$never,
	$elm$regex$Regex$fromString('^([ZABCDEFGHJ]+)([1-9][0-9]*)'));
var $author$project$Shared$Tkey$lastComment = function (path) {
	var _v0 = A2(
		$elm$regex$Regex$find,
		$author$project$Shared$Tkey$reversedCommentPathRegex,
		$elm$core$String$reverse(path));
	if (_v0.b && (!_v0.b.b)) {
		var match = _v0.a;
		var _v1 = match.submatches;
		if ((((_v1.b && (_v1.a.$ === 'Just')) && _v1.b.b) && (_v1.b.a.$ === 'Just')) && (!_v1.b.b.b)) {
			var tkstr = _v1.a.a;
			var _v2 = _v1.b;
			var mstr = _v2.a.a;
			return $elm$core$Maybe$Just(
				_Utils_Tuple2(
					$elm$core$String$reverse(mstr),
					$elm$core$String$reverse(tkstr)));
		} else {
			return $elm$core$Maybe$Nothing;
		}
	} else {
		return $elm$core$Maybe$Nothing;
	}
};
var $elm_community$maybe_extra$Maybe$Extra$combineHelp = F2(
	function (list, acc) {
		combineHelp:
		while (true) {
			if (list.b) {
				var head = list.a;
				var tail = list.b;
				if (head.$ === 'Just') {
					var a = head.a;
					var $temp$list = tail,
						$temp$acc = A2($elm$core$List$cons, a, acc);
					list = $temp$list;
					acc = $temp$acc;
					continue combineHelp;
				} else {
					return $elm$core$Maybe$Nothing;
				}
			} else {
				return $elm$core$Maybe$Just(
					$elm$core$List$reverse(acc));
			}
		}
	});
var $elm_community$maybe_extra$Maybe$Extra$combine = function (list) {
	return A2($elm_community$maybe_extra$Maybe$Extra$combineHelp, list, _List_Nil);
};
var $author$project$Shared$Tkey$tncharToInt = function (tnchar) {
	switch (tnchar.valueOf()) {
		case 'Z':
			return $elm$core$Maybe$Just(0);
		case 'A':
			return $elm$core$Maybe$Just(1);
		case 'B':
			return $elm$core$Maybe$Just(2);
		case 'C':
			return $elm$core$Maybe$Just(3);
		case 'D':
			return $elm$core$Maybe$Just(4);
		case 'E':
			return $elm$core$Maybe$Just(5);
		case 'F':
			return $elm$core$Maybe$Just(6);
		case 'G':
			return $elm$core$Maybe$Just(7);
		case 'H':
			return $elm$core$Maybe$Just(8);
		case 'J':
			return $elm$core$Maybe$Just(9);
		default:
			return $elm$core$Maybe$Nothing;
	}
};
var $author$project$Shared$Tkey$tnstrToInt = function (tnstr) {
	var _v0 = $elm_community$maybe_extra$Maybe$Extra$combine(
		A2(
			$elm$core$List$map,
			$author$project$Shared$Tkey$tncharToInt,
			$elm$core$String$toList(tnstr)));
	if (_v0.$ === 'Just') {
		var digits = _v0.a;
		return $elm$core$String$toInt(
			A2(
				$elm$core$String$join,
				'',
				A2($elm$core$List$map, $elm$core$String$fromInt, digits)));
	} else {
		return $elm$core$Maybe$Nothing;
	}
};
var $author$project$CommentData$Comment$splitCommentPath = function (path) {
	var _v0 = $elm_community$list_extra$List$Extra$init(path);
	if (_v0.$ === 'Just') {
		var parentpath = _v0.a;
		var _v1 = $elm_community$list_extra$List$Extra$last(path);
		if (_v1.$ === 'Just') {
			var cid = _v1.a;
			var _v2 = $author$project$Shared$Tkey$lastComment(cid);
			if (_v2.$ === 'Just') {
				var _v3 = _v2.a;
				var mstr = _v3.a;
				var cnstr = _v3.b;
				var _v4 = _Utils_Tuple2(
					$elm$core$String$toInt(mstr),
					$author$project$Shared$Tkey$tnstrToInt(cnstr));
				if ((_v4.a.$ === 'Just') && (_v4.b.$ === 'Just')) {
					var mnum = _v4.a.a;
					var cnum = _v4.b.a;
					return $elm$core$Maybe$Just(
						_Utils_Tuple3(parentpath, mnum, cnum));
				} else {
					return $elm$core$Maybe$Nothing;
				}
			} else {
				return $elm$core$Maybe$Nothing;
			}
		} else {
			return $elm$core$Maybe$Nothing;
		}
	} else {
		return $elm$core$Maybe$Nothing;
	}
};
var $author$project$CommentData$Comment$toggleExpanded = F2(
	function (path, oldroot) {
		var toggleFn = function (_v0) {
			var node = _v0.a;
			return $author$project$CommentData$Comment$Node(
				_Utils_update(
					node,
					{expanded: !node.expanded}));
		};
		return A3($author$project$CommentData$Comment$applyUpdate, toggleFn, path, oldroot);
	});
var $author$project$Shared$Clock$update = F2(
	function (msg, model) {
		if (msg.$ === 'Tick') {
			var newTime = msg.a;
			return _Utils_eq(model.start, $author$project$Shared$Clock$epoch) ? _Utils_update(
				model,
				{start: newTime, time: newTime}) : _Utils_update(
				model,
				{time: newTime});
		} else {
			var newZone = msg.a;
			return _Utils_update(
				model,
				{zone: newZone});
		}
	});
var $author$project$CommentData$Comment$updateComment = F3(
	function (path, what, oldroot) {
		var updateDetail = function (detail) {
			return _Utils_update(
				detail,
				{what: what});
		};
		var updateReply = function (_v0) {
			var node = _v0.a;
			return $author$project$CommentData$Comment$Node(
				_Utils_update(
					node,
					{
						detail: updateDetail(node.detail)
					}));
		};
		return A3($author$project$CommentData$Comment$applyUpdate, updateReply, path, oldroot);
	});
var $author$project$TopicComments$Model$update = F3(
	function (flags, state, msg) {
		switch (msg.$) {
			case 'ClockMsg':
				var cmsg = msg.a;
				var newstate = _Utils_update(
					state,
					{
						clock: A2($author$project$Shared$Clock$update, cmsg, state.clock)
					});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			case 'PressAccept':
				return A2($author$project$Shared$Cmd$cmdTransition, flags.transitions.accept, state);
			case 'ToggleComment':
				var path = msg.a;
				var newstate = _Utils_update(
					state,
					{
						comments: A2($author$project$CommentData$Comment$toggleExpanded, path, state.comments)
					});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			case 'AddComment':
				var path = msg.a;
				var newstate = function () {
					var _v1 = state.mnum;
					if (_v1.$ === 'Nothing') {
						return state;
					} else {
						var mnum = _v1.a;
						var cid = A2($author$project$Shared$Tkey$makeTkey, mnum, state.next_comment);
						return _Utils_update(
							state,
							{
								comments: A4($author$project$CommentData$Comment$addComment, path, cid, mnum, state.comments),
								next_comment: state.next_comment + 1
							});
					}
				}();
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			case 'EditComment':
				var path = msg.a;
				var newstate = _Utils_update(
					state,
					{
						comments: A2($author$project$CommentData$Comment$editComment, path, state.comments)
					});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			case 'UpdateComment':
				var path = msg.a;
				var what = msg.b;
				var newstate = _Utils_update(
					state,
					{
						comments: A3($author$project$CommentData$Comment$updateComment, path, what, state.comments)
					});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			case 'PressSave':
				var path = msg.a;
				return _Utils_Tuple2(
					state,
					A2(
						$elm$core$Task$perform,
						$author$project$TopicComments$Model$SaveComment(path),
						$elm$time$Time$now));
			case 'SaveComment':
				var path = msg.a;
				var when = msg.b;
				var newstate = _Utils_update(
					state,
					{
						clock: A2($author$project$Shared$Clock$setTime, when, state.clock),
						comments: A3($author$project$CommentData$Comment$saveComment, path, when, state.comments)
					});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			case 'CancelComment':
				var path = msg.a;
				var newstate = _Utils_update(
					state,
					{
						comments: A2($author$project$CommentData$Comment$cancelComment, path, state.comments)
					});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			default:
				var path = msg.a;
				var data = msg.b;
				var newstate = function () {
					var _v2 = state.mnum;
					if (_v2.$ === 'Nothing') {
						return state;
					} else {
						var mnum = _v2.a;
						var _v3 = $author$project$CommentData$Comment$splitCommentPath(path);
						if (_v3.$ === 'Nothing') {
							return state;
						} else {
							var _v4 = _v3.a;
							var parent = _v4.a;
							var cmnum = _v4.b;
							var cnum = _v4.c;
							var next_comment = _Utils_eq(mnum, cmnum) ? ((_Utils_cmp(cnum, state.next_comment) > -1) ? (cnum + 1) : (state.next_comment + 1)) : state.next_comment;
							return _Utils_update(
								state,
								{
									comments: A3($author$project$CommentData$Comment$incomingComment, parent, data, state.comments),
									next_comment: next_comment
								});
						}
					}
				}();
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
		}
	});
var $author$project$Topic$updateComments = F3(
	function (flags, cmsg, state) {
		var _v0 = A3(
			$author$project$TopicComments$Model$update,
			$author$project$Topic$commentsFlags(flags),
			state.comments,
			cmsg);
		var cstate = _v0.a;
		var ccmds = _v0.b;
		return A3(
			$author$project$Topic$updateStateCmds,
			flags,
			$author$project$Topic$commentsCmds(ccmds),
			_Utils_update(
				state,
				{comments: cstate}));
	});
var $author$project$Topic$updateDetails = F3(
	function (flags, dmsg, state) {
		var _v0 = A3(
			$author$project$TopicDetails$Model$update,
			$author$project$Topic$detailsFlags(flags),
			state.details,
			dmsg);
		var dstate = _v0.a;
		var dcmds = _v0.b;
		return A3(
			$author$project$Topic$updateStateCmds,
			flags,
			$author$project$Topic$detailsCmds(dcmds),
			_Utils_update(
				state,
				{details: dstate}));
	});
var $author$project$Topic$updateMembers = F3(
	function (flags, mmsg, state) {
		var _v0 = A3(
			$author$project$TopicMembers$Model$update,
			$author$project$Topic$membersFlags(flags),
			state.members,
			mmsg);
		var mstate = _v0.a;
		var mcmds = _v0.b;
		return A3(
			$author$project$Topic$updateStateCmds,
			flags,
			$author$project$Topic$membersCmds(mcmds),
			_Utils_update(
				state,
				{members: mstate}));
	});
var $author$project$Topic$updateProgress = F3(
	function (flags, pmsg, state) {
		var _v0 = A3(
			$author$project$Progress$Model$update,
			$author$project$Topic$progressFlags(flags),
			state.progress,
			pmsg);
		var pstate = _v0.a;
		var pcmds = _v0.b;
		return A3(
			$author$project$Topic$updateStateCmds,
			flags,
			$author$project$Topic$progressCmds(pcmds),
			_Utils_update(
				state,
				{progress: pstate}));
	});
var $author$project$Topic$Cmd$includedBundles = F2(
	function (state, accepted) {
		var included = function (_v1) {
			var item = _v1.a;
			var b = _v1.b;
			return item.include ? (b.data.restricted ? (accepted ? $elm$core$Maybe$Just(item.bnum) : $elm$core$Maybe$Nothing) : $elm$core$Maybe$Just(item.bnum)) : $elm$core$Maybe$Nothing;
		};
		var getItem = function (item) {
			var _v0 = A2($elm$core$Dict$get, item.bnum, state.bundles.bundles);
			if (_v0.$ === 'Just') {
				var b = _v0.a;
				return $elm$core$Maybe$Just(
					_Utils_Tuple2(item, b));
			} else {
				return $elm$core$Maybe$Nothing;
			}
		};
		var bundlelist = A2($elm$core$List$filterMap, getItem, state.bundles.current);
		return A2($elm$core$List$filterMap, included, bundlelist);
	});
var $author$project$Topic$Cmd$cmdOpenTopic = F7(
	function (flags, state, accepted, target, preview, setup, engage) {
		var encodeTopicPath = _List_fromArray(
			[
				_Utils_Tuple2(
				'topicpath',
				$elm$json$Json$Encode$string(target.topicpath))
			]);
		var engageEncoders = _Utils_ap(_List_Nil, encodeTopicPath);
		var encodeTargetId = _List_fromArray(
			[
				_Utils_Tuple2(
				'targetid',
				$elm$json$Json$Encode$string(target.targetid))
			]);
		var encodePreview = _List_fromArray(
			[
				_Utils_Tuple2(
				'preview',
				$elm$json$Json$Encode$bool(preview))
			]);
		var encodePathname = _List_fromArray(
			[
				_Utils_Tuple2(
				'pathname',
				$elm$json$Json$Encode$string(target.pathname))
			]);
		var encodeOrigin = _List_fromArray(
			[
				_Utils_Tuple2(
				'origin',
				$elm$json$Json$Encode$string(target.origin))
			]);
		var encodeKind = _List_fromArray(
			[
				_Utils_Tuple2(
				'kind',
				$elm$json$Json$Encode$string('review topic'))
			]);
		var encodeEngage = engage ? _List_fromArray(
			[
				_Utils_Tuple2(
				'engage',
				$elm$json$Json$Encode$object(engageEncoders))
			]) : _List_Nil;
		var encodeBundles = _List_fromArray(
			[
				_Utils_Tuple2(
				'bundles',
				A2(
					$elm$json$Json$Encode$list,
					$elm$json$Json$Encode$int,
					A2($author$project$Topic$Cmd$includedBundles, state, accepted)))
			]);
		var setupEncoders = _Utils_ap(
			_List_Nil,
			_Utils_ap(encodeBundles, encodePathname));
		var encodeSetup = setup ? _List_fromArray(
			[
				_Utils_Tuple2(
				'setup',
				$elm$json$Json$Encode$object(setupEncoders))
			]) : _List_Nil;
		var encoders = _Utils_ap(
			_List_Nil,
			_Utils_ap(
				encodeKind,
				_Utils_ap(
					encodePreview,
					_Utils_ap(
						encodeOrigin,
						_Utils_ap(
							encodeTargetId,
							_Utils_ap(encodeSetup, encodeEngage))))));
		var request = $elm$json$Json$Encode$object(encoders);
		return _Utils_Tuple2(
			A2($author$project$Topic$Model$Loaded, flags, state),
			$author$project$Shared$Ports$toMain(request));
	});
var $author$project$TopicReview$Model$topicErr = function (problems) {
	return $elm_community$maybe_extra$Maybe$Extra$orList(
		_List_fromArray(
			[problems.currentErr, problems.pathErr]));
};
var $author$project$TopicReview$View$okToPreview = F2(
	function (state, bundles) {
		var _v0 = _Utils_Tuple2(
			$author$project$TopicReview$Model$topicErr(state.problems),
			$author$project$TopicBundles$Model$bundlesErr(bundles.problems));
		if ((_v0.a.$ === 'Nothing') && (_v0.b.$ === 'Nothing')) {
			var _v1 = _v0.a;
			var _v2 = _v0.b;
			return true;
		} else {
			return false;
		}
	});
var $author$project$TopicReview$Model$reviewWindowTarget = F3(
	function (flags, details, targetid) {
		return {origin: flags.config.extra.originReview, pathname: flags.transitions.review, targetid: targetid, topicpath: details.current.details.path};
	});
var $author$project$TopicReview$Model$PreviewTargetId = function (a) {
	return {$: 'PreviewTargetId', a: a};
};
var $author$project$TopicReview$Model$WindowTargetId = function (a) {
	return {$: 'WindowTargetId', a: a};
};
var $elm$random$Random$Generate = function (a) {
	return {$: 'Generate', a: a};
};
var $elm$random$Random$Seed = F2(
	function (a, b) {
		return {$: 'Seed', a: a, b: b};
	});
var $elm$random$Random$next = function (_v0) {
	var state0 = _v0.a;
	var incr = _v0.b;
	return A2($elm$random$Random$Seed, ((state0 * 1664525) + incr) >>> 0, incr);
};
var $elm$random$Random$initialSeed = function (x) {
	var _v0 = $elm$random$Random$next(
		A2($elm$random$Random$Seed, 0, 1013904223));
	var state1 = _v0.a;
	var incr = _v0.b;
	var state2 = (state1 + x) >>> 0;
	return $elm$random$Random$next(
		A2($elm$random$Random$Seed, state2, incr));
};
var $elm$random$Random$init = A2(
	$elm$core$Task$andThen,
	function (time) {
		return $elm$core$Task$succeed(
			$elm$random$Random$initialSeed(
				$elm$time$Time$posixToMillis(time)));
	},
	$elm$time$Time$now);
var $elm$random$Random$step = F2(
	function (_v0, seed) {
		var generator = _v0.a;
		return generator(seed);
	});
var $elm$random$Random$onEffects = F3(
	function (router, commands, seed) {
		if (!commands.b) {
			return $elm$core$Task$succeed(seed);
		} else {
			var generator = commands.a.a;
			var rest = commands.b;
			var _v1 = A2($elm$random$Random$step, generator, seed);
			var value = _v1.a;
			var newSeed = _v1.b;
			return A2(
				$elm$core$Task$andThen,
				function (_v2) {
					return A3($elm$random$Random$onEffects, router, rest, newSeed);
				},
				A2($elm$core$Platform$sendToApp, router, value));
		}
	});
var $elm$random$Random$onSelfMsg = F3(
	function (_v0, _v1, seed) {
		return $elm$core$Task$succeed(seed);
	});
var $elm$random$Random$Generator = function (a) {
	return {$: 'Generator', a: a};
};
var $elm$random$Random$map = F2(
	function (func, _v0) {
		var genA = _v0.a;
		return $elm$random$Random$Generator(
			function (seed0) {
				var _v1 = genA(seed0);
				var a = _v1.a;
				var seed1 = _v1.b;
				return _Utils_Tuple2(
					func(a),
					seed1);
			});
	});
var $elm$random$Random$cmdMap = F2(
	function (func, _v0) {
		var generator = _v0.a;
		return $elm$random$Random$Generate(
			A2($elm$random$Random$map, func, generator));
	});
_Platform_effectManagers['Random'] = _Platform_createManager($elm$random$Random$init, $elm$random$Random$onEffects, $elm$random$Random$onSelfMsg, $elm$random$Random$cmdMap);
var $elm$random$Random$command = _Platform_leaf('Random');
var $elm$random$Random$generate = F2(
	function (tagger, generator) {
		return $elm$random$Random$command(
			$elm$random$Random$Generate(
				A2($elm$random$Random$map, tagger, generator)));
	});
var $elm$core$Basics$negate = function (n) {
	return -n;
};
var $elm$core$Bitwise$xor = _Bitwise_xor;
var $elm$random$Random$peel = function (_v0) {
	var state = _v0.a;
	var word = (state ^ (state >>> ((state >>> 28) + 4))) * 277803737;
	return ((word >>> 22) ^ word) >>> 0;
};
var $elm$random$Random$int = F2(
	function (a, b) {
		return $elm$random$Random$Generator(
			function (seed0) {
				var _v0 = (_Utils_cmp(a, b) < 0) ? _Utils_Tuple2(a, b) : _Utils_Tuple2(b, a);
				var lo = _v0.a;
				var hi = _v0.b;
				var range = (hi - lo) + 1;
				if (!((range - 1) & range)) {
					return _Utils_Tuple2(
						(((range - 1) & $elm$random$Random$peel(seed0)) >>> 0) + lo,
						$elm$random$Random$next(seed0));
				} else {
					var threshhold = (((-range) >>> 0) % range) >>> 0;
					var accountForBias = function (seed) {
						accountForBias:
						while (true) {
							var x = $elm$random$Random$peel(seed);
							var seedN = $elm$random$Random$next(seed);
							if (_Utils_cmp(x, threshhold) < 0) {
								var $temp$seed = seedN;
								seed = $temp$seed;
								continue accountForBias;
							} else {
								return _Utils_Tuple2((x % range) + lo, seedN);
							}
						}
					};
					return accountForBias(seed0);
				}
			});
	});
var $elm$random$Random$listHelp = F4(
	function (revList, n, gen, seed) {
		listHelp:
		while (true) {
			if (n < 1) {
				return _Utils_Tuple2(revList, seed);
			} else {
				var _v0 = gen(seed);
				var value = _v0.a;
				var newSeed = _v0.b;
				var $temp$revList = A2($elm$core$List$cons, value, revList),
					$temp$n = n - 1,
					$temp$gen = gen,
					$temp$seed = newSeed;
				revList = $temp$revList;
				n = $temp$n;
				gen = $temp$gen;
				seed = $temp$seed;
				continue listHelp;
			}
		}
	});
var $elm$random$Random$list = F2(
	function (n, _v0) {
		var gen = _v0.a;
		return $elm$random$Random$Generator(
			function (seed) {
				return A4($elm$random$Random$listHelp, _List_Nil, n, gen, seed);
			});
	});
var $author$project$TopicReview$Model$makeTargetId = function (values) {
	return A2(
		$elm$core$String$join,
		'',
		A2(
			$elm$core$List$map,
			function (x) {
				return A3($elm$core$String$slice, x, x + 1, 'ABCDEFGHIJKLMNOPQRSTUVWXYZ');
			},
			values));
};
var $author$project$TopicReview$Model$update = F3(
	function (flags, state1, msg) {
		var problems = state1.problems;
		switch (msg.$) {
			case 'UpdateTopicPath':
				var value = msg.a;
				var state = _Utils_update(
					state1,
					{
						problems: _Utils_update(
							problems,
							{
								pathErr: A2(
									$author$project$TopicData$Valid$pathErr,
									$author$project$TopicReview$Model$dataErrors(flags),
									value)
							})
					});
				return _Utils_Tuple2(state, $elm$core$Platform$Cmd$none);
			case 'ToggleOptionsExpanded':
				var state = _Utils_eq(state1.frametarget, $elm$core$Maybe$Nothing) ? _Utils_update(
					state1,
					{expanded: !state1.expanded}) : state1;
				return _Utils_Tuple2(state, $elm$core$Platform$Cmd$none);
			case 'UpdatePause':
				var value = msg.a;
				var state = _Utils_update(
					state1,
					{pause: value});
				return _Utils_Tuple2(state, $elm$core$Platform$Cmd$none);
			case 'PressCloseFrame':
				var state = _Utils_update(
					state1,
					{frametarget: $elm$core$Maybe$Nothing, loaded: $elm$core$Maybe$Nothing, paused: false});
				return _Utils_Tuple2(state, $elm$core$Platform$Cmd$none);
			case 'PressPreviewFrame':
				var targetValues = A2(
					$elm$random$Random$list,
					16,
					A2($elm$random$Random$int, 0, 25));
				return _Utils_Tuple2(
					state1,
					A2($elm$random$Random$generate, $author$project$TopicReview$Model$PreviewTargetId, targetValues));
			case 'PreviewTargetId':
				var values = msg.a;
				var frametarget = $author$project$TopicReview$Model$makeTargetId(values);
				var state = _Utils_update(
					state1,
					{
						frametarget: $elm$core$Maybe$Just(frametarget)
					});
				return _Utils_Tuple2(state, $elm$core$Platform$Cmd$none);
			case 'PreviewFrameLoaded':
				var rt = msg.a;
				var state = function () {
					var _v1 = state1.loaded;
					if (_v1.$ === 'Nothing') {
						return _Utils_update(
							state1,
							{
								loaded: $elm$core$Maybe$Just(rt),
								paused: state1.pause
							});
					} else {
						return state1;
					}
				}();
				return _Utils_Tuple2(state, $elm$core$Platform$Cmd$none);
			case 'PressProceed':
				var state = _Utils_update(
					state1,
					{paused: false});
				return _Utils_Tuple2(state, $elm$core$Platform$Cmd$none);
			case 'PressOpenNewTab':
				var targetValues = A2(
					$elm$random$Random$list,
					16,
					A2($elm$random$Random$int, 0, 25));
				return _Utils_Tuple2(
					state1,
					A2($elm$random$Random$generate, $author$project$TopicReview$Model$WindowTargetId, targetValues));
			default:
				var values = msg.a;
				var windowtarget = $author$project$TopicReview$Model$makeTargetId(values);
				var state = _Utils_update(
					state1,
					{
						windowtarget: $elm$core$Maybe$Just(windowtarget)
					});
				return _Utils_Tuple2(state, $elm$core$Platform$Cmd$none);
		}
	});
var $author$project$Topic$updateReview = F3(
	function (flags, rmsg, state1) {
		var details = state1.details;
		var dcurrent = details.current;
		var ddetails = dcurrent.details;
		var dstate = function () {
			if (rmsg.$ === 'UpdateTopicPath') {
				var value = rmsg.a;
				return _Utils_update(
					details,
					{
						current: _Utils_update(
							dcurrent,
							{
								details: _Utils_update(
									ddetails,
									{path: value})
							})
					});
			} else {
				return details;
			}
		}();
		var accepted = A2($author$project$Topic$Model$isAccepted, state1.members.profiles, state1.auth);
		var _v0 = A3(
			$author$project$TopicReview$Model$update,
			$author$project$Topic$reviewFlags(flags),
			state1.review,
			rmsg);
		var rstate = _v0.a;
		var rcmds = _v0.b;
		var state = _Utils_update(
			state1,
			{details: dstate, review: rstate});
		var that_is_all = A3(
			$author$project$Topic$updateStateCmds,
			flags,
			$author$project$Topic$reviewCmds(rcmds),
			state);
		var _v1 = _Utils_Tuple2(
			rmsg,
			A2($author$project$TopicReview$View$okToPreview, state.review, state.bundles));
		_v1$3:
		while (true) {
			if (_v1.b) {
				switch (_v1.a.$) {
					case 'PreviewFrameLoaded':
						var rt = _v1.a.a;
						var _v2 = _Utils_Tuple2(state1.review.loaded, state.review.loaded);
						if ((_v2.a.$ === 'Nothing') && (_v2.b.$ === 'Just')) {
							var _v3 = _v2.a;
							return A7($author$project$Topic$Cmd$cmdOpenTopic, flags, state, accepted, rt, true, true, !state.review.pause);
						} else {
							return that_is_all;
						}
					case 'PressProceed':
						var _v4 = _v1.a;
						var _v5 = _Utils_Tuple2(state.review.loaded, state1.review.paused);
						if ((_v5.a.$ === 'Just') && _v5.b) {
							var rt = _v5.a.a;
							return A7($author$project$Topic$Cmd$cmdOpenTopic, flags, state, accepted, rt, true, false, true);
						} else {
							return that_is_all;
						}
					case 'WindowTargetId':
						var _v6 = state.review.windowtarget;
						if (_v6.$ === 'Just') {
							var windowtarget = _v6.a;
							var rt = A3(
								$author$project$TopicReview$Model$reviewWindowTarget,
								$author$project$Topic$reviewFlags(flags),
								state.details,
								windowtarget);
							return A7($author$project$Topic$Cmd$cmdOpenTopic, flags, state, accepted, rt, false, true, true);
						} else {
							return that_is_all;
						}
					default:
						break _v1$3;
				}
			} else {
				break _v1$3;
			}
		}
		return that_is_all;
	});
var $author$project$Topic$updateState = F2(
	function (flags, state) {
		return A3($author$project$Topic$updateStateCmds, flags, $elm$core$Platform$Cmd$none, state);
	});
var $author$project$Topic$Decode$IncomingTopicData = F2(
	function (a, b) {
		return {$: 'IncomingTopicData', a: a, b: b};
	});
var $author$project$Topic$Decode$AddTopicOk = function (a) {
	return {$: 'AddTopicOk', a: a};
};
var $author$project$Topic$Decode$IncomingAuth = function (a) {
	return {$: 'IncomingAuth', a: a};
};
var $author$project$Topic$Decode$IncomingBundleData = F3(
	function (a, b, c) {
		return {$: 'IncomingBundleData', a: a, b: b, c: c};
	});
var $author$project$Topic$Decode$IncomingCommentData = F2(
	function (a, b) {
		return {$: 'IncomingCommentData', a: a, b: b};
	});
var $author$project$Topic$Decode$IncomingNote = F2(
	function (a, b) {
		return {$: 'IncomingNote', a: a, b: b};
	});
var $author$project$Topic$Decode$IncomingProfileData = F2(
	function (a, b) {
		return {$: 'IncomingProfileData', a: a, b: b};
	});
var $author$project$Topic$Decode$IncomingTopicMembers = F2(
	function (a, b) {
		return {$: 'IncomingTopicMembers', a: a, b: b};
	});
var $author$project$Topic$Decode$Progress = function (a) {
	return {$: 'Progress', a: a};
};
var $author$project$Topic$Decode$RequestFailed = function (a) {
	return {$: 'RequestFailed', a: a};
};
var $author$project$Topic$Decode$UpdateTopicOk = {$: 'UpdateTopicOk'};
var $author$project$CommentData$Decode$commentDataDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$CommentData$Model$CommentData,
	A2($elm$json$Json$Decode$field, 'mnum', $elm$json$Json$Decode$int),
	A2($elm$json$Json$Decode$field, 'path', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'when', $author$project$Shared$Time$decodeTime),
	A2($elm$json$Json$Decode$field, 'what', $elm$json$Json$Decode$string));
var $author$project$Topic$Decode$incomingMsgDecoderByMsg = function (msg) {
	switch (msg) {
		case 'auth':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Topic$Decode$IncomingAuth,
				A2($elm$json$Json$Decode$field, 'auth', $author$project$Auth$Decode$authDecoder));
		case 'comment info':
			return A3(
				$elm$json$Json$Decode$map2,
				$author$project$Topic$Decode$IncomingCommentData,
				A2($elm$json$Json$Decode$field, 'tkey', $elm$json$Json$Decode$string),
				A2($elm$json$Json$Decode$field, 'comment', $author$project$CommentData$Decode$commentDataDecoder));
		case 'topic info':
			return A3(
				$elm$json$Json$Decode$map2,
				$author$project$Topic$Decode$IncomingTopicData,
				A2($elm$json$Json$Decode$field, 'tkey', $elm$json$Json$Decode$string),
				A2($elm$json$Json$Decode$field, 'topic', $author$project$TopicData$Decode$topicDataDecoder));
		case 'topic members info':
			return A3(
				$elm$json$Json$Decode$map2,
				$author$project$Topic$Decode$IncomingTopicMembers,
				A2($elm$json$Json$Decode$field, 'tkey', $elm$json$Json$Decode$string),
				A2(
					$elm$json$Json$Decode$field,
					'members',
					$elm$json$Json$Decode$list($elm$json$Json$Decode$int)));
		case 'bundle info':
			return A4(
				$elm$json$Json$Decode$map3,
				$author$project$Topic$Decode$IncomingBundleData,
				A2($elm$json$Json$Decode$field, 'bnum', $elm$json$Json$Decode$int),
				A2($elm$json$Json$Decode$field, 'bundle', $author$project$BundleData$Decode$bundleDataDecoder),
				A2($elm$json$Json$Decode$field, 'stats', $author$project$BundleStats$Decode$bundleStatsDecoder));
		case 'profile info':
			return A3(
				$elm$json$Json$Decode$map2,
				$author$project$Topic$Decode$IncomingProfileData,
				A2($elm$json$Json$Decode$field, 'mnum', $elm$json$Json$Decode$int),
				A2($elm$json$Json$Decode$field, 'profile', $author$project$ProfileData$Decode$profileDataDecoder));
		case 'note info':
			return A3(
				$elm$json$Json$Decode$map2,
				$author$project$Topic$Decode$IncomingNote,
				A2($elm$json$Json$Decode$field, 'mnum', $elm$json$Json$Decode$int),
				A2($elm$json$Json$Decode$field, 'note', $elm$json$Json$Decode$string));
		case 'error':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Topic$Decode$RequestFailed,
				$elm$json$Json$Decode$maybe(
					A2($elm$json$Json$Decode$field, 'details', $elm$json$Json$Decode$string)));
		case 'add topic ok':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Topic$Decode$AddTopicOk,
				A2($elm$json$Json$Decode$field, 'tkey', $elm$json$Json$Decode$string));
		case 'update topic ok':
			return $elm$json$Json$Decode$succeed($author$project$Topic$Decode$UpdateTopicOk);
		case 'progress':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Topic$Decode$Progress,
				A2($elm$json$Json$Decode$field, 'progress', $elm$json$Json$Decode$value));
		default:
			var other = msg;
			return $elm$json$Json$Decode$fail(other);
	}
};
var $author$project$Topic$Decode$incomingMsgDecoder = A2(
	$elm$json$Json$Decode$andThen,
	$author$project$Topic$Decode$incomingMsgDecoderByMsg,
	A2($elm$json$Json$Decode$field, 'msg', $elm$json$Json$Decode$string));
var $author$project$Topic$Decode$valueToIncomingMsg = function (value) {
	var _v0 = A2(
		$elm$core$Result$mapError,
		$elm$json$Json$Decode$errorToString,
		A2($elm$json$Json$Decode$decodeValue, $author$project$Topic$Decode$incomingMsgDecoder, value));
	if ((_v0.$ === 'Ok') && (_v0.a.$ === 'IncomingTopicData')) {
		var _v1 = _v0.a;
		var tkey = _v1.a;
		var data = _v1.b;
		return $elm$core$Result$Ok(
			A2(
				$author$project$Topic$Decode$IncomingTopicData,
				tkey,
				A2($author$project$TopicData$Model$setCreator, tkey, data)));
	} else {
		var other = _v0;
		return other;
	}
};
var $author$project$Topic$update = F2(
	function (msg, model) {
		var _v0 = _Utils_Tuple2(model, msg);
		if (_v0.a.$ === 'Failed') {
			return _Utils_Tuple2(model, $elm$core$Platform$Cmd$none);
		} else {
			switch (_v0.b.$) {
				case 'ToggleOptionsExpanded':
					var _v1 = _v0.a;
					var flags = _v1.a;
					var state = _v1.b;
					var _v2 = _v0.b;
					return A2(
						$author$project$Topic$updateState,
						flags,
						_Utils_update(
							state,
							{options_expanded: !state.options_expanded}));
				case 'ProfileViewMsg':
					var _v3 = _v0.a;
					var flags = _v3.a;
					var state = _v3.b;
					var _v4 = _v0.b.a;
					return A2(
						$author$project$Topic$updateState,
						flags,
						_Utils_update(
							state,
							{creator_expanded: !state.creator_expanded}));
				case 'UpdatePause':
					var _v5 = _v0.a;
					var flags = _v5.a;
					var state = _v5.b;
					var value = _v0.b.a;
					return A2(
						$author$project$Topic$updateState,
						flags,
						_Utils_update(
							state,
							{pause: value, result: $krisajenkins$remotedata$RemoteData$NotAsked}));
				case 'DetailsMsg':
					var _v6 = _v0.a;
					var flags = _v6.a;
					var state = _v6.b;
					var dmsg = _v0.b.a;
					return A3($author$project$Topic$updateDetails, flags, dmsg, state);
				case 'BundlesMsg':
					var _v7 = _v0.a;
					var flags = _v7.a;
					var state = _v7.b;
					var bmsg = _v0.b.a;
					return A3($author$project$Topic$updateBundles, flags, bmsg, state);
				case 'ReviewMsg':
					var _v8 = _v0.a;
					var flags = _v8.a;
					var state = _v8.b;
					var rmsg = _v0.b.a;
					return A3($author$project$Topic$updateReview, flags, rmsg, state);
				case 'MembersMsg':
					var _v9 = _v0.a;
					var flags = _v9.a;
					var state = _v9.b;
					var mmsg = _v0.b.a;
					return A3($author$project$Topic$updateMembers, flags, mmsg, state);
				case 'CommentsMsg':
					var _v10 = _v0.a;
					var flags = _v10.a;
					var state = _v10.b;
					var cmsg = _v0.b.a;
					var _v11 = A3($author$project$Topic$updateComments, flags, cmsg, state);
					if (_v11.a.$ === 'Loaded') {
						var _v12 = _v11.a;
						var newstate = _v12.b;
						var newcmd = _v11.b;
						if (cmsg.$ === 'SaveComment') {
							var path = cmsg.a;
							var _v14 = A2($author$project$CommentData$Comment$getComment, path, state.comments.comments);
							if (_v14.$ === 'Just') {
								var saved = _v14.a;
								return A3($author$project$Topic$Cmd$cmdSaveComment, flags, newstate, saved);
							} else {
								return A3($author$project$Topic$updateStateCmds, flags, newcmd, newstate);
							}
						} else {
							return A3($author$project$Topic$updateStateCmds, flags, newcmd, newstate);
						}
					} else {
						return _Utils_Tuple2(model, $elm$core$Platform$Cmd$none);
					}
				case 'PressSubmit':
					var _v15 = _v0.a;
					var flags = _v15.a;
					var state = _v15.b;
					var _v16 = _v0.b;
					return A2($author$project$Topic$View$okToSubmit, flags, state) ? A2($author$project$Topic$Cmd$cmdSubmitRequest, flags, state) : _Utils_Tuple2(model, $elm$core$Platform$Cmd$none);
				case 'ProgressMsg':
					var _v17 = _v0.a;
					var flags = _v17.a;
					var state = _v17.b;
					var pmsg = _v0.b.a;
					return A3($author$project$Topic$updateProgress, flags, pmsg, state);
				default:
					var _v18 = _v0.a;
					var flags = _v18.a;
					var state = _v18.b;
					var v = _v0.b.a;
					var _v19 = $author$project$Topic$Decode$valueToIncomingMsg(v);
					if (_v19.$ === 'Err') {
						var err = _v19.a;
						return $author$project$Shared$Reg$decodeErr(err) ? A3(
							$author$project$Topic$updateProgress,
							flags,
							$author$project$Progress$Model$DecodeErr(err),
							state) : A2($author$project$Shared$Cmd$cmdLog, 'Err ' + err, model);
					} else {
						switch (_v19.a.$) {
							case 'IncomingAuth':
								var auth = _v19.a.a;
								var mstate = state.members;
								var dstate = state.details;
								var cstate = state.comments;
								var added = function () {
									var _v20 = flags.extra.mode;
									if (_v20 === 'add') {
										return $elm$core$Set$fromList(
											_List_fromArray(
												[auth.mnum]));
									} else {
										return mstate.added;
									}
								}();
								return A2(
									$author$project$Topic$updateState,
									flags,
									_Utils_update(
										state,
										{
											auth: $krisajenkins$remotedata$RemoteData$Success(auth),
											comments: _Utils_update(
												cstate,
												{
													mnum: $elm$core$Maybe$Just(auth.mnum)
												}),
											details: _Utils_update(
												dstate,
												{
													mnum: $elm$core$Maybe$Just(auth.mnum)
												}),
											members: _Utils_update(
												mstate,
												{added: added})
										}));
							case 'IncomingCommentData':
								var _v21 = _v19.a;
								var tkey = _v21.a;
								var data = _v21.b;
								var cmsg = A2(
									$author$project$TopicComments$Model$IncomingCommentData,
									$author$project$Shared$Tkey$pathToList(data.path),
									data);
								return A3($author$project$Topic$updateComments, flags, cmsg, state);
							case 'IncomingTopicData':
								var _v22 = _v19.a;
								var tkey = _v22.a;
								var data = _v22.b;
								var dmsg = $author$project$TopicDetails$Model$IncomingTopicData(data);
								var bmsg = $author$project$TopicBundles$Model$IncomingTopicData(data);
								var allowupdate = A2($author$project$Topic$Model$allowUpdate, flags, state);
								var accepted = A2($author$project$Topic$Model$isAccepted, state.members.profiles, state.auth);
								var _v23 = A3(
									$author$project$TopicDetails$Model$update,
									$author$project$Topic$detailsFlags(flags),
									state.details,
									dmsg);
								var dstate = _v23.a;
								var dcmds = _v23.b;
								var _v24 = A5(
									$author$project$TopicBundles$Model$update,
									$author$project$Topic$bundlesFlags(flags),
									state.bundles,
									accepted,
									allowupdate,
									bmsg);
								var bstate = _v24.a;
								var bcmds = _v24.b;
								var cmds = $elm$core$Platform$Cmd$batch(
									_List_fromArray(
										[
											$author$project$Topic$detailsCmds(dcmds),
											$author$project$Topic$bundlesCmds(bcmds)
										]));
								var newstate = _Utils_update(
									state,
									{
										bundles: bstate,
										details: dstate,
										tkey: $elm$core$Maybe$Just(tkey)
									});
								return A3($author$project$Topic$updateStateCmds, flags, cmds, newstate);
							case 'IncomingTopicMembers':
								var _v25 = _v19.a;
								var tkey = _v25.a;
								var members = _v25.b;
								return A3(
									$author$project$Topic$updateMembers,
									flags,
									$author$project$TopicMembers$Model$IncomingTopicMembers(members),
									state);
							case 'IncomingProfileData':
								var _v26 = _v19.a;
								var mnum = _v26.a;
								var profile = _v26.b;
								return A3(
									$author$project$Topic$updateMembers,
									flags,
									A2($author$project$TopicMembers$Model$IncomingProfileData, mnum, profile),
									state);
							case 'IncomingBundleData':
								var _v27 = _v19.a;
								var bnum = _v27.a;
								var bundle = _v27.b;
								var stats = _v27.c;
								return A3(
									$author$project$Topic$updateBundles,
									flags,
									A3($author$project$TopicBundles$Model$IncomingBundleData, bnum, bundle, stats),
									state);
							case 'IncomingNote':
								var _v28 = _v19.a;
								var mnum = _v28.a;
								var note = _v28.b;
								return A3(
									$author$project$Topic$updateMembers,
									flags,
									A2($author$project$TopicMembers$Model$IncomingNote, mnum, note),
									state);
							case 'RequestFailed':
								if (_v19.a.a.$ === 'Just') {
									var err = _v19.a.a.a;
									return A2(
										$author$project$Topic$updateState,
										flags,
										_Utils_update(
											state,
											{
												result: $krisajenkins$remotedata$RemoteData$Failure(err)
											}));
								} else {
									var _v29 = _v19.a.a;
									return A2(
										$author$project$Topic$updateState,
										flags,
										_Utils_update(
											state,
											{
												result: $krisajenkins$remotedata$RemoteData$Failure(flags.extra.topicSubmit.labels.submit.failed)
											}));
								}
							case 'AddTopicOk':
								var tkey = _v19.a.a;
								return state.pause ? A2(
									$author$project$Topic$updateState,
									flags,
									_Utils_update(
										state,
										{
											result: $krisajenkins$remotedata$RemoteData$Success('')
										})) : A3($author$project$Shared$Cmd$cmdTransitionString, flags.extra.topicSubmit.transitions.view, tkey, model);
							case 'UpdateTopicOk':
								var _v30 = _v19.a;
								var _v31 = A3(
									$author$project$TopicMembers$Model$update,
									$author$project$Topic$membersFlags(flags),
									state.members,
									$author$project$TopicMembers$Model$UpdateTopicOk);
								var mstate = _v31.a;
								var mcmds = _v31.b;
								return A3(
									$author$project$Topic$updateStateCmds,
									flags,
									$author$project$Topic$membersCmds(mcmds),
									_Utils_update(
										state,
										{
											members: mstate,
											result: $krisajenkins$remotedata$RemoteData$Success('')
										}));
							default:
								var value = _v19.a.a;
								return A3(
									$author$project$Topic$updateProgress,
									flags,
									$author$project$Progress$Model$Incoming(value),
									state);
						}
					}
			}
		}
	});
var $author$project$Topic$Model$creatorMnum = F2(
	function (flags, state) {
		var _v0 = _Utils_Tuple3(state.auth, flags.extra.mode, state.details.current.creator);
		_v0$2:
		while (true) {
			if (_v0.a.$ === 'Success') {
				if (_v0.b === 'add') {
					var auth = _v0.a.a;
					return $elm$core$Maybe$Just(auth.mnum);
				} else {
					if (_v0.c.$ === 'Just') {
						var auth = _v0.a.a;
						var mnum = _v0.c.a;
						return _Utils_eq(auth.mnum, mnum) ? $elm$core$Maybe$Just(mnum) : $elm$core$Maybe$Nothing;
					} else {
						break _v0$2;
					}
				}
			} else {
				break _v0$2;
			}
		}
		return $elm$core$Maybe$Nothing;
	});
var $author$project$Topic$currentView = 0;
var $author$project$Topic$getMnum = F2(
	function (flags, state) {
		var _v0 = flags.extra.mode;
		if (_v0 === 'add') {
			var _v1 = state.auth;
			if (_v1.$ === 'Success') {
				var auth = _v1.a;
				return $elm$core$Maybe$Just(auth.mnum);
			} else {
				return $elm$core$Maybe$Nothing;
			}
		} else {
			var _v2 = state.tkey;
			if (_v2.$ === 'Just') {
				var tkey = _v2.a;
				return $author$project$TopicData$Model$topicCreator(tkey);
			} else {
				return $elm$core$Maybe$Nothing;
			}
		}
	});
var $author$project$Topic$Model$PressSubmit = {$: 'PressSubmit'};
var $author$project$Topic$Model$ToggleOptionsExpanded = {$: 'ToggleOptionsExpanded'};
var $author$project$Topic$View$descOrError = F2(
	function (flags, state) {
		var _v0 = A2($author$project$Topic$View$currentError, flags, state);
		if (_v0.$ === 'Err') {
			var msg = _v0.a;
			return A2(
				$elm$html$Html$p,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('has-text-danger')
					]),
				_List_fromArray(
					[
						$elm$html$Html$text(msg)
					]));
		} else {
			var msg = _v0.a;
			return A2(
				$elm$html$Html$p,
				_List_Nil,
				_List_fromArray(
					[
						$elm$html$Html$text(msg)
					]));
		}
	});
var $author$project$Topic$Model$UpdatePause = function (a) {
	return {$: 'UpdatePause', a: a};
};
var $elm$html$Html$Attributes$checked = $elm$html$Html$Attributes$boolProperty('checked');
var $author$project$Shared$Text$dropExtra = function (l) {
	return ($elm$core$List$length(l) > 1) ? A2($elm$core$List$drop, 1, l) : l;
};
var $author$project$Shared$Text$htmlBreaks = function (lines) {
	return A2(
		$elm$core$List$map,
		function (s) {
			return A2($elm$html$Html$br, _List_Nil, _List_Nil);
		},
		lines);
};
var $author$project$Shared$Text$htmlTextDivs = function (lines) {
	return A2(
		$elm$core$List$map,
		function (s) {
			return A2(
				$elm$html$Html$div,
				_List_Nil,
				_List_fromArray(
					[
						$elm$html$Html$text(s)
					]));
		},
		lines);
};
var $author$project$Shared$Text$htmlTextLines = function (text) {
	return $author$project$Shared$Text$htmlTextDivs(
		A2($elm$core$String$split, '\n', text));
};
var $elm$html$Html$input = _VirtualDom_node('input');
var $elm$html$Html$label = _VirtualDom_node('label');
var $elm$json$Json$Decode$at = F2(
	function (fields, decoder) {
		return A3($elm$core$List$foldr, $elm$json$Json$Decode$field, decoder, fields);
	});
var $elm$html$Html$Events$targetChecked = A2(
	$elm$json$Json$Decode$at,
	_List_fromArray(
		['target', 'checked']),
	$elm$json$Json$Decode$bool);
var $elm$html$Html$Events$onCheck = function (tagger) {
	return A2(
		$elm$html$Html$Events$on,
		'change',
		A2($elm$json$Json$Decode$map, tagger, $elm$html$Html$Events$targetChecked));
};
var $elm$html$Html$Attributes$type_ = $elm$html$Html$Attributes$stringProperty('type');
var $author$project$Topic$View$viewPause = F2(
	function (flags, state) {
		var bs = flags.extra.topicSubmit;
		var help = $author$project$Shared$Text$htmlTextLines(bs.labels.pause.description);
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('field is-horizontal')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-label is-normal')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help is-hidden-mobile')
												]),
											$author$project$Shared$Text$dropExtra(
												$author$project$Shared$Text$htmlBreaks(help)))
										])),
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('label ml-1')
												]),
											_List_fromArray(
												[
													$elm$html$Html$text(bs.labels.pause.label)
												]))
										]))
								]))
						])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-body')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help')
												]),
											help)
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('field'),
											A2($elm$html$Html$Attributes$style, 'display', 'table')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$div,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('checkbox'),
													A2($elm$html$Html$Attributes$style, 'display', 'table-cell'),
													A2($elm$html$Html$Attributes$style, 'vertical-align', 'middle')
												]),
											_List_fromArray(
												[
													A2(
													$elm$html$Html$input,
													_List_fromArray(
														[
															$elm$html$Html$Attributes$class('sp-checkbox mt-2'),
															$elm$html$Html$Attributes$type_('checkbox'),
															$elm$html$Html$Attributes$checked(state.pause),
															$elm$html$Html$Events$onCheck($author$project$Topic$Model$UpdatePause)
														]),
													_List_Nil)
												]))
										]))
								])),
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field-label is-normal'),
									A2($elm$html$Html$Attributes$style, 'max-width', '5px')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$label,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('label')
										]),
									_List_Nil)
								]))
						]))
				]));
	});
var $author$project$Topic$View$viewSectionTitle = F2(
	function (flags, state) {
		var loading = function (cls) {
			return _Utils_eq(state.result, $krisajenkins$remotedata$RemoteData$Loading) ? (cls + ' is-loading') : cls;
		};
		var enabled = A2($author$project$Topic$View$okToSubmit, flags, state);
		var bs = flags.extra.topicSubmit;
		return _List_fromArray(
			[
				A2(
				$elm$html$Html$h3,
				_List_Nil,
				_List_fromArray(
					[
						$elm$html$Html$text(bs.labels.title.label),
						A2(
						$elm$html$Html$button,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class(
								loading('button has-background-primary-dark has-text-white is-link is-pulled-right')),
								A2($elm$html$Html$Attributes$style, 'width', bs.labels.submit.width),
								$elm$html$Html$Attributes$disabled(!enabled),
								$elm$html$Html$Events$onClick($author$project$Topic$Model$PressSubmit)
							]),
						_List_fromArray(
							[
								$elm$html$Html$text(bs.labels.submit.label)
							]))
					])),
				(flags.extra.mode === 'add') ? A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('is-flex'),
						A2($elm$html$Html$Attributes$style, 'transform', 'translate(-26px, 0px)')
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$div,
						_List_fromArray(
							[
								A2($elm$html$Html$Attributes$style, 'width', '24px'),
								A2($elm$html$Html$Attributes$style, 'min-width', '24px'),
								A2($elm$html$Html$Attributes$style, 'height', '24px'),
								$elm$html$Html$Events$onClick($author$project$Topic$Model$ToggleOptionsExpanded)
							]),
						_List_fromArray(
							[
								$author$project$Shared$Expand$svgExpandCollapse(state.options_expanded)
							])),
						A2($author$project$Topic$View$descOrError, flags, state)
					])) : A2($author$project$Topic$View$descOrError, flags, state),
				state.options_expanded ? A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('sp-form py-3')
					]),
				_List_fromArray(
					[
						A2($author$project$Topic$View$viewPause, flags, state)
					])) : A2($elm$html$Html$div, _List_Nil, _List_Nil)
			]);
	});
var $author$project$Topic$View$view = F2(
	function (flags, state) {
		return A2($author$project$Topic$Model$allowUpdate, flags, state) ? A2(
			$elm$html$Html$div,
			_List_Nil,
			A2($author$project$Topic$View$viewSectionTitle, flags, state)) : A2($elm$html$Html$div, _List_Nil, _List_Nil);
	});
var $author$project$TopicBundles$Model$PressReset = {$: 'PressReset'};
var $elm$html$Html$table = _VirtualDom_node('table');
var $elm$html$Html$tbody = _VirtualDom_node('tbody');
var $elm$html$Html$th = _VirtualDom_node('th');
var $elm$html$Html$thead = _VirtualDom_node('thead');
var $elm$html$Html$tr = _VirtualDom_node('tr');
var $author$project$TopicBundles$Model$PressDetails = function (a) {
	return {$: 'PressDetails', a: a};
};
var $author$project$TopicBundles$Model$PressMoveDown = function (a) {
	return {$: 'PressMoveDown', a: a};
};
var $author$project$TopicBundles$Model$PressMoveUp = function (a) {
	return {$: 'PressMoveUp', a: a};
};
var $author$project$TopicBundles$Model$UpdateInclude = F2(
	function (a, b) {
		return {$: 'UpdateInclude', a: a, b: b};
	});
var $elm$virtual_dom$VirtualDom$attribute = F2(
	function (key, value) {
		return A2(
			_VirtualDom_attribute,
			_VirtualDom_noOnOrFormAction(key),
			_VirtualDom_noJavaScriptOrHtmlUri(value));
	});
var $elm$html$Html$Attributes$attribute = $elm$virtual_dom$VirtualDom$attribute;
var $author$project$Shared$Text$downChar = $elm$core$String$fromChar(
	_Utils_chr('↓'));
var $basti1302$elm_human_readable_filesize$Filesize$Base2 = {$: 'Base2'};
var $basti1302$elm_human_readable_filesize$Filesize$Base10 = {$: 'Base10'};
var $basti1302$elm_human_readable_filesize$Filesize$defaultSettings = {decimalPlaces: 2, decimalSeparator: '.', units: $basti1302$elm_human_readable_filesize$Filesize$Base10};
var $basti1302$elm_human_readable_filesize$Filesize$base10UnitList = _List_fromArray(
	[
		{abbreviation: 'B', minimumSize: 1},
		{abbreviation: 'kB', minimumSize: 1000},
		{abbreviation: 'MB', minimumSize: 1000000},
		{abbreviation: 'GB', minimumSize: 1000000000},
		{abbreviation: 'TB', minimumSize: 1000000000000},
		{abbreviation: 'PB', minimumSize: 1000000000000000},
		{abbreviation: 'EB', minimumSize: 1000000000000000000}
	]);
var $basti1302$elm_human_readable_filesize$Filesize$base2UnitList = _List_fromArray(
	[
		{abbreviation: 'B', minimumSize: 1},
		{abbreviation: 'KiB', minimumSize: 1024},
		{abbreviation: 'MiB', minimumSize: 1048576},
		{abbreviation: 'GiB', minimumSize: 1073741824},
		{abbreviation: 'TiB', minimumSize: 1099511627776},
		{abbreviation: 'PiB', minimumSize: 1125899906842624}
	]);
var $basti1302$elm_human_readable_filesize$Filesize$getUnitDefinitionList = function (units) {
	if (units.$ === 'Base10') {
		return $basti1302$elm_human_readable_filesize$Filesize$base10UnitList;
	} else {
		return $basti1302$elm_human_readable_filesize$Filesize$base2UnitList;
	}
};
var $basti1302$elm_human_readable_filesize$Filesize$decimalSeparatorRegex = A2(
	$elm$core$Maybe$withDefault,
	$elm$regex$Regex$never,
	$elm$regex$Regex$fromString('\\.'));
var $elm$core$String$dropRight = F2(
	function (n, string) {
		return (n < 1) ? string : A3($elm$core$String$slice, 0, -n, string);
	});
var $elm$core$String$endsWith = _String_endsWith;
var $elm$core$Basics$abs = function (n) {
	return (n < 0) ? (-n) : n;
};
var $myrho$elm_round$Round$addSign = F2(
	function (signed, str) {
		var isNotZero = A2(
			$elm$core$List$any,
			function (c) {
				return (!_Utils_eq(
					c,
					_Utils_chr('0'))) && (!_Utils_eq(
					c,
					_Utils_chr('.')));
			},
			$elm$core$String$toList(str));
		return _Utils_ap(
			(signed && isNotZero) ? '-' : '',
			str);
	});
var $elm$core$String$fromFloat = _String_fromNumber;
var $elm$core$Char$fromCode = _Char_fromCode;
var $myrho$elm_round$Round$increaseNum = function (_v0) {
	var head = _v0.a;
	var tail = _v0.b;
	if (_Utils_eq(
		head,
		_Utils_chr('9'))) {
		var _v1 = $elm$core$String$uncons(tail);
		if (_v1.$ === 'Nothing') {
			return '01';
		} else {
			var headtail = _v1.a;
			return A2(
				$elm$core$String$cons,
				_Utils_chr('0'),
				$myrho$elm_round$Round$increaseNum(headtail));
		}
	} else {
		var c = $elm$core$Char$toCode(head);
		return ((c >= 48) && (c < 57)) ? A2(
			$elm$core$String$cons,
			$elm$core$Char$fromCode(c + 1),
			tail) : '0';
	}
};
var $elm$core$Basics$isInfinite = _Basics_isInfinite;
var $elm$core$Basics$isNaN = _Basics_isNaN;
var $elm$core$String$padRight = F3(
	function (n, _char, string) {
		return _Utils_ap(
			string,
			A2(
				$elm$core$String$repeat,
				n - $elm$core$String$length(string),
				$elm$core$String$fromChar(_char)));
	});
var $myrho$elm_round$Round$splitComma = function (str) {
	var _v0 = A2($elm$core$String$split, '.', str);
	if (_v0.b) {
		if (_v0.b.b) {
			var before = _v0.a;
			var _v1 = _v0.b;
			var after = _v1.a;
			return _Utils_Tuple2(before, after);
		} else {
			var before = _v0.a;
			return _Utils_Tuple2(before, '0');
		}
	} else {
		return _Utils_Tuple2('0', '0');
	}
};
var $elm$core$Tuple$mapFirst = F2(
	function (func, _v0) {
		var x = _v0.a;
		var y = _v0.b;
		return _Utils_Tuple2(
			func(x),
			y);
	});
var $myrho$elm_round$Round$toDecimal = function (fl) {
	var _v0 = A2(
		$elm$core$String$split,
		'e',
		$elm$core$String$fromFloat(
			$elm$core$Basics$abs(fl)));
	if (_v0.b) {
		if (_v0.b.b) {
			var num = _v0.a;
			var _v1 = _v0.b;
			var exp = _v1.a;
			var e = A2(
				$elm$core$Maybe$withDefault,
				0,
				$elm$core$String$toInt(
					A2($elm$core$String$startsWith, '+', exp) ? A2($elm$core$String$dropLeft, 1, exp) : exp));
			var _v2 = $myrho$elm_round$Round$splitComma(num);
			var before = _v2.a;
			var after = _v2.b;
			var total = _Utils_ap(before, after);
			var zeroed = (e < 0) ? A2(
				$elm$core$Maybe$withDefault,
				'0',
				A2(
					$elm$core$Maybe$map,
					function (_v3) {
						var a = _v3.a;
						var b = _v3.b;
						return a + ('.' + b);
					},
					A2(
						$elm$core$Maybe$map,
						$elm$core$Tuple$mapFirst($elm$core$String$fromChar),
						$elm$core$String$uncons(
							_Utils_ap(
								A2(
									$elm$core$String$repeat,
									$elm$core$Basics$abs(e),
									'0'),
								total))))) : A3(
				$elm$core$String$padRight,
				e + 1,
				_Utils_chr('0'),
				total);
			return _Utils_ap(
				(fl < 0) ? '-' : '',
				zeroed);
		} else {
			var num = _v0.a;
			return _Utils_ap(
				(fl < 0) ? '-' : '',
				num);
		}
	} else {
		return '';
	}
};
var $myrho$elm_round$Round$roundFun = F3(
	function (functor, s, fl) {
		if ($elm$core$Basics$isInfinite(fl) || $elm$core$Basics$isNaN(fl)) {
			return $elm$core$String$fromFloat(fl);
		} else {
			var signed = fl < 0;
			var _v0 = $myrho$elm_round$Round$splitComma(
				$myrho$elm_round$Round$toDecimal(
					$elm$core$Basics$abs(fl)));
			var before = _v0.a;
			var after = _v0.b;
			var r = $elm$core$String$length(before) + s;
			var normalized = _Utils_ap(
				A2($elm$core$String$repeat, (-r) + 1, '0'),
				A3(
					$elm$core$String$padRight,
					r,
					_Utils_chr('0'),
					_Utils_ap(before, after)));
			var totalLen = $elm$core$String$length(normalized);
			var roundDigitIndex = A2($elm$core$Basics$max, 1, r);
			var increase = A2(
				functor,
				signed,
				A3($elm$core$String$slice, roundDigitIndex, totalLen, normalized));
			var remains = A3($elm$core$String$slice, 0, roundDigitIndex, normalized);
			var num = increase ? $elm$core$String$reverse(
				A2(
					$elm$core$Maybe$withDefault,
					'1',
					A2(
						$elm$core$Maybe$map,
						$myrho$elm_round$Round$increaseNum,
						$elm$core$String$uncons(
							$elm$core$String$reverse(remains))))) : remains;
			var numLen = $elm$core$String$length(num);
			var numZeroed = (num === '0') ? num : ((s <= 0) ? _Utils_ap(
				num,
				A2(
					$elm$core$String$repeat,
					$elm$core$Basics$abs(s),
					'0')) : ((_Utils_cmp(
				s,
				$elm$core$String$length(after)) < 0) ? (A3($elm$core$String$slice, 0, numLen - s, num) + ('.' + A3($elm$core$String$slice, numLen - s, numLen, num))) : _Utils_ap(
				before + '.',
				A3(
					$elm$core$String$padRight,
					s,
					_Utils_chr('0'),
					after))));
			return A2($myrho$elm_round$Round$addSign, signed, numZeroed);
		}
	});
var $myrho$elm_round$Round$floor = $myrho$elm_round$Round$roundFun(
	F2(
		function (signed, str) {
			var _v0 = $elm$core$String$uncons(str);
			if (_v0.$ === 'Nothing') {
				return false;
			} else {
				if ('0' === _v0.a.a.valueOf()) {
					var _v1 = _v0.a;
					var rest = _v1.b;
					return signed && A2(
						$elm$core$List$any,
						$elm$core$Basics$neq(
							_Utils_chr('0')),
						$elm$core$String$toList(rest));
				} else {
					return signed;
				}
			}
		}));
var $basti1302$elm_human_readable_filesize$Filesize$removeTrailingZeroesRegex = A2(
	$elm$core$Maybe$withDefault,
	$elm$regex$Regex$never,
	$elm$regex$Regex$fromString('^(\\d+\\.[^0]*)(0+)$'));
var $elm$regex$Regex$replaceAtMost = _Regex_replaceAtMost;
var $basti1302$elm_human_readable_filesize$Filesize$roundToDecimalPlaces = F2(
	function (settings, num) {
		var rounded = A2($myrho$elm_round$Round$floor, settings.decimalPlaces, num);
		var withoutTrailingZeroes = A4(
			$elm$regex$Regex$replaceAtMost,
			1,
			$basti1302$elm_human_readable_filesize$Filesize$removeTrailingZeroesRegex,
			function (_v1) {
				var submatches = _v1.submatches;
				return A2(
					$elm$core$String$join,
					'',
					A2(
						$elm$core$List$map,
						$elm$core$Maybe$withDefault(''),
						A2($elm$core$List$take, 1, submatches)));
			},
			rounded);
		var withoutTrailingDot = A2($elm$core$String$endsWith, '.', withoutTrailingZeroes) ? A2($elm$core$String$dropRight, 1, withoutTrailingZeroes) : withoutTrailingZeroes;
		return (settings.decimalSeparator === '.') ? withoutTrailingDot : A4(
			$elm$regex$Regex$replaceAtMost,
			1,
			$basti1302$elm_human_readable_filesize$Filesize$decimalSeparatorRegex,
			function (_v0) {
				return settings.decimalSeparator;
			},
			withoutTrailingDot);
	});
var $basti1302$elm_human_readable_filesize$Filesize$unknownUnit = {abbreviation: '?', minimumSize: 1};
var $basti1302$elm_human_readable_filesize$Filesize$formatWithSplit = F2(
	function (settings, num) {
		if (!num) {
			return _Utils_Tuple2('0', 'B');
		} else {
			var unitDefinitionList = $basti1302$elm_human_readable_filesize$Filesize$getUnitDefinitionList(settings.units);
			var _v0 = (num < 0) ? _Utils_Tuple2(-num, '-') : _Utils_Tuple2(num, '');
			var num2 = _v0.a;
			var negativePrefix = _v0.b;
			var unitDefinition = A2(
				$elm$core$Maybe$withDefault,
				$basti1302$elm_human_readable_filesize$Filesize$unknownUnit,
				$elm$core$List$head(
					$elm$core$List$reverse(
						A2(
							$elm$core$List$filter,
							function (unitDef) {
								return _Utils_cmp(num2, unitDef.minimumSize) > -1;
							},
							unitDefinitionList))));
			var formattedNumber = A2($basti1302$elm_human_readable_filesize$Filesize$roundToDecimalPlaces, settings, num2 / unitDefinition.minimumSize);
			return _Utils_Tuple2(
				_Utils_ap(negativePrefix, formattedNumber),
				unitDefinition.abbreviation);
		}
	});
var $basti1302$elm_human_readable_filesize$Filesize$formatBase2Split = $basti1302$elm_human_readable_filesize$Filesize$formatWithSplit(
	_Utils_update(
		$basti1302$elm_human_readable_filesize$Filesize$defaultSettings,
		{units: $basti1302$elm_human_readable_filesize$Filesize$Base2}));
var $author$project$Shared$Text$numsp = $elm$core$String$fromChar(
	_Utils_chr('\u2007'));
var $author$project$Shared$Text$fsize = F2(
	function (sp, size) {
		var _v0 = $basti1302$elm_human_readable_filesize$Filesize$formatBase2Split(size);
		var s1 = _v0.a;
		var s2 = _v0.b;
		if (s2 === 'B') {
			return _Utils_ap(
				s1,
				_Utils_ap(
					sp,
					_Utils_ap(
						s2,
						_Utils_ap($author$project$Shared$Text$numsp, $author$project$Shared$Text$numsp))));
		} else {
			return _Utils_ap(
				s1,
				_Utils_ap(sp, s2));
		}
	});
var $elm$core$List$repeatHelp = F3(
	function (result, n, value) {
		repeatHelp:
		while (true) {
			if (n <= 0) {
				return result;
			} else {
				var $temp$result = A2($elm$core$List$cons, value, result),
					$temp$n = n - 1,
					$temp$value = value;
				result = $temp$result;
				n = $temp$n;
				value = $temp$value;
				continue repeatHelp;
			}
		}
	});
var $elm$core$List$repeat = F2(
	function (n, value) {
		return A3($elm$core$List$repeatHelp, _List_Nil, n, value);
	});
var $author$project$Shared$Text$pad = F2(
	function (width, str) {
		var len = $elm$core$String$length(str);
		var num = width - len;
		return A2(
			$elm$core$String$join,
			'',
			_Utils_ap(
				A2($elm$core$List$repeat, num, $author$project$Shared$Text$numsp),
				_List_fromArray(
					[str])));
	});
var $author$project$TopicBundles$View$restrictedTag = F2(
	function (flags, more) {
		return A2(
			$elm$html$Html$span,
			_Utils_ap(
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('tag is-info mr-2 ')
					]),
				more),
			_List_fromArray(
				[
					$elm$html$Html$text(flags.labels.restricted.value)
				]));
	});
var $author$project$Shared$Icon$roundIcon = F2(
	function (size, name) {
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					A2(
					$elm$html$Html$Attributes$style,
					'width',
					$elm$core$String$fromInt(size) + 'px'),
					A2(
					$elm$html$Html$Attributes$style,
					'height',
					$elm$core$String$fromInt(size) + 'px')
				]),
			_List_fromArray(
				[
					A3(
					$elm$html$Html$node,
					'round-initials',
					_List_fromArray(
						[
							$elm$html$Html$Attributes$value(name)
						]),
					_List_Nil)
				]));
	});
var $elm$html$Html$small = _VirtualDom_node('small');
var $elm$html$Html$td = _VirtualDom_node('td');
var $elm$core$Basics$truncate = _Basics_truncate;
var $author$project$Shared$Text$upChar = $elm$core$String$fromChar(
	_Utils_chr('↑'));
var $author$project$TopicBundles$View$viewBundle = F6(
	function (flags, plurals, state, allowupdate, accepted, _v0) {
		var item = _v0.a;
		var bundle = _v0.b;
		var text = function (x) {
			return A2(
				$elm$html$Html$small,
				_List_Nil,
				_List_fromArray(
					[
						$elm$html$Html$text(x)
					]));
		};
		var size_txt = _List_fromArray(
			[
				text(
				A2($author$project$Shared$Text$fsize, $author$project$Shared$Text$nbsp, bundle.stats.size | 0))
			]);
		var restricted_tag = bundle.data.restricted ? _List_fromArray(
			[
				A2($author$project$TopicBundles$View$restrictedTag, flags, _List_Nil)
			]) : _List_Nil;
		var picture = A2($author$project$Shared$Icon$roundIcon, 24, bundle.data.name);
		var picname = A2(
			$elm$html$Html$div,
			_List_Nil,
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('sp-floatleft mr-2')
						]),
					_List_fromArray(
						[picture])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('sp-floatleft is-small')
						]),
					_List_fromArray(
						[
							$elm$html$Html$text(bundle.data.name)
						]))
				]));
		var mount_txt = _List_fromArray(
			[
				text(bundle.stats.mount)
			]);
		var included = item.include;
		var folders_txt = _List_fromArray(
			[
				text(
				A2(
					$author$project$Shared$Text$pad,
					5,
					$elm$core$String$fromInt(bundle.stats.folders)))
			]);
		var enabled = bundle.data.restricted ? accepted : true;
		var bnum = item.bnum;
		var checkbox = A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('checkbox')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$input,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('sp-checkbox'),
							$elm$html$Html$Attributes$type_('checkbox'),
							$elm$html$Html$Attributes$checked(included),
							$elm$html$Html$Attributes$disabled(!enabled),
							$elm$html$Html$Events$onCheck(
							$author$project$TopicBundles$Model$UpdateInclude(bnum))
						]),
					_List_Nil)
				]));
		var updown = allowupdate ? _List_fromArray(
			[
				A2(
				$elm$html$Html$button,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('button is-light is-small p-0'),
						$elm$html$Html$Events$onClick(
						$author$project$TopicBundles$Model$PressMoveUp(bnum))
					]),
				_List_fromArray(
					[
						$elm$html$Html$text($author$project$Shared$Text$upChar)
					])),
				A2(
				$elm$html$Html$button,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('button is-light is-small p-0'),
						$elm$html$Html$Events$onClick(
						$author$project$TopicBundles$Model$PressMoveDown(bnum))
					]),
				_List_fromArray(
					[
						$elm$html$Html$text($author$project$Shared$Text$downChar)
					]))
			]) : _List_Nil;
		return A2(
			$elm$html$Html$tr,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('is-hoverable')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$td,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('is-checkbox-cell')
						]),
					_List_fromArray(
						[checkbox])),
					A2(
					$elm$html$Html$td,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('px-1'),
							A2($elm$html$Html$Attributes$attribute, 'data-label', flags.labels.name.label)
						]),
					_List_fromArray(
						[picname])),
					A2(
					$elm$html$Html$td,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('px-1'),
							A2($elm$html$Html$Attributes$attribute, 'data-label', flags.labels.restricted.datalabel)
						]),
					restricted_tag),
					A2(
					$elm$html$Html$td,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('px-1'),
							A2($elm$html$Html$Attributes$attribute, 'data-label', flags.labels.mount.label)
						]),
					mount_txt),
					A2(
					$elm$html$Html$td,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('px-1'),
							A2($elm$html$Html$Attributes$attribute, 'data-label', flags.labels.folders.label)
						]),
					_List_fromArray(
						[
							A2($elm$html$Html$div, _List_Nil, folders_txt)
						])),
					A2(
					$elm$html$Html$td,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('px-1'),
							A2($elm$html$Html$Attributes$attribute, 'data-label', flags.labels.size.label)
						]),
					_List_fromArray(
						[
							A2($elm$html$Html$div, _List_Nil, size_txt)
						])),
					A2(
					$elm$html$Html$td,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('px-0')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('is-flex')
								]),
							_Utils_ap(
								updown,
								_List_fromArray(
									[
										A2(
										$elm$html$Html$button,
										_List_fromArray(
											[
												$elm$html$Html$Attributes$class('button has-background-primary-dark has-text-white is-link is-small'),
												$elm$html$Html$Events$onClick(
												$author$project$TopicBundles$Model$PressDetails(bnum))
											]),
										_List_fromArray(
											[
												$elm$html$Html$text(flags.labels.details.label)
											]))
									])))
						]))
				]));
	});
var $author$project$TopicBundles$Model$someRestricted = F2(
	function (state, accepted) {
		return accepted ? false : A2(
			$elm$core$List$any,
			function (_v0) {
				var b = _v0.b;
				return b.data.restricted;
			},
			$author$project$TopicBundles$Model$bundleList(state));
	});
var $author$project$TopicBundles$View$viewSelectedError = F3(
	function (flags, state, accepted) {
		var _v0 = state.problems.selectedErr;
		if (_v0.$ === 'Just') {
			var reason = _v0.a;
			return A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('help is-danger')
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$p,
						_List_Nil,
						$author$project$Shared$Text$htmlTextLines(reason))
					]));
		} else {
			return A2($author$project$TopicBundles$Model$someRestricted, state, accepted) ? A2(
				$elm$html$Html$p,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('help is-flex mt-1')
					]),
				_List_fromArray(
					[
						$elm$html$Html$text(flags.labels.restricted.accept),
						$elm$html$Html$text($author$project$Shared$Text$nbsp),
						A2(
						$author$project$TopicBundles$View$restrictedTag,
						flags,
						_List_fromArray(
							[
								A2($elm$html$Html$Attributes$style, 'width', '16px'),
								A2($elm$html$Html$Attributes$style, 'height', '16px')
							]))
					])) : A2($elm$html$Html$div, _List_Nil, _List_Nil);
		}
	});
var $author$project$TopicBundles$View$viewTopicBundles = F5(
	function (flags, plurals, state, allowupdate, accepted) {
		var viewbundles = A2(
			$elm$core$List$map,
			A5($author$project$TopicBundles$View$viewBundle, flags, plurals, state, allowupdate, accepted),
			$author$project$TopicBundles$Model$bundleList(state));
		var colwidth = function (value) {
			if (value === '') {
				return _List_Nil;
			} else {
				return _List_fromArray(
					[
						A2($elm$html$Html$Attributes$style, 'width', value)
					]);
			}
		};
		var details_width = A2(
			$elm$core$List$cons,
			$elm$html$Html$Attributes$class('px-0'),
			colwidth(flags.labels.details.width));
		var folders_width = A2(
			$elm$core$List$cons,
			$elm$html$Html$Attributes$class('px-1'),
			colwidth(flags.labels.folders.width));
		var mount_width = A2(
			$elm$core$List$cons,
			$elm$html$Html$Attributes$class('px-1'),
			colwidth(flags.labels.mount.width));
		var name_width = A2(
			$elm$core$List$cons,
			$elm$html$Html$Attributes$class('px-1'),
			colwidth(flags.labels.name.width));
		var reset_width = colwidth(flags.labels.reset.width);
		var reset_button = _List_fromArray(
			[
				A2(
				$elm$html$Html$button,
				_Utils_ap(
					reset_width,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('button has-background-primary-dark has-text-white is-link is-small is-pulled-right px-1'),
							$elm$html$Html$Events$onClick($author$project$TopicBundles$Model$PressReset)
						])),
				_List_fromArray(
					[
						$elm$html$Html$text(flags.labels.reset.label)
					]))
			]);
		var restricted_width = A2(
			$elm$core$List$cons,
			$elm$html$Html$Attributes$class('px-1'),
			colwidth(flags.labels.restricted.width));
		var size_width = A2(
			$elm$core$List$cons,
			$elm$html$Html$Attributes$class('px-1'),
			colwidth(flags.labels.size.width));
		var checkbox_width = A2(
			$elm$core$List$cons,
			$elm$html$Html$Attributes$class('px-0'),
			colwidth(flags.labels.checkbox.width));
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('field mt-0 pt-0')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('mx-2')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('b-table')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('table-wrapper has-mobile-cards')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$table,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('table is-fullwidth is-hoverable')
												]),
											_List_fromArray(
												[
													A2(
													$elm$html$Html$thead,
													_List_Nil,
													_List_fromArray(
														[
															A2(
															$elm$html$Html$tr,
															_List_Nil,
															_List_fromArray(
																[
																	A2($elm$html$Html$th, checkbox_width, _List_Nil),
																	A2(
																	$elm$html$Html$th,
																	name_width,
																	_List_fromArray(
																		[
																			$elm$html$Html$text(flags.labels.name.label)
																		])),
																	A2($elm$html$Html$th, restricted_width, _List_Nil),
																	A2(
																	$elm$html$Html$th,
																	mount_width,
																	_List_fromArray(
																		[
																			$elm$html$Html$text(flags.labels.mount.label)
																		])),
																	A2(
																	$elm$html$Html$th,
																	folders_width,
																	_List_fromArray(
																		[
																			$elm$html$Html$text(flags.labels.folders.label)
																		])),
																	A2(
																	$elm$html$Html$th,
																	size_width,
																	_List_fromArray(
																		[
																			$elm$html$Html$text(flags.labels.size.label)
																		])),
																	A2($elm$html$Html$th, details_width, _List_Nil)
																]))
														])),
													A2($elm$html$Html$tbody, _List_Nil, viewbundles)
												]))
										]))
								])),
							A2(
							$elm$html$Html$div,
							_List_Nil,
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A3($author$project$TopicBundles$View$viewSelectedError, flags, state, accepted)
										]))
								]))
						]))
				]));
	});
var $author$project$TopicBundles$View$view = F5(
	function (flags, plurals, state, allowupdate, accepted) {
		return A2(
			$elm$html$Html$div,
			_List_Nil,
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('sp-form mb-0 py-3')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field is-horizontal mb-0')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('field-body')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$div,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('field')
												]),
											_List_fromArray(
												[
													A2(
													$elm$html$Html$div,
													_List_fromArray(
														[
															$elm$html$Html$Attributes$class('control')
														]),
													_List_fromArray(
														[
															A5($author$project$TopicBundles$View$viewTopicBundles, flags, plurals, state, allowupdate, accepted)
														]))
												]))
										]))
								]))
						]))
				]));
	});
var $author$project$CommentData$Comment$beingEdited = function (_v0) {
	var child = _v0.a;
	return child.edit ? true : A3(
		$elm$core$List$foldl,
		F2(
			function (n, acc) {
				return acc || $author$project$CommentData$Comment$beingEdited(n);
			}),
		false,
		child.replies);
};
var $author$project$CommentData$Comment$countDescendents = function (_v0) {
	var child = _v0.a;
	return A3(
		$elm$core$List$foldl,
		F2(
			function (n, acc) {
				return acc + $author$project$CommentData$Comment$countDescendents(n);
			}),
		1,
		child.replies);
};
var $author$project$CommentData$Comment$Row = F4(
	function (detail, path, hidden, edit) {
		return {detail: detail, edit: edit, hidden: hidden, path: path};
	});
var $author$project$CommentData$Comment$getComments = function (root) {
	var flatComments = F2(
		function (path, n) {
			var comment = n.a;
			var hidden = comment.expanded ? $elm$core$Maybe$Nothing : $elm$core$Maybe$Just(
				$author$project$CommentData$Comment$countDescendents(n));
			var thisrow = A4(
				$author$project$CommentData$Comment$Row,
				comment.detail,
				$elm$core$List$reverse(path),
				hidden,
				comment.edit);
			var helper = function (nr) {
				var reply = nr.a;
				return A2(
					flatComments,
					A2($elm$core$List$cons, reply.detail.path, path),
					nr);
			};
			var replyrows = $elm$core$List$concat(
				A2($elm$core$List$map, helper, comment.replies));
			var _v0 = comment.expanded;
			if (_v0) {
				return A2($elm$core$List$cons, thisrow, replyrows);
			} else {
				return _List_fromArray(
					[thisrow]);
			}
		});
	var maybeComments = $elm$core$List$tail(
		A2(flatComments, _List_Nil, root));
	return A2($elm$core$Maybe$withDefault, _List_Nil, maybeComments);
};
var $elm$core$List$concatMap = F2(
	function (f, list) {
		return $elm$core$List$concat(
			A2($elm$core$List$map, f, list));
	});
var $author$project$TopicComments$Model$ToggleComment = function (a) {
	return {$: 'ToggleComment', a: a};
};
var $sporto$time_distance$Time$Distance$second = 1000;
var $sporto$time_distance$Time$Distance$minute = $sporto$time_distance$Time$Distance$second * 60;
var $sporto$time_distance$Time$Distance$hour = $sporto$time_distance$Time$Distance$minute * 60;
var $sporto$time_distance$Time$Distance$day = $sporto$time_distance$Time$Distance$hour * 24;
var $sporto$time_distance$Time$Distance$month = $sporto$time_distance$Time$Distance$day * 30;
var $sporto$time_distance$Time$Distance$toS = $elm$core$String$fromInt;
var $sporto$time_distance$Time$Distance$year = $sporto$time_distance$Time$Distance$day * 365;
var $sporto$time_distance$Time$Distance$inWords = F2(
	function (posix1, posix2) {
		var time2 = $elm$time$Time$posixToMillis(posix2);
		var time1 = $elm$time$Time$posixToMillis(posix1);
		var diff = time1 - time2;
		var absDiff = $elm$core$Basics$abs(diff);
		var diffInDays = (absDiff / $sporto$time_distance$Time$Distance$day) | 0;
		var diffInHours = (absDiff / $sporto$time_distance$Time$Distance$hour) | 0;
		var diffInMinutes = (absDiff / $sporto$time_distance$Time$Distance$minute) | 0;
		var diffInMonths = (absDiff / $sporto$time_distance$Time$Distance$month) | 0;
		var diffInSeconds = (absDiff / $sporto$time_distance$Time$Distance$second) | 0;
		var diffInYear = (absDiff / $sporto$time_distance$Time$Distance$year) | 0;
		var diffInYearFloat = absDiff / $sporto$time_distance$Time$Distance$year;
		if (!diffInSeconds) {
			return '0 seconds';
		} else {
			if (diffInSeconds < 25) {
				return 'less than ' + ($sporto$time_distance$Time$Distance$toS(diffInSeconds) + ' seconds');
			} else {
				if (diffInSeconds < 35) {
					return 'half a minute';
				} else {
					if (diffInSeconds < 60) {
						return 'less than a minute';
					} else {
						if (diffInSeconds < 120) {
							return '1 minute';
						} else {
							if (diffInMinutes < 60) {
								return $sporto$time_distance$Time$Distance$toS(diffInMinutes) + ' minutes';
							} else {
								if (diffInMinutes < 91) {
									return 'about 1 hour';
								} else {
									if (diffInMinutes < 120) {
										return 'about 2 hours';
									} else {
										if (diffInHours < 24) {
											return 'about ' + ($sporto$time_distance$Time$Distance$toS(diffInHours) + ' hours');
										} else {
											if (diffInHours <= 40) {
												return '1 day';
											} else {
												if (diffInHours < 48) {
													return '2 days';
												} else {
													if (diffInDays < 30) {
														return $sporto$time_distance$Time$Distance$toS(diffInDays) + ' days';
													} else {
														if (diffInDays < 60) {
															return 'about 1 month';
														} else {
															if (diffInMonths < 12) {
																return 'about ' + ($sporto$time_distance$Time$Distance$toS(diffInMonths) + ' months');
															} else {
																if (diffInMonths < 21) {
																	return 'about 1 year';
																} else {
																	var sinceStartOfYear = absDiff % $sporto$time_distance$Time$Distance$year;
																	var monthsSinceStartOfYear = (sinceStartOfYear / $sporto$time_distance$Time$Distance$month) | 0;
																	return (monthsSinceStartOfYear < 3) ? ('about ' + ($sporto$time_distance$Time$Distance$toS(diffInYear) + ' years')) : ((monthsSinceStartOfYear < 9) ? ('over ' + ($sporto$time_distance$Time$Distance$toS(diffInYear) + ' years')) : ('almost ' + ($sporto$time_distance$Time$Distance$toS(diffInYear + 1) + ' years')));
																}
															}
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	});
var $author$project$TopicComments$View$viewCommentInfo = F4(
	function (flags, mfn, state, row) {
		var now = state.clock.time;
		var from = mfn(row.detail.mnum);
		var expandlabel = function () {
			var _v0 = row.hidden;
			if (_v0.$ === 'Nothing') {
				return '-';
			} else {
				var count = _v0.a;
				return $elm$core$String$fromInt(count) + (' ' + flags.labels.more.label);
			}
		}();
		var created = row.detail.when;
		var age = A2($sporto$time_distance$Time$Distance$inWords, created, now) + (' ' + flags.labels.ago.label);
		var part1text = from + (' - ' + (age + ' '));
		return _List_fromArray(
			[
				$elm$html$Html$text(part1text),
				A2(
				$elm$html$Html$span,
				_List_Nil,
				_List_fromArray(
					[
						A2(
						$elm$html$Html$button,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('button is-small'),
								A2($elm$html$Html$Attributes$style, 'height', '18px'),
								$elm$html$Html$Events$onClick(
								$author$project$TopicComments$Model$ToggleComment(row.path))
							]),
						_List_fromArray(
							[
								$elm$html$Html$text(expandlabel)
							]))
					]))
			]);
	});
var $author$project$TopicComments$Model$AddComment = function (a) {
	return {$: 'AddComment', a: a};
};
var $author$project$TopicComments$Model$EditComment = function (a) {
	return {$: 'EditComment', a: a};
};
var $author$project$TopicComments$View$viewCommentText = F5(
	function (flags, state, accepted, auth, row) {
		var sentences = A2($elm$core$String$split, '\n\n', row.detail.what);
		var editbtn = function () {
			var _v0 = _Utils_Tuple2(accepted, auth);
			if (_v0.a && (_v0.b.$ === 'Success')) {
				var auth2 = _v0.b.a;
				return _Utils_eq(auth2.mnum, row.detail.mnum) ? _List_fromArray(
					[
						A2(
						$elm$html$Html$button,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('button is-small'),
								A2($elm$html$Html$Attributes$style, 'border', '0px none'),
								A2($elm$html$Html$Attributes$style, 'padding', '0px'),
								A2($elm$html$Html$Attributes$style, 'text-decoration', 'underline'),
								$elm$html$Html$Events$onClick(
								$author$project$TopicComments$Model$EditComment(row.path))
							]),
						_List_fromArray(
							[
								$elm$html$Html$text(flags.labels.edit2.label)
							]))
					]) : _List_Nil;
			} else {
				return _List_Nil;
			}
		}();
		var content = A2(
			$elm$core$List$map,
			function (s) {
				return A2(
					$elm$html$Html$p,
					_List_Nil,
					_List_fromArray(
						[
							$elm$html$Html$text(s)
						]));
			},
			sentences);
		var buttons = _Utils_ap(
			_List_fromArray(
				[
					A2(
					$elm$html$Html$button,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('button is-small'),
							A2($elm$html$Html$Attributes$style, 'border', '0px none'),
							A2($elm$html$Html$Attributes$style, 'padding', '0px'),
							A2($elm$html$Html$Attributes$style, 'text-decoration', 'underline'),
							$elm$html$Html$Events$onClick(
							$author$project$TopicComments$Model$AddComment(row.path))
						]),
					_List_fromArray(
						[
							$elm$html$Html$text(flags.labels.reply.label)
						])),
					$elm$html$Html$text(' ')
				]),
			editbtn);
		return _Utils_ap(content, buttons);
	});
var $author$project$TopicComments$View$viewComment = F6(
	function (flags, mfn, state, accepted, auth, row) {
		var parts = function () {
			var _v0 = row.hidden;
			if (_v0.$ === 'Nothing') {
				return _Utils_ap(
					A4($author$project$TopicComments$View$viewCommentInfo, flags, mfn, state, row),
					A5($author$project$TopicComments$View$viewCommentText, flags, state, accepted, auth, row));
			} else {
				return A4($author$project$TopicComments$View$viewCommentInfo, flags, mfn, state, row);
			}
		}();
		var depth = $elm$core$List$length(row.path);
		return _List_fromArray(
			[
				A2(
				$elm$html$Html$tr,
				_List_Nil,
				_List_fromArray(
					[
						A2(
						$elm$html$Html$td,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('has-text-left'),
								A2($elm$html$Html$Attributes$style, 'font-family', 'Verdana, Geneva, sans-serif'),
								A2($elm$html$Html$Attributes$style, 'font-size', '9pt'),
								A2(
								$elm$html$Html$Attributes$style,
								'padding-left',
								$elm$core$String$fromInt(depth * 25) + 'px')
							]),
						parts)
					]))
			]);
	});
var $author$project$TopicComments$Model$CancelComment = function (a) {
	return {$: 'CancelComment', a: a};
};
var $author$project$TopicComments$Model$PressSave = function (a) {
	return {$: 'PressSave', a: a};
};
var $author$project$TopicComments$Model$UpdateComment = F2(
	function (a, b) {
		return {$: 'UpdateComment', a: a, b: b};
	});
var $elm$html$Html$Events$alwaysStop = function (x) {
	return _Utils_Tuple2(x, true);
};
var $elm$virtual_dom$VirtualDom$MayStopPropagation = function (a) {
	return {$: 'MayStopPropagation', a: a};
};
var $elm$html$Html$Events$stopPropagationOn = F2(
	function (event, decoder) {
		return A2(
			$elm$virtual_dom$VirtualDom$on,
			event,
			$elm$virtual_dom$VirtualDom$MayStopPropagation(decoder));
	});
var $elm$html$Html$Events$targetValue = A2(
	$elm$json$Json$Decode$at,
	_List_fromArray(
		['target', 'value']),
	$elm$json$Json$Decode$string);
var $elm$html$Html$Events$onInput = function (tagger) {
	return A2(
		$elm$html$Html$Events$stopPropagationOn,
		'input',
		A2(
			$elm$json$Json$Decode$map,
			$elm$html$Html$Events$alwaysStop,
			A2($elm$json$Json$Decode$map, tagger, $elm$html$Html$Events$targetValue)));
};
var $elm$html$Html$textarea = _VirtualDom_node('textarea');
var $author$project$TopicComments$View$viewEditComment = F4(
	function (flags, mfn, state, row) {
		var from = mfn(row.detail.mnum);
		var depth = $elm$core$List$length(row.path);
		return _List_fromArray(
			[
				A2(
				$elm$html$Html$tr,
				_List_Nil,
				_List_fromArray(
					[
						A2(
						$elm$html$Html$td,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('has-text-left'),
								A2(
								$elm$html$Html$Attributes$style,
								'padding-left',
								$elm$core$String$fromInt(depth * 25) + 'px')
							]),
						_List_fromArray(
							[
								A2(
								$elm$html$Html$div,
								_List_fromArray(
									[
										$elm$html$Html$Attributes$class('_who')
									]),
								_List_fromArray(
									[
										$elm$html$Html$text('From: '),
										$elm$html$Html$text(from)
									])),
								A2(
								$elm$html$Html$div,
								_List_fromArray(
									[
										$elm$html$Html$Attributes$class('_what')
									]),
								_List_fromArray(
									[
										A2(
										$elm$html$Html$textarea,
										_List_fromArray(
											[
												$elm$html$Html$Attributes$class('textarea'),
												$elm$html$Html$Events$onInput(
												$author$project$TopicComments$Model$UpdateComment(row.path))
											]),
										_List_fromArray(
											[
												$elm$html$Html$text(row.detail.what)
											]))
									])),
								A2(
								$elm$html$Html$button,
								_List_fromArray(
									[
										$elm$html$Html$Attributes$class('button has-background-primary-dark has-text-white is-small'),
										$elm$html$Html$Events$onClick(
										$author$project$TopicComments$Model$PressSave(row.path))
									]),
								_List_fromArray(
									[
										$elm$html$Html$text(flags.labels.save.label)
									])),
								A2(
								$elm$html$Html$button,
								_List_fromArray(
									[
										$elm$html$Html$Attributes$class('button has-background-primary-dark has-text-white is-small'),
										$elm$html$Html$Events$onClick(
										$author$project$TopicComments$Model$CancelComment(row.path))
									]),
								_List_fromArray(
									[
										$elm$html$Html$text(flags.labels.cancel.label)
									]))
							]))
					]))
			]);
	});
var $author$project$TopicComments$View$viewBodyComment = F6(
	function (flags, mfn, state, accepted, auth, row) {
		return row.edit ? A4($author$project$TopicComments$View$viewEditComment, flags, mfn, state, row) : A6($author$project$TopicComments$View$viewComment, flags, mfn, state, accepted, auth, row);
	});
var $author$project$TopicComments$View$viewBodyComments = F6(
	function (flags, mfn, state, accepted, auth, comments) {
		return _List_fromArray(
			[
				A2(
				$elm$html$Html$tbody,
				_List_Nil,
				A2(
					$elm$core$List$concatMap,
					A5($author$project$TopicComments$View$viewBodyComment, flags, mfn, state, accepted, auth),
					comments))
			]);
	});
var $author$project$TopicComments$View$viewSection = F6(
	function (flags, mfn, state, accepted, auth, comments) {
		if (!comments.b) {
			return A2($elm$html$Html$div, _List_Nil, _List_Nil);
		} else {
			return A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('sp-form mt-3 mx-3 mb-0 py-3')
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$div,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('field is-horizontal mb-0')
							]),
						_List_fromArray(
							[
								A2(
								$elm$html$Html$div,
								_List_fromArray(
									[
										$elm$html$Html$Attributes$class('field-body')
									]),
								_List_fromArray(
									[
										A2(
										$elm$html$Html$div,
										_List_fromArray(
											[
												$elm$html$Html$Attributes$class('field')
											]),
										_List_fromArray(
											[
												A2(
												$elm$html$Html$div,
												_List_fromArray(
													[
														$elm$html$Html$Attributes$class('control')
													]),
												_List_fromArray(
													[
														A2(
														$elm$html$Html$div,
														_List_fromArray(
															[
																$elm$html$Html$Attributes$class('field mt-0 pt-0')
															]),
														_List_fromArray(
															[
																A2(
																$elm$html$Html$div,
																_List_fromArray(
																	[
																		$elm$html$Html$Attributes$class('mx-2')
																	]),
																_List_fromArray(
																	[
																		A2(
																		$elm$html$Html$table,
																		_List_fromArray(
																			[
																				$elm$html$Html$Attributes$class('table is-fullwidth')
																			]),
																		A6($author$project$TopicComments$View$viewBodyComments, flags, mfn, state, accepted, auth, comments))
																	]))
															]))
													]))
											]))
									]))
							]))
					]));
		}
	});
var $author$project$TopicComments$Model$PressAccept = {$: 'PressAccept'};
var $elm$html$Html$h2 = _VirtualDom_node('h2');
var $author$project$Shared$Plural$plural_comments = F3(
	function (plurals, n, tag) {
		switch (n) {
			case 0:
				return _List_fromArray(
					[
						tag(plurals.noComments)
					]);
			case 1:
				return _List_fromArray(
					[
						tag(plurals.oneComment)
					]);
			default:
				return _List_fromArray(
					[
						tag(
						$elm$core$String$fromInt(n)),
						tag($author$project$Shared$Text$nbsp),
						tag(plurals.comments)
					]);
		}
	});
var $author$project$TopicComments$View$viewSectionTitle = F7(
	function (flags, plurals, adding, state, accepted, editing, total) {
		if (!accepted) {
			return _List_fromArray(
				[
					A2(
					$elm$html$Html$h2,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('mb-0')
						]),
					_List_fromArray(
						[
							$elm$html$Html$text(flags.labels.title.label)
						])),
					A2(
					$elm$html$Html$button,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('button has-background-primary-dark has-text-white is-pulled-right pr-5'),
							$elm$html$Html$Events$onClick($author$project$TopicComments$Model$PressAccept)
						]),
					_List_fromArray(
						[
							$elm$html$Html$text(flags.labels.accept.label)
						])),
					A2(
					$elm$html$Html$p,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('has-text-danger')
						]),
					_List_fromArray(
						[
							$elm$html$Html$text(flags.labels.invitation.description)
						]))
				]);
		} else {
			var smalltext = function (x) {
				return A2(
					$elm$html$Html$small,
					_List_Nil,
					_List_fromArray(
						[
							$elm$html$Html$text(x)
						]));
			};
			var comment_count = A2(
				$elm$html$Html$p,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('ml-2')
					]),
				A3($author$project$Shared$Plural$plural_comments, plurals, total, smalltext));
			var addwarning = (adding && (total > 0)) ? A2(
				$elm$html$Html$p,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('has-text-danger')
					]),
				_List_fromArray(
					[
						$elm$html$Html$text(flags.labels.addWarning.description)
					])) : A2($elm$html$Html$div, _List_Nil, _List_Nil);
			return _List_fromArray(
				[
					A2(
					$elm$html$Html$h3,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('mb-0')
						]),
					_List_fromArray(
						[
							$elm$html$Html$text(flags.labels.title.label),
							function () {
							var _v0 = state.mnum;
							if (_v0.$ === 'Just') {
								var mnum = _v0.a;
								return A2(
									$elm$html$Html$button,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('button has-background-primary-dark has-text-white is-link is-pulled-right'),
											A2($elm$html$Html$Attributes$style, 'width', flags.labels.addComment.width),
											$elm$html$Html$Attributes$disabled(editing),
											$elm$html$Html$Events$onClick(
											$author$project$TopicComments$Model$AddComment(_List_Nil))
										]),
									_List_fromArray(
										[
											$elm$html$Html$text(flags.labels.addComment.label)
										]));
							} else {
								return A2($elm$html$Html$div, _List_Nil, _List_Nil);
							}
						}()
						])),
					comment_count,
					A2(
					$elm$html$Html$p,
					_List_Nil,
					_List_fromArray(
						[
							$elm$html$Html$text(flags.labels.description.label)
						])),
					addwarning
				]);
		}
	});
var $author$project$TopicComments$View$view = F7(
	function (flags, plurals, mfn, adding, state, accepted, rauth) {
		var total = $author$project$CommentData$Comment$countDescendents(state.comments) - 1;
		var editing = $author$project$CommentData$Comment$beingEdited(state.comments);
		var comments = $author$project$CommentData$Comment$getComments(state.comments);
		return A2(
			$elm$html$Html$div,
			_List_Nil,
			_Utils_ap(
				A7($author$project$TopicComments$View$viewSectionTitle, flags, plurals, adding, state, accepted, editing, total),
				_List_fromArray(
					[
						A6($author$project$TopicComments$View$viewSection, flags, mfn, state, accepted, rauth, comments)
					])));
	});
var $author$project$TopicDetails$Model$UpdateDescription = function (a) {
	return {$: 'UpdateDescription', a: a};
};
var $author$project$Shared$Text$greenX = $elm$core$String$fromChar(
	_Utils_chr('❎'));
var $author$project$TopicDetails$View$isEditable = function (state) {
	var _v0 = _Utils_Tuple2(state.initial, state.mnum);
	if ((_v0.a.$ === 'Just') && (_v0.b.$ === 'Just')) {
		var initial = _v0.a.a;
		var mnum = _v0.b.a;
		return _Utils_eq(
			initial.creator,
			$elm$core$Maybe$Just(mnum));
	} else {
		return true;
	}
};
var $elm$html$Html$Attributes$placeholder = $elm$html$Html$Attributes$stringProperty('placeholder');
var $author$project$Shared$Text$placeholder = F2(
	function (value, readonly) {
		if (readonly) {
			return _List_Nil;
		} else {
			return _List_fromArray(
				[
					$elm$html$Html$Attributes$placeholder(value)
				]);
		}
	});
var $elm$html$Html$Attributes$readonly = $elm$html$Html$Attributes$boolProperty('readOnly');
var $elm$html$Html$Attributes$rows = function (n) {
	return A2(
		_VirtualDom_attribute,
		'rows',
		$elm$core$String$fromInt(n));
};
var $author$project$TopicDetails$View$viewDescription = F2(
	function (flags, state) {
		var reset = function () {
			var _v0 = state.initial;
			if (_v0.$ === 'Just') {
				var initial = _v0.a;
				return (!_Utils_eq(initial.details.description, state.current.details.description)) ? _List_fromArray(
					[
						A2(
						$elm$html$Html$button,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('sp-icon is-right'),
								$elm$html$Html$Events$onClick(
								$author$project$TopicDetails$Model$UpdateDescription(initial.details.description))
							]),
						_List_fromArray(
							[
								$elm$html$Html$text($author$project$Shared$Text$greenX)
							]))
					]) : _List_Nil;
			} else {
				return _List_Nil;
			}
		}();
		var noteditable = !$author$project$TopicDetails$View$isEditable(state);
		var help = $author$project$Shared$Text$htmlTextLines(flags.labels.description.description);
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('field is-horizontal')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-label is-normal')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									noteditable ? _List_Nil : _List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help is-hidden-mobile')
												]),
											$author$project$Shared$Text$dropExtra(
												$author$project$Shared$Text$htmlBreaks(help)))
										])),
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('label ml-1')
												]),
											_List_fromArray(
												[
													$elm$html$Html$text(flags.labels.description.label)
												]))
										]))
								]))
						])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-body')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									noteditable ? _List_Nil : _List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help')
												]),
											help)
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('control has-icons-right')
										]),
									_Utils_ap(
										_List_fromArray(
											[
												A2(
												$elm$html$Html$textarea,
												_Utils_ap(
													_List_fromArray(
														[
															$elm$html$Html$Attributes$class('textarea'),
															$elm$html$Html$Attributes$rows(5),
															$elm$html$Html$Attributes$readonly(noteditable),
															$elm$html$Html$Attributes$value(state.current.details.description),
															$elm$html$Html$Events$onInput($author$project$TopicDetails$Model$UpdateDescription)
														]),
													A2($author$project$Shared$Text$placeholder, flags.labels.description.placeholder, noteditable)),
												_List_Nil)
											]),
										reset))
								])),
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field-label is-normal'),
									A2($elm$html$Html$Attributes$style, 'max-width', '5px')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$label,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('label')
										]),
									_List_Nil)
								]))
						]))
				]));
	});
var $author$project$TopicDetails$Model$UpdateTitle = function (a) {
	return {$: 'UpdateTitle', a: a};
};
var $author$project$Shared$Text$has_danger = F3(
	function (cls, err, readonly) {
		var _v0 = _Utils_Tuple2(err, readonly);
		if ((_v0.a.$ === 'Just') && (!_v0.b)) {
			return cls + ' has-text-danger';
		} else {
			return cls;
		}
	});
var $author$project$Shared$Text$is_danger = F3(
	function (cls, err, readonly) {
		var _v0 = _Utils_Tuple2(err, readonly);
		if ((_v0.a.$ === 'Just') && (!_v0.b)) {
			return cls + ' is-danger';
		} else {
			return cls;
		}
	});
var $author$project$TopicDetails$ViewError$viewTitleError = F2(
	function (flags, state) {
		var _v0 = state.problems.titleErr;
		if (_v0.$ === 'Just') {
			var reason = _v0.a;
			return A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('help is-danger')
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$p,
						_List_Nil,
						$author$project$Shared$Text$htmlTextLines(reason))
					]));
		} else {
			return A2($elm$html$Html$div, _List_Nil, _List_Nil);
		}
	});
var $author$project$TopicDetails$View$viewTitle = F2(
	function (flags, state) {
		var reset = function () {
			var _v0 = state.initial;
			if (_v0.$ === 'Just') {
				var initial = _v0.a;
				return (!_Utils_eq(initial.details.title, state.current.details.title)) ? _List_fromArray(
					[
						A2(
						$elm$html$Html$button,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('sp-icon is-right'),
								$elm$html$Html$Events$onClick(
								$author$project$TopicDetails$Model$UpdateTitle(initial.details.title))
							]),
						_List_fromArray(
							[
								$elm$html$Html$text($author$project$Shared$Text$greenX)
							]))
					]) : _List_Nil;
			} else {
				return _List_Nil;
			}
		}();
		var noteditable = !$author$project$TopicDetails$View$isEditable(state);
		var help = $author$project$Shared$Text$htmlTextLines(flags.labels.title.description);
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('field is-horizontal')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-label is-normal')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									noteditable ? _List_Nil : _List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help is-hidden-mobile')
												]),
											$author$project$Shared$Text$dropExtra(
												$author$project$Shared$Text$htmlBreaks(help)))
										])),
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class(
													A3($author$project$Shared$Text$has_danger, 'label ml-1', state.problems.titleErr, noteditable))
												]),
											_List_fromArray(
												[
													$elm$html$Html$text(flags.labels.title.label)
												]))
										]))
								]))
						])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-body')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									noteditable ? _List_Nil : _List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help')
												]),
											help)
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('field')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$div,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('control has-icons-right')
												]),
											_Utils_ap(
												_List_fromArray(
													[
														A2(
														$elm$html$Html$input,
														_Utils_ap(
															_List_fromArray(
																[
																	$elm$html$Html$Attributes$class(
																	A3($author$project$Shared$Text$is_danger, 'input', state.problems.titleErr, noteditable)),
																	$elm$html$Html$Attributes$type_('text'),
																	$elm$html$Html$Attributes$readonly(noteditable),
																	$elm$html$Html$Attributes$value(state.current.details.title),
																	$elm$html$Html$Events$onInput($author$project$TopicDetails$Model$UpdateTitle)
																]),
															A2($author$project$Shared$Text$placeholder, flags.labels.title.placeholder, noteditable)),
														_List_Nil)
													]),
												reset))
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('field')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$div,
											_List_Nil,
											_List_fromArray(
												[
													A2(
													$elm$html$Html$div,
													_List_Nil,
													_List_fromArray(
														[
															A2($author$project$TopicDetails$ViewError$viewTitleError, flags, state)
														]))
												]))
										]))
								])),
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field-label is-normal'),
									A2($elm$html$Html$Attributes$style, 'max-width', '5px')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$label,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('label')
										]),
									_List_Nil)
								]))
						]))
				]));
	});
var $author$project$TopicDetails$View$view = F2(
	function (flags, state) {
		var title = _List_fromArray(
			[
				A2($author$project$TopicDetails$View$viewTitle, flags, state)
			]);
		var divcls = _List_fromArray(
			[
				$elm$html$Html$Attributes$class('sp-form py-3')
			]);
		var desc = _List_fromArray(
			[
				A2($author$project$TopicDetails$View$viewDescription, flags, state)
			]);
		return A2(
			$elm$html$Html$div,
			divcls,
			_Utils_ap(title, desc));
	});
var $author$project$TopicMembers$Model$UpdateShared = F2(
	function (a, b) {
		return {$: 'UpdateShared', a: a, b: b};
	});
var $author$project$TopicMembers$View$acceptedTag = F2(
	function (flags, more) {
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					A2($elm$html$Html$Attributes$style, 'width', '24px'),
					A2($elm$html$Html$Attributes$style, 'height', '24px'),
					A2($elm$html$Html$Attributes$style, 'transform', 'translate(0px, -2px)')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$span,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('tag is-info px-2 ' + more)
						]),
					_List_fromArray(
						[
							$elm$html$Html$text(flags.labels.accepted.value)
						]))
				]));
	});
var $elm$core$List$all = F2(
	function (isOkay, list) {
		return !A2(
			$elm$core$List$any,
			A2($elm$core$Basics$composeL, $elm$core$Basics$not, isOkay),
			list);
	});
var $author$project$TopicMembers$View$viewMember = F5(
	function (flags, state, mcreator, bstate, _v0) {
		var mnum = _v0.a;
		var profile = _v0.b;
		var topic_bnums = A2(
			$elm$core$List$map,
			function (tb) {
				return tb.bnum;
			},
			A2(
				$elm$core$List$filter,
				function (tb) {
					return tb.include;
				},
				bstate.current));
		var shared = A2($elm$core$Set$member, mnum, state.initial) ? (!A2($elm$core$Set$member, mnum, state.removed)) : A2($elm$core$Set$member, mnum, state.added);
		var picture = A2($author$project$Shared$Icon$squareIcon, 24, profile.initials);
		var picmon = A2(
			$elm$html$Html$div,
			_List_Nil,
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('sp-floatleft mr-2')
						]),
					_List_fromArray(
						[picture])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('sp-floatleft')
						]),
					_List_fromArray(
						[
							$elm$html$Html$text(profile.moniker)
						]))
				]));
		var note = function () {
			var _v4 = A2($elm$core$Dict$get, mnum, state.notes);
			if (_v4.$ === 'Just') {
				var notestr = _v4.a;
				return notestr;
			} else {
				return '-';
			}
		}();
		var member_bnums = A2(
			$elm$core$List$map,
			function (_v3) {
				var n = _v3.a;
				return n;
			},
			A2(
				$elm$core$List$filter,
				function (_v2) {
					var b = _v2.b;
					return A2($elm$core$List$member, mnum, b.data.shared_with);
				},
				$elm$core$Dict$toList(bstate.bundles)));
		var member_eligible = (mnum === 1) ? true : A2(
			$elm$core$List$all,
			function (n) {
				return A2($elm$core$List$member, n, member_bnums);
			},
			topic_bnums);
		var disabled = function () {
			if (mcreator.$ === 'Just') {
				var creator = mcreator.a;
				return _Utils_eq(creator, mnum);
			} else {
				return true;
			}
		}();
		var checkbox = member_eligible ? A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('checkbox')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$input,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('sp-checkbox'),
							$elm$html$Html$Attributes$type_('checkbox'),
							$elm$html$Html$Attributes$disabled(disabled),
							$elm$html$Html$Attributes$checked(shared),
							$elm$html$Html$Events$onCheck(
							$author$project$TopicMembers$Model$UpdateShared(mnum))
						]),
					_List_Nil)
				])) : A2($elm$html$Html$div, _List_Nil, _List_Nil);
		var accepted_tag = (!_Utils_eq(
			profile.accepted_on,
			$elm$time$Time$millisToPosix(0))) ? _List_fromArray(
			[
				A2($author$project$TopicMembers$View$acceptedTag, flags, '')
			]) : _List_Nil;
		return A2(
			$elm$html$Html$tr,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('is-hoverable')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$td,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('px-1 is-checkbox-cell')
						]),
					_List_fromArray(
						[checkbox])),
					A2(
					$elm$html$Html$td,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('px-1'),
							A2($elm$html$Html$Attributes$attribute, 'data-label', flags.labels.who.label)
						]),
					_List_fromArray(
						[picmon])),
					A2(
					$elm$html$Html$td,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('px-1'),
							A2($elm$html$Html$Attributes$attribute, 'data-label', flags.labels.accepted.datalabel)
						]),
					accepted_tag),
					A2(
					$elm$html$Html$td,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('px-1'),
							A2($elm$html$Html$Attributes$attribute, 'data-label', flags.labels.title.label)
						]),
					_List_fromArray(
						[
							$elm$html$Html$text(profile.title)
						])),
					A2(
					$elm$html$Html$td,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('px-1'),
							A2($elm$html$Html$Attributes$attribute, 'data-label', flags.labels.note.label)
						]),
					_List_fromArray(
						[
							$elm$html$Html$text(note)
						]))
				]));
	});
var $author$project$TopicMembers$View$viewTopicMembers = F4(
	function (flags, state, mcreator, bstate) {
		var members = $elm$core$Dict$toList(state.profiles);
		var viewmembers = A2(
			$elm$core$List$map,
			A4($author$project$TopicMembers$View$viewMember, flags, state, mcreator, bstate),
			members);
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('field mt-0 pt-0')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('mx-2')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('b-table')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('table-wrapper has-mobile-cards')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$table,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('table is-fullwidth is-hoverable')
												]),
											_List_fromArray(
												[
													A2(
													$elm$html$Html$thead,
													_List_Nil,
													_List_fromArray(
														[
															A2(
															$elm$html$Html$tr,
															_List_Nil,
															_List_fromArray(
																[
																	A2(
																	$elm$html$Html$th,
																	_List_fromArray(
																		[
																			A2($elm$html$Html$Attributes$style, 'width', flags.labels.checkbox.width)
																		]),
																	_List_Nil),
																	A2(
																	$elm$html$Html$th,
																	_List_fromArray(
																		[
																			A2($elm$html$Html$Attributes$style, 'width', flags.labels.who.width)
																		]),
																	_List_fromArray(
																		[
																			$elm$html$Html$text(flags.labels.who.label)
																		])),
																	A2(
																	$elm$html$Html$th,
																	_List_fromArray(
																		[
																			A2($elm$html$Html$Attributes$style, 'width', flags.labels.accepted.width)
																		]),
																	_List_Nil),
																	A2(
																	$elm$html$Html$th,
																	_List_fromArray(
																		[
																			A2($elm$html$Html$Attributes$style, 'width', flags.labels.title.width)
																		]),
																	_List_fromArray(
																		[
																			$elm$html$Html$text(flags.labels.title.label)
																		])),
																	A2(
																	$elm$html$Html$th,
																	_List_fromArray(
																		[
																			A2($elm$html$Html$Attributes$style, 'width', flags.labels.note.width)
																		]),
																	_List_fromArray(
																		[
																			$elm$html$Html$text(flags.labels.note.label)
																		]))
																]))
														])),
													A2($elm$html$Html$tbody, _List_Nil, viewmembers)
												]))
										]))
								]))
						]))
				]));
	});
var $author$project$TopicMembers$View$viewMembers = F5(
	function (flags, state, allowupdate, mcreator, bstate) {
		var desc = allowupdate ? flags.labels.description.label : flags.labels.description2.label;
		return (!state.expanded) ? A2($elm$html$Html$div, _List_Nil, _List_Nil) : A2(
			$elm$html$Html$div,
			_List_Nil,
			_List_fromArray(
				[
					A2(
					$elm$html$Html$p,
					_List_Nil,
					_List_fromArray(
						[
							$elm$html$Html$text(desc)
						])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('sp-form mt-3 mb-0')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$br,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('is-hidden-mobile')
								]),
							_List_Nil),
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field is-horizontal')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('field-body')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$div,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('field')
												]),
											_List_fromArray(
												[
													A2(
													$elm$html$Html$div,
													_List_fromArray(
														[
															$elm$html$Html$Attributes$class('control')
														]),
													_List_fromArray(
														[
															A4($author$project$TopicMembers$View$viewTopicMembers, flags, state, mcreator, bstate)
														]))
												]))
										]))
								])),
							A2(
							$elm$html$Html$br,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('is-hidden-mobile')
								]),
							_List_Nil)
						]))
				]));
	});
var $author$project$TopicMembers$Model$ToggleMembersExpanded = {$: 'ToggleMembersExpanded'};
var $author$project$TopicMembers$View$viewSectionTitle = F3(
	function (flags, state, allowupdate) {
		return _List_fromArray(
			[
				A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						A2($elm$html$Html$Attributes$style, 'transform', 'translate(-26px, 0px)'),
						A2($elm$html$Html$Attributes$style, 'display', 'flex')
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$div,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('mt-0'),
								A2($elm$html$Html$Attributes$style, 'width', '24px'),
								A2($elm$html$Html$Attributes$style, 'min-width', '24px'),
								A2($elm$html$Html$Attributes$style, 'height', '24px'),
								$elm$html$Html$Events$onClick($author$project$TopicMembers$Model$ToggleMembersExpanded)
							]),
						_List_fromArray(
							[
								$author$project$Shared$Expand$svgExpandCollapse(state.expanded)
							])),
						A2(
						$elm$html$Html$h3,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('m-0')
							]),
						_List_fromArray(
							[
								$elm$html$Html$text(flags.labels.participants.label)
							]))
					]))
			]);
	});
var $author$project$TopicMembers$View$view = F5(
	function (flags, state, allowupdate, mcreator, bstate) {
		var title = A3($author$project$TopicMembers$View$viewSectionTitle, flags, state, allowupdate);
		var members = _List_fromArray(
			[
				A5($author$project$TopicMembers$View$viewMembers, flags, state, allowupdate, mcreator, bstate)
			]);
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					A2($elm$html$Html$Attributes$style, 'class', 'mt-2')
				]),
			_Utils_ap(title, members));
	});
var $author$project$TopicReview$Model$PressCloseFrame = {$: 'PressCloseFrame'};
var $author$project$TopicReview$Model$PressOpenNewTab = {$: 'PressOpenNewTab'};
var $author$project$TopicReview$Model$PressPreviewFrame = {$: 'PressPreviewFrame'};
var $author$project$TopicReview$Model$PressProceed = {$: 'PressProceed'};
var $author$project$TopicReview$View$viewButtons = F5(
	function (flags, state, allowupdate, details, bundles) {
		var proceed_button = A2(
			$elm$html$Html$button,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('button has-background-primary-dark has-text-white is-link ml-3 mt-1'),
					A2($elm$html$Html$Attributes$style, 'width', flags.labels.preview.width),
					$elm$html$Html$Events$onClick($author$project$TopicReview$Model$PressProceed)
				]),
			_List_fromArray(
				[
					$elm$html$Html$text(flags.labels.preview.proceed)
				]));
		var enabled = A2($author$project$TopicReview$View$okToPreview, state, bundles);
		var open_new_tab = A2(
			$elm$html$Html$button,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('button has-background-primary-dark has-text-white is-link ml-3 mt-1'),
					$elm$html$Html$Attributes$disabled(!enabled),
					$elm$html$Html$Events$onClick($author$project$TopicReview$Model$PressOpenNewTab)
				]),
			_List_fromArray(
				[
					$elm$html$Html$text(flags.labels.open.label)
				]));
		var open_review_in_new_window = A2(
			$elm$html$Html$button,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('button has-background-primary-dark has-text-white is-link ml-3 mt-1'),
					$elm$html$Html$Attributes$disabled(!enabled),
					$elm$html$Html$Events$onClick($author$project$TopicReview$Model$PressOpenNewTab)
				]),
			_List_fromArray(
				[
					$elm$html$Html$text(flags.labels.openreview.label)
				]));
		var preview_button = A2(
			$elm$html$Html$button,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('button has-background-primary-dark has-text-white is-link mt-1'),
					A2($elm$html$Html$Attributes$style, 'width', flags.labels.preview.width),
					$elm$html$Html$Attributes$disabled(!enabled),
					$elm$html$Html$Events$onClick($author$project$TopicReview$Model$PressPreviewFrame)
				]),
			_List_fromArray(
				[
					$elm$html$Html$text(flags.labels.preview.label)
				]));
		var close_button = A2(
			$elm$html$Html$button,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('button has-background-primary-dark has-text-white is-link mt-1'),
					A2($elm$html$Html$Attributes$style, 'width', flags.labels.close.width),
					$elm$html$Html$Events$onClick($author$project$TopicReview$Model$PressCloseFrame)
				]),
			_List_fromArray(
				[
					$elm$html$Html$text(flags.labels.close.label)
				]));
		var bundles_err = $author$project$TopicBundles$Model$bundlesErr(bundles.problems);
		var error_text = function () {
			if (bundles_err.$ === 'Just') {
				var reason = bundles_err.a;
				return A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('help is-danger')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$p,
							_List_Nil,
							$author$project$Shared$Text$htmlTextLines(reason))
						]));
			} else {
				return A2($elm$html$Html$div, _List_Nil, _List_Nil);
			}
		}();
		var buttons = (!allowupdate) ? _List_fromArray(
			[open_review_in_new_window]) : _List_fromArray(
			[
				(!_Utils_eq(state.frametarget, $elm$core$Maybe$Nothing)) ? close_button : preview_button,
				state.paused ? proceed_button : open_new_tab,
				state.paused ? open_new_tab : A2($elm$html$Html$div, _List_Nil, _List_Nil),
				error_text
			]);
		return _List_fromArray(
			[
				A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('field is-horizontal')
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$div,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('field-label')
							]),
						_List_fromArray(
							[
								A2($elm$html$Html$div, _List_Nil, _List_Nil)
							])),
						A2(
						$elm$html$Html$div,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('field-body')
							]),
						_List_fromArray(
							[
								A2(
								$elm$html$Html$div,
								_List_fromArray(
									[
										$elm$html$Html$Attributes$class('field')
									]),
								buttons)
							]))
					]))
			]);
	});
var $author$project$TopicReview$Model$ToggleOptionsExpanded = {$: 'ToggleOptionsExpanded'};
var $author$project$TopicReview$Model$UpdatePause = function (a) {
	return {$: 'UpdatePause', a: a};
};
var $author$project$TopicReview$View$viewPause = F3(
	function (flags, state, details) {
		var help = $author$project$Shared$Text$htmlTextLines(flags.labels.pause.description);
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('field is-horizontal')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-label is-normal')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help is-hidden-mobile')
												]),
											$author$project$Shared$Text$dropExtra(
												$author$project$Shared$Text$htmlBreaks(help)))
										])),
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('label ml-1')
												]),
											_List_fromArray(
												[
													$elm$html$Html$text(flags.labels.pause.label)
												]))
										]))
								]))
						])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-body')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help')
												]),
											help)
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('checkbox')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$input,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('sp-checkbox mt-2'),
													$elm$html$Html$Attributes$type_('checkbox'),
													$elm$html$Html$Attributes$disabled(
													!_Utils_eq(state.frametarget, $elm$core$Maybe$Nothing)),
													$elm$html$Html$Attributes$checked(state.pause),
													$elm$html$Html$Events$onCheck($author$project$TopicReview$Model$UpdatePause)
												]),
											_List_Nil)
										]))
								]))
						]))
				]));
	});
var $author$project$TopicReview$View$viewOptions = F3(
	function (flags, state, details) {
		return _Utils_ap(
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field is-horizontal mb-0 pb-0')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field-label is-normal')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('field')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$div,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('is-flex')
												]),
											_List_fromArray(
												[
													A2(
													$elm$html$Html$div,
													_List_fromArray(
														[
															$elm$html$Html$Attributes$class('pl-3 ml-1'),
															A2($elm$html$Html$Attributes$style, 'width', '24px'),
															A2($elm$html$Html$Attributes$style, 'min-width', '24px'),
															A2($elm$html$Html$Attributes$style, 'height', '24px'),
															$elm$html$Html$Events$onClick($author$project$TopicReview$Model$ToggleOptionsExpanded)
														]),
													_List_fromArray(
														[
															$author$project$Shared$Expand$svgExpandCollapse(state.expanded)
														])),
													A2(
													$elm$html$Html$label,
													_List_fromArray(
														[
															$elm$html$Html$Attributes$class('label ml-1')
														]),
													_List_fromArray(
														[
															$elm$html$Html$text(flags.labels.options.label)
														]))
												]))
										]))
								]))
						]))
				]),
			state.expanded ? _List_fromArray(
				[
					A3($author$project$TopicReview$View$viewPause, flags, state, details)
				]) : _List_Nil);
	});
var $author$project$TopicReview$Model$UpdateTopicPath = function (a) {
	return {$: 'UpdateTopicPath', a: a};
};
var $author$project$TopicReview$ViewError$viewPathError = F2(
	function (flags, state) {
		var _v0 = state.problems.pathErr;
		if (_v0.$ === 'Just') {
			var reason = _v0.a;
			return A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('help is-danger')
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$p,
						_List_Nil,
						$author$project$Shared$Text$htmlTextLines(reason))
					]));
		} else {
			return A2($elm$html$Html$div, _List_Nil, _List_Nil);
		}
	});
var $author$project$TopicReview$View$viewPath = F3(
	function (flags, state, details) {
		var reset = function () {
			var _v0 = details.initial;
			if (_v0.$ === 'Just') {
				var initial = _v0.a;
				return (!_Utils_eq(initial.details.path, details.current.details.path)) ? _List_fromArray(
					[
						A2(
						$elm$html$Html$button,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('sp-icon is-right'),
								$elm$html$Html$Events$onClick(
								$author$project$TopicReview$Model$UpdateTopicPath(initial.details.path))
							]),
						_List_fromArray(
							[
								$elm$html$Html$text($author$project$Shared$Text$greenX)
							]))
					]) : _List_Nil;
			} else {
				return _List_Nil;
			}
		}();
		var help = $author$project$Shared$Text$htmlTextLines(flags.labels.path.description);
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('field is-horizontal')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-label is-normal')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help is-hidden-mobile')
												]),
											$author$project$Shared$Text$dropExtra(
												$author$project$Shared$Text$htmlBreaks(help)))
										])),
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class(
													A3($author$project$Shared$Text$has_danger, 'label ml-1', state.problems.pathErr, false))
												]),
											_List_fromArray(
												[
													$elm$html$Html$text(flags.labels.path.label)
												]))
										]))
								]))
						])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-body')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help')
												]),
											help)
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('field')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$div,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('control has-icons-right')
												]),
											_Utils_ap(
												_List_fromArray(
													[
														A2(
														$elm$html$Html$input,
														_List_fromArray(
															[
																$elm$html$Html$Attributes$class('input'),
																$elm$html$Html$Attributes$type_('text'),
																$elm$html$Html$Attributes$value(details.current.details.path),
																$elm$html$Html$Attributes$placeholder(flags.labels.path.placeholder),
																$elm$html$Html$Events$onInput($author$project$TopicReview$Model$UpdateTopicPath)
															]),
														_List_Nil)
													]),
												reset))
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('field')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$div,
											_List_Nil,
											_List_fromArray(
												[
													A2(
													$elm$html$Html$div,
													_List_Nil,
													_List_fromArray(
														[
															A2($author$project$TopicReview$ViewError$viewPathError, flags, state)
														]))
												]))
										]))
								])),
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field-label is-normal'),
									A2($elm$html$Html$Attributes$style, 'max-width', '5px')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$label,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('label')
										]),
									_List_Nil)
								]))
						]))
				]));
	});
var $author$project$TopicReview$Model$PreviewFrameLoaded = function (a) {
	return {$: 'PreviewFrameLoaded', a: a};
};
var $elm$html$Html$figure = _VirtualDom_node('figure');
var $elm$html$Html$Attributes$height = function (n) {
	return A2(
		_VirtualDom_attribute,
		'height',
		$elm$core$String$fromInt(n));
};
var $elm$html$Html$Attributes$id = $elm$html$Html$Attributes$stringProperty('id');
var $elm$html$Html$iframe = _VirtualDom_node('iframe');
var $author$project$TopicReview$Model$reviewFrameTarget = F3(
	function (flags, details, targetid) {
		return {origin: flags.config.extra.originReview, pathname: flags.transitions.frame, targetid: targetid, topicpath: details.current.details.path};
	});
var $author$project$TopicReview$Model$reviewUrl = function (target) {
	return A2(
		$elm$core$String$join,
		'',
		_List_fromArray(
			[target.origin, target.pathname, '?id=', target.targetid]));
};
var $elm$html$Html$Attributes$src = function (url) {
	return A2(
		$elm$html$Html$Attributes$stringProperty,
		'src',
		_VirtualDom_noJavaScriptOrHtmlUri(url));
};
var $elm$html$Html$Attributes$width = function (n) {
	return A2(
		_VirtualDom_attribute,
		'width',
		$elm$core$String$fromInt(n));
};
var $author$project$TopicReview$View$viewReview = F3(
	function (flags, state, details) {
		var _v0 = state.frametarget;
		if (_v0.$ === 'Just') {
			var frametarget = _v0.a;
			var rt = A3($author$project$TopicReview$Model$reviewFrameTarget, flags, details, frametarget);
			var src = $author$project$TopicReview$Model$reviewUrl(rt);
			return A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('field is-horizontal')
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$div,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('field-body')
							]),
						_List_fromArray(
							[
								A2(
								$elm$html$Html$div,
								_List_fromArray(
									[
										$elm$html$Html$Attributes$class('field')
									]),
								_List_fromArray(
									[
										A2(
										$elm$html$Html$div,
										_List_fromArray(
											[
												$elm$html$Html$Attributes$class('control')
											]),
										_List_fromArray(
											[
												A2(
												$elm$html$Html$figure,
												_List_fromArray(
													[
														$elm$html$Html$Attributes$class('image is-16by9'),
														A2($elm$html$Html$Attributes$style, 'border', 'solid')
													]),
												_List_fromArray(
													[
														A2(
														$elm$html$Html$iframe,
														_List_fromArray(
															[
																$elm$html$Html$Attributes$class('has-ratio'),
																$elm$html$Html$Attributes$id(frametarget),
																$elm$html$Html$Attributes$src(src),
																$elm$html$Html$Attributes$width(640),
																$elm$html$Html$Attributes$height(36),
																A2($elm$html$Html$Attributes$attribute, 'allowfullscreen', '1'),
																A2(
																$elm$html$Html$Events$on,
																'load',
																$elm$json$Json$Decode$succeed(
																	$author$project$TopicReview$Model$PreviewFrameLoaded(rt)))
															]),
														_List_Nil)
													]))
											]))
									]))
							]))
					]));
		} else {
			return A2($elm$html$Html$div, _List_Nil, _List_Nil);
		}
	});
var $author$project$TopicReview$View$view = F5(
	function (flags, state, allowupdate, details, bundles) {
		var topicpath = _List_fromArray(
			[
				A3($author$project$TopicReview$View$viewPath, flags, state, details)
			]);
		var review = _List_fromArray(
			[
				A3($author$project$TopicReview$View$viewReview, flags, state, details)
			]);
		var options = A3($author$project$TopicReview$View$viewOptions, flags, state, details);
		var divcls = _List_fromArray(
			[
				$elm$html$Html$Attributes$class('sp-form py-3')
			]);
		var buttons = A5($author$project$TopicReview$View$viewButtons, flags, state, allowupdate, details, bundles);
		return (!allowupdate) ? A2($elm$html$Html$div, divcls, buttons) : A2(
			$elm$html$Html$div,
			divcls,
			_Utils_ap(
				topicpath,
				_Utils_ap(
					options,
					_Utils_ap(buttons, review))));
	});
var $author$project$Topic$remoteDataFlags = function (flags) {
	return {remote: flags.extra.remoteData};
};
var $author$project$Shared$Remote$viewFailure = function (err) {
	return A2(
		$elm$html$Html$p,
		_List_fromArray(
			[
				$elm$html$Html$Attributes$class('notification is-info is-danger')
			]),
		_List_fromArray(
			[
				$elm$html$Html$text(err)
			]));
};
var $author$project$Shared$Remote$viewLoading = function (flags) {
	var loading = F2(
		function (on, cls) {
			return A2(
				$elm$html$Html$p,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class(on + (' notification ' + cls))
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$button,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('button is-large is-loading ' + cls)
							]),
						_List_fromArray(
							[
								$elm$html$Html$text(flags.remote.loading)
							]))
					]));
		});
	return A2(
		$elm$html$Html$div,
		_List_Nil,
		_List_fromArray(
			[
				A2(loading, 'sp-hidden-dark', 'is-white'),
				A2(loading, 'sp-hidden-light', 'is-black')
			]));
};
var $author$project$Topic$viewNotAvailable = F2(
	function (flags, state) {
		var _v0 = state.auth;
		if (_v0.$ === 'Failure') {
			var msg = _v0.a;
			return $author$project$Shared$Remote$viewFailure(msg);
		} else {
			return $author$project$Shared$Remote$viewLoading(
				$author$project$Topic$remoteDataFlags(flags));
		}
	});
var $author$project$Topic$getProfile = F2(
	function (state, mm) {
		if (mm.$ === 'Just') {
			var mnum = mm.a;
			return A2($elm$core$Dict$get, mnum, state.members.profiles);
		} else {
			return $elm$core$Maybe$Nothing;
		}
	});
var $author$project$TopicView$View$view = F2(
	function (data, profile) {
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('card')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('card-content')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('media')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('media-left')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$div,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('image is-48x48')
												]),
											_List_fromArray(
												[
													function () {
													var _v0 = profile.thumbnail;
													if (_v0.$ === 'Nothing') {
														return A2($author$project$Shared$Icon$squareIcon, 48, profile.initials);
													} else {
														var url = _v0.a;
														return A2(
															$elm$html$Html$div,
															_List_fromArray(
																[
																	A2($elm$html$Html$Attributes$style, 'width', '48px'),
																	A2($elm$html$Html$Attributes$style, 'height', '48px'),
																	A2($elm$html$Html$Attributes$style, 'background-image', 'url(\'' + (url + '\')')),
																	A2($elm$html$Html$Attributes$style, 'background-position', 'center'),
																	A2($elm$html$Html$Attributes$style, 'background-repeat', 'no-repeat'),
																	A2($elm$html$Html$Attributes$style, 'background-size', 'contain')
																]),
															_List_Nil);
													}
												}()
												]))
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('media-content')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$p,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('title is-4')
												]),
											_List_fromArray(
												[
													$elm$html$Html$text(data.details.title)
												]))
										]))
								])),
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('content mr-4')
								]),
							_Utils_ap(
								$author$project$Shared$Text$htmlTextLines(data.details.description),
								_List_fromArray(
									[
										A2($elm$html$Html$br, _List_Nil, _List_Nil)
									])))
						]))
				]));
	});
var $author$project$Topic$viewTopic = F3(
	function (flags, state, mm) {
		var _v0 = A2($author$project$Topic$getProfile, state, mm);
		if (_v0.$ === 'Just') {
			var profile = _v0.a;
			return A2($author$project$TopicView$View$view, state.details.current, profile);
		} else {
			return A2($author$project$Topic$viewNotAvailable, flags, state);
		}
	});
var $author$project$Topic$view = function (model) {
	var _v0 = _Utils_Tuple2($author$project$Topic$currentView, model);
	if (_v0.b.$ === 'Failed') {
		if (!_v0.a) {
			var err = _v0.b.a;
			return A2(
				$elm$html$Html$p,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('notification is-danger')
					]),
				_List_fromArray(
					[
						$elm$html$Html$text(err)
					]));
		} else {
			var err = _v0.b.a;
			return A2($elm$html$Html$div, _List_Nil, _List_Nil);
		}
	} else {
		var _v1 = _v0.b;
		var flags = _v1.a;
		var state = _v1.b;
		var mcreator = A2($author$project$Topic$Model$creatorMnum, flags, state);
		var allowupdate = A2($author$project$Topic$Model$allowUpdate, flags, state);
		var accepted = A2($author$project$Topic$Model$isAccepted, state.members.profiles, state.auth);
		var _v2 = $author$project$Topic$currentView;
		switch (_v2) {
			case 0:
				var _v3 = A2($author$project$Topic$getMnum, flags, state);
				if (_v3.$ === 'Just') {
					var mnum = _v3.a;
					return A3(
						$author$project$Topic$viewTopic,
						flags,
						state,
						$elm$core$Maybe$Just(mnum));
				} else {
					return A2($author$project$Topic$viewNotAvailable, flags, state);
				}
			case 1:
				return allowupdate ? A2(
					$elm$html$Html$map,
					$author$project$Topic$Model$DetailsMsg,
					A2(
						$author$project$TopicDetails$View$view,
						$author$project$Topic$detailsFlags(flags),
						state.details)) : A2($elm$html$Html$div, _List_Nil, _List_Nil);
			case 2:
				return A2(
					$elm$html$Html$map,
					$author$project$Topic$Model$BundlesMsg,
					A5(
						$author$project$TopicBundles$View$view,
						$author$project$Topic$bundlesFlags(flags),
						flags.extra.plurals,
						state.bundles,
						allowupdate,
						accepted));
			case 3:
				return A2(
					$elm$html$Html$map,
					$author$project$Topic$Model$ReviewMsg,
					A5(
						$author$project$TopicReview$View$view,
						$author$project$Topic$reviewFlags(flags),
						state.review,
						allowupdate,
						state.details,
						state.bundles));
			case 4:
				var commentflags = $author$project$Topic$commentsFlags(flags);
				var defaultmoniker = function (mnum) {
					return _Utils_ap(
						commentflags.labels.member.label,
						$elm$core$String$fromInt(mnum));
				};
				var monikerfn = function (mnum) {
					var _v4 = A2($elm$core$Dict$get, mnum, state.members.profiles);
					if (_v4.$ === 'Just') {
						var profile = _v4.a;
						return profile.moniker;
					} else {
						return defaultmoniker(mnum);
					}
				};
				var adding = flags.extra.mode === 'add';
				return A2(
					$elm$html$Html$map,
					$author$project$Topic$Model$CommentsMsg,
					A7($author$project$TopicComments$View$view, commentflags, flags.extra.plurals, monikerfn, adding, state.comments, accepted, state.auth));
			case 5:
				return A2(
					$elm$html$Html$map,
					$author$project$Topic$Model$MembersMsg,
					A5(
						$author$project$TopicMembers$View$view,
						$author$project$Topic$membersFlags(flags),
						state.members,
						allowupdate,
						mcreator,
						state.bundles));
			case 6:
				return A2($author$project$Topic$View$view, flags, state);
			case 7:
				return A2(
					$elm$html$Html$map,
					$author$project$Topic$Model$ProgressMsg,
					A2(
						$author$project$Progress$View$view,
						$author$project$Topic$progressFlags(flags),
						state.progress));
			default:
				return A2($elm$html$Html$div, _List_Nil, _List_Nil);
		}
	}
};
var $author$project$Topic$main = $elm$browser$Browser$element(
	{init: $author$project$Topic$init, subscriptions: $author$project$Topic$subscriptions, update: $author$project$Topic$update, view: $author$project$Topic$view});
var $author$project$Test$Failed = function (a) {
	return {$: 'Failed', a: a};
};
var $author$project$Test$Loaded = F2(
	function (a, b) {
		return {$: 'Loaded', a: a, b: b};
	});
var $author$project$Test$Flags$Flags = F3(
	function (config, extra, workflows) {
		return {config: config, extra: extra, workflows: workflows};
	});
var $author$project$Test$Flags$Extra = F4(
	function (mode, module_, testView, viewNodes) {
		return {mode: mode, module_: module_, testView: testView, viewNodes: viewNodes};
	});
var $author$project$Test$Flags$ExtraTestView = function (labels) {
	return {labels: labels};
};
var $author$project$Test$Flags$ExtraTestViewLabels = function (send) {
	return {send: send};
};
var $author$project$Test$Flags$ExtraTestViewLabelsSend = function (label) {
	return {label: label};
};
var $author$project$Test$Flags$extraTestViewLabelsSendDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Test$Flags$ExtraTestViewLabelsSend,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Test$Flags$extraTestViewLabelsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Test$Flags$ExtraTestViewLabels,
	A2($elm$json$Json$Decode$field, 'send', $author$project$Test$Flags$extraTestViewLabelsSendDecoder));
var $author$project$Test$Flags$extraTestViewDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Test$Flags$ExtraTestView,
	A2($elm$json$Json$Decode$field, 'labels', $author$project$Test$Flags$extraTestViewLabelsDecoder));
var $author$project$Test$Flags$extraDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$Test$Flags$Extra,
	A2($elm$json$Json$Decode$field, 'mode', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'module', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'test_view', $author$project$Test$Flags$extraTestViewDecoder),
	A2(
		$elm$json$Json$Decode$field,
		'view_nodes',
		$elm$json$Json$Decode$list($elm$json$Json$Decode$string)));
var $author$project$Test$Flags$FlagsConfig = F3(
	function (baseUrl, defaultLanguage, extra) {
		return {baseUrl: baseUrl, defaultLanguage: defaultLanguage, extra: extra};
	});
var $author$project$Test$Flags$FlagsConfigExtra = F4(
	function (dev, originCollab, originReview, title) {
		return {dev: dev, originCollab: originCollab, originReview: originReview, title: title};
	});
var $author$project$Test$Flags$flagsConfigExtraDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$Test$Flags$FlagsConfigExtra,
	A2($elm$json$Json$Decode$field, 'dev', $elm$json$Json$Decode$bool),
	A2($elm$json$Json$Decode$field, 'origin_collab', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'origin_review', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'title', $elm$json$Json$Decode$string));
var $author$project$Test$Flags$flagsConfigDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Test$Flags$FlagsConfig,
	A2($elm$json$Json$Decode$field, 'base_url', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'default_language', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'extra', $author$project$Test$Flags$flagsConfigExtraDecoder));
var $author$project$Test$Flags$FlagsWorkflowsObject = F3(
	function (name, label, progress) {
		return {label: label, name: name, progress: progress};
	});
var $author$project$Test$Flags$FlagsWorkflowsObjectProgressObject = F2(
	function (display, messages) {
		return {display: display, messages: messages};
	});
var $author$project$Test$Flags$FlagsWorkflowsObjectProgressObjectDisplay = F7(
	function (error, error2, init, ok, ok2, skip, skip2) {
		return {error: error, error2: error2, init: init, ok: ok, ok2: ok2, skip: skip, skip2: skip2};
	});
var $author$project$Test$Flags$flagsWorkflowsObjectProgressObjectDisplayDecoder = A8(
	$elm$json$Json$Decode$map7,
	$author$project$Test$Flags$FlagsWorkflowsObjectProgressObjectDisplay,
	A2($elm$json$Json$Decode$field, 'error', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'error2', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'init', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'ok', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'ok2', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'skip', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'skip2', $elm$json$Json$Decode$string));
var $author$project$Test$Flags$FlagsWorkflowsObjectProgressObjectMessages = F2(
	function (error, ok) {
		return {error: error, ok: ok};
	});
var $author$project$Test$Flags$flagsWorkflowsObjectProgressObjectMessagesDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Test$Flags$FlagsWorkflowsObjectProgressObjectMessages,
	A2($elm$json$Json$Decode$field, 'error', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'ok', $elm$json$Json$Decode$string));
var $author$project$Test$Flags$flagsWorkflowsObjectProgressObjectDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Test$Flags$FlagsWorkflowsObjectProgressObject,
	A2($elm$json$Json$Decode$field, 'display', $author$project$Test$Flags$flagsWorkflowsObjectProgressObjectDisplayDecoder),
	A2($elm$json$Json$Decode$field, 'messages', $author$project$Test$Flags$flagsWorkflowsObjectProgressObjectMessagesDecoder));
var $author$project$Test$Flags$flagsWorkflowsObjectDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Test$Flags$FlagsWorkflowsObject,
	A2($elm$json$Json$Decode$field, 'name', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2(
		$elm$json$Json$Decode$field,
		'progress',
		$elm$json$Json$Decode$list($author$project$Test$Flags$flagsWorkflowsObjectProgressObjectDecoder)));
var $author$project$Test$Flags$flagsDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Test$Flags$Flags,
	A2($elm$json$Json$Decode$field, 'config', $author$project$Test$Flags$flagsConfigDecoder),
	A2($elm$json$Json$Decode$field, 'extra', $author$project$Test$Flags$extraDecoder),
	A2(
		$elm$json$Json$Decode$field,
		'workflows',
		$elm$json$Json$Decode$list($author$project$Test$Flags$flagsWorkflowsObjectDecoder)));
var $author$project$Test$Flags$jsonToResultFlags = function (json) {
	return A2(
		$elm$core$Result$mapError,
		$elm$json$Json$Decode$errorToString,
		A2($elm$json$Json$Decode$decodeValue, $author$project$Test$Flags$flagsDecoder, json));
};
var $author$project$Test$init = function (value) {
	var state = {input: ''};
	var _v0 = $author$project$Test$Flags$jsonToResultFlags(value);
	if (_v0.$ === 'Err') {
		var err = _v0.a;
		return _Utils_Tuple2(
			$author$project$Test$Failed(err),
			$elm$core$Platform$Cmd$none);
	} else {
		var flags = _v0.a;
		return _Utils_Tuple2(
			A2($author$project$Test$Loaded, flags, state),
			$elm$core$Platform$Cmd$none);
	}
};
var $author$project$Test$Incoming = function (a) {
	return {$: 'Incoming', a: a};
};
var $author$project$Test$subscriptions = function (model) {
	return $author$project$Shared$Ports$toElm($author$project$Test$Incoming);
};
var $author$project$Shared$Cmd$cmdSend = F2(
	function (s, model) {
		return _Utils_Tuple2(
			model,
			$author$project$Shared$Ports$toMain(
				$elm$json$Json$Encode$string(s)));
	});
var $author$project$Test$Response = function (a) {
	return {$: 'Response', a: a};
};
var $author$project$Test$valueToIncomingMsg = function (value) {
	var decoder = A2($elm$json$Json$Decode$map, $author$project$Test$Response, $elm$json$Json$Decode$string);
	return A2(
		$elm$core$Result$mapError,
		$elm$json$Json$Decode$errorToString,
		A2($elm$json$Json$Decode$decodeValue, decoder, value));
};
var $author$project$Test$update = F2(
	function (msg, model) {
		var send = function (s) {
			return A2($author$project$Shared$Cmd$cmdSend, s, model);
		};
		var log = function (s) {
			return A2($author$project$Shared$Cmd$cmdLog, s, model);
		};
		var _v0 = _Utils_Tuple2(model, msg);
		if (_v0.a.$ === 'Failed') {
			return _Utils_Tuple2(model, $elm$core$Platform$Cmd$none);
		} else {
			switch (_v0.b.$) {
				case 'PressSend':
					var _v1 = _v0.a;
					var flags = _v1.a;
					var state = _v1.b;
					var _v2 = _v0.b;
					return send(state.input);
				case 'UpdateInput':
					var _v3 = _v0.a;
					var flags = _v3.a;
					var state = _v3.b;
					var value = _v0.b.a;
					return _Utils_Tuple2(
						A2(
							$author$project$Test$Loaded,
							flags,
							_Utils_update(
								state,
								{input: value})),
						$elm$core$Platform$Cmd$none);
				default:
					var _v4 = _v0.a;
					var flags = _v4.a;
					var state = _v4.b;
					var value = _v0.b.a;
					var _v5 = $author$project$Test$valueToIncomingMsg(value);
					if (_v5.$ === 'Err') {
						var err = _v5.a;
						return log('Err ' + err);
					} else {
						var s = _v5.a.a;
						return log(s);
					}
			}
		}
	});
var $author$project$Test$currentView = 0;
var $author$project$Test$PressSend = {$: 'PressSend'};
var $author$project$Test$UpdateInput = function (a) {
	return {$: 'UpdateInput', a: a};
};
var $elm$html$Html$Events$keyCode = A2($elm$json$Json$Decode$field, 'keyCode', $elm$json$Json$Decode$int);
var $author$project$Shared$OnEnter$onEnter = function (msg) {
	var isEnter = function (code) {
		return (code === 13) ? $elm$json$Json$Decode$succeed(msg) : $elm$json$Json$Decode$fail('not ENTER');
	};
	return A2(
		$elm$html$Html$Events$on,
		'keydown',
		A2($elm$json$Json$Decode$andThen, isEnter, $elm$html$Html$Events$keyCode));
};
var $author$project$Test$testView = F2(
	function (flags, state) {
		var tv = flags.extra.testView;
		return A2(
			$elm$html$Html$div,
			_List_Nil,
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('control')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$input,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('input'),
									$elm$html$Html$Attributes$type_('text'),
									$elm$html$Html$Attributes$value(state.input),
									$elm$html$Html$Events$onInput($author$project$Test$UpdateInput),
									$author$project$Shared$OnEnter$onEnter($author$project$Test$PressSend)
								]),
							_List_Nil)
						])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('control')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$button,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('button has-background-primary-dark has-text-white is-link'),
									$elm$html$Html$Events$onClick($author$project$Test$PressSend)
								]),
							_List_fromArray(
								[
									$elm$html$Html$text(tv.labels.send.label)
								]))
						]))
				]));
	});
var $author$project$Test$view = function (model) {
	var _v0 = _Utils_Tuple2($author$project$Test$currentView, model);
	if (!_v0.a) {
		if (_v0.b.$ === 'Failed') {
			var err = _v0.b.a;
			return A2(
				$elm$html$Html$p,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('notification is-danger')
					]),
				_List_fromArray(
					[
						$elm$html$Html$text(err)
					]));
		} else {
			var _v1 = _v0.b;
			var flags = _v1.a;
			var state = _v1.b;
			return A2($author$project$Test$testView, flags, state);
		}
	} else {
		return A2($elm$html$Html$div, _List_Nil, _List_Nil);
	}
};
var $author$project$Test$main = $elm$browser$Browser$element(
	{init: $author$project$Test$init, subscriptions: $author$project$Test$subscriptions, update: $author$project$Test$update, view: $author$project$Test$view});
var $author$project$SignIn$Model$Failed = function (a) {
	return {$: 'Failed', a: a};
};
var $author$project$SignIn$Model$Loaded = F2(
	function (a, b) {
		return {$: 'Loaded', a: a, b: b};
	});
var $author$project$SignIn$Model$Problems = F2(
	function (usernameErr, passwordErr) {
		return {passwordErr: passwordErr, usernameErr: usernameErr};
	});
var $author$project$SignIn$Flags$Flags = F3(
	function (config, extra, workflows) {
		return {config: config, extra: extra, workflows: workflows};
	});
var $author$project$SignIn$Flags$Extra = F6(
	function (mode, module_, progressView, signinView, viewNodes, workflowpaths) {
		return {mode: mode, module_: module_, progressView: progressView, signinView: signinView, viewNodes: viewNodes, workflowpaths: workflowpaths};
	});
var $author$project$SignIn$Flags$ExtraProgressView = function (labels) {
	return {labels: labels};
};
var $author$project$SignIn$Flags$ExtraProgressViewLabels = F4(
	function (decodeErrors, diagnosticLogs, status, workflow) {
		return {decodeErrors: decodeErrors, diagnosticLogs: diagnosticLogs, status: status, workflow: workflow};
	});
var $author$project$SignIn$Flags$ExtraProgressViewLabelsDecodeErrors = function (label) {
	return {label: label};
};
var $author$project$SignIn$Flags$extraProgressViewLabelsDecodeErrorsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$SignIn$Flags$ExtraProgressViewLabelsDecodeErrors,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$SignIn$Flags$ExtraProgressViewLabelsDiagnosticLogs = function (label) {
	return {label: label};
};
var $author$project$SignIn$Flags$extraProgressViewLabelsDiagnosticLogsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$SignIn$Flags$ExtraProgressViewLabelsDiagnosticLogs,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$SignIn$Flags$ExtraProgressViewLabelsStatus = F2(
	function (failure, success) {
		return {failure: failure, success: success};
	});
var $author$project$SignIn$Flags$extraProgressViewLabelsStatusDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$SignIn$Flags$ExtraProgressViewLabelsStatus,
	A2($elm$json$Json$Decode$field, 'failure', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'success', $elm$json$Json$Decode$string));
var $author$project$SignIn$Flags$ExtraProgressViewLabelsWorkflow = function (label) {
	return {label: label};
};
var $author$project$SignIn$Flags$extraProgressViewLabelsWorkflowDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$SignIn$Flags$ExtraProgressViewLabelsWorkflow,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$SignIn$Flags$extraProgressViewLabelsDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$SignIn$Flags$ExtraProgressViewLabels,
	A2($elm$json$Json$Decode$field, 'decode_errors', $author$project$SignIn$Flags$extraProgressViewLabelsDecodeErrorsDecoder),
	A2($elm$json$Json$Decode$field, 'diagnostic_logs', $author$project$SignIn$Flags$extraProgressViewLabelsDiagnosticLogsDecoder),
	A2($elm$json$Json$Decode$field, 'status', $author$project$SignIn$Flags$extraProgressViewLabelsStatusDecoder),
	A2($elm$json$Json$Decode$field, 'workflow', $author$project$SignIn$Flags$extraProgressViewLabelsWorkflowDecoder));
var $author$project$SignIn$Flags$extraProgressViewDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$SignIn$Flags$ExtraProgressView,
	A2($elm$json$Json$Decode$field, 'labels', $author$project$SignIn$Flags$extraProgressViewLabelsDecoder));
var $author$project$SignIn$Flags$ExtraSigninView = F4(
	function (errors, labels, requests, transitions) {
		return {errors: errors, labels: labels, requests: requests, transitions: transitions};
	});
var $author$project$SignIn$Flags$ExtraSigninViewErrors = F4(
	function (confirm, currentPassword, newPassword, username) {
		return {confirm: confirm, currentPassword: currentPassword, newPassword: newPassword, username: username};
	});
var $author$project$SignIn$Flags$ExtraSigninViewErrorsConfirm = F3(
	function (doNotMatch, required, syntax) {
		return {doNotMatch: doNotMatch, required: required, syntax: syntax};
	});
var $author$project$SignIn$Flags$extraSigninViewErrorsConfirmDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$SignIn$Flags$ExtraSigninViewErrorsConfirm,
	A2($elm$json$Json$Decode$field, 'do_not_match', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'required', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'syntax', $elm$json$Json$Decode$string));
var $author$project$SignIn$Flags$ExtraSigninViewErrorsCurrentPassword = F2(
	function (required, syntax) {
		return {required: required, syntax: syntax};
	});
var $author$project$SignIn$Flags$extraSigninViewErrorsCurrentPasswordDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$SignIn$Flags$ExtraSigninViewErrorsCurrentPassword,
	A2($elm$json$Json$Decode$field, 'required', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'syntax', $elm$json$Json$Decode$string));
var $author$project$SignIn$Flags$ExtraSigninViewErrorsNewPassword = F2(
	function (required, syntax) {
		return {required: required, syntax: syntax};
	});
var $author$project$SignIn$Flags$extraSigninViewErrorsNewPasswordDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$SignIn$Flags$ExtraSigninViewErrorsNewPassword,
	A2($elm$json$Json$Decode$field, 'required', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'syntax', $elm$json$Json$Decode$string));
var $author$project$SignIn$Flags$ExtraSigninViewErrorsUsername = F3(
	function (required, syntax, unique) {
		return {required: required, syntax: syntax, unique: unique};
	});
var $author$project$SignIn$Flags$extraSigninViewErrorsUsernameDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$SignIn$Flags$ExtraSigninViewErrorsUsername,
	A2($elm$json$Json$Decode$field, 'required', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'syntax', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'unique', $elm$json$Json$Decode$string));
var $author$project$SignIn$Flags$extraSigninViewErrorsDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$SignIn$Flags$ExtraSigninViewErrors,
	A2($elm$json$Json$Decode$field, 'confirm', $author$project$SignIn$Flags$extraSigninViewErrorsConfirmDecoder),
	A2($elm$json$Json$Decode$field, 'current_password', $author$project$SignIn$Flags$extraSigninViewErrorsCurrentPasswordDecoder),
	A2($elm$json$Json$Decode$field, 'new_password', $author$project$SignIn$Flags$extraSigninViewErrorsNewPasswordDecoder),
	A2($elm$json$Json$Decode$field, 'username', $author$project$SignIn$Flags$extraSigninViewErrorsUsernameDecoder));
var $author$project$SignIn$Flags$ExtraSigninViewLabels = F6(
	function (currentPassword, error, showPasswords, signin, transition, username) {
		return {currentPassword: currentPassword, error: error, showPasswords: showPasswords, signin: signin, transition: transition, username: username};
	});
var $author$project$SignIn$Flags$ExtraSigninViewLabelsCurrentPassword = F5(
	function (description, label, placeholder, required, syntax) {
		return {description: description, label: label, placeholder: placeholder, required: required, syntax: syntax};
	});
var $author$project$SignIn$Flags$extraSigninViewLabelsCurrentPasswordDecoder = A6(
	$elm$json$Json$Decode$map5,
	$author$project$SignIn$Flags$ExtraSigninViewLabelsCurrentPassword,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'placeholder', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'required', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'syntax', $elm$json$Json$Decode$string));
var $author$project$SignIn$Flags$ExtraSigninViewLabelsError = F2(
	function (mismatch, noProfile) {
		return {mismatch: mismatch, noProfile: noProfile};
	});
var $author$project$SignIn$Flags$extraSigninViewLabelsErrorDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$SignIn$Flags$ExtraSigninViewLabelsError,
	A2($elm$json$Json$Decode$field, 'mismatch', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'no_profile', $elm$json$Json$Decode$string));
var $author$project$SignIn$Flags$ExtraSigninViewLabelsShowPasswords = function (label) {
	return {label: label};
};
var $author$project$SignIn$Flags$extraSigninViewLabelsShowPasswordsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$SignIn$Flags$ExtraSigninViewLabelsShowPasswords,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$SignIn$Flags$ExtraSigninViewLabelsSignin = function (label) {
	return {label: label};
};
var $author$project$SignIn$Flags$extraSigninViewLabelsSigninDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$SignIn$Flags$ExtraSigninViewLabelsSignin,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$SignIn$Flags$ExtraSigninViewLabelsTransition = function (label) {
	return {label: label};
};
var $author$project$SignIn$Flags$extraSigninViewLabelsTransitionDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$SignIn$Flags$ExtraSigninViewLabelsTransition,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$SignIn$Flags$ExtraSigninViewLabelsUsername = F5(
	function (description, label, placeholder, required, syntax) {
		return {description: description, label: label, placeholder: placeholder, required: required, syntax: syntax};
	});
var $author$project$SignIn$Flags$extraSigninViewLabelsUsernameDecoder = A6(
	$elm$json$Json$Decode$map5,
	$author$project$SignIn$Flags$ExtraSigninViewLabelsUsername,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'placeholder', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'required', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'syntax', $elm$json$Json$Decode$string));
var $author$project$SignIn$Flags$extraSigninViewLabelsDecoder = A7(
	$elm$json$Json$Decode$map6,
	$author$project$SignIn$Flags$ExtraSigninViewLabels,
	A2($elm$json$Json$Decode$field, 'currentPassword', $author$project$SignIn$Flags$extraSigninViewLabelsCurrentPasswordDecoder),
	A2($elm$json$Json$Decode$field, 'error', $author$project$SignIn$Flags$extraSigninViewLabelsErrorDecoder),
	A2($elm$json$Json$Decode$field, 'show_passwords', $author$project$SignIn$Flags$extraSigninViewLabelsShowPasswordsDecoder),
	A2($elm$json$Json$Decode$field, 'signin', $author$project$SignIn$Flags$extraSigninViewLabelsSigninDecoder),
	A2($elm$json$Json$Decode$field, 'transition', $author$project$SignIn$Flags$extraSigninViewLabelsTransitionDecoder),
	A2($elm$json$Json$Decode$field, 'username', $author$project$SignIn$Flags$extraSigninViewLabelsUsernameDecoder));
var $author$project$SignIn$Flags$ExtraSigninViewRequests = function (submit) {
	return {submit: submit};
};
var $author$project$SignIn$Flags$extraSigninViewRequestsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$SignIn$Flags$ExtraSigninViewRequests,
	A2($elm$json$Json$Decode$field, 'submit', $elm$json$Json$Decode$string));
var $author$project$SignIn$Flags$ExtraSigninViewTransitions = F5(
	function (bundle, profile, signin, topic, topiclist) {
		return {bundle: bundle, profile: profile, signin: signin, topic: topic, topiclist: topiclist};
	});
var $author$project$SignIn$Flags$extraSigninViewTransitionsDecoder = A6(
	$elm$json$Json$Decode$map5,
	$author$project$SignIn$Flags$ExtraSigninViewTransitions,
	A2($elm$json$Json$Decode$field, 'bundle', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'profile', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'signin', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'topic', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'topiclist', $elm$json$Json$Decode$string));
var $author$project$SignIn$Flags$extraSigninViewDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$SignIn$Flags$ExtraSigninView,
	A2($elm$json$Json$Decode$field, 'errors', $author$project$SignIn$Flags$extraSigninViewErrorsDecoder),
	A2($elm$json$Json$Decode$field, 'labels', $author$project$SignIn$Flags$extraSigninViewLabelsDecoder),
	A2($elm$json$Json$Decode$field, 'requests', $author$project$SignIn$Flags$extraSigninViewRequestsDecoder),
	A2($elm$json$Json$Decode$field, 'transitions', $author$project$SignIn$Flags$extraSigninViewTransitionsDecoder));
var $author$project$SignIn$Flags$extraDecoder = A7(
	$elm$json$Json$Decode$map6,
	$author$project$SignIn$Flags$Extra,
	A2($elm$json$Json$Decode$field, 'mode', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'module', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'progress_view', $author$project$SignIn$Flags$extraProgressViewDecoder),
	A2($elm$json$Json$Decode$field, 'signin_view', $author$project$SignIn$Flags$extraSigninViewDecoder),
	A2(
		$elm$json$Json$Decode$field,
		'view_nodes',
		$elm$json$Json$Decode$list($elm$json$Json$Decode$string)),
	A2(
		$elm$json$Json$Decode$field,
		'workflowpaths',
		$elm$json$Json$Decode$list($elm$json$Json$Decode$string)));
var $author$project$SignIn$Flags$FlagsConfig = F3(
	function (baseUrl, defaultLanguage, extra) {
		return {baseUrl: baseUrl, defaultLanguage: defaultLanguage, extra: extra};
	});
var $author$project$SignIn$Flags$FlagsConfigExtra = F4(
	function (dev, originCollab, originReview, title) {
		return {dev: dev, originCollab: originCollab, originReview: originReview, title: title};
	});
var $author$project$SignIn$Flags$flagsConfigExtraDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$SignIn$Flags$FlagsConfigExtra,
	A2($elm$json$Json$Decode$field, 'dev', $elm$json$Json$Decode$bool),
	A2($elm$json$Json$Decode$field, 'origin_collab', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'origin_review', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'title', $elm$json$Json$Decode$string));
var $author$project$SignIn$Flags$flagsConfigDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$SignIn$Flags$FlagsConfig,
	A2($elm$json$Json$Decode$field, 'base_url', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'default_language', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'extra', $author$project$SignIn$Flags$flagsConfigExtraDecoder));
var $author$project$SignIn$Flags$FlagsWorkflowsObject = F3(
	function (name, label, progress) {
		return {label: label, name: name, progress: progress};
	});
var $author$project$SignIn$Flags$FlagsWorkflowsObjectProgressObject = F2(
	function (display, messages) {
		return {display: display, messages: messages};
	});
var $author$project$SignIn$Flags$FlagsWorkflowsObjectProgressObjectDisplay = F7(
	function (error, error2, init, ok, ok2, skip, skip2) {
		return {error: error, error2: error2, init: init, ok: ok, ok2: ok2, skip: skip, skip2: skip2};
	});
var $author$project$SignIn$Flags$flagsWorkflowsObjectProgressObjectDisplayDecoder = A8(
	$elm$json$Json$Decode$map7,
	$author$project$SignIn$Flags$FlagsWorkflowsObjectProgressObjectDisplay,
	A2($elm$json$Json$Decode$field, 'error', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'error2', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'init', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'ok', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'ok2', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'skip', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'skip2', $elm$json$Json$Decode$string));
var $author$project$SignIn$Flags$FlagsWorkflowsObjectProgressObjectMessages = F2(
	function (error, ok) {
		return {error: error, ok: ok};
	});
var $author$project$SignIn$Flags$flagsWorkflowsObjectProgressObjectMessagesDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$SignIn$Flags$FlagsWorkflowsObjectProgressObjectMessages,
	A2($elm$json$Json$Decode$field, 'error', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'ok', $elm$json$Json$Decode$string));
var $author$project$SignIn$Flags$flagsWorkflowsObjectProgressObjectDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$SignIn$Flags$FlagsWorkflowsObjectProgressObject,
	A2($elm$json$Json$Decode$field, 'display', $author$project$SignIn$Flags$flagsWorkflowsObjectProgressObjectDisplayDecoder),
	A2($elm$json$Json$Decode$field, 'messages', $author$project$SignIn$Flags$flagsWorkflowsObjectProgressObjectMessagesDecoder));
var $author$project$SignIn$Flags$flagsWorkflowsObjectDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$SignIn$Flags$FlagsWorkflowsObject,
	A2($elm$json$Json$Decode$field, 'name', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2(
		$elm$json$Json$Decode$field,
		'progress',
		$elm$json$Json$Decode$list($author$project$SignIn$Flags$flagsWorkflowsObjectProgressObjectDecoder)));
var $author$project$SignIn$Flags$flagsDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$SignIn$Flags$Flags,
	A2($elm$json$Json$Decode$field, 'config', $author$project$SignIn$Flags$flagsConfigDecoder),
	A2($elm$json$Json$Decode$field, 'extra', $author$project$SignIn$Flags$extraDecoder),
	A2(
		$elm$json$Json$Decode$field,
		'workflows',
		$elm$json$Json$Decode$list($author$project$SignIn$Flags$flagsWorkflowsObjectDecoder)));
var $author$project$SignIn$Flags$jsonToResultFlags = function (json) {
	return A2(
		$elm$core$Result$mapError,
		$elm$json$Json$Decode$errorToString,
		A2($elm$json$Json$Decode$decodeValue, $author$project$SignIn$Flags$flagsDecoder, json));
};
var $author$project$SignIn$Model$ProgressMsg = function (a) {
	return {$: 'ProgressMsg', a: a};
};
var $author$project$SignIn$progressCmds = function (pcmds) {
	return A2($elm$core$Platform$Cmd$map, $author$project$SignIn$Model$ProgressMsg, pcmds);
};
var $author$project$SignIn$progressFlags = function (flags) {
	return {labels: flags.extra.progressView.labels, workflows: flags.workflows};
};
var $author$project$Userbase$Valid$passwordregex = '^.{6,1000}$';
var $author$project$Userbase$Valid$validPasswordRegex = A2(
	$elm$core$Maybe$withDefault,
	$elm$regex$Regex$never,
	$elm$regex$Regex$fromString($author$project$Userbase$Valid$passwordregex));
var $author$project$Userbase$Valid$passwordSyntaxErr = F2(
	function (errors, password) {
		var _v0 = A2($elm$regex$Regex$contains, $author$project$Userbase$Valid$validPasswordRegex, password);
		if (_v0) {
			return $elm$core$Maybe$Nothing;
		} else {
			return $elm$core$Maybe$Just(errors.currentPassword.syntax);
		}
	});
var $author$project$Userbase$Valid$usernameregex = '^.{1,100}$';
var $author$project$Userbase$Valid$validUsernameRegex = A2(
	$elm$core$Maybe$withDefault,
	$elm$regex$Regex$never,
	$elm$regex$Regex$fromString($author$project$Userbase$Valid$usernameregex));
var $author$project$Userbase$Valid$usernameSyntaxErr = F2(
	function (errors, username) {
		var _v0 = A2($elm$regex$Regex$contains, $author$project$Userbase$Valid$validUsernameRegex, username);
		if (_v0) {
			return $elm$core$Maybe$Nothing;
		} else {
			return $elm$core$Maybe$Just(errors.username.syntax);
		}
	});
var $author$project$SignIn$Model$validate = F2(
	function (flags, state) {
		return {
			passwordErr: A2($author$project$Userbase$Valid$passwordSyntaxErr, flags.extra.signinView.errors, state.password),
			usernameErr: A2($author$project$Userbase$Valid$usernameSyntaxErr, flags.extra.signinView.errors, state.username)
		};
	});
var $author$project$SignIn$Model$validateState = F2(
	function (flags, state) {
		return _Utils_update(
			state,
			{
				problems: A2($author$project$SignIn$Model$validate, flags, state)
			});
	});
var $author$project$SignIn$init = function (value) {
	var _v0 = $author$project$SignIn$Flags$jsonToResultFlags(value);
	if (_v0.$ === 'Err') {
		var err = _v0.a;
		return _Utils_Tuple2(
			$author$project$SignIn$Model$Failed(err),
			$elm$core$Platform$Cmd$none);
	} else {
		var flags = _v0.a;
		var _v1 = $author$project$Progress$Model$init(
			$author$project$SignIn$progressFlags(flags));
		var pstate = _v1.a;
		var pcmds = _v1.b;
		return _Utils_Tuple2(
			A2(
				$author$project$SignIn$Model$Loaded,
				flags,
				A2(
					$author$project$SignIn$Model$validateState,
					flags,
					{
						auth: $krisajenkins$remotedata$RemoteData$NotAsked,
						password: '',
						problems: A2($author$project$SignIn$Model$Problems, $elm$core$Maybe$Nothing, $elm$core$Maybe$Nothing),
						progress: pstate,
						response: $krisajenkins$remotedata$RemoteData$NotAsked,
						showPasswords: false,
						transition: true,
						username: ''
					})),
			$author$project$SignIn$progressCmds(pcmds));
	}
};
var $author$project$SignIn$Model$Incoming = function (a) {
	return {$: 'Incoming', a: a};
};
var $author$project$SignIn$subscriptions = function (model) {
	return $author$project$Shared$Ports$toElm($author$project$SignIn$Model$Incoming);
};
var $author$project$Shared$Cmd$cmdLogDetails = F3(
	function (desc, s, any) {
		var _v0 = A2($author$project$Shared$Dbg$log, 'cmdLogDetails ' + desc, s);
		return _Utils_Tuple2(any, $elm$core$Platform$Cmd$none);
	});
var $author$project$Shared$Cmd$cmdLogDetails2 = F3(
	function (desc, s, _v0) {
		var any = _v0.a;
		var any2 = _v0.b;
		var _v1 = A2($author$project$Shared$Dbg$log, 'cmdLogDetails ' + desc, s);
		return _Utils_Tuple2(any, $elm$core$Platform$Cmd$none);
	});
var $author$project$SignIn$cmdSignIn = F2(
	function (flags, state) {
		var request = $elm$json$Json$Encode$object(
			_List_fromArray(
				[
					_Utils_Tuple2(
					'kind',
					$elm$json$Json$Encode$string(flags.extra.signinView.requests.submit)),
					_Utils_Tuple2(
					'username',
					$elm$json$Json$Encode$string(state.username)),
					_Utils_Tuple2(
					'password',
					$elm$json$Json$Encode$string(state.password))
				]));
		var newstate = _Utils_update(
			state,
			{response: $krisajenkins$remotedata$RemoteData$Loading});
		return _Utils_Tuple2(
			A2($author$project$SignIn$Model$Loaded, flags, newstate),
			$author$project$Shared$Ports$toMain(request));
	});
var $author$project$SignIn$updateStateCmds = F3(
	function (flags, state, cmds) {
		return _Utils_Tuple2(
			A2($author$project$SignIn$Model$Loaded, flags, state),
			cmds);
	});
var $author$project$SignIn$updateProgress = F3(
	function (flags, state, pmsg) {
		var _v0 = A3(
			$author$project$Progress$Model$update,
			$author$project$SignIn$progressFlags(flags),
			state.progress,
			pmsg);
		var pstate = _v0.a;
		var pcmds = _v0.b;
		return A3(
			$author$project$SignIn$updateStateCmds,
			flags,
			_Utils_update(
				state,
				{progress: pstate}),
			$author$project$SignIn$progressCmds(pcmds));
	});
var $author$project$SignIn$updateState = F2(
	function (flags, state) {
		return A3(
			$author$project$SignIn$updateStateCmds,
			flags,
			A2($author$project$SignIn$Model$validateState, flags, state),
			$elm$core$Platform$Cmd$none);
	});
var $author$project$SignIn$Decode$Progress = function (a) {
	return {$: 'Progress', a: a};
};
var $author$project$SignIn$Decode$SignInAuth = function (a) {
	return {$: 'SignInAuth', a: a};
};
var $author$project$SignIn$Decode$SignInFailed = function (a) {
	return {$: 'SignInFailed', a: a};
};
var $author$project$SignIn$Decode$SignInMismatch = function (a) {
	return {$: 'SignInMismatch', a: a};
};
var $author$project$SignIn$Decode$SignInNoProfile = function (a) {
	return {$: 'SignInNoProfile', a: a};
};
var $author$project$SignIn$Decode$SignInProfile = function (a) {
	return {$: 'SignInProfile', a: a};
};
var $author$project$SignIn$Decode$incomingMsgDecoderByMsg = function (msg) {
	switch (msg) {
		case 'error':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$SignIn$Decode$SignInFailed,
				$elm$json$Json$Decode$maybe(
					A2($elm$json$Json$Decode$field, 'details', $elm$json$Json$Decode$string)));
		case 'signin mismatch':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$SignIn$Decode$SignInMismatch,
				$elm$json$Json$Decode$maybe(
					A2($elm$json$Json$Decode$field, 'details', $elm$json$Json$Decode$string)));
		case 'signin no profile':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$SignIn$Decode$SignInNoProfile,
				$elm$json$Json$Decode$maybe(
					A2($elm$json$Json$Decode$field, 'details', $elm$json$Json$Decode$string)));
		case 'auth':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$SignIn$Decode$SignInAuth,
				A2($elm$json$Json$Decode$field, 'auth', $author$project$Auth$Decode$authDecoder));
		case 'profile info':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$SignIn$Decode$SignInProfile,
				A2($elm$json$Json$Decode$field, 'profile', $author$project$ProfileData$Decode$profileDataDecoder));
		case 'progress':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$SignIn$Decode$Progress,
				A2($elm$json$Json$Decode$field, 'progress', $elm$json$Json$Decode$value));
		default:
			var other = msg;
			return $elm$json$Json$Decode$fail(other);
	}
};
var $author$project$SignIn$Decode$incomingMsgDecoder = A2(
	$elm$json$Json$Decode$andThen,
	$author$project$SignIn$Decode$incomingMsgDecoderByMsg,
	A2($elm$json$Json$Decode$field, 'msg', $elm$json$Json$Decode$string));
var $author$project$SignIn$Decode$valueToIncomingMsg = function (value) {
	return function (x) {
		return x;
	}(
		A2(
			$elm$core$Result$mapError,
			$elm$json$Json$Decode$errorToString,
			A2($elm$json$Json$Decode$decodeValue, $author$project$SignIn$Decode$incomingMsgDecoder, value)));
};
var $author$project$SignIn$update = F2(
	function (msg, model) {
		var _v0 = _Utils_Tuple2(model, msg);
		if (_v0.a.$ === 'Failed') {
			return _Utils_Tuple2(model, $elm$core$Platform$Cmd$none);
		} else {
			switch (_v0.b.$) {
				case 'UpdateUsername':
					var _v1 = _v0.a;
					var flags = _v1.a;
					var state = _v1.b;
					var value = _v0.b.a;
					return A2(
						$author$project$SignIn$updateState,
						flags,
						_Utils_update(
							state,
							{response: $krisajenkins$remotedata$RemoteData$NotAsked, username: value}));
				case 'UpdatePassword':
					var _v2 = _v0.a;
					var flags = _v2.a;
					var state = _v2.b;
					var value = _v0.b.a;
					return A2(
						$author$project$SignIn$updateState,
						flags,
						_Utils_update(
							state,
							{password: value, response: $krisajenkins$remotedata$RemoteData$NotAsked}));
				case 'UpdateShowPasswords':
					var _v3 = _v0.a;
					var flags = _v3.a;
					var state = _v3.b;
					var value = _v0.b.a;
					return A2(
						$author$project$SignIn$updateState,
						flags,
						_Utils_update(
							state,
							{response: $krisajenkins$remotedata$RemoteData$NotAsked, showPasswords: value}));
				case 'UpdateTransition':
					var _v4 = _v0.a;
					var flags = _v4.a;
					var state = _v4.b;
					var value = _v0.b.a;
					return A2(
						$author$project$SignIn$updateState,
						flags,
						_Utils_update(
							state,
							{response: $krisajenkins$remotedata$RemoteData$NotAsked, transition: value}));
				case 'PressSignIn':
					var _v5 = _v0.a;
					var flags = _v5.a;
					var state = _v5.b;
					var _v6 = _v0.b;
					return A2($author$project$SignIn$cmdSignIn, flags, state);
				case 'ProgressMsg':
					var _v7 = _v0.a;
					var flags = _v7.a;
					var state = _v7.b;
					var pmsg = _v0.b.a;
					return A3($author$project$SignIn$updateProgress, flags, state, pmsg);
				default:
					var _v8 = _v0.a;
					var flags = _v8.a;
					var state = _v8.b;
					var v = _v0.b.a;
					var fail = function (mdetails) {
						if (mdetails.$ === 'Nothing') {
							return A2(
								$author$project$SignIn$updateState,
								flags,
								_Utils_update(
									state,
									{
										response: $krisajenkins$remotedata$RemoteData$Failure(flags.extra.signinView.labels.error.mismatch)
									}));
						} else {
							var err = mdetails.a;
							return A2(
								$author$project$SignIn$updateState,
								flags,
								_Utils_update(
									state,
									{
										response: $krisajenkins$remotedata$RemoteData$Failure(err)
									}));
						}
					};
					var _v9 = _Utils_Tuple2(
						$author$project$SignIn$Decode$valueToIncomingMsg(v),
						state.transition);
					if (_v9.a.$ === 'Err') {
						var err = _v9.a.a;
						return $author$project$Shared$Reg$decodeErr(err) ? A3(
							$author$project$SignIn$updateProgress,
							flags,
							state,
							$author$project$Progress$Model$DecodeErr(err)) : A2($author$project$Shared$Cmd$cmdLog, 'Err ' + err, model);
					} else {
						switch (_v9.a.a.$) {
							case 'SignInFailed':
								var mdetails = _v9.a.a.a;
								return A3(
									$author$project$Shared$Cmd$cmdLogDetails2,
									'SignInFailed',
									mdetails,
									fail(mdetails));
							case 'SignInMismatch':
								var mdetails = _v9.a.a.a;
								return A3(
									$author$project$Shared$Cmd$cmdLogDetails2,
									'SignInMismatch',
									mdetails,
									fail(mdetails));
							case 'SignInAuth':
								var auth = _v9.a.a.a;
								return A2(
									$author$project$SignIn$updateState,
									flags,
									_Utils_update(
										state,
										{
											auth: $krisajenkins$remotedata$RemoteData$Success(auth)
										}));
							case 'SignInNoProfile':
								if (_v9.b) {
									var mdetails = _v9.a.a.a;
									return A2($author$project$Shared$Cmd$cmdTransition, flags.extra.signinView.transitions.profile, model);
								} else {
									var mdetails = _v9.a.a.a;
									return A3(
										$author$project$Shared$Cmd$cmdLogDetails,
										'SignInNoProfile',
										mdetails,
										A2(
											$author$project$SignIn$Model$Loaded,
											flags,
											_Utils_update(
												state,
												{
													response: $krisajenkins$remotedata$RemoteData$Failure(flags.extra.signinView.labels.error.noProfile)
												})));
								}
							case 'SignInProfile':
								if (!_v9.b) {
									var profile = _v9.a.a.a;
									return A3(
										$author$project$Shared$Cmd$cmdLogDetails2,
										'SignInProfile',
										$elm$core$Maybe$Just(''),
										A2(
											$author$project$SignIn$updateState,
											flags,
											_Utils_update(
												state,
												{
													response: $krisajenkins$remotedata$RemoteData$Success(profile)
												})));
								} else {
									var profile = _v9.a.a.a;
									var _v10 = _Utils_Tuple3(profile.home.page, profile.home.tkey, profile.home.bnum);
									_v10$2:
									while (true) {
										switch (_v10.a.$) {
											case 'Topic':
												if (_v10.b.$ === 'Just') {
													var _v11 = _v10.a;
													var tkey = _v10.b.a;
													return A3($author$project$Shared$Cmd$cmdTransitionString, flags.extra.signinView.transitions.topic, tkey, model);
												} else {
													break _v10$2;
												}
											case 'Bundle':
												if (_v10.c.$ === 'Just') {
													var _v12 = _v10.a;
													var bnum = _v10.c.a;
													return A3($author$project$Shared$Cmd$cmdTransitionNumber, flags.extra.signinView.transitions.bundle, bnum, model);
												} else {
													break _v10$2;
												}
											default:
												break _v10$2;
										}
									}
									return A2($author$project$Shared$Cmd$cmdTransition, flags.extra.signinView.transitions.topiclist, model);
								}
							default:
								var value = _v9.a.a.a;
								return A3(
									$author$project$SignIn$updateProgress,
									flags,
									state,
									$author$project$Progress$Model$Incoming(value));
						}
					}
			}
		}
	});
var $author$project$SignIn$currentView = 0;
var $author$project$SignIn$Model$PressSignIn = {$: 'PressSignIn'};
var $author$project$SignIn$Model$signInErr = function (problems) {
	return $elm_community$maybe_extra$Maybe$Extra$orList(
		_List_fromArray(
			[problems.usernameErr, problems.passwordErr]));
};
var $author$project$SignIn$View$okToSubmit = function (state) {
	var _v0 = _Utils_Tuple2(
		$author$project$SignIn$Model$signInErr(state.problems),
		state.response);
	_v0$2:
	while (true) {
		if (_v0.a.$ === 'Nothing') {
			switch (_v0.b.$) {
				case 'NotAsked':
					var _v1 = _v0.a;
					var _v2 = _v0.b;
					return true;
				case 'Success':
					var _v3 = _v0.a;
					return true;
				default:
					break _v0$2;
			}
		} else {
			break _v0$2;
		}
	}
	return false;
};
var $author$project$SignIn$View$viewButton = F2(
	function (flags, state) {
		var loading = function (cls) {
			var _v0 = state.response;
			if (_v0.$ === 'Loading') {
				return cls + ' is-loading';
			} else {
				return cls;
			}
		};
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('field is-horizontal')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-label')
						]),
					_List_Nil),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-body')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('control')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$button,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class(
													loading('button has-background-primary-dark has-text-white is-link')),
													$elm$html$Html$Attributes$disabled(
													!$author$project$SignIn$View$okToSubmit(state)),
													$elm$html$Html$Events$onClick($author$project$SignIn$Model$PressSignIn)
												]),
											_List_fromArray(
												[
													$elm$html$Html$text(flags.extra.signinView.labels.signin.label)
												]))
										]))
								]))
						]))
				]));
	});
var $author$project$SignIn$Model$UpdatePassword = function (a) {
	return {$: 'UpdatePassword', a: a};
};
var $elm$html$Html$Attributes$autocomplete = function (bool) {
	return A2(
		$elm$html$Html$Attributes$stringProperty,
		'autocomplete',
		bool ? 'on' : 'off');
};
var $author$project$SignIn$View$viewPasswordError = F2(
	function (flags, state) {
		var _v0 = state.problems.passwordErr;
		if (_v0.$ === 'Just') {
			var reason = _v0.a;
			return A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('help is-danger')
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$p,
						_List_Nil,
						$author$project$Shared$Text$htmlTextLines(reason))
					]));
		} else {
			var _v1 = state.response;
			if (_v1.$ === 'Failure') {
				var reason = _v1.a;
				return A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('help is-danger')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$p,
							_List_Nil,
							$author$project$Shared$Text$htmlTextLines(reason))
						]));
			} else {
				return A2($elm$html$Html$div, _List_Nil, _List_Nil);
			}
		}
	});
var $author$project$SignIn$View$viewCurrentPassword = F2(
	function (flags, state) {
		var inputType = state.showPasswords ? 'text' : 'password';
		var help = $author$project$Shared$Text$htmlTextLines(flags.extra.signinView.labels.currentPassword.description);
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('field is-horizontal')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-label is-normal')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help is-hidden-mobile')
												]),
											$author$project$Shared$Text$dropExtra(
												$author$project$Shared$Text$htmlBreaks(help)))
										])),
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class(
													A3($author$project$Shared$Text$has_danger, 'label ml-1', state.problems.passwordErr, false))
												]),
											_List_fromArray(
												[
													$elm$html$Html$text(flags.extra.signinView.labels.currentPassword.label)
												]))
										]))
								]))
						])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-body')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help')
												]),
											help)
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('field')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$div,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('control has-icons-right')
												]),
											_List_fromArray(
												[
													A2(
													$elm$html$Html$input,
													_List_fromArray(
														[
															$elm$html$Html$Attributes$class(
															A3($author$project$Shared$Text$is_danger, 'input', state.problems.passwordErr, false)),
															$elm$html$Html$Attributes$type_(inputType),
															$elm$html$Html$Attributes$placeholder(flags.extra.signinView.labels.currentPassword.placeholder),
															$elm$html$Html$Attributes$value(state.password),
															$elm$html$Html$Attributes$autocomplete(false),
															$elm$html$Html$Events$onInput($author$project$SignIn$Model$UpdatePassword),
															$author$project$Shared$OnEnter$onEnter($author$project$SignIn$Model$PressSignIn)
														]),
													_List_Nil)
												]))
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('field')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$div,
											_List_Nil,
											_List_fromArray(
												[
													A2(
													$elm$html$Html$div,
													_List_Nil,
													_List_fromArray(
														[
															A2($author$project$SignIn$View$viewPasswordError, flags, state)
														]))
												]))
										]))
								])),
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field-label is-normal'),
									A2($elm$html$Html$Attributes$style, 'max-width', '5px')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$label,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('label')
										]),
									_List_Nil)
								]))
						]))
				]));
	});
var $author$project$SignIn$Model$UpdateShowPasswords = function (a) {
	return {$: 'UpdateShowPasswords', a: a};
};
var $author$project$SignIn$View$viewShowPasswords = F2(
	function (flags, state) {
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('field is-horizontal')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-label is-normal')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('label ml-1')
												]),
											_List_fromArray(
												[
													$elm$html$Html$text(flags.extra.signinView.labels.showPasswords.label)
												]))
										]))
								]))
						])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-body')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field'),
									A2($elm$html$Html$Attributes$style, 'display', 'table')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('checkbox'),
											A2($elm$html$Html$Attributes$style, 'display', 'table-cell'),
											A2($elm$html$Html$Attributes$style, 'vertical-align', 'middle')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$input,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('sp-checkbox mt-2'),
													$elm$html$Html$Attributes$type_('checkbox'),
													$elm$html$Html$Attributes$checked(state.showPasswords),
													$elm$html$Html$Events$onCheck($author$project$SignIn$Model$UpdateShowPasswords)
												]),
											_List_Nil)
										]))
								])),
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field-label is-normal'),
									A2($elm$html$Html$Attributes$style, 'max-width', '5px')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$label,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('label')
										]),
									_List_Nil)
								]))
						]))
				]));
	});
var $author$project$SignIn$Model$UpdateUsername = function (a) {
	return {$: 'UpdateUsername', a: a};
};
var $author$project$SignIn$View$viewUsernameError = F2(
	function (flags, state) {
		var _v0 = state.problems.usernameErr;
		if (_v0.$ === 'Just') {
			var reason = _v0.a;
			return A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('help is-danger')
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$p,
						_List_Nil,
						$author$project$Shared$Text$htmlTextLines(reason))
					]));
		} else {
			return A2($elm$html$Html$div, _List_Nil, _List_Nil);
		}
	});
var $author$project$SignIn$View$viewUsername = F2(
	function (flags, state) {
		var help = $author$project$Shared$Text$htmlTextLines(flags.extra.signinView.labels.username.description);
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('field is-horizontal')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-label is-normal')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help is-hidden-mobile')
												]),
											$author$project$Shared$Text$dropExtra(
												$author$project$Shared$Text$htmlBreaks(help)))
										])),
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class(
													A3($author$project$Shared$Text$has_danger, 'label ml-1', state.problems.usernameErr, false))
												]),
											_List_fromArray(
												[
													$elm$html$Html$text(flags.extra.signinView.labels.username.label)
												]))
										]))
								]))
						])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-body')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help')
												]),
											help)
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('field')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$div,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('control has-icons-right')
												]),
											_List_fromArray(
												[
													A2(
													$elm$html$Html$input,
													_List_fromArray(
														[
															$elm$html$Html$Attributes$class(
															A3($author$project$Shared$Text$is_danger, 'input', state.problems.usernameErr, false)),
															$elm$html$Html$Attributes$type_('text'),
															$elm$html$Html$Attributes$placeholder(flags.extra.signinView.labels.username.placeholder),
															$elm$html$Html$Attributes$value(state.username),
															$elm$html$Html$Events$onInput($author$project$SignIn$Model$UpdateUsername)
														]),
													_List_Nil)
												]))
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('field')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$div,
											_List_Nil,
											_List_fromArray(
												[
													A2(
													$elm$html$Html$div,
													_List_Nil,
													_List_fromArray(
														[
															A2($author$project$SignIn$View$viewUsernameError, flags, state)
														]))
												]))
										]))
								])),
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field-label is-normal'),
									A2($elm$html$Html$Attributes$style, 'max-width', '5px')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$label,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('label')
										]),
									_List_Nil)
								]))
						]))
				]));
	});
var $author$project$SignIn$View$view = F2(
	function (flags, state) {
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('sp-form ml-3 mr-3 pb-3')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$br,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('is-hidden-mobile')
						]),
					_List_Nil),
					A2($author$project$SignIn$View$viewUsername, flags, state),
					A2($author$project$SignIn$View$viewShowPasswords, flags, state),
					A2($author$project$SignIn$View$viewCurrentPassword, flags, state),
					A2($author$project$SignIn$View$viewButton, flags, state),
					A2(
					$elm$html$Html$br,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('is-hidden-mobile')
						]),
					_List_Nil)
				]));
	});
var $author$project$SignIn$view = function (model) {
	var _v0 = _Utils_Tuple2($author$project$SignIn$currentView, model);
	_v0$3:
	while (true) {
		if (_v0.b.$ === 'Failed') {
			if (!_v0.a) {
				var err = _v0.b.a;
				return A2(
					$elm$html$Html$p,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('notification is-danger')
						]),
					_List_fromArray(
						[
							$elm$html$Html$text(err)
						]));
			} else {
				break _v0$3;
			}
		} else {
			switch (_v0.a) {
				case 0:
					var _v1 = _v0.b;
					var flags = _v1.a;
					var state = _v1.b;
					return A2($author$project$SignIn$View$view, flags, state);
				case 1:
					var _v2 = _v0.b;
					var flags = _v2.a;
					var state = _v2.b;
					return A2(
						$elm$html$Html$map,
						$author$project$SignIn$Model$ProgressMsg,
						A2(
							$author$project$Progress$View$view,
							$author$project$SignIn$progressFlags(flags),
							state.progress));
				default:
					break _v0$3;
			}
		}
	}
	return A2($elm$html$Html$div, _List_Nil, _List_Nil);
};
var $author$project$SignIn$main = $elm$browser$Browser$element(
	{init: $author$project$SignIn$init, subscriptions: $author$project$SignIn$subscriptions, update: $author$project$SignIn$update, view: $author$project$SignIn$view});
var $author$project$Profile$Model$Failed = function (a) {
	return {$: 'Failed', a: a};
};
var $author$project$Profile$Model$Loaded = F2(
	function (a, b) {
		return {$: 'Loaded', a: a, b: b};
	});
var $author$project$Profile$Model$DetailsMsg = function (a) {
	return {$: 'DetailsMsg', a: a};
};
var $author$project$Profile$detailsCmds = function (dcmds) {
	return A2($elm$core$Platform$Cmd$map, $author$project$Profile$Model$DetailsMsg, dcmds);
};
var $author$project$Profile$detailsFlags = function (flags) {
	return {errors: flags.extra.profileDetails.errors, initial: flags.extra.profileDetails.initial, labels: flags.extra.profileDetails.labels, readonly: flags.extra.profileDetails.readonly};
};
var $author$project$ProfileDetails$Model$Problems = F4(
	function (currentErr, initialsErr, titleErr, monikerErr) {
		return {currentErr: currentErr, initialsErr: initialsErr, monikerErr: monikerErr, titleErr: titleErr};
	});
var $author$project$ProfileData$Valid$initialsregex = '^.{1,16}$';
var $author$project$ProfileData$Valid$validInitialsRegex = A2(
	$elm$core$Maybe$withDefault,
	$elm$regex$Regex$never,
	$elm$regex$Regex$fromString($author$project$ProfileData$Valid$initialsregex));
var $author$project$ProfileData$Valid$initialsSyntaxErr = F2(
	function (errors, initials) {
		return A2($elm$regex$Regex$contains, $author$project$ProfileData$Valid$validInitialsRegex, initials) ? $elm$core$Maybe$Nothing : $elm$core$Maybe$Just(errors.initials.syntax);
	});
var $author$project$ProfileData$Unique$initialsConflict = F2(
	function (unique, initials) {
		return A2(
			$elm$core$List$any,
			function (s) {
				return _Utils_eq(s, initials);
			},
			unique.initials) ? $elm$core$Maybe$Just(
			A2($elm$core$String$join, ', ', unique.initials)) : $elm$core$Maybe$Nothing;
	});
var $author$project$ProfileData$Valid$initialsUniqueErr = F3(
	function (errors, runique, initials) {
		switch (runique.$) {
			case 'Success':
				var unique = runique.a;
				var _v1 = A2($author$project$ProfileData$Unique$initialsConflict, unique, initials);
				if (_v1.$ === 'Just') {
					var values = _v1.a;
					return $elm$core$Maybe$Just(
						_Utils_ap(errors.initials.unique, values));
				} else {
					return $elm$core$Maybe$Nothing;
				}
			case 'Failure':
				var err = runique.a;
				return $elm$core$Maybe$Just(err);
			default:
				return $elm$core$Maybe$Nothing;
		}
	});
var $author$project$ProfileData$Valid$initialsErr = F3(
	function (errors, runique, initials) {
		return $elm_community$maybe_extra$Maybe$Extra$orList(
			_List_fromArray(
				[
					A2($author$project$ProfileData$Valid$initialsSyntaxErr, errors, initials),
					A3($author$project$ProfileData$Valid$initialsUniqueErr, errors, runique, initials)
				]));
	});
var $author$project$ProfileData$Valid$monikerregex = '^.{1,16}$';
var $author$project$ProfileData$Valid$validMonikerRegex = A2(
	$elm$core$Maybe$withDefault,
	$elm$regex$Regex$never,
	$elm$regex$Regex$fromString($author$project$ProfileData$Valid$monikerregex));
var $author$project$ProfileData$Valid$monikerSyntaxErr = F2(
	function (errors, moniker) {
		var _v0 = A2($elm$regex$Regex$contains, $author$project$ProfileData$Valid$validMonikerRegex, moniker);
		if (_v0) {
			return $elm$core$Maybe$Nothing;
		} else {
			return $elm$core$Maybe$Just(errors.moniker.syntax);
		}
	});
var $author$project$ProfileData$Unique$monikerConflict = F2(
	function (unique, moniker) {
		return A2(
			$elm$core$List$any,
			function (s) {
				return _Utils_eq(s, moniker);
			},
			unique.monikers) ? $elm$core$Maybe$Just(
			A2($elm$core$String$join, ', ', unique.monikers)) : $elm$core$Maybe$Nothing;
	});
var $author$project$ProfileData$Valid$monikerUniqueErr = F3(
	function (errors, runique, monikers) {
		switch (runique.$) {
			case 'Success':
				var unique = runique.a;
				var _v1 = A2($author$project$ProfileData$Unique$monikerConflict, unique, monikers);
				if (_v1.$ === 'Just') {
					var values = _v1.a;
					return $elm$core$Maybe$Just(
						_Utils_ap(errors.moniker.unique, values));
				} else {
					return $elm$core$Maybe$Nothing;
				}
			case 'Failure':
				var err = runique.a;
				return $elm$core$Maybe$Just(err);
			default:
				return $elm$core$Maybe$Nothing;
		}
	});
var $author$project$ProfileData$Valid$monikerErr = F3(
	function (errors, unique, moniker) {
		return $elm_community$maybe_extra$Maybe$Extra$orList(
			_List_fromArray(
				[
					A2($author$project$ProfileData$Valid$monikerSyntaxErr, errors, moniker),
					A3($author$project$ProfileData$Valid$monikerUniqueErr, errors, unique, moniker)
				]));
	});
var $author$project$ProfileData$Valid$titleregex = '^.{1,40}$';
var $author$project$ProfileData$Valid$validTitleRegex = A2(
	$elm$core$Maybe$withDefault,
	$elm$regex$Regex$never,
	$elm$regex$Regex$fromString($author$project$ProfileData$Valid$titleregex));
var $author$project$ProfileData$Valid$titleSyntaxErr = F2(
	function (errors, title) {
		var _v0 = A2($elm$regex$Regex$contains, $author$project$ProfileData$Valid$validTitleRegex, title);
		if (_v0) {
			return $elm$core$Maybe$Nothing;
		} else {
			return $elm$core$Maybe$Just(errors.title.syntax);
		}
	});
var $author$project$ProfileData$Unique$titleConflict = F2(
	function (unique, title) {
		return A2(
			$elm$core$List$any,
			function (s) {
				return _Utils_eq(s, title);
			},
			unique.titles) ? $elm$core$Maybe$Just(
			A2($elm$core$String$join, ', ', unique.titles)) : $elm$core$Maybe$Nothing;
	});
var $author$project$ProfileData$Valid$titleUniqueErr = F3(
	function (errors, runique, titles) {
		switch (runique.$) {
			case 'Success':
				var unique = runique.a;
				var _v1 = A2($author$project$ProfileData$Unique$titleConflict, unique, titles);
				if (_v1.$ === 'Just') {
					var values = _v1.a;
					return $elm$core$Maybe$Just(
						_Utils_ap(errors.title.unique, values));
				} else {
					return $elm$core$Maybe$Nothing;
				}
			case 'Failure':
				var err = runique.a;
				return $elm$core$Maybe$Just(err);
			default:
				return $elm$core$Maybe$Nothing;
		}
	});
var $author$project$ProfileData$Valid$titleErr = F3(
	function (errors, unique, title) {
		return $elm_community$maybe_extra$Maybe$Extra$orList(
			_List_fromArray(
				[
					A2($author$project$ProfileData$Valid$titleSyntaxErr, errors, title),
					A3($author$project$ProfileData$Valid$titleUniqueErr, errors, unique, title)
				]));
	});
var $author$project$ProfileDetails$Model$validate = F3(
	function (flags, runique, profile) {
		return {
			currentErr: $elm$core$Maybe$Nothing,
			initialsErr: A3($author$project$ProfileData$Valid$initialsErr, flags.errors, runique, profile.initials),
			monikerErr: A3($author$project$ProfileData$Valid$monikerErr, flags.errors, runique, profile.moniker),
			titleErr: A3($author$project$ProfileData$Valid$titleErr, flags.errors, runique, profile.title)
		};
	});
var $author$project$ProfileDetails$Model$validateState = F2(
	function (flags, state) {
		return _Utils_update(
			state,
			{
				problems: A3($author$project$ProfileDetails$Model$validate, flags, state.runique, state.current)
			});
	});
var $author$project$ProfileDetails$Model$init = function (flags) {
	return _Utils_Tuple2(
		A2(
			$author$project$ProfileDetails$Model$validateState,
			flags,
			{
				current: $author$project$ProfileData$Model$emptyProfileData,
				disabled: false,
				initial: $elm$core$Maybe$Nothing,
				problems: A4($author$project$ProfileDetails$Model$Problems, $elm$core$Maybe$Nothing, $elm$core$Maybe$Nothing, $elm$core$Maybe$Nothing, $elm$core$Maybe$Nothing),
				readonly: flags.readonly,
				runique: $krisajenkins$remotedata$RemoteData$NotAsked,
				showthumb: flags.labels.thumbnail.visible
			}),
		$elm$core$Platform$Cmd$none);
};
var $author$project$ProfileUserbase$Model$Problems = F4(
	function (usernameErr, passwordErr, newPasswordErr, confirmErr) {
		return {confirmErr: confirmErr, newPasswordErr: newPasswordErr, passwordErr: passwordErr, usernameErr: usernameErr};
	});
var $author$project$Userbase$Model$emptyUserbase = {confirm: '', newPassword: '', password: '', username: ''};
var $author$project$Userbase$Valid$confirmSyntaxErr = F3(
	function (errors, confirm, password) {
		var _v0 = A2($elm$regex$Regex$contains, $author$project$Userbase$Valid$validPasswordRegex, confirm);
		if (_v0) {
			return (!_Utils_eq(confirm, password)) ? $elm$core$Maybe$Just(errors.confirm.doNotMatch) : $elm$core$Maybe$Nothing;
		} else {
			return $elm$core$Maybe$Just(errors.confirm.syntax);
		}
	});
var $elm_community$maybe_extra$Maybe$Extra$isNothing = function (m) {
	if (m.$ === 'Nothing') {
		return true;
	} else {
		return false;
	}
};
var $author$project$ProfileUserbase$Model$showCurrentPassword = F2(
	function (flags, state) {
		var _v0 = _Utils_Tuple2(flags.labels.currentPassword.visible, state.auth);
		if (_v0.a && (_v0.b.$ === 'Just')) {
			var auth = _v0.b.a;
			return !auth.unchanged;
		} else {
			return false;
		}
	});
var $author$project$Userbase$Model$userbaseChanged = F3(
	function (includeCurrent, initial, current) {
		if (initial.$ === 'Nothing') {
			return true;
		} else {
			var userbase = initial.a;
			var usernameChanged = !_Utils_eq(userbase.username, current.username);
			var passwordChanged = includeCurrent && (!_Utils_eq(userbase.password, current.password));
			var newPasswordChanged = !_Utils_eq(userbase.newPassword, current.newPassword);
			var confirmChanged = !_Utils_eq(userbase.confirm, current.confirm);
			var result = false || (usernameChanged || (passwordChanged || (newPasswordChanged || confirmChanged)));
			return result;
		}
	});
var $author$project$ProfileUserbase$Model$userbaseProblems = F2(
	function (flags, state) {
		var showcurrent = A2($author$project$ProfileUserbase$Model$showCurrentPassword, flags, state);
		var problems = {
			confirmErr: A3($author$project$Userbase$Valid$confirmSyntaxErr, flags.errors, state.current.confirm, state.current.newPassword),
			newPasswordErr: A2($author$project$Userbase$Valid$passwordSyntaxErr, flags.errors, state.current.newPassword),
			passwordErr: showcurrent ? A2($author$project$Userbase$Valid$passwordSyntaxErr, flags.errors, state.current.password) : $elm$core$Maybe$Nothing,
			usernameErr: A2($author$project$Userbase$Valid$usernameSyntaxErr, flags.errors, state.current.username)
		};
		var noProblems = {confirmErr: $elm$core$Maybe$Nothing, newPasswordErr: $elm$core$Maybe$Nothing, passwordErr: $elm$core$Maybe$Nothing, usernameErr: $elm$core$Maybe$Nothing};
		return ($elm_community$maybe_extra$Maybe$Extra$isNothing(state.initial) || A3($author$project$Userbase$Model$userbaseChanged, showcurrent, state.initial, state.current)) ? problems : noProblems;
	});
var $author$project$ProfileUserbase$Model$validateState = F2(
	function (flags, state) {
		return _Utils_update(
			state,
			{
				problems: A2($author$project$ProfileUserbase$Model$userbaseProblems, flags, state)
			});
	});
var $author$project$ProfileUserbase$Model$init = function (flags) {
	return _Utils_Tuple2(
		A2(
			$author$project$ProfileUserbase$Model$validateState,
			flags,
			{
				auth: $elm$core$Maybe$Nothing,
				current: $author$project$Userbase$Model$emptyUserbase,
				initial: $elm$core$Maybe$Nothing,
				problems: A4($author$project$ProfileUserbase$Model$Problems, $elm$core$Maybe$Nothing, $elm$core$Maybe$Nothing, $elm$core$Maybe$Nothing, $elm$core$Maybe$Nothing),
				showPasswords: false
			}),
		$elm$core$Platform$Cmd$none);
};
var $author$project$Profile$Flags$Flags = F3(
	function (config, extra, workflows) {
		return {config: config, extra: extra, workflows: workflows};
	});
var $author$project$Profile$Flags$Extra = F9(
	function (mode, module_, months, profileDetails, profileSubmit, profileUserbase, profileView, progressView, viewNodes) {
		return {mode: mode, module_: module_, months: months, profileDetails: profileDetails, profileSubmit: profileSubmit, profileUserbase: profileUserbase, profileView: profileView, progressView: progressView, viewNodes: viewNodes};
	});
var $author$project$Profile$Flags$ExtraMonths = function (m1) {
	return function (m10) {
		return function (m11) {
			return function (m12) {
				return function (m2) {
					return function (m3) {
						return function (m4) {
							return function (m5) {
								return function (m6) {
									return function (m7) {
										return function (m8) {
											return function (m9) {
												return {m1: m1, m10: m10, m11: m11, m12: m12, m2: m2, m3: m3, m4: m4, m5: m5, m6: m6, m7: m7, m8: m8, m9: m9};
											};
										};
									};
								};
							};
						};
					};
				};
			};
		};
	};
};
var $author$project$Profile$Flags$extraMonthsDecoder = function () {
	var fieldSet0 = A9(
		$elm$json$Json$Decode$map8,
		$author$project$Profile$Flags$ExtraMonths,
		A2($elm$json$Json$Decode$field, 'm1', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'm10', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'm11', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'm12', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'm2', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'm3', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'm4', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'm5', $elm$json$Json$Decode$string));
	return A6(
		$elm$json$Json$Decode$map5,
		$elm$core$Basics$apL,
		fieldSet0,
		A2($elm$json$Json$Decode$field, 'm6', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'm7', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'm8', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'm9', $elm$json$Json$Decode$string));
}();
var $author$project$Profile$Flags$ExtraProfileDetails = F4(
	function (errors, initial, labels, readonly) {
		return {errors: errors, initial: initial, labels: labels, readonly: readonly};
	});
var $author$project$Profile$Flags$ExtraProfileDetailsErrors = F4(
	function (initials, moniker, remotedata, title) {
		return {initials: initials, moniker: moniker, remotedata: remotedata, title: title};
	});
var $author$project$Profile$Flags$ExtraProfileDetailsErrorsInitials = F2(
	function (syntax, unique) {
		return {syntax: syntax, unique: unique};
	});
var $author$project$Profile$Flags$extraProfileDetailsErrorsInitialsDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Profile$Flags$ExtraProfileDetailsErrorsInitials,
	A2($elm$json$Json$Decode$field, 'syntax', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'unique', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$ExtraProfileDetailsErrorsMoniker = F2(
	function (syntax, unique) {
		return {syntax: syntax, unique: unique};
	});
var $author$project$Profile$Flags$extraProfileDetailsErrorsMonikerDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Profile$Flags$ExtraProfileDetailsErrorsMoniker,
	A2($elm$json$Json$Decode$field, 'syntax', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'unique', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$ExtraProfileDetailsErrorsRemotedata = F2(
	function (loading, notasked) {
		return {loading: loading, notasked: notasked};
	});
var $author$project$Profile$Flags$extraProfileDetailsErrorsRemotedataDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Profile$Flags$ExtraProfileDetailsErrorsRemotedata,
	A2($elm$json$Json$Decode$field, 'loading', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'notasked', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$ExtraProfileDetailsErrorsTitle = F2(
	function (syntax, unique) {
		return {syntax: syntax, unique: unique};
	});
var $author$project$Profile$Flags$extraProfileDetailsErrorsTitleDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Profile$Flags$ExtraProfileDetailsErrorsTitle,
	A2($elm$json$Json$Decode$field, 'syntax', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'unique', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$extraProfileDetailsErrorsDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$Profile$Flags$ExtraProfileDetailsErrors,
	A2($elm$json$Json$Decode$field, 'initials', $author$project$Profile$Flags$extraProfileDetailsErrorsInitialsDecoder),
	A2($elm$json$Json$Decode$field, 'moniker', $author$project$Profile$Flags$extraProfileDetailsErrorsMonikerDecoder),
	A2($elm$json$Json$Decode$field, 'remotedata', $author$project$Profile$Flags$extraProfileDetailsErrorsRemotedataDecoder),
	A2($elm$json$Json$Decode$field, 'title', $author$project$Profile$Flags$extraProfileDetailsErrorsTitleDecoder));
var $author$project$Profile$Flags$ExtraProfileDetailsLabels = F7(
	function (homepage, initials, moniker, paragraph, subtitle, thumbnail, title) {
		return {homepage: homepage, initials: initials, moniker: moniker, paragraph: paragraph, subtitle: subtitle, thumbnail: thumbnail, title: title};
	});
var $author$project$Profile$Flags$ExtraProfileDetailsLabelsHomepage = F6(
	function (bundle, description, label, topic, topiclist, width) {
		return {bundle: bundle, description: description, label: label, topic: topic, topiclist: topiclist, width: width};
	});
var $author$project$Profile$Flags$extraProfileDetailsLabelsHomepageDecoder = A7(
	$elm$json$Json$Decode$map6,
	$author$project$Profile$Flags$ExtraProfileDetailsLabelsHomepage,
	A2($elm$json$Json$Decode$field, 'bundle', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'topic', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'topiclist', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$ExtraProfileDetailsLabelsInitials = F6(
	function (description, label, placeholder, required, syntax, unique) {
		return {description: description, label: label, placeholder: placeholder, required: required, syntax: syntax, unique: unique};
	});
var $author$project$Profile$Flags$extraProfileDetailsLabelsInitialsDecoder = A7(
	$elm$json$Json$Decode$map6,
	$author$project$Profile$Flags$ExtraProfileDetailsLabelsInitials,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'placeholder', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'required', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'syntax', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'unique', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$ExtraProfileDetailsLabelsMoniker = F6(
	function (description, label, placeholder, required, syntax, unique) {
		return {description: description, label: label, placeholder: placeholder, required: required, syntax: syntax, unique: unique};
	});
var $author$project$Profile$Flags$extraProfileDetailsLabelsMonikerDecoder = A7(
	$elm$json$Json$Decode$map6,
	$author$project$Profile$Flags$ExtraProfileDetailsLabelsMoniker,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'placeholder', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'required', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'syntax', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'unique', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$ExtraProfileDetailsLabelsParagraph = F3(
	function (description, label, placeholder) {
		return {description: description, label: label, placeholder: placeholder};
	});
var $author$project$Profile$Flags$extraProfileDetailsLabelsParagraphDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Profile$Flags$ExtraProfileDetailsLabelsParagraph,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'placeholder', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$ExtraProfileDetailsLabelsSubtitle = F3(
	function (description, label, placeholder) {
		return {description: description, label: label, placeholder: placeholder};
	});
var $author$project$Profile$Flags$extraProfileDetailsLabelsSubtitleDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Profile$Flags$ExtraProfileDetailsLabelsSubtitle,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'placeholder', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$ExtraProfileDetailsLabelsThumbnail = F5(
	function (description, label, remove, upload, visible) {
		return {description: description, label: label, remove: remove, upload: upload, visible: visible};
	});
var $author$project$Profile$Flags$extraProfileDetailsLabelsThumbnailDecoder = A6(
	$elm$json$Json$Decode$map5,
	$author$project$Profile$Flags$ExtraProfileDetailsLabelsThumbnail,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'remove', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'upload', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'visible', $elm$json$Json$Decode$bool));
var $author$project$Profile$Flags$ExtraProfileDetailsLabelsTitle = F6(
	function (description, label, placeholder, required, syntax, unique) {
		return {description: description, label: label, placeholder: placeholder, required: required, syntax: syntax, unique: unique};
	});
var $author$project$Profile$Flags$extraProfileDetailsLabelsTitleDecoder = A7(
	$elm$json$Json$Decode$map6,
	$author$project$Profile$Flags$ExtraProfileDetailsLabelsTitle,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'placeholder', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'required', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'syntax', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'unique', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$extraProfileDetailsLabelsDecoder = A8(
	$elm$json$Json$Decode$map7,
	$author$project$Profile$Flags$ExtraProfileDetailsLabels,
	A2($elm$json$Json$Decode$field, 'homepage', $author$project$Profile$Flags$extraProfileDetailsLabelsHomepageDecoder),
	A2($elm$json$Json$Decode$field, 'initials', $author$project$Profile$Flags$extraProfileDetailsLabelsInitialsDecoder),
	A2($elm$json$Json$Decode$field, 'moniker', $author$project$Profile$Flags$extraProfileDetailsLabelsMonikerDecoder),
	A2($elm$json$Json$Decode$field, 'paragraph', $author$project$Profile$Flags$extraProfileDetailsLabelsParagraphDecoder),
	A2($elm$json$Json$Decode$field, 'subtitle', $author$project$Profile$Flags$extraProfileDetailsLabelsSubtitleDecoder),
	A2($elm$json$Json$Decode$field, 'thumbnail', $author$project$Profile$Flags$extraProfileDetailsLabelsThumbnailDecoder),
	A2($elm$json$Json$Decode$field, 'title', $author$project$Profile$Flags$extraProfileDetailsLabelsTitleDecoder));
var $author$project$Profile$Flags$extraProfileDetailsDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$Profile$Flags$ExtraProfileDetails,
	A2($elm$json$Json$Decode$field, 'errors', $author$project$Profile$Flags$extraProfileDetailsErrorsDecoder),
	A2($elm$json$Json$Decode$field, 'initial', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'labels', $author$project$Profile$Flags$extraProfileDetailsLabelsDecoder),
	A2($elm$json$Json$Decode$field, 'readonly', $elm$json$Json$Decode$bool));
var $author$project$Profile$Flags$ExtraProfileSubmit = F3(
	function (labels, requests, transitions) {
		return {labels: labels, requests: requests, transitions: transitions};
	});
var $author$project$Profile$Flags$ExtraProfileSubmitLabels = function (accept) {
	return function (accepted) {
		return function (addBundle) {
			return function (addMember) {
				return function (addTopic) {
					return function (homebundle) {
						return function (hometopic) {
							return function (hometopiclist) {
								return function (next) {
									return function (profile) {
										return function (submit) {
											return function (title) {
												return function (userbase) {
													return {accept: accept, accepted: accepted, addBundle: addBundle, addMember: addMember, addTopic: addTopic, homebundle: homebundle, hometopic: hometopic, hometopiclist: hometopiclist, next: next, profile: profile, submit: submit, title: title, userbase: userbase};
												};
											};
										};
									};
								};
							};
						};
					};
				};
			};
		};
	};
};
var $author$project$Profile$Flags$ExtraProfileSubmitLabelsAccept = F5(
	function (agree, anchor, choose, description, label) {
		return {agree: agree, anchor: anchor, choose: choose, description: description, label: label};
	});
var $author$project$Profile$Flags$extraProfileSubmitLabelsAcceptDecoder = A6(
	$elm$json$Json$Decode$map5,
	$author$project$Profile$Flags$ExtraProfileSubmitLabelsAccept,
	A2($elm$json$Json$Decode$field, 'agree', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'anchor', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'choose', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$ExtraProfileSubmitLabelsAccepted = F2(
	function (acceptedOn, label) {
		return {acceptedOn: acceptedOn, label: label};
	});
var $author$project$Profile$Flags$extraProfileSubmitLabelsAcceptedDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Profile$Flags$ExtraProfileSubmitLabelsAccepted,
	A2($elm$json$Json$Decode$field, 'accepted_on', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$ExtraProfileSubmitLabelsAddBundle = F2(
	function (description, label) {
		return {description: description, label: label};
	});
var $author$project$Profile$Flags$extraProfileSubmitLabelsAddBundleDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Profile$Flags$ExtraProfileSubmitLabelsAddBundle,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$ExtraProfileSubmitLabelsAddMember = F2(
	function (description, label) {
		return {description: description, label: label};
	});
var $author$project$Profile$Flags$extraProfileSubmitLabelsAddMemberDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Profile$Flags$ExtraProfileSubmitLabelsAddMember,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$ExtraProfileSubmitLabelsAddTopic = F2(
	function (description, label) {
		return {description: description, label: label};
	});
var $author$project$Profile$Flags$extraProfileSubmitLabelsAddTopicDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Profile$Flags$ExtraProfileSubmitLabelsAddTopic,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$ExtraProfileSubmitLabelsHomebundle = F2(
	function (description, label) {
		return {description: description, label: label};
	});
var $author$project$Profile$Flags$extraProfileSubmitLabelsHomebundleDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Profile$Flags$ExtraProfileSubmitLabelsHomebundle,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$ExtraProfileSubmitLabelsHometopic = F2(
	function (description, label) {
		return {description: description, label: label};
	});
var $author$project$Profile$Flags$extraProfileSubmitLabelsHometopicDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Profile$Flags$ExtraProfileSubmitLabelsHometopic,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$ExtraProfileSubmitLabelsHometopiclist = F2(
	function (description, label) {
		return {description: description, label: label};
	});
var $author$project$Profile$Flags$extraProfileSubmitLabelsHometopiclistDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Profile$Flags$ExtraProfileSubmitLabelsHometopiclist,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$ExtraProfileSubmitLabelsNext = F2(
	function (description, title) {
		return {description: description, title: title};
	});
var $author$project$Profile$Flags$extraProfileSubmitLabelsNextDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Profile$Flags$ExtraProfileSubmitLabelsNext,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'title', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$ExtraProfileSubmitLabelsProfile = function (initial) {
	return {initial: initial};
};
var $author$project$Profile$Flags$extraProfileSubmitLabelsProfileDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Profile$Flags$ExtraProfileSubmitLabelsProfile,
	A2($elm$json$Json$Decode$field, 'initial', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$ExtraProfileSubmitLabelsSubmit = F6(
	function (changed, failed, label, unchanged, updated, width) {
		return {changed: changed, failed: failed, label: label, unchanged: unchanged, updated: updated, width: width};
	});
var $author$project$Profile$Flags$extraProfileSubmitLabelsSubmitDecoder = A7(
	$elm$json$Json$Decode$map6,
	$author$project$Profile$Flags$ExtraProfileSubmitLabelsSubmit,
	A2($elm$json$Json$Decode$field, 'changed', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'failed', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'unchanged', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'updated', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$ExtraProfileSubmitLabelsTitle = function (label) {
	return {label: label};
};
var $author$project$Profile$Flags$extraProfileSubmitLabelsTitleDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Profile$Flags$ExtraProfileSubmitLabelsTitle,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$ExtraProfileSubmitLabelsUserbase = function (initial) {
	return {initial: initial};
};
var $author$project$Profile$Flags$extraProfileSubmitLabelsUserbaseDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Profile$Flags$ExtraProfileSubmitLabelsUserbase,
	A2($elm$json$Json$Decode$field, 'initial', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$extraProfileSubmitLabelsDecoder = function () {
	var fieldSet0 = A9(
		$elm$json$Json$Decode$map8,
		$author$project$Profile$Flags$ExtraProfileSubmitLabels,
		A2($elm$json$Json$Decode$field, 'accept', $author$project$Profile$Flags$extraProfileSubmitLabelsAcceptDecoder),
		A2($elm$json$Json$Decode$field, 'accepted', $author$project$Profile$Flags$extraProfileSubmitLabelsAcceptedDecoder),
		A2($elm$json$Json$Decode$field, 'add_bundle', $author$project$Profile$Flags$extraProfileSubmitLabelsAddBundleDecoder),
		A2($elm$json$Json$Decode$field, 'add_member', $author$project$Profile$Flags$extraProfileSubmitLabelsAddMemberDecoder),
		A2($elm$json$Json$Decode$field, 'add_topic', $author$project$Profile$Flags$extraProfileSubmitLabelsAddTopicDecoder),
		A2($elm$json$Json$Decode$field, 'homebundle', $author$project$Profile$Flags$extraProfileSubmitLabelsHomebundleDecoder),
		A2($elm$json$Json$Decode$field, 'hometopic', $author$project$Profile$Flags$extraProfileSubmitLabelsHometopicDecoder),
		A2($elm$json$Json$Decode$field, 'hometopiclist', $author$project$Profile$Flags$extraProfileSubmitLabelsHometopiclistDecoder));
	return A7(
		$elm$json$Json$Decode$map6,
		$elm$core$Basics$apL,
		fieldSet0,
		A2($elm$json$Json$Decode$field, 'next', $author$project$Profile$Flags$extraProfileSubmitLabelsNextDecoder),
		A2($elm$json$Json$Decode$field, 'profile', $author$project$Profile$Flags$extraProfileSubmitLabelsProfileDecoder),
		A2($elm$json$Json$Decode$field, 'submit', $author$project$Profile$Flags$extraProfileSubmitLabelsSubmitDecoder),
		A2($elm$json$Json$Decode$field, 'title', $author$project$Profile$Flags$extraProfileSubmitLabelsTitleDecoder),
		A2($elm$json$Json$Decode$field, 'userbase', $author$project$Profile$Flags$extraProfileSubmitLabelsUserbaseDecoder));
}();
var $author$project$Profile$Flags$ExtraProfileSubmitRequests = function (submit) {
	return {submit: submit};
};
var $author$project$Profile$Flags$extraProfileSubmitRequestsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Profile$Flags$ExtraProfileSubmitRequests,
	A2($elm$json$Json$Decode$field, 'submit', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$ExtraProfileSubmitTransitions = F7(
	function (addBundle, addMember, addTopic, bundle, topic, topiclist, update) {
		return {addBundle: addBundle, addMember: addMember, addTopic: addTopic, bundle: bundle, topic: topic, topiclist: topiclist, update: update};
	});
var $author$project$Profile$Flags$extraProfileSubmitTransitionsDecoder = A8(
	$elm$json$Json$Decode$map7,
	$author$project$Profile$Flags$ExtraProfileSubmitTransitions,
	A2($elm$json$Json$Decode$field, 'add_bundle', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'add_member', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'add_topic', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'bundle', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'topic', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'topiclist', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'update', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$extraProfileSubmitDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Profile$Flags$ExtraProfileSubmit,
	A2($elm$json$Json$Decode$field, 'labels', $author$project$Profile$Flags$extraProfileSubmitLabelsDecoder),
	A2($elm$json$Json$Decode$field, 'requests', $author$project$Profile$Flags$extraProfileSubmitRequestsDecoder),
	A2($elm$json$Json$Decode$field, 'transitions', $author$project$Profile$Flags$extraProfileSubmitTransitionsDecoder));
var $author$project$Profile$Flags$ExtraProfileUserbase = F3(
	function (errors, initial, labels) {
		return {errors: errors, initial: initial, labels: labels};
	});
var $author$project$Profile$Flags$ExtraProfileUserbaseErrors = F4(
	function (confirm, currentPassword, newPassword, username) {
		return {confirm: confirm, currentPassword: currentPassword, newPassword: newPassword, username: username};
	});
var $author$project$Profile$Flags$ExtraProfileUserbaseErrorsConfirm = F3(
	function (doNotMatch, required, syntax) {
		return {doNotMatch: doNotMatch, required: required, syntax: syntax};
	});
var $author$project$Profile$Flags$extraProfileUserbaseErrorsConfirmDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Profile$Flags$ExtraProfileUserbaseErrorsConfirm,
	A2($elm$json$Json$Decode$field, 'do_not_match', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'required', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'syntax', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$ExtraProfileUserbaseErrorsCurrentPassword = F2(
	function (required, syntax) {
		return {required: required, syntax: syntax};
	});
var $author$project$Profile$Flags$extraProfileUserbaseErrorsCurrentPasswordDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Profile$Flags$ExtraProfileUserbaseErrorsCurrentPassword,
	A2($elm$json$Json$Decode$field, 'required', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'syntax', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$ExtraProfileUserbaseErrorsNewPassword = F2(
	function (required, syntax) {
		return {required: required, syntax: syntax};
	});
var $author$project$Profile$Flags$extraProfileUserbaseErrorsNewPasswordDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Profile$Flags$ExtraProfileUserbaseErrorsNewPassword,
	A2($elm$json$Json$Decode$field, 'required', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'syntax', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$ExtraProfileUserbaseErrorsUsername = F3(
	function (required, syntax, unique) {
		return {required: required, syntax: syntax, unique: unique};
	});
var $author$project$Profile$Flags$extraProfileUserbaseErrorsUsernameDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Profile$Flags$ExtraProfileUserbaseErrorsUsername,
	A2($elm$json$Json$Decode$field, 'required', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'syntax', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'unique', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$extraProfileUserbaseErrorsDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$Profile$Flags$ExtraProfileUserbaseErrors,
	A2($elm$json$Json$Decode$field, 'confirm', $author$project$Profile$Flags$extraProfileUserbaseErrorsConfirmDecoder),
	A2($elm$json$Json$Decode$field, 'current_password', $author$project$Profile$Flags$extraProfileUserbaseErrorsCurrentPasswordDecoder),
	A2($elm$json$Json$Decode$field, 'new_password', $author$project$Profile$Flags$extraProfileUserbaseErrorsNewPasswordDecoder),
	A2($elm$json$Json$Decode$field, 'username', $author$project$Profile$Flags$extraProfileUserbaseErrorsUsernameDecoder));
var $author$project$Profile$Flags$ExtraProfileUserbaseLabels = F6(
	function (confirm, currentPassword, error, newPassword, showPasswords, username) {
		return {confirm: confirm, currentPassword: currentPassword, error: error, newPassword: newPassword, showPasswords: showPasswords, username: username};
	});
var $author$project$Profile$Flags$ExtraProfileUserbaseLabelsConfirm = F3(
	function (description, label, placeholder) {
		return {description: description, label: label, placeholder: placeholder};
	});
var $author$project$Profile$Flags$extraProfileUserbaseLabelsConfirmDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Profile$Flags$ExtraProfileUserbaseLabelsConfirm,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'placeholder', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$ExtraProfileUserbaseLabelsCurrentPassword = F4(
	function (description, label, placeholder, visible) {
		return {description: description, label: label, placeholder: placeholder, visible: visible};
	});
var $author$project$Profile$Flags$extraProfileUserbaseLabelsCurrentPasswordDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$Profile$Flags$ExtraProfileUserbaseLabelsCurrentPassword,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'placeholder', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'visible', $elm$json$Json$Decode$bool));
var $author$project$Profile$Flags$ExtraProfileUserbaseLabelsError = function (mismatch) {
	return {mismatch: mismatch};
};
var $author$project$Profile$Flags$extraProfileUserbaseLabelsErrorDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Profile$Flags$ExtraProfileUserbaseLabelsError,
	A2($elm$json$Json$Decode$field, 'mismatch', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$ExtraProfileUserbaseLabelsNewPassword = F3(
	function (description, label, placeholder) {
		return {description: description, label: label, placeholder: placeholder};
	});
var $author$project$Profile$Flags$extraProfileUserbaseLabelsNewPasswordDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Profile$Flags$ExtraProfileUserbaseLabelsNewPassword,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'placeholder', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$ExtraProfileUserbaseLabelsShowPasswords = function (label) {
	return {label: label};
};
var $author$project$Profile$Flags$extraProfileUserbaseLabelsShowPasswordsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Profile$Flags$ExtraProfileUserbaseLabelsShowPasswords,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$ExtraProfileUserbaseLabelsUsername = F3(
	function (description, label, placeholder) {
		return {description: description, label: label, placeholder: placeholder};
	});
var $author$project$Profile$Flags$extraProfileUserbaseLabelsUsernameDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Profile$Flags$ExtraProfileUserbaseLabelsUsername,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'placeholder', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$extraProfileUserbaseLabelsDecoder = A7(
	$elm$json$Json$Decode$map6,
	$author$project$Profile$Flags$ExtraProfileUserbaseLabels,
	A2($elm$json$Json$Decode$field, 'confirm', $author$project$Profile$Flags$extraProfileUserbaseLabelsConfirmDecoder),
	A2($elm$json$Json$Decode$field, 'current_password', $author$project$Profile$Flags$extraProfileUserbaseLabelsCurrentPasswordDecoder),
	A2($elm$json$Json$Decode$field, 'error', $author$project$Profile$Flags$extraProfileUserbaseLabelsErrorDecoder),
	A2($elm$json$Json$Decode$field, 'new_password', $author$project$Profile$Flags$extraProfileUserbaseLabelsNewPasswordDecoder),
	A2($elm$json$Json$Decode$field, 'show_passwords', $author$project$Profile$Flags$extraProfileUserbaseLabelsShowPasswordsDecoder),
	A2($elm$json$Json$Decode$field, 'username', $author$project$Profile$Flags$extraProfileUserbaseLabelsUsernameDecoder));
var $author$project$Profile$Flags$extraProfileUserbaseDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Profile$Flags$ExtraProfileUserbase,
	A2($elm$json$Json$Decode$field, 'errors', $author$project$Profile$Flags$extraProfileUserbaseErrorsDecoder),
	A2($elm$json$Json$Decode$field, 'initial', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'labels', $author$project$Profile$Flags$extraProfileUserbaseLabelsDecoder));
var $author$project$Profile$Flags$ExtraProfileView = F2(
	function (initial, labels) {
		return {initial: initial, labels: labels};
	});
var $author$project$Profile$Flags$ExtraProfileViewLabels = function (preview) {
	return {preview: preview};
};
var $author$project$Profile$Flags$ExtraProfileViewLabelsPreview = F5(
	function (engagementHost, guest, paragraph, subtitle, title) {
		return {engagementHost: engagementHost, guest: guest, paragraph: paragraph, subtitle: subtitle, title: title};
	});
var $author$project$Profile$Flags$extraProfileViewLabelsPreviewDecoder = A6(
	$elm$json$Json$Decode$map5,
	$author$project$Profile$Flags$ExtraProfileViewLabelsPreview,
	A2($elm$json$Json$Decode$field, 'engagement_host', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'guest', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'paragraph', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'subtitle', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'title', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$extraProfileViewLabelsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Profile$Flags$ExtraProfileViewLabels,
	A2($elm$json$Json$Decode$field, 'preview', $author$project$Profile$Flags$extraProfileViewLabelsPreviewDecoder));
var $author$project$Profile$Flags$extraProfileViewDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Profile$Flags$ExtraProfileView,
	A2($elm$json$Json$Decode$field, 'initial', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'labels', $author$project$Profile$Flags$extraProfileViewLabelsDecoder));
var $author$project$Profile$Flags$ExtraProgressView = function (labels) {
	return {labels: labels};
};
var $author$project$Profile$Flags$ExtraProgressViewLabels = F4(
	function (decodeErrors, diagnosticLogs, status, workflow) {
		return {decodeErrors: decodeErrors, diagnosticLogs: diagnosticLogs, status: status, workflow: workflow};
	});
var $author$project$Profile$Flags$ExtraProgressViewLabelsDecodeErrors = function (label) {
	return {label: label};
};
var $author$project$Profile$Flags$extraProgressViewLabelsDecodeErrorsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Profile$Flags$ExtraProgressViewLabelsDecodeErrors,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$ExtraProgressViewLabelsDiagnosticLogs = function (label) {
	return {label: label};
};
var $author$project$Profile$Flags$extraProgressViewLabelsDiagnosticLogsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Profile$Flags$ExtraProgressViewLabelsDiagnosticLogs,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$ExtraProgressViewLabelsStatus = F2(
	function (failure, success) {
		return {failure: failure, success: success};
	});
var $author$project$Profile$Flags$extraProgressViewLabelsStatusDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Profile$Flags$ExtraProgressViewLabelsStatus,
	A2($elm$json$Json$Decode$field, 'failure', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'success', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$ExtraProgressViewLabelsWorkflow = function (label) {
	return {label: label};
};
var $author$project$Profile$Flags$extraProgressViewLabelsWorkflowDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Profile$Flags$ExtraProgressViewLabelsWorkflow,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$extraProgressViewLabelsDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$Profile$Flags$ExtraProgressViewLabels,
	A2($elm$json$Json$Decode$field, 'decode_errors', $author$project$Profile$Flags$extraProgressViewLabelsDecodeErrorsDecoder),
	A2($elm$json$Json$Decode$field, 'diagnostic_logs', $author$project$Profile$Flags$extraProgressViewLabelsDiagnosticLogsDecoder),
	A2($elm$json$Json$Decode$field, 'status', $author$project$Profile$Flags$extraProgressViewLabelsStatusDecoder),
	A2($elm$json$Json$Decode$field, 'workflow', $author$project$Profile$Flags$extraProgressViewLabelsWorkflowDecoder));
var $author$project$Profile$Flags$extraProgressViewDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Profile$Flags$ExtraProgressView,
	A2($elm$json$Json$Decode$field, 'labels', $author$project$Profile$Flags$extraProgressViewLabelsDecoder));
var $author$project$Profile$Flags$extraDecoder = function () {
	var fieldSet0 = A9(
		$elm$json$Json$Decode$map8,
		$author$project$Profile$Flags$Extra,
		A2($elm$json$Json$Decode$field, 'mode', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'module', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'months', $author$project$Profile$Flags$extraMonthsDecoder),
		A2($elm$json$Json$Decode$field, 'profile_details', $author$project$Profile$Flags$extraProfileDetailsDecoder),
		A2($elm$json$Json$Decode$field, 'profile_submit', $author$project$Profile$Flags$extraProfileSubmitDecoder),
		A2($elm$json$Json$Decode$field, 'profile_userbase', $author$project$Profile$Flags$extraProfileUserbaseDecoder),
		A2($elm$json$Json$Decode$field, 'profile_view', $author$project$Profile$Flags$extraProfileViewDecoder),
		A2($elm$json$Json$Decode$field, 'progress_view', $author$project$Profile$Flags$extraProgressViewDecoder));
	return A3(
		$elm$json$Json$Decode$map2,
		$elm$core$Basics$apL,
		fieldSet0,
		A2(
			$elm$json$Json$Decode$field,
			'view_nodes',
			$elm$json$Json$Decode$list($elm$json$Json$Decode$string)));
}();
var $author$project$Profile$Flags$FlagsConfig = F3(
	function (baseUrl, defaultLanguage, extra) {
		return {baseUrl: baseUrl, defaultLanguage: defaultLanguage, extra: extra};
	});
var $author$project$Profile$Flags$FlagsConfigExtra = F4(
	function (dev, originCollab, originReview, title) {
		return {dev: dev, originCollab: originCollab, originReview: originReview, title: title};
	});
var $author$project$Profile$Flags$flagsConfigExtraDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$Profile$Flags$FlagsConfigExtra,
	A2($elm$json$Json$Decode$field, 'dev', $elm$json$Json$Decode$bool),
	A2($elm$json$Json$Decode$field, 'origin_collab', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'origin_review', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'title', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$flagsConfigDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Profile$Flags$FlagsConfig,
	A2($elm$json$Json$Decode$field, 'base_url', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'default_language', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'extra', $author$project$Profile$Flags$flagsConfigExtraDecoder));
var $author$project$Profile$Flags$FlagsWorkflowsObject = F3(
	function (name, label, progress) {
		return {label: label, name: name, progress: progress};
	});
var $author$project$Profile$Flags$FlagsWorkflowsObjectProgressObject = F2(
	function (display, messages) {
		return {display: display, messages: messages};
	});
var $author$project$Profile$Flags$FlagsWorkflowsObjectProgressObjectDisplay = F7(
	function (error, error2, init, ok, ok2, skip, skip2) {
		return {error: error, error2: error2, init: init, ok: ok, ok2: ok2, skip: skip, skip2: skip2};
	});
var $author$project$Profile$Flags$flagsWorkflowsObjectProgressObjectDisplayDecoder = A8(
	$elm$json$Json$Decode$map7,
	$author$project$Profile$Flags$FlagsWorkflowsObjectProgressObjectDisplay,
	A2($elm$json$Json$Decode$field, 'error', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'error2', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'init', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'ok', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'ok2', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'skip', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'skip2', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$FlagsWorkflowsObjectProgressObjectMessages = F2(
	function (error, ok) {
		return {error: error, ok: ok};
	});
var $author$project$Profile$Flags$flagsWorkflowsObjectProgressObjectMessagesDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Profile$Flags$FlagsWorkflowsObjectProgressObjectMessages,
	A2($elm$json$Json$Decode$field, 'error', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'ok', $elm$json$Json$Decode$string));
var $author$project$Profile$Flags$flagsWorkflowsObjectProgressObjectDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Profile$Flags$FlagsWorkflowsObjectProgressObject,
	A2($elm$json$Json$Decode$field, 'display', $author$project$Profile$Flags$flagsWorkflowsObjectProgressObjectDisplayDecoder),
	A2($elm$json$Json$Decode$field, 'messages', $author$project$Profile$Flags$flagsWorkflowsObjectProgressObjectMessagesDecoder));
var $author$project$Profile$Flags$flagsWorkflowsObjectDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Profile$Flags$FlagsWorkflowsObject,
	A2($elm$json$Json$Decode$field, 'name', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2(
		$elm$json$Json$Decode$field,
		'progress',
		$elm$json$Json$Decode$list($author$project$Profile$Flags$flagsWorkflowsObjectProgressObjectDecoder)));
var $author$project$Profile$Flags$flagsDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Profile$Flags$Flags,
	A2($elm$json$Json$Decode$field, 'config', $author$project$Profile$Flags$flagsConfigDecoder),
	A2($elm$json$Json$Decode$field, 'extra', $author$project$Profile$Flags$extraDecoder),
	A2(
		$elm$json$Json$Decode$field,
		'workflows',
		$elm$json$Json$Decode$list($author$project$Profile$Flags$flagsWorkflowsObjectDecoder)));
var $author$project$Profile$Flags$jsonToResultFlags = function (json) {
	return A2(
		$elm$core$Result$mapError,
		$elm$json$Json$Decode$errorToString,
		A2($elm$json$Json$Decode$decodeValue, $author$project$Profile$Flags$flagsDecoder, json));
};
var $author$project$Profile$Model$ProgressMsg = function (a) {
	return {$: 'ProgressMsg', a: a};
};
var $author$project$Profile$progressCmds = function (pcmds) {
	return A2($elm$core$Platform$Cmd$map, $author$project$Profile$Model$ProgressMsg, pcmds);
};
var $author$project$Profile$progressFlags = function (flags) {
	return {labels: flags.extra.progressView.labels, workflows: flags.workflows};
};
var $author$project$Profile$Model$UserbaseMsg = function (a) {
	return {$: 'UserbaseMsg', a: a};
};
var $author$project$Profile$userbaseCmds = function (ucmds) {
	return A2($elm$core$Platform$Cmd$map, $author$project$Profile$Model$UserbaseMsg, ucmds);
};
var $author$project$Profile$userbaseFlags = function (flags) {
	return {errors: flags.extra.profileUserbase.errors, labels: flags.extra.profileUserbase.labels};
};
var $author$project$Profile$init = function (value) {
	var _v0 = $author$project$Profile$Flags$jsonToResultFlags(value);
	if (_v0.$ === 'Err') {
		var err = _v0.a;
		return _Utils_Tuple2(
			$author$project$Profile$Model$Failed(err),
			$elm$core$Platform$Cmd$none);
	} else {
		var flags = _v0.a;
		var _v1 = $author$project$ProfileUserbase$Model$init(
			$author$project$Profile$userbaseFlags(flags));
		var ustate = _v1.a;
		var ucmds = _v1.b;
		var _v2 = $author$project$Progress$Model$init(
			$author$project$Profile$progressFlags(flags));
		var pstate = _v2.a;
		var pcmds = _v2.b;
		var _v3 = $author$project$ProfileDetails$Model$init(
			$author$project$Profile$detailsFlags(flags));
		var dstate = _v3.a;
		var dcmds = _v3.b;
		return _Utils_Tuple2(
			A2(
				$author$project$Profile$Model$Loaded,
				flags,
				{auth: $krisajenkins$remotedata$RemoteData$NotAsked, bundles: $elm$core$Dict$empty, details: dstate, progress: pstate, result: $krisajenkins$remotedata$RemoteData$NotAsked, topics: $elm$core$Dict$empty, userbase: ustate}),
			$elm$core$Platform$Cmd$batch(
				_List_fromArray(
					[
						$author$project$Profile$detailsCmds(dcmds),
						$author$project$Profile$userbaseCmds(ucmds),
						$author$project$Profile$progressCmds(pcmds)
					])));
	}
};
var $author$project$Profile$Model$Incoming = function (a) {
	return {$: 'Incoming', a: a};
};
var $author$project$Profile$subscriptions = function (model) {
	return $author$project$Shared$Ports$toElm($author$project$Profile$Model$Incoming);
};
var $author$project$Profile$Model$Accepted = F2(
	function (a, b) {
		return {$: 'Accepted', a: a, b: b};
	});
var $author$project$ProfileUserbase$Model$IncomingAuth = function (a) {
	return {$: 'IncomingAuth', a: a};
};
var $author$project$ProfileDetails$Model$IncomingProfileData = function (a) {
	return {$: 'IncomingProfileData', a: a};
};
var $author$project$ProfileDetails$Model$IncomingProfileUnique = function (a) {
	return {$: 'IncomingProfileUnique', a: a};
};
var $author$project$ProfileUserbase$Model$IncomingUserbase = function (a) {
	return {$: 'IncomingUserbase', a: a};
};
var $author$project$ProfileDetails$Model$UpdateAccepted = function (a) {
	return {$: 'UpdateAccepted', a: a};
};
var $author$project$ProfileDetails$Model$UpdateOk = {$: 'UpdateOk'};
var $author$project$ProfileData$Model$profileDataChanged = F2(
	function (initial, current) {
		if (initial.$ === 'Nothing') {
			return true;
		} else {
			var data = initial.a;
			return false || ((!_Utils_eq(data.thumbnail, current.thumbnail)) || ((!_Utils_eq(data.initials, current.initials)) || ((!_Utils_eq(data.title, current.title)) || ((!_Utils_eq(data.subtitle, current.subtitle)) || ((!_Utils_eq(data.paragraph, current.paragraph)) || ((!_Utils_eq(data.moniker, current.moniker)) || ((!_Utils_eq(data.accepted_on, current.accepted_on)) || (!_Utils_eq(data.home, current.home)))))))));
		}
	});
var $author$project$ProfileData$Encode$profileDataToValue = function (profile) {
	var encodeTitle = _List_fromArray(
		[
			_Utils_Tuple2(
			'title',
			$elm$json$Json$Encode$string(profile.title))
		]);
	var encodeThumbnail = function () {
		var _v5 = profile.thumbnail;
		if (_v5.$ === 'Just') {
			var s = _v5.a;
			return _List_fromArray(
				[
					_Utils_Tuple2(
					'thumbnail',
					$elm$json$Json$Encode$string(s))
				]);
		} else {
			return _List_Nil;
		}
	}();
	var encodeSubtitle = function () {
		var _v4 = profile.subtitle;
		if (_v4.$ === 'Just') {
			var s = _v4.a;
			return _List_fromArray(
				[
					_Utils_Tuple2(
					'subtitle',
					$elm$json$Json$Encode$string(s))
				]);
		} else {
			return _List_Nil;
		}
	}();
	var encodeParagraph = function () {
		var _v3 = profile.paragraph;
		if (_v3.$ === 'Just') {
			var s = _v3.a;
			return _List_fromArray(
				[
					_Utils_Tuple2(
					'paragraph',
					$elm$json$Json$Encode$string(s))
				]);
		} else {
			return _List_Nil;
		}
	}();
	var encodeMoniker = _List_fromArray(
		[
			_Utils_Tuple2(
			'moniker',
			$elm$json$Json$Encode$string(profile.moniker))
		]);
	var encodeKind = _List_fromArray(
		[
			_Utils_Tuple2(
			'kind',
			$elm$json$Json$Encode$string('profile'))
		]);
	var encodeInitials = _List_fromArray(
		[
			_Utils_Tuple2(
			'initials',
			$elm$json$Json$Encode$string(profile.initials))
		]);
	var encodeHomeTopic = function (tkey) {
		return _List_fromArray(
			[
				_Utils_Tuple2(
				'kind',
				$elm$json$Json$Encode$string('home topic')),
				_Utils_Tuple2(
				'tkey',
				$elm$json$Json$Encode$string(tkey))
			]);
	};
	var encodeHomeBundle = function (bnum) {
		return _List_fromArray(
			[
				_Utils_Tuple2(
				'kind',
				$elm$json$Json$Encode$string('home bundle')),
				_Utils_Tuple2(
				'bnum',
				$elm$json$Json$Encode$int(bnum))
			]);
	};
	var encodeHome = function () {
		var _v0 = _Utils_Tuple3(profile.home.page, profile.home.tkey, profile.home.bnum);
		_v0$2:
		while (true) {
			switch (_v0.a.$) {
				case 'Topic':
					if (_v0.b.$ === 'Just') {
						var _v1 = _v0.a;
						var tkey = _v0.b.a;
						return _List_fromArray(
							[
								_Utils_Tuple2(
								'home',
								$elm$json$Json$Encode$object(
									encodeHomeTopic(tkey)))
							]);
					} else {
						break _v0$2;
					}
				case 'Bundle':
					if (_v0.c.$ === 'Just') {
						var _v2 = _v0.a;
						var bnum = _v0.c.a;
						return _List_fromArray(
							[
								_Utils_Tuple2(
								'home',
								$elm$json$Json$Encode$object(
									encodeHomeBundle(bnum)))
							]);
					} else {
						break _v0$2;
					}
				default:
					break _v0$2;
			}
		}
		return _List_Nil;
	}();
	var encodeAcceptedOn = _List_fromArray(
		[
			_Utils_Tuple2(
			'accepted_on',
			$elm$json$Json$Encode$int(
				$elm$time$Time$posixToMillis(profile.accepted_on)))
		]);
	var encoders = _Utils_ap(
		_List_Nil,
		_Utils_ap(
			encodeKind,
			_Utils_ap(
				encodeThumbnail,
				_Utils_ap(
					encodeMoniker,
					_Utils_ap(
						encodeInitials,
						_Utils_ap(
							encodeTitle,
							_Utils_ap(
								encodeSubtitle,
								_Utils_ap(
									encodeParagraph,
									_Utils_ap(encodeAcceptedOn, encodeHome)))))))));
	return $elm$json$Json$Encode$object(encoders);
};
var $author$project$Userbase$Encode$userbaseToValue = F2(
	function (includeCurrentPassword, userbase) {
		var encodeUsername = _List_fromArray(
			[
				_Utils_Tuple2(
				'username',
				$elm$json$Json$Encode$string(userbase.username))
			]);
		var encodeNewPasswordAsPassword = _List_fromArray(
			[
				_Utils_Tuple2(
				'password',
				$elm$json$Json$Encode$string(userbase.newPassword))
			]);
		var encodeNewPassword = _List_fromArray(
			[
				_Utils_Tuple2(
				'newPassword',
				$elm$json$Json$Encode$string(userbase.newPassword))
			]);
		var encodeCurrentPassword = _List_fromArray(
			[
				_Utils_Tuple2(
				'currentPassword',
				$elm$json$Json$Encode$string(userbase.password))
			]);
		var encoders = includeCurrentPassword ? _Utils_ap(
			_List_Nil,
			_Utils_ap(
				encodeUsername,
				_Utils_ap(encodeCurrentPassword, encodeNewPassword))) : _Utils_ap(
			_List_Nil,
			_Utils_ap(encodeUsername, encodeNewPasswordAsPassword));
		return $elm$json$Json$Encode$object(encoders);
	});
var $author$project$Profile$cmdSubmitRequest = F2(
	function (flags, state) {
		var ps = flags.extra.profileSubmit;
		var newstate = _Utils_update(
			state,
			{result: $krisajenkins$remotedata$RemoteData$Loading});
		var includeCurrentPassword = function (x) {
			return x;
		}(flags.extra.profileUserbase.labels.currentPassword.visible);
		var encodeUserbase = A3($author$project$Userbase$Model$userbaseChanged, includeCurrentPassword, state.userbase.initial, state.userbase.current) ? _List_fromArray(
			[
				_Utils_Tuple2(
				'userbase',
				A2($author$project$Userbase$Encode$userbaseToValue, includeCurrentPassword, state.userbase.current))
			]) : _List_Nil;
		var encodeProfile = A2($author$project$ProfileData$Model$profileDataChanged, state.details.initial, state.details.current) ? _List_fromArray(
			[
				_Utils_Tuple2(
				'profile',
				$author$project$ProfileData$Encode$profileDataToValue(state.details.current))
			]) : _List_Nil;
		var encodeKind = _List_fromArray(
			[
				_Utils_Tuple2(
				'kind',
				$elm$json$Json$Encode$string(ps.requests.submit))
			]);
		var encoders = _Utils_ap(
			_List_Nil,
			_Utils_ap(
				encodeKind,
				_Utils_ap(encodeProfile, encodeUserbase)));
		var request = $elm$json$Json$Encode$object(encoders);
		return _Utils_Tuple2(
			A2($author$project$Profile$Model$Loaded, flags, newstate),
			$author$project$Shared$Ports$toMain(request));
	});
var $author$project$ProfileDetails$Model$profileErr = function (problems) {
	return $elm_community$maybe_extra$Maybe$Extra$orList(
		_List_fromArray(
			[problems.currentErr, problems.initialsErr, problems.titleErr, problems.monikerErr]));
};
var $author$project$Profile$View$somethingChanged = F2(
	function (flags, state) {
		var includeCurrentPassword = flags.extra.profileUserbase.labels.currentPassword.visible;
		return A2($author$project$ProfileData$Model$profileDataChanged, state.details.initial, state.details.current) ? true : (A3($author$project$Userbase$Model$userbaseChanged, includeCurrentPassword, state.userbase.initial, state.userbase.current) ? true : false);
	});
var $author$project$ProfileUserbase$Model$userbaseErr = function (problems) {
	return $elm_community$maybe_extra$Maybe$Extra$orList(
		_List_fromArray(
			[problems.usernameErr, problems.passwordErr, problems.newPasswordErr, problems.confirmErr]));
};
var $author$project$Profile$View$currentError = F2(
	function (flags, state) {
		var ps = flags.extra.profileSubmit;
		var emsg = $elm_community$maybe_extra$Maybe$Extra$orList(
			_List_fromArray(
				[
					$author$project$ProfileDetails$Model$profileErr(state.details.problems),
					$author$project$ProfileUserbase$Model$userbaseErr(state.userbase.problems)
				]));
		var changed = A2($author$project$Profile$View$somethingChanged, flags, state);
		var _v0 = _Utils_Tuple3(emsg, changed, state.result);
		_v0$1:
		while (true) {
			if (_v0.a.$ === 'Just') {
				var x = _v0.a.a;
				return $elm$core$Result$Err(x);
			} else {
				switch (_v0.c.$) {
					case 'Failure':
						if (_v0.b) {
							break _v0$1;
						} else {
							var _v2 = _v0.a;
							var err = _v0.c.a;
							return $elm$core$Result$Err(err);
						}
					case 'Success':
						if (_v0.b) {
							break _v0$1;
						} else {
							var _v3 = _v0.a;
							return $elm$core$Result$Ok(ps.labels.submit.updated);
						}
					default:
						if (_v0.b) {
							break _v0$1;
						} else {
							var _v4 = _v0.a;
							return $elm$core$Result$Ok(ps.labels.submit.unchanged);
						}
				}
			}
		}
		var _v1 = _v0.a;
		return $elm$core$Result$Ok(ps.labels.submit.changed);
	});
var $author$project$Profile$View$okToSubmit = F2(
	function (flags, state) {
		return true && (A2($author$project$Profile$View$somethingChanged, flags, state) && ($elm_community$result_extra$Result$Extra$isOk(
			A2($author$project$Profile$View$currentError, flags, state)) && (!_Utils_eq(state.result, $krisajenkins$remotedata$RemoteData$Loading))));
	});
var $author$project$ProfileDetails$Model$GotFile = function (a) {
	return {$: 'GotFile', a: a};
};
var $author$project$ProfileDetails$Model$GotPreview = function (a) {
	return {$: 'GotPreview', a: a};
};
var $elm$file$File$Select$file = F2(
	function (mimes, toMsg) {
		return A2(
			$elm$core$Task$perform,
			toMsg,
			_File_uploadOne(mimes));
	});
var $elm$file$File$toUrl = _File_toUrl;
var $author$project$ProfileDetails$Model$update = F3(
	function (flags, state, msg) {
		var problems = state.problems;
		var initial = state.initial;
		var current = state.current;
		switch (msg.$) {
			case 'RemoveThumbnail':
				var newstate = _Utils_update(
					state,
					{
						current: _Utils_update(
							current,
							{thumbnail: $elm$core$Maybe$Nothing})
					});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			case 'ChooseThumbnail':
				return _Utils_Tuple2(
					state,
					A2(
						$elm$file$File$Select$file,
						_List_fromArray(
							['image/*']),
						$author$project$ProfileDetails$Model$GotFile));
			case 'GotFile':
				var file = msg.a;
				return _Utils_Tuple2(
					state,
					A2(
						$elm$core$Task$perform,
						$author$project$ProfileDetails$Model$GotPreview,
						$elm$file$File$toUrl(file)));
			case 'GotPreview':
				var url = msg.a;
				var newstate = _Utils_update(
					state,
					{
						current: _Utils_update(
							current,
							{
								thumbnail: $elm$core$Maybe$Just(url)
							})
					});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			case 'UpdateThumbnail':
				var value = msg.a;
				var newstate = _Utils_update(
					state,
					{
						current: _Utils_update(
							current,
							{thumbnail: value})
					});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			case 'UpdateMoniker':
				var value = msg.a;
				var title = (_Utils_eq(initial, $elm$core$Maybe$Nothing) && _Utils_eq(current.title, current.moniker)) ? value : current.title;
				var initials = (_Utils_eq(initial, $elm$core$Maybe$Nothing) && _Utils_eq(current.initials, current.moniker)) ? value : current.initials;
				var newstate = _Utils_update(
					state,
					{
						current: _Utils_update(
							current,
							{initials: initials, moniker: value, title: title}),
						problems: _Utils_update(
							problems,
							{
								initialsErr: A3($author$project$ProfileData$Valid$initialsErr, flags.errors, state.runique, value),
								monikerErr: A3($author$project$ProfileData$Valid$monikerErr, flags.errors, state.runique, value),
								titleErr: A3($author$project$ProfileData$Valid$titleErr, flags.errors, state.runique, value)
							})
					});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			case 'UpdateInitials':
				var value = msg.a;
				var newstate = _Utils_update(
					state,
					{
						current: _Utils_update(
							current,
							{initials: value}),
						problems: _Utils_update(
							problems,
							{
								initialsErr: A3($author$project$ProfileData$Valid$initialsErr, flags.errors, state.runique, value)
							})
					});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			case 'UpdateTitle':
				var value = msg.a;
				var newstate = _Utils_update(
					state,
					{
						current: _Utils_update(
							current,
							{title: value}),
						problems: _Utils_update(
							problems,
							{
								titleErr: A3($author$project$ProfileData$Valid$titleErr, flags.errors, state.runique, value)
							})
					});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			case 'UpdateSubtitle':
				var value = msg.a;
				var newstate = _Utils_update(
					state,
					{
						current: _Utils_update(
							current,
							{subtitle: value})
					});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			case 'UpdateParagraph':
				var value = msg.a;
				var newstate = _Utils_update(
					state,
					{
						current: _Utils_update(
							current,
							{paragraph: value})
					});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			case 'ChooseHomeTopicList':
				var home = state.current.home;
				var newstate = _Utils_update(
					state,
					{
						current: _Utils_update(
							current,
							{
								home: _Utils_update(
									home,
									{page: $author$project$ProfileData$Model$TopicList})
							})
					});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			case 'ChooseHomeTopic':
				var mtkey = msg.a;
				var home = state.current.home;
				var newstate = _Utils_update(
					state,
					{
						current: _Utils_update(
							current,
							{
								home: _Utils_update(
									home,
									{page: $author$project$ProfileData$Model$Topic, tkey: mtkey})
							})
					});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			case 'ChooseHomeBundle':
				var mbnum = msg.a;
				var home = state.current.home;
				var newstate = _Utils_update(
					state,
					{
						current: _Utils_update(
							current,
							{
								home: _Utils_update(
									home,
									{bnum: mbnum, page: $author$project$ProfileData$Model$Bundle})
							})
					});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			case 'SelectTopic':
				var tkey = msg.a;
				var home = state.current.home;
				var newstate = _Utils_update(
					state,
					{
						current: _Utils_update(
							current,
							{
								home: _Utils_update(
									home,
									{
										tkey: $elm$core$Maybe$Just(tkey)
									})
							})
					});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			case 'SelectBundle':
				var sbnum = msg.a;
				var home = state.current.home;
				var newstate = function () {
					var _v1 = $elm$core$String$toInt(sbnum);
					if (_v1.$ === 'Just') {
						var bnum = _v1.a;
						return _Utils_update(
							state,
							{
								current: _Utils_update(
									current,
									{
										home: _Utils_update(
											home,
											{
												bnum: $elm$core$Maybe$Just(bnum)
											})
									})
							});
					} else {
						return state;
					}
				}();
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			case 'UpdateAccepted':
				var value = msg.a;
				var newstate = _Utils_update(
					state,
					{
						current: _Utils_update(
							current,
							{accepted_on: value})
					});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			case 'IncomingProfileUnique':
				var unique = msg.a;
				var newstate = _Utils_update(
					state,
					{
						runique: $krisajenkins$remotedata$RemoteData$Success(unique)
					});
				return _Utils_Tuple2(
					A2($author$project$ProfileDetails$Model$validateState, flags, newstate),
					$elm$core$Platform$Cmd$none);
			case 'IncomingProfileData':
				var profile = msg.a;
				var newstate = _Utils_update(
					state,
					{
						current: profile,
						initial: $elm$core$Maybe$Just(profile)
					});
				return _Utils_Tuple2(
					A2($author$project$ProfileDetails$Model$validateState, flags, newstate),
					$elm$core$Platform$Cmd$none);
			default:
				var newstate = _Utils_update(
					state,
					{
						initial: $elm$core$Maybe$Just(current)
					});
				return _Utils_Tuple2(
					A2($author$project$ProfileDetails$Model$validateState, flags, newstate),
					$elm$core$Platform$Cmd$none);
		}
	});
var $author$project$Profile$updateStateCmds = F3(
	function (flags, cmds, state) {
		return _Utils_Tuple2(
			A2($author$project$Profile$Model$Loaded, flags, state),
			cmds);
	});
var $author$project$Profile$updateDetails = F3(
	function (flags, dmsg, state) {
		var _v0 = A3(
			$author$project$ProfileDetails$Model$update,
			$author$project$Profile$detailsFlags(flags),
			state.details,
			dmsg);
		var dstate = _v0.a;
		var dcmds = _v0.b;
		return A3(
			$author$project$Profile$updateStateCmds,
			flags,
			$author$project$Profile$detailsCmds(dcmds),
			_Utils_update(
				state,
				{details: dstate}));
	});
var $author$project$Profile$updateProgress = F3(
	function (flags, pmsg, state) {
		var _v0 = A3(
			$author$project$Progress$Model$update,
			$author$project$Profile$progressFlags(flags),
			state.progress,
			pmsg);
		var pstate = _v0.a;
		var pcmds = _v0.b;
		return A3(
			$author$project$Profile$updateStateCmds,
			flags,
			$author$project$Profile$progressCmds(pcmds),
			_Utils_update(
				state,
				{progress: pstate}));
	});
var $author$project$Profile$updateState = F2(
	function (flags, state) {
		return A3($author$project$Profile$updateStateCmds, flags, $elm$core$Platform$Cmd$none, state);
	});
var $elm$core$String$toLower = _String_toLower;
var $author$project$ProfileUserbase$Model$update = F3(
	function (flags, state, msg) {
		var problems = state.problems;
		var current = state.current;
		switch (msg.$) {
			case 'UpdateUsername':
				var value = msg.a;
				var newstate = _Utils_update(
					state,
					{
						current: _Utils_update(
							current,
							{
								username: $elm$core$String$toLower(value)
							})
					});
				return _Utils_Tuple2(
					A2($author$project$ProfileUserbase$Model$validateState, flags, newstate),
					$elm$core$Platform$Cmd$none);
			case 'UpdateShowPasswords':
				var value = msg.a;
				var newstate = _Utils_update(
					state,
					{showPasswords: value});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			case 'UpdatePassword':
				var value = msg.a;
				var newstate = _Utils_update(
					state,
					{
						current: _Utils_update(
							current,
							{password: value})
					});
				return _Utils_Tuple2(
					A2($author$project$ProfileUserbase$Model$validateState, flags, newstate),
					$elm$core$Platform$Cmd$none);
			case 'UpdateNewPassword':
				var value = msg.a;
				var newstate = _Utils_update(
					state,
					{
						current: _Utils_update(
							current,
							{newPassword: value})
					});
				return _Utils_Tuple2(
					A2($author$project$ProfileUserbase$Model$validateState, flags, newstate),
					$elm$core$Platform$Cmd$none);
			case 'UpdateConfirm':
				var value = msg.a;
				var newstate = _Utils_update(
					state,
					{
						current: _Utils_update(
							current,
							{confirm: value})
					});
				return _Utils_Tuple2(
					A2($author$project$ProfileUserbase$Model$validateState, flags, newstate),
					$elm$core$Platform$Cmd$none);
			case 'IncomingAuth':
				var auth = msg.a;
				var newstate = _Utils_update(
					state,
					{
						auth: $elm$core$Maybe$Just(auth)
					});
				return _Utils_Tuple2(
					A2($author$project$ProfileUserbase$Model$validateState, flags, newstate),
					$elm$core$Platform$Cmd$none);
			default:
				var userbase = msg.a;
				var newstate = _Utils_update(
					state,
					{
						current: userbase,
						initial: $elm$core$Maybe$Just(userbase)
					});
				return _Utils_Tuple2(
					A2($author$project$ProfileUserbase$Model$validateState, flags, newstate),
					$elm$core$Platform$Cmd$none);
		}
	});
var $author$project$Profile$updateUserbase = F3(
	function (flags, umsg, state) {
		var _v0 = A3(
			$author$project$ProfileUserbase$Model$update,
			$author$project$Profile$userbaseFlags(flags),
			state.userbase,
			umsg);
		var ustate = _v0.a;
		var ucmds = _v0.b;
		return A3(
			$author$project$Profile$updateStateCmds,
			flags,
			$author$project$Profile$userbaseCmds(ucmds),
			_Utils_update(
				state,
				{userbase: ustate}));
	});
var $author$project$Profile$Decode$AddProfileOk = {$: 'AddProfileOk'};
var $author$project$Profile$Decode$IncomingAuth = function (a) {
	return {$: 'IncomingAuth', a: a};
};
var $author$project$Profile$Decode$IncomingBundleData = F2(
	function (a, b) {
		return {$: 'IncomingBundleData', a: a, b: b};
	});
var $author$project$Profile$Decode$IncomingProfileData = function (a) {
	return {$: 'IncomingProfileData', a: a};
};
var $author$project$Profile$Decode$IncomingProfileUnique = function (a) {
	return {$: 'IncomingProfileUnique', a: a};
};
var $author$project$Profile$Decode$IncomingTopicData = F2(
	function (a, b) {
		return {$: 'IncomingTopicData', a: a, b: b};
	});
var $author$project$Profile$Decode$IncomingUserbase = function (a) {
	return {$: 'IncomingUserbase', a: a};
};
var $author$project$Profile$Decode$Progress = function (a) {
	return {$: 'Progress', a: a};
};
var $author$project$Profile$Decode$RequestFailed = function (a) {
	return {$: 'RequestFailed', a: a};
};
var $author$project$Profile$Decode$UpdateProfileOk = {$: 'UpdateProfileOk'};
var $author$project$ProfileData$Unique$ProfileUnique = F3(
	function (initials, titles, monikers) {
		return {initials: initials, monikers: monikers, titles: titles};
	});
var $author$project$ProfileData$Decode$profileUniqueDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$ProfileData$Unique$ProfileUnique,
	A2(
		$elm$json$Json$Decode$field,
		'initials',
		$elm$json$Json$Decode$list($elm$json$Json$Decode$string)),
	A2(
		$elm$json$Json$Decode$field,
		'titles',
		$elm$json$Json$Decode$list($elm$json$Json$Decode$string)),
	A2(
		$elm$json$Json$Decode$field,
		'monikers',
		$elm$json$Json$Decode$list($elm$json$Json$Decode$string)));
var $author$project$Userbase$Model$Userbase = F4(
	function (username, password, newPassword, confirm) {
		return {confirm: confirm, newPassword: newPassword, password: password, username: username};
	});
var $author$project$Userbase$Decode$userbaseDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$Userbase$Model$Userbase,
	A2($elm$json$Json$Decode$field, 'username', $elm$json$Json$Decode$string),
	$elm$json$Json$Decode$succeed(''),
	$elm$json$Json$Decode$succeed(''),
	$elm$json$Json$Decode$succeed(''));
var $author$project$Profile$Decode$incomingMsgDecoderByMsg = function (msg) {
	switch (msg) {
		case 'auth':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Profile$Decode$IncomingAuth,
				A2($elm$json$Json$Decode$field, 'auth', $author$project$Auth$Decode$authDecoder));
		case 'topic info':
			return A3(
				$elm$json$Json$Decode$map2,
				$author$project$Profile$Decode$IncomingTopicData,
				A2($elm$json$Json$Decode$field, 'tkey', $elm$json$Json$Decode$string),
				A2($elm$json$Json$Decode$field, 'topic', $author$project$TopicData$Decode$topicDataDecoder));
		case 'bundle info':
			return A3(
				$elm$json$Json$Decode$map2,
				$author$project$Profile$Decode$IncomingBundleData,
				A2($elm$json$Json$Decode$field, 'bnum', $elm$json$Json$Decode$int),
				A2($elm$json$Json$Decode$field, 'bundle', $author$project$BundleData$Decode$bundleDataDecoder));
		case 'profile unique info':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Profile$Decode$IncomingProfileUnique,
				A2($elm$json$Json$Decode$field, 'unique', $author$project$ProfileData$Decode$profileUniqueDecoder));
		case 'profile info':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Profile$Decode$IncomingProfileData,
				A2($elm$json$Json$Decode$field, 'profile', $author$project$ProfileData$Decode$profileDataDecoder));
		case 'userbase info':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Profile$Decode$IncomingUserbase,
				A2($elm$json$Json$Decode$field, 'userbase', $author$project$Userbase$Decode$userbaseDecoder));
		case 'error':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Profile$Decode$RequestFailed,
				$elm$json$Json$Decode$maybe(
					A2($elm$json$Json$Decode$field, 'details', $elm$json$Json$Decode$string)));
		case 'add profile ok':
			return $elm$json$Json$Decode$succeed($author$project$Profile$Decode$AddProfileOk);
		case 'update profile ok':
			return $elm$json$Json$Decode$succeed($author$project$Profile$Decode$UpdateProfileOk);
		case 'progress':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Profile$Decode$Progress,
				A2($elm$json$Json$Decode$field, 'progress', $elm$json$Json$Decode$value));
		default:
			var other = msg;
			return $elm$json$Json$Decode$fail(other);
	}
};
var $author$project$Profile$Decode$incomingMsgDecoder = A2(
	$elm$json$Json$Decode$andThen,
	$author$project$Profile$Decode$incomingMsgDecoderByMsg,
	A2($elm$json$Json$Decode$field, 'msg', $elm$json$Json$Decode$string));
var $author$project$Profile$Decode$valueToIncomingMsg = function (value) {
	return function (x) {
		return x;
	}(
		A2(
			$elm$core$Result$mapError,
			$elm$json$Json$Decode$errorToString,
			A2($elm$json$Json$Decode$decodeValue, $author$project$Profile$Decode$incomingMsgDecoder, value)));
};
var $author$project$Profile$update = F2(
	function (msg, model) {
		var _v0 = _Utils_Tuple2(model, msg);
		if (_v0.a.$ === 'Failed') {
			return _Utils_Tuple2(model, $elm$core$Platform$Cmd$none);
		} else {
			switch (_v0.b.$) {
				case 'UpdateAccepted':
					var _v1 = _v0.a;
					var flags = _v1.a;
					var state = _v1.b;
					var value = _v0.b.a;
					return _Utils_Tuple2(
						model,
						A2(
							$elm$core$Task$perform,
							$author$project$Profile$Model$Accepted(value),
							$elm$time$Time$now));
				case 'Accepted':
					var _v2 = _v0.a;
					var flags = _v2.a;
					var state = _v2.b;
					var _v3 = _v0.b;
					var value = _v3.a;
					var when = _v3.b;
					var accepted_on = value ? when : $elm$time$Time$millisToPosix(0);
					return A3(
						$author$project$Profile$updateDetails,
						flags,
						$author$project$ProfileDetails$Model$UpdateAccepted(accepted_on),
						state);
				case 'PressSubmit':
					var _v4 = _v0.a;
					var flags = _v4.a;
					var state = _v4.b;
					var _v5 = _v0.b;
					return A2($author$project$Profile$View$okToSubmit, flags, state) ? A2($author$project$Profile$cmdSubmitRequest, flags, state) : _Utils_Tuple2(model, $elm$core$Platform$Cmd$none);
				case 'PressAddBundle':
					var _v6 = _v0.a;
					var flags = _v6.a;
					var state = _v6.b;
					var _v7 = _v0.b;
					return A2($author$project$Shared$Cmd$cmdTransition, flags.extra.profileSubmit.transitions.addBundle, model);
				case 'PressAddTopic':
					var _v8 = _v0.a;
					var flags = _v8.a;
					var state = _v8.b;
					var _v9 = _v0.b;
					return A2($author$project$Shared$Cmd$cmdTransition, flags.extra.profileSubmit.transitions.addTopic, model);
				case 'PressAddMember':
					var _v10 = _v0.a;
					var flags = _v10.a;
					var state = _v10.b;
					var _v11 = _v0.b;
					return A2($author$project$Shared$Cmd$cmdTransition, flags.extra.profileSubmit.transitions.addMember, model);
				case 'PressTopicList':
					var _v12 = _v0.a;
					var flags = _v12.a;
					var state = _v12.b;
					var _v13 = _v0.b;
					return A2($author$project$Shared$Cmd$cmdTransition, flags.extra.profileSubmit.transitions.topiclist, model);
				case 'PressViewTopic':
					if (_v0.b.a.$ === 'Just') {
						var _v14 = _v0.a;
						var flags = _v14.a;
						var state = _v14.b;
						var tkey = _v0.b.a.a;
						return A3($author$project$Shared$Cmd$cmdTransitionString, flags.extra.profileSubmit.transitions.topic, tkey, model);
					} else {
						var _v15 = _v0.a;
						var flags = _v15.a;
						var state = _v15.b;
						return _Utils_Tuple2(model, $elm$core$Platform$Cmd$none);
					}
				case 'PressViewBundle':
					if (_v0.b.a.$ === 'Just') {
						var _v16 = _v0.a;
						var flags = _v16.a;
						var state = _v16.b;
						var bnum = _v0.b.a.a;
						return A3($author$project$Shared$Cmd$cmdTransitionNumber, flags.extra.profileSubmit.transitions.bundle, bnum, model);
					} else {
						var _v17 = _v0.a;
						var flags = _v17.a;
						var state = _v17.b;
						return _Utils_Tuple2(model, $elm$core$Platform$Cmd$none);
					}
				case 'ProfileViewMsg':
					var _v18 = _v0.a;
					var flags = _v18.a;
					var state = _v18.b;
					var vmsg = _v0.b.a;
					return _Utils_Tuple2(model, $elm$core$Platform$Cmd$none);
				case 'DetailsMsg':
					var _v19 = _v0.a;
					var flags = _v19.a;
					var state = _v19.b;
					var dmsg = _v0.b.a;
					return A3($author$project$Profile$updateDetails, flags, dmsg, state);
				case 'UserbaseMsg':
					var _v20 = _v0.a;
					var flags = _v20.a;
					var state = _v20.b;
					var umsg = _v0.b.a;
					return A3($author$project$Profile$updateUserbase, flags, umsg, state);
				case 'ProgressMsg':
					var _v21 = _v0.a;
					var flags = _v21.a;
					var state = _v21.b;
					var pmsg = _v0.b.a;
					return A3($author$project$Profile$updateProgress, flags, pmsg, state);
				default:
					var _v22 = _v0.a;
					var flags = _v22.a;
					var state = _v22.b;
					var v = _v0.b.a;
					var _v23 = $author$project$Profile$Decode$valueToIncomingMsg(v);
					if (_v23.$ === 'Err') {
						var err = _v23.a;
						return $author$project$Shared$Reg$decodeErr(err) ? A3(
							$author$project$Profile$updateProgress,
							flags,
							$author$project$Progress$Model$DecodeErr(err),
							state) : A2($author$project$Shared$Cmd$cmdLog, 'Err ' + err, model);
					} else {
						switch (_v23.a.$) {
							case 'IncomingAuth':
								var auth = _v23.a.a;
								var _v24 = A3(
									$author$project$Profile$updateUserbase,
									flags,
									$author$project$ProfileUserbase$Model$IncomingAuth(auth),
									state);
								if (_v24.a.$ === 'Loaded') {
									var _v25 = _v24.a;
									var state2 = _v25.b;
									var cmds = _v24.b;
									return A3(
										$author$project$Profile$updateStateCmds,
										flags,
										cmds,
										_Utils_update(
											state2,
											{
												auth: $krisajenkins$remotedata$RemoteData$Success(auth)
											}));
								} else {
									return _Utils_Tuple2(model, $elm$core$Platform$Cmd$none);
								}
							case 'IncomingTopicData':
								var _v26 = _v23.a;
								var tkey = _v26.a;
								var data = _v26.b;
								var newstate = _Utils_update(
									state,
									{
										topics: A3($elm$core$Dict$insert, tkey, data, state.topics)
									});
								return A2($author$project$Profile$updateState, flags, newstate);
							case 'IncomingBundleData':
								var _v27 = _v23.a;
								var key = _v27.a;
								var data = _v27.b;
								var newstate = _Utils_update(
									state,
									{
										bundles: A3($elm$core$Dict$insert, key, data, state.bundles)
									});
								return A2($author$project$Profile$updateState, flags, newstate);
							case 'IncomingProfileUnique':
								var unique = _v23.a.a;
								return A3(
									$author$project$Profile$updateDetails,
									flags,
									$author$project$ProfileDetails$Model$IncomingProfileUnique(unique),
									state);
							case 'IncomingProfileData':
								var profile = _v23.a.a;
								return (flags.extra.mode === 'view') ? A3(
									$author$project$Profile$updateDetails,
									flags,
									$author$project$ProfileDetails$Model$IncomingProfileData(profile),
									state) : _Utils_Tuple2(model, $elm$core$Platform$Cmd$none);
							case 'IncomingUserbase':
								var userbase = _v23.a.a;
								return (flags.extra.mode === 'view') ? A3(
									$author$project$Profile$updateUserbase,
									flags,
									$author$project$ProfileUserbase$Model$IncomingUserbase(userbase),
									state) : _Utils_Tuple2(model, $elm$core$Platform$Cmd$none);
							case 'RequestFailed':
								if (_v23.a.a.$ === 'Just') {
									var err = _v23.a.a.a;
									return A2(
										$author$project$Profile$updateState,
										flags,
										_Utils_update(
											state,
											{
												result: $krisajenkins$remotedata$RemoteData$Failure(err)
											}));
								} else {
									var _v28 = _v23.a.a;
									return A2(
										$author$project$Profile$updateState,
										flags,
										_Utils_update(
											state,
											{
												result: $krisajenkins$remotedata$RemoteData$Failure(flags.extra.profileSubmit.labels.submit.failed)
											}));
								}
							case 'AddProfileOk':
								var _v29 = _v23.a;
								return A2($author$project$Shared$Cmd$cmdTransition, flags.extra.profileSubmit.transitions.update, model);
							case 'UpdateProfileOk':
								var _v30 = _v23.a;
								return A3(
									$author$project$Profile$updateDetails,
									flags,
									$author$project$ProfileDetails$Model$UpdateOk,
									_Utils_update(
										state,
										{
											result: $krisajenkins$remotedata$RemoteData$Success('')
										}));
							default:
								var value = _v23.a.a;
								return A3(
									$author$project$Profile$updateProgress,
									flags,
									$author$project$Progress$Model$Incoming(value),
									state);
						}
					}
			}
		}
	});
var $author$project$Profile$Model$ProfileViewMsg = function (a) {
	return {$: 'ProfileViewMsg', a: a};
};
var $author$project$Profile$currentView = 0;
var $author$project$Profile$Model$isHost = function (state) {
	var _v0 = state.auth;
	if (_v0.$ === 'Success') {
		var auth = _v0.a;
		return _Utils_eq(auth.role, $author$project$MemberData$Model$Host);
	} else {
		return false;
	}
};
var $author$project$Profile$profileViewFlags = function (flags) {
	return {labels: flags.extra.profileView.labels};
};
var $author$project$Profile$Model$UpdateAccepted = function (a) {
	return {$: 'UpdateAccepted', a: a};
};
var $elm$time$Time$flooredDiv = F2(
	function (numerator, denominator) {
		return $elm$core$Basics$floor(numerator / denominator);
	});
var $elm$time$Time$toAdjustedMinutesHelp = F3(
	function (defaultOffset, posixMinutes, eras) {
		toAdjustedMinutesHelp:
		while (true) {
			if (!eras.b) {
				return posixMinutes + defaultOffset;
			} else {
				var era = eras.a;
				var olderEras = eras.b;
				if (_Utils_cmp(era.start, posixMinutes) < 0) {
					return posixMinutes + era.offset;
				} else {
					var $temp$defaultOffset = defaultOffset,
						$temp$posixMinutes = posixMinutes,
						$temp$eras = olderEras;
					defaultOffset = $temp$defaultOffset;
					posixMinutes = $temp$posixMinutes;
					eras = $temp$eras;
					continue toAdjustedMinutesHelp;
				}
			}
		}
	});
var $elm$time$Time$toAdjustedMinutes = F2(
	function (_v0, time) {
		var defaultOffset = _v0.a;
		var eras = _v0.b;
		return A3(
			$elm$time$Time$toAdjustedMinutesHelp,
			defaultOffset,
			A2(
				$elm$time$Time$flooredDiv,
				$elm$time$Time$posixToMillis(time),
				60000),
			eras);
	});
var $elm$time$Time$toCivil = function (minutes) {
	var rawDay = A2($elm$time$Time$flooredDiv, minutes, 60 * 24) + 719468;
	var era = (((rawDay >= 0) ? rawDay : (rawDay - 146096)) / 146097) | 0;
	var dayOfEra = rawDay - (era * 146097);
	var yearOfEra = ((((dayOfEra - ((dayOfEra / 1460) | 0)) + ((dayOfEra / 36524) | 0)) - ((dayOfEra / 146096) | 0)) / 365) | 0;
	var dayOfYear = dayOfEra - (((365 * yearOfEra) + ((yearOfEra / 4) | 0)) - ((yearOfEra / 100) | 0));
	var mp = (((5 * dayOfYear) + 2) / 153) | 0;
	var month = mp + ((mp < 10) ? 3 : (-9));
	var year = yearOfEra + (era * 400);
	return {
		day: (dayOfYear - ((((153 * mp) + 2) / 5) | 0)) + 1,
		month: month,
		year: year + ((month <= 2) ? 1 : 0)
	};
};
var $elm$time$Time$toDay = F2(
	function (zone, time) {
		return $elm$time$Time$toCivil(
			A2($elm$time$Time$toAdjustedMinutes, zone, time)).day;
	});
var $elm$time$Time$Apr = {$: 'Apr'};
var $elm$time$Time$Aug = {$: 'Aug'};
var $elm$time$Time$Dec = {$: 'Dec'};
var $elm$time$Time$Feb = {$: 'Feb'};
var $elm$time$Time$Jan = {$: 'Jan'};
var $elm$time$Time$Jul = {$: 'Jul'};
var $elm$time$Time$Jun = {$: 'Jun'};
var $elm$time$Time$Mar = {$: 'Mar'};
var $elm$time$Time$May = {$: 'May'};
var $elm$time$Time$Nov = {$: 'Nov'};
var $elm$time$Time$Oct = {$: 'Oct'};
var $elm$time$Time$Sep = {$: 'Sep'};
var $elm$time$Time$toMonth = F2(
	function (zone, time) {
		var _v0 = $elm$time$Time$toCivil(
			A2($elm$time$Time$toAdjustedMinutes, zone, time)).month;
		switch (_v0) {
			case 1:
				return $elm$time$Time$Jan;
			case 2:
				return $elm$time$Time$Feb;
			case 3:
				return $elm$time$Time$Mar;
			case 4:
				return $elm$time$Time$Apr;
			case 5:
				return $elm$time$Time$May;
			case 6:
				return $elm$time$Time$Jun;
			case 7:
				return $elm$time$Time$Jul;
			case 8:
				return $elm$time$Time$Aug;
			case 9:
				return $elm$time$Time$Sep;
			case 10:
				return $elm$time$Time$Oct;
			case 11:
				return $elm$time$Time$Nov;
			default:
				return $elm$time$Time$Dec;
		}
	});
var $elm$time$Time$toYear = F2(
	function (zone, time) {
		return $elm$time$Time$toCivil(
			A2($elm$time$Time$toAdjustedMinutes, zone, time)).year;
	});
var $author$project$Shared$Months$formatDate = F2(
	function (months, value) {
		var yearname = $elm$core$String$fromInt(
			A2($elm$time$Time$toYear, $elm$time$Time$utc, value));
		var month = A2($elm$time$Time$toMonth, $elm$time$Time$utc, value);
		var monthname = function () {
			switch (month.$) {
				case 'Jan':
					return months.m1;
				case 'Feb':
					return months.m2;
				case 'Mar':
					return months.m3;
				case 'Apr':
					return months.m4;
				case 'May':
					return months.m5;
				case 'Jun':
					return months.m6;
				case 'Jul':
					return months.m7;
				case 'Aug':
					return months.m8;
				case 'Sep':
					return months.m9;
				case 'Oct':
					return months.m10;
				case 'Nov':
					return months.m11;
				default:
					return months.m12;
			}
		}();
		var dayname = $elm$core$String$fromInt(
			A2($elm$time$Time$toDay, $elm$time$Time$utc, value));
		return A2(
			$elm$core$String$join,
			'',
			_List_fromArray(
				[monthname, ' ', dayname, ', ', yearname]));
	});
var $author$project$Profile$View$viewAcceptTitle = F2(
	function (flags, state) {
		var ps = flags.extra.profileSubmit;
		var includeCurrentPassword = flags.extra.profileUserbase.labels.currentPassword.visible;
		var userbase_changed = A3($author$project$Userbase$Model$userbaseChanged, includeCurrentPassword, state.userbase.initial, state.userbase.current);
		var enable_accept = function () {
			var _v3 = _Utils_Tuple3(
				A2($author$project$Profile$View$okToSubmit, flags, state),
				userbase_changed,
				state.auth);
			_v3$2:
			while (true) {
				if (_v3.a) {
					if (_v3.b) {
						return A2($author$project$Profile$View$okToSubmit, flags, state);
					} else {
						if (_v3.c.$ === 'Success') {
							var auth = _v3.c.a;
							return !auth.unchanged;
						} else {
							break _v3$2;
						}
					}
				} else {
					break _v3$2;
				}
			}
			return false;
		}();
		var current_accepted = !_Utils_eq(
			state.details.current.accepted_on,
			$elm$time$Time$millisToPosix(0));
		var show_choose = current_accepted ? false : (userbase_changed ? false : (_Utils_eq(state.result, $krisajenkins$remotedata$RemoteData$Loading) ? false : true));
		var choose = $author$project$Shared$Text$htmlTextLines(ps.labels.accept.choose);
		var accepted_date = function () {
			var _v2 = state.details.initial;
			if (_v2.$ === 'Just') {
				var profile = _v2.a;
				return _Utils_eq(
					profile.accepted_on,
					$elm$time$Time$millisToPosix(0)) ? $elm$core$Maybe$Nothing : $elm$core$Maybe$Just(
					A2($author$project$Shared$Months$formatDate, flags.extra.months, profile.accepted_on));
			} else {
				return $elm$core$Maybe$Nothing;
			}
		}();
		var _v0 = _Utils_Tuple3(
			flags.extra.mode,
			$author$project$Profile$Model$isHost(state),
			accepted_date);
		if (_v0.a === 'view') {
			if (_v0.b) {
				return _List_Nil;
			} else {
				if (_v0.c.$ === 'Just') {
					var value = _v0.c.a;
					return _List_fromArray(
						[
							A2(
							$elm$html$Html$h2,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('mt-2')
								]),
							_List_fromArray(
								[
									$elm$html$Html$text(ps.labels.accepted.label)
								])),
							$elm$html$Html$text(ps.labels.accepted.acceptedOn),
							$elm$html$Html$text($author$project$Shared$Text$nbsp),
							$elm$html$Html$text(value)
						]);
				} else {
					var _v1 = _v0.c;
					return _List_fromArray(
						[
							A2(
							$elm$html$Html$h2,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('mt-2')
								]),
							_List_fromArray(
								[
									$elm$html$Html$text(ps.labels.accept.label)
								])),
							$elm$html$Html$text(ps.labels.accept.description),
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('sp-form ml-3 mr-3 mt-3')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$br,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('is-hidden-mobile')
										]),
									_List_Nil),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('field is-horizontal mb-0')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$div,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('field-label is-normal')
												]),
											_List_fromArray(
												[
													A2(
													$elm$html$Html$div,
													_List_fromArray(
														[
															$elm$html$Html$Attributes$class('field')
														]),
													_List_fromArray(
														[
															A2($elm$html$Html$div, _List_Nil, _List_Nil)
														]))
												])),
											A2(
											$elm$html$Html$div,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('field-body')
												]),
											_List_fromArray(
												[
													A2(
													$elm$html$Html$div,
													_List_fromArray(
														[
															$elm$html$Html$Attributes$class('field'),
															A2($elm$html$Html$Attributes$style, 'display', 'table')
														]),
													_List_fromArray(
														[
															A2(
															$elm$html$Html$div,
															_List_fromArray(
																[
																	$elm$html$Html$Attributes$class('checkbox is-flex'),
																	A2($elm$html$Html$Attributes$style, 'display', 'table-cell'),
																	A2($elm$html$Html$Attributes$style, 'vertical-align', 'middle')
																]),
															_List_fromArray(
																[
																	A2(
																	$elm$html$Html$input,
																	_List_fromArray(
																		[
																			$elm$html$Html$Attributes$class('sp-checkbox mx-2'),
																			$elm$html$Html$Attributes$type_('checkbox'),
																			$elm$html$Html$Attributes$disabled(!enable_accept),
																			$elm$html$Html$Attributes$checked(current_accepted),
																			$elm$html$Html$Events$onCheck($author$project$Profile$Model$UpdateAccepted)
																		]),
																	_List_Nil),
																	$elm$html$Html$text(ps.labels.accept.agree)
																])),
															show_choose ? A2(
															$elm$html$Html$div,
															_List_fromArray(
																[
																	$elm$html$Html$Attributes$class('help is-danger')
																]),
															_List_fromArray(
																[
																	A2($elm$html$Html$p, _List_Nil, choose)
																])) : A2($elm$html$Html$div, _List_Nil, _List_Nil)
														])),
													A2(
													$elm$html$Html$div,
													_List_fromArray(
														[
															$elm$html$Html$Attributes$class('field-label is-normal'),
															A2($elm$html$Html$Attributes$style, 'max-width', '5px')
														]),
													_List_fromArray(
														[
															A2(
															$elm$html$Html$label,
															_List_fromArray(
																[
																	$elm$html$Html$Attributes$class('label')
																]),
															_List_Nil)
														]))
												]))
										])),
									A2(
									$elm$html$Html$br,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('is-hidden-mobile')
										]),
									_List_Nil)
								]))
						]);
				}
			}
		} else {
			return _List_Nil;
		}
	});
var $author$project$Profile$Model$PressAddBundle = {$: 'PressAddBundle'};
var $author$project$Profile$Model$PressAddMember = {$: 'PressAddMember'};
var $author$project$Profile$Model$PressAddTopic = {$: 'PressAddTopic'};
var $author$project$Profile$Model$PressTopicList = {$: 'PressTopicList'};
var $author$project$Profile$Model$PressViewBundle = function (a) {
	return {$: 'PressViewBundle', a: a};
};
var $author$project$Profile$Model$PressViewTopic = function (a) {
	return {$: 'PressViewTopic', a: a};
};
var $author$project$Profile$View$viewNextSteps = F2(
	function (flags, state) {
		var ps = flags.extra.profileSubmit;
		var _v0 = _Utils_Tuple2(
			flags.extra.mode,
			$author$project$Profile$Model$isHost(state));
		if (_v0.a === 'view') {
			if (_v0.b) {
				return _List_fromArray(
					[
						A2(
						$elm$html$Html$br,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('is-hidden-mobile')
							]),
						_List_Nil),
						A2(
						$elm$html$Html$h2,
						_List_Nil,
						_List_fromArray(
							[
								$elm$html$Html$text(ps.labels.next.title)
							])),
						A2(
						$elm$html$Html$p,
						_List_Nil,
						_List_fromArray(
							[
								$elm$html$Html$text(ps.labels.next.description)
							])),
						A2(
						$elm$html$Html$div,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('columns mr-5')
							]),
						_List_fromArray(
							[
								A2(
								$elm$html$Html$div,
								_List_fromArray(
									[
										$elm$html$Html$Attributes$class('is-hidden-mobile mr-2')
									]),
								_List_fromArray(
									[
										$elm$html$Html$text($author$project$Shared$Text$nbsp)
									])),
								A2(
								$elm$html$Html$div,
								_List_fromArray(
									[
										$elm$html$Html$Attributes$class('column is-one-third pr-4')
									]),
								_List_fromArray(
									[
										A2(
										$elm$html$Html$button,
										_List_fromArray(
											[
												$elm$html$Html$Attributes$class('button has-background-primary-dark has-text-white'),
												$elm$html$Html$Events$onClick($author$project$Profile$Model$PressAddBundle)
											]),
										_List_fromArray(
											[
												$elm$html$Html$text(ps.labels.addBundle.label)
											])),
										A2(
										$elm$html$Html$p,
										_List_Nil,
										_List_fromArray(
											[
												$elm$html$Html$text(ps.labels.addBundle.description)
											]))
									])),
								A2(
								$elm$html$Html$div,
								_List_fromArray(
									[
										$elm$html$Html$Attributes$class('column is-one-third pr-3')
									]),
								_List_fromArray(
									[
										A2(
										$elm$html$Html$button,
										_List_fromArray(
											[
												$elm$html$Html$Attributes$class('button has-background-primary-dark has-text-white'),
												$elm$html$Html$Events$onClick($author$project$Profile$Model$PressAddTopic)
											]),
										_List_fromArray(
											[
												$elm$html$Html$text(ps.labels.addTopic.label)
											])),
										A2(
										$elm$html$Html$p,
										_List_Nil,
										_List_fromArray(
											[
												$elm$html$Html$text(ps.labels.addTopic.description)
											]))
									])),
								A2(
								$elm$html$Html$div,
								_List_fromArray(
									[
										$elm$html$Html$Attributes$class('column is-one-third pr-3')
									]),
								_List_fromArray(
									[
										A2(
										$elm$html$Html$button,
										_List_fromArray(
											[
												$elm$html$Html$Attributes$class('button has-background-primary-dark has-text-white'),
												$elm$html$Html$Events$onClick($author$project$Profile$Model$PressAddMember)
											]),
										_List_fromArray(
											[
												$elm$html$Html$text(ps.labels.addMember.label)
											])),
										A2(
										$elm$html$Html$p,
										_List_Nil,
										_List_fromArray(
											[
												$elm$html$Html$text(ps.labels.addMember.description)
											]))
									]))
							]))
					]);
			} else {
				var onclick = function () {
					var _v3 = state.details.current.home.page;
					switch (_v3.$) {
						case 'TopicList':
							return $author$project$Profile$Model$PressTopicList;
						case 'Topic':
							return $author$project$Profile$Model$PressViewTopic(state.details.current.home.tkey);
						default:
							return $author$project$Profile$Model$PressViewBundle(state.details.current.home.bnum);
					}
				}();
				var homelabel = function () {
					var _v2 = state.details.current.home.page;
					switch (_v2.$) {
						case 'TopicList':
							return ps.labels.hometopiclist.label;
						case 'Topic':
							return ps.labels.hometopic.label;
						default:
							return ps.labels.homebundle.label;
					}
				}();
				var homedesc = function () {
					var _v1 = state.details.current.home.page;
					switch (_v1.$) {
						case 'TopicList':
							return ps.labels.hometopiclist.description;
						case 'Topic':
							return ps.labels.hometopic.description;
						default:
							return ps.labels.homebundle.description;
					}
				}();
				return _List_fromArray(
					[
						A2(
						$elm$html$Html$br,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('is-hidden-mobile')
							]),
						_List_Nil),
						A2(
						$elm$html$Html$h2,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('mt-1')
							]),
						_List_fromArray(
							[
								$elm$html$Html$text(ps.labels.next.title)
							])),
						A2(
						$elm$html$Html$div,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('columns mr-5'),
								A2($elm$html$Html$Attributes$style, 'align-items', 'center')
							]),
						_List_fromArray(
							[
								A2(
								$elm$html$Html$div,
								_List_fromArray(
									[
										$elm$html$Html$Attributes$class('column is-one-third pr-4')
									]),
								_List_fromArray(
									[
										A2(
										$elm$html$Html$button,
										_List_fromArray(
											[
												$elm$html$Html$Attributes$class('button has-background-primary-dark has-text-white ml-5'),
												$elm$html$Html$Events$onClick(onclick)
											]),
										_List_fromArray(
											[
												$elm$html$Html$text(homelabel)
											]))
									])),
								A2(
								$elm$html$Html$div,
								_List_fromArray(
									[
										$elm$html$Html$Attributes$class('column is-two-thirds pr-3')
									]),
								_List_fromArray(
									[
										A2(
										$elm$html$Html$p,
										_List_Nil,
										_List_fromArray(
											[
												$elm$html$Html$text(homedesc)
											]))
									]))
							]))
					]);
			}
		} else {
			return _List_Nil;
		}
	});
var $author$project$Profile$Model$PressSubmit = {$: 'PressSubmit'};
var $author$project$Profile$View$descOrError = F2(
	function (flags, state) {
		var _v0 = A2($author$project$Profile$View$currentError, flags, state);
		if (_v0.$ === 'Err') {
			var msg = _v0.a;
			return A2(
				$elm$html$Html$p,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('has-text-danger')
					]),
				_List_fromArray(
					[
						$elm$html$Html$text(msg)
					]));
		} else {
			var msg = _v0.a;
			return A2(
				$elm$html$Html$p,
				_List_Nil,
				_List_fromArray(
					[
						$elm$html$Html$text(msg)
					]));
		}
	});
var $author$project$Profile$View$viewSectionTitle = F2(
	function (flags, state) {
		var ps = flags.extra.profileSubmit;
		var loading = function (cls) {
			return _Utils_eq(state.result, $krisajenkins$remotedata$RemoteData$Loading) ? (cls + ' is-loading') : cls;
		};
		var enabled = A2($author$project$Profile$View$okToSubmit, flags, state);
		return _List_fromArray(
			[
				A2(
				$elm$html$Html$br,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('is-hidden-mobile')
					]),
				_List_Nil),
				A2(
				$elm$html$Html$h2,
				_List_Nil,
				_List_fromArray(
					[
						$elm$html$Html$text(ps.labels.title.label),
						A2(
						$elm$html$Html$button,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class(
								loading('button has-background-primary-dark has-text-white is-link is-pulled-right')),
								A2($elm$html$Html$Attributes$style, 'width', ps.labels.submit.width),
								$elm$html$Html$Attributes$disabled(!enabled),
								$elm$html$Html$Events$onClick($author$project$Profile$Model$PressSubmit)
							]),
						_List_fromArray(
							[
								$elm$html$Html$text(ps.labels.submit.label)
							]))
					])),
				A2($author$project$Profile$View$descOrError, flags, state)
			]);
	});
var $author$project$Profile$View$view = F2(
	function (flags, state) {
		return A2(
			$elm$html$Html$div,
			_List_Nil,
			_Utils_ap(
				_List_Nil,
				_Utils_ap(
					A2($author$project$Profile$View$viewAcceptTitle, flags, state),
					_Utils_ap(
						A2($author$project$Profile$View$viewSectionTitle, flags, state),
						A2($author$project$Profile$View$viewNextSteps, flags, state)))));
	});
var $author$project$ProfileDetails$Model$ChooseHomeBundle = function (a) {
	return {$: 'ChooseHomeBundle', a: a};
};
var $author$project$ProfileDetails$Model$ChooseHomeTopic = function (a) {
	return {$: 'ChooseHomeTopic', a: a};
};
var $author$project$ProfileDetails$Model$ChooseHomeTopicList = {$: 'ChooseHomeTopicList'};
var $author$project$ProfileDetails$Model$SelectBundle = function (a) {
	return {$: 'SelectBundle', a: a};
};
var $author$project$ProfileDetails$Model$SelectTopic = function (a) {
	return {$: 'SelectTopic', a: a};
};
var $elm$html$Html$Attributes$name = $elm$html$Html$Attributes$stringProperty('name');
var $elm$html$Html$option = _VirtualDom_node('option');
var $elm$html$Html$select = _VirtualDom_node('select');
var $elm$html$Html$Attributes$selected = $elm$html$Html$Attributes$boolProperty('selected');
var $author$project$ProfileDetails$View$viewHomePage = F4(
	function (flags, state, topics, bundles) {
		var home = state.current.home;
		var selectedbundle = function () {
			var _v5 = home.bnum;
			if (_v5.$ === 'Just') {
				return home.bnum;
			} else {
				var _v6 = $elm$core$List$head(
					$elm$core$Dict$toList(bundles));
				if (_v6.$ === 'Just') {
					var _v7 = _v6.a;
					var bnum = _v7.a;
					return $elm$core$Maybe$Just(bnum);
				} else {
					return $elm$core$Maybe$Nothing;
				}
			}
		}();
		var selectedtopic = function () {
			var _v2 = home.tkey;
			if (_v2.$ === 'Just') {
				return home.tkey;
			} else {
				var _v3 = $elm$core$List$head(
					$elm$core$Dict$toList(topics));
				if (_v3.$ === 'Just') {
					var _v4 = _v3.a;
					var tkey = _v4.a;
					return $elm$core$Maybe$Just(tkey);
				} else {
					return $elm$core$Maybe$Nothing;
				}
			}
		}();
		var topiclistradio = A2(
			$elm$html$Html$label,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('radio is-flex mt-2 ml-2'),
					A2($elm$html$Html$Attributes$style, 'align-items', 'center'),
					A2($elm$html$Html$Attributes$style, 'height', '30px')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$input,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('mr-1'),
							$elm$html$Html$Attributes$type_('radio'),
							$elm$html$Html$Attributes$name('topiclist'),
							$elm$html$Html$Attributes$checked(
							_Utils_eq(home.page, $author$project$ProfileData$Model$TopicList)),
							$elm$html$Html$Events$onClick($author$project$ProfileDetails$Model$ChooseHomeTopicList)
						]),
					_List_Nil),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							A2($elm$html$Html$Attributes$style, 'width', flags.labels.homepage.width)
						]),
					_List_fromArray(
						[
							$elm$html$Html$text(flags.labels.homepage.topiclist)
						]))
				]));
		var topicoption = function (_v1) {
			var tkey = _v1.a;
			var topic = _v1.b;
			return A2(
				$elm$html$Html$option,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$value(tkey),
						$elm$html$Html$Attributes$selected(
						_Utils_eq(
							$elm$core$Maybe$Just(tkey),
							home.tkey))
					]),
				_List_fromArray(
					[
						$elm$html$Html$text(topic.details.title)
					]));
		};
		var topicselect = A2(
			$elm$html$Html$select,
			_List_fromArray(
				[
					$elm$html$Html$Events$onInput($author$project$ProfileDetails$Model$SelectTopic)
				]),
			A2(
				$elm$core$List$map,
				topicoption,
				$elm$core$Dict$toList(topics)));
		var topicradio = A2(
			$elm$html$Html$label,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('radio is-flex ml-2'),
					A2($elm$html$Html$Attributes$style, 'align-items', 'center'),
					A2($elm$html$Html$Attributes$style, 'height', '30px')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$input,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('mr-1'),
							$elm$html$Html$Attributes$type_('radio'),
							$elm$html$Html$Attributes$name('topic'),
							$elm$html$Html$Attributes$checked(
							_Utils_eq(home.page, $author$project$ProfileData$Model$Topic)),
							$elm$html$Html$Attributes$disabled(
							$elm$core$Dict$isEmpty(topics)),
							$elm$html$Html$Events$onClick(
							$author$project$ProfileDetails$Model$ChooseHomeTopic(selectedtopic))
						]),
					_List_Nil),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							A2($elm$html$Html$Attributes$style, 'width', flags.labels.homepage.width)
						]),
					_List_fromArray(
						[
							$elm$html$Html$text(flags.labels.homepage.topic)
						])),
					_Utils_eq(home.page, $author$project$ProfileData$Model$Topic) ? A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('select is-small'),
							A2($elm$html$Html$Attributes$style, 'transform', 'translate(3px, -3px)')
						]),
					_List_fromArray(
						[topicselect])) : A2($elm$html$Html$div, _List_Nil, _List_Nil)
				]));
		var help = $author$project$Shared$Text$htmlTextLines(flags.labels.homepage.description);
		var bundleoption = function (_v0) {
			var bnum = _v0.a;
			var bundle = _v0.b;
			return A2(
				$elm$html$Html$option,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$value(
						$elm$core$String$fromInt(bnum)),
						$elm$html$Html$Attributes$selected(
						_Utils_eq(
							$elm$core$Maybe$Just(bnum),
							home.bnum))
					]),
				_List_fromArray(
					[
						$elm$html$Html$text(bundle.name)
					]));
		};
		var bundleselect = A2(
			$elm$html$Html$select,
			_List_fromArray(
				[
					$elm$html$Html$Events$onInput($author$project$ProfileDetails$Model$SelectBundle)
				]),
			A2(
				$elm$core$List$map,
				bundleoption,
				$elm$core$Dict$toList(bundles)));
		var bundleradio = A2(
			$elm$html$Html$label,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('radio is-flex ml-2'),
					A2($elm$html$Html$Attributes$style, 'align-items', 'center'),
					A2($elm$html$Html$Attributes$style, 'height', '30px')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$input,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('mr-1'),
							$elm$html$Html$Attributes$type_('radio'),
							$elm$html$Html$Attributes$name('bundle'),
							$elm$html$Html$Attributes$checked(
							_Utils_eq(home.page, $author$project$ProfileData$Model$Bundle)),
							$elm$html$Html$Attributes$disabled(
							$elm$core$Dict$isEmpty(bundles)),
							$elm$html$Html$Events$onClick(
							$author$project$ProfileDetails$Model$ChooseHomeBundle(selectedbundle))
						]),
					_List_Nil),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							A2($elm$html$Html$Attributes$style, 'width', flags.labels.homepage.width)
						]),
					_List_fromArray(
						[
							$elm$html$Html$text(flags.labels.homepage.bundle)
						])),
					_Utils_eq(home.page, $author$project$ProfileData$Model$Bundle) ? A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('select is-small'),
							A2($elm$html$Html$Attributes$style, 'transform', 'translate(3px, -3px)')
						]),
					_List_fromArray(
						[bundleselect])) : A2($elm$html$Html$div, _List_Nil, _List_Nil)
				]));
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('field is-horizontal')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-label is-normal')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									state.readonly ? _List_Nil : _List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help is-hidden-mobile')
												]),
											$author$project$Shared$Text$dropExtra(
												$author$project$Shared$Text$htmlBreaks(help)))
										])),
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('label ml-1')
												]),
											_List_fromArray(
												[
													$elm$html$Html$text(flags.labels.homepage.label)
												]))
										]))
								]))
						])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-body')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									state.readonly ? _List_Nil : _List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help')
												]),
											help)
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('control mt-2')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$div,
											_List_Nil,
											_List_fromArray(
												[topiclistradio, topicradio, bundleradio]))
										]))
								])),
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field-label is-normal'),
									A2($elm$html$Html$Attributes$style, 'max-width', '5px')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$label,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('label')
										]),
									_List_Nil)
								]))
						]))
				]));
	});
var $author$project$ProfileDetails$Model$UpdateInitials = function (a) {
	return {$: 'UpdateInitials', a: a};
};
var $author$project$ProfileDetails$ViewError$viewInitialsError = F2(
	function (flags, state) {
		var _v0 = _Utils_Tuple2(state.readonly, state.problems.initialsErr);
		if ((!_v0.a) && (_v0.b.$ === 'Just')) {
			var reason = _v0.b.a;
			return A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('help is-danger')
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$p,
						_List_Nil,
						$author$project$Shared$Text$htmlTextLines(reason))
					]));
		} else {
			return A2($elm$html$Html$div, _List_Nil, _List_Nil);
		}
	});
var $author$project$ProfileDetails$View$viewInitials = F2(
	function (flags, state) {
		var reset = function () {
			var _v0 = state.initial;
			if (_v0.$ === 'Just') {
				var initial = _v0.a;
				return (!_Utils_eq(initial.initials, state.current.initials)) ? _List_fromArray(
					[
						A2(
						$elm$html$Html$button,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('sp-icon is-right'),
								$elm$html$Html$Events$onClick(
								$author$project$ProfileDetails$Model$UpdateInitials(initial.initials))
							]),
						_List_fromArray(
							[
								$elm$html$Html$text($author$project$Shared$Text$greenX)
							]))
					]) : _List_Nil;
			} else {
				return _List_Nil;
			}
		}();
		var help = $author$project$Shared$Text$htmlTextLines(flags.labels.initials.description);
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('field is-horizontal')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-label is-normal')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									state.readonly ? _List_Nil : _List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help is-hidden-mobile')
												]),
											$author$project$Shared$Text$dropExtra(
												$author$project$Shared$Text$htmlBreaks(help)))
										])),
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class(
													A3($author$project$Shared$Text$has_danger, 'label ml-1', state.problems.initialsErr, state.readonly))
												]),
											_List_fromArray(
												[
													$elm$html$Html$text(flags.labels.initials.label)
												]))
										]))
								]))
						])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-body')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									state.readonly ? _List_Nil : _List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help')
												]),
											help)
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('field')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$div,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('control has-icons-right')
												]),
											_Utils_ap(
												_List_fromArray(
													[
														A2(
														$elm$html$Html$input,
														_Utils_ap(
															_List_fromArray(
																[
																	$elm$html$Html$Attributes$class(
																	A3($author$project$Shared$Text$is_danger, 'input', state.problems.initialsErr, state.readonly)),
																	$elm$html$Html$Attributes$type_('text'),
																	$elm$html$Html$Attributes$disabled(state.disabled),
																	$elm$html$Html$Attributes$readonly(state.readonly),
																	$elm$html$Html$Attributes$value(state.current.initials),
																	$elm$html$Html$Events$onInput($author$project$ProfileDetails$Model$UpdateInitials)
																]),
															A2($author$project$Shared$Text$placeholder, flags.labels.initials.placeholder, state.readonly)),
														_List_Nil)
													]),
												reset))
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('field')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$div,
											_List_Nil,
											_List_fromArray(
												[
													A2(
													$elm$html$Html$div,
													_List_Nil,
													_List_fromArray(
														[
															A2($author$project$ProfileDetails$ViewError$viewInitialsError, flags, state)
														]))
												]))
										]))
								])),
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									state.readonly ? _List_Nil : _List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help is-hidden-mobile')
												]),
											$author$project$Shared$Text$dropExtra(
												$author$project$Shared$Text$htmlBreaks(help)))
										])),
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('label ml-1 mt-1 mr-1')
												]),
											_List_fromArray(
												[
													$elm$html$Html$text('Icon')
												]))
										]))
								])),
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									state.readonly ? _List_Nil : _List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help is-hidden-mobile')
												]),
											$author$project$Shared$Text$dropExtra(
												$author$project$Shared$Text$htmlBreaks(help)))
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('control mt-1 ml-2')
										]),
									_List_fromArray(
										[
											A2($author$project$Shared$Icon$squareIcon, 24, state.current.initials)
										]))
								]))
						]))
				]));
	});
var $author$project$ProfileDetails$Model$UpdateMoniker = function (a) {
	return {$: 'UpdateMoniker', a: a};
};
var $author$project$ProfileDetails$ViewError$viewMonikerError = F2(
	function (flags, state) {
		var _v0 = _Utils_Tuple2(state.readonly, state.problems.monikerErr);
		if ((!_v0.a) && (_v0.b.$ === 'Just')) {
			var reason = _v0.b.a;
			return A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('help is-danger')
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$p,
						_List_Nil,
						$author$project$Shared$Text$htmlTextLines(reason))
					]));
		} else {
			return A2($elm$html$Html$div, _List_Nil, _List_Nil);
		}
	});
var $author$project$ProfileDetails$View$viewMoniker = F2(
	function (flags, state) {
		var reset = function () {
			var _v0 = state.initial;
			if (_v0.$ === 'Just') {
				var initial = _v0.a;
				return (!_Utils_eq(initial.moniker, state.current.moniker)) ? _List_fromArray(
					[
						A2(
						$elm$html$Html$button,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('sp-icon is-right'),
								$elm$html$Html$Events$onClick(
								$author$project$ProfileDetails$Model$UpdateMoniker(initial.moniker))
							]),
						_List_fromArray(
							[
								$elm$html$Html$text($author$project$Shared$Text$greenX)
							]))
					]) : _List_Nil;
			} else {
				return _List_Nil;
			}
		}();
		var help = $author$project$Shared$Text$htmlTextLines(flags.labels.moniker.description);
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('field is-horizontal')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-label is-normal')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									state.readonly ? _List_Nil : _List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help is-hidden-mobile')
												]),
											$author$project$Shared$Text$dropExtra(
												$author$project$Shared$Text$htmlBreaks(help)))
										])),
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class(
													A3($author$project$Shared$Text$has_danger, 'label ml-1', state.problems.monikerErr, state.readonly))
												]),
											_List_fromArray(
												[
													$elm$html$Html$text(flags.labels.moniker.label)
												]))
										]))
								]))
						])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-body')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									state.readonly ? _List_Nil : _List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help')
												]),
											help)
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('control has-icons-right')
										]),
									_Utils_ap(
										_List_fromArray(
											[
												A2(
												$elm$html$Html$input,
												_Utils_ap(
													_List_fromArray(
														[
															$elm$html$Html$Attributes$class(
															A3($author$project$Shared$Text$is_danger, 'input', state.problems.monikerErr, state.readonly)),
															$elm$html$Html$Attributes$type_('text'),
															$elm$html$Html$Attributes$disabled(state.disabled),
															$elm$html$Html$Attributes$readonly(state.readonly),
															$elm$html$Html$Attributes$value(state.current.moniker),
															$elm$html$Html$Events$onInput($author$project$ProfileDetails$Model$UpdateMoniker)
														]),
													A2($author$project$Shared$Text$placeholder, flags.labels.moniker.placeholder, state.readonly)),
												_List_Nil)
											]),
										reset)),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('field')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$div,
											_List_Nil,
											_List_fromArray(
												[
													A2(
													$elm$html$Html$div,
													_List_Nil,
													_List_fromArray(
														[
															A2($author$project$ProfileDetails$ViewError$viewMonikerError, flags, state)
														]))
												]))
										]))
								])),
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field-label is-normal'),
									A2($elm$html$Html$Attributes$style, 'max-width', '5px')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$label,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('label')
										]),
									_List_Nil)
								]))
						]))
				]));
	});
var $author$project$ProfileDetails$Model$UpdateParagraph = function (a) {
	return {$: 'UpdateParagraph', a: a};
};
var $author$project$Shared$Text$maybeText = function (x) {
	if (x.$ === 'Nothing') {
		return '';
	} else {
		var s = x.a;
		return s;
	}
};
var $author$project$Shared$Text$textToMaybe = function (x) {
	return (x === '') ? $elm$core$Maybe$Nothing : $elm$core$Maybe$Just(x);
};
var $author$project$ProfileDetails$View$viewParagraph = F2(
	function (flags, state) {
		var reset = function () {
			var _v0 = state.initial;
			if (_v0.$ === 'Just') {
				var initial = _v0.a;
				return (!_Utils_eq(initial.paragraph, state.current.paragraph)) ? _List_fromArray(
					[
						A2(
						$elm$html$Html$button,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('sp-icon is-right'),
								$elm$html$Html$Events$onClick(
								$author$project$ProfileDetails$Model$UpdateParagraph(initial.paragraph))
							]),
						_List_fromArray(
							[
								$elm$html$Html$text($author$project$Shared$Text$greenX)
							]))
					]) : _List_Nil;
			} else {
				return _List_Nil;
			}
		}();
		var help = $author$project$Shared$Text$htmlTextLines(flags.labels.paragraph.description);
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('field is-horizontal')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-label is-normal')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									state.readonly ? _List_Nil : _List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help is-hidden-mobile')
												]),
											$author$project$Shared$Text$dropExtra(
												$author$project$Shared$Text$htmlBreaks(help)))
										])),
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('label ml-1')
												]),
											_List_fromArray(
												[
													$elm$html$Html$text(flags.labels.paragraph.label)
												]))
										]))
								]))
						])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-body')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									state.readonly ? _List_Nil : _List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help')
												]),
											help)
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('control has-icons-right')
										]),
									_Utils_ap(
										_List_fromArray(
											[
												A2(
												$elm$html$Html$textarea,
												_Utils_ap(
													_List_fromArray(
														[
															$elm$html$Html$Attributes$class(
															A3($author$project$Shared$Text$is_danger, 'textarea', $elm$core$Maybe$Nothing, state.readonly)),
															$elm$html$Html$Attributes$rows(5),
															$elm$html$Html$Attributes$disabled(state.disabled),
															$elm$html$Html$Attributes$readonly(state.readonly),
															$elm$html$Html$Attributes$value(
															$author$project$Shared$Text$maybeText(state.current.paragraph)),
															$elm$html$Html$Events$onInput(
															function (x) {
																return $author$project$ProfileDetails$Model$UpdateParagraph(
																	$author$project$Shared$Text$textToMaybe(x));
															})
														]),
													A2($author$project$Shared$Text$placeholder, flags.labels.paragraph.placeholder, state.readonly)),
												_List_Nil)
											]),
										reset))
								])),
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field-label is-normal'),
									A2($elm$html$Html$Attributes$style, 'max-width', '5px')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$label,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('label')
										]),
									_List_Nil)
								]))
						]))
				]));
	});
var $author$project$ProfileDetails$Model$UpdateSubtitle = function (a) {
	return {$: 'UpdateSubtitle', a: a};
};
var $author$project$ProfileDetails$View$viewSubtitle = F2(
	function (flags, state) {
		var reset = function () {
			var _v0 = state.initial;
			if (_v0.$ === 'Just') {
				var initial = _v0.a;
				return (!_Utils_eq(initial.subtitle, state.current.subtitle)) ? _List_fromArray(
					[
						A2(
						$elm$html$Html$button,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('sp-icon is-right'),
								$elm$html$Html$Events$onClick(
								$author$project$ProfileDetails$Model$UpdateSubtitle(initial.subtitle))
							]),
						_List_fromArray(
							[
								$elm$html$Html$text($author$project$Shared$Text$greenX)
							]))
					]) : _List_Nil;
			} else {
				return _List_Nil;
			}
		}();
		var help = $author$project$Shared$Text$htmlTextLines(flags.labels.subtitle.description);
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('field is-horizontal')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-label is-normal')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									state.readonly ? _List_Nil : _List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help is-hidden-mobile')
												]),
											$author$project$Shared$Text$dropExtra(
												$author$project$Shared$Text$htmlBreaks(help)))
										])),
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('label ml-1')
												]),
											_List_fromArray(
												[
													$elm$html$Html$text(flags.labels.subtitle.label)
												]))
										]))
								]))
						])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-body')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									state.readonly ? _List_Nil : _List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help')
												]),
											help)
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('control has-icons-right')
										]),
									_Utils_ap(
										_List_fromArray(
											[
												A2(
												$elm$html$Html$input,
												_Utils_ap(
													_List_fromArray(
														[
															$elm$html$Html$Attributes$class(
															A3($author$project$Shared$Text$is_danger, 'input', $elm$core$Maybe$Nothing, state.readonly)),
															$elm$html$Html$Attributes$type_('text'),
															$elm$html$Html$Attributes$disabled(state.disabled),
															$elm$html$Html$Attributes$readonly(state.readonly),
															$elm$html$Html$Attributes$value(
															$author$project$Shared$Text$maybeText(state.current.subtitle)),
															$elm$html$Html$Events$onInput(
															function (x) {
																return $author$project$ProfileDetails$Model$UpdateSubtitle(
																	$author$project$Shared$Text$textToMaybe(x));
															})
														]),
													A2($author$project$Shared$Text$placeholder, flags.labels.subtitle.placeholder, state.readonly)),
												_List_Nil)
											]),
										reset))
								])),
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field-label is-normal'),
									A2($elm$html$Html$Attributes$style, 'max-width', '5px')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$label,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('label')
										]),
									_List_Nil)
								]))
						]))
				]));
	});
var $author$project$ProfileDetails$Model$ChooseThumbnail = {$: 'ChooseThumbnail'};
var $author$project$ProfileDetails$Model$RemoveThumbnail = {$: 'RemoveThumbnail'};
var $author$project$ProfileDetails$Model$UpdateThumbnail = function (a) {
	return {$: 'UpdateThumbnail', a: a};
};
var $author$project$ProfileDetails$View$viewThumbnail = F2(
	function (flags, state) {
		var reset = function () {
			var _v0 = state.initial;
			if (_v0.$ === 'Just') {
				var initial = _v0.a;
				return (!_Utils_eq(initial.thumbnail, state.current.thumbnail)) ? _List_fromArray(
					[
						A2(
						$elm$html$Html$button,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('sp-icon pb-2'),
								$elm$html$Html$Events$onClick(
								$author$project$ProfileDetails$Model$UpdateThumbnail(initial.thumbnail))
							]),
						_List_fromArray(
							[
								$elm$html$Html$text($author$project$Shared$Text$greenX)
							]))
					]) : _List_Nil;
			} else {
				return _List_Nil;
			}
		}();
		var help = $author$project$Shared$Text$htmlTextLines(flags.labels.thumbnail.description);
		var thumbnail_div = A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('field is-horizontal')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-label is-normal')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help is-hidden-mobile')
												]),
											$author$project$Shared$Text$dropExtra(
												$author$project$Shared$Text$htmlBreaks(help)))
										])),
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('label ml-1')
												]),
											_List_fromArray(
												[
													$elm$html$Html$text(flags.labels.thumbnail.label)
												]))
										]))
								]))
						])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-body')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help')
												]),
											help)
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('control has-icons-right')
										]),
									_Utils_ap(
										_List_fromArray(
											[
												A2(
												$elm$html$Html$button,
												_List_fromArray(
													[
														$elm$html$Html$Attributes$class('button has-background-primary-dark has-text-white is-link is-small mr-4'),
														$elm$html$Html$Attributes$disabled(state.disabled),
														$elm$html$Html$Events$onClick($author$project$ProfileDetails$Model$ChooseThumbnail)
													]),
												_List_fromArray(
													[
														$elm$html$Html$text(flags.labels.thumbnail.upload)
													])),
												A2(
												$elm$html$Html$button,
												_List_fromArray(
													[
														$elm$html$Html$Attributes$class('button has-background-primary-dark has-text-white is-link is-small'),
														$elm$html$Html$Attributes$disabled(
														$elm_community$maybe_extra$Maybe$Extra$isNothing(state.current.thumbnail) || state.disabled),
														$elm$html$Html$Events$onClick($author$project$ProfileDetails$Model$RemoveThumbnail)
													]),
												_List_fromArray(
													[
														$elm$html$Html$text(flags.labels.thumbnail.remove)
													]))
											]),
										reset))
								])),
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field-label is-normal')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$label,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('label')
										]),
									_List_Nil)
								]))
						]))
				]));
		return state.showthumb ? thumbnail_div : A2($elm$html$Html$div, _List_Nil, _List_Nil);
	});
var $author$project$ProfileDetails$Model$UpdateTitle = function (a) {
	return {$: 'UpdateTitle', a: a};
};
var $author$project$ProfileDetails$ViewError$viewTitleError = F2(
	function (flags, state) {
		var _v0 = _Utils_Tuple2(state.readonly, state.problems.titleErr);
		if ((!_v0.a) && (_v0.b.$ === 'Just')) {
			var reason = _v0.b.a;
			return A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('help is-danger')
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$p,
						_List_Nil,
						$author$project$Shared$Text$htmlTextLines(reason))
					]));
		} else {
			return A2($elm$html$Html$div, _List_Nil, _List_Nil);
		}
	});
var $author$project$ProfileDetails$View$viewTitle = F2(
	function (flags, state) {
		var reset = function () {
			var _v0 = state.initial;
			if (_v0.$ === 'Just') {
				var initial = _v0.a;
				return (!_Utils_eq(initial.title, state.current.title)) ? _List_fromArray(
					[
						A2(
						$elm$html$Html$button,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('sp-icon is-right'),
								$elm$html$Html$Events$onClick(
								$author$project$ProfileDetails$Model$UpdateTitle(initial.title))
							]),
						_List_fromArray(
							[
								$elm$html$Html$text($author$project$Shared$Text$greenX)
							]))
					]) : _List_Nil;
			} else {
				return _List_Nil;
			}
		}();
		var help = $author$project$Shared$Text$htmlTextLines(flags.labels.title.description);
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('field is-horizontal')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-label is-normal')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									state.readonly ? _List_Nil : _List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help is-hidden-mobile')
												]),
											$author$project$Shared$Text$dropExtra(
												$author$project$Shared$Text$htmlBreaks(help)))
										])),
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class(
													A3($author$project$Shared$Text$has_danger, 'label ml-1', state.problems.titleErr, state.readonly))
												]),
											_List_fromArray(
												[
													$elm$html$Html$text(flags.labels.title.label)
												]))
										]))
								]))
						])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-body')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									state.readonly ? _List_Nil : _List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help')
												]),
											help)
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('control has-icons-right')
										]),
									_Utils_ap(
										_List_fromArray(
											[
												A2(
												$elm$html$Html$input,
												_Utils_ap(
													_List_fromArray(
														[
															$elm$html$Html$Attributes$class(
															A3($author$project$Shared$Text$is_danger, 'input', state.problems.titleErr, state.readonly)),
															$elm$html$Html$Attributes$type_('text'),
															$elm$html$Html$Attributes$disabled(state.disabled),
															$elm$html$Html$Attributes$readonly(state.readonly),
															$elm$html$Html$Attributes$value(state.current.title),
															$elm$html$Html$Events$onInput($author$project$ProfileDetails$Model$UpdateTitle)
														]),
													A2($author$project$Shared$Text$placeholder, flags.labels.title.placeholder, state.readonly)),
												_List_Nil)
											]),
										reset)),
									A2($author$project$ProfileDetails$ViewError$viewTitleError, flags, state)
								])),
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field-label is-normal'),
									A2($elm$html$Html$Attributes$style, 'max-width', '5px')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$label,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('label')
										]),
									_List_Nil)
								]))
						]))
				]));
	});
var $author$project$ProfileDetails$View$view = F4(
	function (flags, state, topics, bundles) {
		return A2(
			$elm$html$Html$div,
			state.readonly ? _List_fromArray(
				[
					$elm$html$Html$Attributes$class('m-0')
				]) : _List_fromArray(
				[
					$elm$html$Html$Attributes$class('sp-form m-3')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$br,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('is-hidden-mobile')
						]),
					_List_Nil),
					A2($author$project$ProfileDetails$View$viewThumbnail, flags, state),
					A2($author$project$ProfileDetails$View$viewMoniker, flags, state),
					A2($author$project$ProfileDetails$View$viewInitials, flags, state),
					A2($author$project$ProfileDetails$View$viewTitle, flags, state),
					A2($author$project$ProfileDetails$View$viewSubtitle, flags, state),
					A2($author$project$ProfileDetails$View$viewParagraph, flags, state),
					state.readonly ? A2($elm$html$Html$div, _List_Nil, _List_Nil) : A4($author$project$ProfileDetails$View$viewHomePage, flags, state, topics, bundles),
					A2(
					$elm$html$Html$br,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('is-hidden-mobile')
						]),
					_List_Nil)
				]));
	});
var $author$project$ProfileUserbase$Model$UpdateConfirm = function (a) {
	return {$: 'UpdateConfirm', a: a};
};
var $author$project$ProfileUserbase$ViewError$viewConfirmError = F2(
	function (flags, state) {
		var _v0 = state.problems.confirmErr;
		if (_v0.$ === 'Just') {
			var reason = _v0.a;
			return A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('help is-danger')
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$p,
						_List_Nil,
						$author$project$Shared$Text$htmlTextLines(reason))
					]));
		} else {
			return A2($elm$html$Html$div, _List_Nil, _List_Nil);
		}
	});
var $author$project$ProfileUserbase$View$viewConfirmPassword = F2(
	function (flags, state) {
		var reset = function () {
			var _v0 = state.initial;
			if (_v0.$ === 'Just') {
				var initial = _v0.a;
				return (!_Utils_eq(initial.confirm, state.current.confirm)) ? _List_fromArray(
					[
						A2(
						$elm$html$Html$button,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('sp-icon is-right'),
								$elm$html$Html$Events$onClick(
								$author$project$ProfileUserbase$Model$UpdateConfirm(initial.confirm))
							]),
						_List_fromArray(
							[
								$elm$html$Html$text($author$project$Shared$Text$greenX)
							]))
					]) : _List_Nil;
			} else {
				return _List_Nil;
			}
		}();
		var inputType = state.showPasswords ? 'text' : 'password';
		var help = $author$project$Shared$Text$htmlTextLines(flags.labels.confirm.description);
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('field is-horizontal')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-label is-normal')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help is-hidden-mobile')
												]),
											$author$project$Shared$Text$dropExtra(
												$author$project$Shared$Text$htmlBreaks(help)))
										])),
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class(
													A3($author$project$Shared$Text$has_danger, 'label ml-1', state.problems.confirmErr, false))
												]),
											_List_fromArray(
												[
													$elm$html$Html$text(flags.labels.confirm.label)
												]))
										]))
								]))
						])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-body')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help')
												]),
											help)
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('field')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$div,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('control has-icons-right')
												]),
											_Utils_ap(
												_List_fromArray(
													[
														A2(
														$elm$html$Html$input,
														_List_fromArray(
															[
																$elm$html$Html$Attributes$class(
																A3($author$project$Shared$Text$is_danger, 'input', state.problems.confirmErr, false)),
																$elm$html$Html$Attributes$type_(inputType),
																$elm$html$Html$Attributes$placeholder(flags.labels.confirm.placeholder),
																$elm$html$Html$Attributes$value(state.current.confirm),
																$elm$html$Html$Attributes$autocomplete(false),
																$elm$html$Html$Events$onInput($author$project$ProfileUserbase$Model$UpdateConfirm)
															]),
														_List_Nil)
													]),
												reset))
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('field')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$div,
											_List_Nil,
											_List_fromArray(
												[
													A2(
													$elm$html$Html$div,
													_List_Nil,
													_List_fromArray(
														[
															A2($author$project$ProfileUserbase$ViewError$viewConfirmError, flags, state)
														]))
												]))
										]))
								])),
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field-label is-normal'),
									A2($elm$html$Html$Attributes$style, 'max-width', '5px')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$label,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('label')
										]),
									_List_Nil)
								]))
						]))
				]));
	});
var $author$project$ProfileUserbase$Model$UpdatePassword = function (a) {
	return {$: 'UpdatePassword', a: a};
};
var $author$project$ProfileUserbase$ViewError$viewPasswordError = F2(
	function (flags, state) {
		var _v0 = state.problems.passwordErr;
		if (_v0.$ === 'Just') {
			var reason = _v0.a;
			return A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('help is-danger')
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$p,
						_List_Nil,
						$author$project$Shared$Text$htmlTextLines(reason))
					]));
		} else {
			return A2($elm$html$Html$div, _List_Nil, _List_Nil);
		}
	});
var $author$project$ProfileUserbase$View$viewCurrentPassword = F2(
	function (flags, state) {
		var reset = function () {
			var _v0 = state.initial;
			if (_v0.$ === 'Just') {
				var initial = _v0.a;
				return (!_Utils_eq(initial.password, state.current.password)) ? _List_fromArray(
					[
						A2(
						$elm$html$Html$button,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('sp-icon is-right'),
								$elm$html$Html$Events$onClick(
								$author$project$ProfileUserbase$Model$UpdatePassword(initial.password))
							]),
						_List_fromArray(
							[
								$elm$html$Html$text($author$project$Shared$Text$greenX)
							]))
					]) : _List_Nil;
			} else {
				return _List_Nil;
			}
		}();
		var inputType = state.showPasswords ? 'text' : 'password';
		var help = $author$project$Shared$Text$htmlTextLines(flags.labels.currentPassword.description);
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('field is-horizontal')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-label is-normal')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help is-hidden-mobile')
												]),
											$author$project$Shared$Text$dropExtra(
												$author$project$Shared$Text$htmlBreaks(help)))
										])),
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class(
													A3($author$project$Shared$Text$has_danger, 'label ml-1', state.problems.passwordErr, false))
												]),
											_List_fromArray(
												[
													$elm$html$Html$text(flags.labels.currentPassword.label)
												]))
										]))
								]))
						])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-body')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help')
												]),
											help)
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('field')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$div,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('control has-icons-right')
												]),
											_Utils_ap(
												_List_fromArray(
													[
														A2(
														$elm$html$Html$input,
														_List_fromArray(
															[
																$elm$html$Html$Attributes$class(
																A3($author$project$Shared$Text$is_danger, 'input', state.problems.passwordErr, false)),
																$elm$html$Html$Attributes$type_(inputType),
																$elm$html$Html$Attributes$placeholder(flags.labels.currentPassword.placeholder),
																$elm$html$Html$Attributes$value(state.current.password),
																$elm$html$Html$Attributes$autocomplete(false),
																$elm$html$Html$Events$onInput($author$project$ProfileUserbase$Model$UpdatePassword)
															]),
														_List_Nil)
													]),
												reset))
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('field')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$div,
											_List_Nil,
											_List_fromArray(
												[
													A2(
													$elm$html$Html$div,
													_List_Nil,
													_List_fromArray(
														[
															A2($author$project$ProfileUserbase$ViewError$viewPasswordError, flags, state)
														]))
												]))
										]))
								])),
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field-label is-normal'),
									A2($elm$html$Html$Attributes$style, 'max-width', '5px')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$label,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('label')
										]),
									_List_Nil)
								]))
						]))
				]));
	});
var $author$project$ProfileUserbase$Model$UpdateNewPassword = function (a) {
	return {$: 'UpdateNewPassword', a: a};
};
var $author$project$ProfileUserbase$ViewError$viewNewPasswordError = F2(
	function (flags, state) {
		var _v0 = state.problems.newPasswordErr;
		if (_v0.$ === 'Just') {
			var reason = _v0.a;
			return A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('help is-danger')
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$p,
						_List_Nil,
						$author$project$Shared$Text$htmlTextLines(reason))
					]));
		} else {
			return A2($elm$html$Html$div, _List_Nil, _List_Nil);
		}
	});
var $author$project$ProfileUserbase$View$viewNewPassword = F2(
	function (flags, state) {
		var reset = function () {
			var _v0 = state.initial;
			if (_v0.$ === 'Just') {
				var initial = _v0.a;
				return (!_Utils_eq(initial.newPassword, state.current.newPassword)) ? _List_fromArray(
					[
						A2(
						$elm$html$Html$button,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('sp-icon is-right'),
								$elm$html$Html$Events$onClick(
								$author$project$ProfileUserbase$Model$UpdateNewPassword(initial.newPassword))
							]),
						_List_fromArray(
							[
								$elm$html$Html$text($author$project$Shared$Text$greenX)
							]))
					]) : _List_Nil;
			} else {
				return _List_Nil;
			}
		}();
		var inputType = state.showPasswords ? 'text' : 'password';
		var help = $author$project$Shared$Text$htmlTextLines(flags.labels.newPassword.description);
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('field is-horizontal')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-label is-normal')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help is-hidden-mobile')
												]),
											$author$project$Shared$Text$dropExtra(
												$author$project$Shared$Text$htmlBreaks(help)))
										])),
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class(
													A3($author$project$Shared$Text$has_danger, 'label ml-1', state.problems.newPasswordErr, false))
												]),
											_List_fromArray(
												[
													$elm$html$Html$text(flags.labels.newPassword.label)
												]))
										]))
								]))
						])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-body')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help')
												]),
											help)
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('field')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$div,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('control has-icons-right')
												]),
											_Utils_ap(
												_List_fromArray(
													[
														A2(
														$elm$html$Html$input,
														_List_fromArray(
															[
																$elm$html$Html$Attributes$class(
																A3($author$project$Shared$Text$is_danger, 'input', state.problems.newPasswordErr, false)),
																$elm$html$Html$Attributes$type_(inputType),
																$elm$html$Html$Attributes$placeholder(flags.labels.newPassword.placeholder),
																$elm$html$Html$Attributes$value(state.current.newPassword),
																$elm$html$Html$Attributes$autocomplete(false),
																$elm$html$Html$Events$onInput($author$project$ProfileUserbase$Model$UpdateNewPassword)
															]),
														_List_Nil)
													]),
												reset))
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('field')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$div,
											_List_Nil,
											_List_fromArray(
												[
													A2(
													$elm$html$Html$div,
													_List_Nil,
													_List_fromArray(
														[
															A2($author$project$ProfileUserbase$ViewError$viewNewPasswordError, flags, state)
														]))
												]))
										]))
								])),
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field-label is-normal'),
									A2($elm$html$Html$Attributes$style, 'max-width', '5px')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$label,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('label')
										]),
									_List_Nil)
								]))
						]))
				]));
	});
var $author$project$ProfileUserbase$Model$UpdateShowPasswords = function (a) {
	return {$: 'UpdateShowPasswords', a: a};
};
var $author$project$ProfileUserbase$View$viewShowPasswords = F2(
	function (flags, state) {
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('field is-horizontal')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-label is-normal')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('label ml-1')
												]),
											_List_fromArray(
												[
													$elm$html$Html$text(flags.labels.showPasswords.label)
												]))
										]))
								]))
						])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-body')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field'),
									A2($elm$html$Html$Attributes$style, 'display', 'table')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('checkbox'),
											A2($elm$html$Html$Attributes$style, 'display', 'table-cell'),
											A2($elm$html$Html$Attributes$style, 'vertical-align', 'middle')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$input,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('sp-checkbox ml-2 mt-2'),
													$elm$html$Html$Attributes$type_('checkbox'),
													$elm$html$Html$Attributes$checked(state.showPasswords),
													$elm$html$Html$Events$onCheck($author$project$ProfileUserbase$Model$UpdateShowPasswords)
												]),
											_List_Nil)
										]))
								])),
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field-label is-normal'),
									A2($elm$html$Html$Attributes$style, 'max-width', '5px')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$label,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('label')
										]),
									_List_Nil)
								]))
						]))
				]));
	});
var $author$project$ProfileUserbase$Model$UpdateUsername = function (a) {
	return {$: 'UpdateUsername', a: a};
};
var $author$project$ProfileUserbase$ViewError$viewUsernameError = F2(
	function (flags, state) {
		var _v0 = state.problems.usernameErr;
		if (_v0.$ === 'Just') {
			var reason = _v0.a;
			return A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('help is-danger')
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$p,
						_List_Nil,
						$author$project$Shared$Text$htmlTextLines(reason))
					]));
		} else {
			return A2($elm$html$Html$div, _List_Nil, _List_Nil);
		}
	});
var $author$project$ProfileUserbase$View$viewUsername = F2(
	function (flags, state) {
		var reset = function () {
			var _v0 = state.initial;
			if (_v0.$ === 'Just') {
				var initial = _v0.a;
				return (!_Utils_eq(initial.username, state.current.username)) ? _List_fromArray(
					[
						A2(
						$elm$html$Html$button,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('sp-icon is-right'),
								$elm$html$Html$Events$onClick(
								$author$project$ProfileUserbase$Model$UpdateUsername(initial.username))
							]),
						_List_fromArray(
							[
								$elm$html$Html$text($author$project$Shared$Text$greenX)
							]))
					]) : _List_Nil;
			} else {
				return _List_Nil;
			}
		}();
		var help = $author$project$Shared$Text$htmlTextLines(flags.labels.username.description);
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('field is-horizontal')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-label is-normal')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help is-hidden-mobile')
												]),
											$author$project$Shared$Text$dropExtra(
												$author$project$Shared$Text$htmlBreaks(help)))
										])),
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class(
													A3($author$project$Shared$Text$has_danger, 'label ml-1', state.problems.usernameErr, false))
												]),
											_List_fromArray(
												[
													$elm$html$Html$text(flags.labels.username.label)
												]))
										]))
								]))
						])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-body')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help')
												]),
											help)
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('field')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$div,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('control has-icons-right')
												]),
											_Utils_ap(
												_List_fromArray(
													[
														A2(
														$elm$html$Html$input,
														_List_fromArray(
															[
																$elm$html$Html$Attributes$class(
																A3($author$project$Shared$Text$is_danger, 'input', state.problems.usernameErr, false)),
																$elm$html$Html$Attributes$type_('text'),
																$elm$html$Html$Attributes$placeholder(flags.labels.username.placeholder),
																$elm$html$Html$Attributes$value(state.current.username),
																$elm$html$Html$Events$onInput($author$project$ProfileUserbase$Model$UpdateUsername)
															]),
														_List_Nil)
													]),
												reset))
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('field')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$div,
											_List_Nil,
											_List_fromArray(
												[
													A2(
													$elm$html$Html$div,
													_List_Nil,
													_List_fromArray(
														[
															A2($author$project$ProfileUserbase$ViewError$viewUsernameError, flags, state)
														]))
												]))
										]))
								])),
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field-label is-normal'),
									A2($elm$html$Html$Attributes$style, 'max-width', '5px')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$label,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('label')
										]),
									_List_Nil)
								]))
						]))
				]));
	});
var $author$project$ProfileUserbase$View$view = F2(
	function (flags, state) {
		return A2($author$project$ProfileUserbase$Model$showCurrentPassword, flags, state) ? A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('sp-form ml-3 mr-3 pb-3')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$br,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('is-hidden-mobile')
						]),
					_List_Nil),
					A2($author$project$ProfileUserbase$View$viewUsername, flags, state),
					A2($author$project$ProfileUserbase$View$viewShowPasswords, flags, state),
					A2($author$project$ProfileUserbase$View$viewCurrentPassword, flags, state),
					A2($author$project$ProfileUserbase$View$viewNewPassword, flags, state),
					A2($author$project$ProfileUserbase$View$viewConfirmPassword, flags, state)
				])) : A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('sp-form ml-3 mr-3 pb-3')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$br,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('is-hidden-mobile')
						]),
					_List_Nil),
					A2($author$project$ProfileUserbase$View$viewUsername, flags, state),
					A2($author$project$ProfileUserbase$View$viewShowPasswords, flags, state),
					A2($author$project$ProfileUserbase$View$viewNewPassword, flags, state),
					A2($author$project$ProfileUserbase$View$viewConfirmPassword, flags, state)
				]));
	});
var $author$project$ProfileView$View$ToggleProfileExpanded = {$: 'ToggleProfileExpanded'};
var $author$project$ProfileView$View$viewCard = F4(
	function (flags, profile, ishost, mexpanded) {
		var ribbontext = ishost ? flags.labels.preview.engagementHost : flags.labels.preview.guest;
		var marginbottom = function () {
			if ((mexpanded.$ === 'Just') && (!mexpanded.a)) {
				return _List_fromArray(
					[
						A2($elm$html$Html$Attributes$style, 'margin-bottom', '0px')
					]);
			} else {
				return _List_Nil;
			}
		}();
		var cardcontent = function () {
			var _v3 = _Utils_Tuple2(mexpanded, profile.paragraph);
			_v3$0:
			while (true) {
				if (_v3.b.$ === 'Just') {
					if ((_v3.a.$ === 'Just') && (!_v3.a.a)) {
						break _v3$0;
					} else {
						var paragraph = _v3.b.a;
						return A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('content mr-4')
								]),
							_Utils_ap(
								$author$project$Shared$Text$htmlTextLines(paragraph),
								_List_fromArray(
									[
										A2($elm$html$Html$br, _List_Nil, _List_Nil)
									])));
					}
				} else {
					if ((_v3.a.$ === 'Just') && (!_v3.a.a)) {
						break _v3$0;
					} else {
						var _v4 = _v3.b;
						return A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('content mr-4 has-text-grey-light')
								]),
							_List_fromArray(
								[
									$elm$html$Html$text(flags.labels.preview.paragraph),
									A2($elm$html$Html$br, _List_Nil, _List_Nil)
								]));
					}
				}
			}
			return A2($elm$html$Html$div, _List_Nil, _List_Nil);
		}();
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('card has-ribbon')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('ribbon is-primary')
						]),
					_List_fromArray(
						[
							$elm$html$Html$text(ribbontext)
						])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('card-content')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_Utils_ap(
								_List_fromArray(
									[
										$elm$html$Html$Attributes$class('media')
									]),
								marginbottom),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('media-left')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$div,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('image is-48x48')
												]),
											_List_fromArray(
												[
													function () {
													var _v0 = profile.thumbnail;
													if (_v0.$ === 'Nothing') {
														return A2($author$project$Shared$Icon$squareIcon, 48, profile.initials);
													} else {
														var url = _v0.a;
														return A2(
															$elm$html$Html$div,
															_List_fromArray(
																[
																	A2($elm$html$Html$Attributes$style, 'width', '48px'),
																	A2($elm$html$Html$Attributes$style, 'height', '48px'),
																	A2($elm$html$Html$Attributes$style, 'background-image', 'url(\'' + (url + '\')')),
																	A2($elm$html$Html$Attributes$style, 'background-position', 'center'),
																	A2($elm$html$Html$Attributes$style, 'background-repeat', 'no-repeat'),
																	A2($elm$html$Html$Attributes$style, 'background-size', 'contain')
																]),
															_List_Nil);
													}
												}()
												]))
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('media-content')
										]),
									_List_fromArray(
										[
											function () {
											var _v1 = profile.title;
											if (_v1 === '') {
												return A2(
													$elm$html$Html$p,
													_List_fromArray(
														[
															$elm$html$Html$Attributes$class('title is-4 has-text-grey-light')
														]),
													_List_fromArray(
														[
															$elm$html$Html$text(flags.labels.preview.title)
														]));
											} else {
												return A2(
													$elm$html$Html$p,
													_List_fromArray(
														[
															$elm$html$Html$Attributes$class('title is-4')
														]),
													_List_fromArray(
														[
															$elm$html$Html$text(profile.title)
														]));
											}
										}(),
											function () {
											var _v2 = profile.subtitle;
											if (_v2.$ === 'Nothing') {
												return A2(
													$elm$html$Html$p,
													_List_fromArray(
														[
															$elm$html$Html$Attributes$class('subtitle is-6 has-text-grey-light')
														]),
													_List_fromArray(
														[
															$elm$html$Html$text(flags.labels.preview.subtitle)
														]));
											} else {
												var subtitle = _v2.a;
												return A2(
													$elm$html$Html$p,
													_List_fromArray(
														[
															$elm$html$Html$Attributes$class('subtitle is-6')
														]),
													_List_fromArray(
														[
															$elm$html$Html$text(subtitle)
														]));
											}
										}()
										]))
								])),
							cardcontent
						]))
				]));
	});
var $author$project$ProfileView$View$view = F4(
	function (flags, profile, ishost, mexpanded) {
		if (mexpanded.$ === 'Nothing') {
			return A4($author$project$ProfileView$View$viewCard, flags, profile, ishost, mexpanded);
		} else {
			var expanded = mexpanded.a;
			return A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						A2($elm$html$Html$Attributes$style, 'transform', 'translate(-18px, 0px)'),
						A2($elm$html$Html$Attributes$style, 'display', 'flex')
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$div,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('is-narrow mr-1'),
								A2($elm$html$Html$Attributes$style, 'width', '24px'),
								A2($elm$html$Html$Attributes$style, 'min-width', '24px'),
								A2($elm$html$Html$Attributes$style, 'height', '24px'),
								$elm$html$Html$Events$onClick($author$project$ProfileView$View$ToggleProfileExpanded)
							]),
						_List_fromArray(
							[
								$author$project$Shared$Expand$svgExpandCollapse(expanded)
							])),
						A2(
						$elm$html$Html$div,
						_List_fromArray(
							[
								A2($elm$html$Html$Attributes$style, 'flex-grow', '1')
							]),
						_List_fromArray(
							[
								A4($author$project$ProfileView$View$viewCard, flags, profile, ishost, mexpanded)
							]))
					]));
		}
	});
var $author$project$Profile$view = function (model) {
	var _v0 = _Utils_Tuple2($author$project$Profile$currentView, model);
	_v0$6:
	while (true) {
		if (_v0.b.$ === 'Failed') {
			if (!_v0.a) {
				var err = _v0.b.a;
				return A2(
					$elm$html$Html$p,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('notification is-danger')
						]),
					_List_fromArray(
						[
							$elm$html$Html$text(err)
						]));
			} else {
				break _v0$6;
			}
		} else {
			switch (_v0.a) {
				case 0:
					var _v1 = _v0.b;
					var flags = _v1.a;
					var state = _v1.b;
					var ishost = $author$project$Profile$Model$isHost(state);
					return A2(
						$elm$html$Html$map,
						$author$project$Profile$Model$ProfileViewMsg,
						A4(
							$author$project$ProfileView$View$view,
							$author$project$Profile$profileViewFlags(flags),
							state.details.current,
							ishost,
							$elm$core$Maybe$Nothing));
				case 1:
					var _v2 = _v0.b;
					var flags = _v2.a;
					var state = _v2.b;
					return A2(
						$elm$html$Html$map,
						$author$project$Profile$Model$DetailsMsg,
						A4(
							$author$project$ProfileDetails$View$view,
							$author$project$Profile$detailsFlags(flags),
							state.details,
							state.topics,
							state.bundles));
				case 2:
					var _v3 = _v0.b;
					var flags = _v3.a;
					var state = _v3.b;
					return A2(
						$elm$html$Html$map,
						$author$project$Profile$Model$UserbaseMsg,
						A2(
							$author$project$ProfileUserbase$View$view,
							$author$project$Profile$userbaseFlags(flags),
							state.userbase));
				case 3:
					var _v4 = _v0.b;
					var flags = _v4.a;
					var state = _v4.b;
					return A2($author$project$Profile$View$view, flags, state);
				case 4:
					var _v5 = _v0.b;
					var flags = _v5.a;
					var state = _v5.b;
					return A2(
						$elm$html$Html$map,
						$author$project$Profile$Model$ProgressMsg,
						A2(
							$author$project$Progress$View$view,
							$author$project$Profile$progressFlags(flags),
							state.progress));
				default:
					break _v0$6;
			}
		}
	}
	return A2($elm$html$Html$div, _List_Nil, _List_Nil);
};
var $author$project$Profile$main = $elm$browser$Browser$element(
	{init: $author$project$Profile$init, subscriptions: $author$project$Profile$subscriptions, update: $author$project$Profile$update, view: $author$project$Profile$view});
var $author$project$MemberList$Model$Failed = function (a) {
	return {$: 'Failed', a: a};
};
var $author$project$MemberList$Model$Loaded = F2(
	function (a, b) {
		return {$: 'Loaded', a: a, b: b};
	});
var $author$project$MemberList$Flags$Flags = F3(
	function (config, extra, workflows) {
		return {config: config, extra: extra, workflows: workflows};
	});
var $author$project$MemberList$Flags$Extra = F6(
	function (memberlistView, mode, module_, progressView, viewNodes, workflowpaths) {
		return {memberlistView: memberlistView, mode: mode, module_: module_, progressView: progressView, viewNodes: viewNodes, workflowpaths: workflowpaths};
	});
var $author$project$MemberList$Flags$ExtraMemberlistView = F2(
	function (labels, transitions) {
		return {labels: labels, transitions: transitions};
	});
var $author$project$MemberList$Flags$ExtraMemberlistViewLabels = function (accepted) {
	return function (addMember) {
		return function (description) {
			return function (details) {
				return function (host) {
					return function (hostLink) {
						return function (invitationLink) {
							return function (invited) {
								return function (paragraph) {
									return function (searchMembers) {
										return function (shared) {
											return function (showExample) {
												return function (you) {
													return {accepted: accepted, addMember: addMember, description: description, details: details, host: host, hostLink: hostLink, invitationLink: invitationLink, invited: invited, paragraph: paragraph, searchMembers: searchMembers, shared: shared, showExample: showExample, you: you};
												};
											};
										};
									};
								};
							};
						};
					};
				};
			};
		};
	};
};
var $author$project$MemberList$Flags$ExtraMemberlistViewLabelsAccepted = function (label) {
	return {label: label};
};
var $author$project$MemberList$Flags$extraMemberlistViewLabelsAcceptedDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$MemberList$Flags$ExtraMemberlistViewLabelsAccepted,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$MemberList$Flags$ExtraMemberlistViewLabelsAddMember = function (label) {
	return {label: label};
};
var $author$project$MemberList$Flags$extraMemberlistViewLabelsAddMemberDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$MemberList$Flags$ExtraMemberlistViewLabelsAddMember,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$MemberList$Flags$ExtraMemberlistViewLabelsDescription = function (label) {
	return {label: label};
};
var $author$project$MemberList$Flags$extraMemberlistViewLabelsDescriptionDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$MemberList$Flags$ExtraMemberlistViewLabelsDescription,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$MemberList$Flags$ExtraMemberlistViewLabelsDetails = function (label) {
	return {label: label};
};
var $author$project$MemberList$Flags$extraMemberlistViewLabelsDetailsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$MemberList$Flags$ExtraMemberlistViewLabelsDetails,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$MemberList$Flags$ExtraMemberlistViewLabelsHost = function (label) {
	return {label: label};
};
var $author$project$MemberList$Flags$extraMemberlistViewLabelsHostDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$MemberList$Flags$ExtraMemberlistViewLabelsHost,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$MemberList$Flags$ExtraMemberlistViewLabelsHostLink = F2(
	function (copied, copy) {
		return {copied: copied, copy: copy};
	});
var $author$project$MemberList$Flags$extraMemberlistViewLabelsHostLinkDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$MemberList$Flags$ExtraMemberlistViewLabelsHostLink,
	A2($elm$json$Json$Decode$field, 'copied', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'copy', $elm$json$Json$Decode$string));
var $author$project$MemberList$Flags$ExtraMemberlistViewLabelsInvitationLink = function (label) {
	return {label: label};
};
var $author$project$MemberList$Flags$extraMemberlistViewLabelsInvitationLinkDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$MemberList$Flags$ExtraMemberlistViewLabelsInvitationLink,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$MemberList$Flags$ExtraMemberlistViewLabelsInvited = function (label) {
	return {label: label};
};
var $author$project$MemberList$Flags$extraMemberlistViewLabelsInvitedDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$MemberList$Flags$ExtraMemberlistViewLabelsInvited,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$MemberList$Flags$ExtraMemberlistViewLabelsParagraph = function (label) {
	return {label: label};
};
var $author$project$MemberList$Flags$extraMemberlistViewLabelsParagraphDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$MemberList$Flags$ExtraMemberlistViewLabelsParagraph,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$MemberList$Flags$ExtraMemberlistViewLabelsSearchMembers = function (placeholder) {
	return {placeholder: placeholder};
};
var $author$project$MemberList$Flags$extraMemberlistViewLabelsSearchMembersDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$MemberList$Flags$ExtraMemberlistViewLabelsSearchMembers,
	A2($elm$json$Json$Decode$field, 'placeholder', $elm$json$Json$Decode$string));
var $author$project$MemberList$Flags$ExtraMemberlistViewLabelsShared = F2(
	function (label, width) {
		return {label: label, width: width};
	});
var $author$project$MemberList$Flags$extraMemberlistViewLabelsSharedDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$MemberList$Flags$ExtraMemberlistViewLabelsShared,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$MemberList$Flags$ExtraMemberlistViewLabelsShowExample = function (label) {
	return {label: label};
};
var $author$project$MemberList$Flags$extraMemberlistViewLabelsShowExampleDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$MemberList$Flags$ExtraMemberlistViewLabelsShowExample,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$MemberList$Flags$ExtraMemberlistViewLabelsYou = function (label) {
	return {label: label};
};
var $author$project$MemberList$Flags$extraMemberlistViewLabelsYouDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$MemberList$Flags$ExtraMemberlistViewLabelsYou,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$MemberList$Flags$extraMemberlistViewLabelsDecoder = function () {
	var fieldSet0 = A9(
		$elm$json$Json$Decode$map8,
		$author$project$MemberList$Flags$ExtraMemberlistViewLabels,
		A2($elm$json$Json$Decode$field, 'accepted', $author$project$MemberList$Flags$extraMemberlistViewLabelsAcceptedDecoder),
		A2($elm$json$Json$Decode$field, 'add_member', $author$project$MemberList$Flags$extraMemberlistViewLabelsAddMemberDecoder),
		A2($elm$json$Json$Decode$field, 'description', $author$project$MemberList$Flags$extraMemberlistViewLabelsDescriptionDecoder),
		A2($elm$json$Json$Decode$field, 'details', $author$project$MemberList$Flags$extraMemberlistViewLabelsDetailsDecoder),
		A2($elm$json$Json$Decode$field, 'host', $author$project$MemberList$Flags$extraMemberlistViewLabelsHostDecoder),
		A2($elm$json$Json$Decode$field, 'host_link', $author$project$MemberList$Flags$extraMemberlistViewLabelsHostLinkDecoder),
		A2($elm$json$Json$Decode$field, 'invitation_link', $author$project$MemberList$Flags$extraMemberlistViewLabelsInvitationLinkDecoder),
		A2($elm$json$Json$Decode$field, 'invited', $author$project$MemberList$Flags$extraMemberlistViewLabelsInvitedDecoder));
	return A7(
		$elm$json$Json$Decode$map6,
		$elm$core$Basics$apL,
		fieldSet0,
		A2($elm$json$Json$Decode$field, 'paragraph', $author$project$MemberList$Flags$extraMemberlistViewLabelsParagraphDecoder),
		A2($elm$json$Json$Decode$field, 'search_members', $author$project$MemberList$Flags$extraMemberlistViewLabelsSearchMembersDecoder),
		A2($elm$json$Json$Decode$field, 'shared', $author$project$MemberList$Flags$extraMemberlistViewLabelsSharedDecoder),
		A2($elm$json$Json$Decode$field, 'show_example', $author$project$MemberList$Flags$extraMemberlistViewLabelsShowExampleDecoder),
		A2($elm$json$Json$Decode$field, 'you', $author$project$MemberList$Flags$extraMemberlistViewLabelsYouDecoder));
}();
var $author$project$MemberList$Flags$ExtraMemberlistViewTransitions = F2(
	function (add, details) {
		return {add: add, details: details};
	});
var $author$project$MemberList$Flags$extraMemberlistViewTransitionsDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$MemberList$Flags$ExtraMemberlistViewTransitions,
	A2($elm$json$Json$Decode$field, 'add', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'details', $elm$json$Json$Decode$string));
var $author$project$MemberList$Flags$extraMemberlistViewDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$MemberList$Flags$ExtraMemberlistView,
	A2($elm$json$Json$Decode$field, 'labels', $author$project$MemberList$Flags$extraMemberlistViewLabelsDecoder),
	A2($elm$json$Json$Decode$field, 'transitions', $author$project$MemberList$Flags$extraMemberlistViewTransitionsDecoder));
var $author$project$MemberList$Flags$ExtraProgressView = function (labels) {
	return {labels: labels};
};
var $author$project$MemberList$Flags$ExtraProgressViewLabels = F4(
	function (decodeErrors, diagnosticLogs, status, workflow) {
		return {decodeErrors: decodeErrors, diagnosticLogs: diagnosticLogs, status: status, workflow: workflow};
	});
var $author$project$MemberList$Flags$ExtraProgressViewLabelsDecodeErrors = function (label) {
	return {label: label};
};
var $author$project$MemberList$Flags$extraProgressViewLabelsDecodeErrorsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$MemberList$Flags$ExtraProgressViewLabelsDecodeErrors,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$MemberList$Flags$ExtraProgressViewLabelsDiagnosticLogs = function (label) {
	return {label: label};
};
var $author$project$MemberList$Flags$extraProgressViewLabelsDiagnosticLogsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$MemberList$Flags$ExtraProgressViewLabelsDiagnosticLogs,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$MemberList$Flags$ExtraProgressViewLabelsStatus = F2(
	function (failure, success) {
		return {failure: failure, success: success};
	});
var $author$project$MemberList$Flags$extraProgressViewLabelsStatusDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$MemberList$Flags$ExtraProgressViewLabelsStatus,
	A2($elm$json$Json$Decode$field, 'failure', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'success', $elm$json$Json$Decode$string));
var $author$project$MemberList$Flags$ExtraProgressViewLabelsWorkflow = function (label) {
	return {label: label};
};
var $author$project$MemberList$Flags$extraProgressViewLabelsWorkflowDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$MemberList$Flags$ExtraProgressViewLabelsWorkflow,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$MemberList$Flags$extraProgressViewLabelsDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$MemberList$Flags$ExtraProgressViewLabels,
	A2($elm$json$Json$Decode$field, 'decode_errors', $author$project$MemberList$Flags$extraProgressViewLabelsDecodeErrorsDecoder),
	A2($elm$json$Json$Decode$field, 'diagnostic_logs', $author$project$MemberList$Flags$extraProgressViewLabelsDiagnosticLogsDecoder),
	A2($elm$json$Json$Decode$field, 'status', $author$project$MemberList$Flags$extraProgressViewLabelsStatusDecoder),
	A2($elm$json$Json$Decode$field, 'workflow', $author$project$MemberList$Flags$extraProgressViewLabelsWorkflowDecoder));
var $author$project$MemberList$Flags$extraProgressViewDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$MemberList$Flags$ExtraProgressView,
	A2($elm$json$Json$Decode$field, 'labels', $author$project$MemberList$Flags$extraProgressViewLabelsDecoder));
var $author$project$MemberList$Flags$extraDecoder = A7(
	$elm$json$Json$Decode$map6,
	$author$project$MemberList$Flags$Extra,
	A2($elm$json$Json$Decode$field, 'memberlist_view', $author$project$MemberList$Flags$extraMemberlistViewDecoder),
	A2($elm$json$Json$Decode$field, 'mode', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'module', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'progress_view', $author$project$MemberList$Flags$extraProgressViewDecoder),
	A2(
		$elm$json$Json$Decode$field,
		'view_nodes',
		$elm$json$Json$Decode$list($elm$json$Json$Decode$string)),
	A2(
		$elm$json$Json$Decode$field,
		'workflowpaths',
		$elm$json$Json$Decode$list($elm$json$Json$Decode$string)));
var $author$project$MemberList$Flags$FlagsConfig = F3(
	function (baseUrl, defaultLanguage, extra) {
		return {baseUrl: baseUrl, defaultLanguage: defaultLanguage, extra: extra};
	});
var $author$project$MemberList$Flags$FlagsConfigExtra = F4(
	function (dev, originCollab, originReview, title) {
		return {dev: dev, originCollab: originCollab, originReview: originReview, title: title};
	});
var $author$project$MemberList$Flags$flagsConfigExtraDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$MemberList$Flags$FlagsConfigExtra,
	A2($elm$json$Json$Decode$field, 'dev', $elm$json$Json$Decode$bool),
	A2($elm$json$Json$Decode$field, 'origin_collab', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'origin_review', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'title', $elm$json$Json$Decode$string));
var $author$project$MemberList$Flags$flagsConfigDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$MemberList$Flags$FlagsConfig,
	A2($elm$json$Json$Decode$field, 'base_url', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'default_language', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'extra', $author$project$MemberList$Flags$flagsConfigExtraDecoder));
var $author$project$MemberList$Flags$FlagsWorkflowsObject = F3(
	function (name, label, progress) {
		return {label: label, name: name, progress: progress};
	});
var $author$project$MemberList$Flags$FlagsWorkflowsObjectProgressObject = F2(
	function (display, messages) {
		return {display: display, messages: messages};
	});
var $author$project$MemberList$Flags$FlagsWorkflowsObjectProgressObjectDisplay = F7(
	function (error, error2, init, ok, ok2, skip, skip2) {
		return {error: error, error2: error2, init: init, ok: ok, ok2: ok2, skip: skip, skip2: skip2};
	});
var $author$project$MemberList$Flags$flagsWorkflowsObjectProgressObjectDisplayDecoder = A8(
	$elm$json$Json$Decode$map7,
	$author$project$MemberList$Flags$FlagsWorkflowsObjectProgressObjectDisplay,
	A2($elm$json$Json$Decode$field, 'error', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'error2', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'init', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'ok', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'ok2', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'skip', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'skip2', $elm$json$Json$Decode$string));
var $author$project$MemberList$Flags$FlagsWorkflowsObjectProgressObjectMessages = F2(
	function (error, ok) {
		return {error: error, ok: ok};
	});
var $author$project$MemberList$Flags$flagsWorkflowsObjectProgressObjectMessagesDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$MemberList$Flags$FlagsWorkflowsObjectProgressObjectMessages,
	A2($elm$json$Json$Decode$field, 'error', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'ok', $elm$json$Json$Decode$string));
var $author$project$MemberList$Flags$flagsWorkflowsObjectProgressObjectDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$MemberList$Flags$FlagsWorkflowsObjectProgressObject,
	A2($elm$json$Json$Decode$field, 'display', $author$project$MemberList$Flags$flagsWorkflowsObjectProgressObjectDisplayDecoder),
	A2($elm$json$Json$Decode$field, 'messages', $author$project$MemberList$Flags$flagsWorkflowsObjectProgressObjectMessagesDecoder));
var $author$project$MemberList$Flags$flagsWorkflowsObjectDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$MemberList$Flags$FlagsWorkflowsObject,
	A2($elm$json$Json$Decode$field, 'name', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2(
		$elm$json$Json$Decode$field,
		'progress',
		$elm$json$Json$Decode$list($author$project$MemberList$Flags$flagsWorkflowsObjectProgressObjectDecoder)));
var $author$project$MemberList$Flags$flagsDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$MemberList$Flags$Flags,
	A2($elm$json$Json$Decode$field, 'config', $author$project$MemberList$Flags$flagsConfigDecoder),
	A2($elm$json$Json$Decode$field, 'extra', $author$project$MemberList$Flags$extraDecoder),
	A2(
		$elm$json$Json$Decode$field,
		'workflows',
		$elm$json$Json$Decode$list($author$project$MemberList$Flags$flagsWorkflowsObjectDecoder)));
var $author$project$MemberList$Flags$jsonToResultFlags = function (json) {
	return A2(
		$elm$core$Result$mapError,
		$elm$json$Json$Decode$errorToString,
		A2($elm$json$Json$Decode$decodeValue, $author$project$MemberList$Flags$flagsDecoder, json));
};
var $author$project$MemberList$Model$ProgressMsg = function (a) {
	return {$: 'ProgressMsg', a: a};
};
var $author$project$MemberList$progressCmds = function (pcmds) {
	return A2($elm$core$Platform$Cmd$map, $author$project$MemberList$Model$ProgressMsg, pcmds);
};
var $author$project$MemberList$progressFlags = function (flags) {
	return {labels: flags.extra.progressView.labels, workflows: flags.workflows};
};
var $author$project$MemberList$init = function (value) {
	var _v0 = $author$project$MemberList$Flags$jsonToResultFlags(value);
	if (_v0.$ === 'Err') {
		var err = _v0.a;
		return _Utils_Tuple2(
			$author$project$MemberList$Model$Failed(err),
			$elm$core$Platform$Cmd$none);
	} else {
		var flags = _v0.a;
		var _v1 = $author$project$Progress$Model$init(
			$author$project$MemberList$progressFlags(flags));
		var pstate = _v1.a;
		var pcmds = _v1.b;
		return _Utils_Tuple2(
			A2(
				$author$project$MemberList$Model$Loaded,
				flags,
				{auth: $krisajenkins$remotedata$RemoteData$NotAsked, bundles: $elm$core$Dict$empty, filter: '', members: $elm$core$Dict$empty, progress: pstate, response: $krisajenkins$remotedata$RemoteData$NotAsked, show_example: false}),
			$author$project$MemberList$progressCmds(pcmds));
	}
};
var $author$project$MemberList$Model$Incoming = function (a) {
	return {$: 'Incoming', a: a};
};
var $author$project$MemberList$subscriptions = function (model) {
	return $author$project$Shared$Ports$toElm($author$project$MemberList$Model$Incoming);
};
var $author$project$MemberList$Model$emptyBundle = {data: $elm$core$Maybe$Nothing};
var $author$project$MemberList$Model$updateBundle = F3(
	function (key, fn, state) {
		var bundle = function () {
			var _v0 = A2($elm$core$Dict$get, key, state.bundles);
			if (_v0.$ === 'Just') {
				var m = _v0.a;
				return m;
			} else {
				return $author$project$MemberList$Model$emptyBundle;
			}
		}();
		var newbundle = fn(bundle);
		return _Utils_update(
			state,
			{
				bundles: A3($elm$core$Dict$insert, key, newbundle, state.bundles)
			});
	});
var $author$project$MemberList$Model$emptyMember = {data: $elm$core$Maybe$Nothing, expanded: false, link: $elm$core$Maybe$Nothing, note: $elm$core$Maybe$Nothing, profile: $elm$core$Maybe$Nothing};
var $author$project$MemberList$Model$updateMember = F3(
	function (key, fn, state) {
		var member = function () {
			var _v0 = A2($elm$core$Dict$get, key, state.members);
			if (_v0.$ === 'Just') {
				var m = _v0.a;
				return m;
			} else {
				return $author$project$MemberList$Model$emptyMember;
			}
		}();
		var newmember = fn(member);
		return _Utils_update(
			state,
			{
				members: A3($elm$core$Dict$insert, key, newmember, state.members)
			});
	});
var $author$project$MemberList$updateStateCmds = F3(
	function (flags, state, cmds) {
		return _Utils_Tuple2(
			A2($author$project$MemberList$Model$Loaded, flags, state),
			cmds);
	});
var $author$project$MemberList$updateProgress = F3(
	function (flags, state, pmsg) {
		var _v0 = A3(
			$author$project$Progress$Model$update,
			$author$project$MemberList$progressFlags(flags),
			state.progress,
			pmsg);
		var pstate = _v0.a;
		var pcmds = _v0.b;
		return A3(
			$author$project$MemberList$updateStateCmds,
			flags,
			_Utils_update(
				state,
				{progress: pstate}),
			$author$project$MemberList$progressCmds(pcmds));
	});
var $author$project$MemberList$updateState = F2(
	function (flags, state) {
		return A3($author$project$MemberList$updateStateCmds, flags, state, $elm$core$Platform$Cmd$none);
	});
var $author$project$MemberList$Decode$IncomingAuth = function (a) {
	return {$: 'IncomingAuth', a: a};
};
var $author$project$MemberList$Decode$IncomingBundleData = F3(
	function (a, b, c) {
		return {$: 'IncomingBundleData', a: a, b: b, c: c};
	});
var $author$project$MemberList$Decode$IncomingError = function (a) {
	return {$: 'IncomingError', a: a};
};
var $author$project$MemberList$Decode$IncomingLink = F2(
	function (a, b) {
		return {$: 'IncomingLink', a: a, b: b};
	});
var $author$project$MemberList$Decode$IncomingMemberData = F2(
	function (a, b) {
		return {$: 'IncomingMemberData', a: a, b: b};
	});
var $author$project$MemberList$Decode$IncomingNote = F2(
	function (a, b) {
		return {$: 'IncomingNote', a: a, b: b};
	});
var $author$project$MemberList$Decode$IncomingProfileData = F2(
	function (a, b) {
		return {$: 'IncomingProfileData', a: a, b: b};
	});
var $author$project$MemberList$Decode$Progress = function (a) {
	return {$: 'Progress', a: a};
};
var $author$project$MemberData$Model$MemberData = F3(
	function (role, username, userid) {
		return {role: role, userid: userid, username: username};
	});
var $author$project$MemberData$Decode$memberDataDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$MemberData$Model$MemberData,
	A2($elm$json$Json$Decode$field, 'role', $author$project$MemberData$Decode$roleDecoder),
	A2($elm$json$Json$Decode$field, 'username', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'userid', $elm$json$Json$Decode$string));
var $author$project$MemberList$Decode$incomingMsgDecoderByMsg = function (msg) {
	switch (msg) {
		case 'error':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$MemberList$Decode$IncomingError,
				A2($elm$json$Json$Decode$field, 'details', $elm$json$Json$Decode$string));
		case 'auth':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$MemberList$Decode$IncomingAuth,
				A2($elm$json$Json$Decode$field, 'auth', $author$project$Auth$Decode$authDecoder));
		case 'member info':
			return A3(
				$elm$json$Json$Decode$map2,
				$author$project$MemberList$Decode$IncomingMemberData,
				A2($elm$json$Json$Decode$field, 'mnum', $elm$json$Json$Decode$int),
				A2($elm$json$Json$Decode$field, 'member', $author$project$MemberData$Decode$memberDataDecoder));
		case 'link info':
			return A3(
				$elm$json$Json$Decode$map2,
				$author$project$MemberList$Decode$IncomingLink,
				A2($elm$json$Json$Decode$field, 'mnum', $elm$json$Json$Decode$int),
				A2($elm$json$Json$Decode$field, 'link', $elm$json$Json$Decode$string));
		case 'profile info':
			return A3(
				$elm$json$Json$Decode$map2,
				$author$project$MemberList$Decode$IncomingProfileData,
				A2($elm$json$Json$Decode$field, 'mnum', $elm$json$Json$Decode$int),
				A2($elm$json$Json$Decode$field, 'profile', $author$project$ProfileData$Decode$profileDataDecoder));
		case 'note info':
			return A3(
				$elm$json$Json$Decode$map2,
				$author$project$MemberList$Decode$IncomingNote,
				A2($elm$json$Json$Decode$field, 'mnum', $elm$json$Json$Decode$int),
				A2($elm$json$Json$Decode$field, 'note', $elm$json$Json$Decode$string));
		case 'bundle info':
			return A4(
				$elm$json$Json$Decode$map3,
				$author$project$MemberList$Decode$IncomingBundleData,
				A2($elm$json$Json$Decode$field, 'bnum', $elm$json$Json$Decode$int),
				A2($elm$json$Json$Decode$field, 'bundle', $author$project$BundleData$Decode$bundleDataDecoder),
				A2($elm$json$Json$Decode$field, 'stats', $author$project$BundleStats$Decode$bundleStatsDecoder));
		case 'progress':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$MemberList$Decode$Progress,
				A2($elm$json$Json$Decode$field, 'progress', $elm$json$Json$Decode$value));
		default:
			var other = msg;
			return $elm$json$Json$Decode$fail(other);
	}
};
var $author$project$MemberList$Decode$incomingMsgDecoder = A2(
	$elm$json$Json$Decode$andThen,
	$author$project$MemberList$Decode$incomingMsgDecoderByMsg,
	A2($elm$json$Json$Decode$field, 'msg', $elm$json$Json$Decode$string));
var $author$project$MemberList$Decode$valueToIncomingMsg = function (value) {
	return function (x) {
		return x;
	}(
		A2(
			$elm$core$Result$mapError,
			$elm$json$Json$Decode$errorToString,
			A2($elm$json$Json$Decode$decodeValue, $author$project$MemberList$Decode$incomingMsgDecoder, value)));
};
var $author$project$MemberList$update = F2(
	function (msg, model) {
		var _v0 = _Utils_Tuple2(model, msg);
		if (_v0.a.$ === 'Failed') {
			return _Utils_Tuple2(model, $elm$core$Platform$Cmd$none);
		} else {
			switch (_v0.b.$) {
				case 'UpdateFilter':
					var _v1 = _v0.a;
					var flags = _v1.a;
					var state = _v1.b;
					var value = _v0.b.a;
					return A2(
						$author$project$MemberList$updateState,
						flags,
						_Utils_update(
							state,
							{filter: value, response: $krisajenkins$remotedata$RemoteData$NotAsked}));
				case 'UpdateShowExample':
					var _v2 = _v0.a;
					var flags = _v2.a;
					var state = _v2.b;
					var value = _v0.b.a;
					return A2(
						$author$project$MemberList$updateState,
						flags,
						_Utils_update(
							state,
							{response: $krisajenkins$remotedata$RemoteData$NotAsked, show_example: value}));
				case 'PressAddMember':
					var _v3 = _v0.a;
					var flags = _v3.a;
					var state = _v3.b;
					var _v4 = _v0.b;
					return A2($author$project$Shared$Cmd$cmdTransition, flags.extra.memberlistView.transitions.add, model);
				case 'ProgressMsg':
					var _v5 = _v0.a;
					var flags = _v5.a;
					var state = _v5.b;
					var pmsg = _v0.b.a;
					return A3($author$project$MemberList$updateProgress, flags, state, pmsg);
				case 'ToggleExpanded':
					var _v6 = _v0.a;
					var flags = _v6.a;
					var state = _v6.b;
					var key = _v0.b.a;
					var newstate = A3(
						$author$project$MemberList$Model$updateMember,
						key,
						function (m) {
							return _Utils_update(
								m,
								{expanded: !m.expanded});
						},
						state);
					return A2(
						$author$project$MemberList$updateState,
						flags,
						_Utils_update(
							newstate,
							{response: $krisajenkins$remotedata$RemoteData$NotAsked}));
				case 'PressDetails':
					var _v7 = _v0.a;
					var flags = _v7.a;
					var state = _v7.b;
					var key = _v0.b.a;
					return A3($author$project$Shared$Cmd$cmdTransitionNumber, flags.extra.memberlistView.transitions.details, key, model);
				default:
					var _v8 = _v0.a;
					var flags = _v8.a;
					var state = _v8.b;
					var v = _v0.b.a;
					var _v9 = $author$project$MemberList$Decode$valueToIncomingMsg(v);
					if (_v9.$ === 'Err') {
						var err = _v9.a;
						return $author$project$Shared$Reg$decodeErr(err) ? A3(
							$author$project$MemberList$updateProgress,
							flags,
							state,
							$author$project$Progress$Model$DecodeErr(err)) : A2($author$project$Shared$Cmd$cmdLog, 'Err ' + err, model);
					} else {
						switch (_v9.a.$) {
							case 'IncomingError':
								var err = _v9.a.a;
								return A2(
									$author$project$MemberList$updateState,
									flags,
									_Utils_update(
										state,
										{
											response: $krisajenkins$remotedata$RemoteData$Failure(err)
										}));
							case 'IncomingAuth':
								var auth = _v9.a.a;
								return A2(
									$author$project$MemberList$updateState,
									flags,
									_Utils_update(
										state,
										{
											auth: $krisajenkins$remotedata$RemoteData$Success(auth)
										}));
							case 'IncomingMemberData':
								var _v10 = _v9.a;
								var key = _v10.a;
								var data = _v10.b;
								var newstate = A3(
									$author$project$MemberList$Model$updateMember,
									key,
									function (m) {
										return _Utils_update(
											m,
											{
												data: $elm$core$Maybe$Just(data)
											});
									},
									state);
								return A2($author$project$MemberList$updateState, flags, newstate);
							case 'IncomingLink':
								var _v11 = _v9.a;
								var key = _v11.a;
								var link = _v11.b;
								var newstate = A3(
									$author$project$MemberList$Model$updateMember,
									key,
									function (m) {
										return _Utils_update(
											m,
											{
												link: $elm$core$Maybe$Just(link)
											});
									},
									state);
								return A2($author$project$MemberList$updateState, flags, newstate);
							case 'IncomingProfileData':
								var _v12 = _v9.a;
								var key = _v12.a;
								var profile = _v12.b;
								var newstate = A3(
									$author$project$MemberList$Model$updateMember,
									key,
									function (m) {
										return _Utils_update(
											m,
											{
												profile: $elm$core$Maybe$Just(profile)
											});
									},
									state);
								return A2($author$project$MemberList$updateState, flags, newstate);
							case 'IncomingNote':
								var _v13 = _v9.a;
								var key = _v13.a;
								var note = _v13.b;
								var newstate = A3(
									$author$project$MemberList$Model$updateMember,
									key,
									function (m) {
										return _Utils_update(
											m,
											{
												note: $elm$core$Maybe$Just(note)
											});
									},
									state);
								return A2($author$project$MemberList$updateState, flags, newstate);
							case 'IncomingBundleData':
								var _v14 = _v9.a;
								var bnum = _v14.a;
								var bundle = _v14.b;
								var stats = _v14.c;
								var newstate = A3(
									$author$project$MemberList$Model$updateBundle,
									bnum,
									function (b) {
										return _Utils_update(
											b,
											{
												data: $elm$core$Maybe$Just(bundle)
											});
									},
									state);
								return A2($author$project$MemberList$updateState, flags, newstate);
							default:
								var value = _v9.a.a;
								return A3(
									$author$project$MemberList$updateProgress,
									flags,
									state,
									$author$project$Progress$Model$Incoming(value));
						}
					}
			}
		}
	});
var $author$project$MemberList$currentView = 0;
var $author$project$MemberList$Model$PressAddMember = {$: 'PressAddMember'};
var $author$project$MemberList$View$viewAddSearch = F2(
	function (flags, state) {
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('columns pb-4'),
					A2($elm$html$Html$Attributes$style, 'border-bottom', '1px solid rgba(219,219,219,.5)')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('is-hidden-mobile mr-5')
						]),
					_List_fromArray(
						[
							$elm$html$Html$text($author$project$Shared$Text$nbsp)
						])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('column is-one-fifth')
						]),
					_List_fromArray(
						[
							function () {
							var _v0 = state.auth;
							if (_v0.$ === 'Success') {
								var auth = _v0.a;
								var _v1 = auth.role;
								if (_v1.$ === 'Host') {
									return A2(
										$elm$html$Html$button,
										_List_fromArray(
											[
												$elm$html$Html$Attributes$class('button has-background-primary-dark has-text-white'),
												$elm$html$Html$Events$onClick($author$project$MemberList$Model$PressAddMember)
											]),
										_List_fromArray(
											[
												$elm$html$Html$text(flags.extra.memberlistView.labels.addMember.label)
											]));
								} else {
									return $elm$html$Html$text($author$project$Shared$Text$nbsp);
								}
							} else {
								return $elm$html$Html$text($author$project$Shared$Text$nbsp);
							}
						}()
						])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('column is-hidden-mobile')
						]),
					_List_Nil)
				]));
	});
var $author$project$MemberList$Model$PressDetails = function (a) {
	return {$: 'PressDetails', a: a};
};
var $author$project$MemberList$Model$ToggleExpanded = function (a) {
	return {$: 'ToggleExpanded', a: a};
};
var $elm$html$Html$b = _VirtualDom_node('b');
var $author$project$MemberList$View$iSize = 20;
var $author$project$MemberList$View$viewCopyLink = F3(
	function (flags, key, link) {
		var eltid = 'hostlink-' + $elm$core$String$fromInt(key);
		return A2(
			$elm$html$Html$div,
			_List_Nil,
			_List_fromArray(
				[
					A2($elm$html$Html$br, _List_Nil, _List_Nil),
					A2(
					$elm$html$Html$span,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('tag mr-1'),
							A2($elm$html$Html$Attributes$style, 'user-select', 'none')
						]),
					_List_fromArray(
						[
							$elm$html$Html$text(flags.extra.memberlistView.labels.invitationLink.label)
						])),
					A3(
					$elm$html$Html$node,
					'clipboard-copy',
					_List_fromArray(
						[
							A2($elm$html$Html$Attributes$attribute, 'for', eltid),
							$elm$html$Html$Attributes$class('tag has-background-primary-dark has-text-white'),
							A2($elm$html$Html$Attributes$attribute, 'text-copied', flags.extra.memberlistView.labels.hostLink.copied),
							A2($elm$html$Html$Attributes$attribute, 'class-copied', 'tag is-white'),
							A2($elm$html$Html$Attributes$style, 'height', '20px'),
							A2($elm$html$Html$Attributes$style, 'user-select', 'none')
						]),
					_List_fromArray(
						[
							$elm$html$Html$text(flags.extra.memberlistView.labels.hostLink.copy)
						])),
					A2(
					$elm$html$Html$span,
					_List_fromArray(
						[
							A2($elm$html$Html$Attributes$style, 'user-select', 'none')
						]),
					_List_fromArray(
						[
							$elm$html$Html$text($author$project$Shared$Text$nbsp)
						])),
					A2(
					$elm$html$Html$span,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$id(eltid),
							$elm$html$Html$Attributes$class('is-size-7 mt-3'),
							A2($elm$html$Html$Attributes$style, 'word-break', 'break-all')
						]),
					_List_fromArray(
						[
							$elm$html$Html$text(link)
						]))
				]));
	});
var $author$project$MemberList$View$viewExpanded = F4(
	function (flags, state, key, member) {
		var paragraph_text = function () {
			var _v1 = member.profile;
			if (_v1.$ === 'Nothing') {
				return _List_Nil;
			} else {
				var profile = _v1.a;
				var _v2 = profile.paragraph;
				if (_v2.$ === 'Nothing') {
					return _List_Nil;
				} else {
					var paragraph = _v2.a;
					return _List_fromArray(
						[
							A2(
							$elm$html$Html$span,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('tag mr-1')
								]),
							_List_fromArray(
								[
									$elm$html$Html$text(flags.extra.memberlistView.labels.paragraph.label)
								])),
							A2(
							$elm$html$Html$span,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('mt-5')
								]),
							_List_fromArray(
								[
									$elm$html$Html$text(paragraph)
								]))
						]);
				}
			}
		}();
		var invitation_link = function () {
			var _v0 = member.link;
			if (_v0.$ === 'Nothing') {
				return _List_Nil;
			} else {
				var link = _v0.a;
				return _List_fromArray(
					[
						A3($author$project$MemberList$View$viewCopyLink, flags, key, link)
					]);
			}
		}();
		return member.expanded ? _Utils_ap(paragraph_text, invitation_link) : _List_Nil;
	});
var $author$project$MemberList$View$viewMember = F3(
	function (flags, state, _v0) {
		var key = _v0.a;
		var member = _v0.b;
		var sharedWith = function (b) {
			var _v16 = b.data;
			if (_v16.$ === 'Just') {
				var data = _v16.a;
				return A2($elm$core$List$member, key, data.shared_with) ? $elm$core$Maybe$Just(data.name) : $elm$core$Maybe$Nothing;
			} else {
				return $elm$core$Maybe$Nothing;
			}
		};
		var bundles = $elm$core$Dict$toList(state.bundles);
		var shared = A2(
			$elm$core$List$filterMap,
			function (_v15) {
				var i = _v15.a;
				var b = _v15.b;
				return sharedWith(b);
			},
			bundles);
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('media')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('mr-1'),
							A2($elm$html$Html$Attributes$style, 'width', '24px'),
							A2($elm$html$Html$Attributes$style, 'min-width', '24px'),
							A2($elm$html$Html$Attributes$style, 'height', '24px'),
							$elm$html$Html$Events$onClick(
							$author$project$MemberList$Model$ToggleExpanded(key))
						]),
					_List_fromArray(
						[
							$author$project$Shared$Expand$svgExpandCollapse(member.expanded)
						])),
					function () {
					var picture = function () {
						var _v1 = member.profile;
						if (_v1.$ === 'Nothing') {
							return A2($author$project$Shared$Icon$squareIcon, 48, '');
						} else {
							var profile = _v1.a;
							var _v2 = profile.thumbnail;
							if (_v2.$ === 'Nothing') {
								return A2($author$project$Shared$Icon$squareIcon, 48, profile.initials);
							} else {
								var url = _v2.a;
								return A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											A2($elm$html$Html$Attributes$style, 'width', '48px'),
											A2($elm$html$Html$Attributes$style, 'height', '48px'),
											A2($elm$html$Html$Attributes$style, 'background-image', 'url(\'' + (url + '\')')),
											A2($elm$html$Html$Attributes$style, 'background-position', 'center'),
											A2($elm$html$Html$Attributes$style, 'background-repeat', 'no-repeat'),
											A2($elm$html$Html$Attributes$style, 'background-size', 'contain')
										]),
									_List_Nil);
							}
						}
					}();
					var image_div = _List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('image is-48x48')
								]),
							_List_fromArray(
								[picture]))
						]);
					return A2(
						$elm$html$Html$div,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('media-left')
							]),
						image_div);
				}(),
					function () {
					var youtag = function () {
						var _v14 = state.auth;
						if (_v14.$ === 'Success') {
							var auth = _v14.a;
							return _Utils_eq(auth.mnum, key) ? _List_fromArray(
								[
									A2(
									$elm$html$Html$span,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('tag is-primary is-light mr-2 sp-floatright')
										]),
									_List_fromArray(
										[
											$elm$html$Html$text(flags.extra.memberlistView.labels.you.label)
										]))
								]) : _List_Nil;
						} else {
							return _List_Nil;
						}
					}();
					var subtitle_txt = function () {
						var _v12 = member.profile;
						if (_v12.$ === 'Nothing') {
							return _List_Nil;
						} else {
							var profile = _v12.a;
							var _v13 = profile.subtitle;
							if (_v13.$ === 'Just') {
								var subtitle = _v13.a;
								return _List_fromArray(
									[
										A2(
										$elm$html$Html$p,
										_List_fromArray(
											[
												$elm$html$Html$Attributes$class('subtitle is-6 mb-1')
											]),
										_List_fromArray(
											[
												$elm$html$Html$text(subtitle)
											]))
									]);
							} else {
								return _List_Nil;
							}
						}
					}();
					var shared_txt = function () {
						var floatleft = function (h) {
							return A2(
								$elm$html$Html$div,
								_List_fromArray(
									[
										$elm$html$Html$Attributes$class('sp-floatleft mr-1')
									]),
								h);
						};
						var sharedDiv = floatleft(
							_List_fromArray(
								[
									$elm$html$Html$text(flags.extra.memberlistView.labels.shared.label)
								]));
						var bundleDivs = function (name) {
							return A2(
								$elm$core$List$map,
								function (x) {
									return floatleft(
										_List_fromArray(
											[
												A2($author$project$Shared$Icon$roundIcon, $author$project$MemberList$View$iSize, x)
											]));
								},
								name);
						};
						if (!shared.b) {
							return _List_Nil;
						} else {
							var names = shared;
							return _List_fromArray(
								[
									A2($elm$html$Html$br, _List_Nil, _List_Nil),
									A2(
									$elm$html$Html$div,
									_List_Nil,
									A2(
										$elm$core$List$cons,
										sharedDiv,
										bundleDivs(shared))),
									A2($elm$html$Html$br, _List_Nil, _List_Nil)
								]);
						}
					}();
					var note_txt = function () {
						var _v9 = member.note;
						if (_v9.$ === 'Nothing') {
							return _List_Nil;
						} else {
							var note = _v9.a;
							if (note === '') {
								return _List_Nil;
							} else {
								var notetext = note;
								return _List_fromArray(
									[
										A2(
										$elm$html$Html$p,
										_List_fromArray(
											[
												$elm$html$Html$Attributes$class('subtitle mr-1 tag')
											]),
										_List_fromArray(
											[
												$elm$html$Html$text('Note')
											])),
										A2(
										$elm$html$Html$span,
										_List_fromArray(
											[
												$elm$html$Html$Attributes$class('subtitle is-6 is-italic')
											]),
										_List_fromArray(
											[
												$elm$html$Html$text(notetext)
											])),
										A2(
										$elm$html$Html$br,
										_List_fromArray(
											[
												$elm$html$Html$Attributes$class('mb-3')
											]),
										_List_Nil)
									]);
							}
						}
					}();
					var ishost = function () {
						var _v8 = member.data;
						if (_v8.$ === 'Nothing') {
							return false;
						} else {
							var data = _v8.a;
							return _Utils_eq(data.role, $author$project$MemberData$Model$Host);
						}
					}();
					var membertag = function () {
						var _v7 = _Utils_Tuple2(ishost, member.profile);
						if (_v7.a) {
							return _List_fromArray(
								[
									A2(
									$elm$html$Html$span,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('tag is-primary sp-floatright')
										]),
									_List_fromArray(
										[
											$elm$html$Html$text(flags.extra.memberlistView.labels.host.label)
										]))
								]);
						} else {
							if (_v7.b.$ === 'Just') {
								var profile = _v7.b.a;
								var atext = (!_Utils_eq(
									profile.accepted_on,
									$elm$time$Time$millisToPosix(0))) ? flags.extra.memberlistView.labels.accepted.label : flags.extra.memberlistView.labels.invited.label;
								return _List_fromArray(
									[
										A2(
										$elm$html$Html$span,
										_List_fromArray(
											[
												$elm$html$Html$Attributes$class('tag is-info is-light sp-floatright')
											]),
										_List_fromArray(
											[
												$elm$html$Html$text(atext)
											]))
									]);
							} else {
								return _List_Nil;
							}
						}
					}();
					var title_txt = function () {
						var _v6 = member.profile;
						if (_v6.$ === 'Nothing') {
							return _List_Nil;
						} else {
							var profile = _v6.a;
							return _List_fromArray(
								[
									A2(
									$elm$html$Html$p,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('title is-4')
										]),
									_Utils_ap(
										_List_fromArray(
											[
												$elm$html$Html$text(profile.title)
											]),
										_Utils_ap(membertag, youtag)))
								]);
						}
					}();
					var is_host = function () {
						var _v4 = state.auth;
						if (_v4.$ === 'Success') {
							var auth = _v4.a;
							var _v5 = auth.role;
							if (_v5.$ === 'Host') {
								return true;
							} else {
								return false;
							}
						} else {
							return false;
						}
					}();
					var user_txt = function () {
						var _v3 = _Utils_Tuple3(member.profile, is_host, member.data);
						_v3$2:
						while (true) {
							if (_v3.a.$ === 'Just') {
								if (_v3.b) {
									if (_v3.c.$ === 'Just') {
										var profile = _v3.a.a;
										var data = _v3.c.a;
										return _List_fromArray(
											[
												A2(
												$elm$html$Html$b,
												_List_Nil,
												_List_fromArray(
													[
														$elm$html$Html$text(profile.moniker)
													])),
												A2(
												$elm$html$Html$span,
												_List_fromArray(
													[
														$elm$html$Html$Attributes$class('is-size-7'),
														A2($elm$html$Html$Attributes$style, 'line-height', '2'),
														A2($elm$html$Html$Attributes$style, 'user-select', 'none')
													]),
												_List_fromArray(
													[
														$elm$html$Html$text($author$project$Shared$Text$nbsp),
														$elm$html$Html$text('(')
													])),
												A2(
												$elm$html$Html$span,
												_List_fromArray(
													[
														$elm$html$Html$Attributes$class('is-size-7'),
														A2($elm$html$Html$Attributes$style, 'line-height', '2'),
														A2($elm$html$Html$Attributes$style, 'overflow', 'hidden'),
														A2($elm$html$Html$Attributes$style, 'white-space', 'nowrap'),
														A2($elm$html$Html$Attributes$style, 'text-overflow', 'ellipsis')
													]),
												_List_fromArray(
													[
														$elm$html$Html$text(data.username)
													])),
												A2(
												$elm$html$Html$span,
												_List_fromArray(
													[
														$elm$html$Html$Attributes$class('is-size-7'),
														A2($elm$html$Html$Attributes$style, 'line-height', '2'),
														A2($elm$html$Html$Attributes$style, 'user-select', 'none')
													]),
												_List_fromArray(
													[
														$elm$html$Html$text(')')
													]))
											]);
									} else {
										break _v3$2;
									}
								} else {
									var profile = _v3.a.a;
									return _List_fromArray(
										[
											A2(
											$elm$html$Html$b,
											_List_Nil,
											_List_fromArray(
												[
													$elm$html$Html$text(profile.moniker)
												]))
										]);
								}
							} else {
								break _v3$2;
							}
						}
						return _List_Nil;
					}();
					var details_pulledright = _List_fromArray(
						[
							A2(
							$elm$html$Html$button,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('button is-pulled-right has-background-primary-dark has-text-white'),
									$elm$html$Html$Events$onClick(
									$author$project$MemberList$Model$PressDetails(key))
								]),
							_List_fromArray(
								[
									$elm$html$Html$text(flags.extra.memberlistView.labels.details.label)
								]))
						]);
					return A2(
						$elm$html$Html$div,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('media-content'),
								A2($elm$html$Html$Attributes$style, 'overflow-x', 'visible'),
								A2($elm$html$Html$Attributes$style, 'overflow-y', 'visible')
							]),
						_Utils_ap(
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('columns mb-0')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$div,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('column is-7')
												]),
											_Utils_ap(
												title_txt,
												_Utils_ap(subtitle_txt, note_txt))),
											A2(
											$elm$html$Html$div,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('column is-5'),
													A2($elm$html$Html$Attributes$style, 'border-left', '1px solid rgba(219,219,219,.5)')
												]),
											_Utils_ap(
												user_txt,
												_Utils_ap(details_pulledright, shared_txt)))
										]))
								]),
							A4($author$project$MemberList$View$viewExpanded, flags, state, key, member)));
				}()
				]));
	});
var $author$project$MemberList$View$viewMembers = F2(
	function (flags, state) {
		var _v0 = state.filter;
		if (_v0 === '') {
			return A2(
				$elm$core$List$map,
				A2($author$project$MemberList$View$viewMember, flags, state),
				$elm$core$Dict$toList(state.members));
		} else {
			var filter = _v0;
			return A2(
				$elm$core$List$map,
				A2($author$project$MemberList$View$viewMember, flags, state),
				A2(
					$elm$core$List$take,
					1,
					$elm$core$Dict$toList(state.members)));
		}
	});
var $author$project$MemberList$View$view = F2(
	function (flags, state) {
		return A2(
			$elm$html$Html$div,
			_List_Nil,
			A2(
				$elm$core$List$cons,
				A2($author$project$MemberList$View$viewAddSearch, flags, state),
				A2($author$project$MemberList$View$viewMembers, flags, state)));
	});
var $author$project$MemberList$view = function (model) {
	var _v0 = _Utils_Tuple2($author$project$MemberList$currentView, model);
	_v0$3:
	while (true) {
		if (_v0.b.$ === 'Failed') {
			if (!_v0.a) {
				var err = _v0.b.a;
				return A2(
					$elm$html$Html$p,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('notification is-danger')
						]),
					_List_fromArray(
						[
							$elm$html$Html$text(err)
						]));
			} else {
				break _v0$3;
			}
		} else {
			switch (_v0.a) {
				case 0:
					var _v1 = _v0.b;
					var flags = _v1.a;
					var state = _v1.b;
					return A2($author$project$MemberList$View$view, flags, state);
				case 1:
					var _v2 = _v0.b;
					var flags = _v2.a;
					var state = _v2.b;
					return A2(
						$elm$html$Html$map,
						$author$project$MemberList$Model$ProgressMsg,
						A2(
							$author$project$Progress$View$view,
							$author$project$MemberList$progressFlags(flags),
							state.progress));
				default:
					break _v0$3;
			}
		}
	}
	return A2($elm$html$Html$div, _List_Nil, _List_Nil);
};
var $author$project$MemberList$main = $elm$browser$Browser$element(
	{init: $author$project$MemberList$init, subscriptions: $author$project$MemberList$subscriptions, update: $author$project$MemberList$update, view: $author$project$MemberList$view});
var $author$project$Member$Model$Failed = function (a) {
	return {$: 'Failed', a: a};
};
var $author$project$Member$Model$Loaded = F2(
	function (a, b) {
		return {$: 'Loaded', a: a, b: b};
	});
var $author$project$Member$Model$DetailsMsg = function (a) {
	return {$: 'DetailsMsg', a: a};
};
var $author$project$Member$detailsCmds = function (dcmds) {
	return A2($elm$core$Platform$Cmd$map, $author$project$Member$Model$DetailsMsg, dcmds);
};
var $author$project$Member$detailsFlags = function (flags) {
	return {errors: flags.extra.profileDetails.errors, initial: flags.extra.profileDetails.initial, labels: flags.extra.profileDetails.labels, readonly: flags.extra.profileDetails.readonly};
};
var $author$project$MemberBundles$Model$init = function (flags) {
	return _Utils_Tuple2(
		{added: $elm$core$Set$empty, auth: $elm$core$Maybe$Nothing, bundles: $elm$core$Dict$empty, initial: $elm$core$Set$empty, memberdata: $elm$core$Maybe$Nothing, mnum: $elm$core$Maybe$Nothing, removed: $elm$core$Set$empty},
		$elm$core$Platform$Cmd$none);
};
var $author$project$Note$Model$init = function (flags) {
	return _Utils_Tuple2(
		{current: '', initial: $elm$core$Maybe$Nothing},
		$elm$core$Platform$Cmd$none);
};
var $author$project$Member$Flags$Flags = F3(
	function (config, extra, workflows) {
		return {config: config, extra: extra, workflows: workflows};
	});
var $author$project$Member$Flags$Extra = function (memberBundles) {
	return function (memberNotes) {
		return function (memberSubmit) {
			return function (mode) {
				return function (module_) {
					return function (plurals) {
						return function (profileDetails) {
							return function (profileView) {
								return function (progressView) {
									return function (remoteData) {
										return function (viewNodes) {
											return {memberBundles: memberBundles, memberNotes: memberNotes, memberSubmit: memberSubmit, mode: mode, module_: module_, plurals: plurals, profileDetails: profileDetails, profileView: profileView, progressView: progressView, remoteData: remoteData, viewNodes: viewNodes};
										};
									};
								};
							};
						};
					};
				};
			};
		};
	};
};
var $author$project$Member$Flags$ExtraMemberBundles = F2(
	function (labels, transitions) {
		return {labels: labels, transitions: transitions};
	});
var $author$project$Member$Flags$ExtraMemberBundlesLabels = F9(
	function (checkbox, description, details, folders, mount, name, reset, restricted, size) {
		return {checkbox: checkbox, description: description, details: details, folders: folders, mount: mount, name: name, reset: reset, restricted: restricted, size: size};
	});
var $author$project$Member$Flags$ExtraMemberBundlesLabelsCheckbox = function (width) {
	return {width: width};
};
var $author$project$Member$Flags$extraMemberBundlesLabelsCheckboxDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Member$Flags$ExtraMemberBundlesLabelsCheckbox,
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$ExtraMemberBundlesLabelsDescription = F4(
	function (hostViewMember, memberViewOther, memberViewSelf, viewHost) {
		return {hostViewMember: hostViewMember, memberViewOther: memberViewOther, memberViewSelf: memberViewSelf, viewHost: viewHost};
	});
var $author$project$Member$Flags$extraMemberBundlesLabelsDescriptionDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$Member$Flags$ExtraMemberBundlesLabelsDescription,
	A2($elm$json$Json$Decode$field, 'host_view_member', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'member_view_other', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'member_view_self', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'view_host', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$ExtraMemberBundlesLabelsDetails = F2(
	function (label, width) {
		return {label: label, width: width};
	});
var $author$project$Member$Flags$extraMemberBundlesLabelsDetailsDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Member$Flags$ExtraMemberBundlesLabelsDetails,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$ExtraMemberBundlesLabelsFolders = F2(
	function (label, width) {
		return {label: label, width: width};
	});
var $author$project$Member$Flags$extraMemberBundlesLabelsFoldersDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Member$Flags$ExtraMemberBundlesLabelsFolders,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$ExtraMemberBundlesLabelsMount = F2(
	function (label, width) {
		return {label: label, width: width};
	});
var $author$project$Member$Flags$extraMemberBundlesLabelsMountDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Member$Flags$ExtraMemberBundlesLabelsMount,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$ExtraMemberBundlesLabelsName = F2(
	function (label, width) {
		return {label: label, width: width};
	});
var $author$project$Member$Flags$extraMemberBundlesLabelsNameDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Member$Flags$ExtraMemberBundlesLabelsName,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$ExtraMemberBundlesLabelsReset = F2(
	function (label, width) {
		return {label: label, width: width};
	});
var $author$project$Member$Flags$extraMemberBundlesLabelsResetDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Member$Flags$ExtraMemberBundlesLabelsReset,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$ExtraMemberBundlesLabelsRestricted = F4(
	function (datalabel, description, value, width) {
		return {datalabel: datalabel, description: description, value: value, width: width};
	});
var $author$project$Member$Flags$extraMemberBundlesLabelsRestrictedDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$Member$Flags$ExtraMemberBundlesLabelsRestricted,
	A2($elm$json$Json$Decode$field, 'datalabel', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'value', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$ExtraMemberBundlesLabelsSize = F2(
	function (label, width) {
		return {label: label, width: width};
	});
var $author$project$Member$Flags$extraMemberBundlesLabelsSizeDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Member$Flags$ExtraMemberBundlesLabelsSize,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$extraMemberBundlesLabelsDecoder = function () {
	var fieldSet0 = A9(
		$elm$json$Json$Decode$map8,
		$author$project$Member$Flags$ExtraMemberBundlesLabels,
		A2($elm$json$Json$Decode$field, 'checkbox', $author$project$Member$Flags$extraMemberBundlesLabelsCheckboxDecoder),
		A2($elm$json$Json$Decode$field, 'description', $author$project$Member$Flags$extraMemberBundlesLabelsDescriptionDecoder),
		A2($elm$json$Json$Decode$field, 'details', $author$project$Member$Flags$extraMemberBundlesLabelsDetailsDecoder),
		A2($elm$json$Json$Decode$field, 'folders', $author$project$Member$Flags$extraMemberBundlesLabelsFoldersDecoder),
		A2($elm$json$Json$Decode$field, 'mount', $author$project$Member$Flags$extraMemberBundlesLabelsMountDecoder),
		A2($elm$json$Json$Decode$field, 'name', $author$project$Member$Flags$extraMemberBundlesLabelsNameDecoder),
		A2($elm$json$Json$Decode$field, 'reset', $author$project$Member$Flags$extraMemberBundlesLabelsResetDecoder),
		A2($elm$json$Json$Decode$field, 'restricted', $author$project$Member$Flags$extraMemberBundlesLabelsRestrictedDecoder));
	return A3(
		$elm$json$Json$Decode$map2,
		$elm$core$Basics$apL,
		fieldSet0,
		A2($elm$json$Json$Decode$field, 'size', $author$project$Member$Flags$extraMemberBundlesLabelsSizeDecoder));
}();
var $author$project$Member$Flags$ExtraMemberBundlesTransitions = function (details) {
	return {details: details};
};
var $author$project$Member$Flags$extraMemberBundlesTransitionsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Member$Flags$ExtraMemberBundlesTransitions,
	A2($elm$json$Json$Decode$field, 'details', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$extraMemberBundlesDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Member$Flags$ExtraMemberBundles,
	A2($elm$json$Json$Decode$field, 'labels', $author$project$Member$Flags$extraMemberBundlesLabelsDecoder),
	A2($elm$json$Json$Decode$field, 'transitions', $author$project$Member$Flags$extraMemberBundlesTransitionsDecoder));
var $author$project$Member$Flags$ExtraMemberNotes = F2(
	function (initial, labels) {
		return {initial: initial, labels: labels};
	});
var $author$project$Member$Flags$ExtraMemberNotesLabels = function (note) {
	return {note: note};
};
var $author$project$Member$Flags$ExtraMemberNotesLabelsNote = F3(
	function (description, label, placeholder) {
		return {description: description, label: label, placeholder: placeholder};
	});
var $author$project$Member$Flags$extraMemberNotesLabelsNoteDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Member$Flags$ExtraMemberNotesLabelsNote,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'placeholder', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$extraMemberNotesLabelsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Member$Flags$ExtraMemberNotesLabels,
	A2($elm$json$Json$Decode$field, 'note', $author$project$Member$Flags$extraMemberNotesLabelsNoteDecoder));
var $author$project$Member$Flags$extraMemberNotesDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Member$Flags$ExtraMemberNotes,
	A2($elm$json$Json$Decode$field, 'initial', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'labels', $author$project$Member$Flags$extraMemberNotesLabelsDecoder));
var $author$project$Member$Flags$ExtraMemberSubmit = F3(
	function (labels, requests, transitions) {
		return {labels: labels, requests: requests, transitions: transitions};
	});
var $author$project$Member$Flags$ExtraMemberSubmitLabels = F7(
	function (invitationLink, note, pause, profile, shared, submit, title) {
		return {invitationLink: invitationLink, note: note, pause: pause, profile: profile, shared: shared, submit: submit, title: title};
	});
var $author$project$Member$Flags$ExtraMemberSubmitLabelsInvitationLink = F4(
	function (copied, copy, description, label) {
		return {copied: copied, copy: copy, description: description, label: label};
	});
var $author$project$Member$Flags$extraMemberSubmitLabelsInvitationLinkDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$Member$Flags$ExtraMemberSubmitLabelsInvitationLink,
	A2($elm$json$Json$Decode$field, 'copied', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'copy', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$ExtraMemberSubmitLabelsNote = function (initial) {
	return {initial: initial};
};
var $author$project$Member$Flags$extraMemberSubmitLabelsNoteDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Member$Flags$ExtraMemberSubmitLabelsNote,
	A2($elm$json$Json$Decode$field, 'initial', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$ExtraMemberSubmitLabelsPause = F2(
	function (description, label) {
		return {description: description, label: label};
	});
var $author$project$Member$Flags$extraMemberSubmitLabelsPauseDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Member$Flags$ExtraMemberSubmitLabelsPause,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$ExtraMemberSubmitLabelsProfile = function (initial) {
	return {initial: initial};
};
var $author$project$Member$Flags$extraMemberSubmitLabelsProfileDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Member$Flags$ExtraMemberSubmitLabelsProfile,
	A2($elm$json$Json$Decode$field, 'initial', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$ExtraMemberSubmitLabelsShared = function (initial) {
	return {initial: initial};
};
var $author$project$Member$Flags$extraMemberSubmitLabelsSharedDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Member$Flags$ExtraMemberSubmitLabelsShared,
	A2($elm$json$Json$Decode$field, 'initial', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$ExtraMemberSubmitLabelsSubmit = F6(
	function (changed, failed, label, unchanged, updated, width) {
		return {changed: changed, failed: failed, label: label, unchanged: unchanged, updated: updated, width: width};
	});
var $author$project$Member$Flags$extraMemberSubmitLabelsSubmitDecoder = A7(
	$elm$json$Json$Decode$map6,
	$author$project$Member$Flags$ExtraMemberSubmitLabelsSubmit,
	A2($elm$json$Json$Decode$field, 'changed', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'failed', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'unchanged', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'updated', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$ExtraMemberSubmitLabelsTitle = function (label) {
	return {label: label};
};
var $author$project$Member$Flags$extraMemberSubmitLabelsTitleDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Member$Flags$ExtraMemberSubmitLabelsTitle,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$extraMemberSubmitLabelsDecoder = A8(
	$elm$json$Json$Decode$map7,
	$author$project$Member$Flags$ExtraMemberSubmitLabels,
	A2($elm$json$Json$Decode$field, 'invitation_link', $author$project$Member$Flags$extraMemberSubmitLabelsInvitationLinkDecoder),
	A2($elm$json$Json$Decode$field, 'note', $author$project$Member$Flags$extraMemberSubmitLabelsNoteDecoder),
	A2($elm$json$Json$Decode$field, 'pause', $author$project$Member$Flags$extraMemberSubmitLabelsPauseDecoder),
	A2($elm$json$Json$Decode$field, 'profile', $author$project$Member$Flags$extraMemberSubmitLabelsProfileDecoder),
	A2($elm$json$Json$Decode$field, 'shared', $author$project$Member$Flags$extraMemberSubmitLabelsSharedDecoder),
	A2($elm$json$Json$Decode$field, 'submit', $author$project$Member$Flags$extraMemberSubmitLabelsSubmitDecoder),
	A2($elm$json$Json$Decode$field, 'title', $author$project$Member$Flags$extraMemberSubmitLabelsTitleDecoder));
var $author$project$Member$Flags$ExtraMemberSubmitRequests = function (submit) {
	return {submit: submit};
};
var $author$project$Member$Flags$extraMemberSubmitRequestsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Member$Flags$ExtraMemberSubmitRequests,
	A2($elm$json$Json$Decode$field, 'submit', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$ExtraMemberSubmitTransitions = F2(
	function (linkPrefix, view) {
		return {linkPrefix: linkPrefix, view: view};
	});
var $author$project$Member$Flags$extraMemberSubmitTransitionsDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Member$Flags$ExtraMemberSubmitTransitions,
	A2($elm$json$Json$Decode$field, 'link_prefix', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'view', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$extraMemberSubmitDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Member$Flags$ExtraMemberSubmit,
	A2($elm$json$Json$Decode$field, 'labels', $author$project$Member$Flags$extraMemberSubmitLabelsDecoder),
	A2($elm$json$Json$Decode$field, 'requests', $author$project$Member$Flags$extraMemberSubmitRequestsDecoder),
	A2($elm$json$Json$Decode$field, 'transitions', $author$project$Member$Flags$extraMemberSubmitTransitionsDecoder));
var $author$project$Member$Flags$ExtraPlurals = function (comments) {
	return function (files) {
		return function (folders) {
			return function (noComments) {
				return function (noFiles) {
					return function (noFolders) {
						return function (noUnread) {
							return function (oneComment) {
								return function (oneFile) {
									return function (oneFolder) {
										return function (oneUnread) {
											return function (unread) {
												return {comments: comments, files: files, folders: folders, noComments: noComments, noFiles: noFiles, noFolders: noFolders, noUnread: noUnread, oneComment: oneComment, oneFile: oneFile, oneFolder: oneFolder, oneUnread: oneUnread, unread: unread};
											};
										};
									};
								};
							};
						};
					};
				};
			};
		};
	};
};
var $author$project$Member$Flags$extraPluralsDecoder = function () {
	var fieldSet0 = A9(
		$elm$json$Json$Decode$map8,
		$author$project$Member$Flags$ExtraPlurals,
		A2($elm$json$Json$Decode$field, 'comments', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'files', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'folders', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'no_comments', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'no_files', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'no_folders', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'no_unread', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'one_comment', $elm$json$Json$Decode$string));
	return A6(
		$elm$json$Json$Decode$map5,
		$elm$core$Basics$apL,
		fieldSet0,
		A2($elm$json$Json$Decode$field, 'one_file', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'one_folder', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'one_unread', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'unread', $elm$json$Json$Decode$string));
}();
var $author$project$Member$Flags$ExtraProfileDetails = F4(
	function (errors, initial, labels, readonly) {
		return {errors: errors, initial: initial, labels: labels, readonly: readonly};
	});
var $author$project$Member$Flags$ExtraProfileDetailsErrors = F4(
	function (initials, moniker, remotedata, title) {
		return {initials: initials, moniker: moniker, remotedata: remotedata, title: title};
	});
var $author$project$Member$Flags$ExtraProfileDetailsErrorsInitials = F2(
	function (syntax, unique) {
		return {syntax: syntax, unique: unique};
	});
var $author$project$Member$Flags$extraProfileDetailsErrorsInitialsDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Member$Flags$ExtraProfileDetailsErrorsInitials,
	A2($elm$json$Json$Decode$field, 'syntax', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'unique', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$ExtraProfileDetailsErrorsMoniker = F2(
	function (syntax, unique) {
		return {syntax: syntax, unique: unique};
	});
var $author$project$Member$Flags$extraProfileDetailsErrorsMonikerDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Member$Flags$ExtraProfileDetailsErrorsMoniker,
	A2($elm$json$Json$Decode$field, 'syntax', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'unique', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$ExtraProfileDetailsErrorsRemotedata = F2(
	function (loading, notasked) {
		return {loading: loading, notasked: notasked};
	});
var $author$project$Member$Flags$extraProfileDetailsErrorsRemotedataDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Member$Flags$ExtraProfileDetailsErrorsRemotedata,
	A2($elm$json$Json$Decode$field, 'loading', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'notasked', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$ExtraProfileDetailsErrorsTitle = F2(
	function (syntax, unique) {
		return {syntax: syntax, unique: unique};
	});
var $author$project$Member$Flags$extraProfileDetailsErrorsTitleDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Member$Flags$ExtraProfileDetailsErrorsTitle,
	A2($elm$json$Json$Decode$field, 'syntax', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'unique', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$extraProfileDetailsErrorsDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$Member$Flags$ExtraProfileDetailsErrors,
	A2($elm$json$Json$Decode$field, 'initials', $author$project$Member$Flags$extraProfileDetailsErrorsInitialsDecoder),
	A2($elm$json$Json$Decode$field, 'moniker', $author$project$Member$Flags$extraProfileDetailsErrorsMonikerDecoder),
	A2($elm$json$Json$Decode$field, 'remotedata', $author$project$Member$Flags$extraProfileDetailsErrorsRemotedataDecoder),
	A2($elm$json$Json$Decode$field, 'title', $author$project$Member$Flags$extraProfileDetailsErrorsTitleDecoder));
var $author$project$Member$Flags$ExtraProfileDetailsLabels = F7(
	function (homepage, initials, moniker, paragraph, subtitle, thumbnail, title) {
		return {homepage: homepage, initials: initials, moniker: moniker, paragraph: paragraph, subtitle: subtitle, thumbnail: thumbnail, title: title};
	});
var $author$project$Member$Flags$ExtraProfileDetailsLabelsHomepage = F6(
	function (bundle, description, label, topic, topiclist, width) {
		return {bundle: bundle, description: description, label: label, topic: topic, topiclist: topiclist, width: width};
	});
var $author$project$Member$Flags$extraProfileDetailsLabelsHomepageDecoder = A7(
	$elm$json$Json$Decode$map6,
	$author$project$Member$Flags$ExtraProfileDetailsLabelsHomepage,
	A2($elm$json$Json$Decode$field, 'bundle', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'topic', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'topiclist', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$ExtraProfileDetailsLabelsInitials = F6(
	function (description, label, placeholder, required, syntax, unique) {
		return {description: description, label: label, placeholder: placeholder, required: required, syntax: syntax, unique: unique};
	});
var $author$project$Member$Flags$extraProfileDetailsLabelsInitialsDecoder = A7(
	$elm$json$Json$Decode$map6,
	$author$project$Member$Flags$ExtraProfileDetailsLabelsInitials,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'placeholder', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'required', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'syntax', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'unique', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$ExtraProfileDetailsLabelsMoniker = F6(
	function (description, label, placeholder, required, syntax, unique) {
		return {description: description, label: label, placeholder: placeholder, required: required, syntax: syntax, unique: unique};
	});
var $author$project$Member$Flags$extraProfileDetailsLabelsMonikerDecoder = A7(
	$elm$json$Json$Decode$map6,
	$author$project$Member$Flags$ExtraProfileDetailsLabelsMoniker,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'placeholder', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'required', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'syntax', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'unique', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$ExtraProfileDetailsLabelsParagraph = F3(
	function (description, label, placeholder) {
		return {description: description, label: label, placeholder: placeholder};
	});
var $author$project$Member$Flags$extraProfileDetailsLabelsParagraphDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Member$Flags$ExtraProfileDetailsLabelsParagraph,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'placeholder', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$ExtraProfileDetailsLabelsSubtitle = F3(
	function (description, label, placeholder) {
		return {description: description, label: label, placeholder: placeholder};
	});
var $author$project$Member$Flags$extraProfileDetailsLabelsSubtitleDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Member$Flags$ExtraProfileDetailsLabelsSubtitle,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'placeholder', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$ExtraProfileDetailsLabelsThumbnail = F5(
	function (description, label, remove, upload, visible) {
		return {description: description, label: label, remove: remove, upload: upload, visible: visible};
	});
var $author$project$Member$Flags$extraProfileDetailsLabelsThumbnailDecoder = A6(
	$elm$json$Json$Decode$map5,
	$author$project$Member$Flags$ExtraProfileDetailsLabelsThumbnail,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'remove', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'upload', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'visible', $elm$json$Json$Decode$bool));
var $author$project$Member$Flags$ExtraProfileDetailsLabelsTitle = F6(
	function (description, label, placeholder, required, syntax, unique) {
		return {description: description, label: label, placeholder: placeholder, required: required, syntax: syntax, unique: unique};
	});
var $author$project$Member$Flags$extraProfileDetailsLabelsTitleDecoder = A7(
	$elm$json$Json$Decode$map6,
	$author$project$Member$Flags$ExtraProfileDetailsLabelsTitle,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'placeholder', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'required', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'syntax', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'unique', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$extraProfileDetailsLabelsDecoder = A8(
	$elm$json$Json$Decode$map7,
	$author$project$Member$Flags$ExtraProfileDetailsLabels,
	A2($elm$json$Json$Decode$field, 'homepage', $author$project$Member$Flags$extraProfileDetailsLabelsHomepageDecoder),
	A2($elm$json$Json$Decode$field, 'initials', $author$project$Member$Flags$extraProfileDetailsLabelsInitialsDecoder),
	A2($elm$json$Json$Decode$field, 'moniker', $author$project$Member$Flags$extraProfileDetailsLabelsMonikerDecoder),
	A2($elm$json$Json$Decode$field, 'paragraph', $author$project$Member$Flags$extraProfileDetailsLabelsParagraphDecoder),
	A2($elm$json$Json$Decode$field, 'subtitle', $author$project$Member$Flags$extraProfileDetailsLabelsSubtitleDecoder),
	A2($elm$json$Json$Decode$field, 'thumbnail', $author$project$Member$Flags$extraProfileDetailsLabelsThumbnailDecoder),
	A2($elm$json$Json$Decode$field, 'title', $author$project$Member$Flags$extraProfileDetailsLabelsTitleDecoder));
var $author$project$Member$Flags$extraProfileDetailsDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$Member$Flags$ExtraProfileDetails,
	A2($elm$json$Json$Decode$field, 'errors', $author$project$Member$Flags$extraProfileDetailsErrorsDecoder),
	A2($elm$json$Json$Decode$field, 'initial', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'labels', $author$project$Member$Flags$extraProfileDetailsLabelsDecoder),
	A2($elm$json$Json$Decode$field, 'readonly', $elm$json$Json$Decode$bool));
var $author$project$Member$Flags$ExtraProfileView = F2(
	function (initial, labels) {
		return {initial: initial, labels: labels};
	});
var $author$project$Member$Flags$ExtraProfileViewLabels = function (preview) {
	return {preview: preview};
};
var $author$project$Member$Flags$ExtraProfileViewLabelsPreview = F5(
	function (engagementHost, guest, paragraph, subtitle, title) {
		return {engagementHost: engagementHost, guest: guest, paragraph: paragraph, subtitle: subtitle, title: title};
	});
var $author$project$Member$Flags$extraProfileViewLabelsPreviewDecoder = A6(
	$elm$json$Json$Decode$map5,
	$author$project$Member$Flags$ExtraProfileViewLabelsPreview,
	A2($elm$json$Json$Decode$field, 'engagement_host', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'guest', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'paragraph', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'subtitle', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'title', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$extraProfileViewLabelsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Member$Flags$ExtraProfileViewLabels,
	A2($elm$json$Json$Decode$field, 'preview', $author$project$Member$Flags$extraProfileViewLabelsPreviewDecoder));
var $author$project$Member$Flags$extraProfileViewDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Member$Flags$ExtraProfileView,
	A2($elm$json$Json$Decode$field, 'initial', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'labels', $author$project$Member$Flags$extraProfileViewLabelsDecoder));
var $author$project$Member$Flags$ExtraProgressView = function (labels) {
	return {labels: labels};
};
var $author$project$Member$Flags$ExtraProgressViewLabels = F4(
	function (decodeErrors, diagnosticLogs, status, workflow) {
		return {decodeErrors: decodeErrors, diagnosticLogs: diagnosticLogs, status: status, workflow: workflow};
	});
var $author$project$Member$Flags$ExtraProgressViewLabelsDecodeErrors = function (label) {
	return {label: label};
};
var $author$project$Member$Flags$extraProgressViewLabelsDecodeErrorsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Member$Flags$ExtraProgressViewLabelsDecodeErrors,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$ExtraProgressViewLabelsDiagnosticLogs = function (label) {
	return {label: label};
};
var $author$project$Member$Flags$extraProgressViewLabelsDiagnosticLogsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Member$Flags$ExtraProgressViewLabelsDiagnosticLogs,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$ExtraProgressViewLabelsStatus = F2(
	function (failure, success) {
		return {failure: failure, success: success};
	});
var $author$project$Member$Flags$extraProgressViewLabelsStatusDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Member$Flags$ExtraProgressViewLabelsStatus,
	A2($elm$json$Json$Decode$field, 'failure', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'success', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$ExtraProgressViewLabelsWorkflow = function (label) {
	return {label: label};
};
var $author$project$Member$Flags$extraProgressViewLabelsWorkflowDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Member$Flags$ExtraProgressViewLabelsWorkflow,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$extraProgressViewLabelsDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$Member$Flags$ExtraProgressViewLabels,
	A2($elm$json$Json$Decode$field, 'decode_errors', $author$project$Member$Flags$extraProgressViewLabelsDecodeErrorsDecoder),
	A2($elm$json$Json$Decode$field, 'diagnostic_logs', $author$project$Member$Flags$extraProgressViewLabelsDiagnosticLogsDecoder),
	A2($elm$json$Json$Decode$field, 'status', $author$project$Member$Flags$extraProgressViewLabelsStatusDecoder),
	A2($elm$json$Json$Decode$field, 'workflow', $author$project$Member$Flags$extraProgressViewLabelsWorkflowDecoder));
var $author$project$Member$Flags$extraProgressViewDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Member$Flags$ExtraProgressView,
	A2($elm$json$Json$Decode$field, 'labels', $author$project$Member$Flags$extraProgressViewLabelsDecoder));
var $author$project$Member$Flags$ExtraRemoteData = F2(
	function (loading, notasked) {
		return {loading: loading, notasked: notasked};
	});
var $author$project$Member$Flags$extraRemoteDataDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Member$Flags$ExtraRemoteData,
	A2($elm$json$Json$Decode$field, 'loading', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'notasked', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$extraDecoder = function () {
	var fieldSet0 = A9(
		$elm$json$Json$Decode$map8,
		$author$project$Member$Flags$Extra,
		A2($elm$json$Json$Decode$field, 'member_bundles', $author$project$Member$Flags$extraMemberBundlesDecoder),
		A2($elm$json$Json$Decode$field, 'member_notes', $author$project$Member$Flags$extraMemberNotesDecoder),
		A2($elm$json$Json$Decode$field, 'member_submit', $author$project$Member$Flags$extraMemberSubmitDecoder),
		A2($elm$json$Json$Decode$field, 'mode', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'module', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'plurals', $author$project$Member$Flags$extraPluralsDecoder),
		A2($elm$json$Json$Decode$field, 'profile_details', $author$project$Member$Flags$extraProfileDetailsDecoder),
		A2($elm$json$Json$Decode$field, 'profile_view', $author$project$Member$Flags$extraProfileViewDecoder));
	return A5(
		$elm$json$Json$Decode$map4,
		$elm$core$Basics$apL,
		fieldSet0,
		A2($elm$json$Json$Decode$field, 'progress_view', $author$project$Member$Flags$extraProgressViewDecoder),
		A2($elm$json$Json$Decode$field, 'remote_data', $author$project$Member$Flags$extraRemoteDataDecoder),
		A2(
			$elm$json$Json$Decode$field,
			'view_nodes',
			$elm$json$Json$Decode$list($elm$json$Json$Decode$string)));
}();
var $author$project$Member$Flags$FlagsConfig = F3(
	function (baseUrl, defaultLanguage, extra) {
		return {baseUrl: baseUrl, defaultLanguage: defaultLanguage, extra: extra};
	});
var $author$project$Member$Flags$FlagsConfigExtra = F4(
	function (dev, originCollab, originReview, title) {
		return {dev: dev, originCollab: originCollab, originReview: originReview, title: title};
	});
var $author$project$Member$Flags$flagsConfigExtraDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$Member$Flags$FlagsConfigExtra,
	A2($elm$json$Json$Decode$field, 'dev', $elm$json$Json$Decode$bool),
	A2($elm$json$Json$Decode$field, 'origin_collab', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'origin_review', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'title', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$flagsConfigDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Member$Flags$FlagsConfig,
	A2($elm$json$Json$Decode$field, 'base_url', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'default_language', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'extra', $author$project$Member$Flags$flagsConfigExtraDecoder));
var $author$project$Member$Flags$FlagsWorkflowsObject = F3(
	function (name, label, progress) {
		return {label: label, name: name, progress: progress};
	});
var $author$project$Member$Flags$FlagsWorkflowsObjectProgressObject = F2(
	function (display, messages) {
		return {display: display, messages: messages};
	});
var $author$project$Member$Flags$FlagsWorkflowsObjectProgressObjectDisplay = F7(
	function (error, error2, init, ok, ok2, skip, skip2) {
		return {error: error, error2: error2, init: init, ok: ok, ok2: ok2, skip: skip, skip2: skip2};
	});
var $author$project$Member$Flags$flagsWorkflowsObjectProgressObjectDisplayDecoder = A8(
	$elm$json$Json$Decode$map7,
	$author$project$Member$Flags$FlagsWorkflowsObjectProgressObjectDisplay,
	A2($elm$json$Json$Decode$field, 'error', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'error2', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'init', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'ok', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'ok2', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'skip', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'skip2', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$FlagsWorkflowsObjectProgressObjectMessages = F2(
	function (error, ok) {
		return {error: error, ok: ok};
	});
var $author$project$Member$Flags$flagsWorkflowsObjectProgressObjectMessagesDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Member$Flags$FlagsWorkflowsObjectProgressObjectMessages,
	A2($elm$json$Json$Decode$field, 'error', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'ok', $elm$json$Json$Decode$string));
var $author$project$Member$Flags$flagsWorkflowsObjectProgressObjectDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Member$Flags$FlagsWorkflowsObjectProgressObject,
	A2($elm$json$Json$Decode$field, 'display', $author$project$Member$Flags$flagsWorkflowsObjectProgressObjectDisplayDecoder),
	A2($elm$json$Json$Decode$field, 'messages', $author$project$Member$Flags$flagsWorkflowsObjectProgressObjectMessagesDecoder));
var $author$project$Member$Flags$flagsWorkflowsObjectDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Member$Flags$FlagsWorkflowsObject,
	A2($elm$json$Json$Decode$field, 'name', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2(
		$elm$json$Json$Decode$field,
		'progress',
		$elm$json$Json$Decode$list($author$project$Member$Flags$flagsWorkflowsObjectProgressObjectDecoder)));
var $author$project$Member$Flags$flagsDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Member$Flags$Flags,
	A2($elm$json$Json$Decode$field, 'config', $author$project$Member$Flags$flagsConfigDecoder),
	A2($elm$json$Json$Decode$field, 'extra', $author$project$Member$Flags$extraDecoder),
	A2(
		$elm$json$Json$Decode$field,
		'workflows',
		$elm$json$Json$Decode$list($author$project$Member$Flags$flagsWorkflowsObjectDecoder)));
var $author$project$Member$Flags$jsonToResultFlags = function (json) {
	return A2(
		$elm$core$Result$mapError,
		$elm$json$Json$Decode$errorToString,
		A2($elm$json$Json$Decode$decodeValue, $author$project$Member$Flags$flagsDecoder, json));
};
var $author$project$Member$Model$MemberBundlesMsg = function (a) {
	return {$: 'MemberBundlesMsg', a: a};
};
var $author$project$Member$memberBundlesCmds = function (bcmds) {
	return A2($elm$core$Platform$Cmd$map, $author$project$Member$Model$MemberBundlesMsg, bcmds);
};
var $author$project$Member$memberBundlesFlags = function (flags) {
	return {labels: flags.extra.memberBundles.labels, transitions: flags.extra.memberBundles.transitions};
};
var $author$project$Member$Model$NoteMsg = function (a) {
	return {$: 'NoteMsg', a: a};
};
var $author$project$Member$noteCmds = function (ncmds) {
	return A2($elm$core$Platform$Cmd$map, $author$project$Member$Model$NoteMsg, ncmds);
};
var $author$project$Member$noteFlags = function (flags) {
	return {initial: flags.extra.memberNotes.initial, labels: flags.extra.memberNotes.labels};
};
var $author$project$Member$Model$ProgressMsg = function (a) {
	return {$: 'ProgressMsg', a: a};
};
var $author$project$Member$progressCmds = function (pcmds) {
	return A2($elm$core$Platform$Cmd$map, $author$project$Member$Model$ProgressMsg, pcmds);
};
var $author$project$Member$progressFlags = function (flags) {
	return {labels: flags.extra.progressView.labels, workflows: flags.workflows};
};
var $author$project$Member$init = function (value) {
	var _v0 = $author$project$Member$Flags$jsonToResultFlags(value);
	if (_v0.$ === 'Err') {
		var err = _v0.a;
		return _Utils_Tuple2(
			$author$project$Member$Model$Failed(err),
			$elm$core$Platform$Cmd$none);
	} else {
		var flags = _v0.a;
		var _v1 = $author$project$Progress$Model$init(
			$author$project$Member$progressFlags(flags));
		var pstate = _v1.a;
		var pcmds = _v1.b;
		var _v2 = $author$project$Note$Model$init(
			$author$project$Member$noteFlags(flags));
		var nstate = _v2.a;
		var ncmds = _v2.b;
		var _v3 = $author$project$ProfileDetails$Model$init(
			$author$project$Member$detailsFlags(flags));
		var dstate = _v3.a;
		var dcmds = _v3.b;
		var _v4 = $author$project$MemberBundles$Model$init(
			$author$project$Member$memberBundlesFlags(flags));
		var bstate = _v4.a;
		var bcmds = _v4.b;
		return _Utils_Tuple2(
			A2(
				$author$project$Member$Model$Loaded,
				flags,
				{auth: $krisajenkins$remotedata$RemoteData$NotAsked, bundles: $elm$core$Dict$empty, details: dstate, link: $elm$core$Maybe$Nothing, memberbundles: bstate, memberdata: $elm$core$Maybe$Nothing, mnum: $elm$core$Maybe$Nothing, note: nstate, options_expanded: false, pause: false, progress: pstate, result: $krisajenkins$remotedata$RemoteData$NotAsked, topics: $elm$core$Dict$empty}),
			$elm$core$Platform$Cmd$batch(
				_List_fromArray(
					[
						$author$project$Member$detailsCmds(dcmds),
						$author$project$Member$noteCmds(ncmds),
						$author$project$Member$memberBundlesCmds(bcmds),
						$author$project$Member$progressCmds(pcmds)
					])));
	}
};
var $author$project$Member$Model$Incoming = function (a) {
	return {$: 'Incoming', a: a};
};
var $author$project$Member$subscriptions = function (model) {
	if (model.$ === 'Failed') {
		var err = model.a;
		return $elm$core$Platform$Sub$none;
	} else {
		var flags = model.a;
		var state = model.b;
		return $author$project$Shared$Ports$toElm($author$project$Member$Model$Incoming);
	}
};
var $author$project$MemberBundles$Model$IncomingAuth = function (a) {
	return {$: 'IncomingAuth', a: a};
};
var $author$project$MemberBundles$Model$IncomingBundleData = F3(
	function (a, b, c) {
		return {$: 'IncomingBundleData', a: a, b: b, c: c};
	});
var $author$project$MemberBundles$Model$IncomingMemberData = F2(
	function (a, b) {
		return {$: 'IncomingMemberData', a: a, b: b};
	});
var $author$project$Note$Model$IncomingNote = function (a) {
	return {$: 'IncomingNote', a: a};
};
var $author$project$Note$Model$noteChanged = F2(
	function (initial, current) {
		if (initial.$ === 'Nothing') {
			return true;
		} else {
			var data = initial.a;
			return false || (!_Utils_eq(data, current));
		}
	});
var $author$project$Member$Cmd$cmdSubmitRequest = F2(
	function (flags, state) {
		var newstate = _Utils_update(
			state,
			{result: $krisajenkins$remotedata$RemoteData$Loading});
		var ms = flags.extra.memberSubmit;
		var encodeRemoved = _List_fromArray(
			[
				_Utils_Tuple2(
				'removed',
				A2(
					$elm$json$Json$Encode$list,
					$elm$json$Json$Encode$int,
					$elm$core$Set$toList(state.memberbundles.removed)))
			]);
		var encodeProfile = A2($author$project$ProfileData$Model$profileDataChanged, state.details.initial, state.details.current) ? _List_fromArray(
			[
				_Utils_Tuple2(
				'profile',
				$author$project$ProfileData$Encode$profileDataToValue(state.details.current))
			]) : _List_Nil;
		var encodePrefix = _List_fromArray(
			[
				_Utils_Tuple2(
				'prefix',
				$elm$json$Json$Encode$string(ms.transitions.linkPrefix))
			]);
		var encodeNote = A2($author$project$Note$Model$noteChanged, state.note.initial, state.note.current) ? _List_fromArray(
			[
				_Utils_Tuple2(
				'note',
				$elm$json$Json$Encode$string(state.note.current))
			]) : _List_Nil;
		var encodeMnum = function () {
			var _v0 = state.mnum;
			if (_v0.$ === 'Just') {
				var mnum = _v0.a;
				return _List_fromArray(
					[
						_Utils_Tuple2(
						'mnum',
						$elm$json$Json$Encode$int(mnum))
					]);
			} else {
				return _List_Nil;
			}
		}();
		var encodeKind = _List_fromArray(
			[
				_Utils_Tuple2(
				'kind',
				$elm$json$Json$Encode$string(ms.requests.submit))
			]);
		var encodeAdded = _List_fromArray(
			[
				_Utils_Tuple2(
				'added',
				A2(
					$elm$json$Json$Encode$list,
					$elm$json$Json$Encode$int,
					$elm$core$Set$toList(state.memberbundles.added)))
			]);
		var encoders = _Utils_ap(
			_List_Nil,
			_Utils_ap(
				encodeKind,
				_Utils_ap(
					encodePrefix,
					_Utils_ap(
						encodeMnum,
						_Utils_ap(
							encodeProfile,
							_Utils_ap(
								encodeNote,
								_Utils_ap(encodeAdded, encodeRemoved)))))));
		var request = $elm$json$Json$Encode$object(encoders);
		return _Utils_Tuple2(
			A2($author$project$Member$Model$Loaded, flags, newstate),
			$author$project$Shared$Ports$toMain(request));
	});
var $author$project$MemberBundles$Model$memberBundlesChanged = F2(
	function (added, removed) {
		return ($elm$core$Set$isEmpty(added) && $elm$core$Set$isEmpty(removed)) ? false : true;
	});
var $author$project$Member$View$somethingChanged = F2(
	function (flags, state) {
		return A2($author$project$ProfileData$Model$profileDataChanged, state.details.initial, state.details.current) ? true : (A2($author$project$Note$Model$noteChanged, state.note.initial, state.note.current) ? true : (A2($author$project$MemberBundles$Model$memberBundlesChanged, state.memberbundles.added, state.memberbundles.removed) ? true : false));
	});
var $author$project$Member$View$currentError = F2(
	function (flags, state) {
		var updated = A2($author$project$Member$View$somethingChanged, flags, state);
		var ms = flags.extra.memberSubmit;
		var emsg = $elm_community$maybe_extra$Maybe$Extra$orList(
			_List_fromArray(
				[
					state.details.readonly ? $elm$core$Maybe$Nothing : $author$project$ProfileDetails$Model$profileErr(state.details.problems)
				]));
		var _v0 = _Utils_Tuple3(emsg, updated, state.result);
		if (_v0.a.$ === 'Just') {
			var x = _v0.a.a;
			return $elm$core$Result$Err(x);
		} else {
			if (_v0.b) {
				var _v1 = _v0.a;
				return $elm$core$Result$Ok(ms.labels.submit.changed);
			} else {
				if (_v0.c.$ === 'Success') {
					var _v2 = _v0.a;
					return $elm$core$Result$Ok(ms.labels.submit.updated);
				} else {
					var _v3 = _v0.a;
					return $elm$core$Result$Ok(ms.labels.submit.unchanged);
				}
			}
		}
	});
var $author$project$Member$View$okToSubmit = F2(
	function (flags, state) {
		return true && (A2($author$project$Member$View$somethingChanged, flags, state) && ($elm_community$result_extra$Result$Extra$isOk(
			A2($author$project$Member$View$currentError, flags, state)) && (!_Utils_eq(state.result, $krisajenkins$remotedata$RemoteData$Loading))));
	});
var $author$project$MemberBundles$Model$recalcInitial = function (state) {
	var _v0 = state.mnum;
	if (_v0.$ === 'Nothing') {
		return state;
	} else {
		var mnum = _v0.a;
		var bundles = A2(
			$elm$core$List$filter,
			function (_v2) {
				var bnum = _v2.a;
				var b = _v2.b;
				return A2($elm$core$List$member, mnum, b.data.shared_with);
			},
			$elm$core$Dict$toList(state.bundles));
		return _Utils_update(
			state,
			{
				initial: $elm$core$Set$fromList(
					A2(
						$elm$core$List$map,
						function (_v1) {
							var bnum = _v1.a;
							return bnum;
						},
						bundles))
			});
	}
};
var $author$project$MemberBundles$Model$updateBundle = F4(
	function (key, data, stats, state) {
		var newbundle = {data: data, stats: stats};
		return _Utils_update(
			state,
			{
				bundles: A3($elm$core$Dict$insert, key, newbundle, state.bundles)
			});
	});
var $author$project$MemberBundles$Model$updateShared = F4(
	function (flags, bnum, shared, state) {
		return shared ? _Utils_update(
			state,
			{
				added: A2($elm$core$Set$member, bnum, state.initial) ? state.added : A2($elm$core$Set$insert, bnum, state.added),
				removed: A2($elm$core$Set$remove, bnum, state.removed)
			}) : _Utils_update(
			state,
			{
				added: A2($elm$core$Set$remove, bnum, state.added),
				removed: A2($elm$core$Set$member, bnum, state.initial) ? A2($elm$core$Set$insert, bnum, state.removed) : state.removed
			});
	});
var $author$project$MemberBundles$Model$update = F3(
	function (flags, state1, msg) {
		switch (msg.$) {
			case 'UpdateShared':
				var bnum = msg.a;
				var value = msg.b;
				var state = A4($author$project$MemberBundles$Model$updateShared, flags, bnum, value, state1);
				return _Utils_Tuple2(state, $elm$core$Platform$Cmd$none);
			case 'PressDetails':
				var bnum = msg.a;
				return A3($author$project$Shared$Cmd$cmdTransitionNumber, flags.transitions.details, bnum, state1);
			case 'PressReset':
				var state = _Utils_update(
					state1,
					{added: $elm$core$Set$empty, removed: $elm$core$Set$empty});
				return _Utils_Tuple2(state, $elm$core$Platform$Cmd$none);
			case 'IncomingAuth':
				var auth = msg.a;
				var state = _Utils_update(
					state1,
					{
						auth: $elm$core$Maybe$Just(auth)
					});
				return _Utils_Tuple2(state, $elm$core$Platform$Cmd$none);
			case 'IncomingMemberData':
				var mnum = msg.a;
				var memberdata = msg.b;
				var state = _Utils_update(
					state1,
					{
						memberdata: $elm$core$Maybe$Just(memberdata),
						mnum: $elm$core$Maybe$Just(mnum)
					});
				return _Utils_Tuple2(
					$author$project$MemberBundles$Model$recalcInitial(state),
					$elm$core$Platform$Cmd$none);
			default:
				var bnum = msg.a;
				var data = msg.b;
				var stats = msg.c;
				var state = A4($author$project$MemberBundles$Model$updateBundle, bnum, data, stats, state1);
				return _Utils_Tuple2(
					$author$project$MemberBundles$Model$recalcInitial(state),
					$elm$core$Platform$Cmd$none);
		}
	});
var $author$project$Member$updateStateCmds = F3(
	function (flags, cmds, state) {
		return _Utils_Tuple2(
			A2($author$project$Member$Model$Loaded, flags, state),
			cmds);
	});
var $author$project$Member$updateBundles = F3(
	function (flags, bmsg, state) {
		var _v0 = A3(
			$author$project$MemberBundles$Model$update,
			$author$project$Member$memberBundlesFlags(flags),
			state.memberbundles,
			bmsg);
		var bstate = _v0.a;
		var bcmds = _v0.b;
		return A3(
			$author$project$Member$updateStateCmds,
			flags,
			$author$project$Member$memberBundlesCmds(bcmds),
			_Utils_update(
				state,
				{memberbundles: bstate}));
	});
var $author$project$Member$updateDetails = F3(
	function (flags, dmsg, state) {
		var _v0 = A3(
			$author$project$ProfileDetails$Model$update,
			$author$project$Member$detailsFlags(flags),
			state.details,
			dmsg);
		var dstate = _v0.a;
		var dcmds = _v0.b;
		var accepted = function () {
			var _v2 = dstate.initial;
			if (_v2.$ === 'Just') {
				var initial = _v2.a;
				return !_Utils_eq(
					initial.accepted_on,
					$elm$time$Time$millisToPosix(0));
			} else {
				return false;
			}
		}();
		var dstate2 = function () {
			var _v1 = _Utils_Tuple3(flags.extra.mode, state.auth, state.mnum);
			if (((_v1.a === 'view') && (_v1.b.$ === 'Success')) && (_v1.c.$ === 'Just')) {
				var auth = _v1.b.a;
				var num = _v1.c.a;
				return _Utils_eq(auth.mnum, num) ? _Utils_update(
					dstate,
					{readonly: false, showthumb: true}) : ((_Utils_eq(auth.role, $author$project$MemberData$Model$Host) && (!accepted)) ? _Utils_update(
					dstate,
					{readonly: false, showthumb: false}) : _Utils_update(
					dstate,
					{readonly: true, showthumb: false}));
			} else {
				return dstate;
			}
		}();
		return A3(
			$author$project$Member$updateStateCmds,
			flags,
			$author$project$Member$detailsCmds(dcmds),
			_Utils_update(
				state,
				{details: dstate2}));
	});
var $author$project$Note$Model$update = F3(
	function (flags, state, msg) {
		var current = state.current;
		switch (msg.$) {
			case 'UpdateNote':
				var value = msg.a;
				var newstate = _Utils_update(
					state,
					{current: value});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			case 'IncomingNote':
				var value = msg.a;
				var newstate = _Utils_update(
					state,
					{
						current: value,
						initial: $elm$core$Maybe$Just(value)
					});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			default:
				var newstate = _Utils_update(
					state,
					{
						initial: $elm$core$Maybe$Just(current)
					});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
		}
	});
var $author$project$Member$updateNote = F3(
	function (flags, nmsg, state) {
		var _v0 = A3(
			$author$project$Note$Model$update,
			$author$project$Member$noteFlags(flags),
			state.note,
			nmsg);
		var nstate = _v0.a;
		var ncmds = _v0.b;
		return A3(
			$author$project$Member$updateStateCmds,
			flags,
			$author$project$Member$noteCmds(ncmds),
			_Utils_update(
				state,
				{note: nstate}));
	});
var $author$project$Member$updateProgress = F3(
	function (flags, pmsg, state) {
		var _v0 = A3(
			$author$project$Progress$Model$update,
			$author$project$Member$progressFlags(flags),
			state.progress,
			pmsg);
		var pstate = _v0.a;
		var pcmds = _v0.b;
		return A3(
			$author$project$Member$updateStateCmds,
			flags,
			$author$project$Member$progressCmds(pcmds),
			_Utils_update(
				state,
				{progress: pstate}));
	});
var $author$project$Member$updateState = F2(
	function (flags, state) {
		return A3($author$project$Member$updateStateCmds, flags, $elm$core$Platform$Cmd$none, state);
	});
var $author$project$Member$Decode$AddMemberOk = function (a) {
	return {$: 'AddMemberOk', a: a};
};
var $author$project$Member$Decode$IncomingAuth = function (a) {
	return {$: 'IncomingAuth', a: a};
};
var $author$project$Member$Decode$IncomingBundleData = F3(
	function (a, b, c) {
		return {$: 'IncomingBundleData', a: a, b: b, c: c};
	});
var $author$project$Member$Decode$IncomingLink = F2(
	function (a, b) {
		return {$: 'IncomingLink', a: a, b: b};
	});
var $author$project$Member$Decode$IncomingMemberData = F2(
	function (a, b) {
		return {$: 'IncomingMemberData', a: a, b: b};
	});
var $author$project$Member$Decode$IncomingNote = F2(
	function (a, b) {
		return {$: 'IncomingNote', a: a, b: b};
	});
var $author$project$Member$Decode$IncomingProfileData = F2(
	function (a, b) {
		return {$: 'IncomingProfileData', a: a, b: b};
	});
var $author$project$Member$Decode$IncomingProfileUnique = function (a) {
	return {$: 'IncomingProfileUnique', a: a};
};
var $author$project$Member$Decode$IncomingTopicData = F2(
	function (a, b) {
		return {$: 'IncomingTopicData', a: a, b: b};
	});
var $author$project$Member$Decode$Progress = function (a) {
	return {$: 'Progress', a: a};
};
var $author$project$Member$Decode$RequestFailed = function (a) {
	return {$: 'RequestFailed', a: a};
};
var $author$project$Member$Decode$UpdateMemberOk = {$: 'UpdateMemberOk'};
var $author$project$Member$Decode$incomingMsgDecoderByMsg = function (msg) {
	switch (msg) {
		case 'auth':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Member$Decode$IncomingAuth,
				A2($elm$json$Json$Decode$field, 'auth', $author$project$Auth$Decode$authDecoder));
		case 'profile unique info':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Member$Decode$IncomingProfileUnique,
				A2($elm$json$Json$Decode$field, 'unique', $author$project$ProfileData$Decode$profileUniqueDecoder));
		case 'topic info':
			return A3(
				$elm$json$Json$Decode$map2,
				$author$project$Member$Decode$IncomingTopicData,
				A2($elm$json$Json$Decode$field, 'tkey', $elm$json$Json$Decode$string),
				A2($elm$json$Json$Decode$field, 'topic', $author$project$TopicData$Decode$topicDataDecoder));
		case 'bundle info':
			return A4(
				$elm$json$Json$Decode$map3,
				$author$project$Member$Decode$IncomingBundleData,
				A2($elm$json$Json$Decode$field, 'bnum', $elm$json$Json$Decode$int),
				A2($elm$json$Json$Decode$field, 'bundle', $author$project$BundleData$Decode$bundleDataDecoder),
				A2($elm$json$Json$Decode$field, 'stats', $author$project$BundleStats$Decode$bundleStatsDecoder));
		case 'member info':
			return A3(
				$elm$json$Json$Decode$map2,
				$author$project$Member$Decode$IncomingMemberData,
				A2($elm$json$Json$Decode$field, 'mnum', $elm$json$Json$Decode$int),
				A2($elm$json$Json$Decode$field, 'member', $author$project$MemberData$Decode$memberDataDecoder));
		case 'link info':
			return A3(
				$elm$json$Json$Decode$map2,
				$author$project$Member$Decode$IncomingLink,
				A2($elm$json$Json$Decode$field, 'mnum', $elm$json$Json$Decode$int),
				A2($elm$json$Json$Decode$field, 'link', $elm$json$Json$Decode$string));
		case 'profile info':
			return A3(
				$elm$json$Json$Decode$map2,
				$author$project$Member$Decode$IncomingProfileData,
				A2($elm$json$Json$Decode$field, 'mnum', $elm$json$Json$Decode$int),
				A2($elm$json$Json$Decode$field, 'profile', $author$project$ProfileData$Decode$profileDataDecoder));
		case 'note info':
			return A3(
				$elm$json$Json$Decode$map2,
				$author$project$Member$Decode$IncomingNote,
				A2($elm$json$Json$Decode$field, 'mnum', $elm$json$Json$Decode$int),
				A2($elm$json$Json$Decode$field, 'note', $elm$json$Json$Decode$string));
		case 'error':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Member$Decode$RequestFailed,
				$elm$json$Json$Decode$maybe(
					A2($elm$json$Json$Decode$field, 'details', $elm$json$Json$Decode$string)));
		case 'add member ok':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Member$Decode$AddMemberOk,
				A2($elm$json$Json$Decode$field, 'mnum', $elm$json$Json$Decode$int));
		case 'update member ok':
			return $elm$json$Json$Decode$succeed($author$project$Member$Decode$UpdateMemberOk);
		case 'progress':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Member$Decode$Progress,
				A2($elm$json$Json$Decode$field, 'progress', $elm$json$Json$Decode$value));
		default:
			var other = msg;
			return $elm$json$Json$Decode$fail(other);
	}
};
var $author$project$Member$Decode$incomingMsgDecoder = A2(
	$elm$json$Json$Decode$andThen,
	$author$project$Member$Decode$incomingMsgDecoderByMsg,
	A2($elm$json$Json$Decode$field, 'msg', $elm$json$Json$Decode$string));
var $author$project$Member$Decode$valueToIncomingMsg = function (value) {
	return A2(
		$elm$core$Result$mapError,
		$elm$json$Json$Decode$errorToString,
		A2($elm$json$Json$Decode$decodeValue, $author$project$Member$Decode$incomingMsgDecoder, value));
};
var $author$project$Member$update = F2(
	function (msg, model) {
		var _v0 = _Utils_Tuple2(model, msg);
		if (_v0.a.$ === 'Failed') {
			return _Utils_Tuple2(model, $elm$core$Platform$Cmd$none);
		} else {
			switch (_v0.b.$) {
				case 'ToggleOptionsExpanded':
					var _v1 = _v0.a;
					var flags = _v1.a;
					var state = _v1.b;
					var _v2 = _v0.b;
					return A2(
						$author$project$Member$updateState,
						flags,
						_Utils_update(
							state,
							{options_expanded: !state.options_expanded}));
				case 'ProfileViewMsg':
					var _v3 = _v0.a;
					var flags = _v3.a;
					var state = _v3.b;
					var vmsg = _v0.b.a;
					return _Utils_Tuple2(model, $elm$core$Platform$Cmd$none);
				case 'UpdatePause':
					var _v4 = _v0.a;
					var flags = _v4.a;
					var state = _v4.b;
					var value = _v0.b.a;
					return A2(
						$author$project$Member$updateState,
						flags,
						_Utils_update(
							state,
							{pause: value, result: $krisajenkins$remotedata$RemoteData$NotAsked}));
				case 'DetailsMsg':
					var _v5 = _v0.a;
					var flags = _v5.a;
					var state = _v5.b;
					var dmsg = _v0.b.a;
					return A3($author$project$Member$updateDetails, flags, dmsg, state);
				case 'NoteMsg':
					var _v6 = _v0.a;
					var flags = _v6.a;
					var state = _v6.b;
					var nmsg = _v0.b.a;
					return A3($author$project$Member$updateNote, flags, nmsg, state);
				case 'MemberBundlesMsg':
					var _v7 = _v0.a;
					var flags = _v7.a;
					var state = _v7.b;
					var bmsg = _v0.b.a;
					return A3($author$project$Member$updateBundles, flags, bmsg, state);
				case 'PressSubmit':
					var _v8 = _v0.a;
					var flags = _v8.a;
					var state = _v8.b;
					var _v9 = _v0.b;
					return A2($author$project$Member$View$okToSubmit, flags, state) ? A2($author$project$Member$Cmd$cmdSubmitRequest, flags, state) : _Utils_Tuple2(model, $elm$core$Platform$Cmd$none);
				case 'ProgressMsg':
					var _v10 = _v0.a;
					var flags = _v10.a;
					var state = _v10.b;
					var pmsg = _v0.b.a;
					return A3($author$project$Member$updateProgress, flags, pmsg, state);
				default:
					var _v11 = _v0.a;
					var flags = _v11.a;
					var state = _v11.b;
					var v = _v0.b.a;
					var _v12 = $author$project$Member$Decode$valueToIncomingMsg(v);
					if (_v12.$ === 'Err') {
						var err = _v12.a;
						return $author$project$Shared$Reg$decodeErr(err) ? A3(
							$author$project$Member$updateProgress,
							flags,
							$author$project$Progress$Model$DecodeErr(err),
							state) : A2($author$project$Shared$Cmd$cmdLog, 'Err ' + err, model);
					} else {
						switch (_v12.a.$) {
							case 'IncomingAuth':
								var auth = _v12.a.a;
								var _v13 = A3(
									$author$project$Member$updateBundles,
									flags,
									$author$project$MemberBundles$Model$IncomingAuth(auth),
									state);
								if (_v13.a.$ === 'Loaded') {
									var _v14 = _v13.a;
									var state1 = _v14.b;
									var cmds = _v13.b;
									return A3(
										$author$project$Member$updateStateCmds,
										flags,
										cmds,
										_Utils_update(
											state1,
											{
												auth: $krisajenkins$remotedata$RemoteData$Success(auth)
											}));
								} else {
									return _Utils_Tuple2(model, $elm$core$Platform$Cmd$none);
								}
							case 'IncomingProfileUnique':
								var unique = _v12.a.a;
								return A3(
									$author$project$Member$updateDetails,
									flags,
									$author$project$ProfileDetails$Model$IncomingProfileUnique(unique),
									state);
							case 'IncomingTopicData':
								var _v15 = _v12.a;
								var tkey = _v15.a;
								var data = _v15.b;
								return A2(
									$author$project$Member$updateState,
									flags,
									_Utils_update(
										state,
										{
											topics: A3($elm$core$Dict$insert, tkey, data, state.topics)
										}));
							case 'IncomingBundleData':
								var _v16 = _v12.a;
								var bnum = _v16.a;
								var bundle = _v16.b;
								var stats = _v16.c;
								return A3(
									$author$project$Member$updateBundles,
									flags,
									A3($author$project$MemberBundles$Model$IncomingBundleData, bnum, bundle, stats),
									_Utils_update(
										state,
										{
											bundles: A3($elm$core$Dict$insert, bnum, bundle, state.bundles)
										}));
							case 'IncomingMemberData':
								var _v17 = _v12.a;
								var mnum = _v17.a;
								var data = _v17.b;
								var _v18 = A3(
									$author$project$Member$updateBundles,
									flags,
									A2($author$project$MemberBundles$Model$IncomingMemberData, mnum, data),
									state);
								if (_v18.a.$ === 'Loaded') {
									var _v19 = _v18.a;
									var state1 = _v19.b;
									var cmds = _v18.b;
									return A3(
										$author$project$Member$updateStateCmds,
										flags,
										cmds,
										_Utils_update(
											state1,
											{
												memberdata: $elm$core$Maybe$Just(data),
												mnum: $elm$core$Maybe$Just(mnum)
											}));
								} else {
									return _Utils_Tuple2(model, $elm$core$Platform$Cmd$none);
								}
							case 'IncomingProfileData':
								var _v20 = _v12.a;
								var mnum = _v20.a;
								var profile = _v20.b;
								return (flags.extra.mode === 'view') ? A3(
									$author$project$Member$updateDetails,
									flags,
									$author$project$ProfileDetails$Model$IncomingProfileData(profile),
									_Utils_update(
										state,
										{
											mnum: $elm$core$Maybe$Just(mnum)
										})) : _Utils_Tuple2(model, $elm$core$Platform$Cmd$none);
							case 'IncomingNote':
								var _v21 = _v12.a;
								var mnum = _v21.a;
								var note = _v21.b;
								return (flags.extra.mode === 'view') ? A3(
									$author$project$Member$updateNote,
									flags,
									$author$project$Note$Model$IncomingNote(note),
									_Utils_update(
										state,
										{
											mnum: $elm$core$Maybe$Just(mnum)
										})) : _Utils_Tuple2(model, $elm$core$Platform$Cmd$none);
							case 'IncomingLink':
								var _v22 = _v12.a;
								var mnum = _v22.a;
								var link = _v22.b;
								return (flags.extra.mode === 'view') ? A2(
									$author$project$Member$updateState,
									flags,
									_Utils_update(
										state,
										{
											link: $elm$core$Maybe$Just(link)
										})) : _Utils_Tuple2(model, $elm$core$Platform$Cmd$none);
							case 'RequestFailed':
								if (_v12.a.a.$ === 'Just') {
									var err = _v12.a.a.a;
									return A2(
										$author$project$Member$updateState,
										flags,
										_Utils_update(
											state,
											{
												result: $krisajenkins$remotedata$RemoteData$Failure(err)
											}));
								} else {
									var _v23 = _v12.a.a;
									return A2(
										$author$project$Member$updateState,
										flags,
										_Utils_update(
											state,
											{
												result: $krisajenkins$remotedata$RemoteData$Failure(flags.extra.memberSubmit.labels.submit.failed)
											}));
								}
							case 'AddMemberOk':
								var mnum = _v12.a.a;
								return state.pause ? A2(
									$author$project$Member$updateState,
									flags,
									_Utils_update(
										state,
										{
											mnum: $elm$core$Maybe$Just(mnum),
											result: $krisajenkins$remotedata$RemoteData$Success('')
										})) : A3($author$project$Shared$Cmd$cmdTransitionNumber, flags.extra.memberSubmit.transitions.view, mnum, model);
							case 'UpdateMemberOk':
								var _v24 = _v12.a;
								return A3(
									$author$project$Member$updateDetails,
									flags,
									$author$project$ProfileDetails$Model$UpdateOk,
									_Utils_update(
										state,
										{
											result: $krisajenkins$remotedata$RemoteData$Success('')
										}));
							default:
								var value = _v12.a.a;
								return A3(
									$author$project$Member$updateProgress,
									flags,
									$author$project$Progress$Model$Incoming(value),
									state);
						}
					}
			}
		}
	});
var $author$project$Member$Model$ProfileViewMsg = function (a) {
	return {$: 'ProfileViewMsg', a: a};
};
var $author$project$Member$currentView = 0;
var $author$project$Member$Model$isHost = function (state) {
	var _v0 = state.memberdata;
	if (_v0.$ === 'Just') {
		var data = _v0.a;
		return _Utils_eq(data.role, $author$project$MemberData$Model$Host);
	} else {
		return false;
	}
};
var $author$project$Member$profileViewFlags = function (flags) {
	return {labels: flags.extra.profileView.labels};
};
var $author$project$Member$View$viewMemberLink = F2(
	function (flags, state) {
		var ms = flags.extra.memberSubmit;
		var _v0 = state.link;
		if (_v0.$ === 'Nothing') {
			return _List_Nil;
		} else {
			var link = _v0.a;
			var eltid = 'memberlink';
			return _List_fromArray(
				[
					A2(
					$elm$html$Html$h2,
					_List_Nil,
					_List_fromArray(
						[
							$elm$html$Html$text(ms.labels.invitationLink.label)
						])),
					A2(
					$elm$html$Html$p,
					_List_Nil,
					_List_fromArray(
						[
							$elm$html$Html$text(ms.labels.invitationLink.description)
						])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('sp-form mt-3 mx-3 mb-0 p-3')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_Nil,
							_List_fromArray(
								[
									A3(
									$elm$html$Html$node,
									'clipboard-copy',
									_List_fromArray(
										[
											A2($elm$html$Html$Attributes$attribute, 'for', eltid),
											$elm$html$Html$Attributes$class('tag has-background-primary-dark has-text-white'),
											A2($elm$html$Html$Attributes$attribute, 'text-copied', ms.labels.invitationLink.copied),
											A2($elm$html$Html$Attributes$attribute, 'class-copied', 'tag is-white'),
											A2($elm$html$Html$Attributes$style, 'height', '20px'),
											A2($elm$html$Html$Attributes$style, 'user-select', 'none')
										]),
									_List_fromArray(
										[
											$elm$html$Html$text(ms.labels.invitationLink.copy)
										])),
									A2(
									$elm$html$Html$span,
									_List_fromArray(
										[
											A2($elm$html$Html$Attributes$style, 'user-select', 'none')
										]),
									_List_fromArray(
										[
											$elm$html$Html$text($author$project$Shared$Text$nbsp)
										])),
									A2(
									$elm$html$Html$span,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$id(eltid),
											$elm$html$Html$Attributes$class('is-size-7 mt-3'),
											A2($elm$html$Html$Attributes$style, 'word-break', 'break-all')
										]),
									_List_fromArray(
										[
											$elm$html$Html$text(link)
										]))
								]))
						]))
				]);
		}
	});
var $author$project$Member$Model$PressSubmit = {$: 'PressSubmit'};
var $author$project$Member$Model$ToggleOptionsExpanded = {$: 'ToggleOptionsExpanded'};
var $author$project$Member$View$descOrError = F2(
	function (flags, state) {
		var _v0 = A2($author$project$Member$View$currentError, flags, state);
		if (_v0.$ === 'Err') {
			var msg = _v0.a;
			return A2(
				$elm$html$Html$p,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('has-text-danger')
					]),
				_List_fromArray(
					[
						$elm$html$Html$text(msg)
					]));
		} else {
			var msg = _v0.a;
			return A2(
				$elm$html$Html$p,
				_List_Nil,
				_List_fromArray(
					[
						$elm$html$Html$text(msg)
					]));
		}
	});
var $author$project$Member$Model$UpdatePause = function (a) {
	return {$: 'UpdatePause', a: a};
};
var $author$project$Member$View$viewPause = F2(
	function (flags, state) {
		var ms = flags.extra.memberSubmit;
		var help = $author$project$Shared$Text$htmlTextLines(ms.labels.pause.description);
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('field is-horizontal')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-label is-normal')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help is-hidden-mobile')
												]),
											$author$project$Shared$Text$dropExtra(
												$author$project$Shared$Text$htmlBreaks(help)))
										])),
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('label ml-1')
												]),
											_List_fromArray(
												[
													$elm$html$Html$text(ms.labels.pause.label)
												]))
										]))
								]))
						])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-body')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help')
												]),
											help)
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('field'),
											A2($elm$html$Html$Attributes$style, 'display', 'table')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$div,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('checkbox'),
													A2($elm$html$Html$Attributes$style, 'display', 'table-cell'),
													A2($elm$html$Html$Attributes$style, 'vertical-align', 'middle')
												]),
											_List_fromArray(
												[
													A2(
													$elm$html$Html$input,
													_List_fromArray(
														[
															$elm$html$Html$Attributes$class('sp-checkbox mt-2'),
															$elm$html$Html$Attributes$type_('checkbox'),
															$elm$html$Html$Attributes$checked(state.pause),
															$elm$html$Html$Events$onCheck($author$project$Member$Model$UpdatePause)
														]),
													_List_Nil)
												]))
										]))
								])),
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field-label is-normal'),
									A2($elm$html$Html$Attributes$style, 'max-width', '5px')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$label,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('label')
										]),
									_List_Nil)
								]))
						]))
				]));
	});
var $author$project$Member$View$viewSectionTitle = F2(
	function (flags, state) {
		var ms = flags.extra.memberSubmit;
		var loading = function (cls) {
			return _Utils_eq(state.result, $krisajenkins$remotedata$RemoteData$Loading) ? (cls + ' is-loading') : cls;
		};
		var enabled = A2($author$project$Member$View$okToSubmit, flags, state);
		return _List_fromArray(
			[
				A2(
				$elm$html$Html$h2,
				_List_Nil,
				_List_fromArray(
					[
						$elm$html$Html$text(ms.labels.title.label),
						A2(
						$elm$html$Html$button,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class(
								loading('button has-background-primary-dark has-text-white is-link is-pulled-right')),
								A2($elm$html$Html$Attributes$style, 'width', ms.labels.submit.width),
								$elm$html$Html$Attributes$disabled(!enabled),
								$elm$html$Html$Events$onClick($author$project$Member$Model$PressSubmit)
							]),
						_List_fromArray(
							[
								$elm$html$Html$text(ms.labels.submit.label)
							]))
					])),
				(flags.extra.mode === 'add') ? A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('is-flex')
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$div,
						_List_fromArray(
							[
								A2($elm$html$Html$Attributes$style, 'width', '24px'),
								A2($elm$html$Html$Attributes$style, 'min-width', '24px'),
								A2($elm$html$Html$Attributes$style, 'height', '24px'),
								$elm$html$Html$Events$onClick($author$project$Member$Model$ToggleOptionsExpanded)
							]),
						_List_fromArray(
							[
								$author$project$Shared$Expand$svgExpandCollapse(state.options_expanded)
							])),
						A2($author$project$Member$View$descOrError, flags, state)
					])) : A2($author$project$Member$View$descOrError, flags, state),
				state.options_expanded ? A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('sp-form m-3 py-3')
					]),
				_List_fromArray(
					[
						A2($author$project$Member$View$viewPause, flags, state)
					])) : A2($elm$html$Html$div, _List_Nil, _List_Nil)
			]);
	});
var $author$project$Member$View$view = F2(
	function (flags, state) {
		return A2(
			$elm$html$Html$div,
			_List_Nil,
			_Utils_ap(
				A2($author$project$Member$View$viewMemberLink, flags, state),
				A2($author$project$Member$View$viewSectionTitle, flags, state)));
	});
var $author$project$MemberBundles$View$restrictedTag = F2(
	function (flags, more) {
		return A2(
			$elm$html$Html$span,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('tag is-info mr-2 ' + more)
				]),
			_List_fromArray(
				[
					$elm$html$Html$text(flags.labels.restricted.value)
				]));
	});
var $author$project$MemberBundles$Model$PressReset = {$: 'PressReset'};
var $author$project$MemberBundles$Model$PressDetails = function (a) {
	return {$: 'PressDetails', a: a};
};
var $author$project$MemberBundles$Model$UpdateShared = F2(
	function (a, b) {
		return {$: 'UpdateShared', a: a, b: b};
	});
var $author$project$MemberBundles$View$viewBundle = F5(
	function (flags, plurals, sharebox, state, _v0) {
		var bnum = _v0.a;
		var shared = _v0.b;
		var bundle = _v0.c;
		var text = function (x) {
			return A2(
				$elm$html$Html$small,
				_List_Nil,
				_List_fromArray(
					[
						$elm$html$Html$text(x)
					]));
		};
		var size_txt = _List_fromArray(
			[
				text(
				A2($author$project$Shared$Text$fsize, $author$project$Shared$Text$nbsp, bundle.stats.size | 0))
			]);
		var restricted_tag = bundle.data.restricted ? _List_fromArray(
			[
				A2($author$project$MemberBundles$View$restrictedTag, flags, '')
			]) : _List_Nil;
		var picture = A2($author$project$Shared$Icon$roundIcon, 24, bundle.data.name);
		var picname = A2(
			$elm$html$Html$div,
			_List_Nil,
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('sp-floatleft mr-2')
						]),
					_List_fromArray(
						[picture])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('sp-floatleft is-small')
						]),
					_List_fromArray(
						[
							$elm$html$Html$text(bundle.data.name)
						]))
				]));
		var mount_txt = _List_fromArray(
			[
				text(bundle.stats.mount)
			]);
		var folders_txt = _List_fromArray(
			[
				text(
				A2(
					$author$project$Shared$Text$pad,
					5,
					$elm$core$String$fromInt(bundle.stats.folders)))
			]);
		var checkbox = sharebox ? A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('checkbox')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$input,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('sp-checkbox'),
							$elm$html$Html$Attributes$type_('checkbox'),
							$elm$html$Html$Attributes$checked(shared),
							$elm$html$Html$Events$onCheck(
							$author$project$MemberBundles$Model$UpdateShared(bnum))
						]),
					_List_Nil)
				])) : A2($elm$html$Html$div, _List_Nil, _List_Nil);
		return A2(
			$elm$html$Html$tr,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('is-hoverable')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$td,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('is-checkbox-cell')
						]),
					_List_fromArray(
						[checkbox])),
					A2(
					$elm$html$Html$td,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('px-1'),
							A2($elm$html$Html$Attributes$attribute, 'data-label', flags.labels.name.label)
						]),
					_List_fromArray(
						[picname])),
					A2(
					$elm$html$Html$td,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('px-1'),
							A2($elm$html$Html$Attributes$attribute, 'data-label', flags.labels.restricted.datalabel)
						]),
					restricted_tag),
					A2(
					$elm$html$Html$td,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('px-1'),
							A2($elm$html$Html$Attributes$attribute, 'data-label', flags.labels.mount.label)
						]),
					mount_txt),
					A2(
					$elm$html$Html$td,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('px-1'),
							A2($elm$html$Html$Attributes$attribute, 'data-label', flags.labels.folders.label)
						]),
					_List_fromArray(
						[
							A2($elm$html$Html$div, _List_Nil, folders_txt)
						])),
					A2(
					$elm$html$Html$td,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('px-1'),
							A2($elm$html$Html$Attributes$attribute, 'data-label', flags.labels.size.label)
						]),
					_List_fromArray(
						[
							A2($elm$html$Html$div, _List_Nil, size_txt)
						])),
					A2(
					$elm$html$Html$td,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('px-0')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('is-flex')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$button,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('button has-background-primary-dark has-text-white is-link is-small'),
											$elm$html$Html$Events$onClick(
											$author$project$MemberBundles$Model$PressDetails(bnum))
										]),
									_List_fromArray(
										[
											$elm$html$Html$text(flags.labels.details.label)
										]))
								]))
						]))
				]));
	});
var $author$project$MemberBundles$View$viewMemberBundles = F4(
	function (flags, plurals, sharebox, state) {
		var colwidth = function (value) {
			if (value === '') {
				return _List_Nil;
			} else {
				return _List_fromArray(
					[
						A2($elm$html$Html$Attributes$style, 'width', value)
					]);
			}
		};
		var details_width = A2(
			$elm$core$List$cons,
			$elm$html$Html$Attributes$class('px-0'),
			colwidth(flags.labels.details.width));
		var folders_width = A2(
			$elm$core$List$cons,
			$elm$html$Html$Attributes$class('px-1'),
			colwidth(flags.labels.folders.width));
		var mount_width = A2(
			$elm$core$List$cons,
			$elm$html$Html$Attributes$class('px-1'),
			colwidth(flags.labels.mount.width));
		var name_width = A2(
			$elm$core$List$cons,
			$elm$html$Html$Attributes$class('px-1'),
			colwidth(flags.labels.name.width));
		var reset_width = colwidth(flags.labels.reset.width);
		var reset_button = sharebox ? _List_fromArray(
			[
				A2(
				$elm$html$Html$button,
				_Utils_ap(
					reset_width,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('button has-background-primary-dark has-text-white is-link is-small is-pulled-right px-1'),
							$elm$html$Html$Events$onClick($author$project$MemberBundles$Model$PressReset)
						])),
				_List_fromArray(
					[
						$elm$html$Html$text(flags.labels.reset.label)
					]))
			]) : _List_Nil;
		var restricted_width = A2(
			$elm$core$List$cons,
			$elm$html$Html$Attributes$class('px-1'),
			colwidth(flags.labels.restricted.width));
		var size_width = A2(
			$elm$core$List$cons,
			$elm$html$Html$Attributes$class('px-1'),
			colwidth(flags.labels.size.width));
		var checkbox_width = A2(
			$elm$core$List$cons,
			$elm$html$Html$Attributes$class('px-0'),
			colwidth(flags.labels.checkbox.width));
		var calcShared = function (_v1) {
			var bnum = _v1.a;
			var bundle = _v1.b;
			var shared = function () {
				var _v0 = state.mnum;
				if (_v0.$ === 'Just') {
					var mnum = _v0.a;
					return A2($elm$core$List$member, mnum, bundle.data.shared_with) ? (!A2($elm$core$Set$member, bnum, state.removed)) : A2($elm$core$Set$member, bnum, state.added);
				} else {
					return A2($elm$core$Set$member, bnum, state.added);
				}
			}();
			return _Utils_Tuple3(bnum, shared, bundle);
		};
		var bundlelist = A2(
			$elm$core$List$map,
			calcShared,
			$elm$core$Dict$toList(state.bundles));
		var viewbundles = A2(
			$elm$core$List$map,
			A4($author$project$MemberBundles$View$viewBundle, flags, plurals, sharebox, state),
			bundlelist);
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('field mt-0 pt-0')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('mx-2')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('b-table')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('table-wrapper has-mobile-cards')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$table,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('table is-fullwidth is-hoverable')
												]),
											_List_fromArray(
												[
													A2(
													$elm$html$Html$thead,
													_List_Nil,
													_List_fromArray(
														[
															A2(
															$elm$html$Html$tr,
															_List_Nil,
															_List_fromArray(
																[
																	A2($elm$html$Html$th, checkbox_width, _List_Nil),
																	A2(
																	$elm$html$Html$th,
																	name_width,
																	_List_fromArray(
																		[
																			$elm$html$Html$text(flags.labels.name.label)
																		])),
																	A2($elm$html$Html$th, restricted_width, _List_Nil),
																	A2(
																	$elm$html$Html$th,
																	mount_width,
																	_List_fromArray(
																		[
																			$elm$html$Html$text(flags.labels.mount.label)
																		])),
																	A2(
																	$elm$html$Html$th,
																	folders_width,
																	_List_fromArray(
																		[
																			$elm$html$Html$text(flags.labels.folders.label)
																		])),
																	A2(
																	$elm$html$Html$th,
																	size_width,
																	_List_fromArray(
																		[
																			$elm$html$Html$text(flags.labels.size.label)
																		])),
																	A2($elm$html$Html$th, details_width, reset_button)
																]))
														])),
													A2($elm$html$Html$tbody, _List_Nil, viewbundles)
												]))
										]))
								]))
						]))
				]));
	});
var $author$project$MemberBundles$View$viewSection = F4(
	function (flags, plurals, sharebox, state) {
		return A2(
			$elm$html$Html$div,
			_List_Nil,
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('sp-form mt-3 mx-3 mb-0 py-3')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field is-horizontal mb-0')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('field-body')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$div,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('field')
												]),
											_List_fromArray(
												[
													A2(
													$elm$html$Html$div,
													_List_fromArray(
														[
															$elm$html$Html$Attributes$class('control')
														]),
													_List_fromArray(
														[
															A4($author$project$MemberBundles$View$viewMemberBundles, flags, plurals, sharebox, state)
														]))
												]))
										]))
								]))
						]))
				]));
	});
var $author$project$MemberBundles$View$viewSectionDescription = F3(
	function (flags, plurals, state) {
		var _v0 = state.auth;
		if (_v0.$ === 'Nothing') {
			return _List_Nil;
		} else {
			var auth = _v0.a;
			var _v1 = _Utils_Tuple3(
				auth.role,
				_Utils_eq(
					state.mnum,
					$elm$core$Maybe$Just(1)),
				_Utils_eq(
					state.mnum,
					$elm$core$Maybe$Just(auth.mnum)));
			_v1$1:
			while (true) {
				if (_v1.b) {
					if (_v1.a.$ === 'Host') {
						var _v2 = _v1.a;
						return _List_fromArray(
							[
								A2(
								$elm$html$Html$p,
								_List_Nil,
								_List_fromArray(
									[
										$elm$html$Html$text(flags.labels.description.viewHost)
									]))
							]);
					} else {
						return _List_fromArray(
							[
								A2(
								$elm$html$Html$p,
								_List_Nil,
								_List_fromArray(
									[
										$elm$html$Html$text(flags.labels.description.viewHost)
									]))
							]);
					}
				} else {
					if (_v1.c) {
						if (_v1.a.$ === 'Host') {
							break _v1$1;
						} else {
							return _List_fromArray(
								[
									A2(
									$elm$html$Html$p,
									_List_Nil,
									_List_fromArray(
										[
											$elm$html$Html$text(flags.labels.description.memberViewSelf),
											A2($elm$html$Html$br, _List_Nil, _List_Nil),
											$elm$html$Html$text(flags.labels.restricted.description),
											A2($author$project$MemberBundles$View$restrictedTag, flags, 'ml-2'),
											A4($author$project$MemberBundles$View$viewSection, flags, plurals, false, state)
										]))
								]);
						}
					} else {
						if (_v1.a.$ === 'Host') {
							break _v1$1;
						} else {
							return _List_fromArray(
								[
									A2(
									$elm$html$Html$p,
									_List_Nil,
									_List_fromArray(
										[
											$elm$html$Html$text(flags.labels.description.memberViewOther),
											A2($elm$html$Html$br, _List_Nil, _List_Nil),
											$elm$html$Html$text(flags.labels.restricted.description),
											A2($author$project$MemberBundles$View$restrictedTag, flags, 'ml-2'),
											A4($author$project$MemberBundles$View$viewSection, flags, plurals, false, state)
										]))
								]);
						}
					}
				}
			}
			var _v3 = _v1.a;
			return _List_fromArray(
				[
					A2(
					$elm$html$Html$p,
					_List_Nil,
					_List_fromArray(
						[
							$elm$html$Html$text(flags.labels.description.hostViewMember),
							A2($elm$html$Html$br, _List_Nil, _List_Nil),
							$elm$html$Html$text(flags.labels.restricted.description),
							A2($author$project$MemberBundles$View$restrictedTag, flags, 'ml-2'),
							A4($author$project$MemberBundles$View$viewSection, flags, plurals, true, state)
						]))
				]);
		}
	});
var $author$project$MemberBundles$View$view = F3(
	function (flags, plurals, state) {
		return A2(
			$elm$html$Html$div,
			_List_Nil,
			A3($author$project$MemberBundles$View$viewSectionDescription, flags, plurals, state));
	});
var $author$project$Note$Model$UpdateNote = function (a) {
	return {$: 'UpdateNote', a: a};
};
var $author$project$Note$View$viewNote = F2(
	function (flags, state) {
		var reset = function () {
			var _v0 = state.initial;
			if (_v0.$ === 'Just') {
				var initial = _v0.a;
				return (!_Utils_eq(initial, state.current)) ? _List_fromArray(
					[
						A2(
						$elm$html$Html$button,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('sp-icon is-right'),
								$elm$html$Html$Events$onClick(
								$author$project$Note$Model$UpdateNote(initial))
							]),
						_List_fromArray(
							[
								$elm$html$Html$text($author$project$Shared$Text$greenX)
							]))
					]) : _List_Nil;
			} else {
				return _List_Nil;
			}
		}();
		var help = $author$project$Shared$Text$htmlTextLines(flags.labels.note.description);
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('field is-horizontal')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-label is-normal')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help is-hidden-mobile')
												]),
											$author$project$Shared$Text$dropExtra(
												$author$project$Shared$Text$htmlBreaks(help)))
										])),
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class(
													A3($author$project$Shared$Text$has_danger, 'label ml-1', $elm$core$Maybe$Nothing, false))
												]),
											_List_fromArray(
												[
													$elm$html$Html$text(flags.labels.note.label)
												]))
										]))
								]))
						])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-body')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help')
												]),
											help)
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('field')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$div,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('control has-icons-right')
												]),
											_Utils_ap(
												_List_fromArray(
													[
														A2(
														$elm$html$Html$input,
														_List_fromArray(
															[
																$elm$html$Html$Attributes$class(
																A3($author$project$Shared$Text$is_danger, 'input', $elm$core$Maybe$Nothing, false)),
																$elm$html$Html$Attributes$type_('text'),
																$elm$html$Html$Attributes$placeholder(flags.labels.note.placeholder),
																$elm$html$Html$Attributes$value(state.current),
																$elm$html$Html$Events$onInput($author$project$Note$Model$UpdateNote)
															]),
														_List_Nil)
													]),
												reset))
										]))
								])),
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field-label is-normal'),
									A2($elm$html$Html$Attributes$style, 'max-width', '5px')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$label,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('label')
										]),
									_List_Nil)
								]))
						]))
				]));
	});
var $author$project$Note$View$view = F2(
	function (flags, state) {
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('sp-form ml-3 mr-3 pb-3')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$br,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('is-hidden-mobile')
						]),
					_List_Nil),
					A2($author$project$Note$View$viewNote, flags, state),
					A2(
					$elm$html$Html$br,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('is-hidden-mobile')
						]),
					_List_Nil)
				]));
	});
var $author$project$Member$view = function (model) {
	var _v0 = _Utils_Tuple2($author$project$Member$currentView, model);
	_v0$7:
	while (true) {
		if (_v0.b.$ === 'Failed') {
			if (!_v0.a) {
				var err = _v0.b.a;
				return A2(
					$elm$html$Html$p,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('notification is-danger')
						]),
					_List_fromArray(
						[
							$elm$html$Html$text(err)
						]));
			} else {
				break _v0$7;
			}
		} else {
			switch (_v0.a) {
				case 0:
					var _v1 = _v0.b;
					var flags = _v1.a;
					var state = _v1.b;
					return A2(
						$elm$html$Html$map,
						$author$project$Member$Model$ProfileViewMsg,
						A4(
							$author$project$ProfileView$View$view,
							$author$project$Member$profileViewFlags(flags),
							state.details.current,
							$author$project$Member$Model$isHost(state),
							$elm$core$Maybe$Nothing));
				case 1:
					var _v2 = _v0.b;
					var flags = _v2.a;
					var state = _v2.b;
					return (!state.details.readonly) ? A2(
						$elm$html$Html$map,
						$author$project$Member$Model$DetailsMsg,
						A4(
							$author$project$ProfileDetails$View$view,
							$author$project$Member$detailsFlags(flags),
							state.details,
							state.topics,
							state.bundles)) : A2($elm$html$Html$div, _List_Nil, _List_Nil);
				case 2:
					var _v3 = _v0.b;
					var flags = _v3.a;
					var state = _v3.b;
					return A2(
						$elm$html$Html$map,
						$author$project$Member$Model$NoteMsg,
						A2(
							$author$project$Note$View$view,
							$author$project$Member$noteFlags(flags),
							state.note));
				case 3:
					var _v4 = _v0.b;
					var flags = _v4.a;
					var state = _v4.b;
					return A2(
						$elm$html$Html$map,
						$author$project$Member$Model$MemberBundlesMsg,
						A3(
							$author$project$MemberBundles$View$view,
							$author$project$Member$memberBundlesFlags(flags),
							flags.extra.plurals,
							state.memberbundles));
				case 4:
					var _v5 = _v0.b;
					var flags = _v5.a;
					var state = _v5.b;
					return A2($author$project$Member$View$view, flags, state);
				case 5:
					var _v6 = _v0.b;
					var flags = _v6.a;
					var state = _v6.b;
					return A2(
						$elm$html$Html$map,
						$author$project$Member$Model$ProgressMsg,
						A2(
							$author$project$Progress$View$view,
							$author$project$Member$progressFlags(flags),
							state.progress));
				default:
					break _v0$7;
			}
		}
	}
	return A2($elm$html$Html$div, _List_Nil, _List_Nil);
};
var $author$project$Member$main = $elm$browser$Browser$element(
	{init: $author$project$Member$init, subscriptions: $author$project$Member$subscriptions, update: $author$project$Member$update, view: $author$project$Member$view});
var $author$project$Join$Model$Failed = function (a) {
	return {$: 'Failed', a: a};
};
var $author$project$Join$Model$Loaded = F2(
	function (a, b) {
		return {$: 'Loaded', a: a, b: b};
	});
var $author$project$Join$Model$Problems = function (linkErr) {
	return {linkErr: linkErr};
};
var $author$project$Join$Flags$Flags = F3(
	function (config, extra, workflows) {
		return {config: config, extra: extra, workflows: workflows};
	});
var $author$project$Join$Flags$Extra = F6(
	function (joinView, mode, module_, progressView, viewNodes, workflowpaths) {
		return {joinView: joinView, mode: mode, module_: module_, progressView: progressView, viewNodes: viewNodes, workflowpaths: workflowpaths};
	});
var $author$project$Join$Flags$ExtraJoinView = F4(
	function (errors, labels, requests, transitions) {
		return {errors: errors, labels: labels, requests: requests, transitions: transitions};
	});
var $author$project$Join$Flags$ExtraJoinViewErrors = function (link) {
	return {link: link};
};
var $author$project$Join$Flags$ExtraJoinViewErrorsLink = F6(
	function (failed, invalid, noProfile, notFound, pleaseSignIn, syntax) {
		return {failed: failed, invalid: invalid, noProfile: noProfile, notFound: notFound, pleaseSignIn: pleaseSignIn, syntax: syntax};
	});
var $author$project$Join$Flags$extraJoinViewErrorsLinkDecoder = A7(
	$elm$json$Json$Decode$map6,
	$author$project$Join$Flags$ExtraJoinViewErrorsLink,
	A2($elm$json$Json$Decode$field, 'failed', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'invalid', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'no_profile', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'not_found', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'please_sign_in', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'syntax', $elm$json$Json$Decode$string));
var $author$project$Join$Flags$extraJoinViewErrorsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Join$Flags$ExtraJoinViewErrors,
	A2($elm$json$Json$Decode$field, 'link', $author$project$Join$Flags$extraJoinViewErrorsLinkDecoder));
var $author$project$Join$Flags$ExtraJoinViewLabels = F3(
	function (join, link, transition) {
		return {join: join, link: link, transition: transition};
	});
var $author$project$Join$Flags$ExtraJoinViewLabelsJoin = function (label) {
	return {label: label};
};
var $author$project$Join$Flags$extraJoinViewLabelsJoinDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Join$Flags$ExtraJoinViewLabelsJoin,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Join$Flags$ExtraJoinViewLabelsLink = F2(
	function (label, required) {
		return {label: label, required: required};
	});
var $author$project$Join$Flags$extraJoinViewLabelsLinkDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Join$Flags$ExtraJoinViewLabelsLink,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'required', $elm$json$Json$Decode$string));
var $author$project$Join$Flags$ExtraJoinViewLabelsTransition = function (label) {
	return {label: label};
};
var $author$project$Join$Flags$extraJoinViewLabelsTransitionDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Join$Flags$ExtraJoinViewLabelsTransition,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Join$Flags$extraJoinViewLabelsDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Join$Flags$ExtraJoinViewLabels,
	A2($elm$json$Json$Decode$field, 'join', $author$project$Join$Flags$extraJoinViewLabelsJoinDecoder),
	A2($elm$json$Json$Decode$field, 'link', $author$project$Join$Flags$extraJoinViewLabelsLinkDecoder),
	A2($elm$json$Json$Decode$field, 'transition', $author$project$Join$Flags$extraJoinViewLabelsTransitionDecoder));
var $author$project$Join$Flags$ExtraJoinViewRequests = function (submit) {
	return {submit: submit};
};
var $author$project$Join$Flags$extraJoinViewRequestsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Join$Flags$ExtraJoinViewRequests,
	A2($elm$json$Json$Decode$field, 'submit', $elm$json$Json$Decode$string));
var $author$project$Join$Flags$ExtraJoinViewTransitions = F5(
	function (bundle, profile, signin, topic, topiclist) {
		return {bundle: bundle, profile: profile, signin: signin, topic: topic, topiclist: topiclist};
	});
var $author$project$Join$Flags$extraJoinViewTransitionsDecoder = A6(
	$elm$json$Json$Decode$map5,
	$author$project$Join$Flags$ExtraJoinViewTransitions,
	A2($elm$json$Json$Decode$field, 'bundle', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'profile', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'signin', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'topic', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'topiclist', $elm$json$Json$Decode$string));
var $author$project$Join$Flags$extraJoinViewDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$Join$Flags$ExtraJoinView,
	A2($elm$json$Json$Decode$field, 'errors', $author$project$Join$Flags$extraJoinViewErrorsDecoder),
	A2($elm$json$Json$Decode$field, 'labels', $author$project$Join$Flags$extraJoinViewLabelsDecoder),
	A2($elm$json$Json$Decode$field, 'requests', $author$project$Join$Flags$extraJoinViewRequestsDecoder),
	A2($elm$json$Json$Decode$field, 'transitions', $author$project$Join$Flags$extraJoinViewTransitionsDecoder));
var $author$project$Join$Flags$ExtraProgressView = function (labels) {
	return {labels: labels};
};
var $author$project$Join$Flags$ExtraProgressViewLabels = F4(
	function (decodeErrors, diagnosticLogs, status, workflow) {
		return {decodeErrors: decodeErrors, diagnosticLogs: diagnosticLogs, status: status, workflow: workflow};
	});
var $author$project$Join$Flags$ExtraProgressViewLabelsDecodeErrors = function (label) {
	return {label: label};
};
var $author$project$Join$Flags$extraProgressViewLabelsDecodeErrorsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Join$Flags$ExtraProgressViewLabelsDecodeErrors,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Join$Flags$ExtraProgressViewLabelsDiagnosticLogs = function (label) {
	return {label: label};
};
var $author$project$Join$Flags$extraProgressViewLabelsDiagnosticLogsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Join$Flags$ExtraProgressViewLabelsDiagnosticLogs,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Join$Flags$ExtraProgressViewLabelsStatus = F2(
	function (failure, success) {
		return {failure: failure, success: success};
	});
var $author$project$Join$Flags$extraProgressViewLabelsStatusDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Join$Flags$ExtraProgressViewLabelsStatus,
	A2($elm$json$Json$Decode$field, 'failure', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'success', $elm$json$Json$Decode$string));
var $author$project$Join$Flags$ExtraProgressViewLabelsWorkflow = function (label) {
	return {label: label};
};
var $author$project$Join$Flags$extraProgressViewLabelsWorkflowDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Join$Flags$ExtraProgressViewLabelsWorkflow,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Join$Flags$extraProgressViewLabelsDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$Join$Flags$ExtraProgressViewLabels,
	A2($elm$json$Json$Decode$field, 'decode_errors', $author$project$Join$Flags$extraProgressViewLabelsDecodeErrorsDecoder),
	A2($elm$json$Json$Decode$field, 'diagnostic_logs', $author$project$Join$Flags$extraProgressViewLabelsDiagnosticLogsDecoder),
	A2($elm$json$Json$Decode$field, 'status', $author$project$Join$Flags$extraProgressViewLabelsStatusDecoder),
	A2($elm$json$Json$Decode$field, 'workflow', $author$project$Join$Flags$extraProgressViewLabelsWorkflowDecoder));
var $author$project$Join$Flags$extraProgressViewDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Join$Flags$ExtraProgressView,
	A2($elm$json$Json$Decode$field, 'labels', $author$project$Join$Flags$extraProgressViewLabelsDecoder));
var $author$project$Join$Flags$extraDecoder = A7(
	$elm$json$Json$Decode$map6,
	$author$project$Join$Flags$Extra,
	A2($elm$json$Json$Decode$field, 'join_view', $author$project$Join$Flags$extraJoinViewDecoder),
	A2($elm$json$Json$Decode$field, 'mode', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'module', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'progress_view', $author$project$Join$Flags$extraProgressViewDecoder),
	A2(
		$elm$json$Json$Decode$field,
		'view_nodes',
		$elm$json$Json$Decode$list($elm$json$Json$Decode$string)),
	A2(
		$elm$json$Json$Decode$field,
		'workflowpaths',
		$elm$json$Json$Decode$list($elm$json$Json$Decode$string)));
var $author$project$Join$Flags$FlagsConfig = F3(
	function (baseUrl, defaultLanguage, extra) {
		return {baseUrl: baseUrl, defaultLanguage: defaultLanguage, extra: extra};
	});
var $author$project$Join$Flags$FlagsConfigExtra = F4(
	function (dev, originCollab, originReview, title) {
		return {dev: dev, originCollab: originCollab, originReview: originReview, title: title};
	});
var $author$project$Join$Flags$flagsConfigExtraDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$Join$Flags$FlagsConfigExtra,
	A2($elm$json$Json$Decode$field, 'dev', $elm$json$Json$Decode$bool),
	A2($elm$json$Json$Decode$field, 'origin_collab', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'origin_review', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'title', $elm$json$Json$Decode$string));
var $author$project$Join$Flags$flagsConfigDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Join$Flags$FlagsConfig,
	A2($elm$json$Json$Decode$field, 'base_url', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'default_language', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'extra', $author$project$Join$Flags$flagsConfigExtraDecoder));
var $author$project$Join$Flags$FlagsWorkflowsObject = F3(
	function (name, label, progress) {
		return {label: label, name: name, progress: progress};
	});
var $author$project$Join$Flags$FlagsWorkflowsObjectProgressObject = F2(
	function (display, messages) {
		return {display: display, messages: messages};
	});
var $author$project$Join$Flags$FlagsWorkflowsObjectProgressObjectDisplay = F7(
	function (error, error2, init, ok, ok2, skip, skip2) {
		return {error: error, error2: error2, init: init, ok: ok, ok2: ok2, skip: skip, skip2: skip2};
	});
var $author$project$Join$Flags$flagsWorkflowsObjectProgressObjectDisplayDecoder = A8(
	$elm$json$Json$Decode$map7,
	$author$project$Join$Flags$FlagsWorkflowsObjectProgressObjectDisplay,
	A2($elm$json$Json$Decode$field, 'error', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'error2', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'init', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'ok', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'ok2', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'skip', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'skip2', $elm$json$Json$Decode$string));
var $author$project$Join$Flags$FlagsWorkflowsObjectProgressObjectMessages = F2(
	function (error, ok) {
		return {error: error, ok: ok};
	});
var $author$project$Join$Flags$flagsWorkflowsObjectProgressObjectMessagesDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Join$Flags$FlagsWorkflowsObjectProgressObjectMessages,
	A2($elm$json$Json$Decode$field, 'error', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'ok', $elm$json$Json$Decode$string));
var $author$project$Join$Flags$flagsWorkflowsObjectProgressObjectDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Join$Flags$FlagsWorkflowsObjectProgressObject,
	A2($elm$json$Json$Decode$field, 'display', $author$project$Join$Flags$flagsWorkflowsObjectProgressObjectDisplayDecoder),
	A2($elm$json$Json$Decode$field, 'messages', $author$project$Join$Flags$flagsWorkflowsObjectProgressObjectMessagesDecoder));
var $author$project$Join$Flags$flagsWorkflowsObjectDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Join$Flags$FlagsWorkflowsObject,
	A2($elm$json$Json$Decode$field, 'name', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2(
		$elm$json$Json$Decode$field,
		'progress',
		$elm$json$Json$Decode$list($author$project$Join$Flags$flagsWorkflowsObjectProgressObjectDecoder)));
var $author$project$Join$Flags$flagsDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Join$Flags$Flags,
	A2($elm$json$Json$Decode$field, 'config', $author$project$Join$Flags$flagsConfigDecoder),
	A2($elm$json$Json$Decode$field, 'extra', $author$project$Join$Flags$extraDecoder),
	A2(
		$elm$json$Json$Decode$field,
		'workflows',
		$elm$json$Json$Decode$list($author$project$Join$Flags$flagsWorkflowsObjectDecoder)));
var $author$project$Join$Flags$jsonToResultFlags = function (json) {
	return A2(
		$elm$core$Result$mapError,
		$elm$json$Json$Decode$errorToString,
		A2($elm$json$Json$Decode$decodeValue, $author$project$Join$Flags$flagsDecoder, json));
};
var $author$project$Join$Model$ProgressMsg = function (a) {
	return {$: 'ProgressMsg', a: a};
};
var $author$project$Join$progressCmds = function (pcmds) {
	return A2($elm$core$Platform$Cmd$map, $author$project$Join$Model$ProgressMsg, pcmds);
};
var $author$project$Join$progressFlags = function (flags) {
	return {labels: flags.extra.progressView.labels, workflows: flags.workflows};
};
var $author$project$Join$Valid$invitelinkregex_development = '^(http://127.0.0.1:[0-9]+|https://[^.]+.securepub.org)/_v1.2401_/join/#[A-Z0-9]{78}$';
var $author$project$Join$Valid$validLinkRegex = A2(
	$elm$core$Maybe$withDefault,
	$elm$regex$Regex$never,
	$elm$regex$Regex$fromString($author$project$Join$Valid$invitelinkregex_development));
var $author$project$Join$Valid$linkSyntaxErr = F2(
	function (flags, link) {
		var errors = flags.extra.joinView.errors;
		var _v0 = A2($elm$regex$Regex$contains, $author$project$Join$Valid$validLinkRegex, link);
		if (_v0) {
			return $elm$core$Maybe$Nothing;
		} else {
			return $elm$core$Maybe$Just(errors.link.syntax);
		}
	});
var $author$project$Join$Valid$linkErr = F2(
	function (flags, link) {
		return $elm_community$maybe_extra$Maybe$Extra$orList(
			_List_fromArray(
				[
					A2($author$project$Join$Valid$linkSyntaxErr, flags, link)
				]));
	});
var $author$project$Join$Model$validate = F2(
	function (flags, link) {
		return {
			linkErr: A2($author$project$Join$Valid$linkErr, flags, link)
		};
	});
var $author$project$Join$Model$validateState = F2(
	function (flags, state) {
		return _Utils_update(
			state,
			{
				problems: A2($author$project$Join$Model$validate, flags, state.link)
			});
	});
var $author$project$Join$init = function (value) {
	var _v0 = $author$project$Join$Flags$jsonToResultFlags(value);
	if (_v0.$ === 'Err') {
		var err = _v0.a;
		return _Utils_Tuple2(
			$author$project$Join$Model$Failed(err),
			$elm$core$Platform$Cmd$none);
	} else {
		var flags = _v0.a;
		var _v1 = $author$project$Progress$Model$init(
			$author$project$Join$progressFlags(flags));
		var pstate = _v1.a;
		var pcmds = _v1.b;
		return _Utils_Tuple2(
			A2(
				$author$project$Join$Model$Loaded,
				flags,
				A2(
					$author$project$Join$Model$validateState,
					flags,
					{
						link: '',
						problems: $author$project$Join$Model$Problems($elm$core$Maybe$Nothing),
						progress: pstate,
						response: $krisajenkins$remotedata$RemoteData$NotAsked,
						transition: true
					})),
			$author$project$Join$progressCmds(pcmds));
	}
};
var $author$project$Join$Model$Incoming = function (a) {
	return {$: 'Incoming', a: a};
};
var $author$project$Join$subscriptions = function (model) {
	return $author$project$Shared$Ports$toElm($author$project$Join$Model$Incoming);
};
var $author$project$Join$cmdJoin = F2(
	function (flags, state) {
		var request = $elm$json$Json$Encode$object(
			_List_fromArray(
				[
					_Utils_Tuple2(
					'kind',
					$elm$json$Json$Encode$string(flags.extra.joinView.requests.submit)),
					_Utils_Tuple2(
					'link',
					$elm$json$Json$Encode$string(state.link))
				]));
		var newstate = _Utils_update(
			state,
			{response: $krisajenkins$remotedata$RemoteData$Loading});
		return _Utils_Tuple2(
			A2($author$project$Join$Model$Loaded, flags, newstate),
			$author$project$Shared$Ports$toMain(request));
	});
var $author$project$Join$updateStateCmds = F3(
	function (flags, state, cmds) {
		return _Utils_Tuple2(
			A2($author$project$Join$Model$Loaded, flags, state),
			cmds);
	});
var $author$project$Join$updateProgress = F3(
	function (flags, state, pmsg) {
		var _v0 = A3(
			$author$project$Progress$Model$update,
			$author$project$Join$progressFlags(flags),
			state.progress,
			pmsg);
		var pstate = _v0.a;
		var pcmds = _v0.b;
		return A3(
			$author$project$Join$updateStateCmds,
			flags,
			_Utils_update(
				state,
				{progress: pstate}),
			$author$project$Join$progressCmds(pcmds));
	});
var $author$project$Join$updateState = F2(
	function (flags, state) {
		return A3(
			$author$project$Join$updateStateCmds,
			flags,
			A2($author$project$Join$Model$validateState, flags, state),
			$elm$core$Platform$Cmd$none);
	});
var $author$project$Join$Decode$JoinFailed = function (a) {
	return {$: 'JoinFailed', a: a};
};
var $author$project$Join$Decode$JoinHomeBundle = function (a) {
	return {$: 'JoinHomeBundle', a: a};
};
var $author$project$Join$Decode$JoinHomeTopic = function (a) {
	return {$: 'JoinHomeTopic', a: a};
};
var $author$project$Join$Decode$JoinLink = function (a) {
	return {$: 'JoinLink', a: a};
};
var $author$project$Join$Decode$JoinNoProfile = function (a) {
	return {$: 'JoinNoProfile', a: a};
};
var $author$project$Join$Decode$JoinNotFound = function (a) {
	return {$: 'JoinNotFound', a: a};
};
var $author$project$Join$Decode$JoinSignIn = function (a) {
	return {$: 'JoinSignIn', a: a};
};
var $author$project$Join$Decode$JoinStarting = function (a) {
	return {$: 'JoinStarting', a: a};
};
var $author$project$Join$Decode$JoinTopicList = {$: 'JoinTopicList'};
var $author$project$Join$Decode$Progress = function (a) {
	return {$: 'Progress', a: a};
};
var $author$project$Join$Decode$incomingMsgDecoderByMsg = function (msg) {
	switch (msg) {
		case 'error':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Join$Decode$JoinFailed,
				$elm$json$Json$Decode$maybe(
					A2($elm$json$Json$Decode$field, 'details', $elm$json$Json$Decode$string)));
		case 'join link':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Join$Decode$JoinLink,
				A2($elm$json$Json$Decode$field, 'link', $elm$json$Json$Decode$string));
		case 'join starting':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Join$Decode$JoinStarting,
				A2($elm$json$Json$Decode$field, 'link', $elm$json$Json$Decode$string));
		case 'join signin':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Join$Decode$JoinSignIn,
				$elm$json$Json$Decode$maybe(
					A2($elm$json$Json$Decode$field, 'details', $elm$json$Json$Decode$string)));
		case 'join notfound':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Join$Decode$JoinNotFound,
				$elm$json$Json$Decode$maybe(
					A2($elm$json$Json$Decode$field, 'details', $elm$json$Json$Decode$string)));
		case 'join no profile':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Join$Decode$JoinNoProfile,
				$elm$json$Json$Decode$maybe(
					A2($elm$json$Json$Decode$field, 'details', $elm$json$Json$Decode$string)));
		case 'join topiclist':
			return $elm$json$Json$Decode$succeed($author$project$Join$Decode$JoinTopicList);
		case 'join topic':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Join$Decode$JoinHomeTopic,
				A2($elm$json$Json$Decode$field, 'tkey', $elm$json$Json$Decode$string));
		case 'join bundle':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Join$Decode$JoinHomeBundle,
				A2($elm$json$Json$Decode$field, 'bnum', $elm$json$Json$Decode$int));
		case 'progress':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Join$Decode$Progress,
				A2($elm$json$Json$Decode$field, 'progress', $elm$json$Json$Decode$value));
		default:
			var other = msg;
			return $elm$json$Json$Decode$fail(other);
	}
};
var $author$project$Join$Decode$incomingMsgDecoder = A2(
	$elm$json$Json$Decode$andThen,
	$author$project$Join$Decode$incomingMsgDecoderByMsg,
	A2($elm$json$Json$Decode$field, 'msg', $elm$json$Json$Decode$string));
var $author$project$Join$Decode$valueToIncomingMsg = function (value) {
	return A2(
		$elm$core$Result$mapError,
		$elm$json$Json$Decode$errorToString,
		A2($elm$json$Json$Decode$decodeValue, $author$project$Join$Decode$incomingMsgDecoder, value));
};
var $author$project$Join$update = F2(
	function (msg, model) {
		var _v0 = _Utils_Tuple2(model, msg);
		if (_v0.a.$ === 'Failed') {
			return _Utils_Tuple2(model, $elm$core$Platform$Cmd$none);
		} else {
			switch (_v0.b.$) {
				case 'UpdateLink':
					var _v1 = _v0.a;
					var flags = _v1.a;
					var state = _v1.b;
					var link = _v0.b.a;
					return A2(
						$author$project$Join$updateState,
						flags,
						_Utils_update(
							state,
							{link: link, response: $krisajenkins$remotedata$RemoteData$NotAsked}));
				case 'UpdateTransition':
					var _v2 = _v0.a;
					var flags = _v2.a;
					var state = _v2.b;
					var value = _v0.b.a;
					return A2(
						$author$project$Join$updateState,
						flags,
						_Utils_update(
							state,
							{response: $krisajenkins$remotedata$RemoteData$NotAsked, transition: value}));
				case 'PressJoinEngagement':
					var _v3 = _v0.a;
					var flags = _v3.a;
					var state = _v3.b;
					var _v4 = _v0.b;
					return A2($author$project$Join$cmdJoin, flags, state);
				case 'ProgressMsg':
					var _v5 = _v0.a;
					var flags = _v5.a;
					var state = _v5.b;
					var pmsg = _v0.b.a;
					return A3($author$project$Join$updateProgress, flags, state, pmsg);
				default:
					var _v6 = _v0.a;
					var flags = _v6.a;
					var state = _v6.b;
					var v = _v0.b.a;
					var _v7 = _Utils_Tuple2(
						$author$project$Join$Decode$valueToIncomingMsg(v),
						state.transition);
					if (_v7.a.$ === 'Err') {
						var err = _v7.a.a;
						return $author$project$Shared$Reg$decodeErr(err) ? A3(
							$author$project$Join$updateProgress,
							flags,
							state,
							$author$project$Progress$Model$DecodeErr(err)) : A2($author$project$Shared$Cmd$cmdLog, 'Err ' + err, model);
					} else {
						switch (_v7.a.a.$) {
							case 'JoinLink':
								var link = _v7.a.a.a;
								return A2(
									$author$project$Join$updateState,
									flags,
									_Utils_update(
										state,
										{link: link}));
							case 'JoinStarting':
								var link = _v7.a.a.a;
								return A2(
									$author$project$Join$updateState,
									flags,
									_Utils_update(
										state,
										{link: link, response: $krisajenkins$remotedata$RemoteData$Loading}));
							case 'JoinFailed':
								var mdetails = _v7.a.a.a;
								if (mdetails.$ === 'Nothing') {
									return A2(
										$author$project$Join$updateState,
										flags,
										_Utils_update(
											state,
											{
												response: $krisajenkins$remotedata$RemoteData$Failure(flags.extra.joinView.errors.link.failed)
											}));
								} else {
									var err = mdetails.a;
									return A2(
										$author$project$Join$updateState,
										flags,
										_Utils_update(
											state,
											{
												response: $krisajenkins$remotedata$RemoteData$Failure(err)
											}));
								}
							case 'JoinNotFound':
								var mdetails = _v7.a.a.a;
								return A3(
									$author$project$Shared$Cmd$cmdLogDetails,
									'JoinNotFound',
									mdetails,
									A2(
										$author$project$Join$Model$Loaded,
										flags,
										_Utils_update(
											state,
											{
												response: $krisajenkins$remotedata$RemoteData$Failure(flags.extra.joinView.errors.link.notFound)
											})));
							case 'JoinSignIn':
								if (_v7.b) {
									return A2($author$project$Shared$Cmd$cmdTransition, flags.extra.joinView.transitions.signin, model);
								} else {
									var mdetails = _v7.a.a.a;
									return A3(
										$author$project$Shared$Cmd$cmdLogDetails,
										'JoinSignIn',
										mdetails,
										A2(
											$author$project$Join$Model$Loaded,
											flags,
											_Utils_update(
												state,
												{
													response: $krisajenkins$remotedata$RemoteData$Failure(flags.extra.joinView.errors.link.pleaseSignIn)
												})));
								}
							case 'JoinNoProfile':
								if (_v7.b) {
									var mdetails = _v7.a.a.a;
									return A2($author$project$Shared$Cmd$cmdTransition, flags.extra.joinView.transitions.profile, model);
								} else {
									var mdetails = _v7.a.a.a;
									return A3(
										$author$project$Shared$Cmd$cmdLogDetails,
										'JoinNoProfile',
										mdetails,
										A2(
											$author$project$Join$Model$Loaded,
											flags,
											_Utils_update(
												state,
												{
													response: $krisajenkins$remotedata$RemoteData$Failure(flags.extra.joinView.errors.link.noProfile)
												})));
								}
							case 'JoinTopicList':
								if (_v7.b) {
									var _v9 = _v7.a.a;
									return A2($author$project$Shared$Cmd$cmdTransition, flags.extra.joinView.transitions.topiclist, model);
								} else {
									var _v10 = _v7.a.a;
									return A2(
										$author$project$Join$updateState,
										flags,
										_Utils_update(
											state,
											{
												response: $krisajenkins$remotedata$RemoteData$Success('')
											}));
								}
							case 'JoinHomeTopic':
								if (_v7.b) {
									var tkey = _v7.a.a.a;
									return A3($author$project$Shared$Cmd$cmdTransitionString, flags.extra.joinView.transitions.topic, tkey, model);
								} else {
									return A2(
										$author$project$Join$updateState,
										flags,
										_Utils_update(
											state,
											{
												response: $krisajenkins$remotedata$RemoteData$Success('')
											}));
								}
							case 'JoinHomeBundle':
								if (_v7.b) {
									var bnum = _v7.a.a.a;
									return A3($author$project$Shared$Cmd$cmdTransitionNumber, flags.extra.joinView.transitions.bundle, bnum, model);
								} else {
									return A2(
										$author$project$Join$updateState,
										flags,
										_Utils_update(
											state,
											{
												response: $krisajenkins$remotedata$RemoteData$Success('')
											}));
								}
							default:
								var value = _v7.a.a.a;
								return A3(
									$author$project$Join$updateProgress,
									flags,
									state,
									$author$project$Progress$Model$Incoming(value));
						}
					}
			}
		}
	});
var $author$project$Join$currentView = 0;
var $author$project$Join$Model$PressJoinEngagement = {$: 'PressJoinEngagement'};
var $author$project$Join$View$okToSubmit = function (state) {
	var _v0 = _Utils_Tuple2(state.problems.linkErr, state.response);
	_v0$2:
	while (true) {
		if (_v0.a.$ === 'Nothing') {
			switch (_v0.b.$) {
				case 'NotAsked':
					var _v1 = _v0.a;
					var _v2 = _v0.b;
					return true;
				case 'Success':
					var _v3 = _v0.a;
					return true;
				default:
					break _v0$2;
			}
		} else {
			break _v0$2;
		}
	}
	return false;
};
var $author$project$Join$View$viewButton = F2(
	function (flags, state) {
		var loading = function (cls) {
			var _v0 = state.response;
			if (_v0.$ === 'Loading') {
				return cls + ' is-loading';
			} else {
				return cls;
			}
		};
		var enabled = $author$project$Join$View$okToSubmit(state);
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('field is-horizontal')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-label')
						]),
					_List_Nil),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-body')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('control')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$button,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class(
													loading('button has-background-primary-dark has-text-white is-link')),
													$elm$html$Html$Attributes$disabled(!enabled),
													$elm$html$Html$Events$onClick($author$project$Join$Model$PressJoinEngagement)
												]),
											_List_fromArray(
												[
													$elm$html$Html$text(flags.extra.joinView.labels.join.label)
												]))
										]))
								]))
						]))
				]));
	});
var $author$project$Join$Model$UpdateLink = function (a) {
	return {$: 'UpdateLink', a: a};
};
var $author$project$Join$Valid$invitelinkplaceholder = 'https://gl2401.securepub.org/_v1.2401_/join/#47F4TFNW33963TS1RQDK1ZNRS001H480TJ7E7QY443K0CG4RFRF701H6ETXTHFVJQFXMMR23GV4ZBR';
var $author$project$Join$View$viewError = F2(
	function (flags, state) {
		var _v0 = _Utils_Tuple2(state.link === '', state.problems.linkErr);
		if (_v0.a) {
			return A2(
				$elm$html$Html$p,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('help is-danger')
					]),
				_List_fromArray(
					[
						$elm$html$Html$text(flags.extra.joinView.labels.link.required)
					]));
		} else {
			if (_v0.b.$ === 'Just') {
				var lines = _Utils_ap(
					A2($elm$core$String$split, '\n', flags.extra.joinView.errors.link.syntax),
					_List_fromArray(
						[$author$project$Join$Valid$invitelinkplaceholder]));
				return A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('help is-danger')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$p,
							_List_Nil,
							$author$project$Shared$Text$htmlTextDivs(lines))
						]));
			} else {
				var maybeRequestError = function () {
					var _v2 = state.response;
					if (_v2.$ === 'Failure') {
						var msg = _v2.a;
						return $elm$core$Maybe$Just(msg);
					} else {
						return $elm$core$Maybe$Nothing;
					}
				}();
				if (maybeRequestError.$ === 'Just') {
					var msg = maybeRequestError.a;
					return A2(
						$elm$html$Html$label,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('help is-danger')
							]),
						_List_fromArray(
							[
								$elm$html$Html$text(msg)
							]));
				} else {
					return A2($elm$html$Html$div, _List_Nil, _List_Nil);
				}
			}
		}
	});
var $author$project$Join$View$viewLink = F2(
	function (flags, state) {
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('field is-horizontal')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-label is-normal')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$label,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('label ml-1')
								]),
							_List_fromArray(
								[
									$elm$html$Html$text(flags.extra.joinView.labels.link.label)
								]))
						])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-body')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('control')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$input,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('input'),
													$elm$html$Html$Attributes$type_('text'),
													$elm$html$Html$Attributes$placeholder($author$project$Join$Valid$invitelinkplaceholder),
													$elm$html$Html$Attributes$value(state.link),
													$elm$html$Html$Events$onInput($author$project$Join$Model$UpdateLink),
													$author$project$Shared$OnEnter$onEnter($author$project$Join$Model$PressJoinEngagement)
												]),
											_List_Nil)
										])),
									A2($author$project$Join$View$viewError, flags, state)
								])),
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field-label is-normal'),
									A2($elm$html$Html$Attributes$style, 'max-width', '5px')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$label,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('label')
										]),
									_List_Nil)
								]))
						]))
				]));
	});
var $author$project$Join$View$view = F2(
	function (flags, state) {
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('sp-form ml-5 mr-3')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$br,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('is-hidden-mobile')
						]),
					_List_Nil),
					A2($author$project$Join$View$viewLink, flags, state),
					A2($author$project$Join$View$viewButton, flags, state),
					A2(
					$elm$html$Html$br,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('is-hidden-mobile')
						]),
					_List_Nil)
				]));
	});
var $author$project$Join$view = function (model) {
	var _v0 = _Utils_Tuple2($author$project$Join$currentView, model);
	_v0$3:
	while (true) {
		if (_v0.b.$ === 'Failed') {
			if (!_v0.a) {
				var err = _v0.b.a;
				return A2(
					$elm$html$Html$p,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('notification is-danger')
						]),
					_List_fromArray(
						[
							$elm$html$Html$text(err)
						]));
			} else {
				break _v0$3;
			}
		} else {
			switch (_v0.a) {
				case 0:
					var _v1 = _v0.b;
					var flags = _v1.a;
					var state = _v1.b;
					return A2($author$project$Join$View$view, flags, state);
				case 1:
					var _v2 = _v0.b;
					var flags = _v2.a;
					var state = _v2.b;
					return A2(
						$elm$html$Html$map,
						$author$project$Join$Model$ProgressMsg,
						A2(
							$author$project$Progress$View$view,
							$author$project$Join$progressFlags(flags),
							state.progress));
				default:
					break _v0$3;
			}
		}
	}
	return A2($elm$html$Html$div, _List_Nil, _List_Nil);
};
var $author$project$Join$main = $elm$browser$Browser$element(
	{init: $author$project$Join$init, subscriptions: $author$project$Join$subscriptions, update: $author$project$Join$update, view: $author$project$Join$view});
var $author$project$Create$Model$Failed = function (a) {
	return {$: 'Failed', a: a};
};
var $author$project$Create$Model$Loaded = F2(
	function (a, b) {
		return {$: 'Loaded', a: a, b: b};
	});
var $author$project$Create$Flags$Flags = F3(
	function (config, extra, workflows) {
		return {config: config, extra: extra, workflows: workflows};
	});
var $author$project$Create$Flags$Extra = F7(
	function (createView, mode, module_, progressView, remotedata, viewNodes, workflowpaths) {
		return {createView: createView, mode: mode, module_: module_, progressView: progressView, remotedata: remotedata, viewNodes: viewNodes, workflowpaths: workflowpaths};
	});
var $author$project$Create$Flags$ExtraCreateView = F3(
	function (labels, requests, transitions) {
		return {labels: labels, requests: requests, transitions: transitions};
	});
var $author$project$Create$Flags$ExtraCreateViewLabels = F6(
	function (appid, create, error, hostLink, problem, proceed) {
		return {appid: appid, create: create, error: error, hostLink: hostLink, problem: problem, proceed: proceed};
	});
var $author$project$Create$Flags$ExtraCreateViewLabelsAppid = F9(
	function (appid, createFailed, invalidAppid, isnil, noversion, required, unsupportedvariant, wrongformat, wronglength) {
		return {appid: appid, createFailed: createFailed, invalidAppid: invalidAppid, isnil: isnil, noversion: noversion, required: required, unsupportedvariant: unsupportedvariant, wrongformat: wrongformat, wronglength: wronglength};
	});
var $author$project$Create$Flags$extraCreateViewLabelsAppidDecoder = function () {
	var fieldSet0 = A9(
		$elm$json$Json$Decode$map8,
		$author$project$Create$Flags$ExtraCreateViewLabelsAppid,
		A2($elm$json$Json$Decode$field, 'appid', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'create_failed', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'invalid_appid', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'isnil', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'noversion', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'required', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'unsupportedvariant', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'wrongformat', $elm$json$Json$Decode$string));
	return A3(
		$elm$json$Json$Decode$map2,
		$elm$core$Basics$apL,
		fieldSet0,
		A2($elm$json$Json$Decode$field, 'wronglength', $elm$json$Json$Decode$string));
}();
var $author$project$Create$Flags$ExtraCreateViewLabelsCreate = function (label) {
	return {label: label};
};
var $author$project$Create$Flags$extraCreateViewLabelsCreateDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Create$Flags$ExtraCreateViewLabelsCreate,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Create$Flags$ExtraCreateViewLabelsError = F2(
	function (description, label) {
		return {description: description, label: label};
	});
var $author$project$Create$Flags$extraCreateViewLabelsErrorDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Create$Flags$ExtraCreateViewLabelsError,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Create$Flags$ExtraCreateViewLabelsHostLink = F6(
	function (copied, copy, description, keepsafe, label, norecovery) {
		return {copied: copied, copy: copy, description: description, keepsafe: keepsafe, label: label, norecovery: norecovery};
	});
var $author$project$Create$Flags$extraCreateViewLabelsHostLinkDecoder = A7(
	$elm$json$Json$Decode$map6,
	$author$project$Create$Flags$ExtraCreateViewLabelsHostLink,
	A2($elm$json$Json$Decode$field, 'copied', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'copy', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'keepsafe', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'norecovery', $elm$json$Json$Decode$string));
var $author$project$Create$Flags$ExtraCreateViewLabelsProblem = function (label) {
	return {label: label};
};
var $author$project$Create$Flags$extraCreateViewLabelsProblemDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Create$Flags$ExtraCreateViewLabelsProblem,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Create$Flags$ExtraCreateViewLabelsProceed = function (label) {
	return {label: label};
};
var $author$project$Create$Flags$extraCreateViewLabelsProceedDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Create$Flags$ExtraCreateViewLabelsProceed,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Create$Flags$extraCreateViewLabelsDecoder = A7(
	$elm$json$Json$Decode$map6,
	$author$project$Create$Flags$ExtraCreateViewLabels,
	A2($elm$json$Json$Decode$field, 'appid', $author$project$Create$Flags$extraCreateViewLabelsAppidDecoder),
	A2($elm$json$Json$Decode$field, 'create', $author$project$Create$Flags$extraCreateViewLabelsCreateDecoder),
	A2($elm$json$Json$Decode$field, 'error', $author$project$Create$Flags$extraCreateViewLabelsErrorDecoder),
	A2($elm$json$Json$Decode$field, 'host_link', $author$project$Create$Flags$extraCreateViewLabelsHostLinkDecoder),
	A2($elm$json$Json$Decode$field, 'problem', $author$project$Create$Flags$extraCreateViewLabelsProblemDecoder),
	A2($elm$json$Json$Decode$field, 'proceed', $author$project$Create$Flags$extraCreateViewLabelsProceedDecoder));
var $author$project$Create$Flags$ExtraCreateViewRequests = F2(
	function (cancel, submit) {
		return {cancel: cancel, submit: submit};
	});
var $author$project$Create$Flags$extraCreateViewRequestsDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Create$Flags$ExtraCreateViewRequests,
	A2($elm$json$Json$Decode$field, 'cancel', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'submit', $elm$json$Json$Decode$string));
var $author$project$Create$Flags$ExtraCreateViewTransitions = F2(
	function (prefix, profile) {
		return {prefix: prefix, profile: profile};
	});
var $author$project$Create$Flags$extraCreateViewTransitionsDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Create$Flags$ExtraCreateViewTransitions,
	A2($elm$json$Json$Decode$field, 'prefix', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'profile', $elm$json$Json$Decode$string));
var $author$project$Create$Flags$extraCreateViewDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Create$Flags$ExtraCreateView,
	A2($elm$json$Json$Decode$field, 'labels', $author$project$Create$Flags$extraCreateViewLabelsDecoder),
	A2($elm$json$Json$Decode$field, 'requests', $author$project$Create$Flags$extraCreateViewRequestsDecoder),
	A2($elm$json$Json$Decode$field, 'transitions', $author$project$Create$Flags$extraCreateViewTransitionsDecoder));
var $author$project$Create$Flags$ExtraProgressView = function (labels) {
	return {labels: labels};
};
var $author$project$Create$Flags$ExtraProgressViewLabels = F4(
	function (decodeErrors, diagnosticLogs, status, workflow) {
		return {decodeErrors: decodeErrors, diagnosticLogs: diagnosticLogs, status: status, workflow: workflow};
	});
var $author$project$Create$Flags$ExtraProgressViewLabelsDecodeErrors = function (label) {
	return {label: label};
};
var $author$project$Create$Flags$extraProgressViewLabelsDecodeErrorsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Create$Flags$ExtraProgressViewLabelsDecodeErrors,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Create$Flags$ExtraProgressViewLabelsDiagnosticLogs = function (label) {
	return {label: label};
};
var $author$project$Create$Flags$extraProgressViewLabelsDiagnosticLogsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Create$Flags$ExtraProgressViewLabelsDiagnosticLogs,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Create$Flags$ExtraProgressViewLabelsStatus = F2(
	function (failure, success) {
		return {failure: failure, success: success};
	});
var $author$project$Create$Flags$extraProgressViewLabelsStatusDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Create$Flags$ExtraProgressViewLabelsStatus,
	A2($elm$json$Json$Decode$field, 'failure', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'success', $elm$json$Json$Decode$string));
var $author$project$Create$Flags$ExtraProgressViewLabelsWorkflow = function (label) {
	return {label: label};
};
var $author$project$Create$Flags$extraProgressViewLabelsWorkflowDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Create$Flags$ExtraProgressViewLabelsWorkflow,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Create$Flags$extraProgressViewLabelsDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$Create$Flags$ExtraProgressViewLabels,
	A2($elm$json$Json$Decode$field, 'decode_errors', $author$project$Create$Flags$extraProgressViewLabelsDecodeErrorsDecoder),
	A2($elm$json$Json$Decode$field, 'diagnostic_logs', $author$project$Create$Flags$extraProgressViewLabelsDiagnosticLogsDecoder),
	A2($elm$json$Json$Decode$field, 'status', $author$project$Create$Flags$extraProgressViewLabelsStatusDecoder),
	A2($elm$json$Json$Decode$field, 'workflow', $author$project$Create$Flags$extraProgressViewLabelsWorkflowDecoder));
var $author$project$Create$Flags$extraProgressViewDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Create$Flags$ExtraProgressView,
	A2($elm$json$Json$Decode$field, 'labels', $author$project$Create$Flags$extraProgressViewLabelsDecoder));
var $author$project$Create$Flags$ExtraRemotedata = F4(
	function (failure, loading, notasked, success) {
		return {failure: failure, loading: loading, notasked: notasked, success: success};
	});
var $author$project$Create$Flags$extraRemotedataDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$Create$Flags$ExtraRemotedata,
	A2($elm$json$Json$Decode$field, 'failure', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'loading', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'notasked', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'success', $elm$json$Json$Decode$string));
var $author$project$Create$Flags$extraDecoder = A8(
	$elm$json$Json$Decode$map7,
	$author$project$Create$Flags$Extra,
	A2($elm$json$Json$Decode$field, 'create_view', $author$project$Create$Flags$extraCreateViewDecoder),
	A2($elm$json$Json$Decode$field, 'mode', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'module', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'progress_view', $author$project$Create$Flags$extraProgressViewDecoder),
	A2($elm$json$Json$Decode$field, 'remotedata', $author$project$Create$Flags$extraRemotedataDecoder),
	A2(
		$elm$json$Json$Decode$field,
		'view_nodes',
		$elm$json$Json$Decode$list($elm$json$Json$Decode$string)),
	A2(
		$elm$json$Json$Decode$field,
		'workflowpaths',
		$elm$json$Json$Decode$list($elm$json$Json$Decode$string)));
var $author$project$Create$Flags$FlagsConfig = F3(
	function (baseUrl, defaultLanguage, extra) {
		return {baseUrl: baseUrl, defaultLanguage: defaultLanguage, extra: extra};
	});
var $author$project$Create$Flags$FlagsConfigExtra = F4(
	function (dev, originCollab, originReview, title) {
		return {dev: dev, originCollab: originCollab, originReview: originReview, title: title};
	});
var $author$project$Create$Flags$flagsConfigExtraDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$Create$Flags$FlagsConfigExtra,
	A2($elm$json$Json$Decode$field, 'dev', $elm$json$Json$Decode$bool),
	A2($elm$json$Json$Decode$field, 'origin_collab', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'origin_review', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'title', $elm$json$Json$Decode$string));
var $author$project$Create$Flags$flagsConfigDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Create$Flags$FlagsConfig,
	A2($elm$json$Json$Decode$field, 'base_url', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'default_language', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'extra', $author$project$Create$Flags$flagsConfigExtraDecoder));
var $author$project$Create$Flags$FlagsWorkflowsObject = F3(
	function (name, label, progress) {
		return {label: label, name: name, progress: progress};
	});
var $author$project$Create$Flags$FlagsWorkflowsObjectProgressObject = F2(
	function (display, messages) {
		return {display: display, messages: messages};
	});
var $author$project$Create$Flags$FlagsWorkflowsObjectProgressObjectDisplay = F7(
	function (error, error2, init, ok, ok2, skip, skip2) {
		return {error: error, error2: error2, init: init, ok: ok, ok2: ok2, skip: skip, skip2: skip2};
	});
var $author$project$Create$Flags$flagsWorkflowsObjectProgressObjectDisplayDecoder = A8(
	$elm$json$Json$Decode$map7,
	$author$project$Create$Flags$FlagsWorkflowsObjectProgressObjectDisplay,
	A2($elm$json$Json$Decode$field, 'error', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'error2', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'init', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'ok', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'ok2', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'skip', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'skip2', $elm$json$Json$Decode$string));
var $author$project$Create$Flags$FlagsWorkflowsObjectProgressObjectMessages = F2(
	function (error, ok) {
		return {error: error, ok: ok};
	});
var $author$project$Create$Flags$flagsWorkflowsObjectProgressObjectMessagesDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Create$Flags$FlagsWorkflowsObjectProgressObjectMessages,
	A2($elm$json$Json$Decode$field, 'error', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'ok', $elm$json$Json$Decode$string));
var $author$project$Create$Flags$flagsWorkflowsObjectProgressObjectDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Create$Flags$FlagsWorkflowsObjectProgressObject,
	A2($elm$json$Json$Decode$field, 'display', $author$project$Create$Flags$flagsWorkflowsObjectProgressObjectDisplayDecoder),
	A2($elm$json$Json$Decode$field, 'messages', $author$project$Create$Flags$flagsWorkflowsObjectProgressObjectMessagesDecoder));
var $author$project$Create$Flags$flagsWorkflowsObjectDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Create$Flags$FlagsWorkflowsObject,
	A2($elm$json$Json$Decode$field, 'name', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2(
		$elm$json$Json$Decode$field,
		'progress',
		$elm$json$Json$Decode$list($author$project$Create$Flags$flagsWorkflowsObjectProgressObjectDecoder)));
var $author$project$Create$Flags$flagsDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Create$Flags$Flags,
	A2($elm$json$Json$Decode$field, 'config', $author$project$Create$Flags$flagsConfigDecoder),
	A2($elm$json$Json$Decode$field, 'extra', $author$project$Create$Flags$extraDecoder),
	A2(
		$elm$json$Json$Decode$field,
		'workflows',
		$elm$json$Json$Decode$list($author$project$Create$Flags$flagsWorkflowsObjectDecoder)));
var $author$project$Create$Flags$jsonToResultFlags = function (json) {
	return A2(
		$elm$core$Result$mapError,
		$elm$json$Json$Decode$errorToString,
		A2($elm$json$Json$Decode$decodeValue, $author$project$Create$Flags$flagsDecoder, json));
};
var $author$project$Create$Model$ProgressMsg = function (a) {
	return {$: 'ProgressMsg', a: a};
};
var $author$project$Create$progressCmds = function (pcmds) {
	return A2($elm$core$Platform$Cmd$map, $author$project$Create$Model$ProgressMsg, pcmds);
};
var $author$project$Create$progressFlags = function (flags) {
	return {labels: flags.extra.progressView.labels, workflows: flags.workflows};
};
var $author$project$Create$init = function (value) {
	var _v0 = $author$project$Create$Flags$jsonToResultFlags(value);
	if (_v0.$ === 'Err') {
		var err = _v0.a;
		return _Utils_Tuple2(
			$author$project$Create$Model$Failed(err),
			$elm$core$Platform$Cmd$none);
	} else {
		var flags = _v0.a;
		var _v1 = $author$project$Progress$Model$init(
			$author$project$Create$progressFlags(flags));
		var pstate = _v1.a;
		var pcmds = _v1.b;
		return _Utils_Tuple2(
			A2(
				$author$project$Create$Model$Loaded,
				flags,
				{
					appId: '',
					appIdOk: $elm$core$Result$Err(''),
					link: $krisajenkins$remotedata$RemoteData$NotAsked,
					profile: $elm$core$Maybe$Nothing,
					progress: pstate
				}),
			$author$project$Create$progressCmds(pcmds));
	}
};
var $author$project$Create$Model$Incoming = function (a) {
	return {$: 'Incoming', a: a};
};
var $author$project$Create$subscriptions = function (model) {
	return $author$project$Shared$Ports$toElm($author$project$Create$Model$Incoming);
};
var $author$project$Create$cmdCreate = F2(
	function (flags, state) {
		var newstate = _Utils_update(
			state,
			{link: $krisajenkins$remotedata$RemoteData$Loading});
		var cv = flags.extra.createView;
		var request = $elm$json$Json$Encode$object(
			_List_fromArray(
				[
					_Utils_Tuple2(
					'kind',
					$elm$json$Json$Encode$string(cv.requests.submit)),
					_Utils_Tuple2(
					'prefix',
					$elm$json$Json$Encode$string(cv.transitions.prefix)),
					_Utils_Tuple2(
					'appId',
					$elm$json$Json$Encode$string(state.appId))
				]));
		return _Utils_Tuple2(
			A2($author$project$Create$Model$Loaded, flags, newstate),
			$author$project$Shared$Ports$toMain(request));
	});
var $author$project$Create$cmdProceed = F2(
	function (flags, state) {
		var cv = flags.extra.createView;
		return A2(
			$author$project$Shared$Cmd$cmdTransition,
			cv.transitions.profile,
			A2($author$project$Create$Model$Loaded, flags, state));
	});
var $author$project$Create$updateStateCmds = F3(
	function (flags, state, cmds) {
		return _Utils_Tuple2(
			A2($author$project$Create$Model$Loaded, flags, state),
			cmds);
	});
var $author$project$Create$updateProgress = F3(
	function (flags, state, pmsg) {
		var _v0 = A3(
			$author$project$Progress$Model$update,
			$author$project$Create$progressFlags(flags),
			state.progress,
			pmsg);
		var pstate = _v0.a;
		var pcmds = _v0.b;
		return A3(
			$author$project$Create$updateStateCmds,
			flags,
			_Utils_update(
				state,
				{progress: pstate}),
			$author$project$Create$progressCmds(pcmds));
	});
var $TSFoster$elm_uuid$UUID$WrongFormat = {$: 'WrongFormat'};
var $TSFoster$elm_uuid$UUID$WrongLength = {$: 'WrongLength'};
var $TSFoster$elm_uuid$UUID$IsNil = {$: 'IsNil'};
var $TSFoster$elm_uuid$UUID$NoVersion = {$: 'NoVersion'};
var $TSFoster$elm_uuid$UUID$UUID = F4(
	function (a, b, c, d) {
		return {$: 'UUID', a: a, b: b, c: c, d: d};
	});
var $TSFoster$elm_uuid$UUID$UnsupportedVariant = {$: 'UnsupportedVariant'};
var $TSFoster$elm_uuid$UUID$isVariant1 = function (_v0) {
	var c = _v0.c;
	return (c >>> 30) === 2;
};
var $TSFoster$elm_uuid$UUID$version = function (_v0) {
	var b = _v0.b;
	return 15 & (b >>> 12);
};
var $TSFoster$elm_uuid$UUID$fromInt32s = F4(
	function (a, b, c, d) {
		var wouldBeUUID = A4($TSFoster$elm_uuid$UUID$UUID, a, b, c, d);
		return ((!a) && ((!b) && ((!c) && (!d)))) ? $elm$core$Result$Err($TSFoster$elm_uuid$UUID$IsNil) : (($TSFoster$elm_uuid$UUID$version(wouldBeUUID) > 5) ? $elm$core$Result$Err($TSFoster$elm_uuid$UUID$NoVersion) : ((!$TSFoster$elm_uuid$UUID$isVariant1(wouldBeUUID)) ? $elm$core$Result$Err($TSFoster$elm_uuid$UUID$UnsupportedVariant) : $elm$core$Result$Ok(wouldBeUUID)));
	});
var $TSFoster$elm_uuid$UUID$forceUnsigned = $elm$core$Bitwise$shiftRightZfBy(0);
var $elm$core$Bitwise$or = _Bitwise_or;
var $TSFoster$elm_uuid$UUID$nibbleValuesToU32 = F8(
	function (a, b, c, d, e, f, g, h) {
		return $TSFoster$elm_uuid$UUID$forceUnsigned((a << 28) | ((b << 24) | ((c << 20) | ((d << 16) | ((e << 12) | ((f << 8) | ((g << 4) | h)))))));
	});
var $TSFoster$elm_uuid$UUID$toNibbleValue = function (_char) {
	switch (_char.valueOf()) {
		case '0':
			return $elm$core$Maybe$Just(0);
		case '1':
			return $elm$core$Maybe$Just(1);
		case '2':
			return $elm$core$Maybe$Just(2);
		case '3':
			return $elm$core$Maybe$Just(3);
		case '4':
			return $elm$core$Maybe$Just(4);
		case '5':
			return $elm$core$Maybe$Just(5);
		case '6':
			return $elm$core$Maybe$Just(6);
		case '7':
			return $elm$core$Maybe$Just(7);
		case '8':
			return $elm$core$Maybe$Just(8);
		case '9':
			return $elm$core$Maybe$Just(9);
		case 'a':
			return $elm$core$Maybe$Just(10);
		case 'b':
			return $elm$core$Maybe$Just(11);
		case 'c':
			return $elm$core$Maybe$Just(12);
		case 'd':
			return $elm$core$Maybe$Just(13);
		case 'e':
			return $elm$core$Maybe$Just(14);
		case 'f':
			return $elm$core$Maybe$Just(15);
		default:
			return $elm$core$Maybe$Nothing;
	}
};
var $TSFoster$elm_uuid$UUID$fromString = function (string) {
	var normalized = function (str) {
		return A2($elm$core$String$startsWith, 'urn:uuid:', str) ? A2($elm$core$String$dropLeft, 9, str) : ((A2($elm$core$String$startsWith, '{', str) && A2($elm$core$String$endsWith, '}', str)) ? A3($elm$core$String$slice, 1, -1, str) : str);
	}(
		$elm$core$String$toLower(
			A3(
				$elm$core$String$replace,
				'-',
				'',
				A3(
					$elm$core$String$replace,
					' ',
					'',
					A3(
						$elm$core$String$replace,
						'\t',
						'',
						A3($elm$core$String$replace, '\n', '', string))))));
	if ($elm$core$String$length(normalized) !== 32) {
		return $elm$core$Result$Err($TSFoster$elm_uuid$UUID$WrongLength);
	} else {
		var _v0 = A2(
			$elm$core$List$filterMap,
			$TSFoster$elm_uuid$UUID$toNibbleValue,
			$elm$core$String$toList(normalized));
		if ((((((((((((((((((((((((((((((((_v0.b && _v0.b.b) && _v0.b.b.b) && _v0.b.b.b.b) && _v0.b.b.b.b.b) && _v0.b.b.b.b.b.b) && _v0.b.b.b.b.b.b.b) && _v0.b.b.b.b.b.b.b.b) && _v0.b.b.b.b.b.b.b.b.b) && _v0.b.b.b.b.b.b.b.b.b.b) && _v0.b.b.b.b.b.b.b.b.b.b.b) && _v0.b.b.b.b.b.b.b.b.b.b.b.b) && _v0.b.b.b.b.b.b.b.b.b.b.b.b.b) && _v0.b.b.b.b.b.b.b.b.b.b.b.b.b.b) && _v0.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b) && _v0.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b) && _v0.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b) && _v0.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b) && _v0.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b) && _v0.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b) && _v0.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b) && _v0.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b) && _v0.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b) && _v0.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b) && _v0.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b) && _v0.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b) && _v0.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b) && _v0.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b) && _v0.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b) && _v0.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b) && _v0.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b) && _v0.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b) && (!_v0.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b.b)) {
			var a1 = _v0.a;
			var _v1 = _v0.b;
			var a2 = _v1.a;
			var _v2 = _v1.b;
			var a3 = _v2.a;
			var _v3 = _v2.b;
			var a4 = _v3.a;
			var _v4 = _v3.b;
			var a5 = _v4.a;
			var _v5 = _v4.b;
			var a6 = _v5.a;
			var _v6 = _v5.b;
			var a7 = _v6.a;
			var _v7 = _v6.b;
			var a8 = _v7.a;
			var _v8 = _v7.b;
			var b1 = _v8.a;
			var _v9 = _v8.b;
			var b2 = _v9.a;
			var _v10 = _v9.b;
			var b3 = _v10.a;
			var _v11 = _v10.b;
			var b4 = _v11.a;
			var _v12 = _v11.b;
			var b5 = _v12.a;
			var _v13 = _v12.b;
			var b6 = _v13.a;
			var _v14 = _v13.b;
			var b7 = _v14.a;
			var _v15 = _v14.b;
			var b8 = _v15.a;
			var _v16 = _v15.b;
			var c1 = _v16.a;
			var _v17 = _v16.b;
			var c2 = _v17.a;
			var _v18 = _v17.b;
			var c3 = _v18.a;
			var _v19 = _v18.b;
			var c4 = _v19.a;
			var _v20 = _v19.b;
			var c5 = _v20.a;
			var _v21 = _v20.b;
			var c6 = _v21.a;
			var _v22 = _v21.b;
			var c7 = _v22.a;
			var _v23 = _v22.b;
			var c8 = _v23.a;
			var _v24 = _v23.b;
			var d1 = _v24.a;
			var _v25 = _v24.b;
			var d2 = _v25.a;
			var _v26 = _v25.b;
			var d3 = _v26.a;
			var _v27 = _v26.b;
			var d4 = _v27.a;
			var _v28 = _v27.b;
			var d5 = _v28.a;
			var _v29 = _v28.b;
			var d6 = _v29.a;
			var _v30 = _v29.b;
			var d7 = _v30.a;
			var _v31 = _v30.b;
			var d8 = _v31.a;
			return A4(
				$TSFoster$elm_uuid$UUID$fromInt32s,
				A8($TSFoster$elm_uuid$UUID$nibbleValuesToU32, a1, a2, a3, a4, a5, a6, a7, a8),
				A8($TSFoster$elm_uuid$UUID$nibbleValuesToU32, b1, b2, b3, b4, b5, b6, b7, b8),
				A8($TSFoster$elm_uuid$UUID$nibbleValuesToU32, c1, c2, c3, c4, c5, c6, c7, c8),
				A8($TSFoster$elm_uuid$UUID$nibbleValuesToU32, d1, d2, d3, d4, d5, d6, d7, d8));
		} else {
			return $elm$core$Result$Err($TSFoster$elm_uuid$UUID$WrongFormat);
		}
	}
};
var $author$project$Create$Validate$validateAppId = F2(
	function (flags, appid) {
		var _v0 = $TSFoster$elm_uuid$UUID$fromString(appid);
		if (_v0.$ === 'Err') {
			switch (_v0.a.$) {
				case 'WrongFormat':
					var _v1 = _v0.a;
					return $elm$core$Result$Err(flags.extra.createView.labels.appid.wrongformat);
				case 'WrongLength':
					var _v2 = _v0.a;
					return $elm$core$Result$Err(flags.extra.createView.labels.appid.wronglength);
				case 'UnsupportedVariant':
					var _v3 = _v0.a;
					return $elm$core$Result$Err(flags.extra.createView.labels.appid.unsupportedvariant);
				case 'IsNil':
					var _v4 = _v0.a;
					return $elm$core$Result$Err(flags.extra.createView.labels.appid.isnil);
				default:
					var _v5 = _v0.a;
					return $elm$core$Result$Err(flags.extra.createView.labels.appid.noversion);
			}
		} else {
			return $elm$core$Result$Ok(appid);
		}
	});
var $author$project$Create$Model$validateState = F2(
	function (flags, state) {
		return _Utils_update(
			state,
			{
				appIdOk: A2($author$project$Create$Validate$validateAppId, flags, state.appId)
			});
	});
var $author$project$Create$updateState = F2(
	function (flags, state) {
		return A3(
			$author$project$Create$updateStateCmds,
			flags,
			A2($author$project$Create$Model$validateState, flags, state),
			$elm$core$Platform$Cmd$none);
	});
var $author$project$Create$Decode$CreateFailed = function (a) {
	return {$: 'CreateFailed', a: a};
};
var $author$project$Create$Decode$CreateLoggedIn = function (a) {
	return {$: 'CreateLoggedIn', a: a};
};
var $author$project$Create$Decode$CreateStarting = function (a) {
	return {$: 'CreateStarting', a: a};
};
var $author$project$Create$Decode$CreateSucceeded = function (a) {
	return {$: 'CreateSucceeded', a: a};
};
var $author$project$Create$Decode$IncomingProfileData = function (a) {
	return {$: 'IncomingProfileData', a: a};
};
var $author$project$Create$Decode$Progress = function (a) {
	return {$: 'Progress', a: a};
};
var $author$project$Create$Decode$SetState = F2(
	function (a, b) {
		return {$: 'SetState', a: a, b: b};
	});
var $author$project$Create$Decode$incomingMsgDecoderByMsg = function (msg) {
	switch (msg) {
		case 'profile info':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Create$Decode$IncomingProfileData,
				A2($elm$json$Json$Decode$field, 'profile', $author$project$ProfileData$Decode$profileDataDecoder));
		case 'create loggedin':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Create$Decode$CreateLoggedIn,
				A2($elm$json$Json$Decode$field, 'link', $elm$json$Json$Decode$string));
		case 'error':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Create$Decode$CreateFailed,
				$elm$json$Json$Decode$maybe(
					A2($elm$json$Json$Decode$field, 'details', $elm$json$Json$Decode$string)));
		case 'create starting':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Create$Decode$CreateStarting,
				A2($elm$json$Json$Decode$field, 'appId', $elm$json$Json$Decode$string));
		case 'create succeeded':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Create$Decode$CreateSucceeded,
				A2($elm$json$Json$Decode$field, 'link', $elm$json$Json$Decode$string));
		case 'set state':
			return A3(
				$elm$json$Json$Decode$map2,
				$author$project$Create$Decode$SetState,
				A2($elm$json$Json$Decode$field, 'appId', $elm$json$Json$Decode$string),
				A2($elm$json$Json$Decode$field, 'error', $elm$json$Json$Decode$string));
		case 'progress':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Create$Decode$Progress,
				A2($elm$json$Json$Decode$field, 'progress', $elm$json$Json$Decode$value));
		default:
			var other = msg;
			return $elm$json$Json$Decode$fail(other);
	}
};
var $author$project$Create$Decode$incomingMsgDecoder = A2(
	$elm$json$Json$Decode$andThen,
	$author$project$Create$Decode$incomingMsgDecoderByMsg,
	A2($elm$json$Json$Decode$field, 'msg', $elm$json$Json$Decode$string));
var $author$project$Create$Decode$valueToIncomingMsg = function (value) {
	return A2(
		$elm$core$Result$mapError,
		$elm$json$Json$Decode$errorToString,
		A2($elm$json$Json$Decode$decodeValue, $author$project$Create$Decode$incomingMsgDecoder, value));
};
var $author$project$Create$update = F2(
	function (msg, model) {
		var _v0 = _Utils_Tuple2(model, msg);
		if (_v0.a.$ === 'Failed') {
			return _Utils_Tuple2(model, $elm$core$Platform$Cmd$none);
		} else {
			switch (_v0.b.$) {
				case 'UpdateAppID':
					var _v1 = _v0.a;
					var flags = _v1.a;
					var state = _v1.b;
					var appId = _v0.b.a;
					return A2(
						$author$project$Create$updateState,
						flags,
						_Utils_update(
							state,
							{appId: appId, link: $krisajenkins$remotedata$RemoteData$NotAsked}));
				case 'PressCreateEngagement':
					var _v2 = _v0.a;
					var flags = _v2.a;
					var state = _v2.b;
					var _v3 = _v0.b;
					return A2($author$project$Create$cmdCreate, flags, state);
				case 'PressProceed':
					var _v4 = _v0.a;
					var flags = _v4.a;
					var state = _v4.b;
					var _v5 = _v0.b;
					return A2($author$project$Create$cmdProceed, flags, state);
				case 'ProgressMsg':
					var _v6 = _v0.a;
					var flags = _v6.a;
					var state = _v6.b;
					var pmsg = _v0.b.a;
					return A3($author$project$Create$updateProgress, flags, state, pmsg);
				default:
					var _v7 = _v0.a;
					var flags = _v7.a;
					var state = _v7.b;
					var v = _v0.b.a;
					var _v8 = $author$project$Create$Decode$valueToIncomingMsg(v);
					if (_v8.$ === 'Err') {
						var err = _v8.a;
						return $author$project$Shared$Reg$decodeErr(err) ? A3(
							$author$project$Create$updateProgress,
							flags,
							state,
							$author$project$Progress$Model$DecodeErr(err)) : A2($author$project$Shared$Cmd$cmdLog, 'Err ' + err, model);
					} else {
						switch (_v8.a.$) {
							case 'IncomingProfileData':
								var profile = _v8.a.a;
								return A2(
									$author$project$Create$updateState,
									flags,
									_Utils_update(
										state,
										{
											profile: $elm$core$Maybe$Just(profile)
										}));
							case 'CreateLoggedIn':
								var link = _v8.a.a;
								return A2(
									$author$project$Create$updateState,
									flags,
									_Utils_update(
										state,
										{
											link: $krisajenkins$remotedata$RemoteData$Success(link)
										}));
							case 'CreateStarting':
								var appId = _v8.a.a;
								return A2(
									$author$project$Create$updateState,
									flags,
									_Utils_update(
										state,
										{appId: appId}));
							case 'CreateFailed':
								if (_v8.a.a.$ === 'Nothing') {
									var _v9 = _v8.a.a;
									return A2(
										$author$project$Create$updateState,
										flags,
										_Utils_update(
											state,
											{
												link: $krisajenkins$remotedata$RemoteData$Failure(flags.extra.createView.labels.appid.createFailed)
											}));
								} else {
									var err = _v8.a.a.a;
									return A2(
										$author$project$Create$updateState,
										flags,
										_Utils_update(
											state,
											{
												link: $krisajenkins$remotedata$RemoteData$Failure(err)
											}));
								}
							case 'CreateSucceeded':
								var link = _v8.a.a;
								return A2(
									$author$project$Create$updateState,
									flags,
									_Utils_update(
										state,
										{
											link: $krisajenkins$remotedata$RemoteData$Success(link)
										}));
							case 'SetState':
								var _v10 = _v8.a;
								var appId = _v10.a;
								var err = _v10.b;
								return A2(
									$author$project$Create$updateState,
									flags,
									_Utils_update(
										state,
										{
											appId: appId,
											link: $krisajenkins$remotedata$RemoteData$Failure(err)
										}));
							default:
								var value = _v8.a.a;
								return A3(
									$author$project$Create$updateProgress,
									flags,
									state,
									$author$project$Progress$Model$Incoming(value));
						}
					}
			}
		}
	});
var $author$project$Create$currentView = 0;
var $author$project$Create$Model$PressCreateEngagement = {$: 'PressCreateEngagement'};
var $author$project$Create$Model$UpdateAppID = function (a) {
	return {$: 'UpdateAppID', a: a};
};
var $author$project$Create$Validate$appidplaceholder = 'XXXXXXXX-XXXX-XXXX-XXXX-XXXXXXXXXXXX';
var $author$project$Create$View$viewError = F2(
	function (flags, state) {
		var _v0 = _Utils_Tuple2(
			state.appId === '',
			A2($author$project$Create$Validate$validateAppId, flags, state.appId));
		if (_v0.a) {
			return A2(
				$elm$html$Html$label,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('help is-danger')
					]),
				_List_fromArray(
					[
						$elm$html$Html$text(flags.extra.createView.labels.appid.required)
					]));
		} else {
			if (_v0.b.$ === 'Err') {
				var msg = _v0.b.a;
				return A2(
					$elm$html$Html$label,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('help is-danger')
						]),
					_List_fromArray(
						[
							$elm$html$Html$text(msg)
						]));
			} else {
				var maybeRequestError = function () {
					var _v2 = state.link;
					if (_v2.$ === 'Failure') {
						var err = _v2.a;
						return $elm$core$Maybe$Just(err);
					} else {
						return $elm$core$Maybe$Nothing;
					}
				}();
				if (maybeRequestError.$ === 'Just') {
					var msg = maybeRequestError.a;
					return A2(
						$elm$html$Html$label,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('help is-danger')
							]),
						_List_fromArray(
							[
								$elm$html$Html$text(msg)
							]));
				} else {
					return A2($elm$html$Html$div, _List_Nil, _List_Nil);
				}
			}
		}
	});
var $author$project$Create$View$viewAppId = F2(
	function (flags, state) {
		var _v0 = state.link;
		if (_v0.$ === 'Success') {
			var link = _v0.a;
			return A2($elm$html$Html$div, _List_Nil, _List_Nil);
		} else {
			return A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('field is-horizontal')
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$div,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('field-label is-normal')
							]),
						_List_fromArray(
							[
								A2(
								$elm$html$Html$label,
								_List_fromArray(
									[
										$elm$html$Html$Attributes$class('label ml-1')
									]),
								_List_fromArray(
									[
										$elm$html$Html$text(flags.extra.createView.labels.appid.appid)
									]))
							])),
						A2(
						$elm$html$Html$div,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('field-body')
							]),
						_List_fromArray(
							[
								A2(
								$elm$html$Html$div,
								_List_fromArray(
									[
										$elm$html$Html$Attributes$class('field')
									]),
								_List_fromArray(
									[
										A2(
										$elm$html$Html$div,
										_List_fromArray(
											[
												$elm$html$Html$Attributes$class('control')
											]),
										_List_fromArray(
											[
												A2(
												$elm$html$Html$input,
												_List_fromArray(
													[
														$elm$html$Html$Attributes$class('input'),
														$elm$html$Html$Attributes$type_('text'),
														$elm$html$Html$Attributes$placeholder($author$project$Create$Validate$appidplaceholder),
														$elm$html$Html$Attributes$value(state.appId),
														$elm$html$Html$Events$onInput($author$project$Create$Model$UpdateAppID),
														$author$project$Shared$OnEnter$onEnter($author$project$Create$Model$PressCreateEngagement)
													]),
												_List_Nil)
											])),
										A2($author$project$Create$View$viewError, flags, state)
									])),
								A2(
								$elm$html$Html$div,
								_List_fromArray(
									[
										$elm$html$Html$Attributes$class('field-label is-normal'),
										A2($elm$html$Html$Attributes$style, 'max-width', '5px')
									]),
								_List_fromArray(
									[
										A2(
										$elm$html$Html$label,
										_List_fromArray(
											[
												$elm$html$Html$Attributes$class('label')
											]),
										_List_Nil)
									]))
							]))
					]));
		}
	});
var $author$project$Create$View$okToSubmit = function (state) {
	var _v0 = _Utils_Tuple2(state.appIdOk, state.link);
	_v0$2:
	while (true) {
		if (_v0.a.$ === 'Ok') {
			switch (_v0.b.$) {
				case 'NotAsked':
					var _v1 = _v0.b;
					return true;
				case 'Success':
					return false;
				default:
					break _v0$2;
			}
		} else {
			break _v0$2;
		}
	}
	return false;
};
var $author$project$Create$View$viewButton = F2(
	function (flags, state) {
		var _v0 = state.link;
		if (_v0.$ === 'Success') {
			var link = _v0.a;
			return A2($elm$html$Html$div, _List_Nil, _List_Nil);
		} else {
			var loading = function (cls) {
				var _v1 = state.link;
				if (_v1.$ === 'Loading') {
					return cls + ' is-loading';
				} else {
					return cls;
				}
			};
			var enabled = $author$project$Create$View$okToSubmit(state);
			return A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('field is-horizontal')
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$div,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('field-label')
							]),
						_List_Nil),
						A2(
						$elm$html$Html$div,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('field-body')
							]),
						_List_fromArray(
							[
								A2(
								$elm$html$Html$div,
								_List_fromArray(
									[
										$elm$html$Html$Attributes$class('field')
									]),
								_List_fromArray(
									[
										A2(
										$elm$html$Html$div,
										_List_fromArray(
											[
												$elm$html$Html$Attributes$class('control')
											]),
										_List_fromArray(
											[
												A2(
												$elm$html$Html$button,
												_List_fromArray(
													[
														$elm$html$Html$Attributes$class(
														loading('button has-background-primary-dark has-text-white is-link')),
														$elm$html$Html$Attributes$disabled(!enabled),
														$elm$html$Html$Events$onClick($author$project$Create$Model$PressCreateEngagement)
													]),
												_List_fromArray(
													[
														$elm$html$Html$text(flags.extra.createView.labels.create.label)
													]))
											]))
									]))
							]))
					]));
		}
	});
var $author$project$Create$View$viewLink = F2(
	function (flags, state) {
		var _v0 = state.link;
		if (_v0.$ === 'Success') {
			var link = _v0.a;
			var keepsafe = $author$project$Shared$Text$htmlTextDivs(
				A2($elm$core$String$split, '\n', flags.extra.createView.labels.hostLink.keepsafe));
			return A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('field is-horizontal mt-3')
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$div,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('field-label is-normal')
							]),
						_List_fromArray(
							[
								A2(
								$elm$html$Html$label,
								_List_fromArray(
									[
										$elm$html$Html$Attributes$class('label ml-1')
									]),
								_List_fromArray(
									[
										$elm$html$Html$text(flags.extra.createView.labels.hostLink.label)
									]))
							])),
						A2(
						$elm$html$Html$div,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('field-body')
							]),
						_List_fromArray(
							[
								A2(
								$elm$html$Html$div,
								_List_fromArray(
									[
										$elm$html$Html$Attributes$class('field mt-1')
									]),
								_List_fromArray(
									[
										A3(
										$elm$html$Html$node,
										'clipboard-copy',
										_List_fromArray(
											[
												A2($elm$html$Html$Attributes$attribute, 'for', 'hostlink'),
												$elm$html$Html$Attributes$class('tag has-background-primary-dark has-text-white'),
												A2($elm$html$Html$Attributes$attribute, 'text-copied', flags.extra.createView.labels.hostLink.copied),
												A2($elm$html$Html$Attributes$attribute, 'class-copied', 'tag is-white'),
												A2($elm$html$Html$Attributes$style, 'height', '20px'),
												A2($elm$html$Html$Attributes$style, 'user-select', 'none')
											]),
										_List_fromArray(
											[
												$elm$html$Html$text(flags.extra.createView.labels.hostLink.copy)
											])),
										A2(
										$elm$html$Html$span,
										_List_fromArray(
											[
												A2($elm$html$Html$Attributes$style, 'user-select', 'none')
											]),
										_List_fromArray(
											[
												$elm$html$Html$text($author$project$Shared$Text$nbsp)
											])),
										A2(
										$elm$html$Html$span,
										_List_fromArray(
											[
												$elm$html$Html$Attributes$id('hostlink'),
												$elm$html$Html$Attributes$class('is-size-7 mt-3'),
												A2($elm$html$Html$Attributes$style, 'word-break', 'break-all')
											]),
										_List_fromArray(
											[
												$elm$html$Html$text(link)
											])),
										A2(
										$elm$html$Html$p,
										_List_fromArray(
											[
												$elm$html$Html$Attributes$class('has-text-danger mt-2')
											]),
										keepsafe),
										A2(
										$elm$html$Html$p,
										_List_fromArray(
											[
												$elm$html$Html$Attributes$class('has-text-danger has-text-weight-bold')
											]),
										_List_fromArray(
											[
												$elm$html$Html$text(flags.extra.createView.labels.hostLink.norecovery)
											]))
									])),
								A2(
								$elm$html$Html$div,
								_List_fromArray(
									[
										$elm$html$Html$Attributes$class('field-label is-normal'),
										A2($elm$html$Html$Attributes$style, 'max-width', '5px')
									]),
								_List_fromArray(
									[
										A2(
										$elm$html$Html$label,
										_List_fromArray(
											[
												$elm$html$Html$Attributes$class('label')
											]),
										_List_Nil)
									]))
							]))
					]));
		} else {
			return A2($elm$html$Html$div, _List_Nil, _List_Nil);
		}
	});
var $author$project$Create$Model$PressProceed = {$: 'PressProceed'};
var $author$project$Create$View$viewProceed = F2(
	function (flags, state) {
		var _v0 = _Utils_Tuple2(state.profile, state.link);
		if ((_v0.a.$ === 'Nothing') && (_v0.b.$ === 'Success')) {
			var _v1 = _v0.a;
			var link = _v0.b.a;
			return A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('field is-horizontal mt-3')
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$div,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('field-label')
							]),
						_List_Nil),
						A2(
						$elm$html$Html$div,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('field-body')
							]),
						_List_fromArray(
							[
								A2(
								$elm$html$Html$div,
								_List_fromArray(
									[
										$elm$html$Html$Attributes$class('field')
									]),
								_List_fromArray(
									[
										A2(
										$elm$html$Html$div,
										_List_fromArray(
											[
												$elm$html$Html$Attributes$class('control')
											]),
										_List_fromArray(
											[
												A2(
												$elm$html$Html$button,
												_List_fromArray(
													[
														$elm$html$Html$Attributes$class('button has-background-primary-dark has-text-white is-link'),
														$elm$html$Html$Events$onClick($author$project$Create$Model$PressProceed)
													]),
												_List_fromArray(
													[
														$elm$html$Html$text(flags.extra.createView.labels.proceed.label)
													]))
											]))
									]))
							]))
					]));
		} else {
			return A2($elm$html$Html$div, _List_Nil, _List_Nil);
		}
	});
var $author$project$Create$View$view = F2(
	function (flags, state) {
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('sp-form ml-5 mr-3')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$br,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('is-hidden-mobile')
						]),
					_List_Nil),
					A2($author$project$Create$View$viewAppId, flags, state),
					A2($author$project$Create$View$viewButton, flags, state),
					A2($author$project$Create$View$viewLink, flags, state),
					A2($author$project$Create$View$viewProceed, flags, state),
					A2(
					$elm$html$Html$br,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('is-hidden-mobile')
						]),
					_List_Nil)
				]));
	});
var $author$project$Create$view = function (model) {
	var _v0 = _Utils_Tuple2($author$project$Create$currentView, model);
	_v0$3:
	while (true) {
		if (_v0.b.$ === 'Failed') {
			if (!_v0.a) {
				var err = _v0.b.a;
				return A2(
					$elm$html$Html$p,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('notification is-danger')
						]),
					_List_fromArray(
						[
							$elm$html$Html$text(err)
						]));
			} else {
				break _v0$3;
			}
		} else {
			switch (_v0.a) {
				case 0:
					var _v1 = _v0.b;
					var flags = _v1.a;
					var state = _v1.b;
					return A2($author$project$Create$View$view, flags, state);
				case 1:
					var _v2 = _v0.b;
					var flags = _v2.a;
					var state = _v2.b;
					return A2(
						$elm$html$Html$map,
						$author$project$Create$Model$ProgressMsg,
						A2(
							$author$project$Progress$View$view,
							$author$project$Create$progressFlags(flags),
							state.progress));
				default:
					break _v0$3;
			}
		}
	}
	return A2($elm$html$Html$div, _List_Nil, _List_Nil);
};
var $author$project$Create$main = $elm$browser$Browser$element(
	{init: $author$project$Create$init, subscriptions: $author$project$Create$subscriptions, update: $author$project$Create$update, view: $author$project$Create$view});
var $author$project$BundleList$Model$Failed = function (a) {
	return {$: 'Failed', a: a};
};
var $author$project$BundleList$Model$Loaded = F2(
	function (a, b) {
		return {$: 'Loaded', a: a, b: b};
	});
var $author$project$BundleList$Flags$Flags = F3(
	function (config, extra, workflows) {
		return {config: config, extra: extra, workflows: workflows};
	});
var $author$project$BundleList$Flags$Extra = F7(
	function (bundlelistView, mode, module_, plurals, progressView, viewNodes, workflowpaths) {
		return {bundlelistView: bundlelistView, mode: mode, module_: module_, plurals: plurals, progressView: progressView, viewNodes: viewNodes, workflowpaths: workflowpaths};
	});
var $author$project$BundleList$Flags$ExtraBundlelistView = F3(
	function (labels, requests, transitions) {
		return {labels: labels, requests: requests, transitions: transitions};
	});
var $author$project$BundleList$Flags$ExtraBundlelistViewLabels = function (addBundle) {
	return function (description) {
		return function (details) {
			return function (lastVisit) {
				return function (pctVisited) {
					return function (restricted) {
						return function (searchBundles) {
							return function (shared) {
								return function (showExample) {
									return function (unrestricted) {
										return {addBundle: addBundle, description: description, details: details, lastVisit: lastVisit, pctVisited: pctVisited, restricted: restricted, searchBundles: searchBundles, shared: shared, showExample: showExample, unrestricted: unrestricted};
									};
								};
							};
						};
					};
				};
			};
		};
	};
};
var $author$project$BundleList$Flags$ExtraBundlelistViewLabelsAddBundle = function (label) {
	return {label: label};
};
var $author$project$BundleList$Flags$extraBundlelistViewLabelsAddBundleDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$BundleList$Flags$ExtraBundlelistViewLabelsAddBundle,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$BundleList$Flags$ExtraBundlelistViewLabelsDescription = function (label) {
	return {label: label};
};
var $author$project$BundleList$Flags$extraBundlelistViewLabelsDescriptionDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$BundleList$Flags$ExtraBundlelistViewLabelsDescription,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$BundleList$Flags$ExtraBundlelistViewLabelsDetails = function (label) {
	return {label: label};
};
var $author$project$BundleList$Flags$extraBundlelistViewLabelsDetailsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$BundleList$Flags$ExtraBundlelistViewLabelsDetails,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$BundleList$Flags$ExtraBundlelistViewLabelsLastVisit = function (label) {
	return {label: label};
};
var $author$project$BundleList$Flags$extraBundlelistViewLabelsLastVisitDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$BundleList$Flags$ExtraBundlelistViewLabelsLastVisit,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$BundleList$Flags$ExtraBundlelistViewLabelsPctVisited = function (label) {
	return {label: label};
};
var $author$project$BundleList$Flags$extraBundlelistViewLabelsPctVisitedDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$BundleList$Flags$ExtraBundlelistViewLabelsPctVisited,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$BundleList$Flags$ExtraBundlelistViewLabelsRestricted = function (label) {
	return {label: label};
};
var $author$project$BundleList$Flags$extraBundlelistViewLabelsRestrictedDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$BundleList$Flags$ExtraBundlelistViewLabelsRestricted,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$BundleList$Flags$ExtraBundlelistViewLabelsSearchBundles = function (placeholder) {
	return {placeholder: placeholder};
};
var $author$project$BundleList$Flags$extraBundlelistViewLabelsSearchBundlesDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$BundleList$Flags$ExtraBundlelistViewLabelsSearchBundles,
	A2($elm$json$Json$Decode$field, 'placeholder', $elm$json$Json$Decode$string));
var $author$project$BundleList$Flags$ExtraBundlelistViewLabelsShared = F2(
	function (label, width) {
		return {label: label, width: width};
	});
var $author$project$BundleList$Flags$extraBundlelistViewLabelsSharedDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$BundleList$Flags$ExtraBundlelistViewLabelsShared,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$BundleList$Flags$ExtraBundlelistViewLabelsShowExample = function (label) {
	return {label: label};
};
var $author$project$BundleList$Flags$extraBundlelistViewLabelsShowExampleDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$BundleList$Flags$ExtraBundlelistViewLabelsShowExample,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$BundleList$Flags$ExtraBundlelistViewLabelsUnrestricted = function (label) {
	return {label: label};
};
var $author$project$BundleList$Flags$extraBundlelistViewLabelsUnrestrictedDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$BundleList$Flags$ExtraBundlelistViewLabelsUnrestricted,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$BundleList$Flags$extraBundlelistViewLabelsDecoder = function () {
	var fieldSet0 = A9(
		$elm$json$Json$Decode$map8,
		$author$project$BundleList$Flags$ExtraBundlelistViewLabels,
		A2($elm$json$Json$Decode$field, 'add_bundle', $author$project$BundleList$Flags$extraBundlelistViewLabelsAddBundleDecoder),
		A2($elm$json$Json$Decode$field, 'description', $author$project$BundleList$Flags$extraBundlelistViewLabelsDescriptionDecoder),
		A2($elm$json$Json$Decode$field, 'details', $author$project$BundleList$Flags$extraBundlelistViewLabelsDetailsDecoder),
		A2($elm$json$Json$Decode$field, 'last_visit', $author$project$BundleList$Flags$extraBundlelistViewLabelsLastVisitDecoder),
		A2($elm$json$Json$Decode$field, 'pct_visited', $author$project$BundleList$Flags$extraBundlelistViewLabelsPctVisitedDecoder),
		A2($elm$json$Json$Decode$field, 'restricted', $author$project$BundleList$Flags$extraBundlelistViewLabelsRestrictedDecoder),
		A2($elm$json$Json$Decode$field, 'search_bundles', $author$project$BundleList$Flags$extraBundlelistViewLabelsSearchBundlesDecoder),
		A2($elm$json$Json$Decode$field, 'shared', $author$project$BundleList$Flags$extraBundlelistViewLabelsSharedDecoder));
	return A4(
		$elm$json$Json$Decode$map3,
		$elm$core$Basics$apL,
		fieldSet0,
		A2($elm$json$Json$Decode$field, 'show_example', $author$project$BundleList$Flags$extraBundlelistViewLabelsShowExampleDecoder),
		A2($elm$json$Json$Decode$field, 'unrestricted', $author$project$BundleList$Flags$extraBundlelistViewLabelsUnrestrictedDecoder));
}();
var $author$project$BundleList$Flags$ExtraBundlelistViewRequests = function (submit) {
	return {submit: submit};
};
var $author$project$BundleList$Flags$extraBundlelistViewRequestsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$BundleList$Flags$ExtraBundlelistViewRequests,
	A2($elm$json$Json$Decode$field, 'submit', $elm$json$Json$Decode$string));
var $author$project$BundleList$Flags$ExtraBundlelistViewTransitions = F2(
	function (add, details) {
		return {add: add, details: details};
	});
var $author$project$BundleList$Flags$extraBundlelistViewTransitionsDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$BundleList$Flags$ExtraBundlelistViewTransitions,
	A2($elm$json$Json$Decode$field, 'add', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'details', $elm$json$Json$Decode$string));
var $author$project$BundleList$Flags$extraBundlelistViewDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$BundleList$Flags$ExtraBundlelistView,
	A2($elm$json$Json$Decode$field, 'labels', $author$project$BundleList$Flags$extraBundlelistViewLabelsDecoder),
	A2($elm$json$Json$Decode$field, 'requests', $author$project$BundleList$Flags$extraBundlelistViewRequestsDecoder),
	A2($elm$json$Json$Decode$field, 'transitions', $author$project$BundleList$Flags$extraBundlelistViewTransitionsDecoder));
var $author$project$BundleList$Flags$ExtraPlurals = function (comments) {
	return function (files) {
		return function (folders) {
			return function (noComments) {
				return function (noFiles) {
					return function (noFolders) {
						return function (noUnread) {
							return function (oneComment) {
								return function (oneFile) {
									return function (oneFolder) {
										return function (oneUnread) {
											return function (unread) {
												return {comments: comments, files: files, folders: folders, noComments: noComments, noFiles: noFiles, noFolders: noFolders, noUnread: noUnread, oneComment: oneComment, oneFile: oneFile, oneFolder: oneFolder, oneUnread: oneUnread, unread: unread};
											};
										};
									};
								};
							};
						};
					};
				};
			};
		};
	};
};
var $author$project$BundleList$Flags$extraPluralsDecoder = function () {
	var fieldSet0 = A9(
		$elm$json$Json$Decode$map8,
		$author$project$BundleList$Flags$ExtraPlurals,
		A2($elm$json$Json$Decode$field, 'comments', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'files', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'folders', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'no_comments', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'no_files', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'no_folders', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'no_unread', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'one_comment', $elm$json$Json$Decode$string));
	return A6(
		$elm$json$Json$Decode$map5,
		$elm$core$Basics$apL,
		fieldSet0,
		A2($elm$json$Json$Decode$field, 'one_file', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'one_folder', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'one_unread', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'unread', $elm$json$Json$Decode$string));
}();
var $author$project$BundleList$Flags$ExtraProgressView = function (labels) {
	return {labels: labels};
};
var $author$project$BundleList$Flags$ExtraProgressViewLabels = F4(
	function (decodeErrors, diagnosticLogs, status, workflow) {
		return {decodeErrors: decodeErrors, diagnosticLogs: diagnosticLogs, status: status, workflow: workflow};
	});
var $author$project$BundleList$Flags$ExtraProgressViewLabelsDecodeErrors = function (label) {
	return {label: label};
};
var $author$project$BundleList$Flags$extraProgressViewLabelsDecodeErrorsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$BundleList$Flags$ExtraProgressViewLabelsDecodeErrors,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$BundleList$Flags$ExtraProgressViewLabelsDiagnosticLogs = function (label) {
	return {label: label};
};
var $author$project$BundleList$Flags$extraProgressViewLabelsDiagnosticLogsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$BundleList$Flags$ExtraProgressViewLabelsDiagnosticLogs,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$BundleList$Flags$ExtraProgressViewLabelsStatus = F2(
	function (failure, success) {
		return {failure: failure, success: success};
	});
var $author$project$BundleList$Flags$extraProgressViewLabelsStatusDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$BundleList$Flags$ExtraProgressViewLabelsStatus,
	A2($elm$json$Json$Decode$field, 'failure', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'success', $elm$json$Json$Decode$string));
var $author$project$BundleList$Flags$ExtraProgressViewLabelsWorkflow = function (label) {
	return {label: label};
};
var $author$project$BundleList$Flags$extraProgressViewLabelsWorkflowDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$BundleList$Flags$ExtraProgressViewLabelsWorkflow,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$BundleList$Flags$extraProgressViewLabelsDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$BundleList$Flags$ExtraProgressViewLabels,
	A2($elm$json$Json$Decode$field, 'decode_errors', $author$project$BundleList$Flags$extraProgressViewLabelsDecodeErrorsDecoder),
	A2($elm$json$Json$Decode$field, 'diagnostic_logs', $author$project$BundleList$Flags$extraProgressViewLabelsDiagnosticLogsDecoder),
	A2($elm$json$Json$Decode$field, 'status', $author$project$BundleList$Flags$extraProgressViewLabelsStatusDecoder),
	A2($elm$json$Json$Decode$field, 'workflow', $author$project$BundleList$Flags$extraProgressViewLabelsWorkflowDecoder));
var $author$project$BundleList$Flags$extraProgressViewDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$BundleList$Flags$ExtraProgressView,
	A2($elm$json$Json$Decode$field, 'labels', $author$project$BundleList$Flags$extraProgressViewLabelsDecoder));
var $author$project$BundleList$Flags$extraDecoder = A8(
	$elm$json$Json$Decode$map7,
	$author$project$BundleList$Flags$Extra,
	A2($elm$json$Json$Decode$field, 'bundlelist_view', $author$project$BundleList$Flags$extraBundlelistViewDecoder),
	A2($elm$json$Json$Decode$field, 'mode', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'module', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'plurals', $author$project$BundleList$Flags$extraPluralsDecoder),
	A2($elm$json$Json$Decode$field, 'progress_view', $author$project$BundleList$Flags$extraProgressViewDecoder),
	A2(
		$elm$json$Json$Decode$field,
		'view_nodes',
		$elm$json$Json$Decode$list($elm$json$Json$Decode$string)),
	A2(
		$elm$json$Json$Decode$field,
		'workflowpaths',
		$elm$json$Json$Decode$list($elm$json$Json$Decode$string)));
var $author$project$BundleList$Flags$FlagsConfig = F3(
	function (baseUrl, defaultLanguage, extra) {
		return {baseUrl: baseUrl, defaultLanguage: defaultLanguage, extra: extra};
	});
var $author$project$BundleList$Flags$FlagsConfigExtra = F4(
	function (dev, originCollab, originReview, title) {
		return {dev: dev, originCollab: originCollab, originReview: originReview, title: title};
	});
var $author$project$BundleList$Flags$flagsConfigExtraDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$BundleList$Flags$FlagsConfigExtra,
	A2($elm$json$Json$Decode$field, 'dev', $elm$json$Json$Decode$bool),
	A2($elm$json$Json$Decode$field, 'origin_collab', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'origin_review', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'title', $elm$json$Json$Decode$string));
var $author$project$BundleList$Flags$flagsConfigDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$BundleList$Flags$FlagsConfig,
	A2($elm$json$Json$Decode$field, 'base_url', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'default_language', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'extra', $author$project$BundleList$Flags$flagsConfigExtraDecoder));
var $author$project$BundleList$Flags$FlagsWorkflowsObject = F3(
	function (name, label, progress) {
		return {label: label, name: name, progress: progress};
	});
var $author$project$BundleList$Flags$FlagsWorkflowsObjectProgressObject = F2(
	function (display, messages) {
		return {display: display, messages: messages};
	});
var $author$project$BundleList$Flags$FlagsWorkflowsObjectProgressObjectDisplay = F7(
	function (error, error2, init, ok, ok2, skip, skip2) {
		return {error: error, error2: error2, init: init, ok: ok, ok2: ok2, skip: skip, skip2: skip2};
	});
var $author$project$BundleList$Flags$flagsWorkflowsObjectProgressObjectDisplayDecoder = A8(
	$elm$json$Json$Decode$map7,
	$author$project$BundleList$Flags$FlagsWorkflowsObjectProgressObjectDisplay,
	A2($elm$json$Json$Decode$field, 'error', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'error2', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'init', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'ok', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'ok2', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'skip', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'skip2', $elm$json$Json$Decode$string));
var $author$project$BundleList$Flags$FlagsWorkflowsObjectProgressObjectMessages = F2(
	function (error, ok) {
		return {error: error, ok: ok};
	});
var $author$project$BundleList$Flags$flagsWorkflowsObjectProgressObjectMessagesDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$BundleList$Flags$FlagsWorkflowsObjectProgressObjectMessages,
	A2($elm$json$Json$Decode$field, 'error', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'ok', $elm$json$Json$Decode$string));
var $author$project$BundleList$Flags$flagsWorkflowsObjectProgressObjectDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$BundleList$Flags$FlagsWorkflowsObjectProgressObject,
	A2($elm$json$Json$Decode$field, 'display', $author$project$BundleList$Flags$flagsWorkflowsObjectProgressObjectDisplayDecoder),
	A2($elm$json$Json$Decode$field, 'messages', $author$project$BundleList$Flags$flagsWorkflowsObjectProgressObjectMessagesDecoder));
var $author$project$BundleList$Flags$flagsWorkflowsObjectDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$BundleList$Flags$FlagsWorkflowsObject,
	A2($elm$json$Json$Decode$field, 'name', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2(
		$elm$json$Json$Decode$field,
		'progress',
		$elm$json$Json$Decode$list($author$project$BundleList$Flags$flagsWorkflowsObjectProgressObjectDecoder)));
var $author$project$BundleList$Flags$flagsDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$BundleList$Flags$Flags,
	A2($elm$json$Json$Decode$field, 'config', $author$project$BundleList$Flags$flagsConfigDecoder),
	A2($elm$json$Json$Decode$field, 'extra', $author$project$BundleList$Flags$extraDecoder),
	A2(
		$elm$json$Json$Decode$field,
		'workflows',
		$elm$json$Json$Decode$list($author$project$BundleList$Flags$flagsWorkflowsObjectDecoder)));
var $author$project$BundleList$Flags$jsonToResultFlags = function (json) {
	return A2(
		$elm$core$Result$mapError,
		$elm$json$Json$Decode$errorToString,
		A2($elm$json$Json$Decode$decodeValue, $author$project$BundleList$Flags$flagsDecoder, json));
};
var $author$project$BundleList$Model$ProgressMsg = function (a) {
	return {$: 'ProgressMsg', a: a};
};
var $author$project$BundleList$progressCmds = function (pcmds) {
	return A2($elm$core$Platform$Cmd$map, $author$project$BundleList$Model$ProgressMsg, pcmds);
};
var $author$project$BundleList$progressFlags = function (flags) {
	return {labels: flags.extra.progressView.labels, workflows: flags.workflows};
};
var $author$project$BundleList$init = function (value) {
	var _v0 = $author$project$BundleList$Flags$jsonToResultFlags(value);
	if (_v0.$ === 'Err') {
		var err = _v0.a;
		return _Utils_Tuple2(
			$author$project$BundleList$Model$Failed(err),
			$elm$core$Platform$Cmd$none);
	} else {
		var flags = _v0.a;
		var _v1 = $author$project$Progress$Model$init(
			$author$project$BundleList$progressFlags(flags));
		var pstate = _v1.a;
		var pcmds = _v1.b;
		return _Utils_Tuple2(
			A2(
				$author$project$BundleList$Model$Loaded,
				flags,
				{auth: $krisajenkins$remotedata$RemoteData$NotAsked, bundles: $elm$core$Dict$empty, filter: '', members: $elm$core$Dict$empty, progress: pstate, response: $krisajenkins$remotedata$RemoteData$NotAsked, show_example: false}),
			$author$project$BundleList$progressCmds(pcmds));
	}
};
var $author$project$BundleList$Model$Incoming = function (a) {
	return {$: 'Incoming', a: a};
};
var $author$project$BundleList$subscriptions = function (model) {
	return $author$project$Shared$Ports$toElm($author$project$BundleList$Model$Incoming);
};
var $author$project$BundleList$Model$emptyBundle = {bundle_stats: $elm$core$Maybe$Nothing, comment_stats: $elm$core$Maybe$Nothing, data: $elm$core$Maybe$Nothing, expanded: false, last_visit: $elm$core$Maybe$Nothing, share_status: $elm$core$Maybe$Nothing};
var $author$project$BundleList$Model$updateBundle = F3(
	function (key, fn, state) {
		var bundle = function () {
			var _v0 = A2($elm$core$Dict$get, key, state.bundles);
			if (_v0.$ === 'Just') {
				var m = _v0.a;
				return m;
			} else {
				return $author$project$BundleList$Model$emptyBundle;
			}
		}();
		var newbundle = fn(bundle);
		return _Utils_update(
			state,
			{
				bundles: A3($elm$core$Dict$insert, key, newbundle, state.bundles)
			});
	});
var $author$project$BundleList$Model$emptyMember = {profile: $elm$core$Maybe$Nothing};
var $author$project$BundleList$Model$updateMember = F3(
	function (key, fn, state) {
		var member = function () {
			var _v0 = A2($elm$core$Dict$get, key, state.members);
			if (_v0.$ === 'Just') {
				var m = _v0.a;
				return m;
			} else {
				return $author$project$BundleList$Model$emptyMember;
			}
		}();
		var newmember = fn(member);
		return _Utils_update(
			state,
			{
				members: A3($elm$core$Dict$insert, key, newmember, state.members)
			});
	});
var $author$project$BundleList$updateStateCmds = F3(
	function (flags, state, cmds) {
		return _Utils_Tuple2(
			A2($author$project$BundleList$Model$Loaded, flags, state),
			cmds);
	});
var $author$project$BundleList$updateProgress = F3(
	function (flags, state, pmsg) {
		var _v0 = A3(
			$author$project$Progress$Model$update,
			$author$project$BundleList$progressFlags(flags),
			state.progress,
			pmsg);
		var pstate = _v0.a;
		var pcmds = _v0.b;
		return A3(
			$author$project$BundleList$updateStateCmds,
			flags,
			_Utils_update(
				state,
				{progress: pstate}),
			$author$project$BundleList$progressCmds(pcmds));
	});
var $author$project$BundleList$updateState = F2(
	function (flags, state) {
		return A3($author$project$BundleList$updateStateCmds, flags, state, $elm$core$Platform$Cmd$none);
	});
var $author$project$BundleList$Decode$IncomingAuth = function (a) {
	return {$: 'IncomingAuth', a: a};
};
var $author$project$BundleList$Decode$IncomingBundleData = F3(
	function (a, b, c) {
		return {$: 'IncomingBundleData', a: a, b: b, c: c};
	});
var $author$project$BundleList$Decode$IncomingError = function (a) {
	return {$: 'IncomingError', a: a};
};
var $author$project$BundleList$Decode$IncomingProfileData = F2(
	function (a, b) {
		return {$: 'IncomingProfileData', a: a, b: b};
	});
var $author$project$BundleList$Decode$Progress = function (a) {
	return {$: 'Progress', a: a};
};
var $author$project$BundleList$Decode$incomingMsgDecoderByMsg = function (msg) {
	switch (msg) {
		case 'error':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$BundleList$Decode$IncomingError,
				A2($elm$json$Json$Decode$field, 'details', $elm$json$Json$Decode$string));
		case 'auth':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$BundleList$Decode$IncomingAuth,
				A2($elm$json$Json$Decode$field, 'auth', $author$project$Auth$Decode$authDecoder));
		case 'bundle info':
			return A4(
				$elm$json$Json$Decode$map3,
				$author$project$BundleList$Decode$IncomingBundleData,
				A2($elm$json$Json$Decode$field, 'bnum', $elm$json$Json$Decode$int),
				A2($elm$json$Json$Decode$field, 'bundle', $author$project$BundleData$Decode$bundleDataDecoder),
				A2($elm$json$Json$Decode$field, 'stats', $author$project$BundleStats$Decode$bundleStatsDecoder));
		case 'profile info':
			return A3(
				$elm$json$Json$Decode$map2,
				$author$project$BundleList$Decode$IncomingProfileData,
				A2($elm$json$Json$Decode$field, 'mnum', $elm$json$Json$Decode$int),
				A2($elm$json$Json$Decode$field, 'profile', $author$project$ProfileData$Decode$profileDataDecoder));
		case 'progress':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$BundleList$Decode$Progress,
				A2($elm$json$Json$Decode$field, 'progress', $elm$json$Json$Decode$value));
		default:
			var other = msg;
			return $elm$json$Json$Decode$fail(other);
	}
};
var $author$project$BundleList$Decode$incomingMsgDecoder = A2(
	$elm$json$Json$Decode$andThen,
	$author$project$BundleList$Decode$incomingMsgDecoderByMsg,
	A2($elm$json$Json$Decode$field, 'msg', $elm$json$Json$Decode$string));
var $author$project$BundleList$Decode$valueToIncomingMsg = function (value) {
	return function (x) {
		return x;
	}(
		A2(
			$elm$core$Result$mapError,
			$elm$json$Json$Decode$errorToString,
			A2($elm$json$Json$Decode$decodeValue, $author$project$BundleList$Decode$incomingMsgDecoder, value)));
};
var $author$project$BundleList$update = F2(
	function (msg, model) {
		var _v0 = _Utils_Tuple2(model, msg);
		if (_v0.a.$ === 'Failed') {
			return _Utils_Tuple2(model, $elm$core$Platform$Cmd$none);
		} else {
			switch (_v0.b.$) {
				case 'UpdateFilter':
					var _v1 = _v0.a;
					var flags = _v1.a;
					var state = _v1.b;
					var value = _v0.b.a;
					return A2(
						$author$project$BundleList$updateState,
						flags,
						_Utils_update(
							state,
							{filter: value, response: $krisajenkins$remotedata$RemoteData$NotAsked}));
				case 'UpdateShowExample':
					var _v2 = _v0.a;
					var flags = _v2.a;
					var state = _v2.b;
					var value = _v0.b.a;
					return A2(
						$author$project$BundleList$updateState,
						flags,
						_Utils_update(
							state,
							{response: $krisajenkins$remotedata$RemoteData$NotAsked, show_example: value}));
				case 'PressAddBundle':
					var _v3 = _v0.a;
					var flags = _v3.a;
					var state = _v3.b;
					var _v4 = _v0.b;
					return A2($author$project$Shared$Cmd$cmdTransition, flags.extra.bundlelistView.transitions.add, model);
				case 'ProgressMsg':
					var _v5 = _v0.a;
					var flags = _v5.a;
					var state = _v5.b;
					var pmsg = _v0.b.a;
					return A3($author$project$BundleList$updateProgress, flags, state, pmsg);
				case 'ToggleExpanded':
					var _v6 = _v0.a;
					var flags = _v6.a;
					var state = _v6.b;
					var key = _v0.b.a;
					var newstate = A3(
						$author$project$BundleList$Model$updateBundle,
						key,
						function (m) {
							return _Utils_update(
								m,
								{expanded: !m.expanded});
						},
						state);
					return A2(
						$author$project$BundleList$updateState,
						flags,
						_Utils_update(
							newstate,
							{response: $krisajenkins$remotedata$RemoteData$NotAsked}));
				case 'PressDetails':
					var _v7 = _v0.a;
					var flags = _v7.a;
					var state = _v7.b;
					var key = _v0.b.a;
					return A3($author$project$Shared$Cmd$cmdTransitionNumber, flags.extra.bundlelistView.transitions.details, key, model);
				default:
					var _v8 = _v0.a;
					var flags = _v8.a;
					var state = _v8.b;
					var v = _v0.b.a;
					var _v9 = $author$project$BundleList$Decode$valueToIncomingMsg(v);
					if (_v9.$ === 'Err') {
						var err = _v9.a;
						return $author$project$Shared$Reg$decodeErr(err) ? A3(
							$author$project$BundleList$updateProgress,
							flags,
							state,
							$author$project$Progress$Model$DecodeErr(err)) : A2($author$project$Shared$Cmd$cmdLog, 'Err ' + err, model);
					} else {
						switch (_v9.a.$) {
							case 'IncomingError':
								var err = _v9.a.a;
								return A2(
									$author$project$BundleList$updateState,
									flags,
									_Utils_update(
										state,
										{
											response: $krisajenkins$remotedata$RemoteData$Failure(err)
										}));
							case 'IncomingAuth':
								var auth = _v9.a.a;
								return A2(
									$author$project$BundleList$updateState,
									flags,
									_Utils_update(
										state,
										{
											auth: $krisajenkins$remotedata$RemoteData$Success(auth)
										}));
							case 'IncomingBundleData':
								var _v10 = _v9.a;
								var key = _v10.a;
								var data = _v10.b;
								var stats = _v10.c;
								var newstate = A3(
									$author$project$BundleList$Model$updateBundle,
									key,
									function (m) {
										return _Utils_update(
											m,
											{
												bundle_stats: $elm$core$Maybe$Just(stats),
												data: $elm$core$Maybe$Just(data)
											});
									},
									state);
								return A2($author$project$BundleList$updateState, flags, newstate);
							case 'IncomingProfileData':
								var _v11 = _v9.a;
								var key = _v11.a;
								var profile = _v11.b;
								var newstate = A3(
									$author$project$BundleList$Model$updateMember,
									key,
									function (m) {
										return _Utils_update(
											m,
											{
												profile: $elm$core$Maybe$Just(profile)
											});
									},
									state);
								return A2($author$project$BundleList$updateState, flags, newstate);
							default:
								var value = _v9.a.a;
								return A3(
									$author$project$BundleList$updateProgress,
									flags,
									state,
									$author$project$Progress$Model$Incoming(value));
						}
					}
			}
		}
	});
var $author$project$BundleList$currentView = 0;
var $author$project$BundleList$Model$PressAddBundle = {$: 'PressAddBundle'};
var $author$project$BundleList$View$viewAddSearch = F2(
	function (flags, state) {
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('columns pb-4'),
					A2($elm$html$Html$Attributes$style, 'border-bottom', '1px solid rgba(219,219,219,.5)')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('is-hidden-mobile mr-5')
						]),
					_List_fromArray(
						[
							$elm$html$Html$text($author$project$Shared$Text$nbsp)
						])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('column is-one-fifth')
						]),
					_List_fromArray(
						[
							function () {
							var _v0 = state.auth;
							if (_v0.$ === 'Success') {
								var auth = _v0.a;
								var _v1 = auth.role;
								if (_v1.$ === 'Host') {
									return A2(
										$elm$html$Html$button,
										_List_fromArray(
											[
												$elm$html$Html$Attributes$class('button has-background-primary-dark has-text-white'),
												$elm$html$Html$Events$onClick($author$project$BundleList$Model$PressAddBundle)
											]),
										_List_fromArray(
											[
												$elm$html$Html$text(flags.extra.bundlelistView.labels.addBundle.label)
											]));
								} else {
									return $elm$html$Html$text($author$project$Shared$Text$nbsp);
								}
							} else {
								return $elm$html$Html$text($author$project$Shared$Text$nbsp);
							}
						}()
						])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('column is-hidden-mobile')
						]),
					_List_Nil)
				]));
	});
var $author$project$BundleList$Model$PressDetails = function (a) {
	return {$: 'PressDetails', a: a};
};
var $author$project$BundleList$Model$ToggleExpanded = function (a) {
	return {$: 'ToggleExpanded', a: a};
};
var $author$project$BundleList$View$iSize = 20;
var $author$project$Shared$Text$nbd = $elm$core$String$fromChar(
	_Utils_chr('‑'));
var $author$project$Shared$Plural$plural_files = F3(
	function (plurals, n, tag) {
		switch (n) {
			case 0:
				return _List_fromArray(
					[
						tag(plurals.noFiles)
					]);
			case 1:
				return _List_fromArray(
					[
						tag(plurals.oneFile)
					]);
			default:
				return _List_fromArray(
					[
						tag(
						$elm$core$String$fromInt(n)),
						tag($author$project$Shared$Text$nbsp),
						tag(plurals.files)
					]);
		}
	});
var $author$project$Shared$Plural$plural_folders = F3(
	function (plurals, n, tag) {
		switch (n) {
			case 0:
				return _List_fromArray(
					[
						tag(plurals.noFolders)
					]);
			case 1:
				return _List_fromArray(
					[
						tag(plurals.oneFolder)
					]);
			default:
				return _List_fromArray(
					[
						tag(
						$elm$core$String$fromInt(n)),
						tag($author$project$Shared$Text$nbsp),
						tag(plurals.folders)
					]);
		}
	});
var $author$project$BundleList$View$viewExpanded = F4(
	function (flags, state, key, bundle) {
		var description_text = function () {
			var _v0 = bundle.data;
			if (_v0.$ === 'Nothing') {
				return _List_Nil;
			} else {
				var data = _v0.a;
				return _List_fromArray(
					[
						A2($elm$html$Html$br, _List_Nil, _List_Nil),
						A2(
						$elm$html$Html$span,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('tag mr-1')
							]),
						_List_fromArray(
							[
								$elm$html$Html$text(flags.extra.bundlelistView.labels.description.label)
							])),
						A2(
						$elm$html$Html$span,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('mt-5')
							]),
						_List_fromArray(
							[
								$elm$html$Html$text(data.description)
							]))
					]);
			}
		}();
		return bundle.expanded ? description_text : _List_Nil;
	});
var $elm$html$Html$wbr = _VirtualDom_node('wbr');
var $author$project$BundleList$View$viewBundle = F4(
	function (flags, plurals, state, _v0) {
		var key = _v0.a;
		var bundle = _v0.b;
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('media')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('mr-1'),
							A2($elm$html$Html$Attributes$style, 'width', '24px'),
							A2($elm$html$Html$Attributes$style, 'min-width', '24px'),
							A2($elm$html$Html$Attributes$style, 'height', '24px'),
							$elm$html$Html$Events$onClick(
							$author$project$BundleList$Model$ToggleExpanded(key))
						]),
					_List_fromArray(
						[
							$author$project$Shared$Expand$svgExpandCollapse(bundle.expanded)
						])),
					function () {
					var picture = function () {
						var _v1 = bundle.data;
						if (_v1.$ === 'Nothing') {
							return A2($author$project$Shared$Icon$roundIcon, 48, '');
						} else {
							var data = _v1.a;
							return A2($author$project$Shared$Icon$roundIcon, 48, data.name);
						}
					}();
					var image_div = _List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('image is-48x48')
								]),
							_List_fromArray(
								[picture]))
						]);
					return A2(
						$elm$html$Html$div,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('media-left')
							]),
						image_div);
				}(),
					function () {
					var title_txt = function () {
						var _v7 = bundle.data;
						if (_v7.$ === 'Nothing') {
							return _List_Nil;
						} else {
							var data = _v7.a;
							return _List_fromArray(
								[
									A2(
									$elm$html$Html$p,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('title is-4 mt-0 mb-0')
										]),
									_List_fromArray(
										[
											$elm$html$Html$text(data.name)
										]))
								]);
						}
					}();
					var stats_txt = function () {
						var _v6 = bundle.bundle_stats;
						if (_v6.$ === 'Nothing') {
							return _List_Nil;
						} else {
							var stats = _v6.a;
							var size = _List_fromArray(
								[
									$elm$html$Html$text(
									A2($author$project$Shared$Text$fsize, $author$project$Shared$Text$numsp, stats.size | 0))
								]);
							var folders = A3($author$project$Shared$Plural$plural_folders, plurals, stats.folders, $elm$html$Html$text);
							var files = A3($author$project$Shared$Plural$plural_files, plurals, stats.files, $elm$html$Html$text);
							return _List_fromArray(
								[
									A2(
									$elm$html$Html$p,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('is-size-7 mt-0 mb-0')
										]),
									_Utils_ap(
										folders,
										_Utils_ap(
											_List_fromArray(
												[
													$elm$html$Html$text(' ')
												]),
											_Utils_ap(
												files,
												_Utils_ap(
													_List_fromArray(
														[
															$elm$html$Html$text(' ')
														]),
													size)))))
								]);
						}
					}();
					var restricted_txt = function () {
						var _v5 = bundle.data;
						if (_v5.$ === 'Nothing') {
							return _List_Nil;
						} else {
							var data = _v5.a;
							return data.restricted ? _List_fromArray(
								[
									A2(
									$elm$html$Html$p,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('has-text-weight-bold is-size-7 mt-0')
										]),
									_List_fromArray(
										[
											$elm$html$Html$text(flags.extra.bundlelistView.labels.restricted.label)
										]))
								]) : _List_fromArray(
								[
									A2(
									$elm$html$Html$p,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('is-size-7 mt-0')
										]),
									_List_fromArray(
										[
											$elm$html$Html$text(flags.extra.bundlelistView.labels.unrestricted.label)
										]))
								]);
						}
					}();
					var floatLeftCls2 = F2(
						function (h, w) {
							return A2(
								$elm$html$Html$div,
								_List_fromArray(
									[
										$elm$html$Html$Attributes$class('sp-floatleft mr-1'),
										A2($elm$html$Html$Attributes$style, 'width', w)
									]),
								h);
						});
					var sharedWithDiv = A2(
						floatLeftCls2,
						_List_fromArray(
							[
								$elm$html$Html$text(flags.extra.bundlelistView.labels.shared.label)
							]),
						flags.extra.bundlelistView.labels.shared.width);
					var floatLeftCls = function (h) {
						return A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('sp-floatleft mr-1')
								]),
							h);
					};
					var roundIcons = function (l) {
						return A2(
							$elm$core$List$map,
							function (x) {
								return floatLeftCls(
									_List_fromArray(
										[
											A2($author$project$Shared$Icon$roundIcon, $author$project$BundleList$View$iSize, x)
										]));
							},
							l);
					};
					var squareIcons = function (l) {
						return A2(
							$elm$core$List$map,
							function (x) {
								return floatLeftCls(
									_List_fromArray(
										[
											A2($author$project$Shared$Icon$squareIcon, $author$project$BundleList$View$iSize, x)
										]));
							},
							l);
					};
					var shared_txt = function () {
						var _v4 = bundle.share_status;
						if (_v4.$ === 'Nothing') {
							return _List_Nil;
						} else {
							var shared = _v4.a.shared;
							return _List_fromArray(
								[
									A2($elm$html$Html$br, _List_Nil, _List_Nil),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('is-size-7')
										]),
									A2(
										$elm$core$List$cons,
										sharedWithDiv,
										squareIcons(shared)))
								]);
						}
					}();
					var visitedDiv = F2(
						function (pct, last) {
							return floatLeftCls(
								_List_fromArray(
									[
										$elm$html$Html$text(
										$elm$core$String$fromInt(pct)),
										$elm$html$Html$text(flags.extra.bundlelistView.labels.pctVisited.label),
										A2($elm$html$Html$wbr, _List_Nil, _List_Nil),
										$elm$html$Html$text(flags.extra.bundlelistView.labels.lastVisit.label),
										$elm$html$Html$text(
										A3($elm$core$String$replace, '-', $author$project$Shared$Text$nbd, last))
									]));
						});
					var visited_txt = function () {
						var _v3 = bundle.last_visit;
						if (_v3.$ === 'Nothing') {
							return _List_Nil;
						} else {
							var pct = _v3.a.pct;
							var last = _v3.a.last;
							return _List_fromArray(
								[
									A2($elm$html$Html$br, _List_Nil, _List_Nil),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('is-size-7')
										]),
									_List_fromArray(
										[
											A2(visitedDiv, pct, last)
										]))
								]);
						}
					}();
					var comments_txt = function () {
						var _v2 = bundle.comment_stats;
						if (_v2.$ === 'Nothing') {
							return _List_Nil;
						} else {
							var stats = _v2.a;
							return _List_fromArray(
								[
									A2(
									$elm$html$Html$span,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('is-size-7')
										]),
									_List_fromArray(
										[
											$elm$html$Html$text(
											$elm$core$String$fromInt(stats.comments)),
											$elm$html$Html$text($author$project$Shared$Text$nbsp),
											$elm$html$Html$text(plurals.comments),
											$elm$html$Html$text($author$project$Shared$Text$nbsp),
											$elm$html$Html$text(
											$elm$core$String$fromInt(stats.unread)),
											$elm$html$Html$text($author$project$Shared$Text$nbsp),
											$elm$html$Html$text(plurals.unread)
										]))
								]);
						}
					}();
					return A2(
						$elm$html$Html$div,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('media-content'),
								A2($elm$html$Html$Attributes$style, 'overflow-x', 'visible'),
								A2($elm$html$Html$Attributes$style, 'overflow-y', 'visible')
							]),
						_Utils_ap(
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('columns mb-0')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$div,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('column is-5 pb-0')
												]),
											_Utils_ap(
												title_txt,
												_Utils_ap(stats_txt, restricted_txt))),
											A2(
											$elm$html$Html$div,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('column pt-0'),
													A2($elm$html$Html$Attributes$style, 'border-left', '1px solid rgba(219,219,219,.5)')
												]),
											_Utils_ap(
												comments_txt,
												_Utils_ap(visited_txt, shared_txt)))
										]))
								]),
							A4($author$project$BundleList$View$viewExpanded, flags, state, key, bundle)));
				}(),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('media-right')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$button,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('button has-background-primary-dark has-text-white'),
									$elm$html$Html$Events$onClick(
									$author$project$BundleList$Model$PressDetails(key))
								]),
							_List_fromArray(
								[
									$elm$html$Html$text(flags.extra.bundlelistView.labels.details.label)
								]))
						]))
				]));
	});
var $author$project$BundleList$View$viewBundles = F3(
	function (flags, plurals, state) {
		var _v0 = state.filter;
		if (_v0 === '') {
			return A2(
				$elm$core$List$map,
				A3($author$project$BundleList$View$viewBundle, flags, plurals, state),
				$elm$core$Dict$toList(state.bundles));
		} else {
			var filter = _v0;
			return A2(
				$elm$core$List$map,
				A3($author$project$BundleList$View$viewBundle, flags, plurals, state),
				A2(
					$elm$core$List$take,
					1,
					$elm$core$Dict$toList(state.bundles)));
		}
	});
var $author$project$BundleList$View$view = F3(
	function (flags, plurals, state) {
		return A2(
			$elm$html$Html$div,
			_List_Nil,
			A2(
				$elm$core$List$cons,
				A2($author$project$BundleList$View$viewAddSearch, flags, state),
				A3($author$project$BundleList$View$viewBundles, flags, plurals, state)));
	});
var $author$project$BundleList$view = function (model) {
	var _v0 = _Utils_Tuple2($author$project$BundleList$currentView, model);
	_v0$3:
	while (true) {
		if (_v0.b.$ === 'Failed') {
			if (!_v0.a) {
				var err = _v0.b.a;
				return A2(
					$elm$html$Html$p,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('notification is-danger')
						]),
					_List_fromArray(
						[
							$elm$html$Html$text(err)
						]));
			} else {
				break _v0$3;
			}
		} else {
			switch (_v0.a) {
				case 0:
					var _v1 = _v0.b;
					var flags = _v1.a;
					var state = _v1.b;
					return A3($author$project$BundleList$View$view, flags, flags.extra.plurals, state);
				case 1:
					var _v2 = _v0.b;
					var flags = _v2.a;
					var state = _v2.b;
					return A2(
						$elm$html$Html$map,
						$author$project$BundleList$Model$ProgressMsg,
						A2(
							$author$project$Progress$View$view,
							$author$project$BundleList$progressFlags(flags),
							state.progress));
				default:
					break _v0$3;
			}
		}
	}
	return A2($elm$html$Html$div, _List_Nil, _List_Nil);
};
var $author$project$BundleList$main = $elm$browser$Browser$element(
	{init: $author$project$BundleList$init, subscriptions: $author$project$BundleList$subscriptions, update: $author$project$BundleList$update, view: $author$project$BundleList$view});
var $author$project$Bundle$Model$Failed = function (a) {
	return {$: 'Failed', a: a};
};
var $author$project$Bundle$Model$Loaded = F2(
	function (a, b) {
		return {$: 'Loaded', a: a, b: b};
	});
var $author$project$Bundle$Model$ContentsMsg = function (a) {
	return {$: 'ContentsMsg', a: a};
};
var $author$project$Bundle$contentsCmds = function (ccmds) {
	return A2($elm$core$Platform$Cmd$map, $author$project$Bundle$Model$ContentsMsg, ccmds);
};
var $author$project$Bundle$contentsFlags = function (flags) {
	return {errors: flags.extra.bundleContents.errors, labels: flags.extra.bundleContents.labels, mode: flags.extra.mode};
};
var $author$project$Bundle$Model$DetailsMsg = function (a) {
	return {$: 'DetailsMsg', a: a};
};
var $author$project$Bundle$detailsCmds = function (dcmds) {
	return A2($elm$core$Platform$Cmd$map, $author$project$Bundle$Model$DetailsMsg, dcmds);
};
var $author$project$Bundle$detailsFlags = function (flags) {
	return {errors: flags.extra.bundleDetails.errors, labels: flags.extra.bundleDetails.labels, readonly: flags.extra.bundleDetails.readonly};
};
var $author$project$BundleContents$Model$init = function (flags) {
	return _Utils_Tuple2(
		{
			eltId: 'chooseId',
			expanded: false,
			fileChosen: false,
			ishost: false,
			latest: $krisajenkins$remotedata$RemoteData$NotAsked,
			limit: 5,
			name: $elm$core$Maybe$Nothing,
			pagesize: 15,
			path: '',
			problems: {errors: _List_Nil, settingsErrors: _List_Nil},
			settingsApplied: false
		},
		$elm$core$Platform$Cmd$none);
};
var $author$project$BundleDetails$Model$Problems = F2(
	function (currentErr, nameErr) {
		return {currentErr: currentErr, nameErr: nameErr};
	});
var $author$project$BundleData$Model$emptyBundleData = {description: '', name: '', restricted: false, shared_with: _List_Nil};
var $author$project$BundleData$Valid$nameregex = '^.{4,100}$';
var $author$project$BundleData$Valid$validNameRegex = A2(
	$elm$core$Maybe$withDefault,
	$elm$regex$Regex$never,
	$elm$regex$Regex$fromString($author$project$BundleData$Valid$nameregex));
var $author$project$BundleData$Valid$nameSyntaxErr = F2(
	function (errors, name) {
		var _v0 = A2($elm$regex$Regex$contains, $author$project$BundleData$Valid$validNameRegex, name);
		if (_v0) {
			return $elm$core$Maybe$Nothing;
		} else {
			return $elm$core$Maybe$Just(errors.name.syntax);
		}
	});
var $author$project$BundleData$Unique$nameConflict = F2(
	function (unique, names) {
		return A2(
			$elm$core$List$any,
			function (s) {
				return _Utils_eq(s, names);
			},
			unique.names) ? $elm$core$Maybe$Just(
			A2($elm$core$String$join, ', ', unique.names)) : $elm$core$Maybe$Nothing;
	});
var $author$project$BundleData$Valid$nameUniqueErr = F3(
	function (errors, runique, name) {
		switch (runique.$) {
			case 'Success':
				var unique = runique.a;
				var _v1 = A2($author$project$BundleData$Unique$nameConflict, unique, name);
				if (_v1.$ === 'Just') {
					var values = _v1.a;
					return $elm$core$Maybe$Just(
						_Utils_ap(errors.name.unique, values));
				} else {
					return $elm$core$Maybe$Nothing;
				}
			case 'Failure':
				var err = runique.a;
				return $elm$core$Maybe$Just(err);
			default:
				return $elm$core$Maybe$Nothing;
		}
	});
var $author$project$BundleData$Valid$nameErr = F3(
	function (errors, runique, name) {
		return $elm_community$maybe_extra$Maybe$Extra$orList(
			_List_fromArray(
				[
					A2($author$project$BundleData$Valid$nameSyntaxErr, errors, name),
					A3($author$project$BundleData$Valid$nameUniqueErr, errors, runique, name)
				]));
	});
var $author$project$BundleDetails$Model$validate = F4(
	function (flags, runique, current, readonly) {
		return {
			currentErr: $elm$core$Maybe$Nothing,
			nameErr: readonly ? $elm$core$Maybe$Nothing : A3($author$project$BundleData$Valid$nameErr, flags.errors, runique, current.name)
		};
	});
var $author$project$BundleDetails$Model$validateState = F2(
	function (flags, state) {
		return _Utils_update(
			state,
			{
				problems: A4($author$project$BundleDetails$Model$validate, flags, state.runique, state.current, state.readonly)
			});
	});
var $author$project$BundleDetails$Model$init = function (flags) {
	return _Utils_Tuple2(
		A2(
			$author$project$BundleDetails$Model$validateState,
			flags,
			{
				current: $author$project$BundleData$Model$emptyBundleData,
				initial: $elm$core$Maybe$Nothing,
				ishost: false,
				problems: A2($author$project$BundleDetails$Model$Problems, $elm$core$Maybe$Nothing, $elm$core$Maybe$Nothing),
				readonly: flags.readonly,
				runique: $krisajenkins$remotedata$RemoteData$NotAsked
			}),
		$elm$core$Platform$Cmd$none);
};
var $author$project$BundleMembers$Model$init = function (flags) {
	return _Utils_Tuple2(
		{ishost: false, notes: $elm$core$Dict$empty, profiles: $elm$core$Dict$empty},
		$elm$core$Platform$Cmd$none);
};
var $author$project$Bundle$Flags$Flags = F3(
	function (config, extra, workflows) {
		return {config: config, extra: extra, workflows: workflows};
	});
var $author$project$Bundle$Flags$Extra = F9(
	function (bundleComments, bundleContents, bundleDetails, bundleMembers, bundleSubmit, mode, module_, progressView, viewNodes) {
		return {bundleComments: bundleComments, bundleContents: bundleContents, bundleDetails: bundleDetails, bundleMembers: bundleMembers, bundleSubmit: bundleSubmit, mode: mode, module_: module_, progressView: progressView, viewNodes: viewNodes};
	});
var $author$project$Bundle$Flags$ExtraBundleComments = function (labels) {
	return {labels: labels};
};
var $author$project$Bundle$Flags$ExtraBundleCommentsLabels = F6(
	function (addComment, ago, comment, more, name, reply) {
		return {addComment: addComment, ago: ago, comment: comment, more: more, name: name, reply: reply};
	});
var $author$project$Bundle$Flags$ExtraBundleCommentsLabelsAddComment = function (label) {
	return {label: label};
};
var $author$project$Bundle$Flags$extraBundleCommentsLabelsAddCommentDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraBundleCommentsLabelsAddComment,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleCommentsLabelsAgo = F8(
	function (day, days, hour, hours, minute, minutes, week, weeks) {
		return {day: day, days: days, hour: hour, hours: hours, minute: minute, minutes: minutes, week: week, weeks: weeks};
	});
var $author$project$Bundle$Flags$extraBundleCommentsLabelsAgoDecoder = A9(
	$elm$json$Json$Decode$map8,
	$author$project$Bundle$Flags$ExtraBundleCommentsLabelsAgo,
	A2($elm$json$Json$Decode$field, 'day', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'days', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'hour', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'hours', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'minute', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'minutes', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'week', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'weeks', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleCommentsLabelsComment = F3(
	function (comment, comments, noComments) {
		return {comment: comment, comments: comments, noComments: noComments};
	});
var $author$project$Bundle$Flags$extraBundleCommentsLabelsCommentDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Bundle$Flags$ExtraBundleCommentsLabelsComment,
	A2($elm$json$Json$Decode$field, 'comment', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'comments', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'no_comments', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleCommentsLabelsMore = function (label) {
	return {label: label};
};
var $author$project$Bundle$Flags$extraBundleCommentsLabelsMoreDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraBundleCommentsLabelsMore,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleCommentsLabelsName = function (label) {
	return {label: label};
};
var $author$project$Bundle$Flags$extraBundleCommentsLabelsNameDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraBundleCommentsLabelsName,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleCommentsLabelsReply = function (label) {
	return {label: label};
};
var $author$project$Bundle$Flags$extraBundleCommentsLabelsReplyDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraBundleCommentsLabelsReply,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$extraBundleCommentsLabelsDecoder = A7(
	$elm$json$Json$Decode$map6,
	$author$project$Bundle$Flags$ExtraBundleCommentsLabels,
	A2($elm$json$Json$Decode$field, 'add_comment', $author$project$Bundle$Flags$extraBundleCommentsLabelsAddCommentDecoder),
	A2($elm$json$Json$Decode$field, 'ago', $author$project$Bundle$Flags$extraBundleCommentsLabelsAgoDecoder),
	A2($elm$json$Json$Decode$field, 'comment', $author$project$Bundle$Flags$extraBundleCommentsLabelsCommentDecoder),
	A2($elm$json$Json$Decode$field, 'more', $author$project$Bundle$Flags$extraBundleCommentsLabelsMoreDecoder),
	A2($elm$json$Json$Decode$field, 'name', $author$project$Bundle$Flags$extraBundleCommentsLabelsNameDecoder),
	A2($elm$json$Json$Decode$field, 'reply', $author$project$Bundle$Flags$extraBundleCommentsLabelsReplyDecoder));
var $author$project$Bundle$Flags$extraBundleCommentsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraBundleComments,
	A2($elm$json$Json$Decode$field, 'labels', $author$project$Bundle$Flags$extraBundleCommentsLabelsDecoder));
var $author$project$Bundle$Flags$ExtraBundleContents = F2(
	function (errors, labels) {
		return {errors: errors, labels: labels};
	});
var $author$project$Bundle$Flags$ExtraBundleContentsErrors = function (settings) {
	return {settings: settings};
};
var $author$project$Bundle$Flags$ExtraBundleContentsErrorsSettings = F2(
	function (noerrors, problems) {
		return {noerrors: noerrors, problems: problems};
	});
var $author$project$Bundle$Flags$extraBundleContentsErrorsSettingsDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Bundle$Flags$ExtraBundleContentsErrorsSettings,
	A2($elm$json$Json$Decode$field, 'noerrors', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'problems', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$extraBundleContentsErrorsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraBundleContentsErrors,
	A2($elm$json$Json$Decode$field, 'settings', $author$project$Bundle$Flags$extraBundleContentsErrorsSettingsDecoder));
var $author$project$Bundle$Flags$ExtraBundleContentsLabels = function (apply) {
	return function (choose) {
		return function (choosefile) {
			return function (_default) {
				return function (description) {
					return function (detail) {
						return function (dflt) {
							return function (download) {
								return function (entries) {
									return function (files) {
										return function (folders) {
											return function (_function) {
												return function (limit) {
													return function (mime) {
														return function (name) {
															return function (noentries) {
																return function (of_) {
																	return function (page) {
																		return function (pagesize) {
																			return function (path) {
																				return function (reset) {
																					return function (settings) {
																						return function (size) {
																							return function (title) {
																								return function (total) {
																									return function (zipfile) {
																										return function (zipfilename) {
																											return {apply: apply, choose: choose, choosefile: choosefile, _default: _default, description: description, detail: detail, dflt: dflt, download: download, entries: entries, files: files, folders: folders, _function: _function, limit: limit, mime: mime, name: name, noentries: noentries, of_: of_, page: page, pagesize: pagesize, path: path, reset: reset, settings: settings, size: size, title: title, total: total, zipfile: zipfile, zipfilename: zipfilename};
																										};
																									};
																								};
																							};
																						};
																					};
																				};
																			};
																		};
																	};
																};
															};
														};
													};
												};
											};
										};
									};
								};
							};
						};
					};
				};
			};
		};
	};
};
var $author$project$Bundle$Flags$ExtraBundleContentsLabelsApply = function (label) {
	return {label: label};
};
var $author$project$Bundle$Flags$extraBundleContentsLabelsApplyDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraBundleContentsLabelsApply,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleContentsLabelsChoose = function (label) {
	return {label: label};
};
var $author$project$Bundle$Flags$extraBundleContentsLabelsChooseDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraBundleContentsLabelsChoose,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleContentsLabelsChoosefile = function (label) {
	return {label: label};
};
var $author$project$Bundle$Flags$extraBundleContentsLabelsChoosefileDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraBundleContentsLabelsChoosefile,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleContentsLabelsDefault = function (label) {
	return {label: label};
};
var $author$project$Bundle$Flags$extraBundleContentsLabelsDefaultDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraBundleContentsLabelsDefault,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleContentsLabelsDescription = function (label) {
	return {label: label};
};
var $author$project$Bundle$Flags$extraBundleContentsLabelsDescriptionDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraBundleContentsLabelsDescription,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleContentsLabelsDetail = function (label) {
	return {label: label};
};
var $author$project$Bundle$Flags$extraBundleContentsLabelsDetailDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraBundleContentsLabelsDetail,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleContentsLabelsDflt = function (label) {
	return {label: label};
};
var $author$project$Bundle$Flags$extraBundleContentsLabelsDfltDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraBundleContentsLabelsDflt,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleContentsLabelsDownload = F3(
	function (label, restricted, width) {
		return {label: label, restricted: restricted, width: width};
	});
var $author$project$Bundle$Flags$extraBundleContentsLabelsDownloadDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Bundle$Flags$ExtraBundleContentsLabelsDownload,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'restricted', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleContentsLabelsEntries = function (label) {
	return {label: label};
};
var $author$project$Bundle$Flags$extraBundleContentsLabelsEntriesDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraBundleContentsLabelsEntries,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleContentsLabelsFiles = function (label) {
	return {label: label};
};
var $author$project$Bundle$Flags$extraBundleContentsLabelsFilesDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraBundleContentsLabelsFiles,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleContentsLabelsFolders = function (label) {
	return {label: label};
};
var $author$project$Bundle$Flags$extraBundleContentsLabelsFoldersDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraBundleContentsLabelsFolders,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleContentsLabelsFunction = function (label) {
	return {label: label};
};
var $author$project$Bundle$Flags$extraBundleContentsLabelsFunctionDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraBundleContentsLabelsFunction,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleContentsLabelsLimit = F2(
	function (label, maxwidth) {
		return {label: label, maxwidth: maxwidth};
	});
var $author$project$Bundle$Flags$extraBundleContentsLabelsLimitDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Bundle$Flags$ExtraBundleContentsLabelsLimit,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'maxwidth', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleContentsLabelsMime = function (label) {
	return {label: label};
};
var $author$project$Bundle$Flags$extraBundleContentsLabelsMimeDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraBundleContentsLabelsMime,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleContentsLabelsName = function (label) {
	return {label: label};
};
var $author$project$Bundle$Flags$extraBundleContentsLabelsNameDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraBundleContentsLabelsName,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleContentsLabelsNoentries = function (label) {
	return {label: label};
};
var $author$project$Bundle$Flags$extraBundleContentsLabelsNoentriesDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraBundleContentsLabelsNoentries,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleContentsLabelsOf = function (label) {
	return {label: label};
};
var $author$project$Bundle$Flags$extraBundleContentsLabelsOfDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraBundleContentsLabelsOf,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleContentsLabelsPage = function (label) {
	return {label: label};
};
var $author$project$Bundle$Flags$extraBundleContentsLabelsPageDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraBundleContentsLabelsPage,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleContentsLabelsPagesize = F2(
	function (label, maxwidth) {
		return {label: label, maxwidth: maxwidth};
	});
var $author$project$Bundle$Flags$extraBundleContentsLabelsPagesizeDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Bundle$Flags$ExtraBundleContentsLabelsPagesize,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'maxwidth', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleContentsLabelsPath = function (label) {
	return {label: label};
};
var $author$project$Bundle$Flags$extraBundleContentsLabelsPathDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraBundleContentsLabelsPath,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleContentsLabelsReset = function (label) {
	return {label: label};
};
var $author$project$Bundle$Flags$extraBundleContentsLabelsResetDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraBundleContentsLabelsReset,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleContentsLabelsSettings = F2(
	function (description, label) {
		return {description: description, label: label};
	});
var $author$project$Bundle$Flags$extraBundleContentsLabelsSettingsDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Bundle$Flags$ExtraBundleContentsLabelsSettings,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleContentsLabelsSize = function (label) {
	return {label: label};
};
var $author$project$Bundle$Flags$extraBundleContentsLabelsSizeDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraBundleContentsLabelsSize,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleContentsLabelsTitle = function (label) {
	return {label: label};
};
var $author$project$Bundle$Flags$extraBundleContentsLabelsTitleDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraBundleContentsLabelsTitle,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleContentsLabelsTotal = F2(
	function (label, pad) {
		return {label: label, pad: pad};
	});
var $author$project$Bundle$Flags$extraBundleContentsLabelsTotalDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Bundle$Flags$ExtraBundleContentsLabelsTotal,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'pad', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleContentsLabelsZipfile = F3(
	function (description, label, updatedescription) {
		return {description: description, label: label, updatedescription: updatedescription};
	});
var $author$project$Bundle$Flags$extraBundleContentsLabelsZipfileDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Bundle$Flags$ExtraBundleContentsLabelsZipfile,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'updatedescription', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleContentsLabelsZipfilename = function (label) {
	return {label: label};
};
var $author$project$Bundle$Flags$extraBundleContentsLabelsZipfilenameDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraBundleContentsLabelsZipfilename,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$extraBundleContentsLabelsDecoder = function () {
	var fieldSet0 = A9(
		$elm$json$Json$Decode$map8,
		$author$project$Bundle$Flags$ExtraBundleContentsLabels,
		A2($elm$json$Json$Decode$field, 'apply', $author$project$Bundle$Flags$extraBundleContentsLabelsApplyDecoder),
		A2($elm$json$Json$Decode$field, 'choose', $author$project$Bundle$Flags$extraBundleContentsLabelsChooseDecoder),
		A2($elm$json$Json$Decode$field, 'choosefile', $author$project$Bundle$Flags$extraBundleContentsLabelsChoosefileDecoder),
		A2($elm$json$Json$Decode$field, 'default', $author$project$Bundle$Flags$extraBundleContentsLabelsDefaultDecoder),
		A2($elm$json$Json$Decode$field, 'description', $author$project$Bundle$Flags$extraBundleContentsLabelsDescriptionDecoder),
		A2($elm$json$Json$Decode$field, 'detail', $author$project$Bundle$Flags$extraBundleContentsLabelsDetailDecoder),
		A2($elm$json$Json$Decode$field, 'dflt', $author$project$Bundle$Flags$extraBundleContentsLabelsDfltDecoder),
		A2($elm$json$Json$Decode$field, 'download', $author$project$Bundle$Flags$extraBundleContentsLabelsDownloadDecoder));
	var fieldSet1 = A9(
		$elm$json$Json$Decode$map8,
		$elm$core$Basics$apL,
		fieldSet0,
		A2($elm$json$Json$Decode$field, 'entries', $author$project$Bundle$Flags$extraBundleContentsLabelsEntriesDecoder),
		A2($elm$json$Json$Decode$field, 'files', $author$project$Bundle$Flags$extraBundleContentsLabelsFilesDecoder),
		A2($elm$json$Json$Decode$field, 'folders', $author$project$Bundle$Flags$extraBundleContentsLabelsFoldersDecoder),
		A2($elm$json$Json$Decode$field, 'function', $author$project$Bundle$Flags$extraBundleContentsLabelsFunctionDecoder),
		A2($elm$json$Json$Decode$field, 'limit', $author$project$Bundle$Flags$extraBundleContentsLabelsLimitDecoder),
		A2($elm$json$Json$Decode$field, 'mime', $author$project$Bundle$Flags$extraBundleContentsLabelsMimeDecoder),
		A2($elm$json$Json$Decode$field, 'name', $author$project$Bundle$Flags$extraBundleContentsLabelsNameDecoder));
	var fieldSet2 = A9(
		$elm$json$Json$Decode$map8,
		$elm$core$Basics$apL,
		fieldSet1,
		A2($elm$json$Json$Decode$field, 'noentries', $author$project$Bundle$Flags$extraBundleContentsLabelsNoentriesDecoder),
		A2($elm$json$Json$Decode$field, 'of_', $author$project$Bundle$Flags$extraBundleContentsLabelsOfDecoder),
		A2($elm$json$Json$Decode$field, 'page', $author$project$Bundle$Flags$extraBundleContentsLabelsPageDecoder),
		A2($elm$json$Json$Decode$field, 'pagesize', $author$project$Bundle$Flags$extraBundleContentsLabelsPagesizeDecoder),
		A2($elm$json$Json$Decode$field, 'path', $author$project$Bundle$Flags$extraBundleContentsLabelsPathDecoder),
		A2($elm$json$Json$Decode$field, 'reset', $author$project$Bundle$Flags$extraBundleContentsLabelsResetDecoder),
		A2($elm$json$Json$Decode$field, 'settings', $author$project$Bundle$Flags$extraBundleContentsLabelsSettingsDecoder));
	return A7(
		$elm$json$Json$Decode$map6,
		$elm$core$Basics$apL,
		fieldSet2,
		A2($elm$json$Json$Decode$field, 'size', $author$project$Bundle$Flags$extraBundleContentsLabelsSizeDecoder),
		A2($elm$json$Json$Decode$field, 'title', $author$project$Bundle$Flags$extraBundleContentsLabelsTitleDecoder),
		A2($elm$json$Json$Decode$field, 'total', $author$project$Bundle$Flags$extraBundleContentsLabelsTotalDecoder),
		A2($elm$json$Json$Decode$field, 'zipfile', $author$project$Bundle$Flags$extraBundleContentsLabelsZipfileDecoder),
		A2($elm$json$Json$Decode$field, 'zipfilename', $author$project$Bundle$Flags$extraBundleContentsLabelsZipfilenameDecoder));
}();
var $author$project$Bundle$Flags$extraBundleContentsDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Bundle$Flags$ExtraBundleContents,
	A2($elm$json$Json$Decode$field, 'errors', $author$project$Bundle$Flags$extraBundleContentsErrorsDecoder),
	A2($elm$json$Json$Decode$field, 'labels', $author$project$Bundle$Flags$extraBundleContentsLabelsDecoder));
var $author$project$Bundle$Flags$ExtraBundleDetails = F3(
	function (errors, labels, readonly) {
		return {errors: errors, labels: labels, readonly: readonly};
	});
var $author$project$Bundle$Flags$ExtraBundleDetailsErrors = function (name) {
	return {name: name};
};
var $author$project$Bundle$Flags$ExtraBundleDetailsErrorsName = F2(
	function (syntax, unique) {
		return {syntax: syntax, unique: unique};
	});
var $author$project$Bundle$Flags$extraBundleDetailsErrorsNameDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Bundle$Flags$ExtraBundleDetailsErrorsName,
	A2($elm$json$Json$Decode$field, 'syntax', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'unique', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$extraBundleDetailsErrorsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraBundleDetailsErrors,
	A2($elm$json$Json$Decode$field, 'name', $author$project$Bundle$Flags$extraBundleDetailsErrorsNameDecoder));
var $author$project$Bundle$Flags$ExtraBundleDetailsLabels = F4(
	function (description, icon, name, restricted) {
		return {description: description, icon: icon, name: name, restricted: restricted};
	});
var $author$project$Bundle$Flags$ExtraBundleDetailsLabelsDescription = F3(
	function (description, label, placeholder) {
		return {description: description, label: label, placeholder: placeholder};
	});
var $author$project$Bundle$Flags$extraBundleDetailsLabelsDescriptionDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Bundle$Flags$ExtraBundleDetailsLabelsDescription,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'placeholder', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleDetailsLabelsIcon = function (label) {
	return {label: label};
};
var $author$project$Bundle$Flags$extraBundleDetailsLabelsIconDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraBundleDetailsLabelsIcon,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleDetailsLabelsName = F3(
	function (description, label, placeholder) {
		return {description: description, label: label, placeholder: placeholder};
	});
var $author$project$Bundle$Flags$extraBundleDetailsLabelsNameDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Bundle$Flags$ExtraBundleDetailsLabelsName,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'placeholder', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleDetailsLabelsRestricted = F2(
	function (description, label) {
		return {description: description, label: label};
	});
var $author$project$Bundle$Flags$extraBundleDetailsLabelsRestrictedDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Bundle$Flags$ExtraBundleDetailsLabelsRestricted,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$extraBundleDetailsLabelsDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$Bundle$Flags$ExtraBundleDetailsLabels,
	A2($elm$json$Json$Decode$field, 'description', $author$project$Bundle$Flags$extraBundleDetailsLabelsDescriptionDecoder),
	A2($elm$json$Json$Decode$field, 'icon', $author$project$Bundle$Flags$extraBundleDetailsLabelsIconDecoder),
	A2($elm$json$Json$Decode$field, 'name', $author$project$Bundle$Flags$extraBundleDetailsLabelsNameDecoder),
	A2($elm$json$Json$Decode$field, 'restricted', $author$project$Bundle$Flags$extraBundleDetailsLabelsRestrictedDecoder));
var $author$project$Bundle$Flags$extraBundleDetailsDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Bundle$Flags$ExtraBundleDetails,
	A2($elm$json$Json$Decode$field, 'errors', $author$project$Bundle$Flags$extraBundleDetailsErrorsDecoder),
	A2($elm$json$Json$Decode$field, 'labels', $author$project$Bundle$Flags$extraBundleDetailsLabelsDecoder),
	A2($elm$json$Json$Decode$field, 'readonly', $elm$json$Json$Decode$bool));
var $author$project$Bundle$Flags$ExtraBundleMembers = function (labels) {
	return {labels: labels};
};
var $author$project$Bundle$Flags$ExtraBundleMembersLabels = F6(
	function (accepted, checkbox, note, shareWith, title, who) {
		return {accepted: accepted, checkbox: checkbox, note: note, shareWith: shareWith, title: title, who: who};
	});
var $author$project$Bundle$Flags$ExtraBundleMembersLabelsAccepted = F4(
	function (datalabel, description, value, width) {
		return {datalabel: datalabel, description: description, value: value, width: width};
	});
var $author$project$Bundle$Flags$extraBundleMembersLabelsAcceptedDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$Bundle$Flags$ExtraBundleMembersLabelsAccepted,
	A2($elm$json$Json$Decode$field, 'datalabel', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'value', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleMembersLabelsCheckbox = function (width) {
	return {width: width};
};
var $author$project$Bundle$Flags$extraBundleMembersLabelsCheckboxDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraBundleMembersLabelsCheckbox,
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleMembersLabelsNote = F2(
	function (label, width) {
		return {label: label, width: width};
	});
var $author$project$Bundle$Flags$extraBundleMembersLabelsNoteDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Bundle$Flags$ExtraBundleMembersLabelsNote,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleMembersLabelsShareWith = F2(
	function (label, none) {
		return {label: label, none: none};
	});
var $author$project$Bundle$Flags$extraBundleMembersLabelsShareWithDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Bundle$Flags$ExtraBundleMembersLabelsShareWith,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'none', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleMembersLabelsTitle = F2(
	function (label, width) {
		return {label: label, width: width};
	});
var $author$project$Bundle$Flags$extraBundleMembersLabelsTitleDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Bundle$Flags$ExtraBundleMembersLabelsTitle,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleMembersLabelsWho = F2(
	function (label, width) {
		return {label: label, width: width};
	});
var $author$project$Bundle$Flags$extraBundleMembersLabelsWhoDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Bundle$Flags$ExtraBundleMembersLabelsWho,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$extraBundleMembersLabelsDecoder = A7(
	$elm$json$Json$Decode$map6,
	$author$project$Bundle$Flags$ExtraBundleMembersLabels,
	A2($elm$json$Json$Decode$field, 'accepted', $author$project$Bundle$Flags$extraBundleMembersLabelsAcceptedDecoder),
	A2($elm$json$Json$Decode$field, 'checkbox', $author$project$Bundle$Flags$extraBundleMembersLabelsCheckboxDecoder),
	A2($elm$json$Json$Decode$field, 'note', $author$project$Bundle$Flags$extraBundleMembersLabelsNoteDecoder),
	A2($elm$json$Json$Decode$field, 'share_with', $author$project$Bundle$Flags$extraBundleMembersLabelsShareWithDecoder),
	A2($elm$json$Json$Decode$field, 'title', $author$project$Bundle$Flags$extraBundleMembersLabelsTitleDecoder),
	A2($elm$json$Json$Decode$field, 'who', $author$project$Bundle$Flags$extraBundleMembersLabelsWhoDecoder));
var $author$project$Bundle$Flags$extraBundleMembersDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraBundleMembers,
	A2($elm$json$Json$Decode$field, 'labels', $author$project$Bundle$Flags$extraBundleMembersLabelsDecoder));
var $author$project$Bundle$Flags$ExtraBundleSubmit = F3(
	function (labels, requests, transitions) {
		return {labels: labels, requests: requests, transitions: transitions};
	});
var $author$project$Bundle$Flags$ExtraBundleSubmitLabels = F5(
	function (description, options, pause, submit, title) {
		return {description: description, options: options, pause: pause, submit: submit, title: title};
	});
var $author$project$Bundle$Flags$ExtraBundleSubmitLabelsDescription = function (label) {
	return {label: label};
};
var $author$project$Bundle$Flags$extraBundleSubmitLabelsDescriptionDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraBundleSubmitLabelsDescription,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleSubmitLabelsOptions = function (label) {
	return {label: label};
};
var $author$project$Bundle$Flags$extraBundleSubmitLabelsOptionsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraBundleSubmitLabelsOptions,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleSubmitLabelsPause = F2(
	function (description, label) {
		return {description: description, label: label};
	});
var $author$project$Bundle$Flags$extraBundleSubmitLabelsPauseDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Bundle$Flags$ExtraBundleSubmitLabelsPause,
	A2($elm$json$Json$Decode$field, 'description', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleSubmitLabelsSubmit = F8(
	function (changed, failed, label, nofile, settings, unchanged, updated, width) {
		return {changed: changed, failed: failed, label: label, nofile: nofile, settings: settings, unchanged: unchanged, updated: updated, width: width};
	});
var $author$project$Bundle$Flags$extraBundleSubmitLabelsSubmitDecoder = A9(
	$elm$json$Json$Decode$map8,
	$author$project$Bundle$Flags$ExtraBundleSubmitLabelsSubmit,
	A2($elm$json$Json$Decode$field, 'changed', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'failed', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'nofile', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'settings', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'unchanged', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'updated', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'width', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleSubmitLabelsTitle = function (label) {
	return {label: label};
};
var $author$project$Bundle$Flags$extraBundleSubmitLabelsTitleDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraBundleSubmitLabelsTitle,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$extraBundleSubmitLabelsDecoder = A6(
	$elm$json$Json$Decode$map5,
	$author$project$Bundle$Flags$ExtraBundleSubmitLabels,
	A2($elm$json$Json$Decode$field, 'description', $author$project$Bundle$Flags$extraBundleSubmitLabelsDescriptionDecoder),
	A2($elm$json$Json$Decode$field, 'options', $author$project$Bundle$Flags$extraBundleSubmitLabelsOptionsDecoder),
	A2($elm$json$Json$Decode$field, 'pause', $author$project$Bundle$Flags$extraBundleSubmitLabelsPauseDecoder),
	A2($elm$json$Json$Decode$field, 'submit', $author$project$Bundle$Flags$extraBundleSubmitLabelsSubmitDecoder),
	A2($elm$json$Json$Decode$field, 'title', $author$project$Bundle$Flags$extraBundleSubmitLabelsTitleDecoder));
var $author$project$Bundle$Flags$ExtraBundleSubmitRequests = function (submit) {
	return {submit: submit};
};
var $author$project$Bundle$Flags$extraBundleSubmitRequestsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraBundleSubmitRequests,
	A2($elm$json$Json$Decode$field, 'submit', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraBundleSubmitTransitions = function (view) {
	return {view: view};
};
var $author$project$Bundle$Flags$extraBundleSubmitTransitionsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraBundleSubmitTransitions,
	A2($elm$json$Json$Decode$field, 'view', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$extraBundleSubmitDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Bundle$Flags$ExtraBundleSubmit,
	A2($elm$json$Json$Decode$field, 'labels', $author$project$Bundle$Flags$extraBundleSubmitLabelsDecoder),
	A2($elm$json$Json$Decode$field, 'requests', $author$project$Bundle$Flags$extraBundleSubmitRequestsDecoder),
	A2($elm$json$Json$Decode$field, 'transitions', $author$project$Bundle$Flags$extraBundleSubmitTransitionsDecoder));
var $author$project$Bundle$Flags$ExtraProgressView = function (labels) {
	return {labels: labels};
};
var $author$project$Bundle$Flags$ExtraProgressViewLabels = F4(
	function (decodeErrors, diagnosticLogs, status, workflow) {
		return {decodeErrors: decodeErrors, diagnosticLogs: diagnosticLogs, status: status, workflow: workflow};
	});
var $author$project$Bundle$Flags$ExtraProgressViewLabelsDecodeErrors = function (label) {
	return {label: label};
};
var $author$project$Bundle$Flags$extraProgressViewLabelsDecodeErrorsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraProgressViewLabelsDecodeErrors,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraProgressViewLabelsDiagnosticLogs = function (label) {
	return {label: label};
};
var $author$project$Bundle$Flags$extraProgressViewLabelsDiagnosticLogsDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraProgressViewLabelsDiagnosticLogs,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraProgressViewLabelsStatus = F2(
	function (failure, success) {
		return {failure: failure, success: success};
	});
var $author$project$Bundle$Flags$extraProgressViewLabelsStatusDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Bundle$Flags$ExtraProgressViewLabelsStatus,
	A2($elm$json$Json$Decode$field, 'failure', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'success', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$ExtraProgressViewLabelsWorkflow = function (label) {
	return {label: label};
};
var $author$project$Bundle$Flags$extraProgressViewLabelsWorkflowDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraProgressViewLabelsWorkflow,
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$extraProgressViewLabelsDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$Bundle$Flags$ExtraProgressViewLabels,
	A2($elm$json$Json$Decode$field, 'decode_errors', $author$project$Bundle$Flags$extraProgressViewLabelsDecodeErrorsDecoder),
	A2($elm$json$Json$Decode$field, 'diagnostic_logs', $author$project$Bundle$Flags$extraProgressViewLabelsDiagnosticLogsDecoder),
	A2($elm$json$Json$Decode$field, 'status', $author$project$Bundle$Flags$extraProgressViewLabelsStatusDecoder),
	A2($elm$json$Json$Decode$field, 'workflow', $author$project$Bundle$Flags$extraProgressViewLabelsWorkflowDecoder));
var $author$project$Bundle$Flags$extraProgressViewDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$Bundle$Flags$ExtraProgressView,
	A2($elm$json$Json$Decode$field, 'labels', $author$project$Bundle$Flags$extraProgressViewLabelsDecoder));
var $author$project$Bundle$Flags$extraDecoder = function () {
	var fieldSet0 = A9(
		$elm$json$Json$Decode$map8,
		$author$project$Bundle$Flags$Extra,
		A2($elm$json$Json$Decode$field, 'bundle_comments', $author$project$Bundle$Flags$extraBundleCommentsDecoder),
		A2($elm$json$Json$Decode$field, 'bundle_contents', $author$project$Bundle$Flags$extraBundleContentsDecoder),
		A2($elm$json$Json$Decode$field, 'bundle_details', $author$project$Bundle$Flags$extraBundleDetailsDecoder),
		A2($elm$json$Json$Decode$field, 'bundle_members', $author$project$Bundle$Flags$extraBundleMembersDecoder),
		A2($elm$json$Json$Decode$field, 'bundle_submit', $author$project$Bundle$Flags$extraBundleSubmitDecoder),
		A2($elm$json$Json$Decode$field, 'mode', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'module', $elm$json$Json$Decode$string),
		A2($elm$json$Json$Decode$field, 'progress_view', $author$project$Bundle$Flags$extraProgressViewDecoder));
	return A3(
		$elm$json$Json$Decode$map2,
		$elm$core$Basics$apL,
		fieldSet0,
		A2(
			$elm$json$Json$Decode$field,
			'view_nodes',
			$elm$json$Json$Decode$list($elm$json$Json$Decode$string)));
}();
var $author$project$Bundle$Flags$FlagsConfig = F3(
	function (baseUrl, defaultLanguage, extra) {
		return {baseUrl: baseUrl, defaultLanguage: defaultLanguage, extra: extra};
	});
var $author$project$Bundle$Flags$FlagsConfigExtra = F4(
	function (dev, originCollab, originReview, title) {
		return {dev: dev, originCollab: originCollab, originReview: originReview, title: title};
	});
var $author$project$Bundle$Flags$flagsConfigExtraDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$Bundle$Flags$FlagsConfigExtra,
	A2($elm$json$Json$Decode$field, 'dev', $elm$json$Json$Decode$bool),
	A2($elm$json$Json$Decode$field, 'origin_collab', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'origin_review', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'title', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$flagsConfigDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Bundle$Flags$FlagsConfig,
	A2($elm$json$Json$Decode$field, 'base_url', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'default_language', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'extra', $author$project$Bundle$Flags$flagsConfigExtraDecoder));
var $author$project$Bundle$Flags$FlagsWorkflowsObject = F3(
	function (name, label, progress) {
		return {label: label, name: name, progress: progress};
	});
var $author$project$Bundle$Flags$FlagsWorkflowsObjectProgressObject = F2(
	function (display, messages) {
		return {display: display, messages: messages};
	});
var $author$project$Bundle$Flags$FlagsWorkflowsObjectProgressObjectDisplay = F7(
	function (error, error2, init, ok, ok2, skip, skip2) {
		return {error: error, error2: error2, init: init, ok: ok, ok2: ok2, skip: skip, skip2: skip2};
	});
var $author$project$Bundle$Flags$flagsWorkflowsObjectProgressObjectDisplayDecoder = A8(
	$elm$json$Json$Decode$map7,
	$author$project$Bundle$Flags$FlagsWorkflowsObjectProgressObjectDisplay,
	A2($elm$json$Json$Decode$field, 'error', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'error2', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'init', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'ok', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'ok2', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'skip', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'skip2', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$FlagsWorkflowsObjectProgressObjectMessages = F2(
	function (error, ok) {
		return {error: error, ok: ok};
	});
var $author$project$Bundle$Flags$flagsWorkflowsObjectProgressObjectMessagesDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Bundle$Flags$FlagsWorkflowsObjectProgressObjectMessages,
	A2($elm$json$Json$Decode$field, 'error', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'ok', $elm$json$Json$Decode$string));
var $author$project$Bundle$Flags$flagsWorkflowsObjectProgressObjectDecoder = A3(
	$elm$json$Json$Decode$map2,
	$author$project$Bundle$Flags$FlagsWorkflowsObjectProgressObject,
	A2($elm$json$Json$Decode$field, 'display', $author$project$Bundle$Flags$flagsWorkflowsObjectProgressObjectDisplayDecoder),
	A2($elm$json$Json$Decode$field, 'messages', $author$project$Bundle$Flags$flagsWorkflowsObjectProgressObjectMessagesDecoder));
var $author$project$Bundle$Flags$flagsWorkflowsObjectDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Bundle$Flags$FlagsWorkflowsObject,
	A2($elm$json$Json$Decode$field, 'name', $elm$json$Json$Decode$string),
	A2($elm$json$Json$Decode$field, 'label', $elm$json$Json$Decode$string),
	A2(
		$elm$json$Json$Decode$field,
		'progress',
		$elm$json$Json$Decode$list($author$project$Bundle$Flags$flagsWorkflowsObjectProgressObjectDecoder)));
var $author$project$Bundle$Flags$flagsDecoder = A4(
	$elm$json$Json$Decode$map3,
	$author$project$Bundle$Flags$Flags,
	A2($elm$json$Json$Decode$field, 'config', $author$project$Bundle$Flags$flagsConfigDecoder),
	A2($elm$json$Json$Decode$field, 'extra', $author$project$Bundle$Flags$extraDecoder),
	A2(
		$elm$json$Json$Decode$field,
		'workflows',
		$elm$json$Json$Decode$list($author$project$Bundle$Flags$flagsWorkflowsObjectDecoder)));
var $author$project$Bundle$Flags$jsonToResultFlags = function (json) {
	return A2(
		$elm$core$Result$mapError,
		$elm$json$Json$Decode$errorToString,
		A2($elm$json$Json$Decode$decodeValue, $author$project$Bundle$Flags$flagsDecoder, json));
};
var $author$project$Bundle$Model$MembersMsg = function (a) {
	return {$: 'MembersMsg', a: a};
};
var $author$project$Bundle$membersCmds = function (mcmds) {
	return A2($elm$core$Platform$Cmd$map, $author$project$Bundle$Model$MembersMsg, mcmds);
};
var $author$project$Bundle$membersFlags = function (flags) {
	return {labels: flags.extra.bundleMembers.labels};
};
var $author$project$Bundle$Model$ProgressMsg = function (a) {
	return {$: 'ProgressMsg', a: a};
};
var $author$project$Bundle$progressCmds = function (pcmds) {
	return A2($elm$core$Platform$Cmd$map, $author$project$Bundle$Model$ProgressMsg, pcmds);
};
var $author$project$Bundle$progressFlags = function (flags) {
	return {labels: flags.extra.progressView.labels, workflows: flags.workflows};
};
var $author$project$Bundle$init = function (value) {
	var _v0 = $author$project$Bundle$Flags$jsonToResultFlags(value);
	if (_v0.$ === 'Err') {
		var err = _v0.a;
		return _Utils_Tuple2(
			$author$project$Bundle$Model$Failed(err),
			$elm$core$Platform$Cmd$none);
	} else {
		var flags = _v0.a;
		var _v1 = $author$project$Progress$Model$init(
			$author$project$Bundle$progressFlags(flags));
		var pstate = _v1.a;
		var pcmds = _v1.b;
		var _v2 = $author$project$BundleMembers$Model$init(
			$author$project$Bundle$membersFlags(flags));
		var mstate = _v2.a;
		var mcmds = _v2.b;
		var _v3 = $author$project$BundleDetails$Model$init(
			$author$project$Bundle$detailsFlags(flags));
		var dstate = _v3.a;
		var dcmds = _v3.b;
		var _v4 = $author$project$BundleContents$Model$init(
			$author$project$Bundle$contentsFlags(flags));
		var cstate = _v4.a;
		var ccmds = _v4.b;
		return _Utils_Tuple2(
			A2(
				$author$project$Bundle$Model$Loaded,
				flags,
				{auth: $krisajenkins$remotedata$RemoteData$NotAsked, bnum: $elm$core$Maybe$Nothing, contents: cstate, details: dstate, expanded: false, members: mstate, pause: false, progress: pstate, result: $krisajenkins$remotedata$RemoteData$NotAsked}),
			$elm$core$Platform$Cmd$batch(
				_List_fromArray(
					[
						$author$project$Bundle$detailsCmds(dcmds),
						$author$project$Bundle$contentsCmds(ccmds),
						$author$project$Bundle$membersCmds(mcmds),
						$author$project$Bundle$progressCmds(pcmds)
					])));
	}
};
var $author$project$Bundle$Model$Incoming = function (a) {
	return {$: 'Incoming', a: a};
};
var $author$project$Bundle$subscriptions = function (model) {
	return $author$project$Shared$Ports$toElm($author$project$Bundle$Model$Incoming);
};
var $author$project$BundleDetails$Model$IncomingBundleData = function (a) {
	return {$: 'IncomingBundleData', a: a};
};
var $author$project$BundleDetails$Model$IncomingBundleUnique = function (a) {
	return {$: 'IncomingBundleUnique', a: a};
};
var $author$project$BundleContents$Model$IncomingEntries = function (a) {
	return {$: 'IncomingEntries', a: a};
};
var $author$project$BundleContents$Model$IncomingError = function (a) {
	return {$: 'IncomingError', a: a};
};
var $author$project$BundleMembers$Model$IncomingNote = F2(
	function (a, b) {
		return {$: 'IncomingNote', a: a, b: b};
	});
var $author$project$BundleMembers$Model$IncomingProfileData = F2(
	function (a, b) {
		return {$: 'IncomingProfileData', a: a, b: b};
	});
var $author$project$BundleContents$Model$IncomingSettingsError = function (a) {
	return {$: 'IncomingSettingsError', a: a};
};
var $author$project$BundleDetails$Model$UpdateName = function (a) {
	return {$: 'UpdateName', a: a};
};
var $author$project$BundleDetails$Model$UpdateOk = {$: 'UpdateOk'};
var $author$project$BundleDetails$Model$UpdateShared = F2(
	function (a, b) {
		return {$: 'UpdateShared', a: a, b: b};
	});
var $author$project$BundleData$Model$bundleDataChanged = F2(
	function (initial, current) {
		if (initial.$ === 'Nothing') {
			return true;
		} else {
			var bundleData = initial.a;
			return false || ((!_Utils_eq(bundleData.name, current.name)) || ((!_Utils_eq(bundleData.description, current.description)) || ((!_Utils_eq(bundleData.restricted, current.restricted)) || (!_Utils_eq(bundleData.shared_with, current.shared_with)))));
		}
	});
var $author$project$BundleData$Encode$bundleDataToValue = function (args) {
	var encodeSharedWith = _List_fromArray(
		[
			_Utils_Tuple2(
			'shared_with',
			A2($elm$json$Json$Encode$list, $elm$json$Json$Encode$int, args.shared_with))
		]);
	var encodeRestricted = _List_fromArray(
		[
			_Utils_Tuple2(
			'restricted',
			$elm$json$Json$Encode$bool(args.restricted))
		]);
	var encodeName = _List_fromArray(
		[
			_Utils_Tuple2(
			'name',
			$elm$json$Json$Encode$string(args.name))
		]);
	var encodeKind = _List_fromArray(
		[
			_Utils_Tuple2(
			'kind',
			$elm$json$Json$Encode$string('bundle data'))
		]);
	var encodeDescription = _List_fromArray(
		[
			_Utils_Tuple2(
			'description',
			$elm$json$Json$Encode$string(args.description))
		]);
	var encoders = _Utils_ap(
		_List_Nil,
		_Utils_ap(
			encodeKind,
			_Utils_ap(
				encodeName,
				_Utils_ap(
					encodeDescription,
					_Utils_ap(encodeRestricted, encodeSharedWith)))));
	return $elm$json$Json$Encode$object(encoders);
};
var $author$project$Bundle$cmdSubmitRequest = F2(
	function (flags, state) {
		var newstate = _Utils_update(
			state,
			{result: $krisajenkins$remotedata$RemoteData$Loading});
		var ms = flags.extra.bundleSubmit;
		var encodeSettingsApplied = _List_fromArray(
			[
				_Utils_Tuple2(
				'settingsApplied',
				$elm$json$Json$Encode$bool(state.contents.settingsApplied))
			]);
		var encodeKind = _List_fromArray(
			[
				_Utils_Tuple2(
				'kind',
				$elm$json$Json$Encode$string(ms.requests.submit))
			]);
		var encodeFileChosen = _List_fromArray(
			[
				_Utils_Tuple2(
				'fileChosen',
				$elm$json$Json$Encode$bool(state.contents.fileChosen))
			]);
		var encodeBundle = A2($author$project$BundleData$Model$bundleDataChanged, state.details.initial, state.details.current) ? _List_fromArray(
			[
				_Utils_Tuple2(
				'bundle',
				$author$project$BundleData$Encode$bundleDataToValue(state.details.current))
			]) : _List_Nil;
		var encodeBnum = function () {
			var _v0 = state.bnum;
			if (_v0.$ === 'Just') {
				var bnum = _v0.a;
				return _List_fromArray(
					[
						_Utils_Tuple2(
						'bnum',
						$elm$json$Json$Encode$int(bnum))
					]);
			} else {
				return _List_Nil;
			}
		}();
		var encoders = _Utils_ap(
			_List_Nil,
			_Utils_ap(
				encodeKind,
				_Utils_ap(
					encodeBnum,
					_Utils_ap(
						encodeBundle,
						_Utils_ap(encodeSettingsApplied, encodeFileChosen)))));
		var request = $elm$json$Json$Encode$object(encoders);
		return _Utils_Tuple2(
			A2($author$project$Bundle$Model$Loaded, flags, newstate),
			$author$project$Shared$Ports$toMain(request));
	});
var $author$project$BundleDetails$Model$bundleErr = function (problems) {
	return $elm_community$maybe_extra$Maybe$Extra$orList(
		_List_fromArray(
			[problems.currentErr, problems.nameErr]));
};
var $author$project$BundleContents$Model$bundleContentsChanged = function (state) {
	return state.fileChosen || state.settingsApplied;
};
var $author$project$Bundle$View$somethingChanged = F2(
	function (flags, state) {
		return A2($author$project$BundleData$Model$bundleDataChanged, state.details.initial, state.details.current) ? true : ($author$project$BundleContents$Model$bundleContentsChanged(state.contents) ? true : false);
	});
var $author$project$Bundle$View$currentError = F2(
	function (flags, state) {
		var updated = A2($author$project$Bundle$View$somethingChanged, flags, state);
		var bs = flags.extra.bundleSubmit;
		var emsg = $elm_community$maybe_extra$Maybe$Extra$orList(
			_List_fromArray(
				[
					state.details.readonly ? $elm$core$Maybe$Nothing : $author$project$BundleDetails$Model$bundleErr(state.details.problems),
					function () {
					var _v4 = _Utils_Tuple2(state.contents.problems.errors, state.contents.problems.settingsErrors);
					if ((!_v4.a.b) && (!_v4.b.b)) {
						return $elm$core$Maybe$Nothing;
					} else {
						return $elm$core$Maybe$Just(bs.labels.submit.settings);
					}
				}(),
					function () {
					var _v5 = state.contents.latest;
					switch (_v5.$) {
						case 'Failure':
							var err = _v5.a;
							return $elm$core$Maybe$Just(err);
						case 'Success':
							return $elm$core$Maybe$Nothing;
						default:
							return $elm$core$Maybe$Just(bs.labels.submit.nofile);
					}
				}()
				]));
		var _v0 = _Utils_Tuple3(emsg, updated, state.result);
		if (_v0.a.$ === 'Just') {
			var x = _v0.a.a;
			return $elm$core$Result$Err(x);
		} else {
			if (_v0.b) {
				var _v1 = _v0.a;
				return $elm$core$Result$Ok(bs.labels.submit.changed);
			} else {
				if (_v0.c.$ === 'Success') {
					var _v2 = _v0.a;
					return $elm$core$Result$Ok(bs.labels.submit.updated);
				} else {
					var _v3 = _v0.a;
					return $elm$core$Result$Ok(bs.labels.submit.unchanged);
				}
			}
		}
	});
var $author$project$Bundle$View$okToSubmit = F2(
	function (flags, state) {
		return true && (A2($author$project$Bundle$View$somethingChanged, flags, state) && ($elm_community$result_extra$Result$Extra$isOk(
			A2($author$project$Bundle$View$currentError, flags, state)) && (!_Utils_eq(state.result, $krisajenkins$remotedata$RemoteData$Loading))));
	});
var $author$project$BundleContents$Encode$applySettingsValue = F2(
	function (limit, pagesize) {
		return $elm$json$Json$Encode$object(
			_List_fromArray(
				[
					_Utils_Tuple2(
					'kind',
					$elm$json$Json$Encode$string('apply settings')),
					_Utils_Tuple2(
					'limit',
					$elm$json$Json$Encode$int(limit)),
					_Utils_Tuple2(
					'pagesize',
					$elm$json$Json$Encode$int(pagesize))
				]));
	});
var $author$project$BundleContents$Model$cmdApplySettings = function (state) {
	return $author$project$Shared$Ports$toMain(
		A2($author$project$BundleContents$Encode$applySettingsValue, state.limit, state.pagesize));
};
var $author$project$BundleContents$Encode$chooseFileValue = F3(
	function (eltId, limit, pagesize) {
		return $elm$json$Json$Encode$object(
			_List_fromArray(
				[
					_Utils_Tuple2(
					'kind',
					$elm$json$Json$Encode$string('choose file')),
					_Utils_Tuple2(
					'eltId',
					$elm$json$Json$Encode$string(eltId)),
					_Utils_Tuple2(
					'limit',
					$elm$json$Json$Encode$int(limit)),
					_Utils_Tuple2(
					'pagesize',
					$elm$json$Json$Encode$int(pagesize))
				]));
	});
var $author$project$BundleContents$Model$cmdChooseFile = function (state) {
	return $author$project$Shared$Ports$toMain(
		A3($author$project$BundleContents$Encode$chooseFileValue, state.eltId, state.limit, state.pagesize));
};
var $author$project$BundleContents$Encode$defaultSettingsValue = $elm$json$Json$Encode$object(
	_List_fromArray(
		[
			_Utils_Tuple2(
			'kind',
			$elm$json$Json$Encode$string('default settings'))
		]));
var $author$project$BundleContents$Model$cmdDefaultSettings = function (state) {
	return $author$project$Shared$Ports$toMain($author$project$BundleContents$Encode$defaultSettingsValue);
};
var $author$project$BundleContents$Encode$downloadFileValue = $elm$json$Json$Encode$object(
	_List_fromArray(
		[
			_Utils_Tuple2(
			'kind',
			$elm$json$Json$Encode$string('download file'))
		]));
var $author$project$BundleContents$Model$cmdDownloadFile = $author$project$Shared$Ports$toMain($author$project$BundleContents$Encode$downloadFileValue);
var $author$project$BundleContents$Encode$readEntriesValue = function (args) {
	return $elm$json$Json$Encode$object(
		_List_fromArray(
			[
				_Utils_Tuple2(
				'kind',
				$elm$json$Json$Encode$string('read entries')),
				_Utils_Tuple2(
				'dn',
				$elm$json$Json$Encode$int(args.dn)),
				_Utils_Tuple2(
				'pn',
				$elm$json$Json$Encode$int(args.pn))
			]));
};
var $author$project$BundleContents$Model$cmdReadEntries = F2(
	function (dn, pn) {
		return $author$project$Shared$Ports$toMain(
			$author$project$BundleContents$Encode$readEntriesValue(
				{dn: dn, pn: pn}));
	});
var $author$project$BundleContents$Encode$resetSettingsValue = $elm$json$Json$Encode$object(
	_List_fromArray(
		[
			_Utils_Tuple2(
			'kind',
			$elm$json$Json$Encode$string('reset settings'))
		]));
var $author$project$BundleContents$Model$cmdResetSettings = function (state) {
	return $author$project$Shared$Ports$toMain($author$project$BundleContents$Encode$resetSettingsValue);
};
var $author$project$BundleContents$Encode$toggleExpandedValue = $elm$json$Json$Encode$object(
	_List_fromArray(
		[
			_Utils_Tuple2(
			'kind',
			$elm$json$Json$Encode$string('toggle expanded'))
		]));
var $author$project$BundleContents$Model$cmdToggleExpanded = $author$project$Shared$Ports$toMain($author$project$BundleContents$Encode$toggleExpandedValue);
var $author$project$BundleContents$Model$resetSettings = function (state) {
	var problems = state.problems;
	return _Utils_update(
		state,
		{
			limit: 5,
			pagesize: 15,
			problems: _Utils_update(
				problems,
				{settingsErrors: _List_Nil})
		});
};
var $author$project$BundleContents$Model$resetState = function (state) {
	return _Utils_update(
		state,
		{
			path: '',
			problems: {errors: _List_Nil, settingsErrors: _List_Nil}
		});
};
var $author$project$BundleContents$Model$update = F3(
	function (flags, state, msg) {
		var problems = state.problems;
		switch (msg.$) {
			case 'PressDownload':
				return _Utils_Tuple2(state, $author$project$BundleContents$Model$cmdDownloadFile);
			case 'ChooseFile':
				var newstate = $author$project$BundleContents$Model$resetState(state);
				var newstate2 = _Utils_update(
					newstate,
					{fileChosen: true});
				return _Utils_Tuple2(
					newstate2,
					$author$project$BundleContents$Model$cmdChooseFile(newstate2));
			case 'ChooseEntry':
				var dn = msg.a;
				var pn = msg.b;
				return _Utils_Tuple2(
					state,
					A2($author$project$BundleContents$Model$cmdReadEntries, dn, pn));
			case 'ToggleExpanded':
				var newstate = _Utils_update(
					state,
					{expanded: !state.expanded});
				return _Utils_Tuple2(newstate, $author$project$BundleContents$Model$cmdToggleExpanded);
			case 'ApplySettings':
				var newstate = $author$project$BundleContents$Model$resetState(state);
				var newstate2 = _Utils_update(
					newstate,
					{settingsApplied: true});
				return _Utils_Tuple2(
					newstate2,
					$author$project$BundleContents$Model$cmdApplySettings(newstate2));
			case 'ResetSettings':
				var newstate = $author$project$BundleContents$Model$resetSettings(state);
				return _Utils_Tuple2(
					newstate,
					$author$project$BundleContents$Model$cmdResetSettings(newstate));
			case 'DefaultSettings':
				var newstate = $author$project$BundleContents$Model$resetSettings(state);
				return _Utils_Tuple2(
					newstate,
					$author$project$BundleContents$Model$cmdDefaultSettings(newstate));
			case 'UpdateLimit':
				var limitstr = msg.a;
				var _v1 = $elm$core$String$toInt(limitstr);
				if (_v1.$ === 'Nothing') {
					return _Utils_Tuple2(state, $elm$core$Platform$Cmd$none);
				} else {
					var newlimit = _v1.a;
					var newstate = _Utils_update(
						state,
						{limit: newlimit});
					return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
				}
			case 'UpdatePageSize':
				var sizestr = msg.a;
				var _v2 = $elm$core$String$toInt(sizestr);
				if (_v2.$ === 'Nothing') {
					return _Utils_Tuple2(state, $elm$core$Platform$Cmd$none);
				} else {
					var newsize = _v2.a;
					var newstate = _Utils_update(
						state,
						{pagesize: newsize});
					return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
				}
			case 'IncomingError':
				var err = msg.a;
				var newproblems = _Utils_update(
					problems,
					{
						errors: A2($elm$core$List$cons, err, problems.errors)
					});
				var newstate = _Utils_update(
					state,
					{problems: newproblems});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			case 'IncomingSettingsError':
				var serr = msg.a;
				var newproblems = _Utils_update(
					problems,
					{
						settingsErrors: A2($elm$core$List$cons, serr, problems.settingsErrors)
					});
				var newstate = _Utils_update(
					state,
					{problems: newproblems});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			default:
				var reply = msg.a;
				var newstate = _Utils_update(
					state,
					{
						latest: $krisajenkins$remotedata$RemoteData$Success(reply),
						name: reply.name,
						path: reply.path
					});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
		}
	});
var $author$project$BundleDetails$Model$update = F3(
	function (flags, state, msg) {
		var problems = state.problems;
		var current = state.current;
		switch (msg.$) {
			case 'UpdateName':
				var value = msg.a;
				var newstate = _Utils_update(
					state,
					{
						current: _Utils_update(
							current,
							{name: value}),
						problems: _Utils_update(
							problems,
							{
								nameErr: A3($author$project$BundleData$Valid$nameErr, flags.errors, state.runique, value)
							})
					});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			case 'UpdateDescription':
				var value = msg.a;
				var newstate = _Utils_update(
					state,
					{
						current: _Utils_update(
							current,
							{description: value})
					});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			case 'UpdateRestricted':
				var value = msg.a;
				var newstate = _Utils_update(
					state,
					{
						current: _Utils_update(
							current,
							{restricted: value})
					});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			case 'IncomingBundleUnique':
				var unique = msg.a;
				var newstate = _Utils_update(
					state,
					{
						runique: $krisajenkins$remotedata$RemoteData$Success(unique)
					});
				return _Utils_Tuple2(
					A2($author$project$BundleDetails$Model$validateState, flags, newstate),
					$elm$core$Platform$Cmd$none);
			case 'IncomingBundleData':
				var bundle = msg.a;
				var newstate = _Utils_update(
					state,
					{
						current: bundle,
						initial: $elm$core$Maybe$Just(bundle)
					});
				return _Utils_Tuple2(
					A2($author$project$BundleDetails$Model$validateState, flags, newstate),
					$elm$core$Platform$Cmd$none);
			case 'UpdateShared':
				var mnum = msg.a;
				var shared = msg.b;
				var removed = A2(
					$elm$core$List$filter,
					function (x) {
						return !_Utils_eq(x, mnum);
					},
					state.current.shared_with);
				var newshared = shared ? A2($elm$core$List$cons, mnum, removed) : removed;
				var newstate = _Utils_update(
					state,
					{
						current: _Utils_update(
							current,
							{shared_with: newshared})
					});
				return _Utils_Tuple2(
					A2($author$project$BundleDetails$Model$validateState, flags, newstate),
					$elm$core$Platform$Cmd$none);
			default:
				var newstate = _Utils_update(
					state,
					{
						initial: $elm$core$Maybe$Just(current)
					});
				return _Utils_Tuple2(
					A2($author$project$BundleDetails$Model$validateState, flags, newstate),
					$elm$core$Platform$Cmd$none);
		}
	});
var $author$project$Bundle$updateStateCmds = F3(
	function (flags, cmds, state) {
		return _Utils_Tuple2(
			A2($author$project$Bundle$Model$Loaded, flags, state),
			cmds);
	});
var $author$project$Bundle$updateContents = F3(
	function (flags, cmsg, state) {
		var _v0 = A3(
			$author$project$BundleContents$Model$update,
			$author$project$Bundle$contentsFlags(flags),
			state.contents,
			cmsg);
		var cstate = _v0.a;
		var ccmds = _v0.b;
		return A3(
			$author$project$Bundle$updateStateCmds,
			flags,
			$author$project$Bundle$contentsCmds(ccmds),
			_Utils_update(
				state,
				{contents: cstate}));
	});
var $author$project$Bundle$updateDetails = F3(
	function (flags, dmsg, state) {
		var _v0 = A3(
			$author$project$BundleDetails$Model$update,
			$author$project$Bundle$detailsFlags(flags),
			state.details,
			dmsg);
		var dstate = _v0.a;
		var dcmds = _v0.b;
		return A3(
			$author$project$Bundle$updateStateCmds,
			flags,
			$author$project$Bundle$detailsCmds(dcmds),
			_Utils_update(
				state,
				{details: dstate}));
	});
var $author$project$BundleMembers$Model$update = F3(
	function (flags, state, msg) {
		switch (msg.$) {
			case 'UpdateShared':
				var mnum = msg.a;
				var value = msg.b;
				return _Utils_Tuple2(state, $elm$core$Platform$Cmd$none);
			case 'IncomingProfileData':
				var mnum = msg.a;
				var value = msg.b;
				var newstate = _Utils_update(
					state,
					{
						profiles: A3($elm$core$Dict$insert, mnum, value, state.profiles)
					});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
			default:
				var mnum = msg.a;
				var value = msg.b;
				var newstate = _Utils_update(
					state,
					{
						notes: A3($elm$core$Dict$insert, mnum, value, state.notes)
					});
				return _Utils_Tuple2(newstate, $elm$core$Platform$Cmd$none);
		}
	});
var $author$project$Bundle$updateMembers = F3(
	function (flags, mmsg, state) {
		var _v0 = A3(
			$author$project$BundleMembers$Model$update,
			$author$project$Bundle$membersFlags(flags),
			state.members,
			mmsg);
		var mstate = _v0.a;
		var mcmds = _v0.b;
		return A3(
			$author$project$Bundle$updateStateCmds,
			flags,
			$author$project$Bundle$membersCmds(mcmds),
			_Utils_update(
				state,
				{members: mstate}));
	});
var $author$project$Bundle$updateProgress = F3(
	function (flags, pmsg, state) {
		var _v0 = A3(
			$author$project$Progress$Model$update,
			$author$project$Bundle$progressFlags(flags),
			state.progress,
			pmsg);
		var pstate = _v0.a;
		var pcmds = _v0.b;
		return A3(
			$author$project$Bundle$updateStateCmds,
			flags,
			$author$project$Bundle$progressCmds(pcmds),
			_Utils_update(
				state,
				{progress: pstate}));
	});
var $author$project$Bundle$updateState = F2(
	function (flags, state) {
		return A3($author$project$Bundle$updateStateCmds, flags, $elm$core$Platform$Cmd$none, state);
	});
var $author$project$Bundle$Decode$AddBundleOk = function (a) {
	return {$: 'AddBundleOk', a: a};
};
var $author$project$Bundle$Decode$IncomingAuth = function (a) {
	return {$: 'IncomingAuth', a: a};
};
var $author$project$Bundle$Decode$IncomingBundleData = F2(
	function (a, b) {
		return {$: 'IncomingBundleData', a: a, b: b};
	});
var $author$project$Bundle$Decode$IncomingBundleUnique = function (a) {
	return {$: 'IncomingBundleUnique', a: a};
};
var $author$project$Bundle$Decode$IncomingEntries = function (a) {
	return {$: 'IncomingEntries', a: a};
};
var $author$project$Bundle$Decode$IncomingEntriesError = function (a) {
	return {$: 'IncomingEntriesError', a: a};
};
var $author$project$Bundle$Decode$IncomingNote = F2(
	function (a, b) {
		return {$: 'IncomingNote', a: a, b: b};
	});
var $author$project$Bundle$Decode$IncomingProfileData = F2(
	function (a, b) {
		return {$: 'IncomingProfileData', a: a, b: b};
	});
var $author$project$Bundle$Decode$IncomingSettingsError = function (a) {
	return {$: 'IncomingSettingsError', a: a};
};
var $author$project$Bundle$Decode$Progress = function (a) {
	return {$: 'Progress', a: a};
};
var $author$project$Bundle$Decode$RequestFailed = function (a) {
	return {$: 'RequestFailed', a: a};
};
var $author$project$Bundle$Decode$UpdateBundleOk = {$: 'UpdateBundleOk'};
var $author$project$BundleData$Unique$BundleUnique = function (names) {
	return {names: names};
};
var $author$project$BundleData$Decode$bundleUniqueDecoder = A2(
	$elm$json$Json$Decode$map,
	$author$project$BundleData$Unique$BundleUnique,
	A2(
		$elm$json$Json$Decode$field,
		'names',
		$elm$json$Json$Decode$list($elm$json$Json$Decode$string)));
var $author$project$BundleEntries$Model$EntriesMsg = F6(
	function (msg, path, name, npages, pn, entries) {
		return {entries: entries, msg: msg, name: name, npages: npages, path: path, pn: pn};
	});
var $author$project$BundleEntries$Model$Entries = F4(
	function (dn, parent, dirs, files) {
		return {dirs: dirs, dn: dn, files: files, parent: parent};
	});
var $author$project$BundleEntries$Decode$checkType = F2(
	function (expected, _continue) {
		return A2(
			$elm$json$Json$Decode$andThen,
			function (type_) {
				return _Utils_eq(type_, expected) ? _continue : $elm$json$Json$Decode$fail('type not ' + expected);
			},
			A2($elm$json$Json$Decode$field, 'type', $elm$json$Json$Decode$string));
	});
var $author$project$BundleEntries$Model$EntriesDir = F4(
	function (dn, name, folders, total) {
		return {dn: dn, folders: folders, name: name, total: total};
	});
var $NoRedInk$elm_json_decode_pipeline$Json$Decode$Pipeline$custom = $elm$json$Json$Decode$map2($elm$core$Basics$apR);
var $NoRedInk$elm_json_decode_pipeline$Json$Decode$Pipeline$required = F3(
	function (key, valDecoder, decoder) {
		return A2(
			$NoRedInk$elm_json_decode_pipeline$Json$Decode$Pipeline$custom,
			A2($elm$json$Json$Decode$field, key, valDecoder),
			decoder);
	});
var $author$project$BundleEntries$Decode$dirsDecoder = A2(
	$author$project$BundleEntries$Decode$checkType,
	'Dir',
	A3(
		$NoRedInk$elm_json_decode_pipeline$Json$Decode$Pipeline$required,
		'total',
		$elm$json$Json$Decode$float,
		A3(
			$NoRedInk$elm_json_decode_pipeline$Json$Decode$Pipeline$required,
			'folders',
			$elm$json$Json$Decode$int,
			A3(
				$NoRedInk$elm_json_decode_pipeline$Json$Decode$Pipeline$required,
				'name',
				$elm$json$Json$Decode$string,
				A3(
					$NoRedInk$elm_json_decode_pipeline$Json$Decode$Pipeline$required,
					'dn',
					$elm$json$Json$Decode$int,
					$elm$json$Json$Decode$succeed($author$project$BundleEntries$Model$EntriesDir))))));
var $author$project$BundleEntries$Model$EntriesFile = F3(
	function (name, mime, size) {
		return {mime: mime, name: name, size: size};
	});
var $author$project$BundleEntries$Decode$filesDecoder = A2(
	$author$project$BundleEntries$Decode$checkType,
	'File',
	A3(
		$NoRedInk$elm_json_decode_pipeline$Json$Decode$Pipeline$required,
		'size',
		$elm$json$Json$Decode$int,
		A3(
			$NoRedInk$elm_json_decode_pipeline$Json$Decode$Pipeline$required,
			'mime',
			$elm$json$Json$Decode$string,
			A3(
				$NoRedInk$elm_json_decode_pipeline$Json$Decode$Pipeline$required,
				'name',
				$elm$json$Json$Decode$string,
				$elm$json$Json$Decode$succeed($author$project$BundleEntries$Model$EntriesFile)))));
var $author$project$BundleEntries$Decode$entriesDecoder = A2(
	$author$project$BundleEntries$Decode$checkType,
	'Entries',
	A3(
		$NoRedInk$elm_json_decode_pipeline$Json$Decode$Pipeline$required,
		'files',
		$elm$json$Json$Decode$list($author$project$BundleEntries$Decode$filesDecoder),
		A3(
			$NoRedInk$elm_json_decode_pipeline$Json$Decode$Pipeline$required,
			'dirs',
			$elm$json$Json$Decode$list($author$project$BundleEntries$Decode$dirsDecoder),
			A3(
				$NoRedInk$elm_json_decode_pipeline$Json$Decode$Pipeline$required,
				'parent',
				$elm$json$Json$Decode$int,
				A3(
					$NoRedInk$elm_json_decode_pipeline$Json$Decode$Pipeline$required,
					'dn',
					$elm$json$Json$Decode$int,
					$elm$json$Json$Decode$succeed($author$project$BundleEntries$Model$Entries))))));
var $elm$json$Json$Decode$null = _Json_decodeNull;
var $NoRedInk$elm_json_decode_pipeline$Json$Decode$Pipeline$optionalDecoder = F3(
	function (path, valDecoder, fallback) {
		var nullOr = function (decoder) {
			return $elm$json$Json$Decode$oneOf(
				_List_fromArray(
					[
						decoder,
						$elm$json$Json$Decode$null(fallback)
					]));
		};
		var handleResult = function (input) {
			var _v0 = A2(
				$elm$json$Json$Decode$decodeValue,
				A2($elm$json$Json$Decode$at, path, $elm$json$Json$Decode$value),
				input);
			if (_v0.$ === 'Ok') {
				var rawValue = _v0.a;
				var _v1 = A2(
					$elm$json$Json$Decode$decodeValue,
					nullOr(valDecoder),
					rawValue);
				if (_v1.$ === 'Ok') {
					var finalResult = _v1.a;
					return $elm$json$Json$Decode$succeed(finalResult);
				} else {
					return A2(
						$elm$json$Json$Decode$at,
						path,
						nullOr(valDecoder));
				}
			} else {
				return $elm$json$Json$Decode$succeed(fallback);
			}
		};
		return A2($elm$json$Json$Decode$andThen, handleResult, $elm$json$Json$Decode$value);
	});
var $NoRedInk$elm_json_decode_pipeline$Json$Decode$Pipeline$optional = F4(
	function (key, valDecoder, fallback, decoder) {
		return A2(
			$NoRedInk$elm_json_decode_pipeline$Json$Decode$Pipeline$custom,
			A3(
				$NoRedInk$elm_json_decode_pipeline$Json$Decode$Pipeline$optionalDecoder,
				_List_fromArray(
					[key]),
				valDecoder,
				fallback),
			decoder);
	});
var $author$project$BundleEntries$Decode$entriesMsgDecoder = A3(
	$NoRedInk$elm_json_decode_pipeline$Json$Decode$Pipeline$required,
	'entries',
	$author$project$BundleEntries$Decode$entriesDecoder,
	A3(
		$NoRedInk$elm_json_decode_pipeline$Json$Decode$Pipeline$required,
		'pn',
		$elm$json$Json$Decode$int,
		A3(
			$NoRedInk$elm_json_decode_pipeline$Json$Decode$Pipeline$required,
			'npages',
			$elm$json$Json$Decode$int,
			A4(
				$NoRedInk$elm_json_decode_pipeline$Json$Decode$Pipeline$optional,
				'name',
				$elm$json$Json$Decode$maybe($elm$json$Json$Decode$string),
				$elm$core$Maybe$Nothing,
				A3(
					$NoRedInk$elm_json_decode_pipeline$Json$Decode$Pipeline$required,
					'path',
					$elm$json$Json$Decode$string,
					A3(
						$NoRedInk$elm_json_decode_pipeline$Json$Decode$Pipeline$required,
						'msg',
						$elm$json$Json$Decode$string,
						$elm$json$Json$Decode$succeed($author$project$BundleEntries$Model$EntriesMsg)))))));
var $author$project$BundleContents$Decode$SettingsError = F4(
	function (what, path, dflt, detail) {
		return {detail: detail, dflt: dflt, path: path, what: what};
	});
var $author$project$BundleContents$Decode$settingsErrorDecoder = A5(
	$elm$json$Json$Decode$map4,
	$author$project$BundleContents$Decode$SettingsError,
	$elm$json$Json$Decode$maybe(
		A2($elm$json$Json$Decode$field, 'what', $elm$json$Json$Decode$string)),
	$elm$json$Json$Decode$maybe(
		A2($elm$json$Json$Decode$field, 'path', $elm$json$Json$Decode$string)),
	$elm$json$Json$Decode$maybe(
		A2($elm$json$Json$Decode$field, 'dflt', $elm$json$Json$Decode$string)),
	A2($elm$json$Json$Decode$field, 'detail', $elm$json$Json$Decode$string));
var $author$project$Bundle$Decode$incomingMsgDecoderByMsg = function (msg) {
	switch (msg) {
		case 'auth':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Bundle$Decode$IncomingAuth,
				A2($elm$json$Json$Decode$field, 'auth', $author$project$Auth$Decode$authDecoder));
		case 'bundle unique info':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Bundle$Decode$IncomingBundleUnique,
				A2($elm$json$Json$Decode$field, 'unique', $author$project$BundleData$Decode$bundleUniqueDecoder));
		case 'bundle info':
			return A3(
				$elm$json$Json$Decode$map2,
				$author$project$Bundle$Decode$IncomingBundleData,
				A2($elm$json$Json$Decode$field, 'bnum', $elm$json$Json$Decode$int),
				A2($elm$json$Json$Decode$field, 'bundle', $author$project$BundleData$Decode$bundleDataDecoder));
		case 'no file selected':
			return $elm$json$Json$Decode$succeed(
				$author$project$Bundle$Decode$IncomingEntriesError(msg));
		case 'dir not found':
			return $elm$json$Json$Decode$succeed(
				$author$project$Bundle$Decode$IncomingEntriesError(msg));
		case 'page not found':
			return $elm$json$Json$Decode$succeed(
				$author$project$Bundle$Decode$IncomingEntriesError(msg));
		case 'settings error':
			return A2($elm$json$Json$Decode$map, $author$project$Bundle$Decode$IncomingSettingsError, $author$project$BundleContents$Decode$settingsErrorDecoder);
		case 'entries value':
			return A2($elm$json$Json$Decode$map, $author$project$Bundle$Decode$IncomingEntries, $author$project$BundleEntries$Decode$entriesMsgDecoder);
		case 'profile info':
			return A3(
				$elm$json$Json$Decode$map2,
				$author$project$Bundle$Decode$IncomingProfileData,
				A2($elm$json$Json$Decode$field, 'mnum', $elm$json$Json$Decode$int),
				A2($elm$json$Json$Decode$field, 'profile', $author$project$ProfileData$Decode$profileDataDecoder));
		case 'note info':
			return A3(
				$elm$json$Json$Decode$map2,
				$author$project$Bundle$Decode$IncomingNote,
				A2($elm$json$Json$Decode$field, 'mnum', $elm$json$Json$Decode$int),
				A2($elm$json$Json$Decode$field, 'note', $elm$json$Json$Decode$string));
		case 'error':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Bundle$Decode$RequestFailed,
				$elm$json$Json$Decode$maybe(
					A2($elm$json$Json$Decode$field, 'details', $elm$json$Json$Decode$string)));
		case 'add bundle ok':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Bundle$Decode$AddBundleOk,
				A2($elm$json$Json$Decode$field, 'bnum', $elm$json$Json$Decode$int));
		case 'update bundle ok':
			return $elm$json$Json$Decode$succeed($author$project$Bundle$Decode$UpdateBundleOk);
		case 'progress':
			return A2(
				$elm$json$Json$Decode$map,
				$author$project$Bundle$Decode$Progress,
				A2($elm$json$Json$Decode$field, 'progress', $elm$json$Json$Decode$value));
		default:
			var other = msg;
			return $elm$json$Json$Decode$fail(other);
	}
};
var $author$project$Bundle$Decode$incomingMsgDecoder = A2(
	$elm$json$Json$Decode$andThen,
	$author$project$Bundle$Decode$incomingMsgDecoderByMsg,
	A2($elm$json$Json$Decode$field, 'msg', $elm$json$Json$Decode$string));
var $author$project$Bundle$Decode$valueToIncomingMsg = function (value) {
	return function (x) {
		return x;
	}(
		A2(
			$elm$core$Result$mapError,
			$elm$json$Json$Decode$errorToString,
			A2($elm$json$Json$Decode$decodeValue, $author$project$Bundle$Decode$incomingMsgDecoder, value)));
};
var $author$project$Bundle$update = F2(
	function (msg, model) {
		var _v0 = _Utils_Tuple2(model, msg);
		if (_v0.a.$ === 'Failed') {
			return _Utils_Tuple2(model, $elm$core$Platform$Cmd$none);
		} else {
			switch (_v0.b.$) {
				case 'ToggleOptionsExpanded':
					var _v1 = _v0.a;
					var flags = _v1.a;
					var state = _v1.b;
					var _v2 = _v0.b;
					return A2(
						$author$project$Bundle$updateState,
						flags,
						_Utils_update(
							state,
							{expanded: !state.expanded}));
				case 'UpdatePause':
					var _v3 = _v0.a;
					var flags = _v3.a;
					var state = _v3.b;
					var value = _v0.b.a;
					return A2(
						$author$project$Bundle$updateState,
						flags,
						_Utils_update(
							state,
							{pause: value, result: $krisajenkins$remotedata$RemoteData$NotAsked}));
				case 'PressSubmit':
					var _v4 = _v0.a;
					var flags = _v4.a;
					var state = _v4.b;
					var _v5 = _v0.b;
					return A2($author$project$Bundle$View$okToSubmit, flags, state) ? A2($author$project$Bundle$cmdSubmitRequest, flags, state) : _Utils_Tuple2(model, $elm$core$Platform$Cmd$none);
				case 'DetailsMsg':
					var _v6 = _v0.a;
					var flags = _v6.a;
					var state = _v6.b;
					var dmsg = _v0.b.a;
					return A3($author$project$Bundle$updateDetails, flags, dmsg, state);
				case 'ContentsMsg':
					var _v7 = _v0.a;
					var flags = _v7.a;
					var state = _v7.b;
					var cmsg = _v0.b.a;
					return A3($author$project$Bundle$updateContents, flags, cmsg, state);
				case 'MembersMsg':
					var _v8 = _v0.a;
					var flags = _v8.a;
					var state = _v8.b;
					var mmsg = _v0.b.a;
					if (mmsg.$ === 'UpdateShared') {
						var mnum = mmsg.a;
						var value = mmsg.b;
						return A3(
							$author$project$Bundle$updateDetails,
							flags,
							A2($author$project$BundleDetails$Model$UpdateShared, mnum, value),
							state);
					} else {
						return A3($author$project$Bundle$updateMembers, flags, mmsg, state);
					}
				case 'ProgressMsg':
					var _v10 = _v0.a;
					var flags = _v10.a;
					var state = _v10.b;
					var pmsg = _v0.b.a;
					return A3($author$project$Bundle$updateProgress, flags, pmsg, state);
				default:
					var _v11 = _v0.a;
					var flags = _v11.a;
					var state = _v11.b;
					var v = _v0.b.a;
					var _v12 = $author$project$Bundle$Decode$valueToIncomingMsg(v);
					if (_v12.$ === 'Err') {
						var err = _v12.a;
						return $author$project$Shared$Reg$decodeErr(err) ? A3(
							$author$project$Bundle$updateProgress,
							flags,
							$author$project$Progress$Model$DecodeErr(err),
							state) : A2($author$project$Shared$Cmd$cmdLog, 'Err ' + err, model);
					} else {
						switch (_v12.a.$) {
							case 'IncomingAuth':
								var auth = _v12.a.a;
								var mstate = state.members;
								var ishost = _Utils_eq(auth.role, $author$project$MemberData$Model$Host);
								var dstate = state.details;
								var cstate = state.contents;
								return A2(
									$author$project$Bundle$updateState,
									flags,
									_Utils_update(
										state,
										{
											auth: $krisajenkins$remotedata$RemoteData$Success(auth),
											contents: _Utils_update(
												cstate,
												{ishost: ishost}),
											details: _Utils_update(
												dstate,
												{ishost: ishost, readonly: !ishost}),
											members: _Utils_update(
												mstate,
												{ishost: ishost})
										}));
							case 'IncomingBundleUnique':
								var unique = _v12.a.a;
								return A3(
									$author$project$Bundle$updateDetails,
									flags,
									$author$project$BundleDetails$Model$IncomingBundleUnique(unique),
									state);
							case 'IncomingBundleData':
								var _v13 = _v12.a;
								var bnum = _v13.a;
								var bundle = _v13.b;
								return A3(
									$author$project$Bundle$updateDetails,
									flags,
									$author$project$BundleDetails$Model$IncomingBundleData(bundle),
									_Utils_update(
										state,
										{
											bnum: $elm$core$Maybe$Just(bnum)
										}));
							case 'IncomingEntriesError':
								var err = _v12.a.a;
								return A3(
									$author$project$Bundle$updateContents,
									flags,
									$author$project$BundleContents$Model$IncomingError(err),
									state);
							case 'IncomingSettingsError':
								var serr = _v12.a.a;
								return A3(
									$author$project$Bundle$updateContents,
									flags,
									$author$project$BundleContents$Model$IncomingSettingsError(serr),
									state);
							case 'IncomingEntries':
								var emsg = _v12.a.a;
								var _v14 = function () {
									var _v15 = _Utils_Tuple3(state.details.initial, state.details.current.name, emsg.name);
									if (((_v15.a.$ === 'Nothing') && (_v15.b === '')) && (_v15.c.$ === 'Just')) {
										var _v16 = _v15.a;
										var name = _v15.c.a;
										return A3(
											$author$project$BundleDetails$Model$update,
											$author$project$Bundle$detailsFlags(flags),
											state.details,
											$author$project$BundleDetails$Model$UpdateName(name));
									} else {
										return _Utils_Tuple2(state.details, $elm$core$Platform$Cmd$none);
									}
								}();
								var dstate = _v14.a;
								var dcmds = _v14.b;
								var _v17 = A3(
									$author$project$BundleContents$Model$update,
									$author$project$Bundle$contentsFlags(flags),
									state.contents,
									$author$project$BundleContents$Model$IncomingEntries(emsg));
								var cstate = _v17.a;
								var ccmds = _v17.b;
								return A3(
									$author$project$Bundle$updateStateCmds,
									flags,
									$author$project$Bundle$contentsCmds(ccmds),
									_Utils_update(
										state,
										{contents: cstate, details: dstate}));
							case 'IncomingProfileData':
								var _v18 = _v12.a;
								var mnum = _v18.a;
								var profile = _v18.b;
								return A3(
									$author$project$Bundle$updateMembers,
									flags,
									A2($author$project$BundleMembers$Model$IncomingProfileData, mnum, profile),
									state);
							case 'IncomingNote':
								var _v19 = _v12.a;
								var mnum = _v19.a;
								var note = _v19.b;
								return A3(
									$author$project$Bundle$updateMembers,
									flags,
									A2($author$project$BundleMembers$Model$IncomingNote, mnum, note),
									state);
							case 'RequestFailed':
								if (_v12.a.a.$ === 'Just') {
									var err = _v12.a.a.a;
									return A2(
										$author$project$Bundle$updateState,
										flags,
										_Utils_update(
											state,
											{
												result: $krisajenkins$remotedata$RemoteData$Failure(err)
											}));
								} else {
									var _v20 = _v12.a.a;
									return A2(
										$author$project$Bundle$updateState,
										flags,
										_Utils_update(
											state,
											{
												result: $krisajenkins$remotedata$RemoteData$Failure(flags.extra.bundleSubmit.labels.submit.failed)
											}));
								}
							case 'AddBundleOk':
								var bnum = _v12.a.a;
								return state.pause ? A2(
									$author$project$Bundle$updateState,
									flags,
									_Utils_update(
										state,
										{
											result: $krisajenkins$remotedata$RemoteData$Success('')
										})) : A3($author$project$Shared$Cmd$cmdTransitionNumber, flags.extra.bundleSubmit.transitions.view, bnum, model);
							case 'UpdateBundleOk':
								var _v21 = _v12.a;
								return A3(
									$author$project$Bundle$updateDetails,
									flags,
									$author$project$BundleDetails$Model$UpdateOk,
									_Utils_update(
										state,
										{
											result: $krisajenkins$remotedata$RemoteData$Success('')
										}));
							default:
								var value = _v12.a.a;
								return A3(
									$author$project$Bundle$updateProgress,
									flags,
									$author$project$Progress$Model$Incoming(value),
									state);
						}
					}
			}
		}
	});
var $author$project$Bundle$currentView = 0;
var $author$project$Bundle$enableDownload = function (state) {
	var mprofile = function () {
		var _v1 = state.auth;
		if (_v1.$ === 'Success') {
			var auth = _v1.a;
			return A2($elm$core$Dict$get, auth.mnum, state.members.profiles);
		} else {
			return $elm$core$Maybe$Nothing;
		}
	}();
	var _v0 = _Utils_Tuple3(state.members.ishost, state.details.current.restricted, mprofile);
	if (_v0.a) {
		return true;
	} else {
		if (!_v0.b) {
			return true;
		} else {
			if (_v0.c.$ === 'Just') {
				var profile = _v0.c.a;
				return !_Utils_eq(
					profile.accepted_on,
					$elm$time$Time$millisToPosix(0));
			} else {
				return false;
			}
		}
	}
};
var $author$project$Bundle$Model$PressSubmit = {$: 'PressSubmit'};
var $author$project$Bundle$Model$ToggleOptionsExpanded = {$: 'ToggleOptionsExpanded'};
var $author$project$Bundle$View$descOrError = F2(
	function (flags, state) {
		var _v0 = A2($author$project$Bundle$View$currentError, flags, state);
		if (_v0.$ === 'Err') {
			var msg = _v0.a;
			return A2(
				$elm$html$Html$p,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('has-text-danger ml-1')
					]),
				_List_fromArray(
					[
						$elm$html$Html$text(msg)
					]));
		} else {
			var msg = _v0.a;
			return A2(
				$elm$html$Html$p,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('ml-1')
					]),
				_List_fromArray(
					[
						$elm$html$Html$text(msg)
					]));
		}
	});
var $author$project$Bundle$Model$UpdatePause = function (a) {
	return {$: 'UpdatePause', a: a};
};
var $author$project$Bundle$View$viewPause = F2(
	function (flags, state) {
		var bs = flags.extra.bundleSubmit;
		var help = $author$project$Shared$Text$htmlTextLines(bs.labels.pause.description);
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('field is-horizontal ml-1')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-label is-normal')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help is-hidden-mobile')
												]),
											$author$project$Shared$Text$dropExtra(
												$author$project$Shared$Text$htmlBreaks(help)))
										])),
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('label ml-1')
												]),
											_List_fromArray(
												[
													$elm$html$Html$text(bs.labels.pause.label)
												]))
										]))
								]))
						])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-body')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help')
												]),
											help)
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('field'),
											A2($elm$html$Html$Attributes$style, 'display', 'table')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$div,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('checkbox'),
													A2($elm$html$Html$Attributes$style, 'display', 'table-cell'),
													A2($elm$html$Html$Attributes$style, 'vertical-align', 'middle')
												]),
											_List_fromArray(
												[
													A2(
													$elm$html$Html$input,
													_List_fromArray(
														[
															$elm$html$Html$Attributes$class('sp-checkbox mt-2'),
															$elm$html$Html$Attributes$type_('checkbox'),
															$elm$html$Html$Attributes$checked(state.pause),
															$elm$html$Html$Events$onCheck($author$project$Bundle$Model$UpdatePause)
														]),
													_List_Nil)
												]))
										]))
								])),
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field-label is-normal'),
									A2($elm$html$Html$Attributes$style, 'max-width', '5px')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$label,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('label')
										]),
									_List_Nil)
								]))
						]))
				]));
	});
var $author$project$Bundle$View$viewSectionTitle = F2(
	function (flags, state) {
		var loading = function (cls) {
			return _Utils_eq(state.result, $krisajenkins$remotedata$RemoteData$Loading) ? (cls + ' is-loading') : cls;
		};
		var enabled = A2($author$project$Bundle$View$okToSubmit, flags, state);
		var bs = flags.extra.bundleSubmit;
		return _List_fromArray(
			[
				A2(
				$elm$html$Html$h2,
				_List_Nil,
				_List_fromArray(
					[
						$elm$html$Html$text(bs.labels.title.label),
						A2(
						$elm$html$Html$button,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class(
								loading('button has-background-primary-dark has-text-white is-link is-pulled-right')),
								A2($elm$html$Html$Attributes$style, 'width', bs.labels.submit.width),
								$elm$html$Html$Attributes$disabled(!enabled),
								$elm$html$Html$Events$onClick($author$project$Bundle$Model$PressSubmit)
							]),
						_List_fromArray(
							[
								$elm$html$Html$text(bs.labels.submit.label)
							]))
					])),
				(flags.extra.mode === 'add') ? A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('is-flex')
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$div,
						_List_fromArray(
							[
								A2($elm$html$Html$Attributes$style, 'width', '24px'),
								A2($elm$html$Html$Attributes$style, 'min-width', '24px'),
								A2($elm$html$Html$Attributes$style, 'height', '24px'),
								$elm$html$Html$Events$onClick($author$project$Bundle$Model$ToggleOptionsExpanded)
							]),
						_List_fromArray(
							[
								$author$project$Shared$Expand$svgExpandCollapse(state.expanded)
							])),
						A2($author$project$Bundle$View$descOrError, flags, state)
					])) : A2($author$project$Bundle$View$descOrError, flags, state),
				state.expanded ? A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('sp-form m-3 py-3')
					]),
				_List_fromArray(
					[
						A2($author$project$Bundle$View$viewPause, flags, state)
					])) : A2($elm$html$Html$div, _List_Nil, _List_Nil)
			]);
	});
var $author$project$Bundle$View$view = F2(
	function (flags, state) {
		var _v0 = state.auth;
		if (_v0.$ === 'Success') {
			var auth = _v0.a;
			return (auth.mnum === 1) ? A2(
				$elm$html$Html$div,
				_List_Nil,
				A2($author$project$Bundle$View$viewSectionTitle, flags, state)) : A2($elm$html$Html$div, _List_Nil, _List_Nil);
		} else {
			return A2($elm$html$Html$div, _List_Nil, _List_Nil);
		}
	});
var $elm$html$Html$hr = _VirtualDom_node('hr');
var $author$project$Shared$Text$halfBreak = A2(
	$elm$html$Html$hr,
	_List_fromArray(
		[
			A2($elm$html$Html$Attributes$style, 'height', '0px'),
			A2($elm$html$Html$Attributes$style, 'visibility', 'hidden')
		]),
	_List_Nil);
var $author$project$BundleContents$Model$ChooseFile = {$: 'ChooseFile'};
var $author$project$BundleContents$View$viewChoose = F2(
	function (flags, state) {
		var help = (flags.mode === 'view') ? $author$project$Shared$Text$htmlTextLines(flags.labels.zipfile.updatedescription) : $author$project$Shared$Text$htmlTextLines(flags.labels.zipfile.description);
		return state.ishost ? A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('field is-horizontal')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-label is-normal')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help is-hidden-mobile')
												]),
											$author$project$Shared$Text$dropExtra(
												$author$project$Shared$Text$htmlBreaks(help)))
										])),
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('label ml-1')
												]),
											_List_fromArray(
												[
													$elm$html$Html$text(flags.labels.zipfile.label)
												]))
										]))
								]))
						])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-body')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help')
												]),
											help)
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('file has-name is-small')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('file-label')
												]),
											_List_fromArray(
												[
													A2(
													$elm$html$Html$input,
													_List_fromArray(
														[
															$elm$html$Html$Attributes$class('file-input'),
															$elm$html$Html$Attributes$type_('file'),
															$elm$html$Html$Attributes$id(state.eltId),
															A2(
															$elm$html$Html$Events$on,
															'change',
															$elm$json$Json$Decode$succeed($author$project$BundleContents$Model$ChooseFile))
														]),
													_List_Nil),
													A2(
													$elm$html$Html$span,
													_List_fromArray(
														[
															$elm$html$Html$Attributes$class('file-cta')
														]),
													_List_fromArray(
														[
															A2(
															$elm$html$Html$span,
															_List_fromArray(
																[
																	$elm$html$Html$Attributes$class('file-label')
																]),
															_List_fromArray(
																[
																	$elm$html$Html$text(flags.labels.choosefile.label)
																]))
														])),
													function () {
													var _v0 = state.name;
													if (_v0.$ === 'Just') {
														var name = _v0.a;
														return A2(
															$elm$html$Html$span,
															_List_fromArray(
																[
																	$elm$html$Html$Attributes$class('file-name')
																]),
															_List_fromArray(
																[
																	$elm$html$Html$text(name)
																]));
													} else {
														return A2($elm$html$Html$span, _List_Nil, _List_Nil);
													}
												}()
												]))
										]))
								])),
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field-label is-normal')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$label,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('label')
										]),
									_List_Nil)
								]))
						]))
				])) : A2($elm$html$Html$div, _List_Nil, _List_Nil);
	});
var $elm$html$Html$Attributes$colspan = function (n) {
	return A2(
		_VirtualDom_attribute,
		'colspan',
		$elm$core$String$fromInt(n));
};
var $author$project$BundleContents$Model$ChooseEntry = F2(
	function (a, b) {
		return {$: 'ChooseEntry', a: a, b: b};
	});
var $author$project$Shared$Text$folderChar = $elm$core$String$fromChar(
	_Utils_chr('📂'));
var $author$project$Shared$Text$fpad = F2(
	function (width, size) {
		return A2(
			$author$project$Shared$Text$pad,
			width,
			A2($author$project$Shared$Text$fsize, $author$project$Shared$Text$nbsp, size));
	});
var $author$project$BundleContents$View$viewDir = function (dir) {
	var padded = A2($author$project$Shared$Text$fpad, 10, dir.total | 0);
	var fstr = (!dir.folders) ? A2($author$project$Shared$Text$pad, 5, '-') : A2(
		$author$project$Shared$Text$pad,
		5,
		$elm$core$String$fromInt(dir.folders));
	return A2(
		$elm$html$Html$tr,
		_List_fromArray(
			[
				$elm$html$Html$Attributes$class('is-hoverable'),
				$elm$html$Html$Events$onClick(
				A2($author$project$BundleContents$Model$ChooseEntry, dir.dn, 0))
			]),
		_List_fromArray(
			[
				A2(
				$elm$html$Html$td,
				_List_fromArray(
					[
						A2($elm$html$Html$Attributes$attribute, 'data-label', $author$project$Shared$Text$folderChar)
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$div,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('is-hidden-mobile')
							]),
						_List_fromArray(
							[
								$elm$html$Html$text($author$project$Shared$Text$folderChar)
							]))
					])),
				A2(
				$elm$html$Html$td,
				_List_fromArray(
					[
						A2($elm$html$Html$Attributes$attribute, 'data-label', 'Name')
					]),
				_List_fromArray(
					[
						$elm$html$Html$text(dir.name)
					])),
				A2(
				$elm$html$Html$td,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('is-hidden-mobile')
					]),
				_List_fromArray(
					[
						$elm$html$Html$text($author$project$Shared$Text$nbsp)
					])),
				A2(
				$elm$html$Html$td,
				_List_fromArray(
					[
						A2($elm$html$Html$Attributes$attribute, 'data-label', 'Folders')
					]),
				_List_fromArray(
					[
						$elm$html$Html$text(fstr)
					])),
				A2(
				$elm$html$Html$td,
				_List_fromArray(
					[
						A2($elm$html$Html$Attributes$attribute, 'data-label', 'Total')
					]),
				_List_fromArray(
					[
						$elm$html$Html$text(padded)
					]))
			]));
};
var $author$project$BundleContents$View$viewDotDot = function (dn) {
	return A2(
		$elm$html$Html$tr,
		_List_fromArray(
			[
				$elm$html$Html$Attributes$class('is-hoverable'),
				$elm$html$Html$Events$onClick(
				A2($author$project$BundleContents$Model$ChooseEntry, dn, 0))
			]),
		_List_fromArray(
			[
				A2(
				$elm$html$Html$td,
				_List_fromArray(
					[
						A2($elm$html$Html$Attributes$attribute, 'data-label', $author$project$Shared$Text$upChar)
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$div,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('is-hidden-mobile')
							]),
						_List_fromArray(
							[
								$elm$html$Html$text($author$project$Shared$Text$upChar)
							]))
					])),
				A2(
				$elm$html$Html$td,
				_List_fromArray(
					[
						A2($elm$html$Html$Attributes$attribute, 'data-label', 'Name')
					]),
				_List_fromArray(
					[
						$elm$html$Html$text('..')
					])),
				A2(
				$elm$html$Html$td,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('is-hidden-mobile')
					]),
				_List_fromArray(
					[
						$elm$html$Html$text($author$project$Shared$Text$nbsp)
					])),
				A2(
				$elm$html$Html$td,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('is-hidden-mobile')
					]),
				_List_fromArray(
					[
						$elm$html$Html$text($author$project$Shared$Text$nbsp)
					])),
				A2(
				$elm$html$Html$td,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('is-hidden-mobile')
					]),
				_List_fromArray(
					[
						$elm$html$Html$text($author$project$Shared$Text$nbsp)
					]))
			]));
};
var $author$project$Shared$Text$fileChar = $elm$core$String$fromChar(
	_Utils_chr('📄'));
var $author$project$BundleContents$View$viewFile = function (file) {
	var padded = A2($author$project$Shared$Text$fpad, 10, file.size);
	return A2(
		$elm$html$Html$tr,
		_List_Nil,
		_List_fromArray(
			[
				A2(
				$elm$html$Html$td,
				_List_fromArray(
					[
						A2($elm$html$Html$Attributes$attribute, 'data-label', $author$project$Shared$Text$fileChar)
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$div,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('is-hidden-mobile')
							]),
						_List_fromArray(
							[
								$elm$html$Html$text($author$project$Shared$Text$fileChar)
							]))
					])),
				A2(
				$elm$html$Html$td,
				_List_fromArray(
					[
						A2($elm$html$Html$Attributes$attribute, 'data-label', 'Name')
					]),
				_List_fromArray(
					[
						$elm$html$Html$text(file.name)
					])),
				A2(
				$elm$html$Html$td,
				_List_fromArray(
					[
						A2($elm$html$Html$Attributes$attribute, 'data-label', 'Mime')
					]),
				_List_fromArray(
					[
						$elm$html$Html$text(file.mime)
					])),
				A2(
				$elm$html$Html$td,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('is-hidden-mobile')
					]),
				_List_fromArray(
					[
						$elm$html$Html$text($author$project$Shared$Text$nbsp)
					])),
				A2(
				$elm$html$Html$td,
				_List_fromArray(
					[
						A2($elm$html$Html$Attributes$attribute, 'data-label', 'Total')
					]),
				_List_fromArray(
					[
						$elm$html$Html$text(padded)
					]))
			]));
};
var $author$project$BundleContents$View$viewBody = F2(
	function (pn, entries) {
		var dotdot = (!entries.dn) ? _List_Nil : _List_fromArray(
			[
				$author$project$BundleContents$View$viewDotDot(entries.parent)
			]);
		return A2(
			$elm$html$Html$tbody,
			_List_Nil,
			_Utils_ap(
				dotdot,
				_Utils_ap(
					A2($elm$core$List$map, $author$project$BundleContents$View$viewDir, entries.dirs),
					A2($elm$core$List$map, $author$project$BundleContents$View$viewFile, entries.files))));
	});
var $elm$html$Html$section = _VirtualDom_node('section');
var $author$project$BundleContents$View$viewEmpty = F2(
	function (flags, entries) {
		return A2(
			$elm$html$Html$tbody,
			_List_Nil,
			_List_fromArray(
				[
					$author$project$BundleContents$View$viewDotDot(entries.parent),
					A2(
					$elm$html$Html$tr,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('is-empty')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$td,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$colspan(5)
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$section,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('section')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$div,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('content has-text-grey has-text-centered')
												]),
											_List_fromArray(
												[
													A2(
													$elm$html$Html$p,
													_List_Nil,
													_List_fromArray(
														[
															$elm$html$Html$text(flags.labels.noentries.label)
														]))
												]))
										]))
								]))
						]))
				]));
	});
var $author$project$BundleContents$View$viewPaginationButton = F3(
	function (dn, pn, idx) {
		var page = $elm$core$String$fromInt(idx + 1);
		return _Utils_eq(pn, idx) ? A2(
			$elm$html$Html$button,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$type_('button'),
					$elm$html$Html$Attributes$class('button is-active')
				]),
			_List_fromArray(
				[
					$elm$html$Html$text(page)
				])) : A2(
			$elm$html$Html$button,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$type_('button'),
					$elm$html$Html$Attributes$class('button'),
					$elm$html$Html$Events$onClick(
					A2($author$project$BundleContents$Model$ChooseEntry, dn, idx))
				]),
			_List_fromArray(
				[
					$elm$html$Html$text(page)
				]));
	});
var $author$project$BundleContents$View$viewPagination = F4(
	function (flags, npages, pn, entries) {
		var page_ = flags.labels.page.label + ' ';
		var of_ = ' ' + (flags.labels.of_.label + ' ');
		if (npages === 1) {
			return A2($elm$html$Html$div, _List_Nil, _List_Nil);
		} else {
			return A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('notification')
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$div,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('level')
							]),
						_List_fromArray(
							[
								A2(
								$elm$html$Html$div,
								_List_fromArray(
									[
										$elm$html$Html$Attributes$class('level-left')
									]),
								_List_fromArray(
									[
										A2(
										$elm$html$Html$div,
										_List_fromArray(
											[
												$elm$html$Html$Attributes$class('level-item')
											]),
										_List_fromArray(
											[
												A2(
												$elm$html$Html$div,
												_List_fromArray(
													[
														$elm$html$Html$Attributes$class('buttons has-addons')
													]),
												A2(
													$elm$core$List$map,
													A2($author$project$BundleContents$View$viewPaginationButton, entries.dn, pn),
													A2($elm$core$List$range, 0, npages - 1)))
											]))
									])),
								A2(
								$elm$html$Html$div,
								_List_fromArray(
									[
										$elm$html$Html$Attributes$class('level-right')
									]),
								_List_fromArray(
									[
										A2(
										$elm$html$Html$div,
										_List_fromArray(
											[
												$elm$html$Html$Attributes$class('level-item')
											]),
										_List_fromArray(
											[
												A2(
												$elm$html$Html$small,
												_List_Nil,
												_List_fromArray(
													[
														$elm$html$Html$text(
														_Utils_ap(
															page_,
															_Utils_ap(
																$elm$core$String$fromInt(pn + 1),
																_Utils_ap(
																	of_,
																	$elm$core$String$fromInt(npages)))))
													]))
											]))
									]))
							]))
					]));
		}
	});
var $author$project$BundleContents$View$viewEntries = F5(
	function (flags, state, npages, pn, entries) {
		var totalpad = function () {
			var _v0 = $elm$core$String$toInt(flags.labels.total.pad);
			if (_v0.$ === 'Nothing') {
				return 8;
			} else {
				var value = _v0.a;
				return value;
			}
		}();
		var count = $elm$core$List$length(entries.dirs) + $elm$core$List$length(entries.files);
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('field mt-0 pt-0')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('ml-2 mr-2')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('b-table has-pagination')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('table-wrapper has-mobile-cards')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$table,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('table is-fullwidth is-hoverable')
												]),
											_List_fromArray(
												[
													A2(
													$elm$html$Html$thead,
													_List_Nil,
													_List_fromArray(
														[
															A2(
															$elm$html$Html$tr,
															_List_Nil,
															_List_fromArray(
																[
																	A2(
																	$elm$html$Html$th,
																	_List_fromArray(
																		[
																			$elm$html$Html$Attributes$colspan(5),
																			A2($elm$html$Html$Attributes$style, 'border-bottom', '0px')
																		]),
																	_List_fromArray(
																		[
																			$elm$html$Html$text(flags.labels.path.label + (': ' + state.path))
																		]))
																])),
															A2(
															$elm$html$Html$tr,
															_List_Nil,
															_List_fromArray(
																[
																	A2(
																	$elm$html$Html$th,
																	_List_fromArray(
																		[
																			A2($elm$html$Html$Attributes$style, 'width', '5%')
																		]),
																	_List_Nil),
																	A2(
																	$elm$html$Html$th,
																	_List_Nil,
																	_List_fromArray(
																		[
																			$elm$html$Html$text('Name')
																		])),
																	A2(
																	$elm$html$Html$th,
																	_List_fromArray(
																		[
																			A2($elm$html$Html$Attributes$style, 'width', '20%')
																		]),
																	_List_fromArray(
																		[
																			$elm$html$Html$text(flags.labels.mime.label)
																		])),
																	A2(
																	$elm$html$Html$th,
																	_List_fromArray(
																		[
																			A2($elm$html$Html$Attributes$style, 'width', '8%')
																		]),
																	_List_fromArray(
																		[
																			$elm$html$Html$text(flags.labels.folders.label)
																		])),
																	A2(
																	$elm$html$Html$th,
																	_List_fromArray(
																		[
																			A2($elm$html$Html$Attributes$style, 'width', '12%')
																		]),
																	_List_fromArray(
																		[
																			$elm$html$Html$text(
																			A2($author$project$Shared$Text$pad, totalpad, flags.labels.total.label))
																		]))
																]))
														])),
													(count > 0) ? A2($author$project$BundleContents$View$viewBody, pn, entries) : A2($author$project$BundleContents$View$viewEmpty, flags, entries)
												]))
										])),
									A4($author$project$BundleContents$View$viewPagination, flags, npages, pn, entries)
								]))
						]))
				]));
	});
var $author$project$BundleContents$View$viewError = function (msg) {
	return A2(
		$elm$html$Html$tr,
		_List_fromArray(
			[
				$elm$html$Html$Attributes$class('is-hoverable')
			]),
		_List_fromArray(
			[
				A2(
				$elm$html$Html$td,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('is-hidden-mobile')
					]),
				_List_fromArray(
					[
						$elm$html$Html$text($author$project$Shared$Text$nbsp)
					])),
				A2(
				$elm$html$Html$td,
				_List_fromArray(
					[
						A2($elm$html$Html$Attributes$attribute, 'data-label', 'Detail')
					]),
				_List_fromArray(
					[
						$elm$html$Html$text(msg)
					])),
				A2(
				$elm$html$Html$td,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('is-hidden-mobile')
					]),
				_List_fromArray(
					[
						$elm$html$Html$text($author$project$Shared$Text$nbsp)
					])),
				A2(
				$elm$html$Html$td,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('is-hidden-mobile')
					]),
				_List_fromArray(
					[
						$elm$html$Html$text($author$project$Shared$Text$nbsp)
					]))
			]));
};
var $author$project$BundleContents$View$viewSettingsError = function (s) {
	var pathAttr = function (atts) {
		var _v2 = s.path;
		if (_v2.$ === 'Nothing') {
			return _Utils_ap(
				atts,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('is-hidden-mobile')
					]));
		} else {
			return atts;
		}
	};
	var funcAttr = function (atts) {
		var _v1 = s.what;
		if (_v1.$ === 'Nothing') {
			return _Utils_ap(
				atts,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('is-hidden-mobile')
					]));
		} else {
			return atts;
		}
	};
	var dfltAttr = function (atts) {
		var _v0 = s.dflt;
		if (_v0.$ === 'Nothing') {
			return _Utils_ap(
				atts,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('is-hidden-mobile')
					]));
		} else {
			return atts;
		}
	};
	return A2(
		$elm$html$Html$tr,
		_List_Nil,
		_List_fromArray(
			[
				A2(
				$elm$html$Html$td,
				funcAttr(
					_List_fromArray(
						[
							A2($elm$html$Html$Attributes$attribute, 'data-label', 'Function'),
							$elm$html$Html$Attributes$class('has-text-weight-bold')
						])),
				_List_fromArray(
					[
						$elm$html$Html$text(
						$author$project$Shared$Text$maybeText(s.what))
					])),
				A2(
				$elm$html$Html$td,
				_List_fromArray(
					[
						A2($elm$html$Html$Attributes$attribute, 'data-label', 'Detail')
					]),
				_List_fromArray(
					[
						$elm$html$Html$text(s.detail)
					])),
				A2(
				$elm$html$Html$td,
				pathAttr(
					_List_fromArray(
						[
							A2($elm$html$Html$Attributes$attribute, 'data-label', 'Path')
						])),
				_List_fromArray(
					[
						$elm$html$Html$text(
						$author$project$Shared$Text$maybeText(s.path))
					])),
				A2(
				$elm$html$Html$td,
				dfltAttr(
					_List_fromArray(
						[
							A2($elm$html$Html$Attributes$attribute, 'data-label', 'Dflt')
						])),
				_List_fromArray(
					[
						$elm$html$Html$text(
						$author$project$Shared$Text$maybeText(s.dflt))
					]))
			]));
};
var $author$project$BundleContents$View$viewErrors = F2(
	function (flags, state) {
		var errors = _Utils_ap(
			$elm$core$List$reverse(
				A2($elm$core$List$map, $author$project$BundleContents$View$viewError, state.problems.errors)),
			$elm$core$List$reverse(
				A2($elm$core$List$map, $author$project$BundleContents$View$viewSettingsError, state.problems.settingsErrors)));
		var count = $elm$core$List$length(state.problems.errors) + $elm$core$List$length(state.problems.settingsErrors);
		return (count < 1) ? A2($elm$html$Html$div, _List_Nil, _List_Nil) : A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('field mt-0 pt-0')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('ml-2 mr-2')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$p,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('has-text-danger')
								]),
							_List_fromArray(
								[
									$elm$html$Html$text(flags.errors.settings.problems)
								])),
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('b-table')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('table-wrapper has-mobile-cards')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$table,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('table is-fullwidth is-hoverable')
												]),
											_List_fromArray(
												[
													A2(
													$elm$html$Html$thead,
													_List_Nil,
													_List_fromArray(
														[
															A2(
															$elm$html$Html$tr,
															_List_Nil,
															_List_fromArray(
																[
																	A2(
																	$elm$html$Html$th,
																	_List_fromArray(
																		[
																			A2($elm$html$Html$Attributes$style, 'width', '8%')
																		]),
																	_List_fromArray(
																		[
																			$elm$html$Html$text(flags.labels._function.label)
																		])),
																	A2(
																	$elm$html$Html$th,
																	_List_Nil,
																	_List_fromArray(
																		[
																			$elm$html$Html$text(flags.labels.detail.label)
																		])),
																	A2(
																	$elm$html$Html$th,
																	_List_Nil,
																	_List_fromArray(
																		[
																			$elm$html$Html$text(flags.labels.path.label)
																		])),
																	A2(
																	$elm$html$Html$th,
																	_List_Nil,
																	_List_fromArray(
																		[
																			$elm$html$Html$text(flags.labels.dflt.label)
																		]))
																]))
														])),
													A2($elm$html$Html$tbody, _List_Nil, errors)
												]))
										]))
								]))
						]))
				]));
	});
var $author$project$BundleContents$Model$PressDownload = {$: 'PressDownload'};
var $author$project$BundleContents$View$viewSectionTitle = F3(
	function (flags, state, enabled) {
		var desc_or_error = (!enabled) ? A2(
			$elm$html$Html$p,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('has-text-danger ml-1')
				]),
			_List_fromArray(
				[
					$elm$html$Html$text(flags.labels.download.restricted)
				])) : A2(
			$elm$html$Html$p,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('ml-1')
				]),
			_List_fromArray(
				[
					$elm$html$Html$text(flags.labels.description.label)
				]));
		var button = function () {
			var _v0 = state.name;
			if (_v0.$ === 'Just') {
				var filename = _v0.a;
				return A2(
					$elm$html$Html$button,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('button has-background-primary-dark has-text-white is-link is-pulled-right'),
							A2($elm$html$Html$Attributes$style, 'width', flags.labels.download.width),
							$elm$html$Html$Attributes$disabled(!enabled),
							$elm$html$Html$Events$onClick($author$project$BundleContents$Model$PressDownload)
						]),
					_List_fromArray(
						[
							$elm$html$Html$text(flags.labels.download.label)
						]));
			} else {
				return A2($elm$html$Html$div, _List_Nil, _List_Nil);
			}
		}();
		return A2(
			$elm$html$Html$div,
			_List_Nil,
			_List_fromArray(
				[
					A2(
					$elm$html$Html$h2,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('mt-0')
						]),
					_List_fromArray(
						[
							$elm$html$Html$text(flags.labels.title.label),
							button
						])),
					desc_or_error
				]));
	});
var $author$project$BundleContents$Model$ApplySettings = {$: 'ApplySettings'};
var $author$project$BundleContents$Model$DefaultSettings = {$: 'DefaultSettings'};
var $author$project$BundleContents$Model$ResetSettings = {$: 'ResetSettings'};
var $author$project$BundleContents$Model$ToggleExpanded = {$: 'ToggleExpanded'};
var $author$project$BundleContents$Model$UpdateLimit = function (a) {
	return {$: 'UpdateLimit', a: a};
};
var $author$project$BundleContents$Model$UpdatePageSize = function (a) {
	return {$: 'UpdatePageSize', a: a};
};
var $author$project$BundleContents$View$viewSettings = F2(
	function (flags, state) {
		var _v0 = _Utils_Tuple2(state.ishost, state.name);
		if (_v0.a && (_v0.b.$ === 'Just')) {
			var filename = _v0.b.a;
			return A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('media mt-2 mb-2')
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$div,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('media-left mr-1'),
								A2($elm$html$Html$Attributes$style, 'width', '24px'),
								A2($elm$html$Html$Attributes$style, 'min-width', '24px'),
								A2($elm$html$Html$Attributes$style, 'height', '24px'),
								$elm$html$Html$Events$onClick($author$project$BundleContents$Model$ToggleExpanded)
							]),
						_List_fromArray(
							[
								$author$project$Shared$Expand$svgExpandCollapse(state.expanded)
							])),
						function () {
						if (!state.expanded) {
							return A2(
								$elm$html$Html$div,
								_List_fromArray(
									[
										$elm$html$Html$Attributes$class('media-content')
									]),
								_List_fromArray(
									[
										A2(
										$elm$html$Html$h3,
										_List_fromArray(
											[
												$elm$html$Html$Attributes$class('mb-3')
											]),
										_List_fromArray(
											[
												$elm$html$Html$text(flags.labels.settings.label)
											])),
										A3(
										$elm$html$Html$node,
										'style',
										_List_Nil,
										_List_fromArray(
											[
												$elm$html$Html$text('#jsp, #settings-help { display: none; }')
											]))
									]));
						} else {
							var resetButton = (flags.mode === 'view') ? _List_fromArray(
								[
									A2(
									$elm$html$Html$button,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('button has-background-primary-dark has-text-white is-small'),
											$elm$html$Html$Events$onClick($author$project$BundleContents$Model$ResetSettings)
										]),
									_List_fromArray(
										[
											$elm$html$Html$text(flags.labels.reset.label)
										])),
									$elm$html$Html$text(
									A2($elm$core$String$repeat, 5, $author$project$Shared$Text$nbsp))
								]) : _List_Nil;
							var errorLimit = _List_fromArray(
								[
									A2(
									$elm$html$Html$span,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('is-size-7')
										]),
									_List_fromArray(
										[
											$elm$html$Html$text(flags.labels.limit.label)
										])),
									$elm$html$Html$text($author$project$Shared$Text$nbsp),
									A2(
									$elm$html$Html$input,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('input is-small'),
											A2($elm$html$Html$Attributes$style, 'max-width', flags.labels.limit.maxwidth),
											$elm$html$Html$Attributes$type_('text'),
											$elm$html$Html$Attributes$value(
											$elm$core$String$fromInt(state.limit)),
											$elm$html$Html$Events$onInput($author$project$BundleContents$Model$UpdateLimit)
										]),
									_List_Nil),
									$elm$html$Html$text(
									A2($elm$core$String$repeat, 4, $author$project$Shared$Text$nbsp))
								]);
							var entriesPerPage = _List_fromArray(
								[
									A2(
									$elm$html$Html$span,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('is-size-7')
										]),
									_List_fromArray(
										[
											$elm$html$Html$text(flags.labels.pagesize.label)
										])),
									$elm$html$Html$text($author$project$Shared$Text$nbsp),
									A2(
									$elm$html$Html$input,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('input is-small'),
											A2($elm$html$Html$Attributes$style, 'max-width', flags.labels.pagesize.maxwidth),
											$elm$html$Html$Attributes$type_('text'),
											$elm$html$Html$Attributes$value(
											$elm$core$String$fromInt(state.pagesize)),
											$elm$html$Html$Events$onInput($author$project$BundleContents$Model$UpdatePageSize)
										]),
									_List_Nil)
								]);
							var defaultButton = _List_fromArray(
								[
									A2(
									$elm$html$Html$button,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('button has-background-primary-dark has-text-white is-small'),
											$elm$html$Html$Events$onClick($author$project$BundleContents$Model$DefaultSettings)
										]),
									_List_fromArray(
										[
											$elm$html$Html$text(flags.labels._default.label)
										])),
									$elm$html$Html$text(
									A2($elm$core$String$repeat, 5, $author$project$Shared$Text$nbsp))
								]);
							var applyButton = _List_fromArray(
								[
									A2(
									$elm$html$Html$button,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('button has-background-primary-dark has-text-white is-small'),
											$elm$html$Html$Events$onClick($author$project$BundleContents$Model$ApplySettings)
										]),
									_List_fromArray(
										[
											$elm$html$Html$text(flags.labels.apply.label)
										])),
									$elm$html$Html$text(
									A2($elm$core$String$repeat, 5, $author$project$Shared$Text$nbsp))
								]);
							return A2(
								$elm$html$Html$div,
								_List_fromArray(
									[
										$elm$html$Html$Attributes$class('media-content')
									]),
								_List_fromArray(
									[
										A2(
										$elm$html$Html$h3,
										_List_fromArray(
											[
												$elm$html$Html$Attributes$class('mb-3')
											]),
										_List_fromArray(
											[
												$elm$html$Html$text(flags.labels.settings.label)
											])),
										A2(
										$elm$html$Html$div,
										_List_Nil,
										_List_fromArray(
											[
												$elm$html$Html$text(flags.labels.settings.description)
											])),
										A2(
										$elm$html$Html$div,
										_List_fromArray(
											[
												$elm$html$Html$Attributes$class('sp-form p-3 mt-1 mr-2')
											]),
										_Utils_ap(
											_List_Nil,
											_Utils_ap(
												applyButton,
												_Utils_ap(
													resetButton,
													_Utils_ap(
														defaultButton,
														_Utils_ap(errorLimit, entriesPerPage)))))),
										A3(
										$elm$html$Html$node,
										'style',
										_List_Nil,
										_List_fromArray(
											[
												$elm$html$Html$text('#jsp, #settings-help { display: block; }')
											]))
									]));
						}
					}()
					]));
		} else {
			return A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('media mt-2')
					]),
				_List_fromArray(
					[
						A3(
						$elm$html$Html$node,
						'style',
						_List_Nil,
						_List_fromArray(
							[
								$elm$html$Html$text('#jsp, #settings-help { display: none; }')
							]))
					]));
		}
	});
var $author$project$BundleContents$View$view = F3(
	function (flags, state, enable_download) {
		var divcls = state.ishost ? _List_fromArray(
			[
				$elm$html$Html$Attributes$class('sp-form m-3')
			]) : _List_fromArray(
			[
				$elm$html$Html$Attributes$class('m-0')
			]);
		var count = $elm$core$List$length(state.problems.errors) + $elm$core$List$length(state.problems.settingsErrors);
		var _v0 = state.latest;
		switch (_v0.$) {
			case 'Failure':
				var msg = _v0.a;
				return A2(
					$elm$html$Html$div,
					_List_Nil,
					_List_fromArray(
						[
							A3($author$project$BundleContents$View$viewSectionTitle, flags, state, enable_download),
							A2(
							$elm$html$Html$div,
							divcls,
							_List_fromArray(
								[
									$elm$html$Html$text(msg),
									A2($author$project$BundleContents$View$viewChoose, flags, state),
									A2($author$project$BundleContents$View$viewErrors, flags, state),
									$author$project$Shared$Text$halfBreak
								])),
							A2($author$project$BundleContents$View$viewSettings, flags, state)
						]));
			case 'Success':
				var npages = _v0.a.npages;
				var pn = _v0.a.pn;
				var entries = _v0.a.entries;
				return (count < 1) ? A2(
					$elm$html$Html$div,
					_List_Nil,
					_List_fromArray(
						[
							A3($author$project$BundleContents$View$viewSectionTitle, flags, state, enable_download),
							A2(
							$elm$html$Html$div,
							divcls,
							_List_fromArray(
								[
									A2($author$project$BundleContents$View$viewChoose, flags, state),
									A5($author$project$BundleContents$View$viewEntries, flags, state, npages, pn, entries),
									A2(
									$elm$html$Html$br,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('is-hidden-mobile')
										]),
									_List_Nil)
								])),
							A2($author$project$BundleContents$View$viewSettings, flags, state)
						])) : A2(
					$elm$html$Html$div,
					_List_Nil,
					_List_fromArray(
						[
							A3($author$project$BundleContents$View$viewSectionTitle, flags, state, enable_download),
							A2(
							$elm$html$Html$div,
							divcls,
							_List_fromArray(
								[
									A2($author$project$BundleContents$View$viewChoose, flags, state),
									A2($author$project$BundleContents$View$viewErrors, flags, state),
									$author$project$Shared$Text$halfBreak
								])),
							A2($author$project$BundleContents$View$viewSettings, flags, state)
						]));
			default:
				return A2(
					$elm$html$Html$div,
					_List_Nil,
					_List_fromArray(
						[
							A3($author$project$BundleContents$View$viewSectionTitle, flags, state, enable_download),
							A2(
							$elm$html$Html$div,
							divcls,
							_List_fromArray(
								[
									A2($author$project$BundleContents$View$viewChoose, flags, state),
									A2($author$project$BundleContents$View$viewErrors, flags, state),
									A2(
									$elm$html$Html$br,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('is-hidden-mobile')
										]),
									_List_Nil)
								])),
							A2($author$project$BundleContents$View$viewSettings, flags, state)
						]));
		}
	});
var $author$project$BundleDetails$View$isEditable = function (state) {
	return state.ishost ? true : false;
};
var $author$project$BundleDetails$Model$UpdateDescription = function (a) {
	return {$: 'UpdateDescription', a: a};
};
var $author$project$BundleDetails$View$viewDescription = F2(
	function (flags, state) {
		var reset = function () {
			var _v0 = state.initial;
			if (_v0.$ === 'Just') {
				var initial = _v0.a;
				return (!_Utils_eq(initial.description, state.current.description)) ? _List_fromArray(
					[
						A2(
						$elm$html$Html$button,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('sp-icon is-right'),
								$elm$html$Html$Events$onClick(
								$author$project$BundleDetails$Model$UpdateDescription(initial.description))
							]),
						_List_fromArray(
							[
								$elm$html$Html$text($author$project$Shared$Text$greenX)
							]))
					]) : _List_Nil;
			} else {
				return _List_Nil;
			}
		}();
		var noteditable = !$author$project$BundleDetails$View$isEditable(state);
		var help = $author$project$Shared$Text$htmlTextLines(flags.labels.description.description);
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('field is-horizontal')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-label is-normal')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									noteditable ? _List_Nil : _List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help is-hidden-mobile')
												]),
											$author$project$Shared$Text$dropExtra(
												$author$project$Shared$Text$htmlBreaks(help)))
										])),
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('label ml-1')
												]),
											_List_fromArray(
												[
													$elm$html$Html$text(flags.labels.description.label)
												]))
										]))
								]))
						])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-body')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									noteditable ? _List_Nil : _List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help')
												]),
											help)
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('control has-icons-right')
										]),
									_Utils_ap(
										_List_fromArray(
											[
												A2(
												$elm$html$Html$textarea,
												_Utils_ap(
													_List_fromArray(
														[
															$elm$html$Html$Attributes$class('textarea'),
															$elm$html$Html$Attributes$rows(5),
															$elm$html$Html$Attributes$readonly(noteditable),
															$elm$html$Html$Attributes$value(state.current.description),
															$elm$html$Html$Events$onInput($author$project$BundleDetails$Model$UpdateDescription)
														]),
													A2($author$project$Shared$Text$placeholder, flags.labels.description.placeholder, noteditable)),
												_List_Nil)
											]),
										reset))
								])),
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field-label is-normal'),
									A2($elm$html$Html$Attributes$style, 'max-width', '5px')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$label,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('label')
										]),
									_List_Nil)
								]))
						]))
				]));
	});
var $author$project$BundleDetails$ViewError$viewNameError = F2(
	function (flags, state) {
		var _v0 = state.problems.nameErr;
		if (_v0.$ === 'Just') {
			var reason = _v0.a;
			return A2(
				$elm$html$Html$div,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('help is-danger')
					]),
				_List_fromArray(
					[
						A2(
						$elm$html$Html$p,
						_List_Nil,
						$author$project$Shared$Text$htmlTextLines(reason))
					]));
		} else {
			return A2($elm$html$Html$div, _List_Nil, _List_Nil);
		}
	});
var $author$project$BundleDetails$View$viewName = F2(
	function (flags, state) {
		var reset = function () {
			var _v0 = state.initial;
			if (_v0.$ === 'Just') {
				var initial = _v0.a;
				return (!_Utils_eq(initial.name, state.current.name)) ? _List_fromArray(
					[
						A2(
						$elm$html$Html$button,
						_List_fromArray(
							[
								$elm$html$Html$Attributes$class('sp-icon is-right'),
								$elm$html$Html$Events$onClick(
								$author$project$BundleDetails$Model$UpdateName(initial.name))
							]),
						_List_fromArray(
							[
								$elm$html$Html$text($author$project$Shared$Text$greenX)
							]))
					]) : _List_Nil;
			} else {
				return _List_Nil;
			}
		}();
		var noteditable = !$author$project$BundleDetails$View$isEditable(state);
		var help = $author$project$Shared$Text$htmlTextLines(flags.labels.name.description);
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('field is-horizontal')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-label is-normal')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									noteditable ? _List_Nil : _List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help is-hidden-mobile')
												]),
											$author$project$Shared$Text$dropExtra(
												$author$project$Shared$Text$htmlBreaks(help)))
										])),
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class(
													A3($author$project$Shared$Text$has_danger, 'label ml-1', state.problems.nameErr, noteditable))
												]),
											_List_fromArray(
												[
													$elm$html$Html$text(flags.labels.name.label)
												]))
										]))
								]))
						])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-body')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									noteditable ? _List_Nil : _List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help')
												]),
											help)
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('field')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$div,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('control has-icons-right')
												]),
											_Utils_ap(
												_List_fromArray(
													[
														A2(
														$elm$html$Html$input,
														_Utils_ap(
															_List_fromArray(
																[
																	$elm$html$Html$Attributes$class(
																	A3($author$project$Shared$Text$is_danger, 'input', state.problems.nameErr, noteditable)),
																	$elm$html$Html$Attributes$type_('text'),
																	$elm$html$Html$Attributes$readonly(noteditable),
																	$elm$html$Html$Attributes$value(state.current.name),
																	$elm$html$Html$Events$onInput($author$project$BundleDetails$Model$UpdateName)
																]),
															A2($author$project$Shared$Text$placeholder, flags.labels.name.placeholder, noteditable)),
														_List_Nil)
													]),
												reset))
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('field')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$div,
											_List_Nil,
											_List_fromArray(
												[
													A2(
													$elm$html$Html$div,
													_List_Nil,
													_List_fromArray(
														[
															A2($author$project$BundleDetails$ViewError$viewNameError, flags, state)
														]))
												]))
										]))
								])),
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									noteditable ? _List_Nil : _List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help is-hidden-mobile')
												]),
											$author$project$Shared$Text$dropExtra(
												$author$project$Shared$Text$htmlBreaks(help)))
										])),
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('label ml-1 mt-1 mr-1')
												]),
											_List_fromArray(
												[
													$elm$html$Html$text('Icon')
												]))
										]))
								])),
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									noteditable ? _List_Nil : _List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('help is-hidden-mobile')
												]),
											$author$project$Shared$Text$dropExtra(
												$author$project$Shared$Text$htmlBreaks(help)))
										])),
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('control mt-1 ml-2')
										]),
									_List_fromArray(
										[
											A2($author$project$Shared$Icon$roundIcon, 24, state.current.name)
										]))
								]))
						]))
				]));
	});
var $author$project$BundleDetails$Model$UpdateRestricted = function (a) {
	return {$: 'UpdateRestricted', a: a};
};
var $author$project$BundleDetails$View$viewRestricted = F2(
	function (flags, state) {
		var noteditable = !$author$project$BundleDetails$View$isEditable(state);
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('field is-horizontal')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-label is-normal')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_Nil,
									_List_fromArray(
										[
											A2(
											$elm$html$Html$label,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('label ml-1')
												]),
											_List_fromArray(
												[
													$elm$html$Html$text(flags.labels.restricted.label)
												]))
										]))
								]))
						])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('field-body')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field'),
									A2($elm$html$Html$Attributes$style, 'display', 'table')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('checkbox'),
											A2($elm$html$Html$Attributes$style, 'display', 'table-cell'),
											A2($elm$html$Html$Attributes$style, 'vertical-align', 'middle')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$input,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('sp-checkbox ml-2 mt-2'),
													$elm$html$Html$Attributes$type_('checkbox'),
													$elm$html$Html$Attributes$disabled(noteditable),
													$elm$html$Html$Attributes$checked(state.current.restricted),
													$elm$html$Html$Events$onCheck($author$project$BundleDetails$Model$UpdateRestricted)
												]),
											_List_Nil)
										]))
								])),
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field-label is-normal'),
									A2($elm$html$Html$Attributes$style, 'max-width', '5px')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$label,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('label')
										]),
									_List_Nil)
								]))
						]))
				]));
	});
var $author$project$BundleDetails$View$view = F2(
	function (flags, state) {
		var restricted = _List_fromArray(
			[
				A2($author$project$BundleDetails$View$viewRestricted, flags, state)
			]);
		var name = _List_fromArray(
			[
				A2($author$project$BundleDetails$View$viewName, flags, state)
			]);
		var divcls = $author$project$BundleDetails$View$isEditable(state) ? _List_fromArray(
			[
				$elm$html$Html$Attributes$class('sp-form m-3')
			]) : _List_fromArray(
			[
				$elm$html$Html$Attributes$class('m-0')
			]);
		var desc = _List_fromArray(
			[
				A2($author$project$BundleDetails$View$viewDescription, flags, state)
			]);
		var br = _List_fromArray(
			[
				A2(
				$elm$html$Html$br,
				_List_fromArray(
					[
						$elm$html$Html$Attributes$class('is-hidden-mobile')
					]),
				_List_Nil)
			]);
		return A2(
			$elm$html$Html$div,
			divcls,
			_Utils_ap(
				br,
				_Utils_ap(
					name,
					_Utils_ap(
						desc,
						_Utils_ap(restricted, br)))));
	});
var $author$project$BundleMembers$Model$UpdateShared = F2(
	function (a, b) {
		return {$: 'UpdateShared', a: a, b: b};
	});
var $author$project$BundleMembers$View$acceptedTag = F2(
	function (flags, more) {
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					A2($elm$html$Html$Attributes$style, 'width', '24px'),
					A2($elm$html$Html$Attributes$style, 'height', '24px'),
					A2($elm$html$Html$Attributes$style, 'transform', 'translate(0px, -2px)')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$span,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('tag is-info px-2 ' + more)
						]),
					_List_fromArray(
						[
							$elm$html$Html$text(flags.labels.accepted.value)
						]))
				]));
	});
var $author$project$BundleMembers$View$viewMember = F4(
	function (flags, state, details, _v0) {
		var mnum = _v0.a;
		var profile = _v0.b;
		var shared = A2($elm$core$List$member, mnum, details.current.shared_with);
		var picture = A2($author$project$Shared$Icon$squareIcon, 24, profile.initials);
		var picmon = A2(
			$elm$html$Html$div,
			_List_Nil,
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('sp-floatleft mr-2')
						]),
					_List_fromArray(
						[picture])),
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('sp-floatleft')
						]),
					_List_fromArray(
						[
							$elm$html$Html$text(profile.moniker)
						]))
				]));
		var note = function () {
			var _v1 = A2($elm$core$Dict$get, mnum, state.notes);
			if (_v1.$ === 'Just') {
				var notestr = _v1.a;
				return notestr;
			} else {
				return '-';
			}
		}();
		var checkbox = state.ishost ? A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('checkbox')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$input,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('sp-checkbox'),
							$elm$html$Html$Attributes$type_('checkbox'),
							$elm$html$Html$Attributes$checked(shared),
							$elm$html$Html$Events$onCheck(
							$author$project$BundleMembers$Model$UpdateShared(mnum))
						]),
					_List_Nil)
				])) : A2($elm$html$Html$div, _List_Nil, _List_Nil);
		var accepted_tag = (!_Utils_eq(
			profile.accepted_on,
			$elm$time$Time$millisToPosix(0))) ? _List_fromArray(
			[
				A2($author$project$BundleMembers$View$acceptedTag, flags, '')
			]) : _List_Nil;
		return A2(
			$elm$html$Html$tr,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('is-hoverable')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$td,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('px-1 is-checkbox-cell')
						]),
					_List_fromArray(
						[checkbox])),
					A2(
					$elm$html$Html$td,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('px-1'),
							A2($elm$html$Html$Attributes$attribute, 'data-label', flags.labels.who.label)
						]),
					_List_fromArray(
						[picmon])),
					A2(
					$elm$html$Html$td,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('px-1'),
							A2($elm$html$Html$Attributes$attribute, 'data-label', flags.labels.accepted.datalabel)
						]),
					accepted_tag),
					A2(
					$elm$html$Html$td,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('px-1'),
							A2($elm$html$Html$Attributes$attribute, 'data-label', flags.labels.title.label)
						]),
					_List_fromArray(
						[
							$elm$html$Html$text(profile.title)
						])),
					A2(
					$elm$html$Html$td,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('px-1'),
							A2($elm$html$Html$Attributes$attribute, 'data-label', flags.labels.note.label)
						]),
					_List_fromArray(
						[
							$elm$html$Html$text(note)
						]))
				]));
	});
var $author$project$BundleMembers$View$viewBundleMembers = F3(
	function (flags, state, details) {
		var excepthost = A2(
			$elm$core$List$filter,
			function (_v1) {
				var n = _v1.a;
				var p = _v1.b;
				return n !== 1;
			},
			$elm$core$Dict$toList(state.profiles));
		var members = state.ishost ? excepthost : A2(
			$elm$core$List$filter,
			function (_v0) {
				var n = _v0.a;
				var p = _v0.b;
				return A2($elm$core$List$member, n, details.current.shared_with);
			},
			excepthost);
		var viewmembers = A2(
			$elm$core$List$map,
			A3($author$project$BundleMembers$View$viewMember, flags, state, details),
			members);
		return A2(
			$elm$html$Html$div,
			_List_fromArray(
				[
					$elm$html$Html$Attributes$class('field mt-0 pt-0')
				]),
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('mx-2')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('b-table')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('table-wrapper has-mobile-cards')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$table,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('table is-fullwidth is-hoverable')
												]),
											_List_fromArray(
												[
													A2(
													$elm$html$Html$thead,
													_List_Nil,
													_List_fromArray(
														[
															A2(
															$elm$html$Html$tr,
															_List_Nil,
															_List_fromArray(
																[
																	A2(
																	$elm$html$Html$th,
																	_List_fromArray(
																		[
																			A2($elm$html$Html$Attributes$style, 'width', flags.labels.checkbox.width)
																		]),
																	_List_Nil),
																	A2(
																	$elm$html$Html$th,
																	_List_fromArray(
																		[
																			A2($elm$html$Html$Attributes$style, 'width', flags.labels.who.width)
																		]),
																	_List_fromArray(
																		[
																			$elm$html$Html$text(flags.labels.who.label)
																		])),
																	A2(
																	$elm$html$Html$th,
																	_List_fromArray(
																		[
																			A2($elm$html$Html$Attributes$style, 'width', flags.labels.accepted.width)
																		]),
																	_List_Nil),
																	A2(
																	$elm$html$Html$th,
																	_List_fromArray(
																		[
																			A2($elm$html$Html$Attributes$style, 'width', flags.labels.title.width)
																		]),
																	_List_fromArray(
																		[
																			$elm$html$Html$text(flags.labels.title.label)
																		])),
																	A2(
																	$elm$html$Html$th,
																	_List_fromArray(
																		[
																			A2($elm$html$Html$Attributes$style, 'width', flags.labels.note.width)
																		]),
																	_List_fromArray(
																		[
																			$elm$html$Html$text(flags.labels.note.label)
																		]))
																]))
														])),
													A2($elm$html$Html$tbody, _List_Nil, viewmembers)
												]))
										]))
								]))
						]))
				]));
	});
var $author$project$BundleMembers$View$view = F3(
	function (flags, state, details) {
		return A2(
			$elm$html$Html$div,
			_List_Nil,
			_List_fromArray(
				[
					A2(
					$elm$html$Html$div,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('sp-form mt-3 mx-3 mb-0')
						]),
					_List_fromArray(
						[
							A2(
							$elm$html$Html$br,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('is-hidden-mobile')
								]),
							_List_Nil),
							A2(
							$elm$html$Html$div,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('field is-horizontal')
								]),
							_List_fromArray(
								[
									A2(
									$elm$html$Html$div,
									_List_fromArray(
										[
											$elm$html$Html$Attributes$class('field-body')
										]),
									_List_fromArray(
										[
											A2(
											$elm$html$Html$div,
											_List_fromArray(
												[
													$elm$html$Html$Attributes$class('field')
												]),
											_List_fromArray(
												[
													A2(
													$elm$html$Html$div,
													_List_fromArray(
														[
															$elm$html$Html$Attributes$class('control')
														]),
													_List_fromArray(
														[
															A3($author$project$BundleMembers$View$viewBundleMembers, flags, state, details)
														]))
												]))
										]))
								])),
							A2(
							$elm$html$Html$br,
							_List_fromArray(
								[
									$elm$html$Html$Attributes$class('is-hidden-mobile')
								]),
							_List_Nil)
						]))
				]));
	});
var $author$project$Bundle$view = function (model) {
	var _v0 = _Utils_Tuple2($author$project$Bundle$currentView, model);
	_v0$6:
	while (true) {
		if (_v0.b.$ === 'Failed') {
			if (!_v0.a) {
				var err = _v0.b.a;
				return A2(
					$elm$html$Html$p,
					_List_fromArray(
						[
							$elm$html$Html$Attributes$class('notification is-danger')
						]),
					_List_fromArray(
						[
							$elm$html$Html$text(err)
						]));
			} else {
				break _v0$6;
			}
		} else {
			switch (_v0.a) {
				case 0:
					var _v1 = _v0.b;
					var flags = _v1.a;
					var state = _v1.b;
					return A2(
						$elm$html$Html$map,
						$author$project$Bundle$Model$DetailsMsg,
						A2(
							$author$project$BundleDetails$View$view,
							$author$project$Bundle$detailsFlags(flags),
							state.details));
				case 1:
					var _v2 = _v0.b;
					var flags = _v2.a;
					var state = _v2.b;
					return A2(
						$elm$html$Html$map,
						$author$project$Bundle$Model$ContentsMsg,
						A3(
							$author$project$BundleContents$View$view,
							$author$project$Bundle$contentsFlags(flags),
							state.contents,
							$author$project$Bundle$enableDownload(state)));
				case 2:
					var _v3 = _v0.b;
					var flags = _v3.a;
					var state = _v3.b;
					return A2(
						$elm$html$Html$map,
						$author$project$Bundle$Model$MembersMsg,
						A3(
							$author$project$BundleMembers$View$view,
							$author$project$Bundle$membersFlags(flags),
							state.members,
							state.details));
				case 3:
					var _v4 = _v0.b;
					var flags = _v4.a;
					var state = _v4.b;
					return A2($author$project$Bundle$View$view, flags, state);
				case 4:
					var _v5 = _v0.b;
					var flags = _v5.a;
					var state = _v5.b;
					return A2(
						$elm$html$Html$map,
						$author$project$Bundle$Model$ProgressMsg,
						A2(
							$author$project$Progress$View$view,
							$author$project$Bundle$progressFlags(flags),
							state.progress));
				default:
					break _v0$6;
			}
		}
	}
	return A2($elm$html$Html$div, _List_Nil, _List_Nil);
};
var $author$project$Bundle$main = $elm$browser$Browser$element(
	{init: $author$project$Bundle$init, subscriptions: $author$project$Bundle$subscriptions, update: $author$project$Bundle$update, view: $author$project$Bundle$view});
_Platform_export({'Bundle':{'init':$author$project$Bundle$main($elm$json$Json$Decode$value)(0)},'TopicList':{'init':$author$project$TopicList$main($elm$json$Json$Decode$value)(0)},'Topic':{'init':$author$project$Topic$main($elm$json$Json$Decode$value)(0)},'Test':{'init':$author$project$Test$main($elm$json$Json$Decode$value)(0)},'SignIn':{'init':$author$project$SignIn$main($elm$json$Json$Decode$value)(0)},'Profile':{'init':$author$project$Profile$main($elm$json$Json$Decode$value)(0)},'MemberList':{'init':$author$project$MemberList$main($elm$json$Json$Decode$value)(0)},'Member':{'init':$author$project$Member$main($elm$json$Json$Decode$value)(0)},'Join':{'init':$author$project$Join$main($elm$json$Json$Decode$value)(0)},'Create':{'init':$author$project$Create$main($elm$json$Json$Decode$value)(0)},'BundleList':{'init':$author$project$BundleList$main($elm$json$Json$Decode$value)(0)}});}(this));
